/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],k=0,R=$.length;k<R;k++)e[k]=Q[$[k]];return e};define(Q[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(O){return(I,d,l)=>{let v=null,S=null;if(typeof l.value=="function"?(v="value",S=l.value):typeof l.get=="function"&&(v="get",S=l.get),!S)throw new Error("not supported");l[v]=O(S,d)}}function R(O,I,d){let l=null,v=null;if(typeof d.value=="function"?(l="value",v=d.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(l="get",v=d.get),!v)throw new Error("not supported");const S=`$memoize$${I}`;d[l]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,m)}),this[S]}}e.memoize=R;function D(O,I,d){return k((l,v)=>{const S=`$debounce$${v}`,m=`$debounce$result$${v}`;return function(...P){this[m]||(this[m]=d?d():void 0),clearTimeout(this[S]),I&&(this[m]=I(this[m],...P),P=[this[m]]),this[S]=setTimeout(()=>{l.apply(this,P),this[m]=d?d():void 0},O)}})}e.debounce=D;function L(O,I,d){return k((l,v)=>{const S=`$throttle$timer$${v}`,m=`$throttle$result$${v}`,P=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...w){if(this[m]||(this[m]=d?d():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...w)),this[p])return;const E=this[P]+O;E<=Date.now()?(this[P]=Date.now(),l.apply(this,[this[m]]),this[m]=d?d():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[P]=Date.now(),l.apply(this,[this[m]]),this[m]=d?d():void 0},E-Date.now()))}})}e.throttle=L}),define(Q[69],Z([0,1,11]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(d,l){if(!d)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=R;function D(d,l="Unreachable"){throw new Error(l)}e.assertNever=D;function L(d){if(!d)throw new k.BugIndicatingError("Assertion Failed")}e.assert=L;function O(d){if(!d()){debugger;d(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function I(d,l){let v=0;for(;v<d.length-1;){const S=d[v],m=d[v+1];if(!l(S,m))return!1;v++}return!0}e.checkAdjacentItems=I}),define(Q[50],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function O(i,n=!1){let t=0;const r=i.length;let o="",u=0,a=16,g=0;function C(Y){let me=0,ue=0;for(;me<Y;){const se=i.charCodeAt(t);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;t++,me++}return me<Y&&(ue=-1),ue}function N(Y){t=Y,o="",u=0,a=16,g=0}function B(){const Y=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&l(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&l(i.charCodeAt(t)))for(t++;t<i.length&&l(i.charCodeAt(t));)t++;else return g=3,i.substring(Y,t);let me=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&l(i.charCodeAt(t))){for(t++;t<i.length&&l(i.charCodeAt(t));)t++;me=t}else g=3;return i.substring(Y,me)}function K(){let Y="",me=t;for(;;){if(t>=r){Y+=i.substring(me,t),g=2;break}const ue=i.charCodeAt(t);if(ue===34){Y+=i.substring(me,t),t++;break}if(ue===92){if(Y+=i.substring(me,t),t++,t>=r){g=2;break}switch(i.charCodeAt(t++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const W=C(4);W>=0?Y+=String.fromCharCode(W):g=4;break}default:g=5}me=t;continue}if(ue>=0&&ue<=31)if(d(ue)){Y+=i.substring(me,t),g=2;break}else g=6;t++}return Y}function X(){if(o="",g=0,u=t,t>=r)return u=r,a=17;let Y=i.charCodeAt(t);if(I(Y)){do t++,o+=String.fromCharCode(Y),Y=i.charCodeAt(t);while(I(Y));return a=15}if(d(Y))return t++,o+=String.fromCharCode(Y),Y===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(Y){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=K(),a=10;case 47:{const me=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!d(i.charCodeAt(t));)t++;return o=i.substring(me,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const ue=r-1;let se=!1;for(;t<ue;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,se=!0;break}t++}return se||(t++,g=1),o=i.substring(me,t),a=13}return o+=String.fromCharCode(Y),t++,a=16}case 45:if(o+=String.fromCharCode(Y),t++,t===r||!l(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=B(),a=11;default:for(;t<r&&ne(Y);)t++,Y=i.charCodeAt(t);if(u!==t){switch(o=i.substring(u,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Y),t++,a=16}}function ne(Y){if(I(Y)||d(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let Y;do Y=X();while(Y>=12&&Y<=15);return Y}return{setPosition:N,getPosition:()=>t,scan:n?ae:X,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>g}}e.createScanner=O;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function l(i){return i>=48&&i<=57}var v;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(v||(v={}));function S(i,n){const t=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(C,N,B,K){u.value=C,u.offset=N,u.length=B,u.type=K,u.colonOffset=void 0,o=u}try{y(i,{onObjectBegin:(C,N)=>{if(n<=C)throw r;o=void 0,a=n>C,t.push("")},onObjectProperty:(C,N,B)=>{if(n<N||(g(C,N,B,"property"),t[t.length-1]=C,n<=N+B))throw r},onObjectEnd:(C,N)=>{if(n<=C)throw r;o=void 0,t.pop()},onArrayBegin:(C,N)=>{if(n<=C)throw r;o=void 0,t.push(0)},onArrayEnd:(C,N)=>{if(n<=C)throw r;o=void 0,t.pop()},onLiteralValue:(C,N,B)=>{if(n<N||(g(C,N,B,s(C)),n<=N+B))throw r},onSeparator:(C,N,B)=>{if(n<=N)throw r;if(C===":"&&o&&o.type==="property")o.colonOffset=N,a=!1,o=void 0;else if(C===","){const K=t[t.length-1];typeof K=="number"?t[t.length-1]=K+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(C){if(C!==r)throw C}return{path:t,previousNode:o,isAtPropertyKey:a,matches:C=>{let N=0;for(let B=0;N<C.length&&B<t.length;B++)if(C[N]===t[B]||C[N]==="*")N++;else if(C[N]!=="**")return!1;return N===C.length}}}e.getLocation=S;function m(i,n=[],t=L.DEFAULT){let r=null,o=[];const u=[];function a(C){Array.isArray(o)?o.push(C):r!==null&&(o[r]=C)}return y(i,{onObjectBegin:()=>{const C={};a(C),u.push(o),o=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const C=[];a(C),u.push(o),o=C,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:a,onError:(C,N,B)=>{n.push({error:C,offset:N,length:B})}},t),o[0]}e.parse=m;function P(i,n=[],t=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(C){r.type==="property"&&(r.length=C-r.offset,r=r.parent)}function u(C){return r.children.push(C),C}y(i,{onObjectBegin:C=>{r=u({type:"object",offset:C,length:-1,parent:r,children:[]})},onObjectProperty:(C,N,B)=>{r=u({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:C,offset:N,length:B,parent:r})},onObjectEnd:(C,N)=>{r.length=C+N-r.offset,r=r.parent,o(C+N)},onArrayBegin:(C,N)=>{r=u({type:"array",offset:C,length:-1,parent:r,children:[]})},onArrayEnd:(C,N)=>{r.length=C+N-r.offset,r=r.parent,o(C+N)},onLiteralValue:(C,N,B)=>{u({type:s(C),offset:N,length:B,parent:r,value:C}),o(N+B)},onSeparator:(C,N,B)=>{r.type==="property"&&(C===":"?r.colonOffset=N:C===","&&o(N))},onError:(C,N,B)=>{n.push({error:C,offset:N,length:B})}},t);const g=r.children[0];return g&&delete g.parent,g}e.parseTree=P;function p(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===r){t=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=p;function w(i){if(!i.parent||!i.parent.children)return[];const n=w(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=w;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function c(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=c;function h(i,n,t=!1){if(c(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const u=h(r[o],n,t);if(u)return u}return i}}e.findNodeAtOffset=h;function y(i,n,t=L.DEFAULT){const r=O(i,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(q){return q?ee=>q(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),g=u(n.onObjectProperty),C=o(n.onObjectEnd),N=o(n.onArrayBegin),B=o(n.onArrayEnd),K=u(n.onLiteralValue),X=u(n.onSeparator),ne=o(n.onComment),ae=u(n.onError),Y=t&&t.disallowComments,me=t&&t.allowTrailingComma;function ue(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:Y||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(q){case 12:case 13:Y?se(10):ne();break;case 16:se(1);break;case 15:case 14:break;default:return q}}}function se(q,ee=[],U=[]){if(ae(q),ee.length+U.length>0){let b=r.getToken();for(;b!==17;){if(ee.indexOf(b)!==-1){ue();break}else if(U.indexOf(b)!==-1)break;b=ue()}}}function W(q){const ee=r.getTokenValue();return q?K(ee):g(ee),ue(),!0}function F(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(se(2),q=0)}catch{se(2)}K(q);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return ue(),!0}function T(){return r.getToken()!==10?(se(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(X(":"),ue(),J()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function z(){a(),ue();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||se(4,[],[]),X(","),ue(),r.getToken()===2&&me)break}else q&&se(6,[],[]);T()||se(4,[],[2,5]),q=!0}return C(),r.getToken()!==2?se(7,[2],[]):ue(),!0}function _(){N(),ue();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||se(4,[],[]),X(","),ue(),r.getToken()===4&&me)break}else q&&se(6,[],[]);J()||se(4,[],[4,5]),q=!0}return B(),r.getToken()!==4?se(8,[4],[]):ue(),!0}function J(){switch(r.getToken()){case 3:return _();case 1:return z();case 10:return W(!0);default:return F()}}return ue(),r.getToken()===17?t.allowEmptyContent?!0:(se(4,[],[]),!1):J()?(r.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=y;function f(i,n){const t=O(i),r=[];let o,u=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==a&&r.push(i.substring(u,a)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),u=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function $(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function O(d){L.push(d,Date.now())}function I(){const d=[];for(let l=0;l<L.length;l+=2)d.push({name:L[l],startTime:L[l+1]});return d}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))L.push({name:O.name,startTime:Math.round(D+O.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=k(R))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var R in k)(typeof exports=="object"?exports:$)[R]=k[R]}}(typeof self<"u"?self:this,function(){return function($){var e={};function k(R){if(e[R])return e[R].exports;var D=e[R]={i:R,l:!1,exports:{}};return $[R].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=$,k.c=e,k.d=function(R,D,L){k.o(R,D)||Object.defineProperty(R,D,{enumerable:!0,get:L})},k.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},k.t=function(R,D){if(1&D&&(R=k(R)),8&D||4&D&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&D&&typeof R!="string")for(var O in R)k.d(L,O,function(I){return R[I]}.bind(null,O));return L},k.n=function(R){var D=R&&R.__esModule?function(){return R.default}:function(){return R};return k.d(D,"a",D),D},k.o=function(R,D){return Object.prototype.hasOwnProperty.call(R,D)},k.p="",k(k.s=0)}([function($,e,k){(function(R){var D;e=$.exports=U,D=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],d=e.src=[],l=0,v=l++;d[v]="0|[1-9]\\d*";var S=l++;d[S]="[0-9]+";var m=l++;d[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=l++;d[P]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var p=l++;d[p]="("+d[S]+")\\.("+d[S]+")\\.("+d[S]+")";var w=l++;d[w]="(?:"+d[v]+"|"+d[m]+")";var E=l++;d[E]="(?:"+d[S]+"|"+d[m]+")";var c=l++;d[c]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var h=l++;d[h]="(?:-?("+d[E]+"(?:\\."+d[E]+")*))";var y=l++;d[y]="[0-9A-Za-z-]+";var f=l++;d[f]="(?:\\+("+d[y]+"(?:\\."+d[y]+")*))";var s=l++,i="v?"+d[P]+d[c]+"?"+d[f]+"?";d[s]="^"+i+"$";var n="[v=\\s]*"+d[p]+d[h]+"?"+d[f]+"?",t=l++;d[t]="^"+n+"$";var r=l++;d[r]="((?:<|>)?=?)";var o=l++;d[o]=d[S]+"|x|X|\\*";var u=l++;d[u]=d[v]+"|x|X|\\*";var a=l++;d[a]="[v=\\s]*("+d[u]+")(?:\\.("+d[u]+")(?:\\.("+d[u]+")(?:"+d[c]+")?"+d[f]+"?)?)?";var g=l++;d[g]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[h]+")?"+d[f]+"?)?)?";var C=l++;d[C]="^"+d[r]+"\\s*"+d[a]+"$";var N=l++;d[N]="^"+d[r]+"\\s*"+d[g]+"$";var B=l++;d[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=l++;d[K]="(?:~>?)";var X=l++;d[X]="(\\s*)"+d[K]+"\\s+",I[X]=new RegExp(d[X],"g");var ne=l++;d[ne]="^"+d[K]+d[a]+"$";var ae=l++;d[ae]="^"+d[K]+d[g]+"$";var Y=l++;d[Y]="(?:\\^)";var me=l++;d[me]="(\\s*)"+d[Y]+"\\s+",I[me]=new RegExp(d[me],"g");var ue=l++;d[ue]="^"+d[Y]+d[a]+"$";var se=l++;d[se]="^"+d[Y]+d[g]+"$";var W=l++;d[W]="^"+d[r]+"\\s*("+n+")$|^$";var F=l++;d[F]="^"+d[r]+"\\s*("+i+")$|^$";var T=l++;d[T]="(\\s*)"+d[r]+"\\s*("+n+"|"+d[a]+")",I[T]=new RegExp(d[T],"g");var z=l++;d[z]="^\\s*("+d[a]+")\\s+-\\s+("+d[a]+")\\s*$";var _=l++;d[_]="^\\s*("+d[g]+")\\s+-\\s+("+d[g]+")\\s*$";var J=l++;d[J]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)D(q,d[q]),I[q]||(I[q]=new RegExp(d[q]));function ee(x,G){if(x instanceof U)return x;if(typeof x!="string"||x.length>L||!(G?I[t]:I[s]).test(x))return null;try{return new U(x,G)}catch{return null}}function U(x,G){if(x instanceof U){if(x.loose===G)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(x,G);D("SemVer",x,G),this.loose=G;var H=x.trim().match(G?I[t]:I[s]);if(!H)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var pe=+de;if(pe>=0&&pe<O)return pe}return de}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ee,e.valid=function(x,G){var H=ee(x,G);return H?H.version:null},e.clean=function(x,G){var H=ee(x.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(x){return D("SemVer.compare",this.version,this.loose,x),x instanceof U||(x=new U(x,this.loose)),this.compareMain(x)||this.comparePre(x)},U.prototype.compareMain=function(x){return x instanceof U||(x=new U(x,this.loose)),A(this.major,x.major)||A(this.minor,x.minor)||A(this.patch,x.patch)},U.prototype.comparePre=function(x){if(x instanceof U||(x=new U(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],de=x.prerelease[G];if(D("prerelease compare",G,H,de),H===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(H===void 0)return-1;if(H!==de)return A(H,de)}while(++G)},U.prototype.inc=function(x,G){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,G,H,de){typeof H=="string"&&(de=H,H=void 0);try{return new U(x,H).inc(G,de).version}catch{return null}},e.diff=function(x,G){if(te(x,G))return null;var H=ee(x),de=ee(G);if(H.prerelease.length||de.prerelease.length){for(var pe in H)if((pe==="major"||pe==="minor"||pe==="patch")&&H[pe]!==de[pe])return"pre"+pe;return"prerelease"}for(var pe in H)if((pe==="major"||pe==="minor"||pe==="patch")&&H[pe]!==de[pe])return pe},e.compareIdentifiers=A;var b=/^[0-9]+$/;function A(x,G){var H=b.test(x),de=b.test(G);return H&&de&&(x=+x,G=+G),H&&!de?-1:de&&!H?1:x<G?-1:x>G?1:0}function M(x,G,H){return new U(x,H).compare(new U(G,H))}function V(x,G,H){return M(x,G,H)>0}function j(x,G,H){return M(x,G,H)<0}function te(x,G,H){return M(x,G,H)===0}function oe(x,G,H){return M(x,G,H)!==0}function fe(x,G,H){return M(x,G,H)>=0}function ve(x,G,H){return M(x,G,H)<=0}function le(x,G,H,de){var pe;switch(G){case"===":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),pe=x===H;break;case"!==":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),pe=x!==H;break;case"":case"=":case"==":pe=te(x,H,de);break;case"!=":pe=oe(x,H,de);break;case">":pe=V(x,H,de);break;case">=":pe=fe(x,H,de);break;case"<":pe=j(x,H,de);break;case"<=":pe=ve(x,H,de);break;default:throw new TypeError("Invalid operator: "+G)}return pe}function re(x,G){if(x instanceof re){if(x.loose===G)return x;x=x.value}if(!(this instanceof re))return new re(x,G);D("comparator",x,G),this.loose=G,this.parse(x),this.semver===he?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(x,G){return A(G,x)},e.major=function(x,G){return new U(x,G).major},e.minor=function(x,G){return new U(x,G).minor},e.patch=function(x,G){return new U(x,G).patch},e.compare=M,e.compareLoose=function(x,G){return M(x,G,!0)},e.rcompare=function(x,G,H){return M(G,x,H)},e.sort=function(x,G){return x.sort(function(H,de){return e.compare(H,de,G)})},e.rsort=function(x,G){return x.sort(function(H,de){return e.rcompare(H,de,G)})},e.gt=V,e.lt=j,e.eq=te,e.neq=oe,e.gte=fe,e.lte=ve,e.cmp=le,e.Comparator=re;var he={};function ce(x,G){if(x instanceof ce)return x.loose===G?x:new ce(x.raw,G);if(x instanceof re)return new ce(x.value,G);if(!(this instanceof ce))return new ce(x,G);if(this.loose=G,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Se(x){return!x||x.toLowerCase()==="x"||x==="*"}function Re(x,G,H,de,pe,De,we,ke,Ie,Le,Ne,Ce,Oe){return((G=Se(H)?"":Se(de)?">="+H+".0.0":Se(pe)?">="+H+"."+de+".0":">="+G)+" "+(ke=Se(Ie)?"":Se(Le)?"<"+(+Ie+1)+".0.0":Se(Ne)?"<"+Ie+"."+(+Le+1)+".0":Ce?"<="+Ie+"."+Le+"."+Ne+"-"+Ce:"<="+ke)).trim()}function Ae(x,G){for(var H=0;H<x.length;H++)if(!x[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<x.length;H++)if(D(x[H].semver),x[H].semver!==he&&x[H].semver.prerelease.length>0){var de=x[H].semver;if(de.major===G.major&&de.minor===G.minor&&de.patch===G.patch)return!0}return!1}return!0}function Fe(x,G,H){try{G=new ce(G,H)}catch{return!1}return G.test(x)}function xe(x,G,H,de){var pe,De,we,ke,Ie;switch(x=new U(x,de),G=new ce(G,de),H){case">":pe=V,De=ve,we=j,ke=">",Ie=">=";break;case"<":pe=j,De=fe,we=V,ke="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(x,G,de))return!1;for(var Le=0;Le<G.set.length;++Le){var Ne=G.set[Le],Ce=null,Oe=null;if(Ne.forEach(function(Me){Me.semver===he&&(Me=new re(">=0.0.0")),Ce=Ce||Me,Oe=Oe||Me,pe(Me.semver,Ce.semver,de)?Ce=Me:we(Me.semver,Oe.semver,de)&&(Oe=Me)}),Ce.operator===ke||Ce.operator===Ie||(!Oe.operator||Oe.operator===ke)&&De(x,Oe.semver)||Oe.operator===Ie&&we(x,Oe.semver))return!1}return!0}re.prototype.parse=function(x){var G=this.loose?I[W]:I[F],H=x.match(G);if(!H)throw new TypeError("Invalid comparator: "+x);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new U(H[2],this.loose):this.semver=he},re.prototype.toString=function(){return this.value},re.prototype.test=function(x){return D("Comparator.test",x,this.loose),this.semver===he||(typeof x=="string"&&(x=new U(x,this.loose)),le(x,this.operator,this.semver,this.loose))},re.prototype.intersects=function(x,G){if(!(x instanceof re))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ce(x.value,G),Fe(this.value,H,G);if(x.operator==="")return H=new ce(this.value,G),Fe(x.semver,H,G);var de=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),ke=le(this.semver,"<",x.semver,G)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=le(this.semver,">",x.semver,G)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return de||pe||De&&we||ke||Ie},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(x){var G=this.loose;x=x.trim(),D("range",x,G);var H=G?I[_]:I[z];x=x.replace(H,Re),D("hyphen replace",x),x=x.replace(I[T],"$1$2$3"),D("comparator trim",x,I[T]),x=(x=(x=x.replace(I[X],"$1~")).replace(I[me],"$1^")).split(/\s+/).join(" ");var de=G?I[W]:I[F],pe=x.split(" ").map(function(De){return function(we,ke){return D("comp",we),we=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Oe){D("caret",Ce,Oe);var Me=Oe?I[se]:I[ue];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Te;return D("caret",Ce,Ue,ye,Ee,Pe,be),Se(ye)?Te="":Se(Ee)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Te=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":be?(D("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+be+" <"+(+ye+1)+".0.0"):(D("no pr"),Te=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),D("caret return",Te),Te})}(Ne,Le)}).join(" ")}(we,ke),D("caret",we),we=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Oe){var Me=Oe?I[ae]:I[ne];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Te;return D("tilde",Ce,Ue,ye,Ee,Pe,be),Se(ye)?Te="":Se(Ee)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Te=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":be?(D("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0"):Te=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",D("tilde return",Te),Te})}(Ne,Le)}).join(" ")}(we,ke),D("tildes",we),we=function(Ie,Le){return D("replaceXRanges",Ie,Le),Ie.split(/\s+/).map(function(Ne){return function(Ce,Oe){Ce=Ce.trim();var Me=Oe?I[N]:I[C];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be,Te){D("xRange",Ce,Ue,ye,Ee,Pe,be,Te);var _e=Se(Ee),Ve=_e||Se(Pe),ze=Ve||Se(be);return ye==="="&&ze&&(ye=""),_e?Ue=ye===">"||ye==="<"?"<0.0.0":"*":ye&&ze?(Ve&&(Pe=0),ze&&(be=0),ye===">"?(ye=">=",Ve?(Ee=+Ee+1,Pe=0,be=0):ze&&(Pe=+Pe+1,be=0)):ye==="<="&&(ye="<",Ve?Ee=+Ee+1:Pe=+Pe+1),Ue=ye+Ee+"."+Pe+"."+be):Ve?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ue),Ue})}(Ne,Le)}).join(" ")}(we,ke),D("xrange",we),we=function(Ie,Le){return D("replaceStars",Ie,Le),Ie.trim().replace(I[J],"")}(we,ke),D("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(De){return!!De.match(de)})),pe=pe.map(function(De){return new re(De,G)})},ce.prototype.intersects=function(x,G){if(!(x instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(de){return x.set.some(function(pe){return pe.every(function(De){return de.intersects(De,G)})})})})},e.toComparators=function(x,G){return new ce(x,G).set.map(function(H){return H.map(function(de){return de.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new U(x,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],x))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(x,G,H){var de=null,pe=null;try{var De=new ce(G,H)}catch{return null}return x.forEach(function(we){De.test(we)&&(de&&pe.compare(we)!==-1||(pe=new U(de=we,H)))}),de},e.minSatisfying=function(x,G,H){var de=null,pe=null;try{var De=new ce(G,H)}catch{return null}return x.forEach(function(we){De.test(we)&&(de&&pe.compare(we)!==1||(pe=new U(de=we,H)))}),de},e.validRange=function(x,G){try{return new ce(x,G).range||"*"}catch{return null}},e.ltr=function(x,G,H){return xe(x,G,"<",H)},e.gtr=function(x,G,H){return xe(x,G,">",H)},e.outside=xe,e.prerelease=function(x,G){var H=ee(x,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(x,G,H){return x=new ce(x,H),G=new ce(G,H),x.intersects(G)},e.coerce=function(x){if(x instanceof U)return x;if(typeof x!="string")return null;var G=x.match(I[B]);return G==null?null:ee((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,k(1))},function($,e){var k,R,D=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(E){if(k===setTimeout)return setTimeout(E,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(E,0);try{return k(E,0)}catch{try{return k.call(null,E,0)}catch{return k.call(this,E,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch{R=O}})();var d,l=[],v=!1,S=-1;function m(){v&&d&&(v=!1,d.length?l=d.concat(l):S=-1,l.length&&P())}function P(){if(!v){var E=I(m);v=!0;for(var c=l.length;c;){for(d=l,l=[];++S<c;)d&&d[S].run();S=-1,c=l.length}d=null,v=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(E)}}function p(E,c){this.fun=E,this.array=c}function w(){}D.nextTick=function(E){var c=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)c[h-1]=arguments[h];l.push(new p(E,c)),l.length!==1||v||I(P)},p.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=w,D.addListener=w,D.once=w,D.off=w,D.removeListener=w,D.removeAllListeners=w,D.emit=w,D.prependListener=w,D.prependOnceListener=w,D.listeners=function(E){return[]},D.binding=function(E){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(E){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Q[70],Z([0,1]),function($,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(I,d,l){this.level=I,this.key=d,this.value=l,this.forward=[]}}const D=void 0;class L{constructor(I,d=2**16){this.comparator=I,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(d)|0),this._header=new R(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,D,D)}has(I){return Boolean(L._search(this,I,this.comparator))}get(I){return L._search(this,I,this.comparator)?.value}set(I,d){return L._insert(this,I,d,this.comparator)&&(this._size+=1),this}delete(I){const d=L._delete(this,I,this.comparator);return d&&(this._size-=1),d}forEach(I,d){let l=this._header.forward[0];for(;l;)I.call(d,l.value,l.key,this),l=l.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",d=this._header.forward[0];for(;d;)I+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return I}static _search(I,d,l){let v=I._header;for(let S=I._level-1;S>=0;S--)for(;v.forward[S]&&l(v.forward[S].key,d)<0;)v=v.forward[S];if(v=v.forward[0],v&&l(v.key,d)===0)return v}static _insert(I,d,l,v){const S=[];let m=I._header;for(let P=I._level-1;P>=0;P--){for(;m.forward[P]&&v(m.forward[P].key,d)<0;)m=m.forward[P];S[P]=m}if(m=m.forward[0],m&&v(m.key,d)===0)return m.value=l,!1;{const P=L._randomLevel(I);if(P>I._level){for(let p=I._level;p<P;p++)S[p]=I._header;I._level=P}m=new R(P,d,l);for(let p=0;p<P;p++)m.forward[p]=S[p].forward[p],S[p].forward[p]=m;return!0}}static _randomLevel(I,d=.5){let l=1;for(;Math.random()<d&&l<I._maxLevel;)l+=1;return l}static _delete(I,d,l){const v=[];let S=I._header;for(let m=I._level-1;m>=0;m--){for(;S.forward[m]&&l(S.forward[m].key,d)<0;)S=S.forward[m];v[m]=S}if(S=S.forward[0],!S||l(S.key,d)!==0)return!1;for(let m=0;m<I._level&&v[m].forward[m]===S;m++)v[m].forward[m]=S.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===D;)I._level-=1;return!0}}e.SkipList=L}),define(Q[43],Z([0,1,11,2]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=D;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function O(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=O;function I(f,s){return new d(f,s)}e.newWriteableStream=I;class d{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,k.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=l;function v(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=v;function S(f,s){return new Promise((i,n)=>{const t=[];m(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=S;function m(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,R.toDisposable)(()=>i=!0)}e.listenStream=m;function P(f,s){return new Promise((i,n)=>{const t=new R.DisposableStore,r=[],o=g=>{if(r.push(g),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},u=g=>n(g),a=()=>i({stream:f,buffer:r,ended:!0});t.add((0,R.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),t.add((0,R.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,R.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=P;function p(f,s){const i=I(s);return i.end(f),i}e.toStream=p;function w(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=w;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function c(f,s,i){const n=I(i);return m(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=c;function h(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=h;function y(f,s,i){let n=!1;const t=I(i);return m(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=y}),define(Q[14],Z([0,1,43]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let D,L;class O{static alloc(g){return R?new O(Buffer.allocUnsafe(g)):new O(new Uint8Array(g))}static wrap(g){return R&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new O(g)}static fromString(g,C){return!(C?.dontUseNodeBuffer||!1)&&R?new O(Buffer.from(g)):(D||(D=new TextEncoder),new O(D.encode(g)))}static fromByteArray(g){const C=O.alloc(g.length);for(let N=0,B=g.length;N<B;N++)C.buffer[N]=g[N];return C}static concat(g,C){if(typeof C>"u"){C=0;for(let K=0,X=g.length;K<X;K++)C+=g[K].byteLength}const N=O.alloc(C);let B=0;for(let K=0,X=g.length;K<X;K++){const ne=g[K];N.set(ne,B),B+=ne.byteLength}return N}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=O.alloc(this.byteLength);return g.set(this),g}toString(){return R?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(g,C){return new O(this.buffer.subarray(g,C))}set(g,C){if(g instanceof O)this.buffer.set(g.buffer,C);else if(g instanceof Uint8Array)this.buffer.set(g,C);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),C);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return l(this.buffer,g)}writeUInt32BE(g,C){v(this.buffer,g,C)}readUInt32LE(g){return S(this.buffer,g)}writeUInt32LE(g,C){m(this.buffer,g,C)}readUInt8(g){return P(this.buffer,g)}writeUInt8(g,C){p(this.buffer,g,C)}}e.VSBuffer=O;function I(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=I;function d(a,g,C){a[C+0]=g&255,g=g>>>8,a[C+1]=g&255}e.writeUInt16LE=d;function l(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=l;function v(a,g,C){a[C+3]=g,g=g>>>8,a[C+2]=g,g=g>>>8,a[C+1]=g,g=g>>>8,a[C]=g}e.writeUInt32BE=v;function S(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=S;function m(a,g,C){a[C+0]=g&255,g=g>>>8,a[C+1]=g&255,g=g>>>8,a[C+2]=g&255,g=g>>>8,a[C+3]=g&255}e.writeUInt32LE=m;function P(a,g){return a[g]}e.readUInt8=P;function p(a,g,C){a[C]=g}e.writeUInt8=p;function w(a){return k.consumeReadable(a,g=>O.concat(g))}e.readableToBuffer=w;function E(a){return k.toReadable(a)}e.bufferToReadable=E;function c(a){return k.consumeStream(a,g=>O.concat(g))}e.streamToBuffer=c;async function h(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=h;function y(a){return k.toStream(a,g=>O.concat(g))}e.bufferToStream=y;function f(a){return k.transform(a,{data:g=>typeof g=="string"?O.fromString(g):O.wrap(g)},g=>O.concat(g))}e.streamToBufferReadableStream=f;function s(a){return k.newWriteableStream(g=>O.concat(g),a)}e.newWriteableBufferStream=s;function i(a,g){return k.prefixedReadable(a,g,C=>O.concat(C))}e.prefixedBufferReadable=i;function n(a,g){return k.prefixedStream(a,g,C=>O.concat(C))}e.prefixedBufferStream=n;function t(a){let g=0,C=0,N=0;const B=new Uint8Array(Math.floor(a.length/4*3)),K=ne=>{switch(C){case 3:B[N++]=g|ne,C=0;break;case 2:B[N++]=g|ne>>>2,g=ne<<6,C=3;break;case 1:B[N++]=g|ne>>>4,g=ne<<4,C=2;break;default:g=ne<<2,C=1}};for(let ne=0;ne<a.length;ne++){const ae=a.charCodeAt(ne);if(ae>=65&&ae<=90)K(ae-65);else if(ae>=97&&ae<=122)K(ae-97+26);else if(ae>=48&&ae<=57)K(ae-48+52);else if(ae===43||ae===45)K(62);else if(ae===47||ae===95)K(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ne]}`)}}const X=N;for(;C>0;)K(0);return O.wrap(B).slice(0,X)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},g=!0,C=!1){const N=C?o:r;let B="";const K=a.byteLength%3;let X=0;for(;X<a.byteLength-K;X+=3){const ne=a[X+0],ae=a[X+1],Y=a[X+2];B+=N[ne>>>2],B+=N[(ne<<4|ae>>>4)&63],B+=N[(ae<<2|Y>>>6)&63],B+=N[Y&63]}if(K===1){const ne=a[X+0];B+=N[ne>>>2],B+=N[ne<<4&63],g&&(B+="==")}else if(K===2){const ne=a[X+0],ae=a[X+1];B+=N[ne>>>2],B+=N[(ne<<4|ae>>>4)&63],B+=N[ae<<2&63],g&&(B+="=")}return B}e.encodeBase64=u}),define(Q[26],Z([0,1,8]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const h=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([y,f])=>{h[y]=f&&typeof f=="object"?R(f):f}),h}e.deepClone=R;function D(c){if(!c||typeof c!="object")return c;const h=[c];for(;h.length>0;){const y=h.shift();Object.freeze(y);for(const f in y)if(L.call(y,f)){const s=y[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,k.isTypedArray)(s)&&h.push(s)}}return c}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function O(c,h){return I(c,h,new Set)}e.cloneAndChange=O;function I(c,h,y){if((0,k.isUndefinedOrNull)(c))return c;const f=h(c);if(typeof f<"u")return f;if(Array.isArray(c)){const s=[];for(const i of c)s.push(I(i,h,y));return s}if((0,k.isObject)(c)){if(y.has(c))throw new Error("Cannot clone recursive data-structure");y.add(c);const s={};for(const i in c)L.call(c,i)&&(s[i]=I(c[i],h,y));return y.delete(c),s}return c}function d(c,h,y=!0){return(0,k.isObject)(c)?((0,k.isObject)(h)&&Object.keys(h).forEach(f=>{f in c?y&&((0,k.isObject)(c[f])&&(0,k.isObject)(h[f])?d(c[f],h[f],y):c[f]=h[f]):c[f]=h[f]}),c):h}e.mixin=d;function l(c,h){if(c===h)return!0;if(c==null||h===null||h===void 0||typeof c!=typeof h||typeof c!="object"||Array.isArray(c)!==Array.isArray(h))return!1;let y,f;if(Array.isArray(c)){if(c.length!==h.length)return!1;for(y=0;y<c.length;y++)if(!l(c[y],h[y]))return!1}else{const s=[];for(f in c)s.push(f);s.sort();const i=[];for(f in h)i.push(f);if(i.sort(),!l(s,i))return!1;for(y=0;y<s.length;y++)if(!l(c[s[y]],h[s[y]]))return!1}return!0}e.equals=l;function v(c){const h=new Set;return JSON.stringify(c,(y,f)=>{if((0,k.isObject)(f)||Array.isArray(f)){if(h.has(f))return"[Circular]";h.add(f)}return f})}e.safeStringify=v;function S(c,h){const y=Object.create(null);return!c||!h||Object.keys(h).forEach(s=>{const i=c[s],n=h[s];l(i,n)||(y[s]=n)}),y}e.distinct=S;function m(c,h){const y=h.toLowerCase(),f=Object.keys(c).find(s=>s.toLowerCase()===y);return f?c[f]:c[h]}e.getCaseInsensitive=m;function P(c,h){const y=Object.create(null);for(const[f,s]of Object.entries(c))h(f,s)&&(y[f]=s);return y}e.filter=P;function p(c){let h=[],y=Object.getPrototypeOf(c);for(;Object.prototype!==y;)h=h.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return h}e.getAllPropertyNames=p;function w(c){const h=[];for(const y of p(c))typeof c[y]=="function"&&h.push(y);return h}e.getAllMethodNames=w;function E(c,h){const y=s=>function(){const i=Array.prototype.slice.call(arguments,0);return h(s,i)},f={};for(const s of c)f[s]=y(s);return f}e.createProxyObject=E}),define(Q[31],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return k.test(D)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(I){for(let d=0;d<I.length;d++)I[d]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let d=0,l="";return l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l+="-",l+=O[L[d++]],l+=O[L[d++]],l+="-",l+=O[L[d++]],l+=O[L[d++]],l+="-",l+=O[L[d++]],l+=O[L[d++]],l+="-",l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l+=O[L[d++]],l}}()}),define(Q[71],Z([5,6]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[72],Z([0,1,71]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,L=D*24,O=L*7,I=L*30,d=L*365;function l(S,m,P){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,k.localize)(0,null,l(new Date().getTime()+p*1e3,!1));if(p<30)return(0,k.localize)(1,null);let w;return p<R?(w=p,m?w===1?P?(0,k.localize)(2,null,w):(0,k.localize)(3,null,w):P?(0,k.localize)(4,null,w):(0,k.localize)(5,null,w):w===1?P?(0,k.localize)(6,null,w):(0,k.localize)(7,null,w):P?(0,k.localize)(8,null,w):(0,k.localize)(9,null,w)):p<D?(w=Math.floor(p/R),m?w===1?P?(0,k.localize)(10,null,w):(0,k.localize)(11,null,w):P?(0,k.localize)(12,null,w):(0,k.localize)(13,null,w):w===1?P?(0,k.localize)(14,null,w):(0,k.localize)(15,null,w):P?(0,k.localize)(16,null,w):(0,k.localize)(17,null,w)):p<L?(w=Math.floor(p/D),m?w===1?P?(0,k.localize)(18,null,w):(0,k.localize)(19,null,w):P?(0,k.localize)(20,null,w):(0,k.localize)(21,null,w):w===1?P?(0,k.localize)(22,null,w):(0,k.localize)(23,null,w):P?(0,k.localize)(24,null,w):(0,k.localize)(25,null,w)):p<O?(w=Math.floor(p/L),m?w===1?(0,k.localize)(26,null,w):(0,k.localize)(27,null,w):w===1?(0,k.localize)(28,null,w):(0,k.localize)(29,null,w)):p<I?(w=Math.floor(p/O),m?w===1?P?(0,k.localize)(30,null,w):(0,k.localize)(31,null,w):P?(0,k.localize)(32,null,w):(0,k.localize)(33,null,w):w===1?P?(0,k.localize)(34,null,w):(0,k.localize)(35,null,w):P?(0,k.localize)(36,null,w):(0,k.localize)(37,null,w)):p<d?(w=Math.floor(p/I),m?w===1?P?(0,k.localize)(38,null,w):(0,k.localize)(39,null,w):P?(0,k.localize)(40,null,w):(0,k.localize)(41,null,w):w===1?P?(0,k.localize)(42,null,w):(0,k.localize)(43,null,w):P?(0,k.localize)(44,null,w):(0,k.localize)(45,null,w)):(w=Math.floor(p/d),m?w===1?P?(0,k.localize)(46,null,w):(0,k.localize)(47,null,w):P?(0,k.localize)(48,null,w):(0,k.localize)(49,null,w):w===1?P?(0,k.localize)(50,null,w):(0,k.localize)(51,null,w):P?(0,k.localize)(52,null,w):(0,k.localize)(53,null,w))}e.fromNow=l;function v(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(Q[73],Z([5,6]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[32],Z([0,1,19,8,73]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(S,m){return m&&(S.stack||S.stacktrace)?D.localize(0,null,I(S),O(S.stack)||O(S.stacktrace)):I(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function I(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function d(S=null,m=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const P=k.coalesce(S),p=d(P[0],m);return P.length>1?D.localize(4,null,p,P.length):p}if(R.isString(S))return S;if(S.detail){const P=S.detail;if(P.error)return L(P.error,m);if(P.exception)return L(P.exception,m)}return S.stack?L(S,m):S.message?S.message:D.localize(5,null)}e.toErrorMessage=d;function l(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=l;function v(S,m){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=m,P}e.createErrorWithActions=v}),define(Q[74],Z([5,6]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Q[75],Z([0,1,74]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Q[51],Z([0,1,12]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...d){const l=d.reduce((m,P)=>(m[P]=!0,m),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!l[m]).forEach(m=>{for(let P=0;P<v.length;P++)if(m.search(v[P])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=L;function O(I){!I||(delete I.DEBUG,k.isMacintosh&&delete I.DYLD_LIBRARY_PATH,k.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(Q[52],Z([0,1,3,2]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=O=>({onDidChange:k.Event.None,value:O});e.staticObservableValue=D;class L extends R.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new k.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(Q[53],Z([0,1,27]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(c){return D(c,0)}e.hash=R;function D(c,h){switch(typeof c){case"object":return c===null?L(349,h):Array.isArray(c)?d(c,h):l(c,h);case"string":return I(c,h);case"boolean":return O(c,h);case"number":return L(c,h);case"undefined":return L(937,h);default:return L(617,h)}}e.doHash=D;function L(c,h){return(h<<5)-h+c|0}e.numberHash=L;function O(c,h){return L(c?433:863,h)}function I(c,h){h=L(149417,h);for(let y=0,f=c.length;y<f;y++)h=L(c.charCodeAt(y),h);return h}e.stringHash=I;function d(c,h){return h=L(104579,h),c.reduce((y,f)=>D(f,y),h)}function l(c,h){return h=L(181387,h),Object.keys(c).sort().reduce((y,f)=>(y=I(f,y),D(c[f],y)),h)}class v{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=D(h,this._value),this._value}}e.Hasher=v;var S;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(c,h,y=32){const f=y-h,s=~((1<<f)-1);return(c<<h|(s&c)>>>f)>>>0}function P(c,h=0,y=c.byteLength,f=0){for(let s=0;s<y;s++)c[h+s]=f}function p(c,h,y="0"){for(;c.length<h;)c=y+c;return c}function w(c,h=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(y=>y.toString(16).padStart(2,"0")).join(""):p((c>>>0).toString(16),h/4)}e.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const f=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,t;for(i!==0?(n=i,t=-1,i=0):(n=h.charCodeAt(0),t=0);;){let r=n;if(k.isHighSurrogate(n))if(t+1<y){const o=h.charCodeAt(t+1);k.isLowSurrogate(o)?(t++,r=k.computeCodePoint(n,o)):r=65533}else{i=n;break}else k.isLowSurrogate(n)&&(r=65533);if(s=this._push(f,s,r),t++,t<y)n=h.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(h,y,f){return f<128?h[y++]=f:f<2048?(h[y++]=192|(f&1984)>>>6,h[y++]=128|(f&63)>>>0):f<65536?(h[y++]=224|(f&61440)>>>12,h[y++]=128|(f&4032)>>>6,h[y++]=128|(f&63)>>>0):(h[y++]=240|(f&1835008)>>>18,h[y++]=128|(f&258048)>>>12,h[y++]=128|(f&4032)>>>6,h[y++]=128|(f&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,P(this._buff,this._buffLen),this._buffLen>56&&(this._step(),P(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=E._bigBlock32,y=this._buffDV;for(let a=0;a<64;a+=4)h.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)h.setUint32(a,m(h.getUint32(a-12,!1)^h.getUint32(a-32,!1)^h.getUint32(a-56,!1)^h.getUint32(a-64,!1),1),!1);let f=this._h0,s=this._h1,i=this._h2,n=this._h3,t=this._h4,r,o,u;for(let a=0;a<80;a++)a<20?(r=s&i|~s&n,o=1518500249):a<40?(r=s^i^n,o=1859775393):a<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),u=m(f,5)+r+t+o+h.getUint32(a*4,!1)&4294967295,t=n,n=i,i=m(s,30),s=f,f=u;this._h0=this._h0+f&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const L="error",O="warning",I="warn",d="info",l="ignore";function v(m){return m?k.equalsIgnoreCase(L,m)?D.Error:k.equalsIgnoreCase(O,m)||k.equalsIgnoreCase(I,m)?D.Warning:k.equalsIgnoreCase(d,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=v;function S(m){switch(m){case D.Error:return L;case D.Warning:return O;case D.Info:return d;default:return l}}D.toString=S}(R||(R={})),e.default=R}),define(Q[76],Z([0,1,10]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(l){const v=l;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=R;function D(l){const v=[];let S;try{const m=JSON.parse(l.arguments),P=m[m.length-1];P&&P.__$stack&&(m.pop(),S=P.__$stack),v.push(...m)}catch{v.push("Unable to log remote console arguments",l.arguments)}return{args:v,stack:S}}e.parse=D;function L(l){if(typeof l!="string")return L(D(l).stack);const v=l;if(v){const S=O(v),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:k.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function O(l){if(!l)return l;const v=l.indexOf(`
`);return v===-1?l:l.substring(0,v)}function I(l,v){const{args:S,stack:m}=D(l),P=typeof S[0]=="string"&&S.length===1;let p=O(m);p&&(p=`(${p.trim()})`);let w=[];if(typeof S[0]=="string"?p&&P?w=[`%c[${v}] %c${S[0]} %c${p}`,d("blue"),d(""),d("grey")]:w=[`%c[${v}] %c${S[0]}`,d("blue"),d(""),...S.slice(1)]:w=[`%c[${v}]%`,d("blue"),...S],p&&!P&&w.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=I;function d(l){return`color: ${l}`}}),define(Q[44],Z([0,1,14,27,10]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(l){return JSON.stringify(l,I)}e.stringify=L;function O(l){let v=JSON.parse(l);return v=d(v),v}e.parse=O;function I(l,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,R.regExpFlags)(v)}:v}function d(l,v=0){if(!l||v>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return D.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 15:return new Date(l.source)}if(l instanceof k.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let S=0;S<l.length;++S)l[S]=d(l[S],v+1);else for(const S in l)Object.hasOwnProperty.call(l,S)&&(l[S]=d(l[S],v+1))}return l}e.revive=d}),define(Q[77],Z([0,1,38,15,20]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(d||(d={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class S{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:f=!1}={}){return f?l===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=m({useAlternateBitness:f});if(!i)return null;const n=R.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const a of await D.Promises.readdir(n)){let g=-1;if(s){const N=a.indexOf("-");if(N<0)continue;const B=a.substring(0,N);if(!L.test(B)||a.substring(N+1)!=="preview")continue;g=parseInt(B,10)}else{if(!L.test(a))continue;g=parseInt(a,10)}if(g<=t)continue;const C=R.join(n,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(C)||(r=C,t=g)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",u=s?" Preview":"";return new S(r,`PowerShell${u}${o}`,!0)}async function p({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(s))if(i.test(t)){const r=R.join(s,t,"pwsh.exe");return new S(r,n)}return null}function w(){const f=R.join(k.homedir(),".dotnet","tools","pwsh.exe");return new S(f,".NET Core PowerShell Global Tool")}function E(){const f=R.join(process.env.windir,l===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(f,"Windows PowerShell",!0)}async function*c(){let f=await P();f&&(yield f),f=await P({useAlternateBitness:!0}),f&&(yield f),f=await p(),f&&(yield f),f=w(),f&&(yield f),f=await P({findPreview:!0}),f&&(yield f),f=await p({findPreview:!0}),f&&(yield f),f=await P({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*h(){for await(const f of c())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=h;async function y(){for await(const f of h())return f;return null}e.getFirstAvailablePowerShellInstallation=y}),define(Q[55],Z([0,1,15,12,33,51,8,20]),function($,e,k,R,D,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function d(S=D.env){return S.comspec||"cmd.exe"}e.getWindowsShell=d;function l(S){let m=[],P=!1;const p=function(w){if(P){m.push(w);return}(!S.send(w,c=>{if(c&&console.error(c),P=!1,m.length>0){const h=m.slice(0);m=[],h.forEach(y=>p(y))}})||R.isWindows)&&(P=!0)};return{send:p}}e.createQueuedSender=l;var v;(function(S){async function m(P,p,w){if(k.isAbsolute(P))return P;if(p===void 0&&(p=D.cwd()),k.dirname(P)!=="."||(w===void 0&&O.isString(D.env.PATH)&&(w=D.env.PATH.split(k.delimiter)),w===void 0||w.length===0))return k.join(p,P);async function c(h){if(await I.Promises.exists(h)){let y;try{y=await I.Promises.stat(h)}catch(f){f.message.startsWith("EACCES")&&(y=await I.Promises.lstat(h))}return y?!y.isDirectory():!1}return!1}for(const h of w){let y;if(k.isAbsolute(h)?y=k.join(h,P):y=k.join(p,h,P),await c(y))return y;let f=y+".com";if(await c(f)||(f=y+".exe",await c(f)))return f}return k.join(p,P)}S.findExecutable=m})(v=e.win32||(e.win32={}))}),define(Q[78],Z([0,1,38,12,77,55]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function O(P,p){return P===1?R.isWindows?S():L.getWindowsShell(p):l(P,p)}e.getSystemShell=O;function I(P,p){return P===1?R.isWindows?m(p):L.getWindowsShell(p):l(P,p)}e.getSystemShellSync=I;let d=null;function l(P,p){if(R.isLinux&&P===2||R.isMacintosh&&P===3)return"/bin/bash";if(!d){let w;if(R.isWindows)w="/bin/bash";else{if(w=p.SHELL,!w)try{w=(0,k.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}d=w}return d}let v=null;async function S(){return v||(v=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),v}function m(P){if(v)return v;const p=R.isWindows&&parseFloat((0,k.release)())>=10,w=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${P.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?E:L.getWindowsShell(P)}});var ge=this&&this.__decorate||function($,e,k,R){var D=arguments.length,L=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,k):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,e,k,R);else for(var I=$.length-1;I>=0;I--)(O=$[I])&&(L=(D<3?O(L):D>3?O(e,k,L):O(e,k))||L);return D>3&&L&&Object.defineProperty(e,k,L),L};define(Q[56],Z([0,1,19,4,14,22,49,11,3,2,44,27,8]),function($,e,k,R,D,L,O,I,d,l,v,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var P;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(P||(P={}));function p(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w||(w={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(c||(c={}));class h{constructor(T){this.buffer=T,this.pos=0}read(T){const z=this.buffer.slice(this.pos,this.pos+T);return this.pos+=z.byteLength,z}}class y{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function s(F){const T=D.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function i(F){return F.read(4).readUInt32BE(0)}function n(F){const T=D.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(F,T){if(typeof T>"u")F.write(t.Undefined);else if(typeof T=="string"){const z=D.VSBuffer.fromString(T);F.write(t.String),F.write(s(z.byteLength)),F.write(z)}else if(r&&Buffer.isBuffer(T)){const z=D.VSBuffer.wrap(T);F.write(t.Buffer),F.write(s(z.byteLength)),F.write(z)}else if(T instanceof D.VSBuffer)F.write(t.VSBuffer),F.write(s(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(t.Array),F.write(s(T.length));for(const z of T)o(F,z)}else{const z=D.VSBuffer.fromString(JSON.stringify(T));F.write(t.Object),F.write(s(z.byteLength)),F.write(z)}}function u(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(i(F)).toString();case f.Buffer:return F.read(i(F)).buffer;case f.VSBuffer:return F.read(i(F));case f.Array:{const z=i(F),_=[];for(let J=0;J<z;J++)_.push(u(F));return _}case f.Object:return JSON.parse(F.read(i(F)).toString())}}class a{constructor(T,z,_=null,J=1e3){this.protocol=T,this.ctx=z,this.logger=_,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(T,z){this.channels.set(T,z),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const z=this.send([T.type]);this.logger?.logOutgoing(z,0,1,E(T.type));return}case 201:case 202:case 204:case 203:{const z=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(z,T.id,1,E(T.type),T.data);return}}}send(T,z=void 0){const _=new y;return o(_,T),o(_,z),this.sendBuffer(_.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const z=new h(T),_=u(z),J=u(z),q=_[0];switch(q){case 100:return this.logger?.logIncoming(T.byteLength,_[1],1,`${p(q)}: ${_[2]}.${_[3]}`,J),this.onPromise({type:q,id:_[1],channelName:_[2],name:_[3],arg:J});case 102:return this.logger?.logIncoming(T.byteLength,_[1],1,`${p(q)}: ${_[2]}.${_[3]}`,J),this.onEventListen({type:q,id:_[1],channelName:_[2],name:_[3],arg:J});case 101:return this.logger?.logIncoming(T.byteLength,_[1],1,`${p(q)}`),this.disposeActiveRequest({type:q,id:_[1]});case 103:return this.logger?.logIncoming(T.byteLength,_[1],1,`${p(q)}`),this.disposeActiveRequest({type:q,id:_[1]})}}onPromise(T){const z=this.channels.get(T.channelName);if(!z){this.collectPendingRequest(T);return}const _=new L.CancellationTokenSource;let J;try{J=z.call(this.ctx,T.name,T.arg,_.token)}catch(U){J=Promise.reject(U)}const q=T.id;J.then(U=>{this.sendResponse({id:q,data:U,type:201}),this.activeRequests.delete(T.id)},U=>{U instanceof Error?this.sendResponse({id:q,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:q,data:U,type:203}),this.activeRequests.delete(T.id)});const ee=(0,l.toDisposable)(()=>_.cancel());this.activeRequests.set(T.id,ee)}onEventListen(T){const z=this.channels.get(T.channelName);if(!z){this.collectPendingRequest(T);return}const _=T.id,q=z.listen(this.ctx,T.name,T.arg)(ee=>this.sendResponse({id:_,data:ee,type:204}));this.activeRequests.set(T.id,q)}disposeActiveRequest(T){const z=this.activeRequests.get(T.id);z&&(z.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let z=this.pendingRequests.get(T.channelName);z||(z=[],this.pendingRequests.set(T.channelName,z));const _=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:T,timeoutTimer:_})}flushPendingRequests(T){const z=this.pendingRequests.get(T);if(z){for(const _ of z)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(T,z=null){this.protocol=T,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=z}getChannel(T){const z=this;return{call(_,J,q){return z.isDisposed?Promise.reject(new I.CancellationError):z.requestPromise(T,_,J,q)},listen(_,J){return z.isDisposed?d.Event.None:z.requestEvent(T,_,J)}}}requestPromise(T,z,_,J=L.CancellationToken.None){const q=this.lastRequestId++,U={id:q,type:100,channelName:T,name:z,arg:_};if(J.isCancellationRequested)return Promise.reject(new I.CancellationError);let b;return new Promise((M,V)=>{if(J.isCancellationRequested)return V(new I.CancellationError);const j=()=>{const ve=le=>{switch(le.type){case 201:this.handlers.delete(q),M(le.data);break;case 202:{this.handlers.delete(q);const re=new Error(le.data.message);re.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,re.name=le.data.name,V(re);break}case 203:this.handlers.delete(q),V(le.data);break}};this.handlers.set(q,ve),this.sendRequest(U)};let te=null;this.state===c.Idle?j():(te=(0,R.createCancelablePromise)(ve=>this.whenInitialized()),te.then(()=>{te=null,j()}));const oe=()=>{te?(te.cancel(),te=null):this.sendRequest({id:q,type:101}),V(new I.CancellationError)},fe=J.onCancellationRequested(oe);b=(0,l.combinedDisposable)((0,l.toDisposable)(oe),fe),this.activeRequests.add(b)}).finally(()=>{this.activeRequests.delete(b)})}requestEvent(T,z,_){const J=this.lastRequestId++,ee={id:J,type:102,channelName:T,name:z,arg:_};let U=null;const b=new d.Emitter({onWillAddFirstListener:()=>{U=(0,R.createCancelablePromise)(M=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(b),this.sendRequest(ee)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(b),this.sendRequest({id:J,type:103}))}}),A=M=>b.fire(M.data);return this.handlers.set(J,A),b.event}sendRequest(T){switch(T.type){case 100:case 102:{const z=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(z,T.id,0,`${p(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const z=this.send([T.type,T.id]);this.logger?.logOutgoing(z,T.id,0,p(T.type));return}}}send(T,z=void 0){const _=new y;return o(_,T),o(_,z),this.sendBuffer(_.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const z=new h(T),_=u(z),J=u(z),q=_[0];switch(q){case 200:return this.logger?.logIncoming(T.byteLength,0,0,E(q)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,_[1],0,E(q),J),this.onResponse({type:_[0],id:_[1],data:J})}}onResponse(T){if(T.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([O.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class N{get connections(){const T=[];return this._connections.forEach(z=>T.push(z)),T}constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:z,onDidClientDisconnect:_})=>{d.Event.once(z.onMessage)(q=>{const ee=new h(q),U=u(ee),b=new a(z,U),A=new C(z);this.channels.forEach((V,j)=>b.registerChannel(j,V));const M={channelServer:b,channelClient:A,ctx:U};this._connections.add(M),this._onDidAddConnection.fire(M),_(()=>{b.dispose(),A.dispose(),this._connections.delete(M),this._onDidRemoveConnection.fire(M)})})})}getChannel(T,z){const _=this;return{call(J,q,ee){let U;if((0,m.isFunction)(z)){const A=(0,k.getRandomElement)(_.connections.filter(z));U=A?Promise.resolve(A):d.Event.toPromise(d.Event.filter(_.onDidAddConnection,z))}else U=z.routeCall(_,J,q);const b=U.then(A=>A.channelClient.getChannel(T));return K(b).call(J,q,ee)},listen(J,q){if((0,m.isFunction)(z))return _.getMulticastEvent(T,z,J,q);const ee=z.routeEvent(_,J,q).then(U=>U.channelClient.getChannel(T));return K(ee).listen(J,q)}}}getMulticastEvent(T,z,_,J){const q=this;let ee=new l.DisposableStore;const U=new d.Emitter({onWillAddFirstListener:()=>{ee=new l.DisposableStore;const b=new d.EventMultiplexer,A=new Map,M=j=>{const oe=j.channelClient.getChannel(T).listen(_,J),fe=b.add(oe);A.set(j,fe)},V=j=>{const te=A.get(j);!te||(te.dispose(),A.delete(j))};q.connections.filter(z).forEach(M),d.Event.filter(q.onDidAddConnection,z)(M,void 0,ee),q.onDidRemoveConnection(V,void 0,ee),b.event(U.fire,U,ee),ee.add(b)},onDidRemoveLastListener:()=>{ee.dispose()}});return U.event}registerChannel(T,z){this.channels.set(T,z),this._connections.forEach(_=>{_.channelServer.registerChannel(T,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=N;class B{constructor(T,z,_=null){const J=new y;o(J,z),T.send(J.buffer),this.channelClient=new C(T,_),this.channelServer=new a(T,z,_)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,z){this.channelServer.registerChannel(T,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function K(F){return{call(T,z,_){return F.then(J=>J.call(T,z,_))},listen(T,z){const _=new d.Relay;return F.then(J=>_.input=J.listen(T,z)),_.event}}}e.getDelayedChannel=K;function X(F){let T=!1;return{call(z,_,J){return T?F.call(z,_,J):(0,R.timeout)(0).then(()=>T=!0).then(()=>F.call(z,_,J))},listen(z,_){if(T)return F.listen(z,_);const J=new d.Relay;return(0,R.timeout)(0).then(()=>T=!0).then(()=>J.input=F.listen(z,_)),J.event}}}e.getNextTickChannel=X;class ne{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const z of T.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await d.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ne;var ae;(function(F){function T(q,ee){const U=q,b=ee&&ee.disableMarshalling,A=new Map;for(const M in U)_(M)&&A.set(M,d.Event.buffer(U[M],!0));return new class{listen(M,V,j){const te=A.get(V);if(te)return te;if(J(V)){const oe=U[V];if(typeof oe=="function")return oe.call(U,j)}throw new Error(`Event not found: ${V}`)}call(M,V,j){const te=U[V];if(typeof te=="function"){if(!b&&Array.isArray(j))for(let oe=0;oe<j.length;oe++)j[oe]=(0,v.revive)(j[oe]);return te.apply(U,j)}throw new Error(`Method not found: ${V}`)}}}F.fromService=T;function z(q,ee){const U=ee&&ee.disableMarshalling;return new Proxy({},{get(b,A){if(typeof A=="string")return ee?.properties?.has(A)?ee.properties.get(A):J(A)?function(M){return q.listen(A,M)}:_(A)?q.listen(A):async function(...M){let V;ee&&!(0,m.isUndefinedOrNull)(ee.context)?V=[ee.context,...M]:V=M;const j=await q.call(A,V);return U?j:(0,v.revive)(j)};throw new Error(`Property not found: ${String(A)}`)}})}F.toService=z;function _(q){return q[0]==="o"&&q[1]==="n"&&S.isUpperAsciiLetter(q.charCodeAt(2))}function J(q){return/^onDynamic/.test(q)&&S.isUpperAsciiLetter(q.charCodeAt(9))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const T=F.toString();if(T!=="[object Object]")return T}return F}function ue(F){return Array.isArray(F)?F.map(me):me(F)}function se(F,T,z,_,J,q,ee){ee=ue(ee);const U=Y[J],b=U[_%U.length];let A=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${b}`];/\($/.test(q)?(A=A.concat(ee),A.push(")")):A.push(ee),console.log.apply(console,A)}class W{constructor(T,z){this._outgoingPrefix=T,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,z,_,J,q){this._totalOutgoing+=T,se(this._outgoingPrefix,this._totalOutgoing,T,z,_,J,q)}logIncoming(T,z,_,J,q){this._totalIncoming+=T,se(this._incomingPrefix,this._totalIncoming,T,z,_,J,q)}}e.IPCLogger=W}),define(Q[79],Z([0,1,57,4,14,22,76,11,3,2,26,55,51,56]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends P.ChannelServer{constructor(c){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>D.VSBuffer.wrap(Buffer.from(h,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=p;class w{constructor(c,h){this.modulePath=c,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new R.Delayer(y),this.child=null,this._client=null}getChannel(c){const h=this;return{call(y,f,s){return h.requestPromise(c,y,f,s)},listen(y,f){return h.requestEvent(c,y,f)}}}requestPromise(c,h,y,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(c),i=(0,R.createCancelablePromise)(r=>s.call(h,y,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,l.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(c,h,y){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let f;const s=new d.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(c).listen(h,y)(s.fire,s),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(h.env),this.child=(0,k.fork)(this.modulePath,c,h);const y=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=y.event,t={send:i,onMessage:n};this._client=new P.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,l.dispose)(a)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(c){let h=this.channels.get(c);return h||(h=this.client.getChannel(c),this.channels.set(c,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(Q[80],Z([0,1,4,3,2,8]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));function I(S){const m=S;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class l extends D.Disposable{constructor(m,P=Object.create(null)){super(),this.database=m,this.options=P,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(l.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((P,p)=>this.accept(p,P)),m.deleted?.forEach(P=>this.accept(P,void 0))}accept(m,P){if(this.state===d.Closed)return;let p=!1;(0,L.isUndefinedOrNull)(P)?p=this.cache.delete(m):this.cache.get(m)!==P&&(this.cache.set(m,P),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,P){const p=this.cache.get(m);return(0,L.isUndefinedOrNull)(p)?P:p}getBoolean(m,P){const p=this.get(m);return(0,L.isUndefinedOrNull)(p)?P:p==="true"}getNumber(m,P){const p=this.get(m);return(0,L.isUndefinedOrNull)(p)?P:parseInt(p,10)}async set(m,P){if(this.state===d.Closed)return;if((0,L.isUndefinedOrNull)(P))return this.delete(m);const p=String(P);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=l,l.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((P,p)=>this.items.set(p,P)),m.delete?.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=v}),define(Q[81],Z([5,6]),function($,e){return $.create("vs/base/node/zip",e)}),define(Q[82],Z([5,6]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[83],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[84],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[85],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[86],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[87],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[88],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[89],Z([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[90],Z([5,6]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[91],Z([5,6]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[92],Z([5,6]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[93],Z([5,6]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[94],Z([5,6]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[95],Z([5,6]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[96],Z([5,6]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Q[97],Z([5,6]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[98],Z([5,6]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[99],Z([5,6]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Q[100],Z([0,1,72,49,16,15,33,17,10]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return d.URI.file((0,L.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=O.env.VSCODE_PORTABLE;return w?d.URI.file((0,L.join)(w,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,L.resolve)(w):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?d.URI.file((0,L.resolve)(w)):d.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,L.resolve)(w);const E=O.env.VSCODE_EXTENSIONS;if(E)return E;const c=O.env.VSCODE_PORTABLE;return c?(0,L.join)(c,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,L.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(w))}get extensionLogLevel(){const w=[];for(const E of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);c&&c[1]&&c[2]&&w.push([c[1],c[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=O.env.VSCODE_PORTABLE;return w?d.URI.file((0,L.join)(w,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this._args}constructor(w,E,c){this._args=w,this.paths=E,this.productService=c,this.editSessionId=this.args.editSessionId}}ge([R.memoize],l.prototype,"appRoot",null),ge([R.memoize],l.prototype,"userHome",null),ge([R.memoize],l.prototype,"userDataPath",null),ge([R.memoize],l.prototype,"appSettingsHome",null),ge([R.memoize],l.prototype,"tmpDir",null),ge([R.memoize],l.prototype,"cacheHome",null),ge([R.memoize],l.prototype,"stateResource",null),ge([R.memoize],l.prototype,"userRoamingDataHome",null),ge([R.memoize],l.prototype,"userDataSyncHome",null),ge([R.memoize],l.prototype,"userDataSyncLogResource",null),ge([R.memoize],l.prototype,"editSessionsLogResource",null),ge([R.memoize],l.prototype,"remoteTunnelLogResource",null),ge([R.memoize],l.prototype,"sync",null),ge([R.memoize],l.prototype,"machineSettingsResource",null),ge([R.memoize],l.prototype,"workspaceStorageHome",null),ge([R.memoize],l.prototype,"localHistoryHome",null),ge([R.memoize],l.prototype,"keyboardLayoutResource",null),ge([R.memoize],l.prototype,"argvResource",null),ge([R.memoize],l.prototype,"isExtensionDevelopment",null),ge([R.memoize],l.prototype,"untitledWorkspacesHome",null),ge([R.memoize],l.prototype,"installSourcePath",null),ge([R.memoize],l.prototype,"builtinExtensionsPath",null),ge([R.memoize],l.prototype,"extensionsPath",null),ge([R.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],l.prototype,"extensionDevelopmentKind",null),ge([R.memoize],l.prototype,"extensionTestsLocationURI",null),ge([R.memoize],l.prototype,"debugExtensionHost",null),ge([R.memoize],l.prototype,"logLevel",null),ge([R.memoize],l.prototype,"extensionLogLevel",null),ge([R.memoize],l.prototype,"serviceMachineIdResource",null),ge([R.memoize],l.prototype,"telemetryLogResource",null),ge([R.memoize],l.prototype,"disableWorkspaceTrust",null),ge([R.memoize],l.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=l;function v(p,w){return P(p["inspect-extensions"],p["inspect-brk-extensions"],5870,w,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=v;function S(p,w){return P(p["inspect-search"],p["inspect-brk-search"],5876,w,p.extensionEnvironment)}e.parseSearchPort=S;function m(p,w){return P(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,w,p.extensionEnvironment)}e.parsePtyHostPort=m;function P(p,w,E,c,h,y){const s=Number(w||p)||(c?null:E),i=s?Boolean(!!w):!1;let n;if(y)try{n=JSON.parse(y)}catch{}return{port:s,break:i,debugId:h,env:n}}}),function(){"use strict";function $(e,k,R){function D(O,I){const d=L(O,I),l=[d];return e.isAbsolute(d)||l.unshift(R),e.resolve(...l)}function L(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const v=O["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(S,"AppData","Roaming")}break;case"darwin":l=e.join(k.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:D}}if(typeof define=="function")define(Q[101],Z([151,38,33]),function(e,k,R){return $(e,k,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=$(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[102],Z([0,1,38,100,101]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends R.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I,d.nameShort)},d)}}e.NativeEnvironmentService=L}),define(Q[103],Z([0,1,8,86]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,I,d){try{L(O,I,d)}catch(l){console.error(l?.message??l)}return O}e.localizeManifest=D;function L(O,I,d){const l=(v,S,m)=>{const P=v[S];if((0,k.isString)(P)){const p=P,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const E=p.substr(1,w-2);let c=I[E];c===void 0&&d&&(c=d[E]);const h=typeof c=="string"?c:c?.message,y=d?.[E],f=typeof y=="string"?y:y?.message;if(!h){f||console.warn(`[${O.name}]: ${(0,R.localize)(0,null,E)}`);return}if(m&&(S==="title"||S==="category")&&f&&f!==h){const s={value:h,original:f};v[S]=s}else v[S]=h}}else if((0,k.isObject)(P))for(const p in P)P.hasOwnProperty(p)&&(p==="commands"?l(P,p,!0):l(P,p,m));else if(Array.isArray(P))for(let p=0;p<P.length;p++)l(P,p,m)};for(const v in O)O.hasOwnProperty(v)&&l(O,v)}}),define(Q[45],Z([0,1,17,54,90,39]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function d(c){return c=c.trim(),c==="*"||O.test(c)}e.isValidVersionStr=d;function l(c){if(!d(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=c.match(O);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=l;function v(c){if(!c)return null;const h=c.majorBase,y=c.majorMustEqual,f=c.minorBase;let s=c.minorMustEqual;const i=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(h===0||(s=!1),n=!1);let t=0;if(c.preRelease){const r=I.exec(c.preRelease);if(r){const[,o,u,a]=r;t=Date.UTC(Number(o),Number(u)-1,Number(a))}}return{majorBase:h,majorMustEqual:y,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:t}}e.normalizeVersion=v;function S(c,h,y){let f;typeof c=="string"?f=v(l(c)):f=c;let s;h instanceof Date?s=h.getTime():typeof h=="string"&&(s=new Date(h).getTime());let i;if(typeof y=="string"?i=v(l(y)):i=y,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,u=i.minorBase,a=i.patchBase;const g=i.notBefore;let C=i.majorMustEqual,N=i.minorMustEqual,B=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>u?!0:t<u||s&&s<g?!1:r>=a:(n===1&&o===0&&(!C||!N||!B)&&(o=1,u=0,a=0,C=!0,N=!1,B=!1),n<o?!1:n>o?!C:t<u?!1:t>u?!N:r<a?!1:r>a?!B:!(s&&s<g))}e.isValidVersion=S;function m(c,h,y,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([R.default.Error,D.localize(0,null)]),i;if(typeof f.name!="string")return i.push([R.default.Error,D.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([R.default.Error,D.localize(2,null,"version")]),i;if(!f.engines)return i.push([R.default.Error,D.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([R.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return i.push([R.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return i.push([R.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([R.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([R.default.Warning,D.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([R.default.Error,D.localize(9,null,"main")]),i;{const r=(0,k.joinPath)(y,f.main);(0,k.isEqualOrParent)(r,y)||i.push([R.default.Warning,D.localize(10,null,r.path,y.path)])}if(typeof f.activationEvents>"u")return i.push([R.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([R.default.Error,D.localize(12,null,"browser")]),i;{const r=(0,k.joinPath)(y,f.browser);(0,k.isEqualOrParent)(r,y)||i.push([R.default.Warning,D.localize(13,null,r.path,y.path)])}if(typeof f.activationEvents>"u")return i.push([R.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([R.default.Error,D.localize(15,null)]),i;const n=[];if(!P(c,h,f,s,n))for(const r of n)i.push([R.default.Error,r]);return i}e.validateExtensionManifest=m;function P(c,h,y,f,s){return f||typeof y.main>"u"&&typeof y.browser>"u"?!0:w(c,h,y.engines.vscode,s)}e.isValidExtensionVersion=P;function p(c,h,y){return c==="*"||w(h,y,c)}e.isEngineValid=p;function w(c,h,y,f=[]){const s=v(l(y));if(!s)return f.push(D.localize(16,null,y)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(D.localize(17,null,y)),!1}else if(!s.majorMustEqual)return f.push(D.localize(18,null,y)),!1;return S(c,h,s)?!0:(f.push(D.localize(19,null,c,y)),!1)}function E(c){if(!Array.isArray(c))return!1;for(let h=0,y=c.length;h<y;h++)if(typeof c[h]!="string")return!1;return!0}}),define(Q[104],Z([0,1,14,31]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,O,I){let d=I&&I.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const v=(await O.readFile(L.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(v)?v:null}catch{d=null}if(!d){d=(0,R.generateUuid)();try{await O.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(d))}catch{}}return I?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=D}),define(Q[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,L=[],O=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=k}),define(Q[105],Z([0,1,46]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var D;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function L(I,d,l){d instanceof k.SyncDescriptor||(d=new k.SyncDescriptor(d,[],Boolean(l))),R.push([I,d])}e.registerSingleton=L;function O(){return R}e.getSingletonServiceDescriptors=O}),define(Q[106],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(L,O){this.key=L,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class R{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const O of this._nodes.values())O.outgoing.size===0&&L.push(O);return L}insertEdge(L,O){const I=this.lookupOrInsertNode(L),d=this.lookupOrInsertNode(O);I.outgoing.set(d.key,d),d.incoming.set(I.key,I)}removeNode(L){const O=this._hashFn(L);this._nodes.delete(O);for(const I of this._nodes.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(L){const O=this._hashFn(L);let I=this._nodes.get(O);return I||(I=new k(O,L),this._nodes.set(O,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[O,I]of this._nodes)L.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,O]of this._nodes){const I=new Set([L]),d=this._findCycle(O,I);if(d)return d}}_findCycle(L,O){for(const[I,d]of L.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const l=this._findCycle(d,O);if(l)return l;O.delete(I)}}}e.Graph=R}),define(Q[21],Z([0,1,8,10,7]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationOverrides=L;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=O;var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function l(c,h){const y=Object.create(null);for(const f in c)v(y,f,c[f],h);return y}e.toValuesTree=l;function v(c,h,y,f){const s=h.split("."),i=s.pop();let n=c;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${h} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=y}catch{f(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=v;function S(c,h){const y=h.split(".");m(c,y)}e.removeFromValueTree=S;function m(c,h){const y=h.shift();if(h.length===0){delete c[y];return}if(Object.keys(c).indexOf(y)!==-1){const f=c[y];typeof f=="object"&&!Array.isArray(f)&&(m(f,h),Object.keys(f).length===0&&delete c[y])}}function P(c,h,y){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=h.split("."),i=f(c,s);return typeof i>"u"?y:i}e.getConfigurationValue=P;function p(c,h,y){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in c?k.isObject(c[f])&&k.isObject(h[f])?p(c[f],h[f],y):y&&(c[f]=h[f]):c[f]=h[f])})}e.merge=p;function w(c,h,y){const f=c.inspect(h),s=c.inspect(y);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=w;function E(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Q[58],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(Q[18],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[23],Z([0,1,84,7]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function D(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function O(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function I(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function d(c,h,y){return I(h,y)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===y?!0:l(y).includes(c)}e.isTargetPlatformCompatible=d;function l(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function v(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=v;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var P;(function(c){c.Install="install",c.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var p;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var w;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(h,y){super(h),this.code=y,this.name=y}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class R{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((L,O)=>$(["node-vsce-sign"],async I=>L(I),O))),this.moduleLoadingPromise}async verify(L,O){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(L,O)}}e.ExtensionSignatureVerificationService=R}),define(Q[60],Z([0,1,14,11,92,13]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(v,S,m,P,p,w){let E;try{await I(v,S,m,P,p,w)}catch(c){E=c}finally{E&&p.errorTransformer&&(E=p.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}e.readFileIntoStream=O;async function I(v,S,m,P,p,w){d(w);const E=await v.open(S,{create:!1});try{d(w);let c=0,h=0,y=p&&typeof p.length=="number"?p.length:void 0,f=k.VSBuffer.alloc(Math.min(p.bufferSize,typeof y=="number"?y:p.bufferSize)),s=p&&typeof p.position=="number"?p.position:0,i=0;do h=await v.read(E,s,f.buffer,i,f.byteLength-i),s+=h,i+=h,c+=h,typeof y=="number"&&(y-=h),i===f.byteLength&&(await m.write(P(f)),f=k.VSBuffer.alloc(Math.min(p.bufferSize,typeof y=="number"?y:p.bufferSize)),i=0);while(h>0&&(typeof y!="number"||y>0)&&d(w)&&l(c,p));if(i>0){let n=i;typeof y=="number"&&(n=Math.min(i,y)),m.write(P(f.slice(0,n)))}}catch(c){throw(0,L.ensureFileSystemProviderError)(c)}finally{await v.close(E)}}function d(v){if(v.isCancellationRequested)throw(0,R.canceled)();return!0}function l(v,S){if(S?.limits){if(typeof S.limits.memory=="number"&&v>S.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&v>S.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,3,152,2,12,153]),function($,e,k,R,D,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const v=this.normalizeRequests(l),S=v.filter(P=>{const p=this.watchers.get(P.path);return p?!(0,R.patternsEquals)(p.request.excludes,P.excludes)||!(0,R.patternsEquals)(p.request.includes,P.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:P})=>!v.find(p=>p.path===P.path&&(0,R.patternsEquals)(p.excludes,P.excludes)&&(0,R.patternsEquals)(p.includes,P.includes))).map(({request:P})=>P.path);S.length&&this.trace(`Request to start watching: ${S.map(P=>`${P.path} (excludes: ${P.excludes.length>0?P.excludes:"<none>"}, includes: ${P.includes&&P.includes.length>0?JSON.stringify(P.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const P of m)this.stopWatching(P);for(const P of S)this.startWatching(P)}startWatching(l){const v=new O.NodeJSFileWatcherLibrary(l,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),S={request:l,instance:v};this.watchers.set(l.path,S)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const v=this.watchers.get(l);v&&(this.watchers.delete(l),v.instance.dispose())}normalizeRequests(l){const v=new Map;for(const S of l){const m=L.isLinux?S.path:S.path.toLowerCase();v.set(m,S)}return Array.from(v.values())}async setVerboseLogging(l){this.verboseLogging=l;for(const[,v]of this.watchers)v.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,v){return v?`[File Watcher (node.js)] ${l} (path: ${v.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=I}),define(Q[108],Z([0,1,61,107]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(O,I,d){super(O,I,d),this.init()}createWatcher(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(Q[109],Z([0,1,16,56,79,61]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends L.AbstractUniversalWatcherClient{constructor(d,l,v){super(d,l,v),this.init()}createWatcher(d){const l=d.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(l.onDidProcessExit(({code:v,signal:S})=>this.onError(`terminated by itself with code ${v}, signal: ${S}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(Q[62],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this._entries=new Map;for(const[L,O]of D)this.set(L,O)}set(D,L){const O=this._entries.get(D);return this._entries.set(D,L),O}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=k}),define(Q[110],Z([0,1,4,11,2,46,106,7,62,154]),function($,e,k,R,D,L,O,I,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class S extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new d.ServiceCollection,c=!1,h,y=v){this._services=E,this._strict=c,this._parent=h,this._enableTracing=y,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new O.Graph(f=>f):void 0}createChild(E){return new m(E,this._strict,this,this._enableTracing)}invokeFunction(E,...c){const h=p.traceInvocation(this._enableTracing,E);let y=!1;try{return E({get:s=>{if(y)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(s,h);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...c)}finally{y=!0,h.stop()}}createInstance(E,...c){let h,y;return E instanceof L.SyncDescriptor?(h=p.traceCreation(this._enableTracing,E.ctor),y=this._createInstance(E.ctor,E.staticArguments.concat(c),h)):(h=p.traceCreation(this._enableTracing,E),y=this._createInstance(E,c,h)),h.stop(),y}_createInstance(E,c=[],h){const y=I._util.getServiceDependencies(E).sort((i,n)=>i.index-n.index),f=[];for(const i of y){const n=this._getOrCreateServiceInstance(i.id,h);n||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=y.length>0?y[0].index:c.length;if(c.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${c.length} static arguments`);const i=s-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,s)}return Reflect.construct(E,c.concat(f))}_setServiceInstance(E,c){if(this._services.get(E)instanceof L.SyncDescriptor)this._services.set(E,c);else if(this._parent)this._parent._setServiceInstance(E,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const c=this._services.get(E);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):c}_getOrCreateServiceInstance(E,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const h=this._getServiceInstanceOrDescriptor(E);return h instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,h,c.branch(E,!0)):(c.branch(E,!1),h)}_safeCreateAndCacheServiceInstance(E,c,h){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,c,h)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,c,h){const y=new O.Graph(i=>i.id.toString());let f=0;const s=[{id:E,desc:c,_trace:h}];for(;s.length;){const i=s.pop();if(y.lookupOrInsertNode(i),f++>1e3)throw new S(y);for(const n of I._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof L.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};y.insertEdge(i,r),s.push(r)}}}for(;;){const i=y.roots();if(i.length===0){if(!y.isEmpty())throw new S(y);break}for(const{data:n}of i){if(this._getServiceInstanceOrDescriptor(n.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,r)}y.removeNode(n)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,c,h=[],y,f){if(this._services.get(E)instanceof L.SyncDescriptor)return this._createServiceInstance(E,c,h,y,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,c,h,y,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(E,c,h=[],y,f){if(y){const s=new m(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(E);const i=new Map,n=new k.IdleValue(()=>{const t=s._createInstance(c,h,f);for(const[r,o]of i){const u=t[r];if(typeof u=="function")for(const a of o)u.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new l.LinkedList,i.set(r,a)),(C,N,B)=>{const K=a.push([C,N,B]);return(0,D.toDisposable)(K)}}if(r in t)return t[r];const o=n.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),t[r]=u),u},set(t,r,o){return n.value[r]=o,!0}})}else return this._createInstance(c,h,f)}_throwIfStrict(E,c){if(c&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=m;var P;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(P||(P={}));class p{static traceInvocation(E,c){return E?new p(1,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(E,c){return E?new p(0,c.name):p._None}constructor(E,c){this.type=E,this.name=c,this._start=Date.now(),this._dep=[]}branch(E,c){const h=new p(2,E.toString());return this._dep.push([E,c,h]),h}stop(){const E=Date.now()-this._start;p._totals+=E;let c=!1;function h(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s._dep)if(r&&o){c=!0,i.push(`${n}CREATES -> ${t}`);const u=h(f+1,o);u&&i.push(u)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(E>2||c)&&p.all.add(y.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0});var ie=this&&this.__param||function($,e){return function(k,R){e(k,R,$)}};define(Q[63],Z([0,1,22,2,12,94,23,7]),function($,e,k,R,D,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let d=class extends R.Disposable{constructor(v){super(),this.extensionGalleryService=v}async getAvailableLanguages(){const v=new k.CancellationTokenSource;setTimeout(()=>v.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const P=S.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],E=this.getLocale(p);return{...this.createQuickPickItem(E,w,p),extensionId:p.identifier.id,galleryExtension:p}});return P.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),P}getLocale(v){return v.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(v,S,m){const P=S??v;let p;if(P!==v&&(p=`(${v})`),v.toLowerCase()===D.language.toLowerCase()&&(p??="",p+=(0,L.localize)(0,null)),m?.installCount){p??="";const w=m.installCount;let E;w>1e6?E=`${Math.floor(w/1e5)/10}M`:w>1e3?E=`${Math.floor(w/1e3)}K`:E=String(w),p+=` $(cloud-download) ${E}`}return{id:v,label:P,description:p}}};d=ge([ie(0,O.IExtensionGalleryService)],d),e.LanguagePackBaseService=d}),define(Q[9],Z([0,1,32,3,2,34,12,10,7]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function l(){return new Date().toISOString()}var v;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function S(u,a,g){switch(a){case v.Trace:u.trace(g);break;case v.Debug:u.debug(g);break;case v.Info:u.info(g);break;case v.Warning:u.warn(g);break;case v.Error:u.error(g);break;default:throw new Error("Invalid log level")}}e.log=S;function m(u){let a="";for(let g=0;g<u.length;g++){let C=u[g];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}a+=(g>0?" ":"")+C}return a}e.format=m;class P extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class p extends P{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...g){this.checkLogLevel(v.Trace)&&this.log(v.Trace,m([a,...g]))}debug(a,...g){this.checkLogLevel(v.Debug)&&this.log(v.Debug,m([a,...g]))}info(a,...g){this.checkLogLevel(v.Info)&&this.log(v.Info,m([a,...g]))}warn(a,...g){this.checkLogLevel(v.Warning)&&this.log(v.Warning,m([a,...g]))}error(a,...g){if(this.checkLogLevel(v.Error))if(a instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=a.stack,this.log(v.Error,m(C))}else this.log(v.Error,m([a,...g]))}flush(){}}e.AbstractMessageLogger=p;class w extends P{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!O.isWindows}trace(a,...g){this.getLevel()<=v.Trace&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...g):console.log(`[main ${l()}]`,a,...g))}debug(a,...g){this.getLevel()<=v.Debug&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...g):console.log(`[main ${l()}]`,a,...g))}info(a,...g){this.getLevel()<=v.Info&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...g):console.log(`[main ${l()}]`,a,...g))}warn(a,...g){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,a,...g):console.warn(`[main ${l()}]`,a,...g))}error(a,...g){this.getLevel()<=v.Error&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,a,...g):console.error(`[main ${l()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class E extends P{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=E;class c extends P{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(g)}trace(a,...g){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(a),...g])}debug(a,...g){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(a),...g])}info(a,...g){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(a),...g])}warn(a,...g){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(a),...g])}error(a,...g){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(a),...g])}extractMessage(a){return typeof a=="string"?a:(0,k.toErrorMessage)(a,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class h extends P{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.logServices)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const C of this.logServices)C.trace(a,...g)}debug(a,...g){for(const C of this.logServices)C.debug(a,...g)}info(a,...g){for(const C of this.logServices)C.info(a,...g)}warn(a,...g){for(const C of this.logServices)C.warn(a,...g)}error(a,...g){for(const C of this.logServices)C.error(a,...g)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=h;class y extends D.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...g){this.logger.trace(a,...g)}debug(a,...g){this.logger.debug(a,...g)}info(a,...g){this.logger.info(a,...g)}warn(a,...g){this.logger.warn(a,...g)}error(a,...g){this.logger.error(a,...g)}flush(){this.logger.flush()}}e.LogService=y;class f extends D.Disposable{constructor(a,g){super(),this.logLevel=a,this.loggerItems=new L.ResourceMap,this._register(g(C=>this.setLevel(C)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,g,C){let N=this.loggerItems.get(a)?.logger;return N||(C=g?.always?v.Trace:C,N=this.doCreateLogger(a,C??this.logLevel,g),this.loggerItems.set(a,{logger:N,logLevel:C})),N}setLevel(a,g){const C=I.URI.isUri(a)?a:void 0,N=C?g:a;if(C){const B=this.loggerItems.get(C);B&&B.logLevel!==N&&(B.logLevel=N,B.logger.setLevel(N))}else this.logLevel=N,this.loggerItems.forEach(({logLevel:B,logger:K})=>{B===void 0&&K.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(a){}getLevel(){return v.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(v.Info,R.Event.None)}doCreateLogger(a,g,C){return new s}}e.NullLoggerService=n;function t(u){if(u.verbose)return v.Trace;if(typeof u.logLevel=="string"){const a=o(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(u){switch(u){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=r;function o(u){switch(u){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=o}),define(Q[111],Z([0,1,19,4,11,3,2,15,61,9]),function($,e,k,R,D,L,O,I,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends O.Disposable{constructor(m,P){super(),this.logService=m,this.options=P,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(m,P){return P.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,P):this.watchNonRecursive(m,P)}watchUniversal(m,P){const p={path:this.toFilePath(m),excludes:P.excludes,includes:P.includes,recursive:P.recursive},w=(0,k.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{w(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(P=>this._onDidChangeFile.fire((0,d.toFileChanges)(P)),P=>this.onWatcherLogMessage(P),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const P of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(P)&&(P.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const P of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(P)&&m.includes(P.path)&&(P.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,P){const p={path:this.toFilePath(m),excludes:P.excludes,includes:P.includes,recursive:!1},w=(0,k.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{w(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(Q[112],Z([0,1,19,4,14,22,3,53,64,2,113,16,114,17,43,91,13,60,9]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends l.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new l.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new E.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,l.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){i.push(n)}}),!this.provider.has(s)&&await R.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return d.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,P.isAbsolutePath)(s))throw new E.FileOperationError((0,w.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,w.localize)(1,null,s.toString()),n}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,w.localize)(2,null,this.resourceForError(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(s,i){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,a=await n.stat(s);let g;return this.toFileStat(n,s,a,void 0,!!u,(C,N)=>(g||(g=v.TernarySearchTree.forUris(()=>!t),g.set(s,!0),r&&g.fill(!0,r)),g.get(C.resource)||g.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&o?N===1:!1))}async toFileStat(s,i,n,t,r,o){const{providerExtUri:u}=this.getExtUri(s),a={resource:i,name:u.basename(i),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const g=await s.readdir(i),C=await R.Promises.settled(g.map(async([N,B])=>{try{const K=u.joinPath(i,N),X=r?await s.stat(K):{type:B};return await this.toFileStat(s,K,X,g.length,r,o)}catch(K){return this.logService.trace(K),null}}));a.children=(0,k.coalesce)(C)}catch(g){this.logService.trace(g),a.children=[]}return a}return a}async resolveAll(s){return R.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),n=await i.stat(s);return this.toFileStat(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(n){return n}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,w.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,i);return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let u;if((0,E.hasReadWriteCapability)(t)&&!(i instanceof D.VSBuffer))if((0,p.isReadableStream)(i)){const a=await(0,p.peekStream)(i,3);a.ended?u=D.VSBuffer.concat(a.buffer):u=a}else u=(0,p.peekReadable)(i,a=>D.VSBuffer.concat(a),3);else u=i;!(0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)&&u instanceof D.VSBuffer?await this.doWriteUnbuffered(t,s,n,u):await this.doWriteBuffered(t,s,n,u instanceof D.VSBuffer?(0,D.bufferToReadable)(u):u),this._onDidRunOperation.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,w.localize)(4,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,w.localize)(6,null,this.resourceForError(i)),0,n);if(this.throwIfFileIsReadonly(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,w.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(t,s,i,n):this.doReadFile(t,s,i,n)}async doReadFileAtomic(s,i,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(s,i,n,t);r(u)}catch(u){o(u)}})})}async doReadFile(s,i,n,t){const r=await this.doReadFileStream(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,i,n)}async doReadFileStream(s,i,n,t){const r=new L.CancellationTokenSource(t),o=this.validateReadFile(i,n).then(a=>a,a=>{throw r.cancel(),a});let u;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?u=this.readFileUnbuffered(s,i,n):(0,E.hasFileReadStreamCapability)(s)?u=this.readFileStreamed(s,i,r.token,n):u=this.readFileBuffered(s,i,r.token,n),{...await o,value:u}}catch(a){u&&await(0,p.consumeStream)(u);const g=(0,w.localize)(8,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(g,a.stat,n):new E.FileOperationError(g,(0,E.toFileOperationResult)(a),n)}}readFileStreamed(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,p.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,w.localize)(9,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},o=>D.VSBuffer.concat(o))}readFileBuffered(s,i,n,t=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,c.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new E.FileOperationError((0,w.localize)(10,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,i,n){const t=(0,p.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(i,r.byteLength,n),t.end(D.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,w.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,w.localize)(12,null),n,i);return this.validateReadFileLimits(s,n.size,i),n}validateReadFileLimits(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new E.FileOperationError((0,w.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,i,n){return this.doCanMoveCopy(s,i,"move",n)}async canCopy(s,i,n){return this.doCanMoveCopy(s,i,"copy",n)}async doCanMoveCopy(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,s,r,i,"move",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,i,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,s,r,i,"copy",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,i,n,t,r,o);if(u&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const g=await this.resolve(i);g.isDirectory?await this.doCopyFolder(s,g,n,t):await this.doCopyFile(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.doMoveCopy(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,n,t){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,i,n,t);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,i,n,t)}async doCopyFolder(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await R.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,i,n,t,r,o){let u=!1;if(s===n){const{providerExtUri:g,isPathCaseSensitive:C}=this.getExtUri(s);if(C||(u=g.isEqual(i,t)),u&&r==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!u&&g.isEqualOrParent(t,i))throw new Error((0,w.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!u){if(!o)throw new E.FileOperationError((0,w.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(s===n){const{providerExtUri:g}=this.getExtUri(s);if(g.isEqualOrParent(i,t))throw new Error((0,w.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,n)),n}async mkdirp(s,i){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&E.FileType.Directory)===0)throw new Error((0,w.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(n){return n}return!0}async doValidateDelete(s,i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new E.FileOperationError((0,w.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,w.localize)(21,null,this.resourceForError(s)))}return n}async del(s,i){const n=await this.doValidateDelete(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,l.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,i);t?(0,l.dispose)(o):r=()=>(0,l.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,i){const n=await this.withProvider(s),t=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),i]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.activeWatchers.set(t,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,n,t){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(t)||(0,p.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,i,n){let t=0,r;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,u)=>{(0,p.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(s,i,a,a.byteLength,t,0)}catch(g){return u(g)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>u(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,i,n,t,r,o){let u=0;for(;u<t;)u+=await s.write(i,r+u,n.buffer,o+u,t-u)}async doWriteUnbuffered(s,i,n,t){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,n,t))}async doWriteUnbufferedQueued(s,i,n,t){let r;t instanceof D.VSBuffer?r=t:(0,p.isReadableStream)(t)?r=await(0,D.streamToBuffer)(t):(0,p.isReadableBufferedStream)(t)?r=await(0,D.bufferedStreamToBuffer)(t):r=(0,D.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,n,t))}async doPipeBufferedQueued(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const u=D.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,g=0,C=0;do C=await s.read(r,a,u.buffer,g,u.byteLength-g),await this.doWriteBuffer(n,o,u,C,a,g),a+=C,g+=C,g===u.byteLength&&(g=0);while(C>0)}catch(u){throw(0,E.ensureFileSystemProviderError)(u)}finally{await R.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,n,t))}async doPipeUnbufferedQueued(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,n,t))}async doPipeUnbufferedToBufferedQueued(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(n,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,i,n,t){const r=await(0,D.streamToBuffer)(this.readFileBuffered(s,i,L.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new E.FileOperationError((0,w.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,w.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===S.Schemas.file?s.fsPath:s.toString(!0)}};y=ge([ie(0,h.ILogService)],y),e.FileService=y}),define(Q[115],Z([0,1,116,155,4,34,14,3,156,2,15,12,17,43,20,93,13,60,111,32,109,108]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h,y,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(k)}catch(n){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(n)}`)}})();class i extends h.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new L.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await p.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await p.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(t,u.name))).type:a=this.toType(u),o.push([u.name,a])}catch(a){this.logService.trace(a)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=E.FileType.Unknown:t.isFile()?o=E.FileType.File:t.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new D.Barrier;return this.resourceLocks.set(t,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const u=this.toFilePath(t);return await p.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,r,o){const u=(0,P.newWriteableStream)(a=>O.VSBuffer.concat(a.map(g=>O.VSBuffer.wrap(g))).buffer);return(0,c.readFileIntoStream)(this,t,u,a=>a.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(t,r,o){let u;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await p.Promises.exists(a)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,w.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,w.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,r){const o=this.toFilePath(t);let u;(0,E.isFileOpenForWriteOptions)(r)&&(u=await this.createResourceLock(t));let a;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:C}=await p.SymlinkSupport.stat(o);C.mode&128||await p.Promises.chmod(o,C.mode|128)}catch(C){this.logService.trace(C)}let g;if((0,E.isFileOpenForWriteOptions)(r)){if(S.isWindows)try{await p.Promises.truncate(o,0),g="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}g||(g="w")}else g="r";a=await p.Promises.open(o,g)}catch(g){throw u?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(a,0),(0,E.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,t),u){const g=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,u),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),g.dispose())}return a}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await p.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await p.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,u,a){const g=this.normalizePos(t,r);let C=null;try{C=(await p.Promises.read(t,o,u,a,g)).bytesRead}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(t,g,C)}return C}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,u,a){return(0,D.retry)(()=>this.doWrite(t,r,o,u,a),100,3)}async doWrite(t,r,o,u,a){const g=this.normalizePos(t,r);let C=null;try{C=(await p.Promises.write(t,o,u,a,g)).bytesWritten}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),N)}finally{this.updatePos(t,g,C)}return C}async mkdir(t){try{await p.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const u=this.toFilePath(t),a=this.toFilePath(r);if(u!==a)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await p.Promises.move(u,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,w.localize)(2,null,(0,v.basename)(u),(0,v.basename)((0,v.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(t,r,o){const u=this.toFilePath(t),a=this.toFilePath(r);if(u!==a)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await p.Promises.copy(u,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,w.localize)(3,null,(0,v.basename)(u),(0,v.basename)((0,v.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(t,r,o,u){const a=this.toFilePath(t),g=this.toFilePath(r);let C=!1;if(!!(this.capabilities&1024)||(C=(0,d.isEqual)(a,g,!0)),C&&o==="copy")throw(0,E.createFileSystemProviderError)((0,w.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!C&&await p.Promises.exists(g)){if(!u)throw(0,E.createFileSystemProviderError)((0,w.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const u=this.toFilePath(t),a=this.toFilePath(r),g=!!(this.capabilities&1024);if((0,d.isEqual)(u,a,!g))return;const C=new l.DisposableStore;try{const[N,B]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);C.add(N),C.add(B),o&&await p.Promises.mkdir((0,v.dirname)(a),{recursive:!0}),await p.Promises.copyFile(u,a)}catch(N){if(N.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(N)}finally{C.dispose()}}createUniversalWatcher(t,r,o){return new f.UniversalWatcherClient(u=>t(u),u=>r(u),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(u=>t(u),u=>r(u),o)}toFileSystemProviderError(t){if(t instanceof E.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await p.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(Q[117],Z([0,1,13,9]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(D||(D={}));async function L(l,v,S,m,P){try{const p=await new Promise((E,c)=>{$(["spdlog"],E,c)});p.setFlushOn(R.LogLevel.Trace);const w=await p.createAsyncRotatingLogger(l,v,S,m);return P?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(p){console.error(p)}return null}function O(l,v,S){switch(v){case R.LogLevel.Trace:l.trace(S);break;case R.LogLevel.Debug:l.debug(S);break;case R.LogLevel.Info:l.info(S);break;case R.LogLevel.Warning:l.warn(S);break;case R.LogLevel.Error:l.error(S);break;default:throw new Error("Invalid log level")}}function I(l,v){switch(v){case R.LogLevel.Trace:l.setLevel(D.Trace);break;case R.LogLevel.Debug:l.setLevel(D.Debug);break;case R.LogLevel.Info:l.setLevel(D.Info);break;case R.LogLevel.Warning:l.setLevel(D.Warning);break;case R.LogLevel.Error:l.setLevel(D.Error);break;case R.LogLevel.Off:l.setLevel(D.Off);break;default:throw new Error("Invalid log level")}}class d extends R.AbstractMessageLogger{constructor(v,S,m,P,p){super(),this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(v,S,m,P),this._register(this.onDidChangeLogLevel(w=>{this._logger&&I(this._logger,w)}))}async _createSpdLogLogger(v,S,m,P){const p=m?6:1,w=30/p*k.ByteSize.MB,E=await L(v,S,w,p,P);if(E){this._logger=E,I(this._logger,this.getLevel());for(const{level:c,message:h}of this.buffer)O(this._logger,c,h);this.buffer=[]}}log(v,S){this._logger?O(this._logger,v,S):this.getLevel()<=v&&this.buffer.push({level:v,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=d}),define(Q[37],Z([0,1,3,64,2,7]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(l){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(l),R.Iterable.reduce(this.policies.entries(),(S,[m,P])=>({...S,[m]:P}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[v,S])=>({...l,[v]:{definition:S,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=O;class I{constructor(){this.onDidChange=k.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(Q[118],Z([0,1,4,3,64,8,13,9,37]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(S,m){const P=[];for(const p of D.Iterable.concat(S.keys(),m.keys()))S.get(p)!==m.get(p)&&P.push(p);return P}let v=class extends d.AbstractPolicyService{constructor(m,P,p){super(),this.file=m,this.fileService=P,this.logService=p,this.throttledDelayer=this._register(new k.ThrottledDelayer(500));const w=R.Event.filter(P.onDidFilesChange,E=>E.affects(m));this._register(P.watch(m)),this._register(w(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(m){await this.refresh()}async read(){const m=new Map;try{const P=await this.fileService.readFile(this.file),p=JSON.parse(P.value.toString());if(!(0,L.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(p))this.policyDefinitions[w]&&m.set(w,p[w])}catch(P){P.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",P)}return m}async refresh(){const m=await this.read(),P=l(this.policies,m);this.policies=m,P.length>0&&this._onDidChange.fire(P)}};v=ge([ie(1,O.IFileService),ie(2,I.ILogService)],v),e.FilePolicyService=v}),define(Q[28],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[35],Z([0,1,69,8]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(O,I){k.ok(R.isString(O)),k.ok(R.isObject(I)),k.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,I)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new D}),define(Q[119],Z([0,1,3,35]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,l){this.schemasById[D(d)]=l,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new L;R.Registry.add(e.Extensions.JSONContribution,O)}),define(Q[40],Z([0,1,19,3,8,82,21,119,35]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=d.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.doRegisterConfigurations(i,n);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const n=this.doDeregisterConfigurations(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const u in r)if(n.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.configurationDefaultsOverrides.get(u),g=a?.valuesSources??new Map;if(o)for(const K of Object.keys(r[u]))g.set(K,o);const C={...a?.value||{},...r[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:C,valuesSources:g});const N=(0,O.getLanguageTagSettingPlainKey)(u),B={type:"object",default:C,description:L.localize(1,null,N),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...w(u)),this.configurationProperties[u]=B,this.defaultLanguageConfigurationOverridesNode.properties[u]=B}else{this.configurationDefaultsOverrides.set(u,{value:r[u],source:o});const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const u=this.configurationDefaultsOverrides.get(o),a=D.isString(r)?r:r?.id,g=D.isString(u?.source)?u?.source:u?.source?.id;if(a===g)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const C=this.configurationProperties[o];C&&(this.updatePropertyDefaultValue(o,C),this.updateSchema(o,C))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const n of i)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,n){const t=[];return i.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(i,n=!0,t,r,o=3){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const u=[],a=i.properties;if(a)for(const C in a){const N=a[C];if(n&&y(C,N)){delete a[C];continue}if(N.source=t,N.defaultDefaultValue=a[C].default,this.updatePropertyDefaultValue(C,N),e.OVERRIDE_PROPERTY_REGEX.test(C)?N.scope=void 0:(N.scope=D.isUndefinedOrNull(N.scope)?o:N.scope,N.restricted=D.isUndefinedOrNull(N.restricted)?!!r?.includes(C):N.restricted),a[C].hasOwnProperty("included")&&!a[C].included){this.excludedConfigurationProperties[C]=a[C],delete a[C];continue}else this.configurationProperties[C]=a[C],a[C].policy?.name&&this.policyConfigurations.set(a[C].policy.name,C);!a[C].deprecationMessage&&a[C].markdownDeprecationMessage&&(a[C].deprecationMessage=a[C].markdownDeprecationMessage),u.push(C)}const g=i.allOf;if(g)for(const C of g)u.push(...this.validateAndRegisterProperties(C,n,t,r,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const n=t=>{const r=t.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);t.allOf?.forEach(n)};n(i)}updateSchema(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.resourceLanguageSettingsSchema.properties[i]=n;break}}removeFromSchema(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const n=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,n){const t=this.configurationDefaultsOverrides.get(i);let r=t?.value,o=t?.source;D.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),D.isUndefined(r)&&(r=c(n.type)),n.default=r,n.defaultValueSource=o}}const P="\\[([^\\]]+)\\]",p=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=p.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=p.exec(s)}}return(0,k.distinct)(i)}e.overrideIdentifiersFromKey=w;function E(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function c(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const h=new m;d.Registry.add(e.Extensions.Configuration,h);function y(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):h.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,s,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=y;function f(){const s=[],i=h.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Q[65],Z([0,1,19,3,50,2,34,26,8,10,21,40,35]),function($,e,k,R,D,L,O,I,d,l,v,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(n={},t=[],r=[],o){this._contents=n,this._keys=t,this._overrides=r,this.raw=o,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof P)return t;const r=new p("");return r.parseRaw(t),r.configurationModel});this._rawConfiguration=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,v.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,u=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:u}}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,v.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return k.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const a of n)if(u.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(t,a.contents);for(const g of a.overrides){const[C]=r.filter(N=>k.equals(N.identifiers,g.identifiers));C?(this.mergeContents(C.contents,g.contents),C.keys.push(...g.keys),C.keys=k.distinct(C.keys)):r.push(I.deepClone(g))}for(const g of a.keys)o.indexOf(g)===-1&&o.push(g)}return new P(t,o,r,u.every(a=>a instanceof P)?void 0:u)}freeze(){return this.frozen=!0,this}clone(){return new P(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o];const a=t[o];a&&(typeof u=="object"&&typeof a=="object"?(u=I.deepClone(u),this.mergeContents(u,a)):u=a),r[o]=u}return new P(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&d.isObject(n[r])&&d.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=I.deepClone(t[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=I.deepClone(u))};for(const u of this.overrides)k.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,v.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,v.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=P;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!d.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:o,overrides:u,restricted:a,hasExcludedProperties:g}=this.doParseRaw(n,t);this._configurationModel=new P(r,o,u,g?[n]:void 0),this._restrictedConfigurations=a||[]}doParseContent(n){let t={},r=null,o=[];const u=[],a=[];function g(N){Array.isArray(o)?o.push(N):r!==null&&(o[r]=N)}const C={onObjectBegin:()=>{const N={};g(N),u.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const N=[];g(N),u.push(o),o=N,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:g,onError:(N,B,K)=>{a.push({error:N,offset:B,length:K})}};if(n)try{D.visit(n,C),t=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return t}doParseRaw(n,t){const r=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,t);n=o.raw;const u=(0,v.toValuesTree)(n,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),a=Object.keys(n),g=this.toOverrides(n,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:u,keys:a,overrides:g,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(n,t,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:u};const a={},g=[];for(const C in n)if(S.OVERRIDE_PROPERTY_REGEX.test(C)&&r){const N=this.filter(n[C],t,!1,o);a[C]=N.raw,u=u||N.hasExcludedProperties,g.push(...N.restricted)}else{const N=t[C],B=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&g.push(C),(B===void 0||o.scopes===void 0||o.scopes.includes(B))&&!(o.skipRestricted&&N?.restricted)?a[C]=n[C]:u=!0}return{raw:a,restricted:g,hasExcludedProperties:u}}toOverrides(n,t){const r=[];for(const o of Object.keys(n))if(S.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const a in n[o])u[a]=n[o][a];r.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,v.toValuesTree)(u,t)})}return r}}e.ConfigurationModelParser=p;class w extends L.Disposable{constructor(n,t,r,o){super(),this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class E{constructor(n,t,r,o,u,a,g,C,N,B,K,X,ne){this.key=n,this.overrides=t,this.value=r,this.overrideIdentifiers=o,this.defaultConfiguration=u,this.policyConfiguration=a,this.applicationConfiguration=g,this.userConfiguration=C,this.localUserConfiguration=N,this.remoteUserConfiguration=B,this.workspaceConfiguration=K,this.folderConfigurationModel=X,this.memoryInspectValue=ne}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(n,t,r,o,u=new P,a=new P,g=new O.ResourceMap,C=new P,N=new O.ResourceMap,B=!0){this._defaultConfiguration=n,this._policyConfiguration=t,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=u,this._workspaceConfiguration=a,this._folderConfigurations=g,this._memoryConfiguration=C,this._memoryConfigurationByResource=N,this._freeze=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidatedConfigurationModel(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new P,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const o=this.getConsolidatedConfigurationModel(n,t,r),u=k.distinct(o.overrides.map(C=>C.identifiers).flat()).filter(C=>o.getOverrideValue(n,C)!==void 0),a=this.getFolderConfigurationModelForResource(t.resource,r),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return new E(n,t,o.getValue(n),u.length?u:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,g.inspect(n,t.overrideIdentifier))}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:u,removed:a}=f(this._defaultConfiguration,n);t=[...o,...u,...a]}for(const o of t)for(const u of(0,S.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(u),g=n.getKeysForOverrideIdentifier(u),C=[...g.filter(N=>a.indexOf(N)===-1),...a.filter(N=>g.indexOf(N)===-1),...a.filter(N=>!I.equals(this._defaultConfiguration.override(u).getValue(N),n.override(u).getValue(N)))];r.push([u,C])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this._policyConfiguration,n),u=[...t,...r,...o];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.applicationConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.localUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.remoteUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.workspaceConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:o,updated:u,removed:a,overrides:g}=f(r,t),C=[...o,...u,...a];return(C.length||!r)&&this.updateFolderConfiguration(n,t),{keys:C,overrides:g}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:a}=f(t,void 0);return{keys:[...r,...o,...u],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(n);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=r.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),u=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),g=n.folders.reduce((C,N)=>(C.set(l.URI.revive(N[0]),this.parseConfigurationModel(N[1])),C),new O.ResourceMap);return new c(t,r,o,u,new P,a,g,new P,new O.ResourceMap,!1)}static parseConfigurationModel(n){return new P(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=c;function h(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,a])=>{const g=(0,O.getOrSet)(t,u,new Set);a.forEach(C=>g.add(C))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=h;class y{constructor(n,t,r,o){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(g=>u.add(g)),n.overrides.forEach(([,g])=>g.forEach(C=>u.add(C))),this.affectedKeys=[...u.values()];const a=new P;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!I.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,v.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=y;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),u=[],a=i?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const C=g.filter(N=>!a.includes(N));for(const N of C)u.push([N,n.getKeysForOverrideIdentifier(N)])}if(i){const C=a.filter(N=>!g.includes(N));for(const N of C)u.push([N,i.getKeysForOverrideIdentifier(N)])}if(n&&i){for(const C of a)if(g.includes(C)){const N=s({contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)},{contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)});u.push([C,[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(i,n){const t=i?n?i.keys.filter(u=>n.keys.indexOf(u)===-1):[...i.keys]:[],r=n?i?n.keys.filter(u=>i.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(i&&n){for(const u of n.keys)if(i.keys.indexOf(u)!==-1){const a=(0,v.getConfigurationValue)(n.contents,u),g=(0,v.getConfigurationValue)(i.contents,u);I.equals(a,g)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(Q[120],Z([0,1,19,3,2,26,8,21,65,40,9,37,35]),function($,e,k,R,D,L,O,I,d,l,v,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class P extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new p(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:y})=>this.onDidUpdateConfiguration(h,y))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(h,y){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:h})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=P;class p extends d.ConfigurationModel{constructor(h={}){const y=m.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(y),s=Object.create(null),i=[];for(const n in y){const t=h[n],r=t!==void 0?t:y[n].default;(0,I.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))l.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,l.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,I.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=p;class w{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let E=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(h,y,f){super(),this.defaultConfiguration=h,this.policyService=y,this.logService=f,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new d.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(h=>this.onDidChangePolicies(h))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:h})=>this.update(await this.registerPolicyDefinitions(h),!0))),this._configurationModel}async registerPolicyDefinitions(h){const y={},f=[],s=m.Registry.as(l.Extensions.Configuration).getConfigurationProperties();for(const i of h){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),y[n.policy.name]={type:n.type}}}return(0,O.isEmptyObject)(y)||await this.policyService.registerPolicyDefinitions(y),f}onDidChangePolicies(h){const y=m.Registry.as(l.Extensions.Configuration).getPolicyConfigurations(),f=(0,k.coalesce)(h.map(s=>y.get(s)));this.update(f,!0)}update(h,y){const f=m.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),s=[],i=this._configurationModel.isEmpty();for(const n of h){const t=f[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(i?r!==void 0:!(0,L.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new d.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);y&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=ge([ie(1,S.IPolicyService),ie(2,v.ILogService)],E),e.PolicyConfiguration=E}),define(Q[121],Z([0,1,4,3,2,17,21,65,120,37]),function($,e,k,R,D,L,O,I,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends D.Disposable{constructor(m,P,p,w){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new d.DefaultConfiguration),this.policyConfiguration=p instanceof l.NullPolicyService?new d.NullPolicyConfiguration:this._register(new d.PolicyConfiguration(this.defaultConfiguration,p,w)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,P)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:c})=>this.onDidDefaultConfigurationChange(E,c))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,P,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,P,new I.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,P){const p=typeof m=="string"?m:void 0,w=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(p,w,void 0)}updateValue(m,P,p,w){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const P=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,P,2)}onDidDefaultConfigurationChange(m,P){const p=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(m,P);this.trigger(w,p,7)}onDidPolicyConfigurationChange(m){const P=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,P,7)}trigger(m,P,p){const w=new I.ConfigurationChangeEvent(m,{data:P},this.configuration);w.source=p,w.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(Q[122],Z([0,1,16]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(l){return l.scheme===k.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=R;function D(l){if(!l)return;const v=l.indexOf("+");return v<0?l:l.substr(0,v)}e.getRemoteName=D;function L(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=L;function O(l){const{host:v,port:S}=d(l);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:S}}e.parseAuthorityWithPort=O;function I(l,v){let{host:S,port:m}=d(l);return typeof m>"u"&&(m=v),{host:S,port:m}}e.parseAuthorityWithOptionalPort=I;function d(l){const v=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const S=l.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=l.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:l,port:void 0}}}),define(Q[29],Z([0,1,27,7,122]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=L;function O(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var d;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class l{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,E){if(typeof w>"u"||w===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof w=="string"||typeof E=="string"){const c=typeof w=="string"?w:w.value,h=typeof E=="string"?E:E.value;return k.equalsIgnoreCase(c,h)}return w._lower===E._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=l;function v(p){return S(p)}e.isApplicationScopedExtension=v;function S(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function P(p,w){if(w){const E=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return p.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[24],Z([0,1,27,23,29,12,10,11,33]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function l(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,k.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=l;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new S(t.identifier,r,o)}static parse(t){const r=v.exec(t);return r&&r[1]&&r[2]?new S({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof S?l(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(n){const t=m.exec(n);return t&&t[1]?[w(t[1]),t[2]]:[w(n),void 0]}e.getIdAndVersion=P;function p(n,t){return`${n}.${t}`}e.getExtensionId=p;function w(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=w;function E(n,t){return w(p(n,t))}e.getGalleryExtensionId=E;function c(n,t){const r=[],o=u=>{for(const a of r)if(a.some(g=>l(t(g),t(u))))return a;return null};for(const u of n){const a=o(u);a?a.push(u):r.push([u])}return r}e.groupByExtension=c;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=h;function y(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every(a=>!l(a.identifier,{id:u}))){const a=n.filter(g=>l(g.identifier,{id:u}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,R.getTargetPlatform)(r?"alpine":L.platform,d.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Q[123],Z([0,1,22,11,16,17,39,10,85,23,24,29]),function($,e,k,R,D,L,O,I,d,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=E=>(0,d.localize)(0,null,E),P=(0,d.localize)(1,null,"ms-dotnettools.csharp");function p(E,c){return c?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let w=class{constructor(c,h){this.extensionManagementService=c,this.extensionGalleryService=h}get location(){}async listExtensions(c,h,y,f=console){let s=await this.extensionManagementService.getInstalled(1,y);const i=S.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(h&&h!==""){if(i.indexOf(h.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.location&&f.log((0,d.localize)(2,null,this.location)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(p(t.manifest,c)))}async installExtensions(c,h,y,f,s=console){const i=[],n=[];c.length&&s.log(this.location?(0,d.localize)(3,null,this.location):(0,d.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1,y.profileLocation),r=(g,C)=>{const N=t.find(B=>(0,v.areSameExtensions)(B.identifier,{id:g}));if(N){if(!f&&(!C||C==="prerelease"&&N.preRelease))return s.log((0,d.localize)(5,null,g,N.manifest.version,g)),!1;if(C&&N.manifest.version===C)return s.log((0,d.localize)(6,null,`${g}@${C}`)),!1}return!0},o=(g,C,N)=>{a.push({id:g,version:C!=="prerelease"?C:void 0,installOptions:{...y,isBuiltin:N,installPreReleaseVersion:C==="prerelease"||y.installPreReleaseVersion}})},u=[],a=[];for(const g of c)if(g instanceof I.URI)u.push(g);else{const[C,N]=(0,v.getIdAndVersion)(g);r(C,N)&&o(C,N,!1)}for(const g of h){const[C,N]=(0,v.getIdAndVersion)(g);r(C,N)&&o(C,N,!0)}if(u.length&&await Promise.all(u.map(async g=>{try{const C=await this.installVSIX(g,{...y,isBuiltin:!1},f,s);C&&n.push(C)}catch(C){s.error(C.message||C.stack||C),i.push(g.toString())}})),a.length){const g=await this.getGalleryExtensions(a);await Promise.all(a.map(async C=>{const N=g.get(C.id.toLowerCase());if(N)try{const B=await this.installFromGallery(C,N,t,f,s);B&&n.push(B)}catch(B){s.error(B.message||B.stack||B),i.push(C.id)}else s.error(`${m(C.version?`${C.id}@${C.version}`:C.id)}
${P}`),i.push(C.id)}))}if(i.length)throw new Error((0,d.localize)(7,null,i.join(", ")))}async installVSIX(c,h,y,f){const s=await this.extensionManagementService.getManifest(c);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,y,h.profileLocation,f))try{return await this.extensionManagementService.install(c,h),f.log((0,d.localize)(8,null,(0,L.basename)(c))),s}catch(n){if((0,R.isCancellationError)(n))return f.log((0,d.localize)(9,null,(0,L.basename)(c))),null;throw n}return null}async getGalleryExtensions(c){const h=new Map,y=c.some(s=>s.installOptions.installPreReleaseVersion),f=await this.extensionGalleryService.getExtensions(c.map(s=>({...s,preRelease:y})),k.CancellationToken.None);for(const s of f)h.set(s.identifier.id.toLowerCase(),s);return h}async installFromGallery({id:c,version:h,installOptions:y},f,s,i,n){const t=await this.extensionGalleryService.getManifest(f,k.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,v.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,d.localize)(10,null,h?`${c}@${h}`:c)),null;n.log((0,d.localize)(11,null,c,f.version))}try{y.isBuiltin?n.log(h?(0,d.localize)(12,null,c,h):(0,d.localize)(13,null,c)):n.log(h?(0,d.localize)(14,null,c,h):(0,d.localize)(15,null,c));const o=await this.extensionManagementService.installFromGallery(f,{...y,installGivenVersion:!!h});return n.log((0,d.localize)(16,null,c,o.manifest.version)),t}catch(o){if((0,R.isCancellationError)(o))return n.log((0,d.localize)(17,null,c)),null;throw o}}validateExtensionKind(c,h){return!0}async validateVSIX(c,h,y,f){const s={id:(0,v.getGalleryExtensionId)(c.publisher,c.name)},n=(await this.extensionManagementService.getInstalled(1,y)).find(t=>(0,v.areSameExtensions)(s,t.identifier)&&(0,O.gt)(t.manifest.version,c.version));return n&&!h?(f.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,c.version)),!1):this.validateExtensionKind(c,f)}async uninstallExtensions(c,h,y,f=console){const s=async n=>{if(n instanceof I.URI){const t=await this.extensionManagementService.getManifest(n);return p(t)}return n},i=[];for(const n of c){const t=await s(n),o=(await this.extensionManagementService.getInstalled(void 0,y)).filter(u=>(0,v.areSameExtensions)(u.identifier,{id:t}));if(!o.length)throw new Error(`${this.notInstalled(t)}
${P}`);if(o.some(u=>u.type===0)){f.log((0,d.localize)(19,null,t));return}if(!h&&o.some(u=>u.isBuiltin)){f.log((0,d.localize)(20,null,t));return}f.log((0,d.localize)(21,null,t));for(const u of o)await this.extensionManagementService.uninstall(u,{profileLocation:y}),i.push(u);this.location?f.log((0,d.localize)(22,null,t,this.location)):f.log((0,d.localize)(23,null,t))}}async locateExtension(c,h=console){const y=await this.extensionManagementService.getInstalled();c.forEach(f=>{y.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===D.Schemas.file){h.log(s.location.fsPath);return}})})}notInstalled(c){return this.location?(0,d.localize)(24,null,c,this.location):(0,d.localize)(25,null,c)}};w=ge([ie(0,l.IExtensionManagementService),ie(1,l.IExtensionGalleryService)],w),e.ExtensionManagementCLI=w}),define(Q[41],Z([0,1,4,14,2,3,34,10,24,13,7,9]),function($,e,k,R,D,L,O,I,d,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let m=class extends D.Disposable{constructor(p,w){super(),this.fileService=p,this.logService=w,this._onAddExtensions=this._register(new L.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new L.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new L.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new L.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new O.ResourceMap}scanProfileExtensions(p){return this.withProfileExtensions(p)}async addExtensionsToProfile(p,w){this._onAddExtensions.fire({extensions:p.map(E=>E[0]),profileLocation:w});try{const c=(await this.withProfileExtensions(w,h=>(h=h.filter(y=>p.some(([f])=>!(0,d.areSameExtensions)(y.identifier,f.identifier))),h.push(...p.map(([y,f])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:f}))),h))).filter(h=>p.some(([y])=>(0,d.areSameExtensions)(h.identifier,y.identifier)));return this._onDidAddExtensions.fire({extensions:p.map(h=>h[0]),profileLocation:w}),c}catch(E){throw this._onDidAddExtensions.fire({extensions:p.map(c=>c[0]),error:E,profileLocation:w}),E}}async removeExtensionFromProfile(p,w){this._onRemoveExtensions.fire({extensions:[p],profileLocation:w});try{await this.withProfileExtensions(w,E=>E.filter(c=>!(0,d.areSameExtensions)(c.identifier,p.identifier))),this._onDidRemoveExtensions.fire({extensions:[p],profileLocation:w})}catch(E){throw this._onDidRemoveExtensions.fire({extensions:[p],error:E,profileLocation:w}),E}}async withProfileExtensions(p,w){return this.getResourceAccessQueue(p).queue(async()=>{let E=[];try{const c=await this.fileService.readFile(p),h=JSON.parse(c.value.toString());for(const y of h){if(!y.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",y);continue}if(!y.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",y);continue}if(!y.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",y);continue}E.push({identifier:y.identifier,location:I.URI.revive(y.location),version:y.version,metadata:y.metadata})}}catch(c){c.fileOperationResult!==1&&this.logService.error(c)}if(w){E=w(E);const c=E.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),metadata:h.metadata}));await this.fileService.writeFile(p,R.VSBuffer.fromString(JSON.stringify(c)))}return E})}getResourceAccessQueue(p){let w=this.resourcesAccessQueueMap.get(p);return w||(w=new k.Queue,this.resourcesAccessQueueMap.set(p,w)),w}};m=ge([ie(0,l.IFileService),ie(1,S.ILogService)],m),e.ExtensionsProfileScannerService=m}),define(Q[124],Z([0,1,4,11,2,16,12,17,39,31,20,21,18,23,24,59,13,9]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class We extends D.Disposable{constructor(f,s,i,n,t,r){super(),this.fileService=s,this.extensionGalleryService=i,this.configurationService=n,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=f.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(f,s){await this.cleanUpPromise;const i=(0,I.joinPath)(this.extensionsDownloadDir,this.getName(f));try{await this.downloadFile(f,i,t=>this.extensionGalleryService.download(f,t,s))}catch(t){throw new P.ExtensionManagementError(t.message,P.ExtensionManagementErrorCode.Download)}let n=!1;if(f.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const t=await this.downloadSignatureArchive(f);try{n=await this.extensionSignatureVerificationService.verify(i.fsPath,t.fsPath),this.logService.info(`Verified extension: ${f.identifier.id}`,n)}catch(r){throw await this.delete(t),await this.delete(i),new P.ExtensionManagementError(r.code,P.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async downloadSignatureArchive(f){await this.cleanUpPromise;const s=(0,I.joinPath)(this.extensionsDownloadDir,`${this.getName(f)}${We.SignatureArchiveExtension}`);return await this.downloadFile(f,s,i=>this.extensionGalleryService.downloadSignatureArchive(f,i)),s}async downloadFile(f,s,i){if(await this.fileService.exists(s))return;if(s.scheme!==L.Schemas.file){await i(s);return}const n=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.fileService.exists(n)||await i(n);try{await this.rename(n,s,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(n)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",f.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,i){try{await v.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,i);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],i=[],n=[];for(const o of f.children)if(o.name.endsWith(We.SignatureArchiveExtension))n.push(o.resource);else{const u=p.ExtensionKey.parse(o.name);u&&i.push([u,o])}const t=(0,p.groupByExtension)(i,([o])=>o),r=[];for(const o of t)o.sort((u,a)=>d.rcompare(u[0].version,a[0].version)),s.push(...o.slice(1).map(u=>u[1].resource)),r.push(o[0][1]);r.sort((o,u)=>o.mtime-u.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),s.push(...n),await k.Promises.settled(s.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?p.ExtensionKey.create(f).toString().toLowerCase():(0,l.generateUuid)()}};h.SignatureArchiveExtension=".sigzip",h=ge([ie(0,m.INativeEnvironmentService),ie(1,E.IFileService),ie(2,P.IExtensionGalleryService),ie(3,S.IConfigurationService),ie(4,w.IExtensionSignatureVerificationService),ie(5,c.ILogService)],h),e.ExtensionsDownloader=h}),define(Q[125],Z([0,1,2,15,20,29]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(d,l){super(),this.environmentService=d,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(l.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(l.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(d){d.some(l=>!!l.local)&&this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Q[126],Z([0,1,3,2,34,24,29]),function($,e,k,R,D,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends R.Disposable{constructor(l,v,S,m,P,p){super(),this.extensionManagementService=l,this.userDataProfilesService=v,this.extensionsProfileScannerService=S,this.uriIdentityService=m,this.fileService=P,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new R.DisposableMap),this.initialize().then(null,w=>p.error(w))}async initialize(){await this.extensionManagementService.migrateDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added,l.removed))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l,v){try{await Promise.all(v.map(S=>(this.extensionsProfileWatchDisposables.deleteAndDispose(S.id),this.removeExtensionsFromProfile(S.extensionsResource))))}catch(S){this.logService.error(S)}try{l.length&&await Promise.all(l.map(S=>(this.extensionsProfileWatchDisposables.set(S.id,(0,R.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(S.extensionsResource)),this.fileService.watch(S.extensionsResource))),this.populateExtensionsFromProfile(S.extensionsResource))))}catch(S){this.logService.error(S)}}async onAddExtensions(l){for(const v of l.extensions)this.addExtensionWithKey(this.getKey(v.identifier,v.manifest.version),l.profileLocation)}async onDidAddExtensions(l){for(const v of l.extensions){const S=this.getKey(v.identifier,v.manifest.version);l.error?this.removeExtensionWithKey(S,l.profileLocation):this.addExtensionWithKey(S,l.profileLocation)}}async onRemoveExtensions(l){for(const v of l.extensions)this.removeExtensionWithKey(this.getKey(v.identifier,v.manifest.version),l.profileLocation)}async onDidRemoveExtensions(l){const v=[];for(const S of l.extensions){const m=this.getKey(S.identifier,S.manifest.version);l.error?this.addExtensionWithKey(m,l.profileLocation):(this.removeExtensionWithKey(m,l.profileLocation),this.allExtensions.has(m)||v.push(S))}v.length&&await this.extensionManagementService.markAsUninstalled(...v)}onDidFilesChange(l){for(const v of this.userDataProfilesService.profiles)l.contains(v.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(v.extensionsResource)}async onDidExtensionsProfileChange(l){const v=[],S=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(l),P=new Set,p=new Set;for(const[w,E]of this.allExtensions)E.has(l)&&p.add(w);for(const w of m){const E=this.getKey(w.identifier,w.version);P.add(E),p.has(E)||(v.push(w.identifier),this.addExtensionWithKey(E,l))}for(const w of p)if(!P.has(w)){const E=this.fromKey(w);E&&(S.push(E.identifier),this.removeExtensionWithKey(w,l))}(v.length||S.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v.length?{extensions:v,profileLocation:l}:void 0,removed:S.length?{extensions:S,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const v=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const S of v)this.addExtensionWithKey(this.getKey(S.identifier,S.version),l)}async removeExtensionsFromProfile(l){for(const v of[...this.allExtensions.keys()])this.removeExtensionWithKey(v,l);await this.uninstallExtensionsNotInProfiles()}async uninstallExtensionsNotInProfiles(){const v=(await this.extensionManagementService.getAllUserInstalled()).filter(S=>!this.allExtensions.has(this.getKey(S.identifier,S.manifest.version)));v.length&&await this.extensionManagementService.markAsUninstalled(...v)}addExtensionWithKey(l,v){let S=this.allExtensions.get(l);S||this.allExtensions.set(l,S=new D.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),S.add(v)}removeExtensionWithKey(l,v){const S=this.allExtensions.get(l);S&&S.delete(v),S?.size||this.allExtensions.delete(l)}getKey(l,v){return`${O.ExtensionIdentifier.toKey(l.id)}@${v}`}fromKey(l){const[v,S]=(0,L.getIdAndVersion)(l);return S?{identifier:{id:v},version:S}:void 0}}e.ExtensionsWatcher=I}),define(Q[127],Z([0,1,157,19,4,2,16,15,20,18,23,24,9,63,12,10]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends P.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.extensionManagementService=f,this.logService=n,this.cache=this._register(new c(s,n)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.cache.getLanguagePacks())[p.Language.value()];if(!i){this.logService.warn(`No language pack found for ${p.Language.value()}`);return}const n=i.translations[f];return n?w.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.createQuickPickItem(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const s=await this.cache.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,S.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(s);return!(0,R.equals)(Object.keys(f),Object.keys(i))}};E=ge([ie(0,v.IExtensionManagementService),ie(1,l.INativeEnvironmentService),ie(2,v.IExtensionGalleryService),ie(3,m.ILogService)],E),e.NativeLanguagePackService=E;let c=class extends L.Disposable{constructor(f,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(s=>{Object.keys(s).forEach(i=>delete s[i]),this.createLanguagePacksFromExtensions(s,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,i);Object.keys(f).forEach(i=>this.updateHash(f[i]))}createLanguagePacksFromExtension(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===O.Schemas.file&&h(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(u=>(0,S.areSameExtensions)(u.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const u of t.translations)r.translations[u.id]=(0,I.join)(s.location.fsPath,u.path)}}updateHash(f){if(f){const s=(0,k.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return d.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.languagePacks=i,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),d.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>s,i=>this.logService.error(i))})}};c=ge([ie(0,l.INativeEnvironmentService),ie(1,m.ILogService)],c);function h(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const f of y.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,14,95,40,7,35]),function($,e,k,R,D,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=I;function d(w){return w.res.statusCode===204}async function l(w){return d(w)?null:(await(0,k.streamToBuffer)(w.stream)).toString()}e.asText=l;async function v(w){if(!I(w))throw new Error("Server returned "+w.res.statusCode);return l(w)}e.asTextOrError=v;async function S(w){if(!I(w))throw new Error("Server returned "+w.res.statusCode);if(d(w))return null;const c=(await(0,k.streamToBuffer)(w.stream)).toString();try{return JSON.parse(c)}catch(h){throw h.message+=`:
`+c,h}}e.asJson=S;function m(w){p(w)}e.updateProxyConfigurationsScope=m;let P;function p(w){const E=O.Registry.as(D.Extensions.Configuration),c=P;P={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[P],remove:c?[c]:[]})}p(2)}),define(Q[128],Z([0,1,22,16,13,47]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(d,l){this.requestService=d,this.fileService=l}async download(d,l,v=k.CancellationToken.None){if(d.scheme===R.Schemas.file||d.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(d,l);return}const S={type:"GET",url:d.toString(!0)},m=await this.requestService.request(S,v);if(m.res.statusCode===200)await this.fileService.writeFile(l,m.stream);else{const P=await(0,L.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${P}`)}}};O=ge([ie(0,L.IRequestService),ie(1,D.IFileService)],O),e.DownloadService=O}),define(Q[129],Z([0,1,130,8]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function L(O,I,d={}){const l=(0,k.parse)(O),v=d.proxyUrl||D(l,I);if(!v)return null;const S=(0,k.parse)(v);if(!/^https?:$/.test(S.protocol||""))return null;const m={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((P,p)=>{$(["http-proxy-agent"],P,p)}))(m):new(await new Promise((P,p)=>{$(["https-proxy-agent"],P,p)}))(m)}e.getProxyAgent=L}),define(Q[131],Z([0,1,57,15,96,22,32,11,12,31,78,158,4]),function($,e,k,R,D,L,O,I,d,l,v,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const P=1e4;let p;async function w(c,h,y){return h["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(y)&&!h["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(y)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(f,s)=>{const i=new L.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,D.localize)(0,null)))},P);try{f(await E(c,i.token))}catch(t){!(0,I.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),p)}e.getResolvedShellEnv=w;async function E(c,h){const y=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",y);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",f);const s=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",n);const t=await(0,v.getSystemShell)(d.OS,n);return c.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(h.isCancellationRequested)return o((0,I.canceled)());const u=(0,R.basename)(t);let a,g;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${C} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${C} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?g=["-ic"]:g=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const N=(0,k.spawn)(t,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});h.onCancellationRequested(()=>(N.kill(),o((0,I.canceled)()))),N.on("error",X=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(X)),o(X)});const B=[];N.stdout.on("data",X=>B.push(X));const K=[];N.stderr.on("data",X=>K.push(X)),N.on("close",(X,ne)=>{const ae=Buffer.concat(B).toString("utf8");c.trace("getUnixShellEnvironment#raw",ae);const Y=Buffer.concat(K).toString("utf8");if(Y.trim()&&c.trace("getUnixShellEnvironment#stderr",Y),X||ne)return o(new Error((0,D.localize)(2,null,X,ne)));const me=i.exec(ae),ue=me?me[1]:"{}";try{const se=JSON.parse(ue);y?se.ELECTRON_RUN_AS_NODE=y:delete se.ELECTRON_RUN_AS_NODE,f?se.ELECTRON_NO_ATTACH_CONSOLE=f:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",se),r(se)}catch(se){c.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(se)),o(se)}})})}}),define(Q[66],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,k.createDecorator)("stateService")}),define(Q[132],Z([0,1,4,14,8,18,13,9]),function($,e,k,R,D,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(S,m,P){this.storagePath=S,this.logService=m,this.fileService=P,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new k.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,m){const P=this.storage[S];return(0,D.isUndefinedOrNull)(P)?m:P}setItem(S,m){this.setItems([{key:S,data:m}])}setItems(S){let m=!1;for(const{key:P,data:p}of S)this.storage[P]!==p&&((0,D.isUndefinedOrNull)(p)?(0,D.isUndefined)(this.storage[P])||(this.storage[P]=void 0,m=!0):(this.storage[P]=p,m=!0));m&&this.save()}removeItem(S){(0,D.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=d;let l=class{constructor(S,m,P){this.fileStorage=new d(S.stateResource,m,P)}async init(){await this.fileStorage.init()}getItem(S,m){return this.fileStorage.getItem(S,m)}};l=ge([ie(0,L.IEnvironmentService),ie(1,I.ILogService),ie(2,O.IFileService)],l),e.StateService=l}),define(Q[67],Z([0,1,12,33,10,31]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(l){if(k.platform===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}async function I(l,v,S,m,P,p,w,E,c,h){const y=Object.create(null);y["common.machineId"]=w,y.sessionID=(0,L.generateUuid)()+Date.now(),y.commitHash=P,y.version=p,y["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,k.PlatformToString)(k.platform),y["common.nodePlatform"]=R.platform,y["common.nodeArch"]=m,y["common.product"]=h||"desktop",E&&(y["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),k.isLinuxSnap&&(y["common.snap"]="true");const i=O(S);i&&(y["common.platformDetail"]=i);try{const n=await l.readFile(D.URI.file(c));y["common.source"]=n.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=I;function d(l){const v=R.env.USERDNSDOMAIN;if(!v)return!1;const S=v.toLowerCase();return l.some(m=>S===m)}e.verifyMicrosoftInternalDomain=d}),define(Q[36],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,8,21,67,36]),function($,e,k,R,D,L,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class d{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,R.staticObservableValue)(0)}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=d,e.NullTelemetryService=new d;class l{async publicLog(o,u,a){}async publicLogError(o,u,a){}}e.NullEndpointTelemetryService=l,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(r,o){return o.onDidChangeConfiguration(u=>{u.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(u.source),configurationKeys:h(u.sourceConfig)})})}e.configurationTelemetry=v;function S(r,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!r.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=S;function m(r,o){return!(o.isBuilt||o.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=m;function P(r){const o=r.getValue(I.TELEMETRY_SETTING_ID),u=r.getValue("telemetry.enableCrashReporter");if(r.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function p(r){const o={},u={},a={};c(r,a);for(let g in a){g=g.length>150?g.substr(g.length-149):g;const C=a[g];typeof C=="number"?u[g]=C:typeof C=="boolean"?u[g]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${C.length}`),o[g]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(o[g]=C)}return{properties:o,measurements:u}}e.validateTelemetryData=p;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function E(r){if(!r)return"none";for(const o of w)if(r.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=E;function c(r,o,u=0,a){if(!!r)for(const g of Object.getOwnPropertyNames(r)){const C=r[g],N=a?a+g:g;Array.isArray(C)?o[N]=(0,k.safeStringify)(C):C instanceof Date?o[N]=C.toISOString():(0,D.isObject)(C)?u<2?c(C,o,u+1,N+"."):o[N]=(0,k.safeStringify)(C):o[N]=C}}function h(r){if(!r)return[];const o=[];return y(o,"",r),o}function y(r,o,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(a=>y(r,o?`${o}.${a}`:a,u[a])):r.push(o)}function f(r,o){const u=r.msftInternalDomains||[],a=o.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(u)||a}e.isInternalTelemetry=f;function s(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(r,o){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let u=r;const a=[];for(const B of o)for(;;){const K=B.exec(r);if(!K)break;a.push([K.index,B.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(u="";;){const B=C.exec(r);if(!B)break;const K=a.some(([X,ne])=>B.index<ne&&X<C.lastIndex);!g.test(B[0])&&!K&&(u+=r.substring(N,B.index)+"<REDACTED: user-file-path>",N=C.lastIndex)}return N<r.length&&(u+=r.substr(N)),u}function n(r){if(!r)return r;const o=r.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of u)if(a.regex.test(o))return`<REDACTED: ${a.label}>`;return r}function t(r,o){return(0,k.cloneAndChange)(r,u=>{if(typeof u=="string"){let a=u;a=i(a,o);for(const g of o)a=a.replace(g,"");return a=n(a),a}})}e.cleanData=t}),define(Q[133],Z([0,1,104,42]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(L,O,I,d,l,v,S){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,R.supportsTelemetry)(O,I)&&(0,R.getTelemetryLevel)(d)===3){const P=await(0,k.getServiceMachineId)(I,l,v),{sessionId:p}=await S.getTelemetryInfo();m["X-Market-User-Id"]=P,m["VSCode-SessionId"]=p}return m}e.resolveMarketplaceHeaders=D}),define(Q[134],Z([0,1,11,26,42]),function($,e,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function O(d,l,v){const S=await new Promise((E,c)=>{$(["@microsoft/1ds-core-js"],E,c)}),m=await new Promise((E,c)=>{$(["@microsoft/1ds-post-js"],E,c)}),P=new S.AppInsightsCore,p=new m.PostChannel,w={instrumentationKey:d,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(v){w.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:v};w.extensionConfig[p.identifier]=E}return P.initialize(w,[]),P.addTelemetryInitializer(E=>{l&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),P}class I{constructor(l,v,S,m,P){this._isInternalTelemetry=l,this._eventPrefix=v,this._defaultData=S,this._xhrOverride=P,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(l){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){l(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=O(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(v=>{l(v)},v=>{(0,k.onUnexpectedError)(v),console.error(v)})}}log(l,v){if(!this._aiCoreOrKey)return;v=(0,R.mixin)(v,this._defaultData),v=(0,D.validateTelemetryData)(v);const S=this._eventPrefix+"/"+l;try{this._withAIClient(m=>{m.pluginVersionString=v?.properties.version??"Unknown",m.track({name:S,baseData:{name:S,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(l=>{this._withAIClient(v=>{v.unload(!0,()=>{this._aiCoreOrKey=void 0,l(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(Q[135],Z([0,1,2,26,52,12,27,97,21,40,136,28,35,36,42]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(h,y,f){this._configurationService=y,this._productService=f,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(h,y){this._experimentProperties[h]=y}_updateTelemetryLevel(){let h=(0,p.getTelemetryLevel)(this._configurationService);const y=this._productService.enabledTelemetryLevels;if(y){this._sendErrorTelemetry=this.sendErrorTelemetry?y.error:!1;const f=y.usage?3:y.error?2:0;h=Math.min(h,f)}this.telemetryLevel.value=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const h=await this._commonProperties,y=h.sessionID,f=h["common.machineId"],s=h["common.firstSessionDate"],i=h["common.msftInternal"];return{sessionId:y,machineId:f,firstSessionDate:s,msftInternal:i}}dispose(){this._disposables.dispose()}_log(h,y,f,s){return this.telemetryLevel.value<y?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,R.mixin)(f,this._experimentProperties),f=(0,p.cleanData)(f,this._cleanupPatterns),f=(0,R.mixin)(f,i),this._appenders.forEach(n=>n.log(h,f))},i=>{console.error(i)})}publicLog(h,y,f){return this._log(h,3,y,f)}publicLog2(h,y,f){return this.publicLog(h,y,f)}publicLogError(h,y){return this._sendErrorTelemetry?this._log(h,2,y,!0):Promise.resolve(void 0)}publicLogError2(h,y){return this.publicLogError(h,y)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ge([ie(1,d.IConfigurationService),ie(2,S.IProductService)],w),e.TelemetryService=w;function E(){const c=(0,I.localize)(0,null,v.default.nameLong),h=v.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=L.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),s=(0,I.localize)(5,null),i=(0,I.localize)(6,null),n=(0,I.localize)(7,null),t=`
|       | ${f} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${c} ${h} ${y}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}m.Registry.as(l.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(l.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,I.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,I.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[137],Z([0,1,159,134]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends R.AbstractOneDataSystemAppender{constructor(O,I,d,l){const v={sendPOST:(S,m)=>{const P={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const p=k.request(S.urlString,P,w=>{w.on("data",function(E){m(w.statusCode??200,w.headers,E.toString())}),w.on("error",function(E){m(0,{})})});p.write(S.data),p.end()}catch{m(0,{})}}};super(O,I,d,l,v)}}e.OneDataSystemAppender=D}),define(Q[138],Z([0,1,15,20]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function D(L,O){const I=Object.create(null),d=(v,S)=>{const m=JSON.parse(v);I[S]=m};if(O){const v=[],S=await R.Promises.readdir(O);for(const P of S)try{(await R.Promises.stat((0,k.join)(O,P))).isDirectory()&&v.push(P)}catch{}const m=[];for(const P of v)(await R.Promises.readdir((0,k.join)(O,P))).filter(w=>w==="telemetry.json").length===1&&m.push(P);for(const P of m){const p=(await R.Promises.readFile((0,k.join)(O,P,"telemetry.json"))).toString();d(p,P)}}let l=(await R.Promises.readFile((0,k.join)(L,"telemetry-core.json"))).toString();return d(l,"vscode-core"),l=(await R.Promises.readFile((0,k.join)(L,"telemetry-extensions.json"))).toString(),d(l,"vscode-extensions"),JSON.stringify(I,null,4)}e.buildTelemetryMessage=D}),define(Q[30],Z([0,1,7]),function($,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(Q[139],Z([0,1,30,105,13,17,70,3,2]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(m){this.uri=m,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let v=class{constructor(m){this._fileService=m,this._dispooables=new d.DisposableStore,this._limit=2**16;const P=new Map,p=w=>{let E=P.get(w.scheme);return E===void 0&&(E=m.hasProvider(w)&&!this._fileService.hasCapability(w,1024),P.set(w.scheme,E)),E};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(w=>{P.delete(w.scheme)})),this.extUri=new L.ExtUri(p),this._canonicalUris=new O.SkipList((w,E)=>this.extUri.compare(w,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,L.normalizePath)(m));const P=this._canonicalUris.get(m);return P?P.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new l(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,w)=>p[1].touch<w[1].touch?1:p[1].touch>w[1].touch?-1:0);l._clock=0,this._canonicalUris.clear();const P=this._limit*.5;for(let p=0;p<P;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};v=ge([ie(0,D.IFileService)],v),e.UriIdentityService=v,(0,R.registerSingleton)(k.IUriIdentityService,v,1)}),define(Q[140],Z([0,1,99,15,113,17,10,7,16]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function l(n){const t=n;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=l,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function v(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=v;function S(n){const t=n;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=S;function m(n){const t=n;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var P;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=p;function w(n){const t=n;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=w;class E{constructor(t,r,o,u,a){this._id=t,this._transient=o,this._configuration=u,this._ignorePathCasing=a,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class c{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function h(n){return new c({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=h,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(n,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function f(n){let t;return O.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!y(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,R.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Q[25],Z([0,1,53,3,2,17,10,98,18,13,7,9,140,34,30,4,31,27]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function h(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.isUserDataProfile=h,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function y(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:O.URI.revive(n.location).with({scheme:t}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=y;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,o,u){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=u,this.enabled=!1,this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new R.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new R.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new R.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new P.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>f((0,L.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const o=new P.ResourceMap,u=f((0,k.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...u,isDefault:!0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[g,C]of Object.entries(a.workspaces)){const N=O.URI.parse(g),B=O.URI.parse(C),K=t.find(X=>this.uriIdentityService.extUri.isEqual(X.location,B));K&&o.set(N,K)}if(a.emptyWindow){const g=O.URI.parse(a.emptyWindow);r=t.find(C=>this.uriIdentityService.extUri.isEqual(C.location,g))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,c.escapeRegExpCharacters)(r)}\\s(\\d+)`);let u=0;for(const g of this.profiles){const C=o.exec(g.name),N=C?parseInt(C[1]):0;u=N>u?N:u}const a=`${r} ${u+1}`;return this.createProfile((0,k.hash)((0,E.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,k.hash)((0,E.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,u){if(!this.enabled)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,r,o);return u&&await this.setProfileForWorkspace(u,a),a}async doCreateProfile(t,r,o){let u=this.profileCreationPromises.get(r);return u||(u=(async()=>{try{const a=this.profiles.find(N=>N.name===r||N.id===t);if(a)return a;const g=f(t,r,(0,L.joinPath)(this.profilesHome,t),o);await this.fileService.createFolder(g.location);const C=[];return this._onWillCreateProfile.fire({profile:g,join(N){C.push(N)}}),await w.Promises.settled(C),this.updateProfiles([g],[],[]),g}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,u)),u}async updateProfile(t,r){if(!this.enabled)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(u=>u.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(t){if(!this.enabled)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.logService.error(u)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const u of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(u)?.id&&this.profilesObject.workspaces.delete(u);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(u){this.logService.error(u)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return O.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,m.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,m.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const u=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let g of u)g.isDefault||r.some(C=>g.id===C.id)||(g=o.find(C=>g.id===C.id)??g,g.isTransient?this.transientProfilesObject.profiles.push(g):a.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const u=this.getWorkspace(t),a=o?this.transientProfilesObject:this.profilesObject;O.URI.isUri(u)?(a.workspaces.delete(u),r&&a.workspaces.set(u,r)):a.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,u]of this.profilesObject.workspaces.entries())t[o.toString()]=u.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=ge([ie(0,d.IEnvironmentService),ie(1,l.IFileService),ie(2,p.IUriIdentityService),ie(3,S.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=i}),define(Q[141],Z([0,1,19,4,22,11,3,2,12,10,83,23,24,29,9,28,36,25]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let h=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,r,o,u,a){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=u,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:g})=>g.cancel()),this.uninstallingExtensions.forEach(g=>g.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(v.localize(0,null),S.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const u={...o,installOnlyNewlyAddedFromExtensionPack:l.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,P.isApplicationScopedExtension)(t)?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},a=X=>`${m.ExtensionKey.create(X).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!l.URI.isUri(r)){const X=this.installingExtensions.get(a(r));if(X){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:ne}=await X.task.waitUntilTaskIsFinished();return ne}}const g=[],C=[],N=[],B=this.createInstallExtensionTask(t,r,u);l.URI.isUri(r)||this.installingExtensions.set(a(r),{task:B,waitingTasks:[]}),this._onInstallExtension.fire({identifier:B.identifier,source:r,profileLocation:u.profileLocation}),this.logService.info("Installing extension:",B.identifier.id),g.push({task:B,manifest:t});let K=!1;try{if(u.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",B.identifier.id);else try{const ne=await this.getAllDepsAndPackExtensions(B.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),ae=await this.getInstalled(void 0,u.profileLocation);for(const{gallery:Y,manifest:me}of ne){K=K||!!me.extensionDependencies?.some(W=>(0,m.areSameExtensions)({id:W},B.identifier));const ue=a(Y),se=this.installingExtensions.get(ue);if(se){if(this.canWaitForTask(B,se.task)){this.logService.info("Waiting for already requested installing extension",Y.identifier.id,B.identifier.id),se.waitingTasks.push(B);const W=se.task.identifier;C.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,F=>F.some(T=>(0,m.areSameExtensions)(T.identifier,W)))).then(F=>{if(!F.find(z=>(0,m.areSameExtensions)(z.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!ae.some(({identifier:W})=>(0,m.areSameExtensions)(W,Y.identifier))){const W=this.createInstallExtensionTask(me,Y,{...u,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ue,{task:W,waitingTasks:[B]}),this._onInstallExtension.fire({identifier:W.identifier,source:Y,profileLocation:u.profileLocation}),this.logService.info("Installing extension:",W.identifier.id,B.identifier.id),g.push({task:W,manifest:me})}}}catch(ne){if(l.URI.isUri(B.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",B.identifier.id,ne.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",B.identifier.id,ne.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",B.identifier.id),ne}const X=g.reduce((ne,{task:ae,manifest:Y})=>(ne.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:Y}),ne),new Map);for(;X.size;){let ne;const ae=[...X.values()].filter(({manifest:Y})=>!Y.extensionDependencies?.some(me=>X.has(me.toLowerCase())));ae.length?ne=X.size===1?ae:ae.filter(({task:Y})=>!(Y===B&&!K)):(this.logService.info("Found extensions with circular dependencies",ae.map(({task:Y})=>Y.identifier.id)),ne=[...X.values()]),await this.joinAllSettled(ne.map(async({task:Y})=>{const me=new Date().getTime();try{const{local:ue}=await Y.run();if(await this.joinAllSettled(this.participants.map(se=>se.postInstall(ue,Y.source,u,D.CancellationToken.None))),!l.URI.isUri(Y.source)){const se=Y.operation===3,W=se?void 0:(new Date().getTime()-Y.source.lastUpdated)/1e3;if(s(this.telemetryService,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(Y.source),wasVerified:Y.wasVerified,duration:new Date().getTime()-me,durationSinceUpdate:W}),d.isWeb&&Y.operation!==3)try{await this.galleryService.reportStatistic(ue.manifest.publisher,ue.manifest.name,ue.manifest.version,"install")}catch{}}N.push({local:ue,identifier:Y.identifier,operation:Y.operation,source:Y.source,context:u.context,profileLocation:u.profileLocation,applicationScoped:ue.isApplicationScoped})}catch(ue){throw l.URI.isUri(Y.source)||s(this.telemetryService,Y.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(Y.source),wasVerified:Y.wasVerified,duration:new Date().getTime()-me,error:ue}),this.logService.error("Error while installing the extension:",Y.identifier.id),ue}finally{X.delete(Y.identifier.id.toLowerCase())}}))}return C.length&&await this.joinAllSettled(C),N.forEach(({identifier:ne})=>this.logService.info("Extension installed successfully:",ne.id)),this._onDidInstallExtensions.fire(N),N.filter(({identifier:ne})=>(0,m.areSameExtensions)(ne,B.identifier))[0].local}catch(X){if(g.forEach(({task:ne})=>ne.cancel()),N.length)try{const ne=await Promise.allSettled(N.map(({local:ae})=>this.createUninstallExtensionTask(ae,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let ae=0;ae<ne.length;ae++){const Y=ne[ae],{identifier:me}=N[ae];Y.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",me.id):this.logService.warn("Rollback: Error while uninstalling extension",me.id,(0,L.getErrorMessage)(Y.reason))}}catch(ne){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ne),N.map(({identifier:ae})=>ae.id))}throw this._onDidInstallExtensions.fire(g.map(({task:ne})=>({identifier:ne.identifier,operation:2,source:ne.source,context:u.context,profileLocation:u.profileLocation}))),X}finally{for(const[X,{task:ne,waitingTasks:ae}]of this.installingExtensions.entries()){const Y=ae.indexOf(B);Y!==-1&&ae.splice(Y,1),ae.length===0&&(ne===B||Y!==-1)&&this.installingExtensions.delete(X)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:u}]of this.installingExtensions.entries())if(o===t&&(u.includes(r)||u.some(a=>this.canWaitForTask(a,r)))||o===r&&u[0]&&!this.canWaitForTask(t,u[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],u=await Promise.allSettled(t);for(const a of u)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw y(o);return r}async getAllDepsAndPackExtensions(t,r,o,u,a){if(!this.galleryService.isEnabled())return[];const g=await this.getInstalled(void 0,a),C=[t],N=[],B=async(K,X)=>{const ne=X.extensionDependencies||[],ae=[...ne];if(X.extensionPack){const Y=o?g.find(me=>(0,m.areSameExtensions)(me.identifier,K)):void 0;for(const me of X.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(ue=>(0,m.areSameExtensions)({id:ue},{id:me}))||ae.every(ue=>!(0,m.areSameExtensions)({id:ue},{id:me}))&&ae.push(me)}if(ae.length){const Y=[...C,...N.map(ue=>ue.gallery.identifier)],me=ae.filter(ue=>Y.every(se=>!(0,m.areSameExtensions)(se,{id:ue})));if(me.length){const ue=await this.galleryService.getExtensions(me.map(se=>({id:se,preRelease:u})),D.CancellationToken.None);for(const se of ue){if(Y.find(T=>(0,m.areSameExtensions)(T,se.identifier)))continue;const W=ne.some(T=>(0,m.areSameExtensions)({id:T},se.identifier));let F;try{F=await this.checkAndGetCompatibleVersion(se,!1,u)}catch(T){if(T instanceof S.ExtensionManagementError&&T.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw T}N.push({gallery:F.extension,manifest:F.manifest}),await B(F.extension.identifier,F.manifest)}}}};return await B(t,r),N}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,m.areSameExtensions)(t.identifier,C)))throw new S.ExtensionManagementError(v.localize(1,null,t.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new S.ExtensionManagementError(v.localize(2,null,t.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(C)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(v.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],D.CancellationToken.None))[0]?new S.ExtensionManagementError(v.localize(4,null,t.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(v.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const g=await this.galleryService.getManifest(a,D.CancellationToken.None);if(g===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new S.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async getCompatibleVersion(t,r,o){const u=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,u)&&(a=t),a||(r?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,u)),a}async uninstallExtension(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},u=K=>`${K.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(u(t.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const g=K=>{const X=this.createUninstallExtensionTask(K,o);return this.uninstallingExtensions.set(u(X.extension.identifier),X),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this._onUninstallExtension.fire({identifier:K.identifier,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped}),X},C=(K,X)=>{X?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString(),X.message):this.logService.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,X.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(K),error:X}),this._onDidUninstallExtension.fire({identifier:K.identifier,error:X?.code,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped})},N=[],B=[];try{N.push(g(t));const K=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const X=this.getAllPackExtensionsToUninstall(t,K);for(const ne of X)this.uninstallingExtensions.has(u(ne.identifier))?this.logService.info("Extensions is already requested to uninstall",ne.identifier.id):N.push(g(ne))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(N.map(X=>X.extension),K,t),await this.joinAllSettled(N.map(async X=>{try{if(await X.run(),await this.joinAllSettled(this.participants.map(ne=>ne.postUninstall(X.extension,o,D.CancellationToken.None))),X.extension.identifier.uuid)try{await this.galleryService.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}C(X.extension)}catch(ne){const ae=ne instanceof S.ExtensionManagementError?ne:new S.ExtensionManagementError((0,L.getErrorMessage)(ne),S.ExtensionManagementErrorCode.Internal);throw C(X.extension,ae),ae}finally{B.push(X)}}))}catch(K){const X=K instanceof S.ExtensionManagementError?K:new S.ExtensionManagementError((0,L.getErrorMessage)(K),S.ExtensionManagementErrorCode.Internal);for(const ne of N){try{ne.cancel()}catch{}B.includes(ne)||C(ne.extension,X)}throw X}finally{for(const K of N)this.uninstallingExtensions.delete(u(K.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}checkForDependents(t,r,o){for(const u of t){const a=this.getDependents(u,r);if(a.length){const g=a.filter(C=>!t.some(N=>(0,m.areSameExtensions)(N.identifier,C.identifier)));if(g.length)throw new Error(this.getDependentsErrorMessage(u,g,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?v.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?v.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const a=r.filter(C=>!C.isBuiltin&&u.some(N=>(0,m.areSameExtensions)({id:N},C.identifier))),g=[];for(const C of a)g.push(...this.getAllPackExtensionsToUninstall(C,r,o));return[...a,...g]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,m.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};h=ge([ie(0,S.IExtensionGalleryService),ie(1,E.ITelemetryService),ie(2,p.ILogService),ie(3,w.IProductService),ie(4,c.IUserDataProfilesService)],h),e.AbstractExtensionManagementService=h;function y(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=y;function f(n){if(n instanceof S.ExtensionManagementError)return n;const t=new S.ExtensionManagementError(n.message,S.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:u,error:a,durationSinceUpdate:g}){let C,N;a&&(a instanceof S.ExtensionManagementError?(C=a.code,a.code===S.ExtensionManagementErrorCode.Signature&&(N=a.message)):C=S.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!a,duration:u,errorcode:C,errorcodeDetail:N,durationSinceUpdate:g})}e.reportTelemetry=s;class i{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>new Promise((r,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(Q[48],Z([0,1,19,4,26,14,11,50,75,2,16,15,12,17,39,54,8,10,87,18,24,29,45,13,7,9,28,3,44,41,25,30,103]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h,y,f,s,i,n,t,r,o,u,a,g,C,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(se){function W(F,T){if(F===T)return!0;const z=Object.keys(F),_=new Set;for(const J of Object.keys(T))_.add(J);if(z.length!==_.size)return!1;for(const J of z){if(F[J]!==T[J])return!1;_.delete(J)}return _.size===0}se.equals=W})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let X=class extends l.Disposable{constructor(W,F,T,z,_,J,q,ee,U,b,A,M){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=F,this.extensionsControlLocation=T,this.cacheLocation=z,this.userDataProfilesService=_,this.extensionsProfileScannerService=J,this.fileService=q,this.logService=ee,this.environmentService=U,this.productService=b,this.uriIdentityService=A,this.instantiationService=M,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,P.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,(0,P.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,(0,P.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ae,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,F,T){const[z,_]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(F)]),J=T?await this.scanExtensionsUnderDevelopment(W,[...z,..._]):[];return this.dedupExtensions(z,_,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const F=[];F.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),F.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[T,z]=await Promise.all(F);return this.applyScanOptions([...T,...z],0,W,!1)}async scanUserExtensions(W){const F=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",F);const T=await this.createExtensionScannerInput(F,!!W.profileLocation,1,!W.includeUninstalled,W.language);let _=await(W.useCache&&!T.devMode&&T.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(T);return _=await this.applyScanOptions(_,1,W,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(W,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const T=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===v.Schemas.file).map(async z=>{const _=await this.createExtensionScannerInput(z,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(_)).map(q=>(q.type=F.find(ee=>(0,f.areSameExtensions)(ee.identifier,q.identifier))?.type??q.type,this.extensionsScanner.validate(q,_)))}))).flat();return this.applyScanOptions(T,"development",W,!0)}return[]}async scanExistingExtension(W,F,T){const z=await this.createExtensionScannerInput(W,!1,F,!0,T.language),_=await this.extensionsScanner.scanExtension(z);return!_||!T.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(W,F,T){const z=await this.createExtensionScannerInput(W,!1,F,!0,T.language),_=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(_,F,T,!0)}async scanMetadata(W){const F=(0,P.joinPath)(W,"package.json"),T=(await this.fileService.readFile(F)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(W,F){const T=(0,P.joinPath)(W,"package.json"),z=(await this.fileService.readFile(T)).value.toString(),_=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,_.__metadata={..._.__metadata,...F},await this.fileService.writeFile((0,P.joinPath)(W,"package.json"),L.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async applyScanOptions(W,F,T,z){return T.includeAllVersions||(W=this.dedupExtensions(F===0?W:void 0,F===1?W:void 0,F==="development"?W:void 0,await this.getTargetPlatform(),z)),T.includeInvalid||(W=W.filter(_=>_.isValid)),W.sort((_,J)=>{const q=S.basename(_.location.fsPath),ee=S.basename(J.location.fsPath);return q<ee?-1:q>ee?1:0})}dedupExtensions(W,F,T,z,_){const J=(ee,U,b)=>{if(ee.isValid&&!U.isValid)return!1;if(ee.isValid===U.isValid){if(_&&p.gt(ee.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(p.eq(ee.manifest.version,U.manifest.version)){if(ee.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===z)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return b?this.logService.warn(`Overwriting user extension ${ee.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${ee.location.path} with ${U.location.path}.`),!0},q=new Map;return W?.forEach(ee=>{const U=s.ExtensionIdentifier.toKey(ee.identifier.id),b=q.get(U);(!b||J(b,ee,!1))&&q.set(U,ee)}),F?.forEach(ee=>{const U=s.ExtensionIdentifier.toKey(ee.identifier.id),b=q.get(U);if(!b&&W&&ee.type===0){this.logService.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!b||J(b,ee,!1))&&q.set(U,ee)}),T?.forEach(ee=>{const U=s.ExtensionIdentifier.toKey(ee.identifier.id),b=q.get(U);(!b||J(b,ee,!0))&&q.set(U,ee),q.set(U,ee)}),[...q.values()]}async scanDefaultSystemExtensions(W,F){this.logService.trace("Started scanning system extensions");const T=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),_=await(W&&!T.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(T);return this.logService.trace("Scanned system extensions:",_.length),_}async scanDevSystemExtensions(W,F){const T=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!T?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=F?await this.getBuiltInExtensionControl():{},_=[],J=c.URI.file(S.normalize(S.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of T){const U=z[ee.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":_.push((0,P.joinPath)(J,ee.name));break;default:_.push(c.URI.file(U));break}}const q=await Promise.all(_.map(async ee=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ee,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,k.coalesce)(q)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,F,T,z,_,J=!0){const q=await this.getTranslations(_??m.language),ee=await this.getMtime(W),U=F&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,b=U?await this.getMtime(U):void 0;return new ne(W,ee,U,b,F,T,z,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,_,q)}async getMtime(W){try{const F=await this.fileService.stat(W);if(typeof F.mtime=="number")return F.mtime}catch{}}};X=ge([ie(4,C.IUserDataProfilesService),ie(5,g.IExtensionsProfileScannerService),ie(6,n.IFileService),ie(7,r.ILogService),ie(8,y.IEnvironmentService),ie(9,o.IProductService),ie(10,N.IUriIdentityService),ie(11,t.IInstantiationService)],X),e.AbstractExtensionsScannerService=X;class ne{constructor(W,F,T,z,_,J,q,ee,U,b,A,M,V,j){this.location=W,this.mtime=F,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=z,this.profile=_,this.type=J,this.excludeObsolete=q,this.validate=ee,this.productVersion=U,this.productDate=b,this.productCommit=A,this.devMode=M,this.language=V,this.translations=j}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,F){return(0,P.isEqual)(W.location,F.location)&&W.mtime===F.mtime&&(0,P.isEqual)(W.applicationExtensionslocation,F.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&W.profile===F.profile&&W.type===F.type&&W.excludeObsolete===F.excludeObsolete&&W.validate===F.validate&&W.productVersion===F.productVersion&&W.productDate===F.productDate&&W.productCommit===F.productCommit&&W.devMode===F.devMode&&W.language===F.language&&K.equals(W.translations,F.translations)}}let ae=class extends l.Disposable{constructor(W,F,T,z,_){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=F,this.uriIdentityService=T,this.fileService=z,this.logService=_}async scanExtensions(W){const F=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let T={};if(W.excludeObsolete&&W.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();T=JSON.parse(z)}catch{}return(0,E.isEmptyObject)(T)?F:F.filter(z=>!T[f.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(W){const F=await this.fileService.resolve(W.location);if(!F.children?.length)return[];const T=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||W.type===1&&(0,P.basename)(z.resource).indexOf(".")===0)return null;const _=new ne(z.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(_)}));return(0,k.coalesce)(T).sort((z,_)=>z.location.path<_.location.path?-1:1)}async scanExtensionsFromProfile(W){let F=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const T=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W);F.push(...T)}return F}async scanExtensionsFromProfileResource(W,F,T){const z=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!z.length)return[];const _=await Promise.all(z.map(async J=>{if(F(J)){const q=new ne(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(q,J.metadata)}return null}));return(0,k.coalesce)(_)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,P.joinPath)(W.location,"package.json"))){const F=await this.scanExtension(W);return F?[F]:[]}else return await this.scanExtensions(W)}catch(F){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,O.getErrorMessage)(F)),[]}}async scanExtension(W,F){try{let T=await this.scanExtensionManifest(W.location);if(T){T.publisher||(T.publisher=s.UNDEFINED_PUBLISHER),F=F??T.__metadata,delete T.__metadata;const z=(0,f.getGalleryExtensionId)(T.publisher,T.name),_=F?.id?{id:z,uuid:F.id}:{id:z},J=F?.isSystem?0:W.type,q=J===0||!!F?.isBuiltin;T=await this.translateManifest(W.location,T,ne.createNlsConfiguration(W));const ee={type:J,identifier:_,manifest:T,location:W.location,isBuiltin:q,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return W.validate?this.validate(ee,W):ee}}catch(T){W.type!==0&&this.logService.error(T)}return null}validate(W,F){let T=!0;const z=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,W.manifest,W.isBuiltin);for(const[_,J]of z)_===w.default.Error&&(T=!1,this.logService.error(this.formatMessage(F.location,J)));return W.isValid=T,W.validations=z,W}async scanExtensionManifest(W){const F=(0,P.joinPath)(W,"package.json");let T;try{T=(await this.fileService.readFile(F)).value.toString()}catch(_){return(0,n.toFileOperationResult)(_)!==1&&this.logService.error(this.formatMessage(W,(0,h.localize)(0,null,F.path,_.message))),null}let z;try{z=JSON.parse(T)}catch{const J=[];(0,I.parse)(T,J);for(const q of J)this.logService.error(this.formatMessage(W,(0,h.localize)(1,null,F.path,q.offset,q.length,(0,d.getParseErrorMessage)(q.error))));return null}return(0,I.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(W,(0,h.localize)(2,null,F.path))),null):z}async translateManifest(W,F,T){const z=await this.getLocalizedMessages(W,F,T);if(z)try{const _=[],J=await this.resolveOriginalMessageBundle(z.default,_);if(_.length>0)return _.forEach(ee=>{this.logService.error(this.formatMessage(W,(0,h.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)(ee.error))))}),F;if((0,I.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(W,(0,h.localize)(4,null,z.default?.path))),F;const q=z.values||Object.create(null);return(0,B.localizeManifest)(F,q,J)}catch{}return F}async getLocalizedMessages(W,F,T){const z=(0,P.joinPath)(W,"package.nls.json"),_=(U,b)=>{b.forEach(A=>{this.logService.error(this.formatMessage(W,(0,h.localize)(5,null,U?.path,(0,d.getParseErrorMessage)(A.error))))})},J=U=>{this.logService.error(this.formatMessage(W,(0,h.localize)(6,null,U?.path)))},q=`${F.publisher}.${F.name}`,ee=T.translations[q];if(ee)try{const U=c.URI.file(ee),b=(await this.fileService.readFile(U)).value.toString(),A=[],M=(0,I.parse)(b,A);return A.length>0?(_(U,A),{values:void 0,default:z}):(0,I.getNodeType)(M)!=="object"?(J(U),{values:void 0,default:z}):{values:M.contents?M.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let b;try{b=await this.findMessageBundles(W,T)}catch{return}if(!b.localized)return{values:void 0,default:b.original};try{const A=(await this.fileService.readFile(b.localized)).value.toString(),M=[],V=(0,I.parse)(A,M);return M.length>0?(_(b.localized,M),{values:void 0,default:b.original}):(0,I.getNodeType)(V)!=="object"?(J(b.localized),{values:void 0,default:b.original}):{values:V,default:b.original}}catch{return{values:void 0,default:b.original}}}}async resolveOriginalMessageBundle(W,F){if(W)try{const T=(await this.fileService.readFile(W)).value.toString();return(0,I.parse)(T,F)}catch{}}findMessageBundles(W,F){return new Promise((T,z)=>{const _=J=>{const q=(0,P.joinPath)(W,`package.nls.${J}.json`);this.fileService.exists(q).then(ee=>{ee&&T({localized:q,original:(0,P.joinPath)(W,"package.nls.json")});const U=J.lastIndexOf("-");U===-1?T({localized:(0,P.joinPath)(W,"package.nls.json"),original:null}):(J=J.substring(0,U),_(J))})};if(F.devMode||F.pseudo||!F.language)return T({localized:(0,P.joinPath)(W,"package.nls.json"),original:null});_(F.language)})}formatMessage(W,F){return`[${W.path}]: ${F}`}};ae=ge([ie(1,g.IExtensionsProfileScannerService),ie(2,N.IUriIdentityService),ie(3,n.IFileService),ie(4,r.ILogService)],ae);let Y=class extends ae{constructor(W,F,T,z,_,J){super(F,T,z,_,J),this.cacheFile=W,this.cacheValidatorThrottler=this._register(new R.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const F=await this.readExtensionCache();if(this.input=W,F&&F.input&&ne.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(z=>(z.location=c.URI.revive(z.location),z));const T=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:T}),T}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),F=JSON.parse(W.value.toString());return{result:F.result,input:(0,a.revive)(F.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(W)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const F=W.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(T,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};Y=ge([ie(2,g.IExtensionsProfileScannerService),ie(3,N.IUriIdentityService),ie(4,n.IFileService),ie(5,r.ILogService)],Y);function me(se,W){const F=(0,f.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:F,identifier:new s.ExtensionIdentifier(F),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:W,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}e.toExtensionDescription=me;class ue extends X{constructor(W,F,T,z,_,J,q,ee,U,b,A,M){super(W,F,(0,P.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,P.joinPath)(z,s.MANIFEST_CACHE_FOLDER),_,J,q,ee,U,b,A,M),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const V=await this.fileService.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=ue}),define(Q[142],Z([0,1,57,4,32,3,2,16,15,20,9,25]),function($,e,k,R,D,L,O,I,d,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(p,w){super(),this.userDataProfilesService=p,this.logService=w,this.processesLimiter=new R.Limiter(5)}async postUninstall(p){const w=this.parseScript(p,"uninstall");return w&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${E}`)))),l.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(p,w){const E=`vscode:${w}`;if(p.location.scheme===I.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[E]=="string"){const c=p.manifest.scripts[E].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${E} should be a node script`),null):{script:(0,d.join)(p.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(p,w,E,c,h){return new Promise((y,f)=>{const s=this.start(p,w,E,h);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):y(void 0)};s.on("error",t=>{n((0,D.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${w} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}start(p,w,E,c){const h={silent:!0,execArgv:void 0},y=(0,k.fork)(p,[`--type=extension-post-${w}`,...E],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(y.stdout,"data"),s=L.Event.fromNodeEventEmitter(y.stderr,"data");f(t=>this.logService.info(c.identifier.id,c.manifest.version,`post-${w}`,t)),s(t=>this.logService.error(c.identifier.id,c.manifest.version,`post-${w}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),y}getExtensionStoragePath(p){return(0,d.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=ge([ie(0,S.IUserDataProfilesService),ie(1,v.ILogService)],m),e.ExtensionsLifecycle=m}),define(Q[143],Z([0,1,10,18,41,48,13,7,9,28,30,25]),function($,e,k,R,D,L,O,I,d,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends L.NativeExtensionsScannerService{constructor(p,w,E,c,h,y,f,s){super(k.URI.file(h.builtinExtensionsPath),k.URI.file(h.extensionsPath),h.userHome,k.URI.file(h.userDataPath),p,w,E,c,h,y,f,s)}};m=ge([ie(0,S.IUserDataProfilesService),ie(1,D.IExtensionsProfileScannerService),ie(2,O.IFileService),ie(3,d.ILogService),ie(4,R.INativeEnvironmentService),ie(5,l.IProductService),ie(6,v.IUriIdentityService),ie(7,I.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(Q[144],Z([0,1,4,3,2,114,8,80,7,25]),function($,e,k,R,D,L,O,I,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var v;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var m;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function P(h){const y=h.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=P;class p extends D.Disposable{constructor(y={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=y,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,f){if(f===e.TARGET_KEY){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:f,target:this.getKeyTargets(y)[f]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,f,s){return this.getStorage(f)?.get(y,s)}getBoolean(y,f,s){return this.getStorage(f)?.getBoolean(y,s)}getNumber(y,f,s){return this.getStorage(f)?.getNumber(y,s)}store(y,f,s,i){if((0,O.isUndefinedOrNull)(f)){this.remove(y,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,s,i),this.getStorage(s)?.set(y,f)})}remove(y,f){this.withPausedEmitters(()=>{this.updateKeyTarget(y,f,void 0),this.getStorage(f)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,f){const s=[],i=this.getKeyTargets(y);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}updateKeyTarget(y,f,s){const i=this.getKeyTargets(f);typeof s=="number"?i[y]!==s&&(i[y]=s,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[y]=="number"&&(delete i[y],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const f=this.getStorage(y);return f?P(f):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=v.NONE){this._onWillSaveState.fire({reason:y});const f=this.getStorage(-1),s=this.getStorage(0),i=this.getStorage(1);switch(y){case v.NONE:await k.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await k.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return c(y,f,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,f){return this.emitWillSaveState(v.NONE),(0,l.isUserDataProfile)(y)?this.switchToProfile(y,f):this.switchToWorkspace(y,f)}canSwitchProfile(y,f){return!(y.id===f.id||w(f)&&w(y))}switchData(y,f,s,i){this.withPausedEmitters(()=>{if(i)for(const[n,t]of y)f.set(n,t);else{const n=new Set;for(const[t,r]of y)n.add(t),f.get(t)!==r&&this.emitDidChangeValue(s,t);for(const[t]of f.items)n.has(t)||this.emitDidChangeValue(s,t)}})}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;function w(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class E extends p{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(y){return!1}}e.InMemoryStorageService=E;async function c(h,y,f,s,i,n){const t=K=>{try{return JSON.parse(K)}catch{return K}},r=new Map,o=new Map;h.forEach((K,X)=>{r.set(X,K),o.set(X,t(K))});const u=new Map,a=new Map;y.forEach((K,X)=>{u.set(X,K),a.set(X,t(K))});const g=new Map,C=new Map;f.forEach((K,X)=>{g.set(X,K),C.set(X,t(K))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const N=[];if(r.forEach((K,X)=>{N.push({key:X,value:K})}),console.table(N),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const K=[];u.forEach((X,ne)=>{K.push({key:ne,value:X})}),console.table(K),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const B=[];g.forEach((K,X)=>{B.push({key:X,value:K})}),console.table(B),console.groupEnd(),console.log(C)}e.logStorage=c}),define(Q[145],Z([0,1,19,22,11,12,33,8,10,21,18,23,24,45,13,9,28,47,133,144,36]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,S.getTargetPlatform)(L.platform,O.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...U){return String(U.reduce((b,A)=>b|A,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class g{constructor(b=a){this.state=b}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(b,A=this.state.pageSize){return new g({...this.state,pageNumber:b,pageSize:A})}withFilter(b,...A){const M=[...this.state.criteria,...A.length?A.map(V=>({filterType:b,value:V})):[{filterType:b}]];return new g({...this.state,criteria:M})}withSortBy(b){return new g({...this.state,sortBy:b})}withSortOrder(b){return new g({...this.state,sortOrder:b})}withFlags(...b){return new g({...this.state,flags:b.reduce((A,M)=>A|M,0)})}withAssetTypes(...b){return new g({...this.state,assetTypes:b})}withSource(b){return new g({...this.state,source:b})}get raw(){const{criteria:b,pageNumber:A,pageSize:M,sortBy:V,sortOrder:j,flags:te,assetTypes:oe}=this.state;return{filters:[{criteria:b,pageNumber:A,pageSize:M,sortBy:V,sortOrder:j}],assetTypes:oe,flags:te}}get searchText(){const b=this.state.criteria.filter(A=>A.filterType===t.SearchText)[0];return b&&b.value?b.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(b=>String(b.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function C(U,b){const A=(U||[]).filter(M=>M.statisticName===b)[0];return A?A.value:0}function N(U){const b="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(M=>M.assetType.indexOf(b)===0).reduce((M,V)=>{const j=X(U,V.assetType);return j&&M.push([V.assetType.substring(b.length),j]),M},[])}function B(U){if(U.properties){const b=U.properties.filter(V=>V.key===r.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=b.filter(V=>A.test(V.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return X(U,r.Repository)}function K(U){return{uri:`${U.fallbackAssetUri}/${r.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${r.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function X(U,b){return U.files.filter(M=>M.assetType===b)[0]?{uri:`${U.assetUri}/${b}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${b}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ne(U,b){const A=U.properties?U.properties.filter(V=>V.key===b):[],M=A.length>0&&A[0].value;return M?M.split(",").map(V=>(0,m.adoptToGalleryExtensionId)(V)):[]}function ae(U){const b=U.properties?U.properties.filter(A=>A.key===o.Engine):[];return b.length>0&&b[0].value||""}function Y(U){const b=U.properties?U.properties.filter(A=>A.key===o.PreRelease):[];return b.length>0&&b[0].value==="true"}function me(U){const b=U.properties?U.properties.filter(M=>M.key===o.LocalizedLanguages):[],A=b.length>0&&b[0].value||"";return A?A.split(","):[]}function ue(U){return U.properties?.find(b=>b.key===o.SponsorLink)?.value}function se(U){return U.indexOf("preview")!==-1}function W(U){return U.targetPlatform?(0,S.toTargetPlatform)(U.targetPlatform):"undefined"}function F(U){const b=(0,k.distinct)(U.versions.map(W)),A=!!U.tags?.includes(S.WEB_EXTENSION_TAG),M=b.indexOf("web");return A?M===-1&&b.push("web"):M!==-1&&b.splice(M,1),b}function T(U,b){const A=(0,S.getFallbackTargetPlarforms)(b);for(let M=0;M<U.length;M++){const V=U[M];if(V.version===U[M-1]?.version){let j=M;const te=W(V);if(te===b)for(;j>0&&U[j-1].version===V.version;)j--;else if(A.includes(te))for(;j>0&&U[j-1].version===V.version&&W(U[j-1])!==b;)j--;j!==M&&(U.splice(M,1),U.splice(j,0,V))}}return U}e.sortExtensionVersions=T;function z(U,b,A){U.telemetryData={index:b,querySource:A}}function _(U,b,A){const M=U.versions[0],V={manifest:X(b,r.Manifest),readme:X(b,r.Details),changelog:X(b,r.Changelog),license:X(b,r.License),repository:B(b),download:K(b),icon:X(b,r.Icon),signature:X(b,r.Signature),coreTranslations:N(b)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:b.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:ue(M),description:U.shortDescription||"",installCount:C(U.statistics,"install"),rating:C(U.statistics,"averagerating"),ratingCount:C(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:A,assets:V,properties:{dependencies:ne(b,o.Dependency),extensionPack:ne(b,o.ExtensionPack),engine:ae(b),localizedLanguages:me(b),targetPlatform:W(b),isPreReleaseVersion:Y(b)},hasPreReleaseVersion:Y(M),hasReleaseVersion:!0,preview:se(U.flags),isSigned:!!V.signature}}let J=class{constructor(b,A,M,V,j,te,oe,fe){this.requestService=A,this.logService=M,this.environmentService=V,this.telemetryService=j,this.fileService=te,this.productService=oe,this.configurationService=fe;const ve=oe.extensionsGallery,le=ve?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=le?ve.servicePPEUrl:ve?.serviceUrl,this.extensionsGallerySearchUrl=le?void 0:ve?.searchUrl,this.extensionsControlUrl=ve?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(oe.version,oe,this.environmentService,this.configurationService,this.fileService,b,this.telemetryService)}api(b=""){return`${this.extensionsGalleryUrl}${b}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(b,A,M){const V=R.CancellationToken.isCancellationToken(A)?{}:A,j=R.CancellationToken.isCancellationToken(A)?A:M,te=[],oe=[],fe=[],ve=[];let le=!0;for(const ce of b){ce.uuid?oe.push(ce.uuid):te.push(ce.id);const Se=!!(ce.version||ce.preRelease);fe.push({id:ce.id,uuid:ce.uuid,includePreRelease:Se}),ce.version&&ve.push({id:ce.id,uuid:ce.uuid,version:ce.version}),le=le&&!!ce.hasPreRelease&&!Se}if(!oe.length&&!te.length)return[];let re=new g().withPage(1,b.length);oe.length&&(re=re.withFilter(t.ExtensionId,...oe)),te.length&&(re=re.withFilter(t.ExtensionName,...te)),(V.queryAllVersions||le)&&(re=re.withFlags(re.flags,i.IncludeVersions)),V.source&&(re=re.withSource(V.source));const{extensions:he}=await this.queryGalleryExtensions(re,{targetPlatform:V.targetPlatform??s,includePreRelease:fe,versions:ve,compatible:!!V.compatible},j);return V.source&&he.forEach((ce,Se)=>z(ce,Se,V.source)),he}async getCompatibleExtension(b,A,M){if((0,S.isNotWebExtensionInWebTargetPlatform)(b.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(b,A,M))return b;const V=new g().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,b.identifier.uuid),{extensions:j}=await this.queryGalleryExtensions(V,{targetPlatform:M,compatible:!0,includePreRelease:A},R.CancellationToken.None);return j[0]||null}async isExtensionCompatible(b,A,M){if(!(0,S.isTargetPlatformCompatible)(b.properties.targetPlatform,b.allTargetPlatforms,M)||!A&&b.properties.isPreReleaseVersion)return!1;let V=b.properties.engine;if(!V){const j=await this.getManifest(b,R.CancellationToken.None);if(!j)throw new Error("Manifest was not found");V=j.engines.vscode}return(0,P.isEngineValid)(V,this.productService.version,this.productService.date)}async isValidVersion(b,A,M,V,j){if(!(0,S.isTargetPlatformCompatible)(W(b),V,j)||A!=="any"&&Y(b)!==(A==="prerelease"))return!1;if(M)try{const te=await this.getEngine(b);if(!(0,P.isEngineValid)(te,this.productService.version,this.productService.date))return!1}catch(te){return this.logService.error(`Error while getting the engine for the version ${b.version}.`,(0,D.getErrorMessage)(te)),!1}return!0}async query(b,A){let M=b.text||"";const V=b.pageSize??50;let j=new g().withPage(1,V);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,re,he)=>(j=j.withFilter(t.Category,he||re),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,re,he)=>(j=j.withFilter(t.Tag,he||re),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(t.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),j=j.withFilter(t.SearchText,M)),j=j.withSortBy(0)):b.ids?j=j.withFilter(t.ExtensionId,...b.ids):b.names?j=j.withFilter(t.ExtensionName,...b.names):j=j.withSortBy(4),typeof b.sortBy=="number"&&(j=j.withSortBy(b.sortBy)),typeof b.sortOrder=="number"&&(j=j.withSortOrder(b.sortOrder)),b.source&&(j=j.withSource(b.source));const te=async(le,re)=>{const{extensions:he,total:ce}=await this.queryGalleryExtensions(le,{targetPlatform:s,compatible:!1,includePreRelease:!!b.includePreRelease},re);return he.forEach((Se,Re)=>z(Se,(le.pageNumber-1)*le.pageSize+Re,b.source)),{extensions:he,total:ce}},{extensions:oe,total:fe}=await te(j,A),ve=async(le,re)=>{if(re.isCancellationRequested)throw new D.CancellationError;const{extensions:he}=await te(j.withPage(le+1),re);return he};return{firstPage:oe,total:fe,pageSize:j.pageSize,getPage:ve}}async queryGalleryExtensions(b,A,M){const V=b.flags;!!(b.flags&i.IncludeLatestVersionOnly)&&!!(b.flags&i.IncludeVersions)&&(b=b.withFlags(b.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(b.flags&i.IncludeLatestVersionOnly)&&!(b.flags&i.IncludeVersions)&&(b=b.withFlags(b.flags,i.IncludeLatestVersionOnly)),A.versions?.length&&(b=b.withFlags(b.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),b=b.withFlags(b.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:j,total:te}=await this.queryRawGalleryExtensions(b,M);if(!(b.flags&i.IncludeLatestVersionOnly)){const le=[];for(const re of j){const he=await this.toGalleryExtensionWithCriteria(re,A);he&&le.push(he)}return{extensions:le,total:te}}const fe=[],ve=new Map;for(let le=0;le<j.length;le++){const re=j[le],he={id:(0,m.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},ce=(0,I.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(Re=>(0,m.areSameExtensions)(Re,he))?.includePreRelease;if(A.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(F(re),A.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(re,A);!Se||Se.properties.isPreReleaseVersion&&(!ce||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==A.targetPlatform&&Se.hasPreReleaseVersion?ve.set(re.extensionId,le):fe.push([le,Se])}if(ve.size){const le=new Date().getTime(),re=new g().withFlags(V&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(t.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(re,A,M);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const ce of he){const Se=ve.get(ce.identifier.uuid);fe.push([Se,ce])}}return{extensions:fe.sort((le,re)=>le[0]-re[0]).map(([,le])=>le),total:te}}async toGalleryExtensionWithCriteria(b,A){const M={id:(0,m.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},V=A.versions?.find(fe=>(0,m.areSameExtensions)(fe,M))?.version,j=(0,I.isBoolean)(A.includePreRelease)?A.includePreRelease:!!A.includePreRelease.find(fe=>(0,m.areSameExtensions)(fe,M))?.includePreRelease,te=F(b),oe=T(b.versions,A.targetPlatform);if(A.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(te,A.targetPlatform))return null;for(let fe=0;fe<oe.length;fe++){const ve=oe[fe];if(!(V&&ve.version!==V)){if(await this.isValidVersion(ve,j?"any":"release",A.compatible,te,A.targetPlatform))return _(b,ve,te);if(V&&ve.version===V)return null}}return V||A.compatible?null:_(b,b.versions[0],te)}async queryRawGalleryExtensions(b,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");b=b.withFlags(b.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const M=await this.commonHeadersPromise,V=JSON.stringify(b.raw),j={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new Date().getTime();let oe,fe,ve=0;try{if(oe=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&b.criteria.some(re=>re.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:V,headers:j},A),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,c.asJson)(oe);if(le){const re=le.results[0],he=re.extensions,ce=re.resultMetadata&&re.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=ce&&ce.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw fe=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...b.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-te,success:!!oe&&(0,c.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:fe?(0,D.isCancellationError)(fe)?"canceled":(0,D.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(b,A,M,V){if(!this.isEnabled())return;const j=L.isWeb?this.api(`/itemName/${b}.${A}/version/${M}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${b}/extensions/${A}/${M}/stats?statType=${V}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:j,headers:fe},R.CancellationToken.None)}catch{}}async download(b,A,M){this.logService.trace("ExtensionGalleryService#download",b.identifier.id);const V=(0,m.getGalleryExtensionTelemetryData)(b),j=new Date().getTime(),te=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...V,duration:le}),oe=M===2?"install":M===3?"update":"",fe=oe?{uri:`${b.assets.download.uri}${d.URI.parse(b.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${b.assets.download.fallbackUri}${d.URI.parse(b.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:b.assets.download,ve=await this.getAsset(fe);await this.fileService.writeFile(A,ve.stream),te(new Date().getTime()-j)}async downloadSignatureArchive(b,A){if(!b.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",b.identifier.id);const M=await this.getAsset(b.assets.signature);await this.fileService.writeFile(A,M.stream)}async getReadme(b,A){if(b.assets.readme){const M=await this.getAsset(b.assets.readme,{},A);return await(0,c.asTextOrError)(M)||""}return""}async getManifest(b,A){if(b.assets.manifest){const M=await this.getAsset(b.assets.manifest,{},A),V=await(0,c.asTextOrError)(M);return V?JSON.parse(V):null}return null}async getManifestFromRawExtensionVersion(b,A){const M=X(b,r.Manifest);if(!M)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},j=await this.getAsset(M,{headers:V});return await(0,c.asJson)(j)}async getCoreTranslation(b,A){const M=b.assets.coreTranslations.filter(V=>V[0]===A.toUpperCase())[0];if(M){const V=await this.getAsset(M[1]),j=await(0,c.asTextOrError)(V);return j?JSON.parse(j):null}return null}async getChangelog(b,A){if(b.assets.changelog){const M=await this.getAsset(b.assets.changelog,{},A);return await(0,c.asTextOrError)(M)||""}return""}async getAllCompatibleVersions(b,A,M){let V=new g().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);b.identifier.uuid?V=V.withFilter(t.ExtensionId,b.identifier.uuid):V=V.withFilter(t.ExtensionName,b.identifier.id);const{galleryExtensions:j}=await this.queryRawGalleryExtensions(V,R.CancellationToken.None);if(!j.length)return[];const te=F(j[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(te,M))return[];const oe=[];await Promise.all(j[0].versions.map(async le=>{try{await this.isValidVersion(le,A?"any":"release",!0,te,M)&&oe.push(le)}catch{}}));const fe=[],ve=new Set;for(const le of T(oe,M))ve.has(le.version)||(ve.add(le.version),fe.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:Y(le)}));return fe}async getAsset(b,A={},M=R.CancellationToken.None){const V=await this.commonHeadersPromise,j={type:"GET"},te={...V,...A.headers||{}};A={...A,...j,headers:te};const oe=b.uri,fe=b.fallbackUri,ve={...A,url:oe};try{const le=await this.requestService.request(ve,M);if(le.res.statusCode===200)return le;const re=await(0,c.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${re}`)}catch(le){if((0,D.isCancellationError)(le))throw le;const re=(0,D.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:re});const he={...A,url:fe};return this.requestService.request(he,M)}}async getEngine(b){let A=ae(b);if(!A){const M=await this.getManifestFromRawExtensionVersion(b,R.CancellationToken.None);if(!M)throw new Error("Manifest was not found");A=M.engines.vscode}return A}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const b=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(b.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,c.asJson)(b),M=[],V={};if(A){for(const j of A.malicious)M.push({id:j});if(A.migrateToPreRelease)for(const[j,te]of Object.entries(A.migrateToPreRelease))(!te.engine||(0,P.isEngineValid)(te.engine,this.productService.version,this.productService.date))&&(V[j.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(A.deprecated)for(const[j,te]of Object.entries(A.deprecated))te&&(V[j.toLowerCase()]=(0,I.isBoolean)(te)?{}:te)}return{malicious:M,deprecated:V}}};J=ge([ie(1,c.IRequestService),ie(2,w.ILogService),ie(3,v.IEnvironmentService),ie(4,f.ITelemetryService),ie(5,p.IFileService),ie(6,E.IProductService),ie(7,l.IConfigurationService)],J);let q=class extends J{constructor(b,A,M,V,j,te,oe,fe){super(b,A,M,V,j,te,oe,fe)}};q=ge([ie(0,y.IStorageService),ie(1,c.IRequestService),ie(2,w.ILogService),ie(3,v.IEnvironmentService),ie(4,f.ITelemetryService),ie(5,p.IFileService),ie(6,E.IProductService),ie(7,l.IConfigurationService)],q),e.ExtensionGalleryService=q;let ee=class extends J{constructor(b,A,M,V,j,te,oe){super(void 0,b,A,M,V,j,te,oe)}};ee=ge([ie(0,c.IRequestService),ie(1,w.ILogService),ie(2,v.IEnvironmentService),ie(3,f.ITelemetryService),ie(4,p.IFileService),ie(5,E.IProductService),ie(6,l.IConfigurationService)],ee),e.ExtensionGalleryServiceWithNoStorageService=ee}),define(Q[146],Z([0,1,44,18,13,9,66,30,25]),function($,e,k,R,D,L,O,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let l=class je extends d.UserDataProfilesService{constructor(S,m,P,p,w){super(P,p,m,w),this.stateService=S}getStoredProfiles(){return(0,k.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,k.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};l=ge([ie(0,O.IStateService),ie(1,I.IUriIdentityService),ie(2,R.IEnvironmentService),ie(3,D.IFileService),ie(4,L.ILogService)],l),e.UserDataProfilesService=l}),define(Q[147],Z([0,1,37,4,160,2]),function($,e,k,R,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class O extends k.AbstractPolicyService{constructor(d){super(),this.productName=d,this.throttler=new R.Throttler,this.watcher=this._register(new L.MutableDisposable)}async initializePolicies(d){await this.throttler.queue(()=>new Promise((l,v)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,d,S=>{for(const m in S){const P=S[m];P===void 0?this.policies.delete(m):this.policies.set(m,P)}this._onDidChange.fire(Object.keys(S)),l()})}catch(S){v(S)}}))}}e.NativePolicyService=O}),define(Q[68],Z([0,1,116,4,15,8,20,81,161,162]),function($,e,k,R,D,L,O,I,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class v extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=v;function S(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function m(s){if(s instanceof v)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new v(i,s)}function P(s,i,n,t,r,o){const u=D.dirname(i),a=D.join(t,u);if(!a.startsWith(t))return Promise.reject(new Error(I.localize(0,null,i)));const g=D.join(t,i);let C;return o.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((N,B)=>{if(!o.isCancellationRequested)try{C=(0,k.createWriteStream)(g,{mode:n}),C.once("close",()=>N()),C.once("error",B),s.once("error",B),s.pipe(C)}catch(K){B(K)}}))}function p(s,i,n,t){let r=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((u,a)=>{const g=new R.Sequencer,C=N=>{N.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?u():a(new v("Incomplete",new Error(I.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",N=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(N.fileName)){C(t);return}const B=N.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const ne=D.join(i,B);r=(0,R.createCancelablePromise)(ae=>O.Promises.mkdir(ne,{recursive:!0}).then(()=>C(ae)).then(void 0,a));return}const K=E(s,N),X=S(N);r=(0,R.createCancelablePromise)(ne=>g.queue(()=>K.then(ae=>P(ae,B,X,i,n,ne).then(()=>C(ne)))).then(null,a))})})}function w(s,i=!1){return new Promise((n,t)=>{(0,d.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(m(r)):n((0,L.assertIsDefined)(o))})})}function E(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(m(r)):n((0,L.assertIsDefined)(o))})})}function c(s,i){return new Promise((n,t)=>{const r=new l.ZipFile;i.forEach(u=>{u.contents?r.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&r.addFile(u.localPath,u.path)}),r.end();const o=(0,k.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=c;function h(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=w(s,!0);return n.overwrite&&(o=o.then(u=>O.Promises.rm(i).then(()=>u))),o.then(u=>p(u,i,{sourcePathRegex:r},t))}e.extract=h;function y(s,i){return w(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&E(n,o).then(u=>t(u),u=>r(u))}),n.once("close",()=>r(new Error(I.localize(2,null,i))))}))}function f(s,i){return y(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",u=>o.push(u)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Q[148],Z([0,1,68,89]),function($,e,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,k.buffer)(L,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=D}),define(Q[149],Z([0,1,4,14,22,32,11,3,2,34,16,15,12,17,39,8,10,31,20,68,88,58,18,141,23,24,41,48,124,142,148,125,126,29,45,13,7,9,28,36,30,25]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h,y,f,s,i,n,t,r,o,u,a,g,C,N,B,K,X,ne,ae,Y,me,ue,se,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ae.refineServiceDecorator)(t.IExtensionManagementService);let F=class extends n.AbstractExtensionManagementService{constructor(b,A,M,V,j,te,oe,fe,ve,le,re,he){super(b,A,M,le,he),this.extensionsScannerService=j,this.extensionsProfileScannerService=te,this.downloadService=oe,this.fileService=ve,this.uriIdentityService=re,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new l.ResourceSet;const ce=this._register(fe.createInstance(g.ExtensionsLifecycle));this.extensionsScanner=this._register(fe.createInstance(T,Re=>ce.postUninstall(Re))),this.manifestCache=this._register(new N.ExtensionsManifestCache(V,this)),this.extensionsDownloader=this._register(fe.createInstance(a.ExtensionsDownloader));const Se=this._register(new B.ExtensionsWatcher(this,he,te,re,ve,M));this._register(Se.onDidChangeExtensionsByAnotherSource(Re=>this.onDidChangeExtensionsFromAnotherSource(Re))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,r.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(b){this.logService.trace("ExtensionManagementService#zip",b.identifier.id);const A=await this.collectFiles(b),M=await(0,y.zip)((0,P.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,A);return E.URI.file(M)}async unzip(b){return this.logService.trace("ExtensionManagementService#unzip",b.toString()),(await this.install(b)).identifier}async getManifest(b){const{location:A,cleanup:M}=await this.downloadVsix(b),V=S.resolve(A.fsPath);try{return await(0,C.getManifest)(V)}finally{await M()}}getInstalled(b,A){return this.extensionsScanner.scanExtensions(b??null,A)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(b,A={}){this.logService.trace("ExtensionManagementService#install",b.toString());const{location:M,cleanup:V}=await this.downloadVsix(b);try{const j=await(0,C.getManifest)(S.resolve(M.fsPath));if(j.engines&&j.engines.vscode&&!(0,X.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,r.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return await this.installExtension(j,M,A)}finally{await V()}}getMetadata(b){return this.extensionsScannerService.scanMetadata(b.location)}async updateMetadata(b,A){this.logService.trace("ExtensionManagementService#updateMetadata",b.identifier.id);const M={...A};return A.isPreReleaseVersion&&(M.preRelease=!0),b=await this.extensionsScanner.updateMetadata(b,M),this.manifestCache.invalidate(),b}async updateExtensionScope(b,A){return this.logService.trace("ExtensionManagementService#updateExtensionScope",b.identifier.id),b=await this.extensionsScanner.updateMetadata(b,{isMachineScoped:A}),this.manifestCache.invalidate(),b}async reinstallFromGallery(b){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",b.identifier.id),!this.galleryService.isEnabled())throw new Error(f.localize(1,null));const A=await this.getTargetPlatform(),[M]=await this.galleryService.getExtensions([{...b.identifier,preRelease:b.preRelease}],{targetPlatform:A,compatible:!0},D.CancellationToken.None);if(!M)throw new Error(f.localize(2,null));await this.extensionsScanner.setUninstalled(b);try{await this.extensionsScanner.removeUninstalledExtension(b)}catch(V){throw new Error(f.localize(3,null,(0,L.toErrorMessage)(V)))}await this.installFromGallery(M)}markAsUninstalled(...b){return this.extensionsScanner.setUninstalled(...b)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}migrateDefaultProfileExtensions(){return this.extensionsScanner.migrateDefaultProfileExtensions()}async download(b,A){const{location:M}=await this.extensionsDownloader.download(b,A);return M}async downloadVsix(b){if(b.scheme===v.Schemas.file)return{location:b,async cleanup(){}};this.logService.trace("Downloading extension from",b.toString());const A=(0,P.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)());return await this.downloadService.download(b,A),this.logService.info("Downloaded extension to",A.toString()),{location:A,cleanup:async()=>{try{await this.fileService.del(A)}catch(V){this.logService.error(V)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(b,A,M){let V;if(E.URI.isUri(A))V=new J(b,A,M,this.galleryService,this.extensionsScanner,this.logService);else{const j=r.ExtensionKey.create(A).toString();V=this.installGalleryExtensionsTasks.get(j),V||(this.installGalleryExtensionsTasks.set(j,V=new _(b,A,M,this.extensionsDownloader,this.extensionsScanner,this.logService)),V.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(j)))}return new q(V,M.profileLocation,this.extensionsProfileScannerService)}createUninstallExtensionTask(b,A){return new ee(b,A.profileLocation,this.extensionsProfileScannerService)}async collectFiles(b){const A=async V=>{let j=await h.Promises.readdir(V);j=j.map(fe=>S.join(V,fe));const te=await Promise.all(j.map(fe=>h.Promises.stat(fe)));let oe=Promise.resolve([]);return te.forEach((fe,ve)=>{const le=j[ve];fe.isFile()&&(oe=oe.then(re=>[...re,le])),fe.isDirectory()&&(oe=oe.then(re=>A(le).then(he=>[...re,...he])))}),oe};return(await A(b.location.fsPath)).map(V=>({path:`extension/${S.relative(b.location.fsPath,V)}`,localPath:V}))}async onDidChangeExtensionsFromAnotherSource({added:b,removed:A}){if(A)for(const M of A.extensions)this._onDidUninstallExtension.fire({identifier:M,profileLocation:A.profileLocation});if(b){const V=(await this.extensionsScanner.scanExtensions(1,b.profileLocation)).filter(j=>b.extensions.some(te=>(0,r.areSameExtensions)(te,j.identifier)));this._onDidInstallExtensions.fire(V.map(j=>({identifier:j.identifier,local:j,profileLocation:b.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(A=>this.knownDirectories.add(A)));const b=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const A of b.children??[])A.isDirectory&&this.knownDirectories.add(A.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(A=>this.onDidFilesChange(A)))}async onDidFilesChange(b){const A=[];for(const M of b.rawAdded){if(this.knownDirectories.has(M)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(M),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(M,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(M).startsWith(".")||!(await this.fileService.stat(M)).isDirectory)continue;const V=await this.extensionsScanner.scanUserExtensionAtLocation(M);V&&V.installedTimestamp===void 0&&(this.knownDirectories.add(M),A.push(V))}A.length&&(await this.extensionsProfileScannerService.addExtensionsToProfile(A.map(M=>[M,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this._onDidInstallExtensions.fire(A.map(M=>({local:M,version:M.manifest.version,identifier:M.identifier,operation:1,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}))))}};F=ge([ie(0,t.IExtensionGalleryService),ie(1,ue.ITelemetryService),ie(2,Y.ILogService),ie(3,i.INativeEnvironmentService),ie(4,u.IExtensionsScannerService),ie(5,o.IExtensionsProfileScannerService),ie(6,s.IDownloadService),ie(7,ae.IInstantiationService),ie(8,ne.IFileService),ie(9,me.IProductService),ie(10,se.IUriIdentityService),ie(11,W.IUserDataProfilesService)],F),e.ExtensionManagementService=F;let T=class extends d.Disposable{constructor(b,A,M,V,j,te){super(),this.beforeRemovingExtension=b,this.fileService=A,this.extensionsScannerService=M,this.userDataProfilesService=V,this.extensionsProfileScannerService=j,this.logService=te,this._onExtract=this._register(new I.Emitter),this.onExtract=this._onExtract.event,this._migrateDefaultProfileExtensionsPromise=void 0,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(b,A){await this.migrateDefaultProfileExtensions();const M={includeInvalid:!0,profileLocation:A};let V=[];return b===null||b===0?V.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},M,!1)):b===1&&V.push(...await this.extensionsScannerService.scanUserExtensions(M)),V=b!==null?V.filter(j=>j.type===b):V,Promise.all(V.map(j=>this.toLocalExtension(j)))}async scanAllUserExtensions(b){const A=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!b,includeInvalid:!0});return Promise.all(A.map(M=>this.toLocalExtension(M)))}async scanUserExtensionAtLocation(b){try{const A=await this.extensionsScannerService.scanExistingExtension(b,1,{includeInvalid:!0});if(A)return await this.toLocalExtension(A)}catch(A){this.logService.error(A)}return null}async extractUserExtension(b,A,M,V){await this.migrateDefaultProfileExtensions();const j=b.toString(),te=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`),oe=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j);try{await h.Promises.rm(oe)}catch{throw new t.ExtensionManagementError(f.localize(4,null,oe,b.id),t.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(b,A,te,V),await this.extensionsScannerService.updateMetadata(E.URI.file(te),M);try{this._onExtract.fire(E.URI.file(oe)),await this.rename(b,te,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(fe){try{await h.Promises.rm(te)}catch{}if(fe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(fe)}. Deleted from extracted location`,te),fe}return this.scanLocalExtension(E.URI.file(oe),1)}async updateMetadata(b,A){return await this.extensionsScannerService.updateMetadata(b.location,A),this.scanLocalExtension(b.location,b.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...b){const A=b.map(M=>r.ExtensionKey.create(M));await this.withUninstalledExtensions(M=>A.forEach(V=>{M[V.toString()]=!0,this.logService.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(b){await this.withUninstalledExtensions(V=>delete V[b.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(V=>r.ExtensionKey.create(V).equals(b))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(b,A){this.logService.trace(`Deleting ${A} extension from disk`,b.identifier.id,b.location.fsPath),await h.Promises.rm(b.location.fsPath),this.logService.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[r.ExtensionKey.create(b).toString()])}async withUninstalledExtensions(b){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let M={};if(A)try{M=JSON.parse(A)}catch{}return b&&(b(M),Object.keys(M).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(M)):await h.Promises.rm(this.uninstalledPath)),M})}async extractAtLocation(b,A,M,V){this.logService.trace(`Started extracting the extension from ${A} to ${M}`);try{await h.Promises.rm(M)}catch(j){throw new t.ExtensionManagementError(this.joinErrors(j).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(A,M,{sourcePath:"extension",overwrite:!0},V),this.logService.info(`Extracted extension to ${M}:`,b.id)}catch(j){try{await h.Promises.rm(M)}catch{}let te=t.ExtensionManagementErrorCode.Extract;throw j instanceof y.ExtractError&&(j.type==="CorruptZip"?te=t.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(te=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(j.message,te)}}async rename(b,A,M,V){try{await h.Promises.rename(A,M)}catch(j){if(m.isWindows&&j&&j.code==="EPERM"&&Date.now()<V)return this.logService.info(`Failed renaming ${A} to ${M} with 'EPERM' error. Trying again...`,b.id),this.rename(b,A,M,V);throw new t.ExtensionManagementError(j.message||f.localize(5,null,A,M),j.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(b,A){const M=await this.extensionsScannerService.scanExistingExtension(b,A,{includeInvalid:!0});if(M)return this.toLocalExtension(M);throw new Error(f.localize(6,null,b.path))}async toLocalExtension(b){const A=await this.fileService.resolve(b.location);let M,V;return A.children&&(M=A.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,V=A.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:b.identifier,type:b.type,isBuiltin:b.isBuiltin||!!b.metadata?.isBuiltin,location:b.location,manifest:b.manifest,targetPlatform:b.targetPlatform,validations:b.validations,isValid:b.isValid,readmeUrl:M,changelogUrl:V,publisherDisplayName:b.metadata?.publisherDisplayName||null,publisherId:b.metadata?.publisherId||null,isApplicationScoped:!!b.metadata?.isApplicationScoped,isMachineScoped:!!b.metadata?.isMachineScoped,isPreReleaseVersion:!!b.metadata?.isPreReleaseVersion,preRelease:!!b.metadata?.preRelease,installedTimestamp:b.metadata?.installedTimestamp,updated:!!b.metadata?.updated}}async removeUninstalledExtensions(){const b=await this.getUninstalledExtensions(),A=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const te of A)b[r.ExtensionKey.create(te).toString()]||M.add(te.identifier.id.toLowerCase());const V=(0,r.groupByExtension)(A,te=>te.identifier);await k.Promises.settled(V.map(async te=>{const oe=te.sort((fe,ve)=>p.rcompare(fe.manifest.version,ve.manifest.version))[0];M.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(oe))}));const j=A.filter(te=>b[r.ExtensionKey.create(te).toString()]);await k.Promises.settled(j.map(te=>this.removeUninstalledExtension(te)))}migrateDefaultProfileExtensions(){return this._migrateDefaultProfileExtensionsPromise||(this._migrateDefaultProfileExtensionsPromise=(async()=>{try{const b=(0,P.joinPath)(this.userDataProfilesService.defaultProfile.location,".migrated-default-profile");if(await this.fileService.exists(b))return;if(!await this.fileService.exists(this.userDataProfilesService.defaultProfile.extensionsResource)){this.logService.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const A=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(A.map(M=>[M,M.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.fileService.createFile(b,R.VSBuffer.fromString(""))}catch(A){this.logService.warn("Failed to create migration marker file for default profile extensions migration.",(0,O.getErrorMessage)(A))}}catch(b){throw this.logService.error(b),b}})()),this._migrateDefaultProfileExtensionsPromise}joinErrors(b){const A=Array.isArray(b)?b:[b];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((M,V)=>new Error(`${M.message}${M.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}};T=ge([ie(1,ne.IFileService),ie(2,u.IExtensionsScannerService),ie(3,W.IUserDataProfilesService),ie(4,o.IExtensionsProfileScannerService),ie(5,Y.ILogService)],T),e.ExtensionsScanner=T;class z extends n.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(b,A,M,V,j){super(),this.identifier=b,this.source=A,this.options=M,this.extensionsScanner=V,this.logService=j,this.wasVerified=!1,this._operation=2}async installExtension(b,A){try{const M=await this.unsetUninstalledAndGetLocal(b.key);if(M)return this.extensionsScanner.updateMetadata(M,b.metadata)}catch{throw m.isMacintosh?new t.ExtensionManagementError(f.localize(7,null),t.ExtensionManagementErrorCode.Internal):new t.ExtensionManagementError(f.localize(8,null),t.ExtensionManagementErrorCode.Internal)}return this.extract(b,A)}async unsetUninstalledAndGetLocal(b){if(!await this.isUninstalled(b))return null;this.logService.trace("Removing the extension from uninstalled list:",b.id);const M=await this.extensionsScanner.setInstalled(b);return this.logService.info("Removed the extension from uninstalled list:",b.id),M}async isUninstalled(b){return!!(await this.extensionsScanner.getUninstalledExtensions())[b.toString()]}async extract({zipPath:b,key:A,metadata:M},V){const j=await this.extensionsScanner.extractUserExtension(A,b,M,V);return this.logService.info("Extracting completed.",A.id),j}}class _ extends z{constructor(b,A,M,V,j,te){super(A.identifier,A,M,j,te),this.manifest=b,this.gallery=A,this.extensionsDownloader=V}async doRun(b){const M=(await this.extensionsScanner.scanExtensions(null,void 0)).find(oe=>(0,r.areSameExtensions)(oe.identifier,this.gallery.identifier));M&&(this._operation=3);const V={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,K.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(M,V),metadata:V};const{location:j,verified:te}=await this.extensionsDownloader.download(this.gallery,this._operation);try{return this.wasVerified=!!te,this.validateManifest(j.fsPath),{local:await this.installExtension({zipPath:j.fsPath,key:r.ExtensionKey.create(this.gallery),metadata:V},b),metadata:V}}catch(oe){try{await this.extensionsDownloader.delete(j)}catch(fe){this.logService.warn("Error while deleting the downloaded file",j.toString(),(0,O.getErrorMessage)(fe))}throw oe}}async validateManifest(b){try{await(0,C.getManifest)(b)}catch(A){throw new t.ExtensionManagementError((0,n.joinErrors)(A).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=_;class J extends z{constructor(b,A,M,V,j,te){super({id:(0,r.getGalleryExtensionId)(b.publisher,b.name)},A,M,j,te),this.manifest=b,this.location=A,this.galleryService=V}async doRun(b){const A=new r.ExtensionKey(this.identifier,this.manifest.version),V=(await this.extensionsScanner.scanExtensions(1,void 0)).find(oe=>(0,r.areSameExtensions)(this.identifier,oe.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,b);if(j.isApplicationScoped=(0,K.isApplicationScopedExtension)(this.manifest),j.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||V?.isBuiltin,j.installedTimestamp=Date.now(),V)if(this._operation=3,A.equals(new r.ExtensionKey(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(f.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(V.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(V);else{const oe=await this.unsetUninstalledAndGetLocal(A);if(oe)try{await this.extensionsScanner.removeExtension(oe,"existing")}catch{throw new Error(f.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:S.resolve(this.location.fsPath),key:A,metadata:j},b),metadata:j}}async getMetadata(b,A,M){try{let[V]=await this.galleryService.getExtensions([{id:b,version:A}],M);if(V||([V]=await this.galleryService.getExtensions([{id:b}],M)),V)return{id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId,isPreReleaseVersion:V.properties.isPreReleaseVersion,preRelease:V.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class q{constructor(b,A,M){this.task=b,this.profileLocation=A,this.extensionsProfileScannerService=M,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const b=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[b.local,b.metadata]],this.profileLocation),b}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class ee extends n.AbstractExtensionTask{constructor(b,A,M){super(),this.extension=b,this.profileLocation=A,this.extensionsProfileScannerService=M}async doRun(b){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(Q[150],Z([0,1,130,4,14,11,2,8,21,18,131,9,129,163]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends O.Disposable{constructor(E,c,h){super(),this.environmentService=c,this.logService=h,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,c){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:h,strictSSL:y}=this;let f;try{f=await(0,v.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",s,{proxyUrl:h,strictSSL:y});E.agent=i,E.strictSSL=y,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(E,c);return this.logService.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",E.url,n),n}}async getNodeRequest(E){return((0,k.parse)(E.url).protocol==="https:"?await new Promise((y,f)=>{$(["https"],y,f)}):await new Promise((y,f)=>{$(["http"],y,f)})).request}_request(E,c){return R.Promises.withAsyncBody(async(h,y)=>{const f=(0,k.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(i.auth=E.user+":"+E.password);const n=s(i,t=>{const r=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...E,url:t.headers.location,followRedirects:r-1},c).then(h,y);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,P.createGunzip)())),h({res:t,stream:(0,D.streamToBufferReadableStream)(o)})}});n.on("error",y),E.timeout&&n.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),c.onCancellationRequested(()=>{n.abort(),y(new L.CancellationError)})})}async resolveProxy(E){}};p=ge([ie(0,d.IConfigurationService),ie(1,l.INativeEnvironmentService),ie(2,S.ILogService)],p),e.RequestService=p}),define(Q[164],Z([0,1,38,4,14,32,11,2,16,15,12,33,10,20,21,121,58,128,18,102,145,23,59,123,41,48,149,143,13,112,115,46,110,62,63,127,9,117,118,37,147,136,28,47,150,66,132,67,36,135,42,137,138,30,139,25,146]),function($,e,k,R,D,L,O,I,d,l,v,S,m,P,p,w,E,c,h,y,f,s,i,n,t,r,o,u,a,g,C,N,B,K,X,ne,ae,Y,me,ue,se,W,F,T,z,_,J,q,ee,U,b,A,M,V,j,te,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class fe extends I.Disposable{constructor(re){super(),this.argv=re,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[re,he]=await this.initServices();return re.invokeFunction(async ce=>{const Se=ce.get(ae.ILogService),Re=ce.get(a.IFileService),Ae=ce.get(h.INativeEnvironmentService),Fe=ce.get(te.IUserDataProfilesService);Se.info("CLI main",this.argv),this.registerErrorHandler(Se),await this.doRun(Ae,Re,Fe,re),await Promise.all(he.map(xe=>{(0,R.raceTimeout)(xe.flush(),1e3)}))})}async initServices(){const re=new K.ServiceCollection,he={_serviceBrand:void 0,...W.default};re.set(F.IProductService,he);const ce=new y.NativeEnvironmentService(this.argv,he);re.set(h.INativeEnvironmentService,ce),await Promise.all([ce.appSettingsHome.fsPath,ce.extensionsPath].map(ke=>ke?P.Promises.mkdir(ke,{recursive:!0}):void 0));const Se=(0,ae.getLogLevel)(ce),Re=[];Re.push(new Y.SpdLogLogger("cli",(0,l.join)(ce.logsPath,"cli.log"),!0,!1,Se)),Se===ae.LogLevel.Trace&&Re.push(new ae.ConsoleLogger(Se));const Ae=this._register(new ae.MultiplexLogService(Re));re.set(ae.ILogService,Ae);const Fe=this._register(new g.FileService(Ae));re.set(a.IFileService,Fe);const xe=this._register(new C.DiskFileSystemProvider(Ae));Fe.registerProvider(d.Schemas.file,xe);const x=new J.StateService(ce,Ae,Fe);re.set(_.IStateService,x);const G=new j.UriIdentityService(Fe);re.set(V.IUriIdentityService,G);const H=new oe.UserDataProfilesService(x,G,ce,Fe,Ae);re.set(te.IUserDataProfilesService,H);const de=v.isWindows&&he.win32RegValueName?this._register(new se.NativePolicyService(he.win32RegValueName)):ce.policyFile?this._register(new me.FilePolicyService(ce.policyFile,Fe,Ae)):new ue.NullPolicyService;re.set(ue.IPolicyService,de);const pe=this._register(new w.ConfigurationService(H.defaultProfile.settingsResource,Fe,de,Ae));re.set(p.IConfigurationService,pe),await Promise.all([x.init(),pe.initialize()]),H.setEnablement(he.quality!=="stable"||pe.getValue(te.PROFILES_ENABLEMENT_CONFIG)),re.set(V.IUriIdentityService,new j.UriIdentityService(Fe)),re.set(T.IRequestService,new N.SyncDescriptor(z.RequestService,void 0,!0)),re.set(E.IDownloadService,new N.SyncDescriptor(c.DownloadService,void 0,!0)),re.set(t.IExtensionsProfileScannerService,new N.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),re.set(r.IExtensionsScannerService,new N.SyncDescriptor(u.ExtensionsScannerService,void 0,!0)),re.set(i.IExtensionSignatureVerificationService,new N.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),re.set(o.INativeServerExtensionManagementService,new N.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),re.set(s.IExtensionGalleryService,new N.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),re.set(X.ILanguagePackService,new N.SyncDescriptor(ne.NativeLanguagePackService,void 0,!1));const De=[],we=(0,b.isInternalTelemetry)(he,pe);if((0,b.supportsTelemetry)(he,ce)){he.aiConfig&&he.aiConfig.ariaKey&&De.push(new A.OneDataSystemAppender(we,"monacoworkbench",null,he.aiConfig.ariaKey));const{installSourcePath:ke}=ce,Ie={appenders:De,sendErrorTelemetry:!1,commonProperties:(async()=>{let Le;try{const Ne=await P.Promises.readFile(ce.stateResource.fsPath);Le=JSON.parse(Ne.toString())[ee.machineIdKey]}catch(Ne){Ne.code!=="ENOENT"&&Ae.error(Ne)}return(0,q.resolveCommonProperties)(Fe,(0,k.release)(),(0,k.hostname)(),process.arch,he.commit,he.version,Le,we,ke)})(),piiPaths:(0,b.getPiiPathsFromEnvironment)(ce)};re.set(ee.ITelemetryService,new N.SyncDescriptor(U.TelemetryService,[Ie],!1))}else re.set(ee.ITelemetryService,b.NullTelemetryService);return[new B.InstantiationService(re),De]}registerErrorHandler(re){(0,O.setUnexpectedErrorHandler)(he=>{const ce=(0,L.toErrorMessage)(he,!0);!ce||re.error(`[uncaught exception in CLI]: ${ce}`)}),process.on("uncaughtException",he=>(0,O.onUnexpectedError)(he)),process.on("unhandledRejection",he=>(0,O.onUnexpectedError)(he))}async doRun(re,he,ce,Se){const Re=(re.args.profile?ce.profiles.find(Ae=>Ae.name===re.args.profile)??ce.defaultProfile:ce.defaultProfile).extensionsResource;if(this.argv["install-source"])return this.setInstallSource(re,he,this.argv["install-source"]);if(this.argv["list-extensions"])return Se.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,Re);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Ae={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Re};return Se.createInstance(n.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Ae,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Se.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Re);if(this.argv["locate-extension"])return Se.createInstance(n.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(re.appRoot,re.extensionsPath))}}asExtensionIdOrVSIX(re){return re.map(he=>/\.vsix$/i.test(he)?m.URI.file((0,l.isAbsolute)(he)?he:(0,l.join)((0,S.cwd)(),he)):he)}async setInstallSource(re,he,ce){await he.writeFile(m.URI.file(re.installSourcePath),D.VSBuffer.fromString(ce.slice(0,30)))}}async function ve(le){const re=new fe(le);try{await re.run()}finally{re.dispose()}}e.main=ve})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef415578d1b1019db585718968a303eeca4b8979/core/vs/code/node/cliProcessMain.js.map
