/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(Z){for(var e=[],c=0,t=Z.length;c<t;c++)e[c]=_e[Z[c]];return e};define(_e[77],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(P){return P?P.replace(/\$\((.*?)\)/g,(y,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(y,k,S){this.id=y,this.definition=k,this.description=S,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function k(A){if(A instanceof t)return["codicon","codicon-"+A.id];const T=y.exec(A.id);if(!T)return k(t.error);const[,E,_]=T,w=["codicon","codicon-"+E];return _&&w.push("codicon-modifier-"+_.substring(1)),w}P.asClassNameArray=k;function S(A){return k(A).join(" ")}P.asClassName=S;function C(A){return"."+k(A).join(".")}P.asCSSSelector=C})(I=e.CSSIcon||(e.CSSIcon={}))}),define(_e[78],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(y,k){const S=Object.create(null);for(const C of y){const A=k(C);let T=S[A];T||(T=S[A]=[]),T.push(C)}return S}e.groupBy=c;function t(y,k){const S=[],C=[];for(const A of y)k.has(A)||S.push(A);for(const A of k)y.has(A)||C.push(A);return{removed:S,added:C}}e.diffSets=t;function I(y,k){const S=[],C=[];for(const[A,T]of y)k.has(A)||S.push(T);for(const[A,T]of k)y.has(A)||C.push(T);return{removed:S,added:C}}e.diffMaps=I;class P{constructor(){this.map=new Map}add(k,S){let C=this.map.get(k);C||(C=new Set,this.map.set(k,C)),C.add(S)}delete(k,S){const C=this.map.get(k);!C||(C.delete(S),C.size===0&&this.map.delete(k))}forEach(k,S){const C=this.map.get(k);!C||C.forEach(S)}}e.SetMap=P}),define(_e[60],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(y){return(k,S,C)=>{let A=null,T=null;if(typeof C.value=="function"?(A="value",T=C.value):typeof C.get=="function"&&(A="get",T=C.get),!T)throw new Error("not supported");C[A]=y(T,S)}}function t(y,k,S){let C=null,A=null;if(typeof S.value=="function"?(C="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",A=S.get),!A)throw new Error("not supported");const T=`$memoize$${k}`;S[C]=function(...E){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[T]}}e.memoize=t;function I(y,k,S){return c((C,A)=>{const T=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(..._){this[E]||(this[E]=S?S():void 0),clearTimeout(this[T]),k&&(this[E]=k(this[E],..._),_=[this[E]]),this[T]=setTimeout(()=>{C.apply(this,_),this[E]=S?S():void 0},y)}})}e.debounce=I;function P(y,k,S){return c((C,A)=>{const T=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,_=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[E]||(this[E]=S?S():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...h)),this[w])return;const g=this[_]+y;g<=Date.now()?(this[_]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0):(this[w]=!0,this[T]=setTimeout(()=>{this[w]=!1,this[_]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=P}),define(_e[10],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?m.isErrorNoTelemetry(r)?new m(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=c,e.errorHandler=new c;function t(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=t;function I(v){S(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=I;function P(v){S(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=P;function y(v){if(v instanceof Error){const{name:r,message:o}=v,l=v.stacktrace||v.stack;return{$isError:!0,name:r,message:o,stack:l,noTelemetry:m.isErrorNoTelemetry(v)}}return v}e.transformErrorForSerialization=y;const k="Canceled";function S(v){return v instanceof C?!0:v instanceof Error&&v.name===k&&v.message===k}e.isCancellationError=S;class C extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=C;function A(){const v=new Error(k);return v.name=v.message,v}e.canceled=A;function T(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=T;function E(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=E;function _(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=_;function w(v){const r=new Error(`${v} has been disposed`);return r.name="DISPOSED",r}e.disposed=w;function h(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=h;class g extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=g;class f extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=f;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class m extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof m)return r;const o=new m;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class d extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(_e[17],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(ne,ce=0){return ne[ne.length-(1+ce)]}e.tail=t;function I(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.tail2=I;function P(ne,ce,fe=(J,ie)=>J===ie){if(ne===ce)return!0;if(!ne||!ce||ne.length!==ce.length)return!1;for(let J=0,ie=ne.length;J<ie;J++)if(!fe(ne[J],ce[J]))return!1;return!0}e.equals=P;function y(ne,ce){const fe=ne.length-1;ce<fe&&(ne[ce]=ne[fe]),ne.pop()}e.removeFastWithoutKeepingOrder=y;function k(ne,ce,fe){return S(ne.length,J=>fe(ne[J],ce))}e.binarySearch=k;function S(ne,ce){let fe=0,J=ne-1;for(;fe<=J;){const ie=(fe+J)/2|0,te=ce(ie);if(te<0)fe=ie+1;else if(te>0)J=ie-1;else return ie}return-(fe+1)}e.binarySearch2=S;function C(ne,ce){let fe=0,J=ne.length;if(J===0)return 0;for(;fe<J;){const ie=Math.floor((fe+J)/2);ce(ne[ie])?J=ie:fe=ie+1}return fe}e.findFirstInSorted=C;function A(ne,ce,fe){if(ne=ne|0,ne>=ce.length)throw new TypeError("invalid index");const J=ce[Math.floor(ce.length*Math.random())],ie=[],te=[],O=[];for(const W of ce){const q=fe(W,J);q<0?ie.push(W):q>0?te.push(W):O.push(W)}return ne<ie.length?A(ne,ie,fe):ne<ie.length+O.length?O[0]:A(ne-(ie.length+O.length),te,fe)}e.quickSelect=A;function T(ne,ce){const fe=[];let J;for(const ie of ne.slice(0).sort(ce))!J||ce(J[0],ie)!==0?(J=[ie],fe.push(J)):J.push(ie);return fe}e.groupBy=T;function E(ne,ce,fe){const J=[];function ie(W,q,X){if(q===0&&X.length===0)return;const ae=J[J.length-1];ae&&ae.start+ae.deleteCount===W?(ae.deleteCount+=q,ae.toInsert.push(...X)):J.push({start:W,deleteCount:q,toInsert:X})}let te=0,O=0;for(;;){if(te===ne.length){ie(te,0,ce.slice(O));break}if(O===ce.length){ie(te,ne.length-te,[]);break}const W=ne[te],q=ce[O],X=fe(W,q);X===0?(te+=1,O+=1):X<0?(ie(te,1,[]),te+=1):X>0&&(ie(te,0,[q]),O+=1)}return J}e.sortedDiff=E;function _(ne,ce,fe){const J=E(ne,ce,fe),ie=[],te=[];for(const O of J)ie.push(...ne.slice(O.start,O.start+O.deleteCount)),te.push(...O.toInsert);return{removed:ie,added:te}}e.delta=_;function w(ne,ce,fe){if(fe===0)return[];const J=ne.slice(0,fe).sort(ce);return g(ne,ce,J,fe,ne.length),J}e.top=w;function h(ne,ce,fe,J,ie){return fe===0?Promise.resolve([]):new Promise((te,O)=>{(async()=>{const W=ne.length,q=ne.slice(0,fe).sort(ce);for(let X=fe,ae=Math.min(fe+J,W);X<W;X=ae,ae=Math.min(ae+J,W)){if(X>fe&&await new Promise(ve=>setTimeout(ve)),ie&&ie.isCancellationRequested)throw new c.CancellationError;g(ne,ce,q,X,ae)}return q})().then(te,O)})}e.topAsync=h;function g(ne,ce,fe,J,ie){for(const te=fe.length;J<ie;J++){const O=ne[J];if(ce(O,fe[te-1])<0){fe.pop();const W=C(fe,q=>ce(O,q)<0);fe.splice(W,0,O)}}}function f(ne){return ne.filter(ce=>!!ce)}e.coalesce=f;function b(ne){let ce=0;for(let fe=0;fe<ne.length;fe++)ne[fe]&&(ne[ce]=ne[fe],ce+=1);ne.length=ce}e.coalesceInPlace=b;function m(ne,ce,fe){ne.splice(fe,0,ne.splice(ce,1)[0])}e.move=m;function d(ne){return!Array.isArray(ne)||ne.length===0}e.isFalsyOrEmpty=d;function v(ne){return Array.isArray(ne)&&ne.length>0}e.isNonEmptyArray=v;function r(ne,ce=fe=>fe){const fe=new Set;return ne.filter(J=>{const ie=ce(J);return fe.has(ie)?!1:(fe.add(ie),!0)})}e.distinct=r;function o(ne){const ce=new Set;return fe=>{const J=ne(fe);return ce.has(J)?!1:(ce.add(J),!0)}}e.uniqueFilter=o;function l(ne,ce){const fe=s(ne,ce);if(fe!==-1)return ne[fe]}e.findLast=l;function s(ne,ce){for(let fe=ne.length-1;fe>=0;fe--){const J=ne[fe];if(ce(J))return fe}return-1}e.lastIndex=s;function a(ne,ce){return ne.length>0?ne[0]:ce}e.firstOrDefault=a;function u(ne,ce){return ne.length>0?ne[ne.length-1]:ce}e.lastOrDefault=u;function n(ne,ce,fe=(J,ie)=>J===ie){let J=0;for(let ie=0,te=Math.min(ne.length,ce.length);ie<te&&fe(ne[ie],ce[ie]);ie++)J++;return J}e.commonPrefixLength=n;function i(ne){return[].concat(...ne)}e.flatten=i;function p(ne,ce){let fe=typeof ce=="number"?ne:0;typeof ce=="number"?fe=ne:(fe=0,ce=ne);const J=[];if(fe<=ce)for(let ie=fe;ie<ce;ie++)J.push(ie);else for(let ie=fe;ie>ce;ie--)J.push(ie);return J}e.range=p;function D(ne,ce,fe){return ne.reduce((J,ie)=>(J[ce(ie)]=fe?fe(ie):ie,J),Object.create(null))}e.index=D;function R(ne,ce){return ne.push(ce),()=>N(ne,ce)}e.insert=R;function N(ne,ce){const fe=ne.indexOf(ce);if(fe>-1)return ne.splice(fe,1),ce}e.remove=N;function V(ne,ce,fe){const J=ne.slice(0,ce),ie=ne.slice(ce);return J.concat(fe,ie)}e.arrayInsert=V;function x(ne,ce){let fe;if(typeof ce=="number"){let J=ce;fe=()=>{const ie=Math.sin(J++)*179426549;return ie-Math.floor(ie)}}else fe=Math.random;for(let J=ne.length-1;J>0;J-=1){const ie=Math.floor(fe()*(J+1)),te=ne[J];ne[J]=ne[ie],ne[ie]=te}}e.shuffle=x;function L(ne,ce){const fe=ne.indexOf(ce);fe>-1&&(ne.splice(fe,1),ne.unshift(ce))}e.pushToStart=L;function U(ne,ce){const fe=ne.indexOf(ce);fe>-1&&(ne.splice(fe,1),ne.push(ce))}e.pushToEnd=U;function F(ne,ce){for(const fe of ce)ne.push(fe)}e.pushMany=F;function B(ne,ce){return Array.isArray(ne)?ne.map(ce):ce(ne)}e.mapArrayOrNot=B;function M(ne){return Array.isArray(ne)?ne:[ne]}e.asArray=M;function z(ne){return ne[Math.floor(Math.random()*ne.length)]}e.getRandomElement=z;function j(ne,ce){for(const fe of ne){const J=ce(fe);if(J!==void 0)return J}}e.mapFind=j;function $(ne,ce,fe){const J=K(ne,ce),ie=ne.length,te=fe.length;ne.length=ie+te;for(let O=ie-1;O>=J;O--)ne[O+te]=ne[O];for(let O=0;O<te;O++)ne[O+J]=fe[O]}e.insertInto=$;function Q(ne,ce,fe,J){const ie=K(ne,ce),te=ne.splice(ie,fe);return $(ne,ie,J),te}e.splice=Q;function K(ne,ce){return ce<0?Math.max(ce+ne.length,0):Math.min(ce,ne.length)}var ue;(function(ne){function ce(ie){return ie<0}ne.isLessThan=ce;function fe(ie){return ie>0}ne.isGreaterThan=fe;function J(ie){return ie===0}ne.isNeitherLessOrGreaterThan=J,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(ue=e.CompareResult||(e.CompareResult={}));function re(ne,ce){return(fe,J)=>ce(ne(fe),ne(J))}e.compareBy=re;function de(...ne){return(ce,fe)=>{for(const J of ne){const ie=J(ce,fe);if(!ue.isNeitherLessOrGreaterThan(ie))return ie}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=de;const Y=(ne,ce)=>ne-ce;e.numberComparator=Y;function pe(ne,ce){if(ne.length===0)return;let fe=ne[0];for(let J=1;J<ne.length;J++){const ie=ne[J];ce(ie,fe)>0&&(fe=ie)}return fe}e.findMaxBy=pe;function be(ne,ce){if(ne.length===0)return;let fe=ne[0];for(let J=1;J<ne.length;J++){const ie=ne[J];ce(ie,fe)>=0&&(fe=ie)}return fe}e.findLastMaxBy=be;function Ce(ne,ce){return pe(ne,(fe,J)=>-ce(fe,J))}e.findMinBy=Ce;class Re{constructor(ce){this.items=ce,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ce){let fe=this.firstIdx;for(;fe<this.items.length&&ce(this.items[fe]);)fe++;const J=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,J}takeFromEndWhile(ce){let fe=this.lastIdx;for(;fe>=0&&ce(this.items[fe]);)fe--;const J=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,J}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ce=this.items[this.firstIdx];return this.firstIdx++,ce}removeLast(){const ce=this.items[this.lastIdx];return this.lastIdx--,ce}takeCount(ce){const fe=this.items.slice(this.firstIdx,this.firstIdx+ce);return this.firstIdx+=ce,fe}}e.ArrayQueue=Re;class We{constructor(ce){this.iterate=ce}forEach(ce){this.iterate(fe=>(ce(fe),!0))}toArray(){const ce=[];return this.iterate(fe=>(ce.push(fe),!0)),ce}filter(ce){return new We(fe=>this.iterate(J=>ce(J)?fe(J):!0))}map(ce){return new We(fe=>this.iterate(J=>fe(ce(J))))}some(ce){let fe=!1;return this.iterate(J=>(fe=ce(J),!fe)),fe}findFirst(ce){let fe;return this.iterate(J=>ce(J)?(fe=J,!1):!0),fe}findLast(ce){let fe;return this.iterate(J=>(ce(J)&&(fe=J),!0)),fe}findLastMaxBy(ce){let fe,J=!0;return this.iterate(ie=>((J||ue.isGreaterThan(ce(ie,fe)))&&(J=!1,fe=ie),!0)),fe}}e.CallbackIterable=We,We.empty=new We(ne=>{})}),define(_e[48],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function I(S,C="Unreachable"){throw new Error(C)}e.assertNever=I;function P(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=P;function y(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function k(S,C){let A=0;for(;A<S.length-1;){const T=S[A],E=S[A+1];if(!C(T,E))return!1;A++}return!0}e.checkAdjacentItems=k}),define(_e[61],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const I=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(I,arguments)),y}}e.once=c}),define(_e[99],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(_e[62],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function I(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=I;const P=Object.freeze([]);function y(){return P}t.empty=y;function*k(d){yield d}t.single=k;function S(d){return I(d)?d:k(d)}t.wrap=S;function C(d){return d||P}t.from=C;function A(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=A;function T(d){return d[Symbol.iterator]().next().value}t.first=T;function E(d,v){for(const r of d)if(v(r))return!0;return!1}t.some=E;function _(d,v){for(const r of d)if(v(r))return r}t.find=_;function*w(d,v){for(const r of d)v(r)&&(yield r)}t.filter=w;function*h(d,v){let r=0;for(const o of d)yield v(o,r++)}t.map=h;function*g(...d){for(const v of d)for(const r of v)yield r}t.concat=g;function f(d,v,r){let o=r;for(const l of d)o=v(o,l);return o}t.reduce=f;function*b(d,v,r=d.length){for(v<0&&(v+=d.length),r<0?r+=d.length:r>d.length&&(r=d.length);v<r;v++)yield d[v]}t.slice=b;function m(d,v=Number.POSITIVE_INFINITY){const r=[];if(v===0)return[r,d];const o=d[Symbol.iterator]();for(let l=0;l<v;l++){const s=o.next();if(s.done)return[r,t.empty()];r.push(s.value)}return[r,{[Symbol.iterator](){return o}}]}t.consume=m})(c=e.Iterable||(e.Iterable={}))}),define(_e[144],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(r){r.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(r,o=!1){let l=0;const s=r.length;let a="",u=0,n=16,i=0;function p(U){let F=0,B=0;for(;F<U;){const M=r.charCodeAt(l);if(M>=48&&M<=57)B=B*16+M-48;else if(M>=65&&M<=70)B=B*16+M-65+10;else if(M>=97&&M<=102)B=B*16+M-97+10;else break;l++,F++}return F<U&&(B=-1),B}function D(U){l=U,a="",u=0,n=16,i=0}function R(){const U=l;if(r.charCodeAt(l)===48)l++;else for(l++;l<r.length&&C(r.charCodeAt(l));)l++;if(l<r.length&&r.charCodeAt(l)===46)if(l++,l<r.length&&C(r.charCodeAt(l)))for(l++;l<r.length&&C(r.charCodeAt(l));)l++;else return i=3,r.substring(U,l);let F=l;if(l<r.length&&(r.charCodeAt(l)===69||r.charCodeAt(l)===101))if(l++,(l<r.length&&r.charCodeAt(l)===43||r.charCodeAt(l)===45)&&l++,l<r.length&&C(r.charCodeAt(l))){for(l++;l<r.length&&C(r.charCodeAt(l));)l++;F=l}else i=3;return r.substring(U,F)}function N(){let U="",F=l;for(;;){if(l>=s){U+=r.substring(F,l),i=2;break}const B=r.charCodeAt(l);if(B===34){U+=r.substring(F,l),l++;break}if(B===92){if(U+=r.substring(F,l),l++,l>=s){i=2;break}switch(r.charCodeAt(l++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const z=p(4);z>=0?U+=String.fromCharCode(z):i=4;break}default:i=5}F=l;continue}if(B>=0&&B<=31)if(S(B)){U+=r.substring(F,l),i=2;break}else i=6;l++}return U}function V(){if(a="",i=0,u=l,l>=s)return u=s,n=17;let U=r.charCodeAt(l);if(k(U)){do l++,a+=String.fromCharCode(U),U=r.charCodeAt(l);while(k(U));return n=15}if(S(U))return l++,a+=String.fromCharCode(U),U===13&&r.charCodeAt(l)===10&&(l++,a+=`
`),n=14;switch(U){case 123:return l++,n=1;case 125:return l++,n=2;case 91:return l++,n=3;case 93:return l++,n=4;case 58:return l++,n=6;case 44:return l++,n=5;case 34:return l++,a=N(),n=10;case 47:{const F=l-1;if(r.charCodeAt(l+1)===47){for(l+=2;l<s&&!S(r.charCodeAt(l));)l++;return a=r.substring(F,l),n=12}if(r.charCodeAt(l+1)===42){l+=2;const B=s-1;let M=!1;for(;l<B;){if(r.charCodeAt(l)===42&&r.charCodeAt(l+1)===47){l+=2,M=!0;break}l++}return M||(l++,i=1),a=r.substring(F,l),n=13}return a+=String.fromCharCode(U),l++,n=16}case 45:if(a+=String.fromCharCode(U),l++,l===s||!C(r.charCodeAt(l)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),n=11;default:for(;l<s&&x(U);)l++,U=r.charCodeAt(l);if(u!==l){switch(a=r.substring(u,l),a){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return a+=String.fromCharCode(U),l++,n=16}}function x(U){if(k(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=V();while(U>=12&&U<=15);return U}return{setPosition:D,getPosition:()=>l,scan:o?L:V,getToken:()=>n,getTokenValue:()=>a,getTokenOffset:()=>u,getTokenLength:()=>l-u,getTokenError:()=>i}}e.createScanner=y;function k(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function T(r,o){const l=[],s=new Object;let a;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(p,D,R,N){u.value=p,u.offset=D,u.length=R,u.type=N,u.colonOffset=void 0,a=u}try{m(r,{onObjectBegin:(p,D)=>{if(o<=p)throw s;a=void 0,n=o>p,l.push("")},onObjectProperty:(p,D,R)=>{if(o<D||(i(p,D,R,"property"),l[l.length-1]=p,o<=D+R))throw s},onObjectEnd:(p,D)=>{if(o<=p)throw s;a=void 0,l.pop()},onArrayBegin:(p,D)=>{if(o<=p)throw s;a=void 0,l.push(0)},onArrayEnd:(p,D)=>{if(o<=p)throw s;a=void 0,l.pop()},onLiteralValue:(p,D,R)=>{if(o<D||(i(p,D,R,v(p)),o<=D+R))throw s},onSeparator:(p,D,R)=>{if(o<=D)throw s;if(p===":"&&a&&a.type==="property")a.colonOffset=D,n=!1,a=void 0;else if(p===","){const N=l[l.length-1];typeof N=="number"?l[l.length-1]=N+1:(n=!0,l[l.length-1]=""),a=void 0}}})}catch(p){if(p!==s)throw p}return{path:l,previousNode:a,isAtPropertyKey:n,matches:p=>{let D=0;for(let R=0;D<p.length&&R<l.length;R++)if(p[D]===l[R]||p[D]==="*")D++;else if(p[D]!=="**")return!1;return D===p.length}}}e.getLocation=T;function E(r,o=[],l=P.DEFAULT){let s=null,a=[];const u=[];function n(p){Array.isArray(a)?a.push(p):s!==null&&(a[s]=p)}return m(r,{onObjectBegin:()=>{const p={};n(p),u.push(a),a=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{const p=[];n(p),u.push(a),a=p,s=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:n,onError:(p,D,R)=>{o.push({error:p,offset:D,length:R})}},l),a[0]}e.parse=E;function _(r,o=[],l=P.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){s.type==="property"&&(s.length=p-s.offset,s=s.parent)}function u(p){return s.children.push(p),p}m(r,{onObjectBegin:p=>{s=u({type:"object",offset:p,length:-1,parent:s,children:[]})},onObjectProperty:(p,D,R)=>{s=u({type:"property",offset:D,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:p,offset:D,length:R,parent:s})},onObjectEnd:(p,D)=>{s.length=p+D-s.offset,s=s.parent,a(p+D)},onArrayBegin:(p,D)=>{s=u({type:"array",offset:p,length:-1,parent:s,children:[]})},onArrayEnd:(p,D)=>{s.length=p+D-s.offset,s=s.parent,a(p+D)},onLiteralValue:(p,D,R)=>{u({type:v(p),offset:D,length:R,parent:s,value:p}),a(D+R)},onSeparator:(p,D,R)=>{s.type==="property"&&(p===":"?s.colonOffset=D:p===","&&a(D))},onError:(p,D,R)=>{o.push({error:p,offset:D,length:R})}},l);const i=s.children[0];return i&&delete i.parent,i}e.parseTree=_;function w(r,o){if(!r)return;let l=r;for(const s of o)if(typeof s=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let a=!1;for(const u of l.children)if(Array.isArray(u.children)&&u.children[0].value===s){l=u.children[1],a=!0;break}if(!a)return}else{const a=s;if(l.type!=="array"||a<0||!Array.isArray(l.children)||a>=l.children.length)return;l=l.children[a]}return l}e.findNodeAtLocation=w;function h(r){if(!r.parent||!r.parent.children)return[];const o=h(r.parent);if(r.parent.type==="property"){const l=r.parent.children[0].value;o.push(l)}else if(r.parent.type==="array"){const l=r.parent.children.indexOf(r);l!==-1&&o.push(l)}return o}e.getNodePath=h;function g(r){switch(r.type){case"array":return r.children.map(g);case"object":{const o=Object.create(null);for(const l of r.children){const s=l.children[1];s&&(o[l.children[0].value]=g(s))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=g;function f(r,o,l=!1){return o>=r.offset&&o<r.offset+r.length||l&&o===r.offset+r.length}e.contains=f;function b(r,o,l=!1){if(f(r,o,l)){const s=r.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=o;a++){const u=b(s[a],o,l);if(u)return u}return r}}e.findNodeAtOffset=b;function m(r,o,l=P.DEFAULT){const s=y(r,!1);function a(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function u(re){return re?de=>re(de,s.getTokenOffset(),s.getTokenLength()):()=>!0}const n=a(o.onObjectBegin),i=u(o.onObjectProperty),p=a(o.onObjectEnd),D=a(o.onArrayBegin),R=a(o.onArrayEnd),N=u(o.onLiteralValue),V=u(o.onSeparator),x=a(o.onComment),L=u(o.onError),U=l&&l.disallowComments,F=l&&l.allowTrailingComma;function B(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:U||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(re){case 12:case 13:U?M(10):x();break;case 16:M(1);break;case 15:case 14:break;default:return re}}}function M(re,de=[],Y=[]){if(L(re),de.length+Y.length>0){let pe=s.getToken();for(;pe!==17;){if(de.indexOf(pe)!==-1){B();break}else if(Y.indexOf(pe)!==-1)break;pe=B()}}}function z(re){const de=s.getTokenValue();return re?N(de):i(de),B(),!0}function j(){switch(s.getToken()){case 11:{let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(M(2),re=0)}catch{M(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return B(),!0}function $(){return s.getToken()!==10?(M(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(V(":"),B(),ue()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function Q(){n(),B();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||M(4,[],[]),V(","),B(),s.getToken()===2&&F)break}else re&&M(6,[],[]);$()||M(4,[],[2,5]),re=!0}return p(),s.getToken()!==2?M(7,[2],[]):B(),!0}function K(){D(),B();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||M(4,[],[]),V(","),B(),s.getToken()===4&&F)break}else re&&M(6,[],[]);ue()||M(4,[],[4,5]),re=!0}return R(),s.getToken()!==4?M(8,[4],[]):B(),!0}function ue(){switch(s.getToken()){case 3:return K();case 1:return Q();case 10:return z(!0);default:return j()}}return B(),s.getToken()===17?l.allowEmptyContent?!0:(M(4,[],[]),!1):ue()?(s.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function d(r,o){const l=y(r),s=[];let a,u=0,n;do switch(n=l.getPosition(),a=l.scan(),a){case 12:case 13:case 17:u!==n&&s.push(r.substring(u,n)),o!==void 0&&s.push(l.getTokenValue().replace(/[^\r\n]/g,o)),u=l.getPosition();break}while(a!==17);return s.join("")}e.stripComments=d;function v(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(_e[79],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new c(()=>I(this.getValue()))}}e.Lazy=c}),define(_e[6],ye([1,0,61,62]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let P=null;function y(u){P=u}if(e.setDisposableTracker=y,I){const u="__is_disposable_tracked__";y(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[u]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==b.None)try{n[u]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[u]=!0}catch{}}markAsSingleton(n){}})}function k(u){return P?.trackDisposable(u),u}function S(u){P?.markAsDisposed(u)}function C(u,n){P?.setParent(u,n)}function A(u,n){if(!!P)for(const i of u)P.setParent(i,n)}function T(u){return P?.markAsSingleton(u),u}e.markAsSingleton=T;function E(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=E;function _(u){if(t.Iterable.is(u)){const n=[];for(const i of u)if(i)try{i.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=_;function w(u){for(const n of u)E(n)&&n.dispose();return[]}e.disposeIfDisposable=w;function h(...u){const n=g(()=>_(u));return A(u,n),n}e.combinedDisposable=h;function g(u){const n=k({dispose:(0,c.once)(()=>{S(n),u()})});return n}e.toDisposable=g;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new f,k(this),C(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&C(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&C(n,null),n}}e.MutableDisposable=m;class d{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=v;class r{constructor(){this.references=new Map}acquire(n,...i){let p=this.references.get(n);p||(p={counter:0,object:this.createReferencedObject(n,...i)},this.references.set(n,p));const{object:D}=p,R=(0,c.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(n,p.object),this.references.delete(n))});return p.counter++,{object:D,dispose:R}}}e.ReferenceCollection=r;class o{constructor(n){this.referenceCollection=n}async acquire(n,...i){const p=this.referenceCollection.acquire(n,...i);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(D){throw p.dispose(),D}}}e.AsyncReferenceCollection=o;class l{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=l;function s(u){const n=new f;try{u(n)}finally{n.dispose()}}e.disposeOnReturn=s;class a{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,i,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(n)?.dispose(),this._store.set(n,i)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(_e[63],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(P){this.element=P,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let P=this._first;for(;P!==c.Undefined;){const y=P.next;P.prev=c.Undefined,P.next=c.Undefined,P=y}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const k=new c(P);if(this._first===c.Undefined)this._first=k,this._last=k;else if(y){const C=this._last;this._last=k,k.prev=C,C.next=k}else{const C=this._first;this._first=k,k.next=C,C.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==c.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==c.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==c.Undefined&&P.next!==c.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===c.Undefined&&P.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):P.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):P.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==c.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),define(_e[28],ye([1,0]),function(Z,e){"use strict";var c,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function P(w,h,g){let f=w.get(h);return f===void 0&&(f=g,w.set(h,f)),f}e.getOrSet=P;function y(w){const h=[];return w.forEach((g,f)=>{h.push(`${f} => ${g}`)}),`Map(${w.size}) {${h.join(", ")}}`}e.mapToString=y;function k(w){const h=[];return w.forEach(g=>{h.push(g)}),`Set(${w.size}) {${h.join(", ")}}`}e.setToString=k;class S{constructor(h,g){this.uri=h,this.value=g}}class C{constructor(h,g){this[c]="ResourceMap",h instanceof C?(this.map=new Map(h.map),this.toKey=g??C.defaultToKey):(this.map=new Map,this.toKey=h??C.defaultToKey)}set(h,g){return this.map.set(this.toKey(h),new S(h,g)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,g){typeof g<"u"&&(h=h.bind(g));for(const[f,b]of this.map)h(b.value,b.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=C,C.defaultToKey=w=>w.toString();class A{constructor(h,g){this[t]="ResourceSet",!h||typeof h=="function"?this._map=new C(h):(this._map=new C(g),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,g){this._map.forEach((f,b)=>h.call(g,b,b,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=A;var T;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,g=0){const f=this._map.get(h);if(!!f)return g!==0&&this.touch(f,g),f.value}set(h,g,f=0){let b=this._map.get(h);if(b)b.value=g,f!==0&&this.touch(b,f);else{switch(b={key:h,value:g,next:void 0,previous:void 0},f){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(h,b),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const g=this._map.get(h);if(!!g)return this._map.delete(h),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,g){const f=this._state;let b=this._head;for(;b;){if(g?h.bind(g)(b.value,b.key,this):h(b.value,b.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const h=this,g=this._state;let f=this._head;const b={[Symbol.iterator](){return b},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.key,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return b}values(){const h=this,g=this._state;let f=this._head;const b={[Symbol.iterator](){return b},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:f.value,done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return b}entries(){const h=this,g=this._state;let f=this._head;const b={[Symbol.iterator](){return b},next(){if(h._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const m={value:[f.key,f.value],done:!1};return f=f.next,m}else return{value:void 0,done:!0}}};return b}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let g=this._head,f=this.size;for(;g&&f>h;)this._map.delete(g.key),g=g.next,f--;this._head=g,this._size=f,g&&(g.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const g=h.next,f=h.previous;if(!g||!f)throw new Error("Invalid list");g.previous=f,f.next=g}h.next=void 0,h.previous=void 0,this._state++}touch(h,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(h===this._head)return;const f=h.next,b=h.previous;h===this._tail?(b.next=void 0,this._tail=b):(f.previous=b,b.next=f),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(g===2){if(h===this._tail)return;const f=h.next,b=h.previous;h===this._head?(f.previous=void 0,this._head=f):(f.previous=b,b.next=f),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((g,f)=>{h.push([f,g])}),h}fromJSON(h){this.clear();for(const[g,f]of h)this.set(g,f)}}e.LinkedMap=E;class _ extends E{constructor(h,g=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,g=2){return super.get(h,g)}peek(h){return super.get(h,0)}set(h,g){return super.set(h,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_}),function(Z,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(_e[145],ye([0]),e):(Z=typeof globalThis<"u"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ne,ce){for(var fe=0;fe<ce.length;fe++){var J=ce[fe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ne,J.key,J)}}function c(ne,ce,fe){return ce&&e(ne.prototype,ce),fe&&e(ne,fe),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function t(ne,ce){if(!!ne){if(typeof ne=="string")return I(ne,ce);var fe=Object.prototype.toString.call(ne).slice(8,-1);if(fe==="Object"&&ne.constructor&&(fe=ne.constructor.name),fe==="Map"||fe==="Set")return Array.from(ne);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return I(ne,ce)}}function I(ne,ce){(ce==null||ce>ne.length)&&(ce=ne.length);for(var fe=0,J=new Array(ce);fe<ce;fe++)J[fe]=ne[fe];return J}function P(ne,ce){var fe=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(fe)return(fe=fe.call(ne)).next.bind(fe);if(Array.isArray(ne)||(fe=t(ne))||ce&&ne&&typeof ne.length=="number"){fe&&(ne=fe);var J=0;return function(){return J>=ne.length?{done:!0}:{done:!1,value:ne[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function k(ne){Z.defaults=ne}var S=/[&<>"']/,C=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(ce){return E[ce]};function w(ne,ce){if(ce){if(S.test(ne))return ne.replace(C,_)}else if(A.test(ne))return ne.replace(T,_);return ne}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ne){return ne.replace(h,function(ce,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function b(ne,ce){ne=typeof ne=="string"?ne:ne.source,ce=ce||"";var fe={replace:function(ie,te){return te=te.source||te,te=te.replace(f,"$1"),ne=ne.replace(ie,te),fe},getRegex:function(){return new RegExp(ne,ce)}};return fe}var m=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ne,ce,fe){if(ne){var J;try{J=decodeURIComponent(g(fe)).replace(m,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ce&&!d.test(fe)&&(fe=a(ce,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var r={},o=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ne,ce){r[" "+ne]||(o.test(ne)?r[" "+ne]=ne+"/":r[" "+ne]=p(ne,"/",!0)),ne=r[" "+ne];var fe=ne.indexOf(":")===-1;return ce.substring(0,2)==="//"?fe?ce:ne.replace(l,"$1")+ce:ce.charAt(0)==="/"?fe?ce:ne.replace(s,"$1")+ce:ne+ce}var u={exec:function(){}};function n(ne){for(var ce=1,fe,J;ce<arguments.length;ce++){fe=arguments[ce];for(J in fe)Object.prototype.hasOwnProperty.call(fe,J)&&(ne[J]=fe[J])}return ne}function i(ne,ce){var fe=ne.replace(/\|/g,function(te,O,W){for(var q=!1,X=O;--X>=0&&W[X]==="\\";)q=!q;return q?"|":" |"}),J=fe.split(/ \|/),ie=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ce)J.splice(ce);else for(;J.length<ce;)J.push("");for(;ie<J.length;ie++)J[ie]=J[ie].trim().replace(/\\\|/g,"|");return J}function p(ne,ce,fe){var J=ne.length;if(J===0)return"";for(var ie=0;ie<J;){var te=ne.charAt(J-ie-1);if(te===ce&&!fe)ie++;else if(te!==ce&&fe)ie++;else break}return ne.slice(0,J-ie)}function D(ne,ce){if(ne.indexOf(ce[1])===-1)return-1;for(var fe=ne.length,J=0,ie=0;ie<fe;ie++)if(ne[ie]==="\\")ie++;else if(ne[ie]===ce[0])J++;else if(ne[ie]===ce[1]&&(J--,J<0))return ie;return-1}function R(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(ne,ce){if(ce<1)return"";for(var fe="";ce>1;)ce&1&&(fe+=ne),ce>>=1,ne+=ne;return fe+ne}function V(ne,ce,fe,J){var ie=ce.href,te=ce.title?w(ce.title):null,O=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){J.state.inLink=!0;var W={type:"link",raw:fe,href:ie,title:te,text:O,tokens:J.inlineTokens(O)};return J.state.inLink=!1,W}return{type:"image",raw:fe,href:ie,title:te,text:w(O)}}function x(ne,ce){var fe=ne.match(/^(\s+)(?:```)/);if(fe===null)return ce;var J=fe[1];return ce.split(`
`).map(function(ie){var te=ie.match(/^\s+/);if(te===null)return ie;var O=te[0];return O.length>=J.length?ie.slice(J.length):ie}).join(`
`)}var L=function(){function ne(fe){this.options=fe||Z.defaults}var ce=ne.prototype;return ce.space=function(J){var ie=this.rules.block.newline.exec(J);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},ce.code=function(J){var ie=this.rules.block.code.exec(J);if(ie){var te=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?te:p(te,`
`)}}},ce.fences=function(J){var ie=this.rules.block.fences.exec(J);if(ie){var te=ie[0],O=x(te,ie[3]||"");return{type:"code",raw:te,lang:ie[2]?ie[2].trim():ie[2],text:O}}},ce.heading=function(J){var ie=this.rules.block.heading.exec(J);if(ie){var te=ie[2].trim();if(/#$/.test(te)){var O=p(te,"#");(this.options.pedantic||!O||/ $/.test(O))&&(te=O.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:te,tokens:this.lexer.inline(te)}}},ce.hr=function(J){var ie=this.rules.block.hr.exec(J);if(ie)return{type:"hr",raw:ie[0]}},ce.blockquote=function(J){var ie=this.rules.block.blockquote.exec(J);if(ie){var te=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ce.list=function(J){var ie=this.rules.block.list.exec(J);if(ie){var te,O,W,q,X,ae,ve,Te,ge,ke,De,xe,qe=ie[1].trim(),nt=qe.length>1,Xe={type:"list",raw:"",ordered:nt,start:nt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=nt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=nt?qe:"[*+-]");for(var st=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(xe=!1,!(!(ie=st.exec(J))||this.rules.block.hr.test(J)));){if(te=ie[0],J=J.substring(te.length),Te=ie[2].split(`
`,1)[0],ge=J.split(`
`,1)[0],this.options.pedantic?(q=2,De=Te.trimLeft()):(q=ie[2].search(/[^ ]/),q=q>4?1:q,De=Te.slice(q),q+=ie[1].length),ae=!1,!Te&&/^ *$/.test(ge)&&(te+=ge+`
`,J=J.substring(ge.length+1),xe=!0),!xe)for(var Be=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),oe=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");J&&(ke=J.split(`
`,1)[0],Te=ke,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(Te)||oe.test(Te)||Be.test(Te)||dt.test(J)));){if(Te.search(/[^ ]/)>=q||!Te.trim())De+=`
`+Te.slice(q);else if(!ae)De+=`
`+Te;else break;!ae&&!Te.trim()&&(ae=!0),te+=ke+`
`,J=J.substring(ke.length+1)}Xe.loose||(ve?Xe.loose=!0:/\n *\n *$/.test(te)&&(ve=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(De),O&&(W=O[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:te,task:!!O,checked:W,loose:!1,text:De}),Xe.raw+=te}Xe.items[Xe.items.length-1].raw=te.trimRight(),Xe.items[Xe.items.length-1].text=De.trimRight(),Xe.raw=Xe.raw.trimRight();var Se=Xe.items.length;for(X=0;X<Se;X++){this.lexer.state.top=!1,Xe.items[X].tokens=this.lexer.blockTokens(Xe.items[X].text,[]);var le=Xe.items[X].tokens.filter(function(Le){return Le.type==="space"}),Pe=le.every(function(Le){for(var Fe=Le.raw.split(""),Ge=0,Je=P(Fe),it;!(it=Je()).done;){var vt=it.value;if(vt===`
`&&(Ge+=1),Ge>1)return!0}return!1});!Xe.loose&&le.length&&Pe&&(Xe.loose=!0,Xe.items[X].loose=!0)}return Xe}},ce.html=function(J){var ie=this.rules.block.html.exec(J);if(ie){var te={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ie[0]):w(ie[0]);te.type="paragraph",te.text=O,te.tokens=this.lexer.inline(O)}return te}},ce.def=function(J){var ie=this.rules.block.def.exec(J);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var te=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:ie[0],href:ie[2],title:ie[3]}}},ce.table=function(J){var ie=this.rules.block.table.exec(J);if(ie){var te={type:"table",header:i(ie[1]).map(function(ve){return{text:ve}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=ie[0];var O=te.align.length,W,q,X,ae;for(W=0;W<O;W++)/^ *-+: *$/.test(te.align[W])?te.align[W]="right":/^ *:-+: *$/.test(te.align[W])?te.align[W]="center":/^ *:-+ *$/.test(te.align[W])?te.align[W]="left":te.align[W]=null;for(O=te.rows.length,W=0;W<O;W++)te.rows[W]=i(te.rows[W],te.header.length).map(function(ve){return{text:ve}});for(O=te.header.length,q=0;q<O;q++)te.header[q].tokens=this.lexer.inline(te.header[q].text);for(O=te.rows.length,q=0;q<O;q++)for(ae=te.rows[q],X=0;X<ae.length;X++)ae[X].tokens=this.lexer.inline(ae[X].text);return te}}},ce.lheading=function(J){var ie=this.rules.block.lheading.exec(J);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},ce.paragraph=function(J){var ie=this.rules.block.paragraph.exec(J);if(ie){var te=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:te,tokens:this.lexer.inline(te)}}},ce.text=function(J){var ie=this.rules.block.text.exec(J);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},ce.escape=function(J){var ie=this.rules.inline.escape.exec(J);if(ie)return{type:"escape",raw:ie[0],text:w(ie[1])}},ce.tag=function(J){var ie=this.rules.inline.tag.exec(J);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):w(ie[0]):ie[0]}},ce.link=function(J){var ie=this.rules.inline.link.exec(J);if(ie){var te=ie[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var O=p(te.slice(0,-1),"\\");if((te.length-O.length)%2===0)return}else{var W=D(ie[2],"()");if(W>-1){var q=ie[0].indexOf("!")===0?5:4,X=q+ie[1].length+W;ie[2]=ie[2].substring(0,W),ie[0]=ie[0].substring(0,X).trim(),ie[3]=""}}var ae=ie[2],ve="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ae);Te&&(ae=Te[1],ve=Te[3])}else ve=ie[3]?ie[3].slice(1,-1):"";return ae=ae.trim(),/^</.test(ae)&&(this.options.pedantic&&!/>$/.test(te)?ae=ae.slice(1):ae=ae.slice(1,-1)),V(ie,{href:ae&&ae.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},ce.reflink=function(J,ie){var te;if((te=this.rules.inline.reflink.exec(J))||(te=this.rules.inline.nolink.exec(J))){var O=(te[2]||te[1]).replace(/\s+/g," ");if(O=ie[O.toLowerCase()],!O||!O.href){var W=te[0].charAt(0);return{type:"text",raw:W,text:W}}return V(te,O,te[0],this.lexer)}},ce.emStrong=function(J,ie,te){te===void 0&&(te="");var O=this.rules.inline.emStrong.lDelim.exec(J);if(!!O&&!(O[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=O[1]||O[2]||"";if(!W||W&&(te===""||this.rules.inline.punctuation.exec(te))){var q=O[0].length-1,X,ae,ve=q,Te=0,ge=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ie=ie.slice(-1*J.length+q);(O=ge.exec(ie))!=null;)if(X=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!X){if(ae=X.length,O[3]||O[4]){ve+=ae;continue}else if((O[5]||O[6])&&q%3&&!((q+ae)%3)){Te+=ae;continue}if(ve-=ae,!(ve>0)){if(ae=Math.min(ae,ae+ve+Te),Math.min(q,ae)%2){var ke=J.slice(1,q+O.index+ae);return{type:"em",raw:J.slice(0,q+O.index+ae+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var De=J.slice(2,q+O.index+ae-1);return{type:"strong",raw:J.slice(0,q+O.index+ae+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},ce.codespan=function(J){var ie=this.rules.inline.code.exec(J);if(ie){var te=ie[2].replace(/\n/g," "),O=/[^ ]/.test(te),W=/^ /.test(te)&&/ $/.test(te);return O&&W&&(te=te.substring(1,te.length-1)),te=w(te,!0),{type:"codespan",raw:ie[0],text:te}}},ce.br=function(J){var ie=this.rules.inline.br.exec(J);if(ie)return{type:"br",raw:ie[0]}},ce.del=function(J){var ie=this.rules.inline.del.exec(J);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},ce.autolink=function(J,ie){var te=this.rules.inline.autolink.exec(J);if(te){var O,W;return te[2]==="@"?(O=w(this.options.mangle?ie(te[1]):te[1]),W="mailto:"+O):(O=w(te[1]),W=O),{type:"link",raw:te[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ce.url=function(J,ie){var te;if(te=this.rules.inline.url.exec(J)){var O,W;if(te[2]==="@")O=w(this.options.mangle?ie(te[0]):te[0]),W="mailto:"+O;else{var q;do q=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(q!==te[0]);O=w(te[0]),te[1]==="www."?W="http://"+O:W=O}return{type:"link",raw:te[0],text:O,href:W,tokens:[{type:"text",raw:O,text:O}]}}},ce.inlineText=function(J,ie){var te=this.rules.inline.text.exec(J);if(te){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):w(te[0]):te[0]:O=w(this.options.smartypants?ie(te[0]):te[0]),{type:"text",raw:te[0],text:O}}},ne}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=b(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=b(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=b(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=b(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=b(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=n({},U),U.gfm=n({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=b(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=n({},U.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:b(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=b(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=b(U._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=b(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=b(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=b(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=b(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=b(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=b(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=b(F.reflink).replace("label",F._label).replace("ref",U._label).getRegex(),F.nolink=b(F.nolink).replace("ref",U._label).getRegex(),F.reflinkSearch=b(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:b(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=b(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:b(F.br).replace("{2,}","*").getRegex(),text:b(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(ne){var ce="",fe,J,ie=ne.length;for(fe=0;fe<ie;fe++)J=ne.charCodeAt(fe),Math.random()>.5&&(J="x"+J.toString(16)),ce+="&#"+J+";";return ce}var z=function(){function ne(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||Z.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:F.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=F.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=F.breaks:J.inline=F.gfm),this.tokenizer.rules=J}ne.lex=function(J,ie){var te=new ne(ie);return te.lex(J)},ne.lexInline=function(J,ie){var te=new ne(ie);return te.inlineTokens(J)};var ce=ne.prototype;return ce.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},ce.blockTokens=function(J,ie){var te=this;ie===void 0&&(ie=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ve,Te,ge){return Te+"    ".repeat(ge.length)});for(var O,W,q,X;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(O=ve.call({lexer:te},J,ie))?(J=J.substring(O.raw.length),ie.push(O),!0):!1}))){if(O=this.tokenizer.space(J)){J=J.substring(O.raw.length),O.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(O);continue}if(O=this.tokenizer.code(J)){J=J.substring(O.raw.length),W=ie[ie.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):ie.push(O);continue}if(O=this.tokenizer.fences(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.heading(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.hr(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.blockquote(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.list(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.html(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.def(J)){J=J.substring(O.raw.length),W=ie[ie.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+O.raw,W.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.lheading(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(q=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,Te=J.slice(1),ge=void 0;te.options.extensions.startBlock.forEach(function(ke){ge=ke.call({lexer:this},Te),typeof ge=="number"&&ge>=0&&(ve=Math.min(ve,ge))}),ve<1/0&&ve>=0&&(q=J.substring(0,ve+1))}(),this.state.top&&(O=this.tokenizer.paragraph(q))){W=ie[ie.length-1],X&&W.type==="paragraph"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ie.push(O),X=q.length!==J.length,J=J.substring(O.raw.length);continue}if(O=this.tokenizer.text(J)){J=J.substring(O.raw.length),W=ie[ie.length-1],W&&W.type==="text"?(W.raw+=`
`+O.raw,W.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ie.push(O);continue}if(J){var ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return this.state.top=!0,ie},ce.inline=function(J,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:J,tokens:ie}),ie},ce.inlineTokens=function(J,ie){var te=this;ie===void 0&&(ie=[]);var O,W,q,X=J,ae,ve,Te;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ae=this.tokenizer.rules.inline.reflinkSearch.exec(X))!=null;)ge.includes(ae[0].slice(ae[0].lastIndexOf("[")+1,-1))&&(X=X.slice(0,ae.index)+"["+N("a",ae[0].length-2)+"]"+X.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ae=this.tokenizer.rules.inline.blockSkip.exec(X))!=null;)X=X.slice(0,ae.index)+"["+N("a",ae[0].length-2)+"]"+X.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ae=this.tokenizer.rules.inline.escapedEmSt.exec(X))!=null;)X=X.slice(0,ae.index)+"++"+X.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ve||(Te=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(O=De.call({lexer:te},J,ie))?(J=J.substring(O.raw.length),ie.push(O),!0):!1}))){if(O=this.tokenizer.escape(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.tag(J)){J=J.substring(O.raw.length),W=ie[ie.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ie.push(O);continue}if(O=this.tokenizer.link(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(O.raw.length),W=ie[ie.length-1],W&&O.type==="text"&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ie.push(O);continue}if(O=this.tokenizer.emStrong(J,X,Te)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.codespan(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.br(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.del(J)){J=J.substring(O.raw.length),ie.push(O);continue}if(O=this.tokenizer.autolink(J,M)){J=J.substring(O.raw.length),ie.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(J,M))){J=J.substring(O.raw.length),ie.push(O);continue}if(q=J,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,xe=J.slice(1),qe=void 0;te.options.extensions.startInline.forEach(function(nt){qe=nt.call({lexer:this},xe),typeof qe=="number"&&qe>=0&&(De=Math.min(De,qe))}),De<1/0&&De>=0&&(q=J.substring(0,De+1))}(),O=this.tokenizer.inlineText(q,B)){J=J.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Te=O.raw.slice(-1)),ve=!0,W=ie[ie.length-1],W&&W.type==="text"?(W.raw+=O.raw,W.text+=O.text):ie.push(O);continue}if(J){var ke="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return ie},c(ne,null,[{key:"rules",get:function(){return{block:U,inline:F}}}]),ne}(),j=function(){function ne(fe){this.options=fe||Z.defaults}var ce=ne.prototype;return ce.code=function(J,ie,te){var O=(ie||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(J,O);W!=null&&W!==J&&(te=!0,J=W)}return J=J.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+w(O,!0)+'">'+(te?J:w(J,!0))+`</code></pre>
`:"<pre><code>"+(te?J:w(J,!0))+`</code></pre>
`},ce.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ce.html=function(J){return J},ce.heading=function(J,ie,te,O){if(this.options.headerIds){var W=this.options.headerPrefix+O.slug(te);return"<h"+ie+' id="'+W+'">'+J+"</h"+ie+`>
`}return"<h"+ie+">"+J+"</h"+ie+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(J,ie,te){var O=ie?"ol":"ul",W=ie&&te!==1?' start="'+te+'"':"";return"<"+O+W+`>
`+J+"</"+O+`>
`},ce.listitem=function(J){return"<li>"+J+`</li>
`},ce.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(J){return"<p>"+J+`</p>
`},ce.table=function(J,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ie+`</table>
`},ce.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ce.tablecell=function(J,ie){var te=ie.header?"th":"td",O=ie.align?"<"+te+' align="'+ie.align+'">':"<"+te+">";return O+J+("</"+te+`>
`)},ce.strong=function(J){return"<strong>"+J+"</strong>"},ce.em=function(J){return"<em>"+J+"</em>"},ce.codespan=function(J){return"<code>"+J+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(J){return"<del>"+J+"</del>"},ce.link=function(J,ie,te){if(J=v(this.options.sanitize,this.options.baseUrl,J),J===null)return te;var O='<a href="'+w(J)+'"';return ie&&(O+=' title="'+ie+'"'),O+=">"+te+"</a>",O},ce.image=function(J,ie,te){if(J=v(this.options.sanitize,this.options.baseUrl,J),J===null)return te;var O='<img src="'+J+'" alt="'+te+'"';return ie&&(O+=' title="'+ie+'"'),O+=this.options.xhtml?"/>":">",O},ce.text=function(J){return J},ne}(),$=function(){function ne(){}var ce=ne.prototype;return ce.strong=function(J){return J},ce.em=function(J){return J},ce.codespan=function(J){return J},ce.del=function(J){return J},ce.html=function(J){return J},ce.text=function(J){return J},ce.link=function(J,ie,te){return""+te},ce.image=function(J,ie,te){return""+te},ce.br=function(){return""},ne}(),Q=function(){function ne(){this.seen={}}var ce=ne.prototype;return ce.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(J,ie){var te=J,O=0;if(this.seen.hasOwnProperty(te)){O=this.seen[J];do O++,te=J+"-"+O;while(this.seen.hasOwnProperty(te))}return ie||(this.seen[J]=O,this.seen[te]=0),te},ce.slug=function(J,ie){ie===void 0&&(ie={});var te=this.serialize(J);return this.getNextSafeSlug(te,ie.dryrun)},ne}(),K=function(){function ne(fe){this.options=fe||Z.defaults,this.options.renderer=this.options.renderer||new j,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new Q}ne.parse=function(J,ie){var te=new ne(ie);return te.parse(J)},ne.parseInline=function(J,ie){var te=new ne(ie);return te.parseInline(J)};var ce=ne.prototype;return ce.parse=function(J,ie){ie===void 0&&(ie=!0);var te="",O,W,q,X,ae,ve,Te,ge,ke,De,xe,qe,nt,Xe,st,Be,dt,se,oe,Se=J.length;for(O=0;O<Se;O++){if(De=J[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(oe=this.options.extensions.renderers[De.type].call({parser:this},De),oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){te+=oe||"";continue}switch(De.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(De.tokens),De.depth,g(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ge="",Te="",X=De.header.length,W=0;W<X;W++)Te+=this.renderer.tablecell(this.parseInline(De.header[W].tokens),{header:!0,align:De.align[W]});for(ge+=this.renderer.tablerow(Te),ke="",X=De.rows.length,W=0;W<X;W++){for(ve=De.rows[W],Te="",ae=ve.length,q=0;q<ae;q++)Te+=this.renderer.tablecell(this.parseInline(ve[q].tokens),{header:!1,align:De.align[q]});ke+=this.renderer.tablerow(Te)}te+=this.renderer.table(ge,ke);continue}case"blockquote":{ke=this.parse(De.tokens),te+=this.renderer.blockquote(ke);continue}case"list":{for(xe=De.ordered,qe=De.start,nt=De.loose,X=De.items.length,ke="",W=0;W<X;W++)st=De.items[W],Be=st.checked,dt=st.task,Xe="",st.task&&(se=this.renderer.checkbox(Be),nt?st.tokens.length>0&&st.tokens[0].type==="paragraph"?(st.tokens[0].text=se+" "+st.tokens[0].text,st.tokens[0].tokens&&st.tokens[0].tokens.length>0&&st.tokens[0].tokens[0].type==="text"&&(st.tokens[0].tokens[0].text=se+" "+st.tokens[0].tokens[0].text)):st.tokens.unshift({type:"text",text:se}):Xe+=se),Xe+=this.parse(st.tokens,nt),ke+=this.renderer.listitem(Xe,dt,Be);te+=this.renderer.list(ke,xe,qe);continue}case"html":{te+=this.renderer.html(De.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(ke=De.tokens?this.parseInline(De.tokens):De.text;O+1<Se&&J[O+1].type==="text";)De=J[++O],ke+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);te+=ie?this.renderer.paragraph(ke):ke;continue}default:{var le='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return te},ce.parseInline=function(J,ie){ie=ie||this.renderer;var te="",O,W,q,X=J.length;for(O=0;O<X;O++){if(W=J[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(q=this.options.extensions.renderers[W.type].call({parser:this},W),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){te+=q||"";continue}switch(W.type){case"escape":{te+=ie.text(W.text);break}case"html":{te+=ie.html(W.text);break}case"link":{te+=ie.link(W.href,W.title,this.parseInline(W.tokens,ie));break}case"image":{te+=ie.image(W.href,W.title,W.text);break}case"strong":{te+=ie.strong(this.parseInline(W.tokens,ie));break}case"em":{te+=ie.em(this.parseInline(W.tokens,ie));break}case"codespan":{te+=ie.codespan(W.text);break}case"br":{te+=ie.br();break}case"del":{te+=ie.del(this.parseInline(W.tokens,ie));break}case"text":{te+=ie.text(W.text);break}default:{var ae='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return te},ne}();function ue(ne,ce,fe){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof ce=="function"&&(fe=ce,ce=null),ce=n({},ue.defaults,ce||{}),R(ce),fe){var J=ce.highlight,ie;try{ie=z.lex(ne,ce)}catch(X){return fe(X)}var te=function(ae){var ve;if(!ae)try{ce.walkTokens&&ue.walkTokens(ie,ce.walkTokens),ve=K.parse(ie,ce)}catch(Te){ae=Te}return ce.highlight=J,ae?fe(ae):fe(null,ve)};if(!J||J.length<3||(delete ce.highlight,!ie.length))return te();var O=0;ue.walkTokens(ie,function(X){X.type==="code"&&(O++,setTimeout(function(){J(X.text,X.lang,function(ae,ve){if(ae)return te(ae);ve!=null&&ve!==X.text&&(X.text=ve,X.escaped=!0),O--,O===0&&te()})},0))}),O===0&&te();return}function W(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(X.message+"",!0)+"</pre>";throw X}try{var q=z.lex(ne,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ue.walkTokens(q,ce.walkTokens)).then(function(){return K.parse(q,ce)}).catch(W);ue.walkTokens(q,ce.walkTokens)}return K.parse(q,ce)}catch(X){W(X)}}ue.options=ue.setOptions=function(ne){return n(ue.defaults,ne),k(ue.defaults),ue},ue.getDefaults=y,ue.defaults=Z.defaults,ue.use=function(){for(var ne=arguments.length,ce=new Array(ne),fe=0;fe<ne;fe++)ce[fe]=arguments[fe];var J=n.apply(void 0,[{}].concat(ce)),ie=ue.defaults.extensions||{renderers:{},childTokens:{}},te;ce.forEach(function(O){if(O.extensions&&(te=!0,O.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var X=ie.renderers?ie.renderers[q.name]:null;X?ie.renderers[q.name]=function(){for(var ae=arguments.length,ve=new Array(ae),Te=0;Te<ae;Te++)ve[Te]=arguments[Te];var ge=q.renderer.apply(this,ve);return ge===!1&&(ge=X.apply(this,ve)),ge}:ie.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[q.level]?ie[q.level].unshift(q.tokenizer):ie[q.level]=[q.tokenizer],q.start&&(q.level==="block"?ie.startBlock?ie.startBlock.push(q.start):ie.startBlock=[q.start]:q.level==="inline"&&(ie.startInline?ie.startInline.push(q.start):ie.startInline=[q.start]))}q.childTokens&&(ie.childTokens[q.name]=q.childTokens)})),O.renderer&&function(){var q=ue.defaults.renderer||new j,X=function(Te){var ge=q[Te];q[Te]=function(){for(var ke=arguments.length,De=new Array(ke),xe=0;xe<ke;xe++)De[xe]=arguments[xe];var qe=O.renderer[Te].apply(q,De);return qe===!1&&(qe=ge.apply(q,De)),qe}};for(var ae in O.renderer)X(ae);J.renderer=q}(),O.tokenizer&&function(){var q=ue.defaults.tokenizer||new L,X=function(Te){var ge=q[Te];q[Te]=function(){for(var ke=arguments.length,De=new Array(ke),xe=0;xe<ke;xe++)De[xe]=arguments[xe];var qe=O.tokenizer[Te].apply(q,De);return qe===!1&&(qe=ge.apply(q,De)),qe}};for(var ae in O.tokenizer)X(ae);J.tokenizer=q}(),O.walkTokens){var W=ue.defaults.walkTokens;J.walkTokens=function(q){var X=[];return X.push(O.walkTokens.call(this,q)),W&&(X=X.concat(W.call(this,q))),X}}te&&(J.extensions=ie),ue.setOptions(J)})},ue.walkTokens=function(ne,ce){for(var fe=[],J=function(){var W=te.value;switch(fe=fe.concat(ce.call(ue,W)),W.type){case"table":{for(var q=P(W.header),X;!(X=q()).done;){var ae=X.value;fe=fe.concat(ue.walkTokens(ae.tokens,ce))}for(var ve=P(W.rows),Te;!(Te=ve()).done;)for(var ge=Te.value,ke=P(ge),De;!(De=ke()).done;){var xe=De.value;fe=fe.concat(ue.walkTokens(xe.tokens,ce))}break}case"list":{fe=fe.concat(ue.walkTokens(W.items,ce));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[W.type]?ue.defaults.extensions.childTokens[W.type].forEach(function(qe){fe=fe.concat(ue.walkTokens(W[qe],ce))}):W.tokens&&(fe=fe.concat(ue.walkTokens(W.tokens,ce)))}},ie=P(ne),te;!(te=ie()).done;)J();return fe},ue.parseInline=function(ne,ce){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");ce=n({},ue.defaults,ce||{}),R(ce);try{var fe=z.lexInline(ne,ce);return ce.walkTokens&&ue.walkTokens(fe,ce.walkTokens),K.parseInline(fe,ce)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(J.message+"",!0)+"</pre>";throw J}},ue.Parser=K,ue.parser=K.parse,ue.Renderer=j,ue.TextRenderer=$,ue.Lexer=z,ue.lexer=z.lex,ue.Tokenizer=L,ue.Slugger=Q,ue.parse=ue;var re=ue.options,de=ue.setOptions,Y=ue.use,pe=ue.walkTokens,be=ue.parseInline,Ce=ue,Re=K.parse,We=z.lex;Z.Lexer=z,Z.Parser=K,Z.Renderer=j,Z.Slugger=Q,Z.TextRenderer=$,Z.Tokenizer=L,Z.getDefaults=y,Z.lexer=We,Z.marked=ue,Z.options=re,Z.parse=Ce,Z.parseInline=be,Z.parser=Re,Z.setOptions=de,Z.use=Y,Z.walkTokens=pe,Object.defineProperty(Z,"__esModule",{value:!0})}),define(_e[80],ye([1,0,28]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function I(C){return S(C,"NFC",t)}e.normalizeNFC=I;const P=new c.LRUCache(1e4);function y(C){return S(C,"NFD",P)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function S(C,A,T){if(!C)return C;const E=T.get(C);if(E)return E;let _;return k.test(C)?_=C.normalize(A):_=C,T.set(C,_),_}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(A){return y(A).replace(C,"")}}()}),define(_e[100],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(k,S,C){return Math.min(Math.max(k,S),C)}e.clamp=c;function t(k,S){return(S+k%S)%S}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class P{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const C=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=C,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Z(I){const P=[];typeof I=="number"&&P.push("code/timeOrigin",I);function y(S){P.push(S,Date.now())}function k(){const S=[];for(let C=0;C<P.length;C+=2)S.push({name:P[C],startTime:P[C+1]});return S}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(I+y.startTime)});return P}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function c(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:Z)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function c(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return Z[t].call(I.exports,I,I.exports,c),I.l=!0,I.exports}return c.m=Z,c.c=e,c.d=function(t,I,P){c.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:P})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,I){if(1&I&&(t=c(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(c.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var y in t)c.d(P,y,function(k){return t[k]}.bind(null,y));return P},c.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(I,"a",I),I},c.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},c.p="",c(c.s=0)}([function(Z,e,c){(function(t){var I;e=Z.exports=Y,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],S=e.src=[],C=0,A=C++;S[A]="0|[1-9]\\d*";var T=C++;S[T]="[0-9]+";var E=C++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var _=C++;S[_]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var w=C++;S[w]="("+S[T]+")\\.("+S[T]+")\\.("+S[T]+")";var h=C++;S[h]="(?:"+S[A]+"|"+S[E]+")";var g=C++;S[g]="(?:"+S[T]+"|"+S[E]+")";var f=C++;S[f]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var b=C++;S[b]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=C++;S[m]="[0-9A-Za-z-]+";var d=C++;S[d]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var v=C++,r="v?"+S[_]+S[f]+"?"+S[d]+"?";S[v]="^"+r+"$";var o="[v=\\s]*"+S[w]+S[b]+"?"+S[d]+"?",l=C++;S[l]="^"+o+"$";var s=C++;S[s]="((?:<|>)?=?)";var a=C++;S[a]=S[T]+"|x|X|\\*";var u=C++;S[u]=S[A]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[f]+")?"+S[d]+"?)?)?";var i=C++;S[i]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[b]+")?"+S[d]+"?)?)?";var p=C++;S[p]="^"+S[s]+"\\s*"+S[n]+"$";var D=C++;S[D]="^"+S[s]+"\\s*"+S[i]+"$";var R=C++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=C++;S[N]="(?:~>?)";var V=C++;S[V]="(\\s*)"+S[N]+"\\s+",k[V]=new RegExp(S[V],"g");var x=C++;S[x]="^"+S[N]+S[n]+"$";var L=C++;S[L]="^"+S[N]+S[i]+"$";var U=C++;S[U]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[U]+"\\s+",k[F]=new RegExp(S[F],"g");var B=C++;S[B]="^"+S[U]+S[n]+"$";var M=C++;S[M]="^"+S[U]+S[i]+"$";var z=C++;S[z]="^"+S[s]+"\\s*("+o+")$|^$";var j=C++;S[j]="^"+S[s]+"\\s*("+r+")$|^$";var $=C++;S[$]="(\\s*)"+S[s]+"\\s*("+o+"|"+S[n]+")",k[$]=new RegExp(S[$],"g");var Q=C++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var K=C++;S[K]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var ue=C++;S[ue]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)I(re,S[re]),k[re]||(k[re]=new RegExp(S[re]));function de(ge,ke){if(ge instanceof Y)return ge;if(typeof ge!="string"||ge.length>P||!(ke?k[l]:k[v]).test(ge))return null;try{return new Y(ge,ke)}catch{return null}}function Y(ge,ke){if(ge instanceof Y){if(ge.loose===ke)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ge,ke);I("SemVer",ge,ke),this.loose=ke;var De=ge.trim().match(ke?k[l]:k[v]);if(!De)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var qe=+xe;if(qe>=0&&qe<y)return qe}return xe}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=de,e.valid=function(ge,ke){var De=de(ge,ke);return De?De.version:null},e.clean=function(ge,ke){var De=de(ge.trim().replace(/^[=v]+/,""),ke);return De?De.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ge){return I("SemVer.compare",this.version,this.loose,ge),ge instanceof Y||(ge=new Y(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},Y.prototype.compareMain=function(ge){return ge instanceof Y||(ge=new Y(ge,this.loose)),be(this.major,ge.major)||be(this.minor,ge.minor)||be(this.patch,ge.patch)},Y.prototype.comparePre=function(ge){if(ge instanceof Y||(ge=new Y(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var ke=0;do{var De=this.prerelease[ke],xe=ge.prerelease[ke];if(I("prerelease compare",ke,De,xe),De===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(De===void 0)return-1;if(De!==xe)return be(De,xe)}while(++ke)},Y.prototype.inc=function(ge,ke){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,ke,De,xe){typeof De=="string"&&(xe=De,De=void 0);try{return new Y(ge,De).inc(ke,xe).version}catch{return null}},e.diff=function(ge,ke){if(ne(ge,ke))return null;var De=de(ge),xe=de(ke);if(De.prerelease.length||xe.prerelease.length){for(var qe in De)if((qe==="major"||qe==="minor"||qe==="patch")&&De[qe]!==xe[qe])return"pre"+qe;return"prerelease"}for(var qe in De)if((qe==="major"||qe==="minor"||qe==="patch")&&De[qe]!==xe[qe])return qe},e.compareIdentifiers=be;var pe=/^[0-9]+$/;function be(ge,ke){var De=pe.test(ge),xe=pe.test(ke);return De&&xe&&(ge=+ge,ke=+ke),De&&!xe?-1:xe&&!De?1:ge<ke?-1:ge>ke?1:0}function Ce(ge,ke,De){return new Y(ge,De).compare(new Y(ke,De))}function Re(ge,ke,De){return Ce(ge,ke,De)>0}function We(ge,ke,De){return Ce(ge,ke,De)<0}function ne(ge,ke,De){return Ce(ge,ke,De)===0}function ce(ge,ke,De){return Ce(ge,ke,De)!==0}function fe(ge,ke,De){return Ce(ge,ke,De)>=0}function J(ge,ke,De){return Ce(ge,ke,De)<=0}function ie(ge,ke,De,xe){var qe;switch(ke){case"===":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),qe=ge===De;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),qe=ge!==De;break;case"":case"=":case"==":qe=ne(ge,De,xe);break;case"!=":qe=ce(ge,De,xe);break;case">":qe=Re(ge,De,xe);break;case">=":qe=fe(ge,De,xe);break;case"<":qe=We(ge,De,xe);break;case"<=":qe=J(ge,De,xe);break;default:throw new TypeError("Invalid operator: "+ke)}return qe}function te(ge,ke){if(ge instanceof te){if(ge.loose===ke)return ge;ge=ge.value}if(!(this instanceof te))return new te(ge,ke);I("comparator",ge,ke),this.loose=ke,this.parse(ge),this.semver===O?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ge,ke){return be(ke,ge)},e.major=function(ge,ke){return new Y(ge,ke).major},e.minor=function(ge,ke){return new Y(ge,ke).minor},e.patch=function(ge,ke){return new Y(ge,ke).patch},e.compare=Ce,e.compareLoose=function(ge,ke){return Ce(ge,ke,!0)},e.rcompare=function(ge,ke,De){return Ce(ke,ge,De)},e.sort=function(ge,ke){return ge.sort(function(De,xe){return e.compare(De,xe,ke)})},e.rsort=function(ge,ke){return ge.sort(function(De,xe){return e.rcompare(De,xe,ke)})},e.gt=Re,e.lt=We,e.eq=ne,e.neq=ce,e.gte=fe,e.lte=J,e.cmp=ie,e.Comparator=te;var O={};function W(ge,ke){if(ge instanceof W)return ge.loose===ke?ge:new W(ge.raw,ke);if(ge instanceof te)return new W(ge.value,ke);if(!(this instanceof W))return new W(ge,ke);if(this.loose=ke,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function q(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function X(ge,ke,De,xe,qe,nt,Xe,st,Be,dt,se,oe,Se){return((ke=q(De)?"":q(xe)?">="+De+".0.0":q(qe)?">="+De+"."+xe+".0":">="+ke)+" "+(st=q(Be)?"":q(dt)?"<"+(+Be+1)+".0.0":q(se)?"<"+Be+"."+(+dt+1)+".0":oe?"<="+Be+"."+dt+"."+se+"-"+oe:"<="+st)).trim()}function ae(ge,ke){for(var De=0;De<ge.length;De++)if(!ge[De].test(ke))return!1;if(ke.prerelease.length){for(De=0;De<ge.length;De++)if(I(ge[De].semver),ge[De].semver!==O&&ge[De].semver.prerelease.length>0){var xe=ge[De].semver;if(xe.major===ke.major&&xe.minor===ke.minor&&xe.patch===ke.patch)return!0}return!1}return!0}function ve(ge,ke,De){try{ke=new W(ke,De)}catch{return!1}return ke.test(ge)}function Te(ge,ke,De,xe){var qe,nt,Xe,st,Be;switch(ge=new Y(ge,xe),ke=new W(ke,xe),De){case">":qe=Re,nt=J,Xe=We,st=">",Be=">=";break;case"<":qe=We,nt=fe,Xe=Re,st="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ge,ke,xe))return!1;for(var dt=0;dt<ke.set.length;++dt){var se=ke.set[dt],oe=null,Se=null;if(se.forEach(function(le){le.semver===O&&(le=new te(">=0.0.0")),oe=oe||le,Se=Se||le,qe(le.semver,oe.semver,xe)?oe=le:Xe(le.semver,Se.semver,xe)&&(Se=le)}),oe.operator===st||oe.operator===Be||(!Se.operator||Se.operator===st)&&nt(ge,Se.semver)||Se.operator===Be&&Xe(ge,Se.semver))return!1}return!0}te.prototype.parse=function(ge){var ke=this.loose?k[z]:k[j],De=ge.match(ke);if(!De)throw new TypeError("Invalid comparator: "+ge);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new Y(De[2],this.loose):this.semver=O},te.prototype.toString=function(){return this.value},te.prototype.test=function(ge){return I("Comparator.test",ge,this.loose),this.semver===O||(typeof ge=="string"&&(ge=new Y(ge,this.loose)),ie(ge,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ge,ke){if(!(ge instanceof te))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new W(ge.value,ke),ve(this.value,De,ke);if(ge.operator==="")return De=new W(this.value,ke),ve(ge.semver,De,ke);var xe=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),nt=this.semver.version===ge.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),st=ie(this.semver,"<",ge.semver,ke)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Be=ie(this.semver,">",ge.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return xe||qe||nt&&Xe||st||Be},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(ge){var ke=this.loose;ge=ge.trim(),I("range",ge,ke);var De=ke?k[K]:k[Q];ge=ge.replace(De,X),I("hyphen replace",ge),ge=ge.replace(k[$],"$1$2$3"),I("comparator trim",ge,k[$]),ge=(ge=(ge=ge.replace(k[V],"$1~")).replace(k[F],"$1^")).split(/\s+/).join(" ");var xe=ke?k[z]:k[j],qe=ge.split(" ").map(function(nt){return function(Xe,st){return I("comp",Xe),Xe=function(Be,dt){return Be.trim().split(/\s+/).map(function(se){return function(oe,Se){I("caret",oe,Se);var le=Se?k[M]:k[B];return oe.replace(le,function(Pe,Le,Fe,Ge,Je){var it;return I("caret",oe,Pe,Le,Fe,Ge,Je),q(Le)?it="":q(Fe)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":q(Ge)?it=Le==="0"?">="+Le+"."+Fe+".0 <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+".0 <"+(+Le+1)+".0.0":Je?(I("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),it=Le==="0"?Fe==="0"?">="+Le+"."+Fe+"."+Ge+Je+" <"+Le+"."+Fe+"."+(+Ge+1):">="+Le+"."+Fe+"."+Ge+Je+" <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+"."+Ge+Je+" <"+(+Le+1)+".0.0"):(I("no pr"),it=Le==="0"?Fe==="0"?">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+Fe+"."+(+Ge+1):">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+(+Fe+1)+".0":">="+Le+"."+Fe+"."+Ge+" <"+(+Le+1)+".0.0"),I("caret return",it),it})}(se,dt)}).join(" ")}(Xe,st),I("caret",Xe),Xe=function(Be,dt){return Be.trim().split(/\s+/).map(function(se){return function(oe,Se){var le=Se?k[L]:k[x];return oe.replace(le,function(Pe,Le,Fe,Ge,Je){var it;return I("tilde",oe,Pe,Le,Fe,Ge,Je),q(Le)?it="":q(Fe)?it=">="+Le+".0.0 <"+(+Le+1)+".0.0":q(Ge)?it=">="+Le+"."+Fe+".0 <"+Le+"."+(+Fe+1)+".0":Je?(I("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),it=">="+Le+"."+Fe+"."+Ge+Je+" <"+Le+"."+(+Fe+1)+".0"):it=">="+Le+"."+Fe+"."+Ge+" <"+Le+"."+(+Fe+1)+".0",I("tilde return",it),it})}(se,dt)}).join(" ")}(Xe,st),I("tildes",Xe),Xe=function(Be,dt){return I("replaceXRanges",Be,dt),Be.split(/\s+/).map(function(se){return function(oe,Se){oe=oe.trim();var le=Se?k[D]:k[p];return oe.replace(le,function(Pe,Le,Fe,Ge,Je,it){I("xRange",oe,Pe,Le,Fe,Ge,Je,it);var vt=q(Fe),rt=vt||q(Ge),Ze=rt||q(Je);return Le==="="&&Ze&&(Le=""),vt?Pe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Ze?(rt&&(Ge=0),Ze&&(Je=0),Le===">"?(Le=">=",rt?(Fe=+Fe+1,Ge=0,Je=0):Ze&&(Ge=+Ge+1,Je=0)):Le==="<="&&(Le="<",rt?Fe=+Fe+1:Ge=+Ge+1),Pe=Le+Fe+"."+Ge+"."+Je):rt?Pe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ze&&(Pe=">="+Fe+"."+Ge+".0 <"+Fe+"."+(+Ge+1)+".0"),I("xRange return",Pe),Pe})}(se,dt)}).join(" ")}(Xe,st),I("xrange",Xe),Xe=function(Be,dt){return I("replaceStars",Be,dt),Be.trim().replace(k[ue],"")}(Xe,st),I("stars",Xe),Xe}(nt,ke)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(nt){return!!nt.match(xe)})),qe=qe.map(function(nt){return new te(nt,ke)})},W.prototype.intersects=function(ge,ke){if(!(ge instanceof W))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(xe){return ge.set.some(function(qe){return qe.every(function(nt){return xe.intersects(nt,ke)})})})})},e.toComparators=function(ge,ke){return new W(ge,ke).set.map(function(De){return De.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},W.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new Y(ge,this.loose));for(var ke=0;ke<this.set.length;ke++)if(ae(this.set[ke],ge))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ge,ke,De){var xe=null,qe=null;try{var nt=new W(ke,De)}catch{return null}return ge.forEach(function(Xe){nt.test(Xe)&&(xe&&qe.compare(Xe)!==-1||(qe=new Y(xe=Xe,De)))}),xe},e.minSatisfying=function(ge,ke,De){var xe=null,qe=null;try{var nt=new W(ke,De)}catch{return null}return ge.forEach(function(Xe){nt.test(Xe)&&(xe&&qe.compare(Xe)!==1||(qe=new Y(xe=Xe,De)))}),xe},e.validRange=function(ge,ke){try{return new W(ge,ke).range||"*"}catch{return null}},e.ltr=function(ge,ke,De){return Te(ge,ke,"<",De)},e.gtr=function(ge,ke,De){return Te(ge,ke,">",De)},e.outside=Te,e.prerelease=function(ge,ke){var De=de(ge,ke);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function(ge,ke,De){return ge=new W(ge,De),ke=new W(ke,De),ge.intersects(ke)},e.coerce=function(ge){if(ge instanceof Y)return ge;if(typeof ge!="string")return null;var ke=ge.match(k[R]);return ke==null?null:de((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,c(1))},function(Z,e){var c,t,I=Z.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function k(g){if(c===setTimeout)return setTimeout(g,0);if((c===P||!c)&&setTimeout)return c=setTimeout,setTimeout(g,0);try{return c(g,0)}catch{try{return c.call(null,g,0)}catch{return c.call(this,g,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:P}catch{c=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var S,C=[],A=!1,T=-1;function E(){A&&S&&(A=!1,S.length?C=S.concat(C):T=-1,C.length&&_())}function _(){if(!A){var g=k(E);A=!0;for(var f=C.length;f;){for(S=C,C=[];++T<f;)S&&S[T].run();T=-1,f=C.length}S=null,A=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(g)}}function w(g,f){this.fun=g,this.array=f}function h(){}I.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)f[b-1]=arguments[b];C.push(new w(g,f)),C.length!==1||A||k(_)},w.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(_e[101],ye([1,0,10,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(d){const v=d;return v?typeof v.read=="function":!1}e.isReadable=I;function P(d){const v=d;return v?[v.on,v.pause,v.resume,v.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=P;function y(d){const v=d;return v?P(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=y;function k(d,v){return new S(d,v)}e.newWriteableStream=k;class S{constructor(v,r){this.reducer=v,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(r=>r(v))}emitError(v){this.listeners.error.length===0?(0,c.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(r=>r(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,r){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(v,r){if(this.state.destroyed)return;let o;switch(v){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const l=o.indexOf(r);l>=0&&o.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(d,v){const r=[];let o;for(;(o=d.read())!==null;)r.push(o);return v(r)}e.consumeReadable=C;function A(d,v,r){const o=[];let l;for(;(l=d.read())!==null&&o.length<r;)o.push(l);return l===null&&o.length>0?v(o):{read:()=>{if(o.length>0)return o.shift();if(typeof l<"u"){const s=l;return l=void 0,s}return d.read()}}}e.peekReadable=A;function T(d,v){return new Promise((r,o)=>{const l=[];E(d,{onData:s=>{v&&l.push(s)},onError:s=>{v?o(s):r(void 0)},onEnd:()=>{r(v?v(l):void 0)}})})}e.consumeStream=T;function E(d,v){let r=!1;return d.on("error",o=>{r||v.onError(o)}),d.on("end",()=>{r||v.onEnd()}),d.on("data",o=>{r||v.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=E;function _(d,v){return new Promise((r,o)=>{const l=new t.DisposableStore,s=[],a=i=>{if(s.push(i),s.length>v)return l.dispose(),d.pause(),r({stream:d,buffer:s,ended:!1})},u=i=>o(i),n=()=>r({stream:d,buffer:s,ended:!0});l.add((0,t.toDisposable)(()=>d.removeListener("error",u))),d.on("error",u),l.add((0,t.toDisposable)(()=>d.removeListener("end",n))),d.on("end",n),l.add((0,t.toDisposable)(()=>d.removeListener("data",a))),d.on("data",a)})}e.peekStream=_;function w(d,v){const r=k(v);return r.end(d),r}e.toStream=w;function h(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function g(d){let v=!1;return{read:()=>v?null:(v=!0,d)}}e.toReadable=g;function f(d,v,r){const o=k(r);return E(d,{onData:l=>o.write(v.data(l)),onError:l=>o.error(v.error?v.error(l):l),onEnd:()=>o.end()}),o}e.transform=f;function b(d,v,r){let o=!1;return{read:()=>{const l=v.read();return o?l:(o=!0,l!==null?r([d,l]):d)}}}e.prefixedReadable=b;function m(d,v,r){let o=!1;const l=k(r);return E(v,{onData:s=>o?l.write(s):(o=!0,l.write(r([d,s]))),onError:s=>l.error(s),onEnd:()=>{o||(o=!0,l.write(d)),l.end()}}),l}e.prefixedStream=m}),define(_e[23],ye([1,0,101]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,P;class y{static alloc(i){return t?new y(Buffer.allocUnsafe(i)):new y(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new y(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(i)):(I||(I=new TextEncoder),new y(I.encode(i)))}static fromByteArray(i){const p=y.alloc(i.length);for(let D=0,R=i.length;D<R;D++)p.buffer[D]=i[D];return p}static concat(i,p){if(typeof p>"u"){p=0;for(let N=0,V=i.length;N<V;N++)p+=i[N].byteLength}const D=y.alloc(p);let R=0;for(let N=0,V=i.length;N<V;N++){const x=i[N];D.set(x,R),R+=x.byteLength}return D}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=y.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,p){return new y(this.buffer.subarray(i,p))}set(i,p){if(i instanceof y)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return C(this.buffer,i)}writeUInt32BE(i,p){A(this.buffer,i,p)}readUInt32LE(i){return T(this.buffer,i)}writeUInt32LE(i,p){E(this.buffer,i,p)}readUInt8(i){return _(this.buffer,i)}writeUInt8(i,p){w(this.buffer,i,p)}}e.VSBuffer=y;function k(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=k;function S(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255}e.writeUInt16LE=S;function C(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=C;function A(n,i,p){n[p+3]=i,i=i>>>8,n[p+2]=i,i=i>>>8,n[p+1]=i,i=i>>>8,n[p]=i}e.writeUInt32BE=A;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=T;function E(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255,i=i>>>8,n[p+2]=i&255,i=i>>>8,n[p+3]=i&255}e.writeUInt32LE=E;function _(n,i){return n[i]}e.readUInt8=_;function w(n,i,p){n[p]=i}e.writeUInt8=w;function h(n){return c.consumeReadable(n,i=>y.concat(i))}e.readableToBuffer=h;function g(n){return c.toReadable(n)}e.bufferToReadable=g;function f(n){return c.consumeStream(n,i=>y.concat(i))}e.streamToBuffer=f;async function b(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=b;function m(n){return c.toStream(n,i=>y.concat(i))}e.bufferToStream=m;function d(n){return c.transform(n,{data:i=>typeof i=="string"?y.fromString(i):y.wrap(i)},i=>y.concat(i))}e.streamToBufferReadableStream=d;function v(n){return c.newWriteableStream(i=>y.concat(i),n)}e.newWriteableBufferStream=v;function r(n,i){return c.prefixedReadable(n,i,p=>y.concat(p))}e.prefixedBufferReadable=r;function o(n,i){return c.prefixedStream(n,i,p=>y.concat(p))}e.prefixedBufferStream=o;function l(n){let i=0,p=0,D=0;const R=new Uint8Array(Math.floor(n.length/4*3)),N=x=>{switch(p){case 3:R[D++]=i|x,p=0;break;case 2:R[D++]=i|x>>>2,i=x<<6,p=3;break;case 1:R[D++]=i|x>>>4,i=x<<4,p=2;break;default:i=x<<2,p=1}};for(let x=0;x<n.length;x++){const L=n.charCodeAt(x);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${n[x]}`)}}const V=D;for(;p>0;)N(0);return y.wrap(R).slice(0,V)}e.decodeBase64=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},i=!0,p=!1){const D=p?a:s;let R="";const N=n.byteLength%3;let V=0;for(;V<n.byteLength-N;V+=3){const x=n[V+0],L=n[V+1],U=n[V+2];R+=D[x>>>2],R+=D[(x<<4|L>>>4)&63],R+=D[(L<<2|U>>>6)&63],R+=D[U&63]}if(N===1){const x=n[V+0];R+=D[x>>>2],R+=D[x<<4&63],i&&(R+="==")}else if(N===2){const x=n[V+0],L=n[V+1];R+=D[x>>>2],R+=D[(x<<4|L>>>4)&63],R+=D[L<<2&63],i&&(R+="=")}return R}e.encodeBase64=u}),define(_e[11],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function t(o){return Array.isArray(o)&&o.every(l=>c(l))}e.isStringArray=t;function I(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=I;function P(o){const l=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof l}e.isTypedArray=P;function y(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=y;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function S(o){return o===!0||o===!1}e.isBoolean=S;function C(o){return typeof o>"u"}e.isUndefined=C;function A(o){return!T(o)}e.isDefined=A;function T(o){return C(o)||o===null}e.isUndefinedOrNull=T;function E(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=E;function _(o){if(T(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=_;function w(...o){const l=[];for(let s=0;s<o.length;s++){const a=o[s];if(T(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);l.push(a)}return l}e.assertAllDefined=w;const h=Object.prototype.hasOwnProperty;function g(o){if(!I(o))return!1;for(const l in o)if(h.call(o,l))return!1;return!0}e.isEmptyObject=g;function f(o){return typeof o=="function"}e.isFunction=f;function b(...o){return o.length>0&&o.every(f)}e.areFunctions=b;function m(o,l){const s=Math.min(o.length,l.length);for(let a=0;a<s;a++)d(o[a],l[a])}e.validateConstraints=m;function d(o,l){if(c(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(f(l)){try{if(o instanceof l)return}catch{}if(!T(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function v(o){return o===null?void 0:o}e.withNullAsUndefined=v;function r(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=r}),define(_e[24],ye([1,0,11]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([m,d])=>{b[m]=d&&typeof d=="object"?t(d):d}),b}e.deepClone=t;function I(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const m=b.shift();Object.freeze(m);for(const d in m)if(P.call(m,d)){const v=m[d];typeof v=="object"&&!Object.isFrozen(v)&&!(0,c.isTypedArray)(v)&&b.push(v)}}return f}e.deepFreeze=I;const P=Object.prototype.hasOwnProperty;function y(f,b){return k(f,b,new Set)}e.cloneAndChange=y;function k(f,b,m){if((0,c.isUndefinedOrNull)(f))return f;const d=b(f);if(typeof d<"u")return d;if(Array.isArray(f)){const v=[];for(const r of f)v.push(k(r,b,m));return v}if((0,c.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const v={};for(const r in f)P.call(f,r)&&(v[r]=k(f[r],b,m));return m.delete(f),v}return f}function S(f,b,m=!0){return(0,c.isObject)(f)?((0,c.isObject)(b)&&Object.keys(b).forEach(d=>{d in f?m&&((0,c.isObject)(f[d])&&(0,c.isObject)(b[d])?S(f[d],b[d],m):f[d]=b[d]):f[d]=b[d]}),f):b}e.mixin=S;function C(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let m,d;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(m=0;m<f.length;m++)if(!C(f[m],b[m]))return!1}else{const v=[];for(d in f)v.push(d);v.sort();const r=[];for(d in b)r.push(d);if(r.sort(),!C(v,r))return!1;for(m=0;m<v.length;m++)if(!C(f[v[m]],b[v[m]]))return!1}return!0}e.equals=C;function A(f){const b=new Set;return JSON.stringify(f,(m,d)=>{if((0,c.isObject)(d)||Array.isArray(d)){if(b.has(d))return"[Circular]";b.add(d)}return d})}e.safeStringify=A;function T(f,b){const m=Object.create(null);return!f||!b||Object.keys(b).forEach(v=>{const r=f[v],o=b[v];C(r,o)||(m[v]=o)}),m}e.distinct=T;function E(f,b){const m=b.toLowerCase(),d=Object.keys(f).find(v=>v.toLowerCase()===m);return d?f[d]:f[b]}e.getCaseInsensitive=E;function _(f,b){const m=Object.create(null);for(const[d,v]of Object.entries(f))b(d,v)&&(m[d]=v);return m}e.filter=_;function w(f){let b=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)b=b.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return b}e.getAllPropertyNames=w;function h(f){const b=[];for(const m of w(f))typeof f[m]=="function"&&b.push(m);return b}e.getAllMethodNames=h;function g(f,b){const m=v=>function(){const r=Array.prototype.slice.call(arguments,0);return b(v,r)},d={};for(const v of f)d[v]=m(v);return d}e.createProxyObject=g}),define(_e[102],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function I(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=I}),define(_e[30],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return c.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(k){for(let S=0;S<k.length;S++)k[S]=Math.floor(Math.random()*256);return k};const P=new Uint8Array(16),y=[];for(let k=0;k<256;k++)y.push(k.toString(16).padStart(2,"0"));return function(){I(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,C="";return C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C+="-",C+=y[P[S++]],C+=y[P[S++]],C+="-",C+=y[P[S++]],C+=y[P[S++]],C+="-",C+=y[P[S++]],C+=y[P[S++]],C+="-",C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C+=y[P[S++]],C}}()}),define(_e[146],ye([1,0,17,30]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(k){return{id:(0,t.generateUuid)(),asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=I;function P(k,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:k,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=P;class y{constructor(){this._entries=new Map}get size(){return this._entries.size}has(S){return this._entries.has(this.toKey(S))}get(S){return this._entries.get(this.toKey(S))?.[0]}append(S,C){const A=this._entries.get(S);A?A.push(C):this._entries.set(this.toKey(S),[C])}replace(S,C){this._entries.set(this.toKey(S),[C])}delete(S){this._entries.delete(this.toKey(S))}*entries(){for(const[S,C]of this._entries.entries())for(const A of C)yield[S,A]}values(){return Array.from(this._entries.values()).flat()}forEach(S){for(const[C,A]of this.entries())S(A,C)}toKey(S){return S.toLowerCase()}}e.VSDataTransfer=y,e.UriList=Object.freeze({create:k=>(0,c.distinct)(k.map(S=>S.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(S=>!S.startsWith("#"))})}),define(_e[103],ye([1,0,102]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const S=(0,c.toUint8)(k);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){const S=new Uint8Array(256);return S.fill(k),S}set(k,S){const C=(0,c.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=C:this._map.set(k,C)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=t;var I;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(I||(I={}));class P{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}clear(){return this._actual.clear()}}e.CharacterSet=P}),define(_e[49],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(I,P){this.lineNumber=I,this.column=P}with(I=this.lineNumber,P=this.column){return I===this.lineNumber&&P===this.column?this:new c(I,P)}delta(I=0,P=0){return this.with(this.lineNumber+I,this.column+P)}equals(I){return c.equals(this,I)}static equals(I,P){return!I&&!P?!0:!!I&&!!P&&I.lineNumber===P.lineNumber&&I.column===P.column}isBefore(I){return c.isBefore(this,I)}static isBefore(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<P.column}isBeforeOrEqual(I){return c.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,P){return I.lineNumber<P.lineNumber?!0:P.lineNumber<I.lineNumber?!1:I.column<=P.column}static compare(I,P){const y=I.lineNumber|0,k=P.lineNumber|0;if(y===k){const S=I.column|0,C=P.column|0;return S-C}return y-k}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new c(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=c}),define(_e[35],ye([1,0,49]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,k,S){P>k||P===k&&y>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let k,S,C,A;return y.startLineNumber<P.startLineNumber?(k=y.startLineNumber,S=y.startColumn):y.startLineNumber===P.startLineNumber?(k=y.startLineNumber,S=Math.min(y.startColumn,P.startColumn)):(k=P.startLineNumber,S=P.startColumn),y.endLineNumber>P.endLineNumber?(C=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(C=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(C=P.endLineNumber,A=P.endColumn),new t(k,S,C,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let k=P.startLineNumber,S=P.startColumn,C=P.endLineNumber,A=P.endColumn;const T=y.startLineNumber,E=y.startColumn,_=y.endLineNumber,w=y.endColumn;return k<T?(k=T,S=E):k===T&&(S=Math.max(S,E)),C>_?(C=_,A=w):C===_&&(A=Math.min(A,w)),k>C||k===C&&S>A?null:new t(k,S,C,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!P&&!y?!0:!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new c.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new c.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const C=P.startLineNumber|0,A=y.startLineNumber|0;if(C===A){const T=P.startColumn|0,E=y.startColumn|0;if(T===E){const _=P.endLineNumber|0,w=y.endLineNumber|0;if(_===w){const h=P.endColumn|0,g=y.endColumn|0;return h-g}return _-w}return T-E}return C-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(_e[147],ye([1,0,49,35]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(k,S,C,A){super(k,S,C,A),this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return P.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,k,S):new P(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new P(k,S,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new P(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new P(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new P(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new P(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let C=0,A=k.length;C<A;C++)if(!this.selectionsEqual(k[C],S[C]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,C,A,T){return T===0?new P(k,S,C,A):new P(C,A,k,S)}}e.Selection=P}),define(_e[148],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(_e[149],ye([1,0,103]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends c.CharacterClassifier{constructor(k){super(0);for(let S=0,C=k.length;S<C;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function P(y){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=y(S)),k[S])}e.getMapForWordSeparators=P(y=>new I(y))}),define(_e[104],ye([1,0,62,6,63]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(T=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const _ of e.USUAL_WORD_SEPARATORS)T.indexOf(_)>=0||(E+="\\"+_);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function y(T){let E=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)E=T;else{let _="g";T.ignoreCase&&(_+="i"),T.multiline&&(_+="m"),T.unicode&&(_+="u"),E=new RegExp(T.source,_)}return E.lastIndex=0,E}e.ensureValidWordDefinition=y;const k=new I.LinkedList;k.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(T){const E=k.unshift(T);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function C(T,E,_,w,h){if(h||(h=c.Iterable.first(k)),_.length>h.maxLen){let d=T-h.maxLen/2;return d<0?d=0:w+=d,_=_.substring(d,T+h.maxLen/2),C(T,E,_,w,h)}const g=Date.now(),f=T-1-w;let b=-1,m=null;for(let d=1;!(Date.now()-g>=h.timeBudget);d++){const v=f-h.windowSize*d;E.lastIndex=Math.max(0,v);const r=A(E,_,f,b);if(!r&&m||(m=r,v<=0))break;b=v}if(m){const d={word:m[0],startColumn:w+1+m.index,endColumn:w+1+m.index+m[0].length};return E.lastIndex=0,d}return null}e.getWordAtText=C;function A(T,E,_,w){let h;for(;h=T.exec(E);){const g=h.index||0;if(g<=_&&T.lastIndex>=_)return h;if(w>0&&g>w)return null}return null}}),define(_e[150],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let S=0,C=k.notIn.length;S<C;S++)switch(k.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const C=k.findTokenIndexAtOffset(S-2),A=k.getStandardTokenType(C);return this.isOK(A)}_findNeutralCharacterInRange(k,S){for(let C=k;C<=S;C++){const A=String.fromCharCode(C);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function P(y,k,S){y.has(k)?y.get(k).push(S):y.set(k,[S])}}),define(_e[151],ye([1,0,103]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(w,h,g){const f=new Uint8Array(w*h);for(let b=0,m=w*h;b<m;b++)f[b]=g;this._data=f,this.rows=w,this.cols=h}get(w,h){return this._data[w*this.cols+h]}set(w,h,g){this._data[w*this.cols+h]=g}}class P{constructor(w){let h=0,g=0;for(let b=0,m=w.length;b<m;b++){const[d,v,r]=w[b];v>h&&(h=v),d>g&&(g=d),r>g&&(g=r)}h++,g++;const f=new I(g,h,0);for(let b=0,m=w.length;b<m;b++){const[d,v,r]=w[b];f.set(d,v,r)}this._states=f,this._maxCharCode=h}nextState(w,h){return h<0||h>=this._maxCharCode?0:this._states.get(w,h)}}e.StateMachine=P;let y=null;function k(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function A(){if(C===null){C=new c.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<_.length;h++)C.set(_.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)C.set(w.charCodeAt(h),2)}return C}class T{static _createLink(w,h,g,f,b){let m=b-1;do{const d=h.charCodeAt(m);if(w.get(d)!==2)break;m--}while(m>f);if(f>0){const d=h.charCodeAt(f-1),v=h.charCodeAt(m);(d===40&&v===41||d===91&&v===93||d===123&&v===125)&&m--}return{range:{startLineNumber:g,startColumn:f+1,endLineNumber:g,endColumn:m+2},url:h.substring(f,m+1)}}static computeLinks(w,h=k()){const g=A(),f=[];for(let b=1,m=w.getLineCount();b<=m;b++){const d=w.getLineContent(b),v=d.length;let r=0,o=0,l=0,s=1,a=!1,u=!1,n=!1,i=!1;for(;r<v;){let p=!1;const D=d.charCodeAt(r);if(s===13){let R;switch(D){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:n=!0,u=!0,R=0;break;case 93:n=!1,R=u?0:1;break;case 123:i=!0,R=0;break;case 125:R=i?0:1;break;case 39:case 34:case 96:l===D?R=1:l===39||l===34||l===96?R=0:R=1;break;case 42:R=l===42?1:0;break;case 124:R=l===124?1:0;break;case 32:R=n?0:1;break;default:R=g.get(D)}R===1&&(f.push(T._createLink(g,d,b,o,r)),p=!0)}else if(s===12){let R;D===91?(u=!0,R=0):R=g.get(D),R===1?p=!0:s=13}else s=h.nextState(s,D),s===0&&(p=!0);p&&(s=1,a=!1,u=!1,i=!1,o=r+1,l=D),r++}s===13&&f.push(T._createLink(g,d,b,o,v))}return f}}e.LinkComputer=T;function E(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:T.computeLinks(_)}e.computeLinks=E}),define(_e[105],ye([1,0,24]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace),this.bracketPairColorizationOptions=d.bracketPairColorizationOptions}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,d.bracketPairColorizationOptions)}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class A{constructor(d,v){this._findMatchBrand=void 0,this.range=d,this.matches=v}}e.FindMatch=A;var T;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var _;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class h{constructor(d,v,r,o,l,s){this.identifier=d,this.range=v,this.text=r,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=l,this._isTracked=s}}e.ValidAnnotatedEditOperation=h;class g{constructor(d,v,r){this.regex=d,this.wordSeparators=v,this.simpleSearch=r}}e.SearchData=g;class f{constructor(d,v,r){this.reverseEdits=d,this.changes=v,this.trimAutoWhitespaceLineNumbers=r}}e.ApplyEditsResult=f;function b(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(_e[152],ye([1,0,17,102]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,C){S=(0,t.toUint32)(S);const A=this.values,T=this.prefixSum,E=C.length;return E===0?!1:(this.values=new Uint32Array(A.length+E),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S),S+E),this.values.set(C,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.values[S]===C?!1:(this.values[S]=C,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const A=this.values,T=this.prefixSum;if(S>=A.length)return!1;const E=A.length-S;return C>=E&&(C=E),C===0?!1:(this.values=new Uint32Array(A.length-C),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S+C),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),S>=this.values.length&&(S=this.values.length-1);for(let A=C;A<=S;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,A=this.values.length-1,T=0,E=0,_=0;for(;C<=A;)if(T=C+(A-C)/2|0,E=this.prefixSum[T],_=E-this.values[T],S<_)A=T-1;else if(S>=E)C=T+1;else break;return new y(T,S-_)}}e.PrefixSumComputer=I;class P{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const C=this._indexBySum[S],A=C>0?this._prefixSum[C-1]:0;return new y(C,S-A)}removeValues(S,C){this._values.splice(S,C),this._invalidate(S)}insertValues(S,C){this._values=(0,c.arrayInsert)(this._values,S,C),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,C=this._values.length;S<C;S++){const A=this._values[S],T=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=T+A;for(let E=0;E<A;E++)this._indexBySum[T+E]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,C){this._values[S]!==C&&(this._values[S]=C,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=y}),define(_e[153],ye([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(_e[154],ye([1,0,153]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,P=I*24,y=P*7,k=P*30,S=P*365;function C(T,E,_){typeof T!="number"&&(T=T.getTime());const w=Math.round((new Date().getTime()-T)/1e3);if(w<-30)return(0,c.localize)(0,null,C(new Date().getTime()+w*1e3,!1));if(w<30)return(0,c.localize)(1,null);let h;return w<t?(h=w,E?h===1?_?(0,c.localize)(2,null,h):(0,c.localize)(3,null,h):_?(0,c.localize)(4,null,h):(0,c.localize)(5,null,h):h===1?_?(0,c.localize)(6,null,h):(0,c.localize)(7,null,h):_?(0,c.localize)(8,null,h):(0,c.localize)(9,null,h)):w<I?(h=Math.floor(w/t),E?h===1?_?(0,c.localize)(10,null,h):(0,c.localize)(11,null,h):_?(0,c.localize)(12,null,h):(0,c.localize)(13,null,h):h===1?_?(0,c.localize)(14,null,h):(0,c.localize)(15,null,h):_?(0,c.localize)(16,null,h):(0,c.localize)(17,null,h)):w<P?(h=Math.floor(w/I),E?h===1?_?(0,c.localize)(18,null,h):(0,c.localize)(19,null,h):_?(0,c.localize)(20,null,h):(0,c.localize)(21,null,h):h===1?_?(0,c.localize)(22,null,h):(0,c.localize)(23,null,h):_?(0,c.localize)(24,null,h):(0,c.localize)(25,null,h)):w<y?(h=Math.floor(w/P),E?h===1?(0,c.localize)(26,null,h):(0,c.localize)(27,null,h):h===1?(0,c.localize)(28,null,h):(0,c.localize)(29,null,h)):w<k?(h=Math.floor(w/y),E?h===1?_?(0,c.localize)(30,null,h):(0,c.localize)(31,null,h):_?(0,c.localize)(32,null,h):(0,c.localize)(33,null,h):h===1?_?(0,c.localize)(34,null,h):(0,c.localize)(35,null,h):_?(0,c.localize)(36,null,h):(0,c.localize)(37,null,h)):w<S?(h=Math.floor(w/k),E?h===1?_?(0,c.localize)(38,null,h):(0,c.localize)(39,null,h):_?(0,c.localize)(40,null,h):(0,c.localize)(41,null,h):h===1?_?(0,c.localize)(42,null,h):(0,c.localize)(43,null,h):_?(0,c.localize)(44,null,h):(0,c.localize)(45,null,h)):(h=Math.floor(w/S),E?h===1?_?(0,c.localize)(46,null,h):(0,c.localize)(47,null,h):_?(0,c.localize)(48,null,h):(0,c.localize)(49,null,h):h===1?_?(0,c.localize)(50,null,h):(0,c.localize)(51,null,h):_?(0,c.localize)(52,null,h):(0,c.localize)(53,null,h))}e.fromNow=C;function A(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(_e[155],ye([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(_e[50],ye([1,0,17,11,155]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(T,E){return E&&(T.stack||T.stacktrace)?I.localize(0,null,k(T),y(T.stack)||y(T.stacktrace)):k(T)}function y(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?I.localize(1,null,T.message):T.message||I.localize(2,null)}function S(T=null,E=!1){if(!T)return I.localize(3,null);if(Array.isArray(T)){const _=c.coalesce(T),w=S(_[0],E);return _.length>1?I.localize(4,null,w,_.length):w}if(t.isString(T))return T;if(T.detail){const _=T.detail;if(_.error)return P(_.error,E);if(_.exception)return P(_.exception,E)}return T.stack?P(T,E):T.message?T.message:I.localize(5,null)}e.toErrorMessage=S;function C(T){const E=T;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=C;function A(T,E){let _;return typeof T=="string"?_=new Error(T):_=T,_.actions=E,_}e.createErrorWithActions=A}),define(_e[156],ye([19,20]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(_e[12],ye([1,0,156]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,P=!1,y=!1,k=!1,S=!1,C=!1,A=!1,T=!1,E=!1,_,w=e.LANGUAGE_DEFAULT,h,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const b=typeof f?.versions?.electron=="string",m=b&&f?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,I=g.indexOf("Macintosh")>=0,A=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,_=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,w=_;else if(typeof f=="object"){t=f.platform==="win32",I=f.platform==="darwin",P=f.platform==="linux",y=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,C=b,T=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),p=i.availableLanguages["*"];_=i.locale,w=p||e.LANGUAGE_DEFAULT,h=i._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var d;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function v(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let r=0;I?r=1:t?r=3:P&&(r=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=P,e.isLinuxSnap=y,e.isNative=k,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=E,e.isCI=T,e.platform=r,e.userAgent=g,e.language=w;var o;(function(n){function i(){return e.language}n.value=i;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function D(){return e.language==="en"}n.isDefault=D})(o=e.Language||(e.Language={})),e.locale=_,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let D=0,R=n.length;D<R;D++){const N=n[D];if(N.id===p.data.vscodeScheduleAsyncWork){n.splice(D,1),N.callback();return}}});let i=0;return p=>{const D=++i;n.push({id:D,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:D},"*")}}return n=>setTimeout(n)})();var l;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||A?2:t?1:3;let s=!0,a=!1;function u(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,s=new Uint16Array(n.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(_e[36],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const I=c.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(_e[9],ye([1,0,36]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,P=90,y=122,k=46,S=47,C=92,A=58,T=63;class E extends Error{constructor(d,v,r){let o;typeof v=="string"&&v.indexOf("not ")===0?(o="must not be",v=v.replace(/^not /,"")):o="must be";const l=d.indexOf(".")!==-1?"property":"argument";let s=`The "${d}" ${l} ${o} of type ${v}`;s+=`. Received type ${typeof r}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function _(m,d){if(typeof m!="string")throw new E(d,"string",m)}function w(m){return m===S||m===C}function h(m){return m===S}function g(m){return m>=t&&m<=P||m>=I&&m<=y}function f(m,d,v,r){let o="",l=0,s=-1,a=0,u=0;for(let n=0;n<=m.length;++n){if(n<m.length)u=m.charCodeAt(n);else{if(r(u))break;u=S}if(r(u)){if(!(s===n-1||a===1))if(a===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const i=o.lastIndexOf(v);i===-1?(o="",l=0):(o=o.slice(0,i),l=o.length-1-o.lastIndexOf(v)),s=n,a=0;continue}else if(o.length!==0){o="",l=0,s=n,a=0;continue}}d&&(o+=o.length>0?`${v}..`:"..",l=2)}else o.length>0?o+=`${v}${m.slice(s+1,n)}`:o=m.slice(s+1,n),l=n-s-1;s=n,a=0}else u===k&&a!==-1?++a:a=-1}return o}function b(m,d){if(d===null||typeof d!="object")throw new E("pathObject","Object",d);const v=d.dir||d.root,r=d.base||`${d.name||""}${d.ext||""}`;return v?v===d.root?`${v}${r}`:`${v}${m}${r}`:r}e.win32={resolve(...m){let d="",v="",r=!1;for(let o=m.length-1;o>=-1;o--){let l;if(o>=0){if(l=m[o],_(l,"path"),l.length===0)continue}else d.length===0?l=c.cwd():(l=c.env[`=${d}`]||c.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==d.toLowerCase()&&l.charCodeAt(2)===C)&&(l=`${d}\\`));const s=l.length;let a=0,u="",n=!1;const i=l.charCodeAt(0);if(s===1)w(i)&&(a=1,n=!0);else if(w(i))if(n=!0,w(l.charCodeAt(1))){let p=2,D=p;for(;p<s&&!w(l.charCodeAt(p));)p++;if(p<s&&p!==D){const R=l.slice(D,p);for(D=p;p<s&&w(l.charCodeAt(p));)p++;if(p<s&&p!==D){for(D=p;p<s&&!w(l.charCodeAt(p));)p++;(p===s||p!==D)&&(u=`\\\\${R}\\${l.slice(D,p)}`,a=p)}}}else a=1;else g(i)&&l.charCodeAt(1)===A&&(u=l.slice(0,2),a=2,s>2&&w(l.charCodeAt(2))&&(n=!0,a=3));if(u.length>0)if(d.length>0){if(u.toLowerCase()!==d.toLowerCase())continue}else d=u;if(r){if(d.length>0)break}else if(v=`${l.slice(a)}\\${v}`,r=n,n&&d.length>0)break}return v=f(v,!r,"\\",w),r?`${d}\\${v}`:`${d}${v}`||"."},normalize(m){_(m,"path");const d=m.length;if(d===0)return".";let v=0,r,o=!1;const l=m.charCodeAt(0);if(d===1)return h(l)?"\\":m;if(w(l))if(o=!0,w(m.charCodeAt(1))){let a=2,u=a;for(;a<d&&!w(m.charCodeAt(a));)a++;if(a<d&&a!==u){const n=m.slice(u,a);for(u=a;a<d&&w(m.charCodeAt(a));)a++;if(a<d&&a!==u){for(u=a;a<d&&!w(m.charCodeAt(a));)a++;if(a===d)return`\\\\${n}\\${m.slice(u)}\\`;a!==u&&(r=`\\\\${n}\\${m.slice(u,a)}`,v=a)}}}else v=1;else g(l)&&m.charCodeAt(1)===A&&(r=m.slice(0,2),v=2,d>2&&w(m.charCodeAt(2))&&(o=!0,v=3));let s=v<d?f(m.slice(v),!o,"\\",w):"";return s.length===0&&!o&&(s="."),s.length>0&&w(m.charCodeAt(d-1))&&(s+="\\"),r===void 0?o?`\\${s}`:s:o?`${r}\\${s}`:`${r}${s}`},isAbsolute(m){_(m,"path");const d=m.length;if(d===0)return!1;const v=m.charCodeAt(0);return w(v)||d>2&&g(v)&&m.charCodeAt(1)===A&&w(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let d,v;for(let l=0;l<m.length;++l){const s=m[l];_(s,"path"),s.length>0&&(d===void 0?d=v=s:d+=`\\${s}`)}if(d===void 0)return".";let r=!0,o=0;if(typeof v=="string"&&w(v.charCodeAt(0))){++o;const l=v.length;l>1&&w(v.charCodeAt(1))&&(++o,l>2&&(w(v.charCodeAt(2))?++o:r=!1))}if(r){for(;o<d.length&&w(d.charCodeAt(o));)o++;o>=2&&(d=`\\${d.slice(o)}`)}return e.win32.normalize(d)},relative(m,d){if(_(m,"from"),_(d,"to"),m===d)return"";const v=e.win32.resolve(m),r=e.win32.resolve(d);if(v===r||(m=v.toLowerCase(),d=r.toLowerCase(),m===d))return"";let o=0;for(;o<m.length&&m.charCodeAt(o)===C;)o++;let l=m.length;for(;l-1>o&&m.charCodeAt(l-1)===C;)l--;const s=l-o;let a=0;for(;a<d.length&&d.charCodeAt(a)===C;)a++;let u=d.length;for(;u-1>a&&d.charCodeAt(u-1)===C;)u--;const n=u-a,i=s<n?s:n;let p=-1,D=0;for(;D<i;D++){const N=m.charCodeAt(o+D);if(N!==d.charCodeAt(a+D))break;N===C&&(p=D)}if(D!==i){if(p===-1)return r}else{if(n>i){if(d.charCodeAt(a+D)===C)return r.slice(a+D+1);if(D===2)return r.slice(a+D)}s>i&&(m.charCodeAt(o+D)===C?p=D:D===2&&(p=3)),p===-1&&(p=0)}let R="";for(D=o+p+1;D<=l;++D)(D===l||m.charCodeAt(D)===C)&&(R+=R.length===0?"..":"\\..");return a+=p,R.length>0?`${R}${r.slice(a,u)}`:(r.charCodeAt(a)===C&&++a,r.slice(a,u))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const d=e.win32.resolve(m);if(d.length<=2)return m;if(d.charCodeAt(0)===C){if(d.charCodeAt(1)===C){const v=d.charCodeAt(2);if(v!==T&&v!==k)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(g(d.charCodeAt(0))&&d.charCodeAt(1)===A&&d.charCodeAt(2)===C)return`\\\\?\\${d}`;return m},dirname(m){_(m,"path");const d=m.length;if(d===0)return".";let v=-1,r=0;const o=m.charCodeAt(0);if(d===1)return w(o)?m:".";if(w(o)){if(v=r=1,w(m.charCodeAt(1))){let a=2,u=a;for(;a<d&&!w(m.charCodeAt(a));)a++;if(a<d&&a!==u){for(u=a;a<d&&w(m.charCodeAt(a));)a++;if(a<d&&a!==u){for(u=a;a<d&&!w(m.charCodeAt(a));)a++;if(a===d)return m;a!==u&&(v=r=a+1)}}}}else g(o)&&m.charCodeAt(1)===A&&(v=d>2&&w(m.charCodeAt(2))?3:2,r=v);let l=-1,s=!0;for(let a=d-1;a>=r;--a)if(w(m.charCodeAt(a))){if(!s){l=a;break}}else s=!1;if(l===-1){if(v===-1)return".";l=v}return m.slice(0,l)},basename(m,d){d!==void 0&&_(d,"ext"),_(m,"path");let v=0,r=-1,o=!0,l;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===A&&(v=2),d!==void 0&&d.length>0&&d.length<=m.length){if(d===m)return"";let s=d.length-1,a=-1;for(l=m.length-1;l>=v;--l){const u=m.charCodeAt(l);if(w(u)){if(!o){v=l+1;break}}else a===-1&&(o=!1,a=l+1),s>=0&&(u===d.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=a))}return v===r?r=a:r===-1&&(r=m.length),m.slice(v,r)}for(l=m.length-1;l>=v;--l)if(w(m.charCodeAt(l))){if(!o){v=l+1;break}}else r===-1&&(o=!1,r=l+1);return r===-1?"":m.slice(v,r)},extname(m){_(m,"path");let d=0,v=-1,r=0,o=-1,l=!0,s=0;m.length>=2&&m.charCodeAt(1)===A&&g(m.charCodeAt(0))&&(d=r=2);for(let a=m.length-1;a>=d;--a){const u=m.charCodeAt(a);if(w(u)){if(!l){r=a+1;break}continue}o===-1&&(l=!1,o=a+1),u===k?v===-1?v=a:s!==1&&(s=1):v!==-1&&(s=-1)}return v===-1||o===-1||s===0||s===1&&v===o-1&&v===r+1?"":m.slice(v,o)},format:b.bind(null,"\\"),parse(m){_(m,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return d;const v=m.length;let r=0,o=m.charCodeAt(0);if(v===1)return w(o)?(d.root=d.dir=m,d):(d.base=d.name=m,d);if(w(o)){if(r=1,w(m.charCodeAt(1))){let p=2,D=p;for(;p<v&&!w(m.charCodeAt(p));)p++;if(p<v&&p!==D){for(D=p;p<v&&w(m.charCodeAt(p));)p++;if(p<v&&p!==D){for(D=p;p<v&&!w(m.charCodeAt(p));)p++;p===v?r=p:p!==D&&(r=p+1)}}}}else if(g(o)&&m.charCodeAt(1)===A){if(v<=2)return d.root=d.dir=m,d;if(r=2,w(m.charCodeAt(2))){if(v===3)return d.root=d.dir=m,d;r=3}}r>0&&(d.root=m.slice(0,r));let l=-1,s=r,a=-1,u=!0,n=m.length-1,i=0;for(;n>=r;--n){if(o=m.charCodeAt(n),w(o)){if(!u){s=n+1;break}continue}a===-1&&(u=!1,a=n+1),o===k?l===-1?l=n:i!==1&&(i=1):l!==-1&&(i=-1)}return a!==-1&&(l===-1||i===0||i===1&&l===a-1&&l===s+1?d.base=d.name=m.slice(s,a):(d.name=m.slice(s,l),d.base=m.slice(s,a),d.ext=m.slice(l,a))),s>0&&s!==r?d.dir=m.slice(0,s-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let d="",v=!1;for(let r=m.length-1;r>=-1&&!v;r--){const o=r>=0?m[r]:c.cwd();_(o,"path"),o.length!==0&&(d=`${o}/${d}`,v=o.charCodeAt(0)===S)}return d=f(d,!v,"/",h),v?`/${d}`:d.length>0?d:"."},normalize(m){if(_(m,"path"),m.length===0)return".";const d=m.charCodeAt(0)===S,v=m.charCodeAt(m.length-1)===S;return m=f(m,!d,"/",h),m.length===0?d?"/":v?"./":".":(v&&(m+="/"),d?`/${m}`:m)},isAbsolute(m){return _(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let d;for(let v=0;v<m.length;++v){const r=m[v];_(r,"path"),r.length>0&&(d===void 0?d=r:d+=`/${r}`)}return d===void 0?".":e.posix.normalize(d)},relative(m,d){if(_(m,"from"),_(d,"to"),m===d||(m=e.posix.resolve(m),d=e.posix.resolve(d),m===d))return"";const v=1,r=m.length,o=r-v,l=1,s=d.length-l,a=o<s?o:s;let u=-1,n=0;for(;n<a;n++){const p=m.charCodeAt(v+n);if(p!==d.charCodeAt(l+n))break;p===S&&(u=n)}if(n===a)if(s>a){if(d.charCodeAt(l+n)===S)return d.slice(l+n+1);if(n===0)return d.slice(l+n)}else o>a&&(m.charCodeAt(v+n)===S?u=n:n===0&&(u=0));let i="";for(n=v+u+1;n<=r;++n)(n===r||m.charCodeAt(n)===S)&&(i+=i.length===0?"..":"/..");return`${i}${d.slice(l+u)}`},toNamespacedPath(m){return m},dirname(m){if(_(m,"path"),m.length===0)return".";const d=m.charCodeAt(0)===S;let v=-1,r=!0;for(let o=m.length-1;o>=1;--o)if(m.charCodeAt(o)===S){if(!r){v=o;break}}else r=!1;return v===-1?d?"/":".":d&&v===1?"//":m.slice(0,v)},basename(m,d){d!==void 0&&_(d,"ext"),_(m,"path");let v=0,r=-1,o=!0,l;if(d!==void 0&&d.length>0&&d.length<=m.length){if(d===m)return"";let s=d.length-1,a=-1;for(l=m.length-1;l>=0;--l){const u=m.charCodeAt(l);if(u===S){if(!o){v=l+1;break}}else a===-1&&(o=!1,a=l+1),s>=0&&(u===d.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=a))}return v===r?r=a:r===-1&&(r=m.length),m.slice(v,r)}for(l=m.length-1;l>=0;--l)if(m.charCodeAt(l)===S){if(!o){v=l+1;break}}else r===-1&&(o=!1,r=l+1);return r===-1?"":m.slice(v,r)},extname(m){_(m,"path");let d=-1,v=0,r=-1,o=!0,l=0;for(let s=m.length-1;s>=0;--s){const a=m.charCodeAt(s);if(a===S){if(!o){v=s+1;break}continue}r===-1&&(o=!1,r=s+1),a===k?d===-1?d=s:l!==1&&(l=1):d!==-1&&(l=-1)}return d===-1||r===-1||l===0||l===1&&d===r-1&&d===v+1?"":m.slice(d,r)},format:b.bind(null,"/"),parse(m){_(m,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return d;const v=m.charCodeAt(0)===S;let r;v?(d.root="/",r=1):r=0;let o=-1,l=0,s=-1,a=!0,u=m.length-1,n=0;for(;u>=r;--u){const i=m.charCodeAt(u);if(i===S){if(!a){l=u+1;break}continue}s===-1&&(a=!1,s=u+1),i===k?o===-1?o=u:n!==1&&(n=1):o!==-1&&(n=-1)}if(s!==-1){const i=l===0&&v?1:l;o===-1||n===0||n===1&&o===s-1&&o===l+1?d.base=d.name=m.slice(i,s):(d.name=m.slice(i,o),d.base=m.slice(i,s),d.ext=m.slice(o,s))}return l>0?d.dir=m.slice(0,l-1):v&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=c.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=c.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=c.platform==="win32"?e.win32.join:e.posix.join,e.resolve=c.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=c.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=c.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=c.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=c.platform==="win32"?e.win32.extname:e.posix.extname,e.format=c.platform==="win32"?e.win32.format:e.posix.format,e.parse=c.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=c.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=c.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=c.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(_e[81],ye([1,0,9]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const T=(0,c.extname)(A),E=t[T.toLowerCase()];return E!==void 0?E:y(A)}e.getMediaOrTextMime=P;function y(A){const T=(0,c.extname)(A);return I[T.toLowerCase()]}e.getMediaMime=y;function k(A){for(const T in I)if(I[T]===A)return T}e.getExtensionForMimeType=k;const S=/^(.+)\/(.+?)(;.+)?$/;function C(A,T){const E=S.exec(A);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:T?void 0:A}e.normalizeMimeType=C}),define(_e[106],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(k,...S){const C=S.reduce((E,_)=>(E[_]=!0,E),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(E=>!C[E]).forEach(E=>{for(let _=0;_<A.length;_++)if(E.search(A[_])!==-1){delete k[E];break}})}e.sanitizeProcessEnvironment=P;function y(k){!k||(delete k.DEBUG,c.isMacintosh&&delete k.DYLD_LIBRARY_PATH,c.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(_e[51],ye([1,0,12]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class I{static create(y=!0){return new I(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?c.globals.performance.now():Date.now()}}e.StopWatch=I}),define(_e[4],ye([1,0,10,61,6,63,51]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,S=!1;var C;(function(u){u.None=()=>I.Disposable.None;function n(Ce){if(S){const{onDidAddListener:Re}=Ce,We=w.create();let ne=0;Ce.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),We.print()),Re?.()}}}function i(Ce,Re){return B(Ce,()=>{},0,void 0,void 0,Re)}u.defer=i;function p(Ce,Re=0,We){return u.debounce(Ce,(ne,ce)=>ne?(ne.push(ce),ne):[ce],Re,void 0,void 0,We)}u.accumulate=p;function D(Ce){return(Re,We=null,ne)=>{let ce=!1,fe;return fe=Ce(J=>{if(!ce)return fe?fe.dispose():ce=!0,Re.call(We,J)},null,ne),ce&&fe.dispose(),fe}}u.once=D;function R(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>ne.call(ce,Re(J)),null,fe),We)}u.map=R;function N(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>{Re(J),ne.call(ce,J)},null,fe),We)}u.forEach=N;function V(Ce,Re,We){return F((ne,ce=null,fe)=>Ce(J=>Re(J)&&ne.call(ce,J),null,fe),We)}u.filter=V;function x(Ce){return Ce}u.signal=x;function L(...Ce){return(Re,We=null,ne)=>(0,I.combinedDisposable)(...Ce.map(ce=>ce(fe=>Re.call(We,fe),null,ne)))}u.any=L;function U(Ce,Re,We,ne){let ce=We;return R(Ce,fe=>(ce=Re(ce,fe),ce),ne)}u.reduce=U;function F(Ce,Re){let We;const ne={onWillAddFirstListener(){We=Ce(ce.fire,ce)},onDidRemoveLastListener(){We?.dispose()}};Re||n(ne);const ce=new g(ne);return Re?.add(ce),ce.event}function B(Ce,Re,We=100,ne=!1,ce,fe){let J,ie,te,O=0;const W={leakWarningThreshold:ce,onWillAddFirstListener(){J=Ce(X=>{O++,ie=Re(ie,X),ne&&!te&&(q.fire(ie),ie=void 0),clearTimeout(te),te=setTimeout(()=>{const ae=ie;ie=void 0,te=void 0,(!ne||O>1)&&q.fire(ae),O=0},We)})},onDidRemoveLastListener(){J.dispose()}};fe||n(W);const q=new g(W);return fe?.add(q),q.event}u.debounce=B;function M(Ce,Re=(ne,ce)=>ne===ce,We){let ne=!0,ce;return V(Ce,fe=>{const J=ne||!Re(fe,ce);return ne=!1,ce=fe,J},We)}u.latch=M;function z(Ce,Re,We){return[u.filter(Ce,Re,We),u.filter(Ce,ne=>!Re(ne),We)]}u.split=z;function j(Ce,Re=!1,We=[]){let ne=We.slice(),ce=Ce(ie=>{ne?ne.push(ie):J.fire(ie)});const fe=()=>{ne?.forEach(ie=>J.fire(ie)),ne=null},J=new g({onWillAddFirstListener(){ce||(ce=Ce(ie=>J.fire(ie)))},onDidAddFirstListener(){ne&&(Re?setTimeout(fe):fe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return J.event}u.buffer=j;class ${constructor(Re){this.event=Re,this.disposables=new I.DisposableStore}map(Re){return new $(R(this.event,Re,this.disposables))}forEach(Re){return new $(N(this.event,Re,this.disposables))}filter(Re){return new $(V(this.event,Re,this.disposables))}reduce(Re,We){return new $(U(this.event,Re,We,this.disposables))}latch(){return new $(M(this.event,void 0,this.disposables))}debounce(Re,We=100,ne=!1,ce){return new $(B(this.event,Re,We,ne,ce,this.disposables))}on(Re,We,ne){return this.event(Re,We,ne)}once(Re,We,ne){return D(this.event)(Re,We,ne)}dispose(){this.disposables.dispose()}}function Q(Ce){return new $(Ce)}u.chain=Q;function K(Ce,Re,We=ne=>ne){const ne=(...ie)=>J.fire(We(...ie)),ce=()=>Ce.on(Re,ne),fe=()=>Ce.removeListener(Re,ne),J=new g({onWillAddFirstListener:ce,onDidRemoveLastListener:fe});return J.event}u.fromNodeEventEmitter=K;function ue(Ce,Re,We=ne=>ne){const ne=(...ie)=>J.fire(We(...ie)),ce=()=>Ce.addEventListener(Re,ne),fe=()=>Ce.removeEventListener(Re,ne),J=new g({onWillAddFirstListener:ce,onDidRemoveLastListener:fe});return J.event}u.fromDOMEventEmitter=ue;function re(Ce){return new Promise(Re=>D(Ce)(Re))}u.toPromise=re;function de(Ce,Re){return Re(void 0),Ce(We=>Re(We))}u.runAndSubscribe=de;function Y(Ce,Re){let We=null;function ne(fe){We?.dispose(),We=new I.DisposableStore,Re(fe,We)}ne(void 0);const ce=Ce(fe=>ne(fe));return(0,I.toDisposable)(()=>{ce.dispose(),We?.dispose()})}u.runAndSubscribeWithStore=Y;class pe{constructor(Re,We){this.obs=Re,this._counter=0,this._hasChanged=!1;const ne={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};We||n(ne),this.emitter=new g(ne),We&&We.add(this.emitter)}beginUpdate(Re){this._counter++}handleChange(Re,We){this._hasChanged=!0}endUpdate(Re){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function be(Ce,Re){return new pe(Ce,Re).emitter.event}u.fromObservable=be})(C=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new y.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let T=-1;function E(u){const n=T;return T=u,{dispose(){T=n}}}e.setGlobalLeakWarningThreshold=E;class _{constructor(n,i=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(n,i){const p=this.threshold;if(p<=0||i<p)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let R,N=0;for(const[V,x]of this._stacks)(!R||N<x)&&(R=V,N=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${N}):`),console.warn(R)}return()=>{const R=this._stacks.get(n.value)||0;this._stacks.set(n.value,R-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,i,p){this.callback=n,this.callbackThis=i,this.stack=p,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=T>0||this._options?.leakWarningThreshold?new _(this._options?.leakWarningThreshold??T):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,i,p)=>{if(this._listeners||(this._listeners=new P.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const D=this._listeners.isEmpty();D&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let R,N;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(N=w.create(),R=this._leakageMon.check(N,this._listeners.size+1)),k&&(N=N??w.create());const V=new h(n,i,N),x=this._listeners.push(V);D&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,n,i);const L=V.subscription.set(()=>{R?.(),this._disposed||(x(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return p instanceof I.DisposableStore?p.add(L):Array.isArray(p)&&p.push(L),L}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b);for(const i of this._listeners)this._deliveryQueue.push(this,i,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,i,p){this._queue.push(new m(n,i,p))}clear(n){const i=new P.LinkedList;for(const p of this._queue)p.emitter!==n&&i.push(p);this._queue=i}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(i){(0,c.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=f;class b extends f{clear(n){this._queue.clear()}}class m{constructor(n,i,p){this.emitter=n,this.listener=i,this.event=p}}class d extends g{async fireAsync(n,i,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const D of this._listeners)this._asyncDeliveryQueue.push([D,n]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[D,R]=this._asyncDeliveryQueue.shift(),N=[],V={...R,token:i,waitUntil:x=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");p&&(x=p(x,D.callback)),N.push(x)}};try{D.invoke(V)}catch(x){(0,c.onUnexpectedError)(x);continue}Object.freeze(N),await Promise.allSettled(N).then(x=>{for(const L of x)L.status==="rejected"&&(0,c.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=d;class v extends g{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=v;class r extends v{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=r;class o extends g{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const p=()=>{this.hasListeners&&this.unhook(i);const D=this.events.indexOf(i);this.events.splice(D,1)};return(0,I.toDisposable)((0,t.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class s{constructor(){this.buffers=[]}wrapEvent(n){return(i,p,D)=>n(R=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>i.call(p,R)):i.call(p,R)},void 0,D)}bufferEvents(n){const i=[];this.buffers.push(i);const p=n();return this.buffers.pop(),i.forEach(D=>D()),p}}e.EventBufferer=s;class a{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new g({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(_e[21],ye([1,0,4]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,S){const C=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(C)}}});var I;(function(k){function S(C){return C===k.None||C===k.Cancelled||C instanceof P?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=y}),define(_e[157],ye([1,0,21]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new c.CancellationTokenSource,S=this.task(k.token);return this.result={promise:S,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=t;class I{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const S=JSON.stringify(k);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=I;class P{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const S=this.fn(k);return this._map.set(k,S),S}}e.CachedFunction=P}),define(_e[158],ye([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=y=>({onDidChange:c.Event.None,value:y});e.staticObservableValue=I;class P extends t.Disposable{get value(){return this._value}set value(k){k!==this._value&&(this._value=k,this.changeEmitter.fire(k))}constructor(k){super(),this._value=k,this.changeEmitter=this._register(new c.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(_e[8],ye([1,0,157,79]),function(Z,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function k(le,...Pe){return Pe.length===0?le:le.replace(y,function(Le,Fe){const Ge=parseInt(Fe,10);return isNaN(Ge)||Ge<0||Ge>=Pe.length?Le:Pe[Ge]})}e.format=k;const S=/{([^}]+)}/g;function C(le,Pe){return le.replace(S,(Le,Fe)=>Pe[Fe]??Le)}e.format2=C;function A(le){return le.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=A;function T(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function E(le,Pe){let Le=0;const Fe=Pe.charCodeAt(0);for(let Ge=le.length-1;Ge>=0;Ge--)le.charCodeAt(Ge)===Fe&&Le++;return Le}e.count=E;function _(le,Pe,Le="\u2026"){return le.length<=Pe?le:`${le.substr(0,Pe)}${Le}`}e.truncate=_;function w(le,Pe=" "){const Le=h(le,Pe);return g(Le,Pe)}e.trim=w;function h(le,Pe){if(!le||!Pe)return le;const Le=Pe.length;if(Le===0||le.length===0)return le;let Fe=0;for(;le.indexOf(Pe,Fe)===Fe;)Fe=Fe+Le;return le.substring(Fe)}e.ltrim=h;function g(le,Pe){if(!le||!Pe)return le;const Le=Pe.length,Fe=le.length;if(Le===0||Fe===0)return le;let Ge=Fe,Je=-1;for(;Je=le.lastIndexOf(Pe,Ge-1),!(Je===-1||Je+Le!==Ge);){if(Je===0)return"";Ge=Je}return le.substring(0,Ge)}e.rtrim=g;function f(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function b(le){return le.replace(/\*/g,"")}e.stripWildcards=b;function m(le,Pe,Le={}){if(!le)throw new Error("Cannot create regex from empty string");Pe||(le=T(le)),Le.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Fe="";return Le.global&&(Fe+="g"),Le.matchCase||(Fe+="i"),Le.multiline&&(Fe+="m"),Le.unicode&&(Fe+="u"),new RegExp(le,Fe)}e.createRegExp=m;function d(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function v(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function r(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=r;function o(le){return le.split(/\r\n|\r|\n/)}e.splitLines=o;function l(le){for(let Pe=0,Le=le.length;Pe<Le;Pe++){const Fe=le.charCodeAt(Pe);if(Fe!==32&&Fe!==9)return Pe}return-1}e.firstNonWhitespaceIndex=l;function s(le,Pe=0,Le=le.length){for(let Fe=Pe;Fe<Le;Fe++){const Ge=le.charCodeAt(Fe);if(Ge!==32&&Ge!==9)return le.substring(Pe,Fe)}return le.substring(Pe,Le)}e.getLeadingWhitespace=s;function a(le,Pe=le.length-1){for(let Le=Pe;Le>=0;Le--){const Fe=le.charCodeAt(Le);if(Fe!==32&&Fe!==9)return Le}return-1}e.lastNonWhitespaceIndex=a;function u(le,Pe,Le){const Fe=[];let Ge=0;for(const Je of le.matchAll(Pe)){if(Fe.push(le.slice(Ge,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ge=Je.index+Je[0].length,Fe.push(Le(Je[0],...Je.slice(1),Je.index,le,Je.groups))}return Fe.push(le.slice(Ge)),Promise.all(Fe).then(Je=>Je.join(""))}e.replaceAsync=u;function n(le,Pe){return le<Pe?-1:le>Pe?1:0}e.compare=n;function i(le,Pe,Le=0,Fe=le.length,Ge=0,Je=Pe.length){for(;Le<Fe&&Ge<Je;Le++,Ge++){const rt=le.charCodeAt(Le),Ze=Pe.charCodeAt(Ge);if(rt<Ze)return-1;if(rt>Ze)return 1}const it=Fe-Le,vt=Je-Ge;return it<vt?-1:it>vt?1:0}e.compareSubstring=i;function p(le,Pe){return D(le,Pe,0,le.length,0,Pe.length)}e.compareIgnoreCase=p;function D(le,Pe,Le=0,Fe=le.length,Ge=0,Je=Pe.length){for(;Le<Fe&&Ge<Je;Le++,Ge++){let rt=le.charCodeAt(Le),Ze=Pe.charCodeAt(Ge);if(rt===Ze)continue;if(rt>=128||Ze>=128)return i(le.toLowerCase(),Pe.toLowerCase(),Le,Fe,Ge,Je);N(rt)&&(rt-=32),N(Ze)&&(Ze-=32);const wt=rt-Ze;if(wt!==0)return wt}const it=Fe-Le,vt=Je-Ge;return it<vt?-1:it>vt?1:0}e.compareSubstringIgnoreCase=D;function R(le){return le>=48&&le<=57}e.isAsciiDigit=R;function N(le){return le>=97&&le<=122}e.isLowerAsciiLetter=N;function V(le){return le>=65&&le<=90}e.isUpperAsciiLetter=V;function x(le,Pe){return le.length===Pe.length&&D(le,Pe)===0}e.equalsIgnoreCase=x;function L(le,Pe){const Le=Pe.length;return Pe.length>le.length?!1:D(le,Pe,0,Le)===0}e.startsWithIgnoreCase=L;function U(le,Pe){const Le=Math.min(le.length,Pe.length);let Fe;for(Fe=0;Fe<Le;Fe++)if(le.charCodeAt(Fe)!==Pe.charCodeAt(Fe))return Fe;return Le}e.commonPrefixLength=U;function F(le,Pe){const Le=Math.min(le.length,Pe.length);let Fe;const Ge=le.length-1,Je=Pe.length-1;for(Fe=0;Fe<Le;Fe++)if(le.charCodeAt(Ge-Fe)!==Pe.charCodeAt(Je-Fe))return Fe;return Le}e.commonSuffixLength=F;function B(le){return 55296<=le&&le<=56319}e.isHighSurrogate=B;function M(le){return 56320<=le&&le<=57343}e.isLowSurrogate=M;function z(le,Pe){return(le-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=z;function j(le,Pe,Le){const Fe=le.charCodeAt(Le);if(B(Fe)&&Le+1<Pe){const Ge=le.charCodeAt(Le+1);if(M(Ge))return z(Fe,Ge)}return Fe}e.getNextCodePoint=j;function $(le,Pe){const Le=le.charCodeAt(Pe-1);if(M(Le)&&Pe>1){const Fe=le.charCodeAt(Pe-2);if(B(Fe))return z(Fe,Le)}return Le}class Q{get offset(){return this._offset}constructor(Pe,Le=0){this._str=Pe,this._len=Pe.length,this._offset=Le}setOffset(Pe){this._offset=Pe}prevCodePoint(){const Pe=$(this._str,this._offset);return this._offset-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=j(this._str,this._len,this._offset);return this._offset+=Pe>=65536?2:1,Pe}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Pe,Le=0){this._iterator=new Q(Pe,Le)}nextGraphemeLength(){const Pe=nt.getInstance(),Le=this._iterator,Fe=Le.offset;let Ge=Pe.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Je=Le.offset,it=Pe.getGraphemeBreakType(Le.nextCodePoint());if(xe(Ge,it)){Le.setOffset(Je);break}Ge=it}return Le.offset-Fe}prevGraphemeLength(){const Pe=nt.getInstance(),Le=this._iterator,Fe=Le.offset;let Ge=Pe.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Je=Le.offset,it=Pe.getGraphemeBreakType(Le.prevCodePoint());if(xe(it,Ge)){Le.setOffset(Je);break}Ge=it}return Fe-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function ue(le,Pe){return new K(le,Pe).nextGraphemeLength()}e.nextCharLength=ue;function re(le,Pe){return new K(le,Pe).prevGraphemeLength()}e.prevCharLength=re;function de(le,Pe){Pe>0&&M(le.charCodeAt(Pe))&&Pe--;const Le=Pe+ue(le,Pe);return[Le-re(le,Le),Le]}e.getCharContainingOffset=de;function Y(le){const Pe=new K(le);let Le=0;for(;!Pe.eol();)Le++,Pe.nextGraphemeLength();return Le}e.charCount=Y;let pe;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ce(le){return pe||(pe=be()),pe.test(le)}e.containsRTL=Ce;const Re=/^[\t\n\r\x20-\x7E]*$/;function We(le){return Re.test(le)}e.isBasicASCII=We,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=ne;function ce(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=ce;function fe(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129008||le>=129280&&le<=129535||le>=129648&&le<=129782}e.isEmojiImprecise=fe;function J(le,Pe){if(le.length<Pe)return le;const Le=/\b/g;let Fe=0;for(;Le.test(le)&&!(le.length-Le.lastIndex<Pe);)Fe=Le.lastIndex,Le.lastIndex+=1;return le.substring(Fe).replace(/^\s/,"")}e.lcut=J;const ie=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function W(le){return le&&(le=le.replace(ie,""),le=le.replace(te,""),le=le.replace(O,"")),le}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function q(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=q;function X(le){return q(le)?le.substr(1):le}e.stripUTF8BOM=X;function ae(le,Pe){if(!le||!Pe||le.length<Pe.length)return!1;const Le=Pe.length,Fe=le.toLowerCase();let Ge=0,Je=-1;for(;Ge<Le;){const it=Fe.indexOf(Pe[Ge],Je+1);if(it<0)return!1;Je=it,Ge++}return!0}e.fuzzyContains=ae;function ve(le,Pe=!1){return le?(Pe&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=ve;function Te(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Te;function ge(le,Pe=1){if(Pe===0)return"";let Le=-1;do Le=le.indexOf(`
`,Le+1),Pe--;while(Pe>0&&Le>=0);return Le===-1?le:(le[Le-1]==="\r"&&Le--,le.substr(0,Le))}e.getNLines=ge;function ke(le){return le=le%(2*26),le<26?String.fromCharCode(97+le):String.fromCharCode(65+le-26)}e.singleLetterHash=ke;function De(le){return nt.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=De;function xe(le,Pe){return le===0?Pe!==5&&Pe!==7:le===2&&Pe===3?!1:le===4||le===2||le===3||Pe===4||Pe===2||Pe===3?!0:!(le===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(le===11||le===9)&&(Pe===9||Pe===10)||(le===12||le===10)&&Pe===10||Pe===5||Pe===13||Pe===7||le===1||le===13&&Pe===14||le===6&&Pe===6)}var qe;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}constructor(){this._data=Xe()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Le=this._data,Fe=Le.length/3;let Ge=1;for(;Ge<=Fe;)if(Pe<Le[3*Ge])Ge=2*Ge;else if(Pe>Le[3*Ge+1])Ge=2*Ge+1;else return Le[3*Ge+2];return 0}}nt._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(le,Pe){if(le===0)return 0;const Le=Be(le,Pe);if(Le!==void 0)return Le;const Fe=new Q(Pe,le);return Fe.prevCodePoint(),Fe.offset}e.getLeftDeleteOffset=st;function Be(le,Pe){const Le=new Q(Pe,le);let Fe=Le.prevCodePoint();for(;dt(Fe)||Fe===65039||Fe===8419;){if(Le.offset===0)return;Fe=Le.prevCodePoint()}if(!fe(Fe))return;let Ge=Le.offset;return Ge>0&&Le.prevCodePoint()===8205&&(Ge=Le.offset),Ge}function dt(le){return 127995<=le&&le<=127999}var se;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class oe{static getInstance(Pe){return oe.cache.get(Array.from(Pe))}static getLocales(){return oe._locales.getValue()}constructor(Pe){this.confusableDictionary=Pe}isAmbiguous(Pe){return this.confusableDictionary.has(Pe)}getPrimaryConfusable(Pe){return this.confusableDictionary.get(Pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=oe,I=oe,oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),oe.cache=new c.LRUCachedFunction(le=>{function Pe(Ze){const wt=new Map;for(let Et=0;Et<Ze.length;Et+=2)wt.set(Ze[Et],Ze[Et+1]);return wt}function Le(Ze,wt){const Et=new Map(Ze);for(const[kt,ft]of wt)Et.set(kt,ft);return Et}function Fe(Ze,wt){if(!Ze)return wt;const Et=new Map;for(const[kt,ft]of Ze)wt.has(kt)&&Et.set(kt,ft);return Et}const Ge=I.ambiguousCharacterData.getValue();let Je=le.filter(Ze=>!Ze.startsWith("_")&&Ze in Ge);Je.length===0&&(Je=["_default"]);let it;for(const Ze of Je){const wt=Pe(Ge[Ze]);it=Fe(it,wt)}const vt=Pe(Ge._common),rt=Le(vt,it);return new oe(rt)}),oe._locales=new t.Lazy(()=>Object.keys(oe.ambiguousCharacterData.getValue()).filter(le=>!le.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(Pe){return Se.getData().has(Pe)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(_e[32],ye([1,0,9,12,8,11]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(a){return a===47||a===92}e.isPathSeparator=y;function k(a){return a.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=k;function S(a){return a.indexOf("/")===-1&&(a=k(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function C(a,u=c.posix.sep){if(!a)return"";const n=a.length,i=a.charCodeAt(0);if(y(i)){if(y(a.charCodeAt(1))&&!y(a.charCodeAt(2))){let D=3;const R=D;for(;D<n&&!y(a.charCodeAt(D));D++);if(R!==D&&!y(a.charCodeAt(D+1))){for(D+=1;D<n;D++)if(y(a.charCodeAt(D)))return a.slice(0,D+1).replace(/[\\/]/g,u)}}return u}else if(f(i)&&a.charCodeAt(1)===58)return y(a.charCodeAt(2))?a.slice(0,2)+u:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(y(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.getRoot=C;function A(a){if(!t.isWindows||!a||a.length<5)return!1;let u=a.charCodeAt(0);if(u!==92||(u=a.charCodeAt(1),u!==92))return!1;let n=2;const i=n;for(;n<a.length&&(u=a.charCodeAt(n),u!==92);n++);return!(i===n||(u=a.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=A;const T=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(a,u=t.isWindows){const n=u?T:E;return!(!a||a.length===0||/^\s+$/.test(a)||(n.lastIndex=0,n.test(a))||u&&_.test(a)||a==="."||a===".."||u&&a[a.length-1]==="."||u&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=w;function h(a,u,n){const i=a===u;return!n||i?i:!a||!u?!1:(0,I.equalsIgnoreCase)(a,u)}e.isEqual=h;function g(a,u,n,i=c.sep){if(a===u)return!0;if(!a||!u||u.length>a.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(a,u))return!1;if(u.length===a.length)return!0;let D=u.length;return u.charAt(u.length-1)===i&&D--,a.charAt(D)===i}return u.charAt(u.length-1)!==i&&(u+=i),a.indexOf(u)===0}e.isEqualOrParent=g;function f(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=f;function b(a,u){return t.isWindows&&a.endsWith(":")&&(a+=c.sep),(0,c.isAbsolute)(a)||(a=(0,c.join)(u,a)),a=(0,c.normalize)(a),t.isWindows?(a=(0,I.rtrim)(a,c.sep),a.endsWith(":")&&(a+=c.sep)):(a=(0,I.rtrim)(a,c.sep),a||(a=c.sep)),a}e.sanitizeFilePath=b;function m(a){const u=(0,c.normalize)(a);return t.isWindows?a.length>3?!1:d(u)&&(a.length===2||u.charCodeAt(2)===92):u===c.posix.sep}e.isRootOrDriveLetter=m;function d(a,u=t.isWindows){return u?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function v(a){return d(a)?a[0]:void 0}e.getDriveLetter=v;function r(a,u,n){return u.length>a.length?-1:a===u?0:(n&&(a=a.toLowerCase(),u=u.toLowerCase()),a.indexOf(u))}e.indexOfPath=r;function o(a){const u=a.split(":");let n,i,p;for(const D of u){const R=Number(D);(0,P.isNumber)(R)?i===void 0?i=R:p===void 0&&(p=R):n=n?[n,D].join(":"):D}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:p!==void 0?p:i!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(a,u,n=8){let i="";for(let D=0;D<n;D++)i+=l.charAt(Math.floor(Math.random()*l.length));let p;return u?p=`${u}-${i}`:p=i,a?(0,c.join)(a,p):p}e.randomPath=s}),define(_e[107],ye([1,0,28,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...te){return function(O,W){for(let q=0,X=te.length;q<X;q++){const ae=te[q](O,W);if(ae)return ae}return null}}e.or=I,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(te,O,W){if(!W||W.length<O.length)return null;let q;return te?q=t.startsWithIgnoreCase(W,O):q=W.indexOf(O)===0,q?O.length>0?[{start:0,end:O.length}]:[]:null}function y(te,O){const W=O.toLowerCase().indexOf(te.toLowerCase());return W===-1?null:[{start:W,end:W+te.length}]}e.matchesContiguousSubString=y;function k(te,O){return S(te.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=k;function S(te,O,W,q){if(W===te.length)return[];if(q===O.length)return null;if(te[W]===O[q]){let X=null;return(X=S(te,O,W+1,q+1))?f({start:q,end:q+1},X):null}return S(te,O,W,q+1)}function C(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.isUpper=A;function T(te){return 48<=te&&te<=57}function E(te){return te===32||te===9||te===10||te===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>_.add(te.charCodeAt(0)));function w(te){return E(te)||_.has(te)}function h(te,O){return te===O||w(te)&&w(O)}function g(te){return C(te)||A(te)||T(te)}function f(te,O){return O.length===0?O=[te]:te.end===O[0].start?O[0].start=te.start:O.unshift(te),O}function b(te,O){for(let W=O;W<te.length;W++){const q=te.charCodeAt(W);if(A(q)||T(q)||W>0&&!g(te.charCodeAt(W-1)))return W}return te.length}function m(te,O,W,q){if(W===te.length)return[];if(q===O.length)return null;if(te[W]!==O[q].toLowerCase())return null;{let X=null,ae=q+1;for(X=m(te,O,W+1,q+1);!X&&(ae=b(O,ae))<O.length;)X=m(te,O,W+1,ae),ae++;return X===null?null:f({start:q,end:q+1},X)}}function d(te){let O=0,W=0,q=0,X=0,ae=0;for(let De=0;De<te.length;De++)ae=te.charCodeAt(De),A(ae)&&O++,C(ae)&&W++,g(ae)&&q++,T(ae)&&X++;const ve=O/te.length,Te=W/te.length,ge=q/te.length,ke=X/te.length;return{upperPercent:ve,lowerPercent:Te,alphaPercent:ge,numericPercent:ke}}function v(te){const{upperPercent:O,lowerPercent:W}=te;return W===0&&O>.6}function r(te){const{upperPercent:O,lowerPercent:W,alphaPercent:q,numericPercent:X}=te;return W>.2&&O<.8&&q>.6&&X<.2}function o(te){let O=0,W=0,q=0,X=0;for(let ae=0;ae<te.length;ae++)q=te.charCodeAt(ae),A(q)&&O++,C(q)&&W++,E(q)&&X++;return(O===0||W===0)&&X===0?te.length<=30:O<=5}function l(te,O){if(!O||(O=O.trim(),O.length===0)||!o(te)||O.length>60)return null;const W=d(O);if(!r(W)){if(!v(W))return null;O=O.toLowerCase()}let q=null,X=0;for(te=te.toLowerCase();X<O.length&&(q=m(te,O,0,X))===null;)X=b(O,X+1);return q}e.matchesCamelCase=l;function s(te,O,W=!1){if(!O||O.length===0)return null;let q=null,X=0;for(te=te.toLowerCase(),O=O.toLowerCase();X<O.length&&(q=a(te,O,0,X,W))===null;)X=u(O,X+1);return q}e.matchesWords=s;function a(te,O,W,q,X){if(W===te.length)return[];if(q===O.length)return null;if(h(te.charCodeAt(W),O.charCodeAt(q))){let ae=null,ve=q+1;if(ae=a(te,O,W+1,q+1,X),!X)for(;!ae&&(ve=u(O,ve))<O.length;)ae=a(te,O,W+1,ve,X),ve++;return ae?te.charCodeAt(W)!==O.charCodeAt(q)?ae:f({start:q,end:q+1},ae):null}else return null}function u(te,O){for(let W=O;W<te.length;W++)if(w(te.charCodeAt(W))||W>0&&w(te.charCodeAt(W-1)))return W;return te.length}const n=I(e.matchesPrefix,l,y),i=I(e.matchesPrefix,l,k),p=new c.LRUCache(1e4);function D(te,O,W=!1){if(typeof te!="string"||typeof O!="string")return null;let q=p.get(te);q||(q=new RegExp(t.convertSimple2RegExpPattern(te),"i"),p.set(te,q));const X=q.exec(O);return X?[{start:X.index,end:X.index+X[0].length}]:W?i(te,O):n(te,O)}e.matchesFuzzy=D;function R(te,O){const W=Re(te,te.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?V(W):null}e.matchesFuzzy2=R;function N(te,O,W,q,X,ae){const ve=Math.min(13,te.length);for(;W<ve;W++){const Te=Re(te,O,W,q,X,ae,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Te)return Te}return[0,ae]}e.anyScore=N;function V(te){if(typeof te>"u")return[];const O=[],W=te[1];for(let q=te.length-1;q>1;q--){const X=te[q]+W,ae=O[O.length-1];ae&&ae.end===X?ae.end=X+1:O.push({start:X,end:X+1})}return O}e.createMatches=V;const x=128;function L(){const te=[],O=[];for(let W=0;W<=x;W++)O[W]=0;for(let W=0;W<=x;W++)te.push(O.slice(0));return te}function U(te){const O=[];for(let W=0;W<=te;W++)O[W]=0;return O}const F=U(2*x),B=U(2*x),M=L(),z=L(),j=L(),$=!1;function Q(te,O,W,q,X){function ae(Te,ge,ke=" "){for(;Te.length<ge;)Te=ke+Te;return Te}let ve=` |   |${q.split("").map(Te=>ae(Te,3)).join("|")}
`;for(let Te=0;Te<=W;Te++)Te===0?ve+=" |":ve+=`${O[Te-1]}|`,ve+=te[Te].slice(0,X+1).map(ge=>ae(ge.toString(),3)).join("|")+`
`;return ve}function K(te,O,W,q){te=te.substr(O),W=W.substr(q),console.log(Q(z,te,te.length,W,W.length)),console.log(Q(j,te,te.length,W,W.length)),console.log(Q(M,te,te.length,W,W.length))}function ue(te,O){if(O<0||O>=te.length)return!1;const W=te.codePointAt(O);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(W)}}function re(te,O){if(O<0||O>=te.length)return!1;switch(te.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function de(te,O,W){return O[te]!==W[te]}function Y(te,O,W,q,X,ae,ve=!1){for(;O<W&&X<ae;)te[O]===q[X]&&(ve&&(F[O]=X),O+=1),X+=1;return O===W}e.isPatternInWord=Y;var pe;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var be;(function(te){te.Default=[-100,0];function O(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}te.isDefault=O})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ce{constructor(O,W){this.firstMatchCanBeWeak=O,this.boostFullMatch=W}}e.FuzzyScoreOptions=Ce,Ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(te,O,W,q,X,ae,ve=Ce.default){const Te=te.length>x?x:te.length,ge=q.length>x?x:q.length;if(W>=Te||ae>=ge||Te-W>ge-ae||!Y(O,W,Te,X,ae,ge,!0))return;We(Te,ge,W,ae,O,X);let ke=1,De=1,xe=W,qe=ae;const nt=[!1];for(ke=1,xe=W;xe<Te;ke++,xe++){const se=F[xe],oe=B[xe],Se=xe+1<Te?B[xe+1]:ge;for(De=se-ae+1,qe=se;qe<Se;De++,qe++){let le=Number.MIN_SAFE_INTEGER,Pe=!1;qe<=oe&&(le=ne(te,O,xe,W,q,X,qe,ge,ae,M[ke-1][De-1]===0,nt));let Le=0;le!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Le=le+z[ke-1][De-1]);const Fe=qe>se,Ge=Fe?z[ke][De-1]+(M[ke][De-1]>0?-5:0):0,Je=qe>se+1&&M[ke][De-1]>0,it=Je?z[ke][De-2]+(M[ke][De-2]>0?-5:0):0;if(Je&&(!Fe||it>=Ge)&&(!Pe||it>=Le))z[ke][De]=it,j[ke][De]=3,M[ke][De]=0;else if(Fe&&(!Pe||Ge>=Le))z[ke][De]=Ge,j[ke][De]=2,M[ke][De]=0;else if(Pe)z[ke][De]=Le,j[ke][De]=1,M[ke][De]=M[ke-1][De-1]+1;else throw new Error("not possible")}}if($&&K(te,W,q,ae),!nt[0]&&!ve.firstMatchCanBeWeak)return;ke--,De--;const Xe=[z[ke][De],ae];let st=0,Be=0;for(;ke>=1;){let se=De;do{const oe=j[ke][se];if(oe===3)se=se-2;else if(oe===2)se=se-1;else break}while(se>=1);st>1&&O[W+ke-1]===X[ae+De-1]&&!de(se+ae-1,q,X)&&st+1>M[ke][se]&&(se=De),se===De?st++:st=1,Be||(Be=se),ke--,De=se-1,Xe.push(De)}ge===Te&&ve.boostFullMatch&&(Xe[0]+=2);const dt=Be-Te;return Xe[0]-=dt,Xe}e.fuzzyScore=Re;function We(te,O,W,q,X,ae){let ve=te-1,Te=O-1;for(;ve>=W&&Te>=q;)X[ve]===ae[Te]&&(B[ve]=Te,ve--),Te--}function ne(te,O,W,q,X,ae,ve,Te,ge,ke,De){if(O[W]!==ae[ve])return Number.MIN_SAFE_INTEGER;let xe=1,qe=!1;return ve===W-q?xe=te[W]===X[ve]?7:5:de(ve,X,ae)&&(ve===0||!de(ve-1,X,ae))?(xe=te[W]===X[ve]?7:5,qe=!0):ue(ae,ve)&&(ve===0||!ue(ae,ve-1))?xe=5:(ue(ae,ve-1)||re(ae,ve-1))&&(xe=5,qe=!0),xe>1&&W===q&&(De[0]=!0),qe||(qe=de(ve,X,ae)||ue(ae,ve-1)||re(ae,ve-1)),W===q?ve>ge&&(xe-=qe?3:5):ke?xe+=qe?2:0:xe+=qe?0:1,ve+1===Te&&(xe-=qe?3:5),xe}function ce(te,O,W,q,X,ae,ve){return J(te,O,W,q,X,ae,!0,ve)}e.fuzzyScoreGracefulAggressive=ce;function fe(te,O,W,q,X,ae,ve){return J(te,O,W,q,X,ae,!1,ve)}e.fuzzyScoreGraceful=fe;function J(te,O,W,q,X,ae,ve,Te){let ge=Re(te,O,W,q,X,ae,Te);if(ge&&!ve)return ge;if(te.length>=3){const ke=Math.min(7,te.length-1);for(let De=W+1;De<ke;De++){const xe=ie(te,De);if(xe){const qe=Re(xe,xe.toLowerCase(),W,q,X,ae,Te);qe&&(qe[0]-=3,(!ge||qe[0]>ge[0])&&(ge=qe))}}}return ge}function ie(te,O){if(O+1>=te.length)return;const W=te[O],q=te[O+1];if(W!==q)return te.slice(0,O)+q+W+te.slice(O+2)}}),define(_e[82],ye([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return I(f,0)}e.hash=t;function I(f,b){switch(typeof f){case"object":return f===null?P(349,b):Array.isArray(f)?S(f,b):C(f,b);case"string":return k(f,b);case"boolean":return y(f,b);case"number":return P(f,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=I;function P(f,b){return(b<<5)-b+f|0}e.numberHash=P;function y(f,b){return P(f?433:863,b)}function k(f,b){b=P(149417,b);for(let m=0,d=f.length;m<d;m++)b=P(f.charCodeAt(m),b);return b}e.stringHash=k;function S(f,b){return b=P(104579,b),f.reduce((m,d)=>I(d,m),b)}function C(f,b){return b=P(181387,b),Object.keys(f).sort().reduce((m,d)=>(m=k(d,m),I(f[d],m)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=I(b,this._value),this._value}}e.Hasher=A;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function E(f,b,m=32){const d=m-b,v=~((1<<d)-1);return(f<<b|(v&f)>>>d)>>>0}function _(f,b=0,m=f.byteLength,d=0){for(let v=0;v<m;v++)f[b+v]=d}function w(f,b,m="0"){for(;f.length<b;)f=m+f;return f}function h(f,b=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),b/4)}e.toHexString=h;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const m=b.length;if(m===0)return;const d=this._buff;let v=this._buffLen,r=this._leftoverHighSurrogate,o,l;for(r!==0?(o=r,l=-1,r=0):(o=b.charCodeAt(0),l=0);;){let s=o;if(c.isHighSurrogate(o))if(l+1<m){const a=b.charCodeAt(l+1);c.isLowSurrogate(a)?(l++,s=c.computeCodePoint(o,a)):s=65533}else{r=o;break}else c.isLowSurrogate(o)&&(s=65533);if(v=this._push(d,v,s),l++,l<m)o=b.charCodeAt(l);else break}this._buffLen=v,this._leftoverHighSurrogate=r}_push(b,m,d){return d<128?b[m++]=d:d<2048?(b[m++]=192|(d&1984)>>>6,b[m++]=128|(d&63)>>>0):d<65536?(b[m++]=224|(d&61440)>>>12,b[m++]=128|(d&4032)>>>6,b[m++]=128|(d&63)>>>0):(b[m++]=240|(d&1835008)>>>18,b[m++]=128|(d&258048)>>>12,b[m++]=128|(d&4032)>>>6,b[m++]=128|(d&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=g._bigBlock32,m=this._buffDV;for(let n=0;n<64;n+=4)b.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,E(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let d=this._h0,v=this._h1,r=this._h2,o=this._h3,l=this._h4,s,a,u;for(let n=0;n<80;n++)n<20?(s=v&r|~v&o,a=1518500249):n<40?(s=v^r^o,a=1859775393):n<60?(s=v&r|v&o|r&o,a=2400959708):(s=v^r^o,a=3395469782),u=E(d,5)+s+l+a+b.getUint32(n*4,!1)&4294967295,l=o,o=r,r=E(v,30),v=d,d=u;this._h0=this._h0+d&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(_e[159],ye([1,0,77,107,8]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const P="$(",y=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(c.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${y.source}`,"g");function C(f){return f.replace(S,(b,m)=>m?b:`\\${b}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${y.source}`,"g");function T(f){return f.replace(A,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=T;const E=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function _(f){return f.indexOf(P)===-1?f:f.replace(E,(b,m,d,v)=>d?b:m||v||"")}e.stripIcons=_;function w(f){const b=f.indexOf(P);return b===-1?{text:f}:h(f,b)}e.parseLabelWithIcons=w;function h(f,b){const m=[];let d="";function v(i){if(i){d+=i;for(const p of i)m.push(l)}}let r=-1,o="",l=0,s,a,u=b;const n=f.length;for(v(f.substr(0,b));u<n;)s=f[u],a=f[u+1],s===P[0]&&a===P[1]?(r=u,v(o),o=P,u++):s===")"&&r!==-1?(l+=u-r+1,r=-1,o=""):r!==-1?k.test(s)?o+=s:(v(o),r=-1,o=""):v(s),u++;return v(o),{text:d,iconOffsets:m}}function g(f,b,m=!1){const{text:d,iconOffsets:v}=b;if(!v||v.length===0)return(0,t.matchesFuzzy)(f,d,m);const r=(0,I.ltrim)(d," "),o=d.length-r.length,l=(0,t.matchesFuzzy)(f,r,m);if(l)for(const s of l){const a=v[s.start+o]+o;s.start+=a,s.end+=a}return l}e.matchesFuzzyIconAware=g}),define(_e[42],ye([1,0,8]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const P="error",y="warning",k="warn",S="info",C="ignore";function A(E){return E?c.equalsIgnoreCase(P,E)?I.Error:c.equalsIgnoreCase(y,E)||c.equalsIgnoreCase(k,E)?I.Warning:c.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function T(E){switch(E){case I.Error:return P;case I.Warning:return y;case I.Info:return S;default:return C}}I.toString=T}(t||(t={})),e.default=t}),define(_e[64],ye([1,0,17,8]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(_){return this._value=_,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(_){const w=_.charCodeAt(0),h=this._value.charCodeAt(this._pos);return w-h}value(){return this._value[this._pos]}}e.StringIterator=I;class P{constructor(_=!0){this._caseSensitive=_}reset(_){return this._value=_,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let _=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(_)this._from++;else break;else _=!1;return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class y{constructor(_=!0,w=!0){this._splitOnBackslash=_,this._caseSensitive=w}reset(_){this._from=0,this._to=0,this._value=_,this._valueLen=_.length;for(let w=_.length-1;w>=0;w--,this._valueLen--){const h=this._value.charCodeAt(w);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let _=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(_)this._from++;else break;else _=!1}return this}cmp(_){return this._caseSensitive?(0,t.compareSubstring)(_,this._value,0,_.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(_,this._value,0,_.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class S{constructor(_,w){this._ignorePathCasing=_,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(_){return this._value=_,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(_)),this._pathIterator.reset(_.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(_)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(_){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(_,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(_,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(_);if(this._states[this._stateIdx]===4)return(0,t.compare)(_,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(_,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const _=this.right;return this.right=_.left,_.left=this,this.updateHeight(),_.updateHeight(),_}rotateRight(){const _=this.left;return this.left=_.right,_.right=this,this.updateHeight(),_.updateHeight(),_}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(A||(A={}));class T{static forUris(_=()=>!1,w=()=>!1){return new T(new S(_,w))}static forPaths(_=!1){return new T(new y(void 0,!_))}static forStrings(){return new T(new I)}static forConfigKeys(){return new T(new P)}constructor(_){this._iter=_}clear(){this._root=void 0}fill(_,w){if(w){const h=w.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g,_)}else{const h=_.slice(0);(0,c.shuffle)(h);for(const g of h)this.set(g[0],g[1])}}set(_,w){const h=this._iter.reset(_);let g;this._root||(this._root=new C,this._root.segment=h.value());const f=[];for(g=this._root;;){const m=h.cmp(g.segment);if(m>0)g.left||(g.left=new C,g.left.segment=h.value()),f.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new C,g.right.segment=h.value()),f.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new C,g.mid.segment=h.value()),f.push([0,g]),g=g.mid;else break}const b=g.value;g.value=w,g.key=_;for(let m=f.length-1;m>=0;m--){const d=f[m][1];d.updateHeight();const v=d.balanceFactor();if(v<-1||v>1){const r=f[m][0],o=f[m+1][0];if(r===1&&o===1)f[m][1]=d.rotateLeft();else if(r===-1&&o===-1)f[m][1]=d.rotateRight();else if(r===1&&o===-1)d.right=f[m+1][1]=f[m+1][1].rotateRight(),f[m][1]=d.rotateLeft();else if(r===-1&&o===1)d.left=f[m+1][1]=f[m+1][1].rotateLeft(),f[m][1]=d.rotateRight();else throw new Error;if(m>0)switch(f[m-1][0]){case-1:f[m-1][1].left=f[m][1];break;case 1:f[m-1][1].right=f[m][1];break;case 0:f[m-1][1].mid=f[m][1];break}else this._root=f[0][1]}}return b}get(_){return this._getNode(_)?.value}_getNode(_){const w=this._iter.reset(_);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(_){const w=this._getNode(_);return!(w?.value===void 0&&w?.mid===void 0)}delete(_){return this._delete(_,!1)}deleteSuperstr(_){return this._delete(_,!0)}_delete(_,w){const h=this._iter.reset(_),g=[];let f=this._root;for(;f;){const b=h.cmp(f.segment);if(b>0)g.push([-1,f]),f=f.left;else if(b<0)g.push([1,f]),f=f.right;else if(h.hasNext())h.next(),g.push([0,f]),f=f.mid;else break}if(!!f){if(w?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const b=this._min(f.right);if(b.key){const{key:m,value:d,segment:v}=b;this._delete(b.key,!1),f.key=m,f.value=d,f.segment=v}}else{const b=f.left??f.right;if(g.length>0){const[m,d]=g[g.length-1];switch(m){case-1:d.left=b;break;case 0:d.mid=b;break;case 1:d.right=b;break}}else this._root=b}for(let b=g.length-1;b>=0;b--){const m=g[b][1];m.updateHeight();const d=m.balanceFactor();if(d>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[b][1]=m.rotateLeft()):d<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[b][1]=m.rotateRight()),b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this._root=g[0][1]}}}_min(_){for(;_.left;)_=_.left;return _}findSubstr(_){const w=this._iter.reset(_);let h=this._root,g;for(;h;){const f=w.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(w.hasNext())w.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(_){const w=this._iter.reset(_);let h=this._root;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(_){for(const[w,h]of this)_(h,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(_){const w=[];return this._dfsEntries(_,w),w[Symbol.iterator]()}_dfsEntries(_,w){!_||(_.left&&this._dfsEntries(_.left,w),_.value&&w.push([_.key,_.value]),_.mid&&this._dfsEntries(_.mid,w),_.right&&this._dfsEntries(_.right,w))}_isBalanced(){const _=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:_(w.left)&&_(w.right)};return _(this._root)}}e.TernarySearchTree=T}),define(_e[2],ye([1,0,9,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function k(l,s){if(!l.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!I.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,s){return!l&&!s?"file":l}function C(l,s){switch(l){case"https":case"http":case"file":s?s[0]!==T&&(s=T+s):s=T;break}return s}const A="",T="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{static isUri(s){return s instanceof _?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,a,u,n,i,p=!1){typeof s=="object"?(this.scheme=s.scheme||A,this.authority=s.authority||A,this.path=s.path||A,this.query=s.query||A,this.fragment=s.fragment||A):(this.scheme=S(s,p),this.authority=a||A,this.path=C(this.scheme,u||A),this.query=n||A,this.fragment=i||A,k(this,p))}get fsPath(){return m(this,!1)}with(s){if(!s)return this;let{scheme:a,authority:u,path:n,query:i,fragment:p}=s;return a===void 0?a=this.scheme:a===null&&(a=A),u===void 0?u=this.authority:u===null&&(u=A),n===void 0?n=this.path:n===null&&(n=A),i===void 0?i=this.query:i===null&&(i=A),p===void 0?p=this.fragment:p===null&&(p=A),a===this.scheme&&u===this.authority&&n===this.path&&i===this.query&&p===this.fragment?this:new h(a,u,n,i,p)}static parse(s,a=!1){const u=E.exec(s);return u?new h(u[2]||A,o(u[4]||A),o(u[5]||A),o(u[7]||A),o(u[9]||A),a):new h(A,A,A,A,A)}static file(s){let a=A;if(t.isWindows&&(s=s.replace(/\\/g,T)),s[0]===T&&s[1]===T){const u=s.indexOf(T,2);u===-1?(a=s.substring(2),s=T):(a=s.substring(2,u),s=s.substring(u)||T)}return new h("file",a,s,A,A)}static from(s){const a=new h(s.scheme,s.authority,s.path,s.query,s.fragment);return k(a,!0),a}static joinPath(s,...a){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&s.scheme==="file"?u=_.file(c.win32.join(m(s,!0),...a)).path:u=c.posix.join(s.path,...a),s.with({path:u})}toString(s=!1){return d(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof _)return s;{const a=new h(s);return a._formatted=s.external,a._fsPath=s._sep===w?s.fsPath:null,a}}else return s}}e.URI=_;const w=t.isWindows?1:void 0;class h extends _{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(s=!1){return s?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(l,s){let a,u=-1;for(let n=0;n<l.length;n++){const i=l.charCodeAt(n);if(i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57||i===45||i===46||i===95||i===126||s&&i===47)u!==-1&&(a+=encodeURIComponent(l.substring(u,n)),u=-1),a!==void 0&&(a+=l.charAt(n));else{a===void 0&&(a=l.substr(0,n));const p=g[i];p!==void 0?(u!==-1&&(a+=encodeURIComponent(l.substring(u,n)),u=-1),a+=p):u===-1&&(u=n)}}return u!==-1&&(a+=encodeURIComponent(l.substring(u))),a!==void 0?a:l}function b(l){let s;for(let a=0;a<l.length;a++){const u=l.charCodeAt(a);u===35||u===63?(s===void 0&&(s=l.substr(0,a)),s+=g[u]):s!==void 0&&(s+=l[a])}return s!==void 0?s:l}function m(l,s){let a;return l.authority&&l.path.length>1&&l.scheme==="file"?a=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?s?a=l.path.substr(1):a=l.path[1].toLowerCase()+l.path.substr(2):a=l.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=m;function d(l,s){const a=s?b:f;let u="",{scheme:n,authority:i,path:p,query:D,fragment:R}=l;if(n&&(u+=n,u+=":"),(i||n==="file")&&(u+=T,u+=T),i){let N=i.indexOf("@");if(N!==-1){const V=i.substr(0,N);i=i.substr(N+1),N=V.indexOf(":"),N===-1?u+=a(V,!1):(u+=a(V.substr(0,N),!1),u+=":",u+=a(V.substr(N+1),!1)),u+="@"}i=i.toLowerCase(),N=i.indexOf(":"),N===-1?u+=a(i,!1):(u+=a(i.substr(0,N),!1),u+=i.substr(N))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const N=p.charCodeAt(1);N>=65&&N<=90&&(p=`/${String.fromCharCode(N+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const N=p.charCodeAt(0);N>=65&&N<=90&&(p=`${String.fromCharCode(N+32)}:${p.substr(2)}`)}u+=a(p,!0)}return D&&(u+="?",u+=a(D,!1)),R&&(u+="#",u+=s?R:f(R,!1)),u}function v(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+v(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(l){return l.match(r)?l.replace(r,s=>v(s)):l}}),define(_e[83],ye([1,0,23,8,2]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(C){return JSON.stringify(C,k)}e.stringify=P;function y(C){let A=JSON.parse(C);return A=S(A),A}e.parse=y;function k(C,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function S(C,A=0){if(!C||A>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return I.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 15:return new Date(C.source)}if(C instanceof c.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let T=0;T<C.length;++T)C[T]=S(C[T],A+1);else for(const T in C)Object.hasOwnProperty.call(C,T)&&(C[T]=S(C[T],A+1))}return C}e.revive=S}),define(_e[14],ye([1,0,12,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}setServerRootPath(C){this._remoteResourcesPath=`${C}/${I.vscodeRemoteResource}`}set(C,A,T){this._hosts[C]=A,this._ports[C]=T}setConnectionToken(C,A){this._connectionTokens[C]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let T=this._hosts[A];T&&T.indexOf(":")!==-1&&T.indexOf("[")===-1&&(T=`[${T}]`);const E=this._ports[A],_=this._connectionTokens[A];let w=`path=${encodeURIComponent(C.path)}`;return typeof _=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),t.URI.from({scheme:c.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${T}:${E}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new P,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(C){const A=this.toUri(C,Z);return this.uriToBrowserUri(A)}uriToBrowserUri(C){return C.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===I.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${I.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?C.with({scheme:I.vscodeFileResource,authority:C.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(C){const A=this.toUri(C,Z);return this.uriToFileUri(A)}uriToFileUri(C){return C.scheme===I.vscodeFileResource?C.with({scheme:I.file,authority:C.authority!==y.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(C,A){return t.URI.isUri(C)?C:t.URI.parse(A.toUrl(C))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var k;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const A="vscode-coi";function T(_){let w;typeof _=="string"?w=new URL(_).searchParams:_ instanceof URL?w=_.searchParams:t.URI.isUri(_)&&(w=new URL(_.toString(!0)).searchParams);const h=w?.get(A);if(!!h)return C.get(h)}S.getHeadersFromQuery=T;function E(_,w,h){if(!globalThis.crossOriginIsolated)return;const g=w&&h?"3":h?"2":"1";_ instanceof URLSearchParams?_.set(A,g):_[A]=g}S.addSearchParam=E})(k=e.COI||(e.COI={}))}),define(_e[22],ye([1,0,32,14,9,12,8,2]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(_){return(0,k.uriToFsPath)(_,!0)}e.originalFSPath=S;class C{constructor(w){this._ignorePathCasing=w}compare(w,h,g=!1){return w===h?0:(0,y.compare)(this.getComparisonKey(w,g),this.getComparisonKey(h,g))}isEqual(w,h,g=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,g)===this.getComparisonKey(h,g)}getComparisonKey(w,h=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,h,g=!1){if(w.scheme===h.scheme){if(w.scheme===t.Schemas.file)return c.isEqualOrParent(S(w),S(h),this._ignorePathCasing(w))&&w.query===h.query&&(g||w.fragment===h.fragment);if((0,e.isEqualAuthority)(w.authority,h.authority))return c.isEqualOrParent(w.path,h.path,this._ignorePathCasing(w),"/")&&w.query===h.query&&(g||w.fragment===h.fragment)}return!1}joinPath(w,...h){return k.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return I.posix.basename(w.path)}extname(w){return I.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===t.Schemas.file?h=k.URI.file(I.dirname(S(w))).path:(h=I.posix.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===t.Schemas.file?h=k.URI.file(I.normalize(S(w))).path:h=I.posix.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.isEqualAuthority)(w.authority,h.authority))return;if(w.scheme===t.Schemas.file){const b=I.relative(S(w),S(h));return P.isWindows?c.toSlashes(b):b}let g=w.path||"/";const f=h.path||"/";if(this._ignorePathCasing(w)){let b=0;for(const m=Math.min(g.length,f.length);b<m&&!(g.charCodeAt(b)!==f.charCodeAt(b)&&g.charAt(b).toLowerCase()!==f.charAt(b).toLowerCase());b++);g=f.substr(0,b)+g.substr(b)}return I.posix.relative(g,f)}resolvePath(w,h){if(w.scheme===t.Schemas.file){const g=k.URI.file(I.resolve(S(w),h));return w.with({authority:g.authority,path:g.path})}return h=c.toPosixPath(h),w.with({path:I.posix.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,y.equalsIgnoreCase)(w,h)}hasTrailingPathSeparator(w,h=I.sep){if(w.scheme===t.Schemas.file){const g=S(w);return g.length>c.getRoot(g).length&&g[g.length-1]===h}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=I.sep){return(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=I.sep){let g=!1;if(w.scheme===t.Schemas.file){const f=S(w);g=f!==void 0&&f.length===c.getRoot(f).length&&f[f.length-1]===h}else{h="/";const f=w.path;g=f.length===1&&f.charCodeAt(f.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(w,h)?w.with({path:w.path+"/"}):w}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(_=>_.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new C(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(_,w){const h=[];for(let g=0;g<_.length;g++){const f=w(_[g]);_.some((b,m)=>m===g?!1:(0,e.isEqualOrParent)(f,w(b)))||h.push(_[g])}return h}e.distinctParents=A;var T;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function w(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[d,v]=m.split(":");d&&v&&g.set(d,v)});const b=h.path.substring(0,h.path.indexOf(";"));return b&&g.set(_.META_DATA_MIME,b),g}_.parseMetaData=w})(T=e.DataUri||(e.DataUri={}));function E(_,w,h){if(w){let g=_.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),_.with({scheme:h,authority:w,path:g})}return _.with({scheme:h})}e.toLocalResource=E}),define(_e[18],ye([1,0,21,10,4,6,22,12]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function C(de){const Y=new c.CancellationTokenSource,pe=de(Y.token),be=new Promise((Ce,Re)=>{const We=Y.token.onCancellationRequested(()=>{We.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(pe).then(ne=>{We.dispose(),Y.dispose(),Ce(ne)},ne=>{We.dispose(),Y.dispose(),Re(ne)})});return new class{cancel(){Y.cancel()}then(Ce,Re){return be.then(Ce,Re)}catch(Ce){return this.then(void 0,Ce)}finally(Ce){return be.finally(Ce)}}}e.createCancelablePromise=C;function A(de,Y,pe){return new Promise((be,Ce)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(pe)});de.then(be,Ce).finally(()=>Re.dispose())})}e.raceCancellation=A;function T(de,Y){return new Promise((pe,be)=>{const Ce=Y.onCancellationRequested(()=>{Ce.dispose(),be(new t.CancellationError)});de.then(pe,be).finally(()=>Ce.dispose())})}e.raceCancellationError=T;async function E(de){let Y=-1;const pe=de.map((Ce,Re)=>Ce.then(We=>(Y=Re,We))),be=await Promise.race(pe);return de.forEach((Ce,Re)=>{Re!==Y&&Ce.cancel()}),be}e.raceCancellablePromises=E;function _(de,Y,pe){let be;const Ce=setTimeout(()=>{be?.(void 0),pe?.()},Y);return Promise.race([de.finally(()=>clearTimeout(Ce)),new Promise(Re=>be=Re)])}e.raceTimeout=_;function w(de){return new Promise((Y,pe)=>{const be=de();S(be)?be.then(Y,pe):Y(be)})}e.asPromise=w;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=Y(),new Promise((pe,be)=>{this.activePromise.then(Ce=>{this.activePromise=null,pe(Ce)},Ce=>{this.activePromise=null,be(Ce)})})}}e.Throttler=h;class g{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=g;class f{constructor(){this.promiseMap=new Map}queue(Y,pe){const Ce=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Y)===Ce&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Ce),Ce}}e.SequencerByKey=f;const b=(de,Y)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,Y()},de);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},m=de=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,de())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,pe=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ce,Re)=>{this.doResolve=Ce,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ce=this.task;return this.task=null,Ce()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?m(be):b(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class v{constructor(Y){this.delayer=new d(Y),this.throttler=new h}trigger(Y,pe){return this.delayer.trigger(()=>this.throttler.queue(Y),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class r{constructor(){this._isOpen=!1,this._promise=new Promise((Y,pe)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function l(de,Y){return Y?new Promise((pe,be)=>{const Ce=setTimeout(()=>{Re.dispose(),pe()},de),Re=Y.onCancellationRequested(()=>{clearTimeout(Ce),Re.dispose(),be(new t.CancellationError)})}):C(pe=>l(de,pe))}e.timeout=l;function s(de,Y=0){const pe=setTimeout(de,Y);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=s;function a(de){const Y=[];let pe=0;const be=de.length;function Ce(){return pe<be?de[pe++]():null}function Re(We){We!=null&&Y.push(We);const ne=Ce();return ne?ne.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=a;function u(de,Y=be=>!!be,pe=null){let be=0;const Ce=de.length,Re=()=>{if(be>=Ce)return Promise.resolve(pe);const We=de[be++];return Promise.resolve(We()).then(ce=>Y(ce)?Promise.resolve(ce):Re())};return Re()}e.first=u;function n(de,Y=be=>!!be,pe=null){if(de.length===0)return Promise.resolve(pe);let be=de.length;const Ce=()=>{be=-1;for(const Re of de)Re.cancel?.()};return new Promise((Re,We)=>{for(const ne of de)ne.then(ce=>{--be>=0&&Y(ce)?(Ce(),Re(ce)):be===0&&Re(pe)}).catch(ce=>{--be>=0&&(Ce(),We(ce))})})}e.firstParallel=n;class i{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:Y,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const pe=Y.factory();pe.then(Y.c,Y.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new j;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,pe=y.extUri){const be=pe.getComparisonKey(Y);let Ce=this.queues.get(be);return Ce||(Ce=new p,I.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,Ce)),Ce}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class R{constructor(Y,pe){this._token=-1,typeof Y=="function"&&typeof pe=="number"&&this.setIfNotSet(Y,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},pe)}setIfNotSet(Y,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},pe))}}e.TimeoutTimer=R;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,pe){this.cancel(),this._token=setInterval(()=>{Y()},pe)}}e.IntervalTimer=N;class V{constructor(Y,pe){this.timeoutToken=-1,this.runner=Y,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class x{constructor(Y,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class L extends V{constructor(Y,pe){super(Y,pe),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends P.Disposable{constructor(Y,pe){super(),this.options=Y,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,k.setTimeout0)(()=>{if(Y)return;const pe=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(de,Y)=>{const pe=requestIdleCallback(de,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class F{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function B(de,Y,pe){let be;for(let Ce=0;Ce<pe;Ce++)try{return await de()}catch(Re){be=Re,await l(Y)}throw be}e.retry=B;class M{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,pe,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(Y),()=>this.donePending(Y)),pe}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let pe,be;const Ce=new Promise((Re,We)=>{pe=Re,be=We});this._next={run:Y,promise:Ce,promiseResolve:pe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=M;class z{constructor(Y,pe=()=>Date.now()){this.interval=Y,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class j{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,pe)=>{this.completeCallback=Y,this.errorCallback=pe})}complete(Y){return new Promise(pe=>{this.completeCallback(Y),this.resolved=!0,pe()})}error(Y){return new Promise(pe=>{this.errorCallback(Y),this.rejected=!0,pe()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=j;var $;(function(de){async function Y(be){let Ce;const Re=await Promise.all(be.map(We=>We.then(ne=>ne,ne=>{Ce||(Ce=ne)})));if(typeof Ce<"u")throw Ce;return Re}de.settled=Y;function pe(be){return new Promise(async(Ce,Re)=>{try{await be(Ce,Re)}catch(We){Re(We)}})}de.withAsyncBody=pe})($=e.Promises||(e.Promises={}));var Q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(pe=>{pe.emitMany(Y)})}static fromPromise(Y){return new K(async pe=>{pe.emitMany(await Y)})}static fromPromises(Y){return new K(async pe=>{await Promise.all(Y.map(async be=>pe.emitOne(await be)))})}static merge(Y){return new K(async pe=>{await Promise.all(Y.map(async be=>{for await(const Ce of be)pe.emitOne(Ce)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,pe){return new K(async be=>{for await(const Ce of Y)be.emitOne(pe(Ce))})}map(Y){return K.map(this,Y)}static filter(Y,pe){return new K(async be=>{for await(const Ce of Y)pe(Ce)&&be.emitOne(Ce)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,pe=>!!pe)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const pe=[];for await(const be of Y)pe.push(be);return pe}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class ue extends K{constructor(Y,pe){super(pe),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ue;function re(de){const Y=new c.CancellationTokenSource,pe=de(Y.token);return new ue(Y,async be=>{const Ce=Y.token.onCancellationRequested(()=>{Ce.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of pe){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}Ce.dispose(),Y.dispose()}catch(Re){Ce.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=re}),define(_e[108],ye([1,0,18,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new c.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(p,D,R=!1){const N=p||"",V=D||"",x=I.value.collator.compare(N,V);return I.value.collatorIsNumeric&&x===0&&N!==V?N<V?-1:1:x}e.compareFileNames=k;function S(p,D){const R=P.value.collator;return p=p||"",D=D||"",v(R,p,D)}e.compareFileNamesDefault=S;function C(p,D){const R=P.value.collator;return p=p||"",D=D||"",s(p,D)||v(R,p,D)}e.compareFileNamesUpper=C;function A(p,D){const R=P.value.collator;return p=p||"",D=D||"",l(p,D)||v(R,p,D)}e.compareFileNamesLower=A;function T(p,D){return p=p||"",D=D||"",p===D?0:p<D?-1:1}e.compareFileNamesUnicode=T;function E(p,D,R=!1){R||(p=p&&p.toLowerCase(),D=D&&D.toLowerCase());const[N,V]=m(p),[x,L]=m(D);return N!==x?N<x?-1:1:V===L?0:V<L?-1:1}e.noIntlCompareFileNames=E;function _(p,D){const[R,N]=m(p),[V,x]=m(D);let L=I.value.collator.compare(N,x);if(L===0){if(I.value.collatorIsNumeric&&N!==x)return N<x?-1:1;if(L=I.value.collator.compare(R,V),I.value.collatorIsNumeric&&L===0&&R!==V)return R<V?-1:1}return L}e.compareFileExtensions=_;function w(p,D){p=p||"",D=D||"";const R=d(p),N=d(D),V=P.value.collator,x=y.value.collator;return v(x,R,N)||v(V,p,D)}e.compareFileExtensionsDefault=w;function h(p,D){p=p||"",D=D||"";const R=d(p),N=d(D),V=P.value.collator,x=y.value.collator;return v(x,R,N)||s(p,D)||v(V,p,D)}e.compareFileExtensionsUpper=h;function g(p,D){p=p||"",D=D||"";const R=d(p),N=d(D),V=P.value.collator,x=y.value.collator;return v(x,R,N)||l(p,D)||v(V,p,D)}e.compareFileExtensionsLower=g;function f(p,D){p=p||"",D=D||"";const R=d(p).toLowerCase(),N=d(D).toLowerCase();return R!==N?R<N?-1:1:p!==D?p<D?-1:1:0}e.compareFileExtensionsUnicode=f;const b=/^(.*?)(\.([^.]*))?$/;function m(p,D=!1){const R=p?b.exec(p):[];let N=[R&&R[1]||"",R&&R[3]||""];return D&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function d(p){const D=p?b.exec(p):[];return D&&D[1]&&D[1].charAt(0)!=="."&&D[3]||""}function v(p,D,R){const N=p.compare(D,R);return N!==0?N:D.length!==R.length?D.length<R.length?-1:1:0}function r(p){const D=p.charAt(0);return D.toLocaleUpperCase()!==D}function o(p){const D=p.charAt(0);return D.toLocaleLowerCase()!==D}function l(p,D){return r(p)&&o(D)?-1:o(p)&&r(D)?1:0}function s(p,D){return o(p)&&r(D)?-1:r(p)&&o(D)?1:0}function a(p,D,R=!1){return R||(p=p&&p.toLowerCase(),D=D&&D.toLowerCase()),p===D?0:p<D?-1:1}function u(p,D,R=!1){const N=p.split(t.sep),V=D.split(t.sep),x=N.length-1,L=V.length-1;let U,F;for(let B=0;;B++){if(U=x===B,F=L===B,U&&F)return k(N[B],V[B],R);if(U)return-1;if(F)return 1;const M=a(N[B],V[B],R);if(M!==0)return M}}e.comparePaths=u;function n(p,D,R){const N=p.toLowerCase(),V=D.toLowerCase(),x=i(p,D,R);if(x)return x;const L=N.endsWith(R),U=V.endsWith(R);if(L!==U)return L?-1:1;const F=k(N,V);return F!==0?F:N.localeCompare(V)}e.compareAnything=n;function i(p,D,R){const N=p.toLowerCase(),V=D.toLowerCase(),x=N.startsWith(R),L=V.startsWith(R);if(x!==L)return x?-1:1;if(x&&L){if(N.length<V.length)return-1;if(N.length>V.length)return 1}return 0}e.compareByPrefix=i}),define(_e[109],ye([1,0,108,107,82,9,12,8]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function A(M,z,j,$){if(!M||!z)return C;const Q=M.length,K=z.length;if(Q<K)return C;const ue=M.toLowerCase();return T(z,j,K,M,ue,Q,$)}e.scoreFuzzy=A;function T(M,z,j,$,Q,K,ue){const re=[],de=[];for(let Ce=0;Ce<j;Ce++){const Re=Ce*K,We=Re-K,ne=Ce>0,ce=M[Ce],fe=z[Ce];for(let J=0;J<K;J++){const ie=J>0,te=Re+J,O=te-1,W=We+J-1,q=ie?re[O]:0,X=ne&&ie?re[W]:0,ae=ne&&ie?de[W]:0;let ve;!X&&ne?ve=0:ve=E(ce,fe,$,Q,J,ae),ve&&X+ve>=q&&(ue||ne||Q.startsWith(z,J))?(de[te]=ae+1,re[te]=X+ve):(de[te]=S,re[te]=q)}}const Y=[];let pe=j-1,be=K-1;for(;pe>=0&&be>=0;){const Ce=pe*K+be;de[Ce]===S||(Y.push(be),pe--),be--}return[re[j*K-1],Y.reverse()]}function E(M,z,j,$,Q,K){let ue=0;if(!_(z,$[Q]))return ue;if(ue+=1,K>0&&(ue+=K*5),M===j[Q]&&(ue+=1),Q===0)ue+=8;else{const re=w(j.charCodeAt(Q-1));re?ue+=re:(0,t.isUpper)(j.charCodeAt(Q))&&K===0&&(ue+=2)}return ue}function _(M,z){return M===z?!0:M==="/"||M==="\\"?z==="/"||z==="\\":!1}function w(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(M,z,j=0,$=0){const Q=z;return Q.values&&Q.values.length>1?f(M,Q.values,j,$):b(M,z,j,$)}e.scoreFuzzy2=g;function f(M,z,j,$){let Q=0;const K=[];for(const ue of z){const[re,de]=b(M,ue,j,$);if(typeof re!="number")return h;Q+=re,K.push(...de)}return[Q,i(K)]}function b(M,z,j,$){const Q=(0,t.fuzzyScore)(z.original,z.originalLowercase,j,M,M.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:h}const m=Object.freeze({score:0}),d=1<<18,v=1<<17,r=1<<16;function o(M,z,j,$){const Q=$.values?$.values:[$];return(0,I.hash)({[$.normalized]:{values:Q.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:M,description:z,allowNonContiguousMatches:j}})}function l(M,z,j,$,Q){if(!M||!z.normalized)return m;const K=$.getItemLabel(M);if(!K)return m;const ue=$.getItemDescription(M),re=o(K,ue,j,z),de=Q[re];if(de)return de;const Y=s(K,ue,$.getItemPath(M),z,j);return Q[re]=Y,Y}e.scoreItemFuzzy=l;function s(M,z,j,$,Q){const K=!j||!$.containsPathSeparator;return j&&(y.isLinux?$.pathNormalized===j:(0,k.equalsIgnoreCase)($.pathNormalized,j))?{score:d,labelMatch:[{start:0,end:M.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:$.values&&$.values.length>1?a(M,z,j,$.values,K,Q):u(M,z,j,$,K,Q)}function a(M,z,j,$,Q,K){let ue=0;const re=[],de=[];for(const Y of $){const{score:pe,labelMatch:be,descriptionMatch:Ce}=u(M,z,j,Y,Q,K);if(pe===S)return m;ue+=pe,be&&re.push(...be),Ce&&de.push(...Ce)}return{score:ue,labelMatch:i(re),descriptionMatch:i(de)}}function u(M,z,j,$,Q,K){if(Q||!z){const[ue,re]=A(M,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(ue){const de=(0,t.matchesPrefix)($.normalized,M);let Y;return de?(Y=v,Y+=Math.round($.normalized.length/M.length*100)):Y=r,{score:Y+ue,labelMatch:de||n(re)}}}if(z){let ue=z;j&&(ue=`${z}${P.sep}`);const re=ue.length,de=`${ue}${M}`,[Y,pe]=A(de,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(Y){const be=n(pe),Ce=[],Re=[];return be.forEach(We=>{We.start<re&&We.end>re?(Ce.push({start:0,end:We.end-re}),Re.push({start:We.start,end:re})):We.start>=re?Ce.push({start:We.start-re,end:We.end-re}):Re.push(We)}),{score:Y,labelMatch:Ce,descriptionMatch:Re}}}return m}function n(M){const z=[];if(!M)return z;let j;for(const $ of M)j&&j.end===$?j.end+=1:(j={start:$,end:$+1},z.push(j));return z}function i(M){const z=M.sort((Q,K)=>Q.start-K.start),j=[];let $;for(const Q of z)!$||!p($,Q)?($=Q,j.push(Q)):($.start=Math.min($.start,Q.start),$.end=Math.max($.end,Q.end));return j}function p(M,z){return!(M.end<z.start||z.end<M.start)}function D(M,z,j,$,Q,K){const ue=l(M,j,$,Q,K),re=l(z,j,$,Q,K),de=ue.score,Y=re.score;if((de===d||Y===d)&&de!==Y)return de===d?-1:1;if(de>r||Y>r){if(de!==Y)return de>Y?-1:1;if(de<v&&Y<v){const ce=N(ue.labelMatch,re.labelMatch);if(ce!==0)return ce}const We=Q.getItemLabel(M)||"",ne=Q.getItemLabel(z)||"";if(We.length!==ne.length)return We.length-ne.length}if(de!==Y)return de>Y?-1:1;const pe=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,be=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(pe&&!be)return-1;if(be&&!pe)return 1;const Ce=R(M,ue,Q),Re=R(z,re,Q);return Ce&&Re&&Ce!==Re?Re>Ce?-1:1:V(M,z,j,Q)}e.compareItemsByFuzzyScore=D;function R(M,z,j){let $=-1,Q=-1;if(z.descriptionMatch&&z.descriptionMatch.length?$=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&($=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(Q=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const K=j.getItemDescription(M);K&&(Q+=K.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(Q=z.descriptionMatch[z.descriptionMatch.length-1].end);return Q-$}function N(M,z){if(!M&&!z||(!M||!M.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!M||!M.length)return 1;const j=M[0].start,Q=M[M.length-1].end-j,K=z[0].start,re=z[z.length-1].end-K;return Q===re?0:re<Q?1:-1}function V(M,z,j,$){const Q=$.getItemLabel(M)||"",K=$.getItemLabel(z)||"",ue=$.getItemDescription(M),re=$.getItemDescription(z),de=Q.length+(ue?ue.length:0),Y=K.length+(re?re.length:0);if(de!==Y)return de-Y;const pe=$.getItemPath(M),be=$.getItemPath(z);return pe&&be&&pe.length!==be.length?pe.length-be.length:Q!==K?(0,c.compareAnything)(Q,K,j.normalized):ue&&re&&ue!==re?(0,c.compareAnything)(ue,re,j.normalized):pe&&be&&pe!==be?(0,c.compareAnything)(pe,be,j.normalized):0}function x(M){return M.startsWith('"')&&M.endsWith('"')}const L=" ";function U(M){typeof M!="string"&&(M="");const z=M.toLowerCase(),{pathNormalized:j,normalized:$,normalizedLowercase:Q}=F(M),K=j.indexOf(P.sep)>=0,ue=x(M);let re;const de=M.split(L);if(de.length>1)for(const Y of de){const pe=x(Y),{pathNormalized:be,normalized:Ce,normalizedLowercase:Re}=F(Y);Ce&&(re||(re=[]),re.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:Ce,normalizedLowercase:Re,expectContiguousMatch:pe}))}return{original:M,originalLowercase:z,pathNormalized:j,normalized:$,normalizedLowercase:Q,values:re,containsPathSeparator:K,expectContiguousMatch:ue}}e.prepareQuery=U;function F(M){let z;y.isWindows?z=M.replace(/\//g,P.sep):z=M.replace(/\\/g,P.sep);const j=(0,k.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:j,normalizedLowercase:j.toLowerCase()}}function B(M){return Array.isArray(M)?U(M.map(z=>z.original).join(L)):U(M.original)}e.pieceToQuery=B}),define(_e[37],ye([1,0,17,18,32,28,9,12,8]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",T="[^/\\\\]",E=/\//g;function _(j,$){switch(j){case 0:return"";case 1:return`${T}*?`;default:return`(?:${A}|${T}+${A}${$?`|${A}${T}+`:""})*?`}}function w(j,$){if(!j)return[];const Q=[];let K=!1,ue=!1,re="";for(const de of j){switch(de){case $:if(!K&&!ue){Q.push(re),re="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}re+=de}return re&&Q.push(re),Q}e.splitGlobAware=w;function h(j){if(!j)return"";let $="";const Q=w(j,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))$=".*";else{let K=!1;Q.forEach((ue,re)=>{if(ue===e.GLOBSTAR){if(K)return;$+=_(2,re===Q.length-1)}else{let de=!1,Y="",pe=!1,be="";for(const Ce of ue){if(Ce!=="}"&&de){Y+=Ce;continue}if(pe&&(Ce!=="]"||!be)){let Re;Ce==="-"?Re=Ce:(Ce==="^"||Ce==="!")&&!be?Re="^":Ce===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(Ce),be+=Re;continue}switch(Ce){case"{":de=!0;continue;case"[":pe=!0;continue;case"}":{$+=`(?:${w(Y,",").map(ne=>h(ne)).join("|")})`,de=!1,Y="";break}case"]":{$+="["+be+"]",pe=!1,be="";break}case"?":$+=T;continue;case"*":$+=_(1);continue;default:$+=(0,S.escapeRegExpCharacters)(Ce)}}re<Q.length-1&&(Q[re+1]!==e.GLOBSTAR||re+2<Q.length)&&($+=A)}K=ue===e.GLOBSTAR})}return $}const g=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new P.LRUCache(1e4),o=function(){return!1},l=function(){return null};function s(j,$){if(!j)return l;let Q;typeof j!="string"?Q=j.pattern:Q=j,Q=Q.trim();const K=`${Q}_${!!$.trimForExclusions}`;let ue=r.get(K);if(ue)return a(ue,j);let re;return g.test(Q)?ue=n(Q.substr(4),Q):(re=f.exec(u(Q,$)))?ue=i(re[1],Q):($.trimForExclusions?m:b).test(Q)?ue=p(Q,$):(re=d.exec(u(Q,$)))?ue=D(re[1].substr(1),Q,!0):(re=v.exec(u(Q,$)))?ue=D(re[1],Q,!1):ue=R(Q),r.set(K,ue),a(ue,j)}function a(j,$){if(typeof $=="string")return j;const Q=function(K,ue){return(0,I.isEqualOrParent)(K,$.base,!k.isLinux)?j(K.substr($.base.length+1),ue):null};return Q.allBasenames=j.allBasenames,Q.allPaths=j.allPaths,Q.basenames=j.basenames,Q.patterns=j.patterns,Q}function u(j,$){return $.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function n(j,$){return function(Q,K){return typeof Q=="string"&&Q.endsWith(j)?$:null}}function i(j,$){const Q=`/${j}`,K=`\\${j}`,ue=function(de,Y){return typeof de!="string"?null:Y?Y===j?$:null:de===j||de.endsWith(Q)||de.endsWith(K)?$:null},re=[j];return ue.basenames=re,ue.patterns=[$],ue.allBasenames=re,ue}function p(j,$){const Q=M(j.slice(1,-1).split(",").map(Y=>s(Y,$)).filter(Y=>Y!==l),j),K=Q.length;if(!K)return l;if(K===1)return Q[0];const ue=function(Y,pe){for(let be=0,Ce=Q.length;be<Ce;be++)if(Q[be](Y,pe))return j;return null},re=Q.find(Y=>!!Y.allBasenames);re&&(ue.allBasenames=re.allBasenames);const de=Q.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return de.length&&(ue.allPaths=de),ue}function D(j,$,Q){const K=y.sep===y.posix.sep,ue=K?j:j.replace(E,y.sep),re=y.sep+ue,de=y.posix.sep+j;let Y;return Q?Y=function(pe,be){return typeof pe=="string"&&(pe===ue||pe.endsWith(re)||!K&&(pe===j||pe.endsWith(de)))?$:null}:Y=function(pe,be){return typeof pe=="string"&&(pe===ue||!K&&pe===j)?$:null},Y.allPaths=[(Q?"*/":"./")+j],Y}function R(j){try{const $=new RegExp(`^${h(j)}$`);return function(Q){return $.lastIndex=0,typeof Q=="string"&&$.test(Q)?j:null}}catch{return l}}function N(j,$,Q){return!j||typeof $!="string"?!1:V(j)($,void 0,Q)}e.match=N;function V(j,$={}){if(!j)return o;if(typeof j=="string"||x(j)){const Q=s(j,$);if(Q===l)return o;const K=function(ue,re){return!!Q(ue,re)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return F(j,$)}e.parse=V;function x(j){const $=j;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=x;function L(j){return j.allBasenames||[]}e.getBasenameTerms=L;function U(j){return j.allPaths||[]}e.getPathTerms=U;function F(j,$){const Q=M(Object.getOwnPropertyNames(j).map(Y=>B(Y,j[Y],$)).filter(Y=>Y!==l)),K=Q.length;if(!K)return l;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(Ce,Re){let We;for(let ne=0,ce=Q.length;ne<ce;ne++){const fe=Q[ne](Ce,Re);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(We||(We=[]),We.push(fe))}return We?(async()=>{for(const ne of We){const ce=await ne;if(typeof ce=="string")return ce}return null})():null},pe=Q.find(Ce=>!!Ce.allBasenames);pe&&(Y.allBasenames=pe.allBasenames);const be=Q.reduce((Ce,Re)=>Re.allPaths?Ce.concat(Re.allPaths):Ce,[]);return be.length&&(Y.allPaths=be),Y}const ue=function(Y,pe,be){let Ce,Re;for(let We=0,ne=Q.length;We<ne;We++){const ce=Q[We];ce.requiresSiblings&&be&&(pe||(pe=(0,y.basename)(Y)),Ce||(Ce=pe.substr(0,pe.length-(0,y.extname)(Y).length)));const fe=ce(Y,pe,Ce,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Re||(Re=[]),Re.push(fe))}return Re?(async()=>{for(const We of Re){const ne=await We;if(typeof ne=="string")return ne}return null})():null},re=Q.find(Y=>!!Y.allBasenames);re&&(ue.allBasenames=re.allBasenames);const de=Q.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return de.length&&(ue.allPaths=de),ue}function B(j,$,Q){if($===!1)return l;const K=s(j,Q);if(K===l)return l;if(typeof $=="boolean")return K;if($){const ue=$.when;if(typeof ue=="string"){const re=(de,Y,pe,be)=>{if(!be||!K(de,Y))return null;const Ce=ue.replace("$(basename)",pe),Re=be(Ce);return(0,t.isThenable)(Re)?Re.then(We=>We?j:null):Re?j:null};return re.requiresSiblings=!0,re}}return K}function M(j,$){const Q=j.filter(Y=>!!Y.basenames);if(Q.length<2)return j;const K=Q.reduce((Y,pe)=>{const be=pe.basenames;return be?Y.concat(be):Y},[]);let ue;if($){ue=[];for(let Y=0,pe=K.length;Y<pe;Y++)ue.push($)}else ue=Q.reduce((Y,pe)=>{const be=pe.patterns;return be?Y.concat(be):Y},[]);const re=function(Y,pe){if(typeof Y!="string")return null;if(!pe){let Ce;for(Ce=Y.length;Ce>0;Ce--){const Re=Y.charCodeAt(Ce-1);if(Re===47||Re===92)break}pe=Y.substr(Ce)}const be=K.indexOf(pe);return be!==-1?ue[be]:null};re.basenames=K,re.patterns=ue,re.allBasenames=K;const de=j.filter(Y=>!Y.basenames);return de.push(re),de}function z(j,$){return(0,c.equals)(j,$,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=z}),define(_e[110],ye([1,0,10,159,22,8,2]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",b=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(f,b=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,b){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(f,b,m){return this.value+="[",this.value+=this._escape(b,"]"),this.value+="](",this.value+=this._escape(String(f),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(f,b){const m=new RegExp((0,P.escapeRegExpCharacters)(b),"g");return f.replace(m,(d,v)=>f.charAt(v-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=S;function C(g){return A(g)?!g.value:Array.isArray(g)?g.every(C):!0}e.isEmptyMarkdownString=C;function A(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function T(g,f){return g===f?!0:!g||!f?!1:g.value===f.value&&g.isTrusted===f.isTrusted&&g.supportThemeIcons===f.supportThemeIcons&&g.supportHtml===f.supportHtml&&(g.baseUri===f.baseUri||!!g.baseUri&&!!f.baseUri&&(0,I.isEqual)(y.URI.from(g.baseUri),y.URI.from(f.baseUri)))}e.markdownStringEqual=T;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function _(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function w(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function h(g){const f=[],b=g.split("|").map(d=>d.trim());g=b[0];const m=b[1];if(m){const d=/height=(\d+)/.exec(m),v=/width=(\d+)/.exec(m),r=d?d[1]:"",o=v?v[1]:"",l=isFinite(parseInt(o)),s=isFinite(parseInt(r));l&&f.push(`width="${o}"`),s&&f.push(`height="${r}"`)}return{href:g,dimensions:f}}e.parseHrefAndDimensions=h}),define(_e[111],ye([1,0,17,32,9,12,22,8]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(l,s){const{os:a,tildify:u,relative:n}=s;if(n){const D=C(l,n,a);if(typeof D=="string")return D}let i=l.fsPath;if(a===1&&!P.isWindows?i=i.replace(/\//g,"\\"):a!==1&&P.isWindows&&(i=i.replace(/\\/g,"/")),a!==1&&u?.userHome){const D=u.userHome.fsPath;let R;l.scheme!==u.userHome.scheme&&l.path.startsWith(I.posix.sep)?R=u.userHome.with({path:l.path}).fsPath:R=l.fsPath,i=E(R,D,a)}return(a===1?I.win32:I.posix).normalize(A(i,a===1))}e.getPathLabel=S;function C(l,s,a){const u=a===1?I.win32:I.posix,n=a===3?y.extUri:y.extUriIgnorePathCase,i=s.getWorkspace(),p=(0,c.firstOrDefault)(i.folders);if(!p)return;l.scheme!==p.uri.scheme&&l.path.startsWith(I.posix.sep)&&(l=p.uri.with({path:l.path}));const D=s.getWorkspaceFolder(l);if(!D)return;let R;if(n.isEqual(D.uri,l)?R="":R=n.relativePath(D.uri,l)??"",R&&(R=u.normalize(R)),i.folders.length>1&&!s.noPrefix){const N=D.name?D.name:n.basenameOrAuthority(D.uri);R=R?`${N} \u2022 ${R}`:N}return R}function A(l,s=P.isWindows){return(0,t.hasDriveLetter)(l,s)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=A;let T=Object.create(null);function E(l,s,a=P.OS){if(a===1||!l||!s)return l;let u=T.original===s?T.normalized:void 0;u||(u=s,P.isWindows&&(u=(0,t.toSlashes)(u)),u=`${(0,k.rtrim)(u,I.posix.sep)}${I.posix.sep}`,T={original:s,normalized:u});let n=l;return P.isWindows&&(n=(0,t.toSlashes)(n)),(a===3?n.startsWith(u):(0,k.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:l}e.tildify=E;function _(l,s){return l.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=_;const w="\u2026",h="\\\\",g="~";function f(l,s=I.sep){const a=new Array(l.length);let u=!1;for(let n=0;n<l.length;n++){const i=l[n];if(i===""){a[n]=`.${s}`;continue}if(!i){a[n]=i;continue}u=!0;let p="",D=i;D.indexOf(h)===0?(p=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(s)===0?(p=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length)):D.indexOf(g)===0&&(p=D.substr(0,D.indexOf(g)+g.length),D=D.substr(D.indexOf(g)+g.length));const R=D.split(s);for(let N=1;u&&N<=R.length;N++)for(let V=R.length-N;u&&V>=0;V--){u=!1;let x=R.slice(V,V+N).join(s);for(let L=0;!u&&L<l.length;L++)if(L!==n&&l[L]&&l[L].indexOf(x)>-1){const U=V+N===R.length,F=V>0&&l[L].indexOf(s)>-1?s+x:x,B=l[L].endsWith(F);u=!U||B}if(!u){let L="";(R[0].endsWith(":")||p!=="")&&(V===1&&(V=0,N++,x=R[0]+s+x),V>0&&(L=R[0]+s),L=p+L),V>0&&(L=L+w+s),L=L+x,V+N<R.length&&(L=L+s+w),a[n]=L}}u&&(a[n]=i)}return a}e.shorten=f;var b;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function m(l,s=Object.create(null)){const a=[];let u=!1,n="";for(const i of l)if(i==="$"||u&&i==="{")n&&a.push({value:n,type:b.TEXT}),n="",u=!0;else if(i==="}"&&u){const p=s[n];if(typeof p=="string")p.length&&a.push({value:p,type:b.VARIABLE});else if(p){const D=a[a.length-1];(!D||D.type!==b.SEPARATOR)&&a.push({value:p.label,type:b.SEPARATOR})}n="",u=!1}else n+=i;return n&&!u&&a.push({value:n,type:b.TEXT}),a.filter((i,p)=>{if(i.type===b.SEPARATOR){const D=a[p-1],R=a[p+1];return[D,R].every(N=>N&&(N.type===b.VARIABLE||N.type===b.TEXT)&&N.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=m;function d(l,s){return P.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):l.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function v(l,s){return P.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,""):P.isWindows?l.replace(/&&|&/g,a=>a==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(l){const s=l.indexOf("/")!==-1?I.posix:I.win32,a=s.basename(l),u=s.dirname(l);return a.length?{name:a,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(_e[112],ye([1,0,2]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class I{constructor(T){this._uriTransformer=T}transformIncoming(T){const E=this._uriTransformer.transformIncoming(T);return E===T?T:t(c.URI.from(E))}transformOutgoing(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:t(c.URI.from(E))}transformOutgoingURI(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:c.URI.from(E)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,T,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return T.transformOutgoing(A);for(const _ in A)if(Object.hasOwnProperty.call(A,_)){const w=P(A[_],T,E+1);w!==null&&(A[_]=w)}}return null}function y(A,T){const E=P(A,T,0);return E===null?A:E}e.transformOutgoingURIs=y;function k(A,T,E,_){if(!A||_>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?c.URI.revive(T.transformIncoming(A)):T.transformIncoming(A);for(const w in A)if(Object.hasOwnProperty.call(A,w)){const h=k(A[w],T,E,_+1);h!==null&&(A[w]=h)}}return null}function S(A,T){const E=k(A,T,!1,0);return E===null?A:E}e.transformIncomingURIs=S;function C(A,T){const E=k(A,T,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=C}),define(_e[29],ye([1,0,65,84,308,18,32,80,9,12,22,2]),function(Z,e,c,t,I,P,y,k,S,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function _(F,B=E.UNLINK){if((0,y.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===E.UNLINK?h(F):w(F)}async function w(F){try{const B=(0,y.randomPath)((0,t.tmpdir)());try{await c.promises.rename(F,B)}catch(M){return M.code==="ENOENT"?void 0:h(F)}h(B).catch(M=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function h(F){return(0,I.promisify)(c.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,y.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function f(F,B){return d(await(B?b(F):(0,I.promisify)(c.readdir)(F)))}async function b(F){try{return await(0,I.promisify)(c.readdir)(F,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],M=await f(F);for(const z of M){let j=!1,$=!1,Q=!1;try{const K=await e.Promises.lstat((0,S.join)(F,z));j=K.isFile(),$=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}B.push({name:z,isFile:()=>j,isDirectory:()=>$,isSymbolicLink:()=>Q})}return B}function m(F){return d(c.readdirSync(F))}e.readdirSync=m;function d(F){return F.map(B=>typeof B=="string"?C.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=C.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function v(F){const B=await f(F),M=[];for(const z of B)await o.existsDirectory((0,S.join)(F,z))&&M.push(z);return M}function r(F,B=1e3){return new Promise(M=>{let z=!1;const j=setInterval(()=>{z||(z=!0,c.access(F,$=>{z=!1,$&&(clearInterval(j),M(void 0))}))},B)})}e.whenDeleted=r;var o;(function(F){async function B(j){let $;try{if($=await e.Promises.lstat(j),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(C.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw K}throw Q}}F.stat=B;async function M(j){try{const{stat:$,symbolicLink:Q}=await F.stat(j);return $.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=M;async function z(j){try{const{stat:$,symbolicLink:Q}=await F.stat(j);return $.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new P.ResourceQueue;function s(F,B,M){return l.queueFor(T.URI.file(F),A.extUriBiasedIgnorePathCase).queue(()=>{const z=p(M);return new Promise((j,$)=>n(F,B,z,Q=>Q?$(Q):j()))})}let a=!0;function u(F){a=F}e.configureFlushOnWrite=u;function n(F,B,M,z){if(!a)return c.writeFile(F,B,{mode:M.mode,flag:M.flag},z);c.open(F,M.flag,M.mode,(j,$)=>{if(j)return z(j);c.writeFile($,B,Q=>{if(Q)return c.close($,()=>z(Q));c.fdatasync($,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),u(!1)),c.close($,ue=>z(ue))))})})}function i(F,B,M){const z=p(M);if(!a)return c.writeFileSync(F,B,{mode:z.mode,flag:z.flag});const j=c.openSync(F,z.flag,z.mode);try{c.writeFileSync(j,B);try{c.fdatasyncSync(j)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),u(!1)}}finally{c.closeSync(j)}}e.writeFileSync=i;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function D(F,B){if(F!==B)try{await e.Promises.rename(F,B)}catch(M){if(F.toLowerCase()!==B.toLowerCase()&&M.code==="EXDEV"||F.endsWith("."))await R(F,B,{preserveSymlinks:!1}),await _(F,E.MOVE);else throw M}}async function R(F,B,M){return V(F,B,{root:{source:F,target:B},options:M,handledSourcePaths:new Set})}const N=511;async function V(F,B,M){if(M.handledSourcePaths.has(F))return;M.handledSourcePaths.add(F);const{stat:z,symbolicLink:j}=await o.stat(F);if(j){if(M.options.preserveSymlinks)try{return await U(F,B,M)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(j.dangling)return}return z.isDirectory()?x(F,B,z.mode&N,M):L(F,B,z.mode&N)}async function x(F,B,M,z){await e.Promises.mkdir(B,{recursive:!0,mode:M});const j=await f(F);for(const $ of j)await V((0,S.join)(F,$),(0,S.join)(B,$),z)}async function L(F,B,M){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,M)}async function U(F,B,M){let z=await e.Promises.readlink(F);(0,y.isEqualOrParent)(z,M.root.source,!C.isLinux)&&(z=(0,S.join)(M.root.target,z.substr(M.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,I.promisify)(c.access)}get stat(){return(0,I.promisify)(c.stat)}get lstat(){return(0,I.promisify)(c.lstat)}get utimes(){return(0,I.promisify)(c.utimes)}get read(){return(F,B,M,z,j)=>new Promise(($,Q)=>{c.read(F,B,M,z,j,(K,ue,re)=>K?Q(K):$({bytesRead:ue,buffer:re}))})}get readFile(){return(0,I.promisify)(c.readFile)}get write(){return(F,B,M,z,j)=>new Promise(($,Q)=>{c.write(F,B,M,z,j,(K,ue,re)=>K?Q(K):$({bytesWritten:ue,buffer:re}))})}get appendFile(){return(0,I.promisify)(c.appendFile)}get fdatasync(){return(0,I.promisify)(c.fdatasync)}get truncate(){return(0,I.promisify)(c.truncate)}get rename(){return(0,I.promisify)(c.rename)}get copyFile(){return(0,I.promisify)(c.copyFile)}get open(){return(0,I.promisify)(c.open)}get close(){return(0,I.promisify)(c.close)}get symlink(){return(0,I.promisify)(c.symlink)}get readlink(){return(0,I.promisify)(c.readlink)}get chmod(){return(0,I.promisify)(c.chmod)}get mkdir(){return(0,I.promisify)(c.mkdir)}get unlink(){return(0,I.promisify)(c.unlink)}get rmdir(){return(0,I.promisify)(c.rmdir)}get realpath(){return(0,I.promisify)(c.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return v}get writeFile(){return s}get rm(){return _}get move(){return D}get copy(){return R}}}),define(_e[113],ye([1,0,65,9,12,8,29]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(E){if(I.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,y.readdirSync)(_).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=k(_);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const b=k(_);if(b)return(0,t.join)(b,g[f])}}}catch{}return null}e.realcaseSync=k;async function S(E){if(I.isLinux)return E;const _=(0,t.dirname)(E);if(E===_)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const g=(await y.Promises.readdir(_)).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=await S(_);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const b=await S(_);if(b)return(0,t.join)(b,g[f])}}}catch{}return null}e.realcase=S;async function C(E){try{return await y.Promises.realpath(E)}catch{const w=T(E);return await y.Promises.access(w,c.constants.R_OK),w}}e.realpath=C;function A(E){try{return c.realpathSync(E)}catch{const w=T(E);return c.accessSync(w,c.constants.R_OK),w}}e.realpathSync=A;function T(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(_e[114],ye([1,0,9,12,36,106,11,29]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function S(T=I.env){return T.comspec||"cmd.exe"}e.getWindowsShell=S;function C(T){let E=[],_=!1;const w=function(h){if(_){E.push(h);return}(!T.send(h,f=>{if(f&&console.error(f),_=!1,E.length>0){const b=E.slice(0);E=[],b.forEach(m=>w(m))}})||t.isWindows)&&(_=!0)};return{send:w}}e.createQueuedSender=C;var A;(function(T){async function E(_,w,h){if(c.isAbsolute(_))return _;if(w===void 0&&(w=I.cwd()),c.dirname(_)!=="."||(h===void 0&&y.isString(I.env.PATH)&&(h=I.env.PATH.split(c.delimiter)),h===void 0||h.length===0))return c.join(w,_);async function f(b){if(await k.Promises.exists(b)){let m;try{m=await k.Promises.stat(b)}catch(d){d.message.startsWith("EACCES")&&(m=await k.Promises.lstat(b))}return m?!m.isDirectory():!1}return!1}for(const b of h){let m;if(c.isAbsolute(b)?m=c.join(b,_):m=c.join(w,b,_),await f(m))return m;let d=m+".com";if(await f(d)||(d=m+".exe",await f(d)))return d}return c.join(w,_)}T.findExecutable=E})(A=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(Z,e,c,t){var I=arguments.length,P=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,c,t);else for(var k=Z.length-1;k>=0;k--)(y=Z[k])&&(P=(I<3?y(P):I>3?y(e,c,P):y(e,c))||P);return I>3&&P&&Object.defineProperty(e,c,P),P};define(_e[115],ye([1,0,17,18,23,21,60,10,4,6,83,8,11]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var _;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(_||(_={}));function w(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(h||(h={}));function g(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));class b{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}class m{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var d;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(d||(d={}));function v(j){const $=I.VSBuffer.alloc(4);return $.writeUInt32BE(j,0),$}function r(j){return j.read(4).readUInt32BE(0)}function o(j){const $=I.VSBuffer.alloc(1);return $.writeUInt8(j,0),$}const l={Undefined:o(d.Undefined),String:o(d.String),Buffer:o(d.Buffer),VSBuffer:o(d.VSBuffer),Array:o(d.Array),Object:o(d.Object)},s=typeof Buffer<"u";function a(j,$){if(typeof $>"u")j.write(l.Undefined);else if(typeof $=="string"){const Q=I.VSBuffer.fromString($);j.write(l.String),j.write(v(Q.byteLength)),j.write(Q)}else if(s&&Buffer.isBuffer($)){const Q=I.VSBuffer.wrap($);j.write(l.Buffer),j.write(v(Q.byteLength)),j.write(Q)}else if($ instanceof I.VSBuffer)j.write(l.VSBuffer),j.write(v($.byteLength)),j.write($);else if(Array.isArray($)){j.write(l.Array),j.write(v($.length));for(const Q of $)a(j,Q)}else{const Q=I.VSBuffer.fromString(JSON.stringify($));j.write(l.Object),j.write(v(Q.byteLength)),j.write(Q)}}function u(j){switch(j.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return j.read(r(j)).toString();case d.Buffer:return j.read(r(j)).buffer;case d.VSBuffer:return j.read(r(j));case d.Array:{const Q=r(j),K=[];for(let ue=0;ue<Q;ue++)K.push(u(j));return K}case d.Object:return JSON.parse(j.read(r(j)).toString())}}class n{constructor($,Q,K=null,ue=1e3){this.protocol=$,this.ctx=Q,this.logger=K,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,g($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,g($.type),$.data);return}}}send($,Q=void 0){const K=new m;return a(K,$),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new b($),K=u(Q),ue=u(Q),re=K[0];switch(re){case 100:return this.logger?.logIncoming($.byteLength,K[1],1,`${w(re)}: ${K[2]}.${K[3]}`,ue),this.onPromise({type:re,id:K[1],channelName:K[2],name:K[3],arg:ue});case 102:return this.logger?.logIncoming($.byteLength,K[1],1,`${w(re)}: ${K[2]}.${K[3]}`,ue),this.onEventListen({type:re,id:K[1],channelName:K[2],name:K[3],arg:ue});case 101:return this.logger?.logIncoming($.byteLength,K[1],1,`${w(re)}`),this.disposeActiveRequest({type:re,id:K[1]});case 103:return this.logger?.logIncoming($.byteLength,K[1],1,`${w(re)}`),this.disposeActiveRequest({type:re,id:K[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=new P.CancellationTokenSource;let ue;try{ue=Q.call(this.ctx,$.name,$.arg,K.token)}catch(Y){ue=Promise.reject(Y)}const re=$.id;ue.then(Y=>{this.sendResponse({id:re,data:Y,type:201}),this.activeRequests.delete($.id)},Y=>{Y instanceof Error?this.sendResponse({id:re,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:re,data:Y,type:203}),this.activeRequests.delete($.id)});const de=(0,C.toDisposable)(()=>K.cancel());this.activeRequests.set($.id,de)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=$.id,re=Q.listen(this.ctx,$.name,$.arg)(de=>this.sendResponse({id:K,data:de,type:204}));this.activeRequests.set($.id,re)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:K})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var i;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(i=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel($){const Q=this;return{call(K,ue,re){return Q.isDisposed?Promise.reject(new k.CancellationError):Q.requestPromise($,K,ue,re)},listen(K,ue){return Q.isDisposed?S.Event.None:Q.requestEvent($,K,ue)}}}requestPromise($,Q,K,ue=P.CancellationToken.None){const re=this.lastRequestId++,Y={id:re,type:100,channelName:$,name:Q,arg:K};if(ue.isCancellationRequested)return Promise.reject(new k.CancellationError);let pe;return new Promise((Ce,Re)=>{if(ue.isCancellationRequested)return Re(new k.CancellationError);const We=()=>{const J=ie=>{switch(ie.type){case 201:this.handlers.delete(re),Ce(ie.data);break;case 202:{this.handlers.delete(re);const te=new Error(ie.data.message);te.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,te.name=ie.data.name,Re(te);break}case 203:this.handlers.delete(re),Re(ie.data);break}};this.handlers.set(re,J),this.sendRequest(Y)};let ne=null;this.state===f.Idle?We():(ne=(0,t.createCancelablePromise)(J=>this.whenInitialized()),ne.then(()=>{ne=null,We()}));const ce=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:re,type:101}),Re(new k.CancellationError)},fe=ue.onCancellationRequested(ce);pe=(0,C.combinedDisposable)((0,C.toDisposable)(ce),fe),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent($,Q,K){const ue=this.lastRequestId++,de={id:ue,type:102,channelName:$,name:Q,arg:K};let Y=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{Y=(0,t.createCancelablePromise)(Ce=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(pe),this.sendRequest(de)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(pe),this.sendRequest({id:ue,type:103}))}}),be=Ce=>pe.fire(Ce.data);return this.handlers.set(ue,be),pe.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(Q,$.id,0,`${w($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger?.logOutgoing(Q,$.id,0,w($.type));return}}}send($,Q=void 0){const K=new m;return a(K,$),a(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new b($),K=u(Q),ue=u(Q),re=K[0];switch(re){case 200:return this.logger?.logIncoming($.byteLength,0,0,g(re)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,K[1],0,g(re),ue),this.onResponse({type:K[0],id:K[1],data:ue})}}onResponse($){if($.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([y.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class D{get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Q,onDidClientDisconnect:K})=>{S.Event.once(Q.onMessage)(re=>{const de=new b(re),Y=u(de),pe=new n(Q,Y),be=new p(Q);this.channels.forEach((Re,We)=>pe.registerChannel(We,Re));const Ce={channelServer:pe,channelClient:be,ctx:Y};this._connections.add(Ce),this._onDidAddConnection.fire(Ce),K(()=>{pe.dispose(),be.dispose(),this._connections.delete(Ce),this._onDidRemoveConnection.fire(Ce)})})})}getChannel($,Q){const K=this;return{call(ue,re,de){let Y;if((0,E.isFunction)(Q)){const be=(0,c.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,ue,re);const pe=Y.then(be=>be.channelClient.getChannel($));return N(pe).call(ue,re,de)},listen(ue,re){if((0,E.isFunction)(Q))return K.getMulticastEvent($,Q,ue,re);const de=Q.routeEvent(K,ue,re).then(Y=>Y.channelClient.getChannel($));return N(de).listen(ue,re)}}}getMulticastEvent($,Q,K,ue){const re=this;let de=new C.DisposableStore;const Y=new S.Emitter({onWillAddFirstListener:()=>{de=new C.DisposableStore;const pe=new S.EventMultiplexer,be=new Map,Ce=We=>{const ce=We.channelClient.getChannel($).listen(K,ue),fe=pe.add(ce);be.set(We,fe)},Re=We=>{const ne=be.get(We);!ne||(ne.dispose(),be.delete(We))};re.connections.filter(Q).forEach(Ce),S.Event.filter(re.onDidAddConnection,Q)(Ce,void 0,de),re.onDidRemoveConnection(Re,void 0,de),pe.event(Y.fire,Y,de),de.add(pe)},onDidRemoveLastListener:()=>{de.dispose()}});return Y.event}registerChannel($,Q){this.channels.set($,Q),this._connections.forEach(K=>{K.channelServer.registerChannel($,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class R{constructor($,Q,K=null){const ue=new m;a(ue,Q),$.send(ue.buffer),this.channelClient=new p($,K),this.channelServer=new n($,Q,K)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N(j){return{call($,Q,K){return j.then(ue=>ue.call($,Q,K))},listen($,Q){const K=new S.Relay;return j.then(ue=>K.input=ue.listen($,Q)),K.event}}}e.getDelayedChannel=N;function V(j){let $=!1;return{call(Q,K,ue){return $?j.call(Q,K,ue):(0,t.timeout)(0).then(()=>$=!0).then(()=>j.call(Q,K,ue))},listen(Q,K){if($)return j.listen(Q,K);const ue=new S.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>ue.input=j.listen(Q,K)),ue.event}}}e.getNextTickChannel=V;class x{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=x;var L;(function(j){function $(re,de){const Y=re,pe=de&&de.disableMarshalling,be=new Map;for(const Ce in Y)K(Ce)&&be.set(Ce,S.Event.buffer(Y[Ce],!0));return new class{listen(Ce,Re,We){const ne=be.get(Re);if(ne)return ne;if(ue(Re)){const ce=Y[Re];if(typeof ce=="function")return ce.call(Y,We)}throw new Error(`Event not found: ${Re}`)}call(Ce,Re,We){const ne=Y[Re];if(typeof ne=="function"){if(!pe&&Array.isArray(We))for(let ce=0;ce<We.length;ce++)We[ce]=(0,A.revive)(We[ce]);return ne.apply(Y,We)}throw new Error(`Method not found: ${Re}`)}}}j.fromService=$;function Q(re,de){const Y=de&&de.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return de?.properties?.has(be)?de.properties.get(be):ue(be)?function(Ce){return re.listen(be,Ce)}:K(be)?re.listen(be):async function(...Ce){let Re;de&&!(0,E.isUndefinedOrNull)(de.context)?Re=[de.context,...Ce]:Re=Ce;const We=await re.call(be,Re);return Y?We:(0,A.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}j.toService=Q;function K(re){return re[0]==="o"&&re[1]==="n"&&T.isUpperAsciiLetter(re.charCodeAt(2))}function ue(re){return/^onDynamic/.test(re)&&T.isUpperAsciiLetter(re.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const $=j.toString();if($!=="[object Object]")return $}return j}function B(j){return Array.isArray(j)?j.map(F):F(j)}function M(j,$,Q,K,ue,re,de){de=B(de);const Y=U[ue],pe=Y[K%Y.length];let be=[`%c[${j}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(re)?(be=be.concat(de),be.push(")")):be.push(de),console.log.apply(console,be)}class z{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,K,ue,re){this._totalOutgoing+=$,M(this._outgoingPrefix,this._totalOutgoing,$,Q,K,ue,re)}logIncoming($,Q,K,ue,re){this._totalIncoming+=$,M(this._incomingPrefix,this._totalIncoming,$,Q,K,ue,re)}}e.IPCLogger=z}),define(_e[116],ye([1,0,23,4,6,115]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let u=0;function n(p,D){if(!a.has(p)){const R=String(++u);a.set(p,R)}return a.get(p)}function i(p,D,R,N){if(!s.enableDiagnostics)return;const V=n(p,D);if(N instanceof c.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const x=c.VSBuffer.alloc(N.byteLength);x.set(N),s.records.push({timestamp:Date.now(),id:V,label:D,type:R,buff:x})}else s.records.push({timestamp:Date.now(),id:V,label:D,type:R,data:N})}s.traceSocketEvent=i})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function A(){return C||(C=c.VSBuffer.alloc(0)),C}class T{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,u){if(a===0)return A();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const D=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=a),D}if(this._chunks[0].byteLength>a){const D=this._chunks[0].slice(0,a);return u&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),D}const n=c.VSBuffer.alloc(a);let i=0,p=0;for(;a>0;){const D=this._chunks[p];if(D.byteLength>a){const R=D.slice(0,a);n.set(R,i),i+=a,u&&(this._chunks[p]=D.slice(a),this._totalLength-=a),a-=a}else n.set(D,i),i+=D.byteLength,u?(this._chunks.shift(),this._totalLength-=D.byteLength):p++,a-=D.byteLength}return n}}e.ChunkStream=T;var E;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(E||(E={}));function _(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(a,u,n,i){this.type=a,this.id=u,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,i=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new h(n,i,p,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=c.VSBuffer.alloc(13);u.writeUInt8(a.type,0),u.writeUInt32BE(a.id,1),u.writeUInt32BE(a.ack,5),u.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(u,a.data)}_bufferAdd(a,u){const n=this._totalLength===0;return this._data.push(a,u),this._totalLength+=a.byteLength+u.byteLength,n}_bufferTake(){const a=c.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,u){this._bufferAdd(a,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class b extends I.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new h(1,0,0,a))}}e.Protocol=b;class m extends P.IPCClient{static fromSocket(a,u){return new m(new b(a),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,u,n=null){super(a,u,n),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=m;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class v{constructor(a){this.data=a,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let a=0,u=this._first;for(;u;)u=u.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let u=0,n=this._first;for(;n;)a[u++]=n.data,n=n.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const u=new v(a);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let u=0;u<o._HISTORY_LENGTH;u++)this.lastRuns[u]=a-1e3*u;setInterval(()=>{for(let u=o._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),u=(1+o._HISTORY_LENGTH)*1e3;let n=0;for(let i=0;i<o._HISTORY_LENGTH;i++)a-this.lastRuns[i]<=u&&n++;return 1-n/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class l{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,u=null,n=o.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(i=>this._onSocketClose.fire(i))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new h(5,0,0,A());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new h(7,0,0,A());this._socketWriter.write(a)}sendResume(){const a=new h(8,0,0,A());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,u){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a);const u=this._outgoingUnackMsg.toArray();for(let n=0,i=u.length;n<i;n++)this._socketWriter.write(u[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new h(6,0,0,A())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let n=0,i=u.length;n<i;n++)this._socketWriter.write(u[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new h(1,u,this._incomingAckId,a);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(a){const u=new h(2,0,0,a);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),u=Date.now()-a.writtenTime,n=Date.now()-this._socketReader.lastReadTime,i=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&n>=2e4&&i>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-u,2e4-n,2e4-i,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,A());this._socketWriter.write(a)}_sendKeepAlive(){const a=new h(9,0,0,A());this._socketWriter.write(a)}}e.PersistentProtocol=l}),define(_e[117],ye([1,0,23,10,4,6,9,12,30,115,116]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class E{traceSocketEvent(n,i){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this._canWrite=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const i=p=>{this.traceSocketEvent("read",p),n(c.VSBuffer.wrap(p))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var _;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(w||(w={}));class h extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,p,D){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:p?.byteLength||0,recordInflateBytes:D}),this._flowManager=this._register(new g(this,i,p,D,this._onData,(R,N)=>this._write(R,N))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,i){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const D=c.VSBuffer.alloc(p);if(i?D.writeUInt8(194,0):D.writeUInt8(130,0),n.byteLength<126)D.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){D.writeUInt8(126,1);let R=1;D.writeUInt8(n.byteLength>>>8&255,++R),D.writeUInt8(n.byteLength>>>0&255,++R)}else{D.writeUInt8(127,1);let R=1;D.writeUInt8(0,++R),D.writeUInt8(0,++R),D.writeUInt8(0,++R),D.writeUInt8(0,++R),D.writeUInt8(n.byteLength>>>24&255,++R),D.writeUInt8(n.byteLength>>>16&255,++R),D.writeUInt8(n.byteLength>>>8&255,++R),D.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([D,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const i=this._incomingData.peek(this._state.readLen),p=i.readUInt8(0),D=(p&128)>>>7,R=(p&64)>>>6,N=i.readUInt8(1),V=(N&128)>>>7,x=N&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=D,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(D),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const i=this._incomingData.read(this._state.readLen),p=i.readUInt8(1),D=(p&128)>>>7;let R=p&127,N=1;R===126?R=i.readUInt8(++N)*2**8+i.readUInt8(++N):R===127&&(R=i.readUInt8(++N)*0+i.readUInt8(++N)*0+i.readUInt8(++N)*0+i.readUInt8(++N)*0+i.readUInt8(++N)*2**24+i.readUInt8(++N)*2**16+i.readUInt8(++N)*2**8+i.readUInt8(++N));let V=0;D&&(V=i.readUInt8(++N)*2**24+i.readUInt8(++N)*2**16+i.readUInt8(++N)*2**8+i.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const i=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),m(i,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(i,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class g extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,i,p,D,R,N){super(),this._tracer=n,this._onData=R,this._writeFn=N,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,i?(this._zlibInflateStream=this._register(new f(this._tracer,D,p,{windowBits:15})),this._zlibDeflateStream=this._register(new b(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const i=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(i,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,i){return new Promise((p,D)=>{n.write(i),n.flush(R=>p(R))})}acceptFrame(n,i,p){this._readQueue.push({data:n,isCompressed:i,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const i=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(i)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,i,p){return new Promise((D,R)=>{n.write(i),p&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(N=>D(N))})}}class f extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?c.VSBuffer.concat(this._recordedInflateBytes):c.VSBuffer.alloc(0)}constructor(n,i,p,D){super(),this._tracer=n,this._recordInflateBytes=i,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=T().zlib.createInflateRaw(D),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(c.VSBuffer.wrap(R))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const i=c.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(i)})}}class b extends P.Disposable{constructor(n,i){super(),this._tracer=n,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=T().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(c.VSBuffer.wrap(p))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let i=c.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function m(u,n){if(n===0)return;const i=u.byteLength>>>2;for(let x=0;x<i;x++){const L=u.readUInt32BE(x*4);u.writeUInt32BE(L^n,x*4)}const p=i*4,D=u.byteLength-p,R=n>>>24&255,N=n>>>16&255,V=n>>>8&255;D>=1&&u.writeUInt8(u.readUInt8(p)^R,p),D>=2&&u.writeUInt8(u.readUInt8(p+1)^N,p+1),D>=3&&u.writeUInt8(u.readUInt8(p+2)^V,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function v(){const u=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):n=(0,y.join)(T().os.tmpdir(),`vscode-ipc-${u}.sock`),o(n),n}e.createRandomIPCHandle=v;function r(u,n,i){const p=T().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${i}-${n}-sock`;let D;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?D=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${i}-${n}.sock`):D=(0,y.join)(u,`${i}-${n}.sock`),o(D),D}e.createStaticIPCHandle=r;function o(u){const n=d[k.platform];typeof n=="number"&&u.length>=n&&console.warn(`WARNING: IPC handle "${u}" is longer than ${n} chars, try a shorter --user-data-dir`)}class l extends C.IPCServer{static toClientConnectionEvent(n){const i=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(i,p=>({protocol:new A.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(l.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function s(u){return new Promise((n,i)=>{const p=T().net.createServer();p.on("error",i),p.listen(u,()=>{p.removeListener("error",i),n(new l(p))})})}e.serve=s;function a(u,n){return new Promise((i,p)=>{const D=T().net.createConnection(u,()=>{D.removeListener("error",p),i(A.Client.fromSocket(new E(D,`ipc-client${n}`),n))});D.once("error",p)})}e.connect=a}),define(_e[160],ye([1,0,37,9]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(P,y,k,S,C,A){if(Array.isArray(P)){let T=0;for(const E of P){const _=I(E,y,k,S,C,A);if(_===10)return _;_>T&&(T=_)}return T}else{if(typeof P=="string")return S?P==="*"?5:P===k?10:0:0;if(P){const{language:T,pattern:E,scheme:_,hasAccessToAllModels:w,notebookType:h}=P;if(!S&&!w)return 0;h&&C&&(y=C);let g=0;if(_)if(_===y.scheme)g=10;else if(_==="*")g=5;else return 0;if(T)if(T===k)g=10;else if(T==="*")g=Math.max(g,5);else return 0;if(h)if(h===A)g=10;else if(h==="*"&&A!==void 0)g=Math.max(g,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===y.fsPath||(0,c.match)(f,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=I}),define(_e[161],ye([1,0,8,49,152]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(k,S,C,A){this._uri=k,this._lines=S,this._eol=C,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let A=0;A<S;A++)C[A]=this._lines[A].length+k;this._lineStarts=new I.PrefixSumComputer(C)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;const C=(0,c.splitLines)(S);if(C.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}C[C.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]);const A=new Uint32Array(C.length-1);for(let T=1;T<C.length;T++)this._lines.splice(k.lineNumber+T-1,0,C[T]),A[T-1]=C[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,A)}}e.MirrorTextModel=P}),define(_e[162],ye([1,0,8,149,49,35,105]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(b,m,d,v){this.searchString=b,this.isRegex=m,this.matchCase=d,this.wordSeparators=v}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=C(this.searchString):b=this.searchString.indexOf(`
`)>=0;let m=null;try{m=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!m)return null;let d=!this.isRegex&&!b;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new y.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=S;function C(f){if(!f||f.length===0)return!1;for(let b=0,m=f.length;b<m;b++){const d=f.charCodeAt(b);if(d===10)return!0;if(d===92){if(b++,b>=m)break;const v=f.charCodeAt(b);if(v===110||v===114||v===87)return!0}}return!1}e.isMultilineRegexSource=C;function A(f,b,m){if(!m)return new y.FindMatch(f,null);const d=[];for(let v=0,r=b.length;v<r;v++)d[v]=b[v];return new y.FindMatch(f,d)}e.createFindMatch=A;class T{constructor(b){const m=[];let d=0;for(let v=0,r=b.length;v<r;v++)b.charCodeAt(v)===10&&(m[d++]=v);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(b){const m=this._lineFeedsOffsets;let d=0,v=m.length-1;if(v===-1||b<=m[0])return 0;for(;d<v;){const r=d+((v-d)/2>>0);m[r]>=b?v=r-1:m[r+1]>=b?(d=r,v=r):d=r+1}return d+1}}class E{static findMatches(b,m,d,v,r){const o=m.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(b,d,new g(o.wordSeparators,o.regex),v,r):this._doFindMatchesLineByLine(b,d,o,v,r):[]}static _getMultilineMatchRange(b,m,d,v,r,o){let l,s=0;v?(s=v.findLineFeedCountBeforeOffset(r),l=m+r+s):l=m+r;let a;if(v){const p=v.findLineFeedCountBeforeOffset(r+o.length)-s;a=l+o.length+p}else a=l+o.length;const u=b.getPositionAt(l),n=b.getPositionAt(a);return new P.Range(u.lineNumber,u.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(b,m,d,v,r){const o=b.getOffsetAt(m.getStartPosition()),l=b.getValueInRange(m,1),s=b.getEOL()===`\r
`?new T(l):null,a=[];let u=0,n;for(d.reset(0);n=d.next(l);)if(a[u++]=A(this._getMultilineMatchRange(b,o,l,s,n.index,n[0]),n,v),u>=r)return a;return a}static _doFindMatchesLineByLine(b,m,d,v,r){const o=[];let l=0;if(m.startLineNumber===m.endLineNumber){const a=b.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return l=this._findMatchesInLine(d,a,m.startLineNumber,m.startColumn-1,l,o,v,r),o}const s=b.getLineContent(m.startLineNumber).substring(m.startColumn-1);l=this._findMatchesInLine(d,s,m.startLineNumber,m.startColumn-1,l,o,v,r);for(let a=m.startLineNumber+1;a<m.endLineNumber&&l<r;a++)l=this._findMatchesInLine(d,b.getLineContent(a),a,0,l,o,v,r);if(l<r){const a=b.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);l=this._findMatchesInLine(d,a,m.endLineNumber,0,l,o,v,r)}return o}static _findMatchesInLine(b,m,d,v,r,o,l,s){const a=b.wordSeparators;if(!l&&b.simpleSearch){const i=b.simpleSearch,p=i.length,D=m.length;let R=-p;for(;(R=m.indexOf(i,R+p))!==-1;)if((!a||h(a,m,D,R,p))&&(o[r++]=new y.FindMatch(new P.Range(d,R+1+v,d,R+1+p+v),null),r>=s))return r;return r}const u=new g(b.wordSeparators,b.regex);let n;u.reset(0);do if(n=u.next(m),n&&(o[r++]=A(new P.Range(d,n.index+1+v,d,n.index+1+n[0].length+v),n,l),r>=s))return r;while(n);return r}static findNextMatch(b,m,d,v){const r=m.parseSearchRequest();if(!r)return null;const o=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(b,d,o,v):this._doFindNextMatchLineByLine(b,d,o,v)}static _doFindNextMatchMultiline(b,m,d,v){const r=new I.Position(m.lineNumber,1),o=b.getOffsetAt(r),l=b.getLineCount(),s=b.getValueInRange(new P.Range(r.lineNumber,r.column,l,b.getLineMaxColumn(l)),1),a=b.getEOL()===`\r
`?new T(s):null;d.reset(m.column-1);const u=d.next(s);return u?A(this._getMultilineMatchRange(b,o,s,a,u.index,u[0]),u,v):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(b,new I.Position(1,1),d,v):null}static _doFindNextMatchLineByLine(b,m,d,v){const r=b.getLineCount(),o=m.lineNumber,l=b.getLineContent(o),s=this._findFirstMatchInLine(d,l,o,m.column,v);if(s)return s;for(let a=1;a<=r;a++){const u=(o+a-1)%r,n=b.getLineContent(u+1),i=this._findFirstMatchInLine(d,n,u+1,1,v);if(i)return i}return null}static _findFirstMatchInLine(b,m,d,v,r){b.reset(v-1);const o=b.next(m);return o?A(new P.Range(d,o.index+1,d,o.index+1+o[0].length),o,r):null}static findPreviousMatch(b,m,d,v){const r=m.parseSearchRequest();if(!r)return null;const o=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(b,d,o,v):this._doFindPreviousMatchLineByLine(b,d,o,v)}static _doFindPreviousMatchMultiline(b,m,d,v){const r=this._doFindMatchesMultiline(b,new P.Range(1,1,m.lineNumber,m.column),d,v,10*k);if(r.length>0)return r[r.length-1];const o=b.getLineCount();return m.lineNumber!==o||m.column!==b.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(b,new I.Position(o,b.getLineMaxColumn(o)),d,v):null}static _doFindPreviousMatchLineByLine(b,m,d,v){const r=b.getLineCount(),o=m.lineNumber,l=b.getLineContent(o).substring(0,m.column-1),s=this._findLastMatchInLine(d,l,o,v);if(s)return s;for(let a=1;a<=r;a++){const u=(r+o-a-1)%r,n=b.getLineContent(u+1),i=this._findLastMatchInLine(d,n,u+1,v);if(i)return i}return null}static _findLastMatchInLine(b,m,d,v){let r=null,o;for(b.reset(0);o=b.next(m);)r=A(new P.Range(d,o.index+1,d,o.index+1+o[0].length),o,v);return r}}e.TextModelSearch=E;function _(f,b,m,d,v){if(d===0)return!0;const r=b.charCodeAt(d-1);if(f.get(r)!==0||r===13||r===10)return!0;if(v>0){const o=b.charCodeAt(d);if(f.get(o)!==0)return!0}return!1}function w(f,b,m,d,v){if(d+v===m)return!0;const r=b.charCodeAt(d+v);if(f.get(r)!==0||r===13||r===10)return!0;if(v>0){const o=b.charCodeAt(d+v-1);if(f.get(o)!==0)return!0}return!1}function h(f,b,m,d,v){return _(f,b,m,d,v)&&w(f,b,m,d,v)}e.isValidMatch=h;class g{constructor(b,m){this._wordSeparators=b,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const m=b.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(d=this._searchRegex.exec(b),!d))return null;const v=d.index,r=d[0].length;if(v===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){c.getNextCodePoint(b,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=v,this._prevMatchLength=r,!this._wordSeparators||h(this._wordSeparators,b,m,v,r))return d}while(d);return null}}e.Searcher=g}),define(_e[118],ye([1,0,23,12]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(I||(I={}));function P(T){for(let E=0,_=T.length;E<_;E+=4){const w=T[E+0],h=T[E+1],g=T[E+2],f=T[E+3];T[E+0]=f,T[E+1]=g,T[E+2]=h,T[E+3]=w}}function y(T){const E=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return t.isLittleEndian()||P(E),c.VSBuffer.wrap(E)}function k(T){const E=T.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const _=new Uint8Array(E.byteLength);return _.set(E),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function S(T){const E=new Uint32Array(C(T));let _=0;if(E[_++]=T.id,T.type==="full")E[_++]=1,E[_++]=T.data.length,E.set(T.data,_),_+=T.data.length;else{E[_++]=2,E[_++]=T.deltas.length;for(const w of T.deltas)E[_++]=w.start,E[_++]=w.deleteCount,w.data?(E[_++]=w.data.length,E.set(w.data,_),_+=w.data.length):E[_++]=0}return y(E)}e.encodeSemanticTokensDto=S;function C(T){let E=0;if(E+=1+1,T.type==="full")E+=1+T.data.length;else{E+=1,E+=(1+1+1)*T.deltas.length;for(const _ of T.deltas)_.data&&(E+=_.data.length)}return E}function A(T){const E=k(T);let _=0;const w=E[_++];if(E[_++]===1){const b=E[_++],m=E.subarray(_,_+b);return _+=b,{id:w,type:"full",data:m}}const g=E[_++],f=[];for(let b=0;b<g;b++){const m=E[_++],d=E[_++],v=E[_++];let r;v>0&&(r=E.subarray(_,_+v),_+=v),f[b]={start:m,deleteCount:d,data:r}}return{id:w,type:"delta",deltas:f}}e.decodeSemanticTokensDto=A}),define(_e[163],ye([1,0,4,6]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,S){this._factories.get(k)?.dispose();const C=new P(this,k,S);return this._factories.set(k,C),(0,t.toDisposable)(()=>{const A=this._factories.get(k);!A||A!==C||(this._factories.delete(k),A.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const C=this._factories.get(k);return!C||C.isResolved?null:(await C.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const C=this._factories.get(k);return!!(!C||C.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(k,S,C){super(),this._registry=k,this._languageId=S,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(_e[66],ye([1,0,77,2,35,163]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(p,D,R){this._tokenBrand=void 0,this.offset=p,this.type=D,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class k{constructor(p,D){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=D}}e.TokenizationResult=k;class S{constructor(p,D){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=D}}e.EncodedTokenizationResult=S;var C;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(i){const p=new Map;p.set(0,c.Codicon.symbolMethod),p.set(1,c.Codicon.symbolFunction),p.set(2,c.Codicon.symbolConstructor),p.set(3,c.Codicon.symbolField),p.set(4,c.Codicon.symbolVariable),p.set(5,c.Codicon.symbolClass),p.set(6,c.Codicon.symbolStruct),p.set(7,c.Codicon.symbolInterface),p.set(8,c.Codicon.symbolModule),p.set(9,c.Codicon.symbolProperty),p.set(10,c.Codicon.symbolEvent),p.set(11,c.Codicon.symbolOperator),p.set(12,c.Codicon.symbolUnit),p.set(13,c.Codicon.symbolValue),p.set(15,c.Codicon.symbolEnum),p.set(14,c.Codicon.symbolConstant),p.set(15,c.Codicon.symbolEnum),p.set(16,c.Codicon.symbolEnumMember),p.set(17,c.Codicon.symbolKeyword),p.set(27,c.Codicon.symbolSnippet),p.set(18,c.Codicon.symbolText),p.set(19,c.Codicon.symbolColor),p.set(20,c.Codicon.symbolFile),p.set(21,c.Codicon.symbolReference),p.set(22,c.Codicon.symbolCustomColor),p.set(23,c.Codicon.symbolFolder),p.set(24,c.Codicon.symbolTypeParameter),p.set(25,c.Codicon.account),p.set(26,c.Codicon.issues);function D(V){let x=p.get(V);return x||(console.info("No codicon found for CompletionItemKind "+V),x=c.Codicon.symbolProperty),x}i.toIcon=D;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function N(V,x){let L=R.get(V);return typeof L>"u"&&!x&&(L=9),L}i.fromString=N})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(i){i[i.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(i){return i&&t.URI.isUri(i.uri)&&I.Range.isIRange(i.range)&&(I.Range.isIRange(i.originSelectionRange)||I.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=b;var m;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var d;(function(i){i[i.Deprecated=1]="Deprecated"})(d=e.SymbolTag||(e.SymbolTag={}));var v;(function(i){const p=new Map;p.set(0,c.Codicon.symbolFile),p.set(1,c.Codicon.symbolModule),p.set(2,c.Codicon.symbolNamespace),p.set(3,c.Codicon.symbolPackage),p.set(4,c.Codicon.symbolClass),p.set(5,c.Codicon.symbolMethod),p.set(6,c.Codicon.symbolProperty),p.set(7,c.Codicon.symbolField),p.set(8,c.Codicon.symbolConstructor),p.set(9,c.Codicon.symbolEnum),p.set(10,c.Codicon.symbolInterface),p.set(11,c.Codicon.symbolFunction),p.set(12,c.Codicon.symbolVariable),p.set(13,c.Codicon.symbolConstant),p.set(14,c.Codicon.symbolString),p.set(15,c.Codicon.symbolNumber),p.set(16,c.Codicon.symbolBoolean),p.set(17,c.Codicon.symbolArray),p.set(18,c.Codicon.symbolObject),p.set(19,c.Codicon.symbolKey),p.set(20,c.Codicon.symbolNull),p.set(21,c.Codicon.symbolEnumMember),p.set(22,c.Codicon.symbolStruct),p.set(23,c.Codicon.symbolEvent),p.set(24,c.Codicon.symbolOperator),p.set(25,c.Codicon.symbolTypeParameter);function D(R){let N=p.get(R);return N||(console.info("No codicon found for SymbolKind "+R),N=c.Codicon.symbolProperty),N}i.toIcon=D})(v=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(p){this.value=p}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(i){function p(D){return!D||typeof D!="object"?!1:typeof D.id=="string"&&typeof D.title=="string"}i.is=p})(o=e.Command||(e.Command={}));var l;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var u;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[164],ye([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(_e[119],ye([1,0,164,12,104,17,24,148]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=C;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class T{constructor(oe,Se,le,Pe){this.id=oe,this.name=Se,this.defaultValue=le,this.schema=Pe}applyUpdate(oe,Se){return _(oe,Se)}compute(oe,Se,le){return le}}class E{constructor(oe,Se){this.newValue=oe,this.didChange=Se}}e.ApplyUpdateResult=E;function _(se,oe){if(typeof se!="object"||typeof oe!="object"||!se||!oe)return new E(oe,se!==oe);if(Array.isArray(se)||Array.isArray(oe)){const le=Array.isArray(se)&&Array.isArray(oe)&&P.equals(se,oe);return new E(oe,!le)}let Se=!1;for(const le in oe)if(oe.hasOwnProperty(le)){const Pe=_(se[le],oe[le]);Pe.didChange&&(se[le]=Pe.newValue,Se=!0)}return new E(se,Se)}class w{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Se){return _(oe,Se)}validate(oe){return this.defaultValue}}class h{constructor(oe,Se,le,Pe){this.id=oe,this.name=Se,this.defaultValue=le,this.schema=Pe}applyUpdate(oe,Se){return _(oe,Se)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Se,le){return le}}function g(se,oe){return typeof se>"u"?oe:se==="false"?!1:Boolean(se)}e.boolean=g;class f extends h{constructor(oe,Se,le,Pe=void 0){typeof Pe<"u"&&(Pe.type="boolean",Pe.default=le),super(oe,Se,le,Pe)}validate(oe){return g(oe,this.defaultValue)}}function b(se,oe,Se,le){if(typeof se>"u")return oe;let Pe=parseInt(se,10);return isNaN(Pe)?oe:(Pe=Math.max(Se,Pe),Pe=Math.min(le,Pe),Pe|0)}e.clampedInt=b;class m extends h{static clampedInt(oe,Se,le,Pe){return b(oe,Se,le,Pe)}constructor(oe,Se,le,Pe,Le,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=le,Fe.minimum=Pe,Fe.maximum=Le),super(oe,Se,le,Fe),this.minimum=Pe,this.maximum=Le}validate(oe){return m.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class d extends h{static clamp(oe,Se,le){return oe<Se?Se:oe>le?le:oe}static float(oe,Se){if(typeof oe=="number")return oe;if(typeof oe>"u")return Se;const le=parseFloat(oe);return isNaN(le)?Se:le}constructor(oe,Se,le,Pe,Le){typeof Le<"u"&&(Le.type="number",Le.default=le),super(oe,Se,le,Le),this.validationFn=Pe}validate(oe){return this.validationFn(d.float(oe,this.defaultValue))}}class v extends h{static string(oe,Se){return typeof oe!="string"?Se:oe}constructor(oe,Se,le,Pe=void 0){typeof Pe<"u"&&(Pe.type="string",Pe.default=le),super(oe,Se,le,Pe)}validate(oe){return v.string(oe,this.defaultValue)}}function r(se,oe,Se){return typeof se!="string"||Se.indexOf(se)===-1?oe:se}e.stringSet=r;class o extends h{constructor(oe,Se,le,Pe,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.enum=Pe,Le.default=le),super(oe,Se,le,Le),this._allowedValues=Pe}validate(oe){return r(oe,this.defaultValue,this._allowedValues)}}class l extends T{constructor(oe,Se,le,Pe,Le,Fe,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Le,Ge.default=Pe),super(oe,Se,le,Ge),this._allowedValues=Le,this._convert=Fe}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function s(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Se,le){return le===0?oe.accessibilitySupport:le}}class u extends T{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:c.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function D(se){switch(se){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function R(se){switch(se){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class N extends w{constructor(){super(130)}compute(oe,Se,le){const Pe=["monaco-editor"];return Se.get(34)&&Pe.push(Se.get(34)),oe.extraEditorClassName&&Pe.push(oe.extraEditorClassName),Se.get(67)==="default"?Pe.push("mouse-default"):Se.get(67)==="copy"&&Pe.push("mouse-copy"),Se.get(101)&&Pe.push("showUnused"),Se.get(128)&&Pe.push("showDeprecated"),Pe.join(" ")}}class V extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(oe,Se,le){return le&&oe.emptySelectionClipboard}}class x extends T{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:c.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":r(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":r(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class L extends T{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?L.OFF:oe==="true"?L.ON:oe:Boolean(oe)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class U extends w{constructor(){super(45)}compute(oe,Se,le){return oe.fontInfo}}class F extends h{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(oe){const Se=d.float(oe,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Se,6,100)}compute(oe,Se,le){return oe.fontInfo.fontSize}}class B extends T{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(m.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class M extends T{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:le,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:le,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:le,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:le,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:le,description:c.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{multiple:r(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??r(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??r(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??r(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??r(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??r(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends T{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:c.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:m.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),above:g(Se.above,this.defaultValue.above)}}}var j;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class $ extends w{constructor(){super(133)}compute(oe,Se,le){return $.computeLayout(Se,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const Se=oe.height/oe.lineHeight,le=oe.scrollBeyondLastLine?Se-1:0,Pe=(oe.viewLineCount+le)/(oe.pixelRatio*oe.height),Le=Math.floor(oe.viewLineCount/Pe);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:le,desiredRatio:Pe,minimapLineCount:Le}}static _computeMinimapLayout(oe,Se){const le=oe.outerWidth,Pe=oe.outerHeight,Le=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Le*Pe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Pe};const Fe=Se.stableMinimapLayoutInput,Ge=Fe&&oe.outerHeight===Fe.outerHeight&&oe.lineHeight===Fe.lineHeight&&oe.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Fe.pixelRatio&&oe.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&oe.minimap.enabled===Fe.minimap.enabled&&oe.minimap.side===Fe.minimap.side&&oe.minimap.size===Fe.minimap.size&&oe.minimap.showSlider===Fe.minimap.showSlider&&oe.minimap.renderCharacters===Fe.minimap.renderCharacters&&oe.minimap.maxColumn===Fe.minimap.maxColumn&&oe.minimap.scale===Fe.minimap.scale&&oe.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&oe.isViewportWrapping===Fe.isViewportWrapping,Je=oe.lineHeight,it=oe.typicalHalfwidthCharacterWidth,vt=oe.scrollBeyondLastLine,rt=oe.minimap.renderCharacters;let Ze=Le>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const wt=oe.minimap.maxColumn,Et=oe.minimap.size,kt=oe.minimap.side,ft=oe.verticalScrollbarWidth,Tt=oe.viewLineCount,Rt=oe.remainingWidth,Lt=oe.isViewportWrapping,Qe=rt?2:3;let At=Math.floor(Le*Pe);const Mt=At/Le;let Wt=!1,pt=!1,It=Qe*Ze,Ct=Ze/Le,Ae=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:Ve,extraLinesBeyondLastLine:at,desiredRatio:mt,minimapLineCount:Ot}=$.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:vt,height:Pe,lineHeight:Je,pixelRatio:Le});if(Tt/Ot>1)Wt=!0,pt=!0,Ze=1,It=1,Ct=Ze/Le;else{let St=!1,ht=Ze+1;if(Et==="fit"){const Nt=Math.ceil((Tt+at)*It);Lt&&Ge&&Rt<=Se.stableFitRemainingWidth?(St=!0,ht=Se.stableFitMaxMinimapScale):St=Nt>At}if(Et==="fill"||St){Wt=!0;const Nt=Ze;It=Math.min(Je*Le,Math.max(1,Math.floor(1/mt))),Lt&&Ge&&Rt<=Se.stableFitRemainingWidth&&(ht=Se.stableFitMaxMinimapScale),Ze=Math.min(ht,Math.max(1,Math.floor(It/Qe))),Ze>Nt&&(Ae=Math.min(2,Ze/Nt)),Ct=Ze/Le/Ae,At=Math.ceil(Math.max(Ve,Tt+at)*It),Lt?(Se.stableMinimapLayoutInput=oe,Se.stableFitRemainingWidth=Rt,Se.stableFitMaxMinimapScale=Ze):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Me=Math.floor(wt*Ct),Ee=Math.min(Me,Math.max(0,Math.floor((Rt-ft-2)*Ct/(it+Ct)))+e.MINIMAP_GUTTER_WIDTH);let ee=Math.floor(Le*Ee);const Oe=ee/Le;ee=Math.floor(ee*Ae);const ze=rt?1:2,Ye=kt==="left"?0:le-Ee-ft;return{renderMinimap:ze,minimapLeft:Ye,minimapWidth:Ee,minimapHeightIsEditorHeight:Wt,minimapIsSampling:pt,minimapScale:Ze,minimapLineHeight:It,minimapCanvasInnerWidth:ee,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:Mt}}static computeLayout(oe,Se){const le=Se.outerWidth|0,Pe=Se.outerHeight|0,Le=Se.lineHeight|0,Fe=Se.lineNumbersDigitCount|0,Ge=Se.typicalHalfwidthCharacterWidth,Je=Se.maxDigitWidth,it=Se.pixelRatio,vt=Se.viewLineCount,rt=oe.get(125),Ze=rt==="inherit"?oe.get(124):rt,wt=Ze==="inherit"?oe.get(120):Ze,Et=oe.get(123),kt=Se.isDominatedByLongLines,ft=oe.get(51),Tt=oe.get(61).renderType!==0,Rt=oe.get(62),Lt=oe.get(95),Qe=oe.get(66),At=oe.get(93),Mt=At.verticalScrollbarSize,Wt=At.verticalHasArrows,pt=At.arrowSize,It=At.horizontalScrollbarSize,Ct=oe.get(59),Ae=oe.get(38),Me=oe.get(100)!=="never";let Ee;if(typeof Ct=="string"&&/^\d+(\.\d+)?ch$/.test(Ct)){const xt=parseFloat(Ct.substr(0,Ct.length-2));Ee=m.clampedInt(xt*Ge,0,0,1e3)}else Ee=m.clampedInt(Ct,0,0,1e3);Ae&&Me&&(Ee+=16);let ee=0;if(Tt){const xt=Math.max(Fe,Rt);ee=Math.round(xt*Je)}let Oe=0;ft&&(Oe=Le);let ze=0,Ye=ze+Oe,Ve=Ye+ee,at=Ve+Ee;const mt=le-Oe-ee-Ee;let Ot=!1,bt=!1,St=-1;Ze==="inherit"&&kt?(Ot=!0,bt=!0):wt==="on"||wt==="bounded"?bt=!0:wt==="wordWrapColumn"&&(St=Et);const ht=$._computeMinimapLayout({outerWidth:le,outerHeight:Pe,lineHeight:Le,typicalHalfwidthCharacterWidth:Ge,pixelRatio:it,scrollBeyondLastLine:Lt,minimap:Qe,verticalScrollbarWidth:Mt,viewLineCount:vt,remainingWidth:mt,isViewportWrapping:bt},Se.memory||new A);ht.renderMinimap!==0&&ht.minimapLeft===0&&(ze+=ht.minimapWidth,Ye+=ht.minimapWidth,Ve+=ht.minimapWidth,at+=ht.minimapWidth);const Nt=mt-ht.minimapWidth,Gt=Math.max(1,Math.floor((Nt-Mt-2)/Ge)),_t=Wt?pt:0;return bt&&(St=Math.max(1,Gt),wt==="bounded"&&(St=Math.min(St,Et))),{width:le,height:Pe,glyphMarginLeft:ze,glyphMarginWidth:Oe,lineNumbersLeft:Ye,lineNumbersWidth:ee,decorationsLeft:Ve,decorationsWidth:Ee,contentLeft:at,contentWidth:Nt,minimap:ht,viewportColumn:Gt,isWordWrapMinified:Ot,isViewportWrapping:bt,wrappingColumn:St,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:It,overviewRuler:{top:_t,width:Mt,height:Pe-2*_t,right:0}}}}e.EditorLayoutInfoComputer=$;class Q extends T{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(43,null),c.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(45,null)}})}validate(oe){return r(oe,"simple",["simple","advanced"])}compute(oe,Se,le){return Se.get(2)===2?"advanced":le}}class K extends T{constructor(){const oe={enabled:!0};super(58,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:c.localize(46,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}class ue extends T{constructor(){const oe={enabled:!1,maxLineCount:5};super(105,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:c.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:c.localize(48,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class re extends T{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:c.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(50,null),c.localize(51,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(52,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:c.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:c.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:c.localize(56,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:r(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(Se.fontFamily,this.defaultValue.fontFamily),padding:g(Se.padding,this.defaultValue.padding)}}}class de extends d{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>d.clamp(oe,0,150),{markdownDescription:c.localize(57,null)})}compute(oe,Se,le){return oe.fontInfo.lineHeight}}class Y extends T{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:c.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:c.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)],default:oe.size,description:c.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:c.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:c.localize(65,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:c.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:c.localize(68,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),autohide:g(Se.autohide,this.defaultValue.autohide),size:r(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Se.side,this.defaultValue.side,["right","left"]),showSlider:r(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Se.scale,1,1,3),maxColumn:m.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(se){return se==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class be extends T{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(70,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{top:m.clampedInt(Se.top,0,0,1e3),bottom:m.clampedInt(Se.bottom,0,0,1e3)}}}class Ce extends T{constructor(){const oe={enabled:!0,cycle:!1};super(77,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:c.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:c.localize(72,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class Re extends w{constructor(){super(131)}compute(oe,Se,le){return oe.pixelRatio}}class We extends T{constructor(){const oe={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)]}];super(80,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:oe.strings,description:c.localize(76,null)},comments:{anyOf:Se,default:oe.comments,description:c.localize(77,null)},other:{anyOf:Se,default:oe.other,description:c.localize(78,null)}},default:oe,markdownDescription:c.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const it=oe?"on":"off";return{comments:it,strings:it,other:it}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Se,comments:le,strings:Pe}=oe,Le=["on","inline","off"];let Fe,Ge,Je;return typeof Se=="boolean"?Fe=Se?"on":"off":Fe=r(Se,this.defaultValue.other,Le),typeof le=="boolean"?Ge=le?"on":"off":Ge=r(le,this.defaultValue.comments,Le),typeof Pe=="boolean"?Je=Pe?"on":"off":Je=r(Pe,this.defaultValue.strings,Le),{other:Fe,comments:Ge,strings:Je}}}var ne;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(ne=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ce extends T{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(80,null),c.localize(81,null),c.localize(82,null),c.localize(83,null)],default:"on",description:c.localize(84,null)})}validate(oe){let Se=this.defaultValue.renderType,le=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Se=4,le=oe):oe==="interval"?Se=3:oe==="relative"?Se=2:oe==="on"?Se=1:Se=0),{renderType:Se,renderFn:le}}}function fe(se){const oe=se.get(88);return oe==="editable"?se.get(82):oe!=="on"}e.filterValidationDecorations=fe;class J extends T{constructor(){const oe=[],Se={type:"number",description:c.localize(85,null)};super(92,"rulers",oe,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:c.localize(86,null),format:"color-hex"}}}]},default:oe,description:c.localize(87,null)})}validate(oe){if(Array.isArray(oe)){const Se=[];for(const le of oe)if(typeof le=="number")Se.push({column:m.clampedInt(le,0,0,1e4),color:null});else if(le&&typeof le=="object"){const Pe=le;Se.push({column:m.clampedInt(Pe.column,0,0,1e4),color:Pe.color})}return Se.sort((le,Pe)=>le.column-Pe.column),Se}return this.defaultValue}}function ie(se,oe){if(typeof se!="string")return oe;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class te extends T{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(88,null),c.localize(89,null),c.localize(90,null)],default:"auto",description:c.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:"auto",description:c.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:c.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:c.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:c.localize(98,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe,le=m.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Pe=m.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ie(Se.vertical,this.defaultValue.vertical),horizontal:ie(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:le,horizontalSliderSize:m.clampedInt(Se.horizontalSliderSize,le,0,1e3),verticalScrollbarSize:Pe,verticalSliderSize:m.clampedInt(Se.verticalSliderSize,Pe,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends T{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:c.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:c.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:c.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:c.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:c.localize(105,null)}})}applyUpdate(oe,Se){let le=!1;Se.allowedCharacters&&oe&&(y.equals(oe.allowedCharacters,Se.allowedCharacters)||(oe={...oe,allowedCharacters:Se.allowedCharacters},le=!0)),Se.allowedLocales&&oe&&(y.equals(oe.allowedLocales,Se.allowedLocales)||(oe={...oe,allowedLocales:Se.allowedLocales},le=!0));const Pe=super.applyUpdate(oe,Se);return le?new E(Pe.newValue,!0):Pe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{nonBasicASCII:ae(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,Se){if(typeof oe!="object"||!oe)return Se;const le={};for(const[Pe,Le]of Object.entries(oe))Le===!0&&(le[Pe]=!0);return le}}class W extends T{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:c.localize(106,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:r(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class q extends T{constructor(){const oe={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:c.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{enabled:g(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends T{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(109,null),c.localize(110,null),c.localize(111,null)],default:oe.bracketPairs,description:c.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(113,null),c.localize(114,null),c.localize(115,null)],default:oe.bracketPairsHorizontal,description:c.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:c.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:c.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:oe.highlightActiveIndentation,description:c.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{bracketPairs:ae(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:ae(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ae(se,oe,Se){const le=Se.indexOf(se);return le===-1?oe:Se[le]}class ve extends T{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(123,null),c.localize(124,null)],default:oe.insertMode,description:c.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:c.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:c.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:c.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:c.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:c.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:c.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:c.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:c.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Se=oe;return{insertMode:r(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:g(Se.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:r(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class Te extends T{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(166,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends w{constructor(){super(132)}compute(oe,Se,le){return Se.get(82)?!0:oe.tabFocusMode}}var ke;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class De extends T{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),c.localize(170,null)],description:c.localize(171,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Se,le){return Se.get(2)===2?0:le}}class xe extends w{constructor(){super(134)}compute(oe,Se,le){const Pe=Se.get(133);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Pe.isWordWrapMinified,isViewportWrapping:Pe.isViewportWrapping,wrappingColumn:Pe.wrappingColumn}}}class qe extends T{constructor(){const oe={enabled:!0};super(32,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:c.localize(172,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Xe:t.isLinux?st:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(se){return e.editorOptionsRegistry[se.id]=se,se}var dt;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.autoClosingBrackets=5]="autoClosingBrackets",se[se.autoClosingDelete=6]="autoClosingDelete",se[se.autoClosingOvertype=7]="autoClosingOvertype",se[se.autoClosingQuotes=8]="autoClosingQuotes",se[se.autoIndent=9]="autoIndent",se[se.automaticLayout=10]="automaticLayout",se[se.autoSurround=11]="autoSurround",se[se.bracketPairColorization=12]="bracketPairColorization",se[se.guides=13]="guides",se[se.codeLens=14]="codeLens",se[se.codeLensFontFamily=15]="codeLensFontFamily",se[se.codeLensFontSize=16]="codeLensFontSize",se[se.colorDecorators=17]="colorDecorators",se[se.columnSelection=18]="columnSelection",se[se.comments=19]="comments",se[se.contextmenu=20]="contextmenu",se[se.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",se[se.cursorBlinking=22]="cursorBlinking",se[se.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",se[se.cursorStyle=24]="cursorStyle",se[se.cursorSurroundingLines=25]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",se[se.cursorWidth=27]="cursorWidth",se[se.disableLayerHinting=28]="disableLayerHinting",se[se.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",se[se.domReadOnly=30]="domReadOnly",se[se.dragAndDrop=31]="dragAndDrop",se[se.dropIntoEditor=32]="dropIntoEditor",se[se.emptySelectionClipboard=33]="emptySelectionClipboard",se[se.extraEditorClassName=34]="extraEditorClassName",se[se.fastScrollSensitivity=35]="fastScrollSensitivity",se[se.find=36]="find",se[se.fixedOverflowWidgets=37]="fixedOverflowWidgets",se[se.folding=38]="folding",se[se.foldingStrategy=39]="foldingStrategy",se[se.foldingHighlight=40]="foldingHighlight",se[se.foldingImportsByDefault=41]="foldingImportsByDefault",se[se.foldingMaximumRegions=42]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=44]="fontFamily",se[se.fontInfo=45]="fontInfo",se[se.fontLigatures=46]="fontLigatures",se[se.fontSize=47]="fontSize",se[se.fontWeight=48]="fontWeight",se[se.formatOnPaste=49]="formatOnPaste",se[se.formatOnType=50]="formatOnType",se[se.glyphMargin=51]="glyphMargin",se[se.gotoLocation=52]="gotoLocation",se[se.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",se[se.hover=54]="hover",se[se.inDiffEditor=55]="inDiffEditor",se[se.inlineSuggest=56]="inlineSuggest",se[se.letterSpacing=57]="letterSpacing",se[se.lightbulb=58]="lightbulb",se[se.lineDecorationsWidth=59]="lineDecorationsWidth",se[se.lineHeight=60]="lineHeight",se[se.lineNumbers=61]="lineNumbers",se[se.lineNumbersMinChars=62]="lineNumbersMinChars",se[se.linkedEditing=63]="linkedEditing",se[se.links=64]="links",se[se.matchBrackets=65]="matchBrackets",se[se.minimap=66]="minimap",se[se.mouseStyle=67]="mouseStyle",se[se.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=69]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",se[se.multiCursorModifier=71]="multiCursorModifier",se[se.multiCursorPaste=72]="multiCursorPaste",se[se.occurrencesHighlight=73]="occurrencesHighlight",se[se.overviewRulerBorder=74]="overviewRulerBorder",se[se.overviewRulerLanes=75]="overviewRulerLanes",se[se.padding=76]="padding",se[se.parameterHints=77]="parameterHints",se[se.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",se[se.quickSuggestions=80]="quickSuggestions",se[se.quickSuggestionsDelay=81]="quickSuggestionsDelay",se[se.readOnly=82]="readOnly",se[se.renameOnType=83]="renameOnType",se[se.renderControlCharacters=84]="renderControlCharacters",se[se.renderFinalNewline=85]="renderFinalNewline",se[se.renderLineHighlight=86]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=88]="renderValidationDecorations",se[se.renderWhitespace=89]="renderWhitespace",se[se.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",se[se.roundedSelection=91]="roundedSelection",se[se.rulers=92]="rulers",se[se.scrollbar=93]="scrollbar",se[se.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=95]="scrollBeyondLastLine",se[se.scrollPredominantAxis=96]="scrollPredominantAxis",se[se.selectionClipboard=97]="selectionClipboard",se[se.selectionHighlight=98]="selectionHighlight",se[se.selectOnLineNumbers=99]="selectOnLineNumbers",se[se.showFoldingControls=100]="showFoldingControls",se[se.showUnused=101]="showUnused",se[se.snippetSuggestions=102]="snippetSuggestions",se[se.smartSelect=103]="smartSelect",se[se.smoothScrolling=104]="smoothScrolling",se[se.stickyScroll=105]="stickyScroll",se[se.stickyTabStops=106]="stickyTabStops",se[se.stopRenderingLineAfter=107]="stopRenderingLineAfter",se[se.suggest=108]="suggest",se[se.suggestFontSize=109]="suggestFontSize",se[se.suggestLineHeight=110]="suggestLineHeight",se[se.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",se[se.suggestSelection=112]="suggestSelection",se[se.tabCompletion=113]="tabCompletion",se[se.tabIndex=114]="tabIndex",se[se.unicodeHighlighting=115]="unicodeHighlighting",se[se.unusualLineTerminators=116]="unusualLineTerminators",se[se.useShadowDOM=117]="useShadowDOM",se[se.useTabStops=118]="useTabStops",se[se.wordSeparators=119]="wordSeparators",se[se.wordWrap=120]="wordWrap",se[se.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=123]="wordWrapColumn",se[se.wordWrapOverride1=124]="wordWrapOverride1",se[se.wordWrapOverride2=125]="wordWrapOverride2",se[se.wrappingIndent=126]="wrappingIndent",se[se.wrappingStrategy=127]="wrappingStrategy",se[se.showDeprecated=128]="showDeprecated",se[se.inlayHints=129]="inlayHints",se[se.editorClassName=130]="editorClassName",se[se.pixelRatio=131]="pixelRatio",se[se.tabFocusMode=132]="tabFocusMode",se[se.layoutInfo=133]="layoutInfo",se[se.wrappingInfo=134]="wrappingInfo"})(dt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(173,null)})),acceptSuggestionOnEnter:Be(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(174,null),""],markdownDescription:c.localize(175,null)})),accessibilitySupport:Be(new a),accessibilityPageSize:Be(new m(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(176,null),tags:["accessibility"]})),ariaLabel:Be(new v(4,"ariaLabel",c.localize(177,null))),autoClosingBrackets:Be(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(178,null),c.localize(179,null),""],description:c.localize(180,null)})),autoClosingDelete:Be(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(181,null),""],description:c.localize(182,null)})),autoClosingOvertype:Be(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(183,null),""],description:c.localize(184,null)})),autoClosingQuotes:Be(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(185,null),c.localize(186,null),""],description:c.localize(187,null)})),autoIndent:Be(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[c.localize(188,null),c.localize(189,null),c.localize(190,null),c.localize(191,null),c.localize(192,null)],description:c.localize(193,null)})),automaticLayout:Be(new f(10,"automaticLayout",!1)),autoSurround:Be(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(194,null),c.localize(195,null),c.localize(196,null),""],description:c.localize(197,null)})),bracketPairColorization:Be(new q),bracketPairGuides:Be(new X),stickyTabStops:Be(new f(106,"stickyTabStops",!1,{description:c.localize(198,null)})),codeLens:Be(new f(14,"codeLens",!0,{description:c.localize(199,null)})),codeLensFontFamily:Be(new v(15,"codeLensFontFamily","",{description:c.localize(200,null)})),codeLensFontSize:Be(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(201,null)})),colorDecorators:Be(new f(17,"colorDecorators",!0,{description:c.localize(202,null)})),columnSelection:Be(new f(18,"columnSelection",!1,{description:c.localize(203,null)})),comments:Be(new u),contextmenu:Be(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(204,null)})),cursorBlinking:Be(new l(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(205,null)})),cursorSmoothCaretAnimation:Be(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(206,null)})),cursorStyle:Be(new l(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(207,null)})),cursorSurroundingLines:Be(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(208,null)})),cursorSurroundingLinesStyle:Be(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(209,null),c.localize(210,null)],description:c.localize(211,null)})),cursorWidth:Be(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(212,null)})),disableLayerHinting:Be(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new f(30,"domReadOnly",!1)),dragAndDrop:Be(new f(31,"dragAndDrop",!0,{description:c.localize(213,null)})),emptySelectionClipboard:Be(new V),dropIntoEditor:Be(new qe),stickyScroll:Be(new ue),extraEditorClassName:Be(new v(34,"extraEditorClassName","")),fastScrollSensitivity:Be(new d(35,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:c.localize(214,null)})),find:Be(new x),fixedOverflowWidgets:Be(new f(37,"fixedOverflowWidgets",!1)),folding:Be(new f(38,"folding",!0,{description:c.localize(215,null)})),foldingStrategy:Be(new o(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),foldingHighlight:Be(new f(40,"foldingHighlight",!0,{description:c.localize(219,null)})),foldingImportsByDefault:Be(new f(41,"foldingImportsByDefault",!1,{description:c.localize(220,null)})),foldingMaximumRegions:Be(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(221,null)})),unfoldOnClickAfterEndOfLine:Be(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(222,null)})),fontFamily:Be(new v(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(223,null)})),fontInfo:Be(new U),fontLigatures2:Be(new L),fontSize:Be(new F),fontWeight:Be(new B),formatOnPaste:Be(new f(49,"formatOnPaste",!1,{description:c.localize(224,null)})),formatOnType:Be(new f(50,"formatOnType",!1,{description:c.localize(225,null)})),glyphMargin:Be(new f(51,"glyphMargin",!0,{description:c.localize(226,null)})),gotoLocation:Be(new M),hideCursorInOverviewRuler:Be(new f(53,"hideCursorInOverviewRuler",!1,{description:c.localize(227,null)})),hover:Be(new z),inDiffEditor:Be(new f(55,"inDiffEditor",!1)),letterSpacing:Be(new d(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>d.clamp(se,-5,20),{description:c.localize(228,null)})),lightbulb:Be(new K),lineDecorationsWidth:Be(new h(59,"lineDecorationsWidth",10)),lineHeight:Be(new de),lineNumbers:Be(new ce),lineNumbersMinChars:Be(new m(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new f(63,"linkedEditing",!1,{description:c.localize(229,null)})),links:Be(new f(64,"links",!0,{description:c.localize(230,null)})),matchBrackets:Be(new o(65,"matchBrackets","always",["always","near","never"],{description:c.localize(231,null)})),minimap:Be(new Y),mouseStyle:Be(new o(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new d(68,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:c.localize(232,null)})),mouseWheelZoom:Be(new f(69,"mouseWheelZoom",!1,{markdownDescription:c.localize(233,null)})),multiCursorMergeOverlapping:Be(new f(70,"multiCursorMergeOverlapping",!0,{description:c.localize(234,null)})),multiCursorModifier:Be(new l(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[c.localize(235,null),c.localize(236,null)],markdownDescription:c.localize(237,null)})),multiCursorPaste:Be(new o(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(238,null),c.localize(239,null)],markdownDescription:c.localize(240,null)})),occurrencesHighlight:Be(new f(73,"occurrencesHighlight",!0,{description:c.localize(241,null)})),overviewRulerBorder:Be(new f(74,"overviewRulerBorder",!0,{description:c.localize(242,null)})),overviewRulerLanes:Be(new m(75,"overviewRulerLanes",3,0,3)),padding:Be(new be),parameterHints:Be(new Ce),peekWidgetDefaultFocus:Be(new o(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(243,null),c.localize(244,null)],description:c.localize(245,null)})),definitionLinkOpensInPeek:Be(new f(79,"definitionLinkOpensInPeek",!1,{description:c.localize(246,null)})),quickSuggestions:Be(new We),quickSuggestionsDelay:Be(new m(81,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(247,null)})),readOnly:Be(new f(82,"readOnly",!1)),renameOnType:Be(new f(83,"renameOnType",!1,{description:c.localize(248,null),markdownDeprecationMessage:c.localize(249,null)})),renderControlCharacters:Be(new f(84,"renderControlCharacters",!0,{description:c.localize(250,null),restricted:!0})),renderFinalNewline:Be(new f(85,"renderFinalNewline",!0,{description:c.localize(251,null)})),renderLineHighlight:Be(new o(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(252,null)],description:c.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Be(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(254,null)})),renderValidationDecorations:Be(new o(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new o(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(255,null),c.localize(256,null),c.localize(257,null),""],description:c.localize(258,null)})),revealHorizontalRightPadding:Be(new m(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new f(91,"roundedSelection",!0,{description:c.localize(259,null)})),rulers:Be(new J),scrollbar:Be(new te),scrollBeyondLastColumn:Be(new m(94,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(260,null)})),scrollBeyondLastLine:Be(new f(95,"scrollBeyondLastLine",!0,{description:c.localize(261,null)})),scrollPredominantAxis:Be(new f(96,"scrollPredominantAxis",!0,{description:c.localize(262,null)})),selectionClipboard:Be(new f(97,"selectionClipboard",!0,{description:c.localize(263,null),included:t.isLinux})),selectionHighlight:Be(new f(98,"selectionHighlight",!0,{description:c.localize(264,null)})),selectOnLineNumbers:Be(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Be(new o(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),showUnused:Be(new f(101,"showUnused",!0,{description:c.localize(269,null)})),showDeprecated:Be(new f(128,"showDeprecated",!0,{description:c.localize(270,null)})),inlayHints:Be(new re),snippetSuggestions:Be(new o(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new f(104,"smoothScrolling",!1,{description:c.localize(276,null)})),stopRenderingLineAfter:Be(new m(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new ve),inlineSuggest:Be(new W),suggestFontSize:Be(new m(109,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new m(110,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new f(111,"suggestOnTriggerCharacters",!0,{description:c.localize(279,null)})),suggestSelection:Be(new o(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(280,null),c.localize(281,null),c.localize(282,null)],description:c.localize(283,null)})),tabCompletion:Be(new o(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(284,null),c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),tabIndex:Be(new m(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new O),unusualLineTerminators:Be(new o(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null)],description:c.localize(291,null)})),useShadowDOM:Be(new f(117,"useShadowDOM",!0)),useTabStops:Be(new f(118,"useTabStops",!0,{description:c.localize(292,null)})),wordSeparators:Be(new v(119,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:c.localize(293,null)})),wordWrap:Be(new o(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null),c.localize(296,null),c.localize(297,null)],description:c.localize(298,null)})),wordWrapBreakAfterCharacters:Be(new v(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new v(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new m(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(299,null)})),wordWrapOverride1:Be(new o(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new o(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new N),pixelRatio:Be(new Re),tabFocusMode:Be(new ge),layoutInfo:Be(new $),wrappingInfo:Be(new xe),wrappingIndent:Be(new De),wrappingStrategy:Be(new Q)}}),define(_e[165],ye([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[166],ye([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(_e[167],ye([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[168],ye([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(_e[169],ye([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(_e[170],ye([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(_e[171],ye([19,20]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(_e[172],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[173],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[174],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[175],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[176],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[177],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[178],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[179],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(_e[180],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(_e[181],ye([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(_e[182],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[183],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(_e[184],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(_e[185],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(_e[186],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(_e[187],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[188],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(_e[189],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(_e[190],ye([1,0,22,42,167,309]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||y.test(f)}e.isValidVersionStr=S;function C(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=f.match(y);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=C;function A(f){if(!f)return null;const b=f.majorBase,m=f.majorMustEqual,d=f.minorBase;let v=f.minorMustEqual;const r=f.patchBase;let o=f.patchMustEqual;f.hasCaret&&(b===0||(v=!1),o=!1);let l=0;if(f.preRelease){const s=k.exec(f.preRelease);if(s){const[,a,u,n]=s;l=Date.UTC(Number(a),Number(u)-1,Number(n))}}return{majorBase:b,majorMustEqual:m,minorBase:d,minorMustEqual:v,patchBase:r,patchMustEqual:o,isMinimum:f.hasGreaterEquals,notBefore:l}}e.normalizeVersion=A;function T(f,b,m){let d;typeof f=="string"?d=A(C(f)):d=f;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let r;if(typeof m=="string"?r=A(C(m)):r=m,!d||!r)return!1;const o=d.majorBase,l=d.minorBase,s=d.patchBase;let a=r.majorBase,u=r.minorBase,n=r.patchBase;const i=r.notBefore;let p=r.majorMustEqual,D=r.minorMustEqual,R=r.patchMustEqual;return r.isMinimum?o>a?!0:o<a?!1:l>u?!0:l<u||v&&v<i?!1:s>=n:(o===1&&a===0&&(!p||!D||!R)&&(a=1,u=0,n=0,p=!0,D=!1,R=!1),o<a?!1:o>a?!p:l<u?!1:l>u?!D:s<n?!1:s>n?!R:!(v&&v<i))}e.isValidVersion=T;function E(f,b,m,d,v){const r=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return r.push([t.default.Error,I.localize(0,null)]),r;if(typeof d.name!="string")return r.push([t.default.Error,I.localize(1,null,"name")]),r;if(typeof d.version!="string")return r.push([t.default.Error,I.localize(2,null,"version")]),r;if(!d.engines)return r.push([t.default.Error,I.localize(3,null,"engines")]),r;if(typeof d.engines.vscode!="string")return r.push([t.default.Error,I.localize(4,null,"engines.vscode")]),r;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return r.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),r;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return r.push([t.default.Error,I.localize(6,null,"activationEvents")]),r;if(typeof d.main>"u"&&typeof d.browser>"u")return r.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),r}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&r.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return r.push([t.default.Error,I.localize(9,null,"main")]),r;{const s=(0,c.joinPath)(m,d.main);(0,c.isEqualOrParent)(s,m)||r.push([t.default.Warning,I.localize(10,null,s.path,m.path)])}if(typeof d.activationEvents>"u")return r.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),r}if(typeof d.browser<"u"){if(typeof d.browser!="string")return r.push([t.default.Error,I.localize(12,null,"browser")]),r;{const s=(0,c.joinPath)(m,d.browser);(0,c.isEqualOrParent)(s,m)||r.push([t.default.Warning,I.localize(13,null,s.path,m.path)])}if(typeof d.activationEvents>"u")return r.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),r}if(!P.valid(d.version))return r.push([t.default.Error,I.localize(15,null)]),r;const o=[];if(!_(f,b,d,v,o))for(const s of o)r.push([t.default.Error,s]);return r}e.validateExtensionManifest=E;function _(f,b,m,d,v){return d||typeof m.main>"u"&&typeof m.browser>"u"?!0:h(f,b,m.engines.vscode,v)}e.isValidExtensionVersion=_;function w(f,b,m){return f==="*"||h(b,m,f)}e.isEngineValid=w;function h(f,b,m,d=[]){const v=A(C(m));if(!v)return d.push(I.localize(16,null,m)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return d.push(I.localize(17,null,m)),!1}else if(!v.majorMustEqual)return d.push(I.localize(18,null,m)),!1;return T(f,b,v)?!0:(d.push(I.localize(19,null,f,m)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let b=0,m=f.length;b<m;b++)if(typeof f[b]!="string")return!1;return!0}}),define(_e[120],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(I,P=[],y=!1){this.ctor=I,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=c}),define(_e[85],ye([1,0,120]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function P(k,S,C){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(C))),t.push([k,S])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(_e[191],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const k=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(y);k.outgoing.set(S.key,S),S.incoming.set(k.key,k)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let k=this._nodes.get(y);return k||(k=new c(y,P),this._nodes.set(y,k)),k}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,k]of this._nodes)P.push(`${y}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const k=new Set([P]),S=this._findCycle(y,k);if(S)return S}}_findCycle(P,y){for(const[k,S]of P.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const C=this._findCycle(S,y);if(C)return C;y.delete(k)}}}e.Graph=t}),define(_e[3],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=k})(c=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(y,k,S){k[c.DI_TARGET]===k?k[c.DI_DEPENDENCIES].push({id:y,index:S}):(k[c.DI_DEPENDENCIES]=[{id:y,index:S}],k[c.DI_TARGET]=k)}function I(y){if(c.serviceIds.has(y))return c.serviceIds.get(y);const k=function(S,C,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,S,A)};return k.toString=()=>y,c.serviceIds.set(y,k),k}e.createDecorator=I;function P(y){return y}e.refineServiceDecorator=P}),define(_e[52],ye([1,0,11,2,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(f,b){const m=Object.create(null);for(const d in f)A(m,d,f[d],b);return m}e.toValuesTree=C;function A(f,b,m,d){const v=b.split("."),r=v.pop();let o=f;for(let l=0;l<v.length;l++){const s=v[l];let a=o[s];switch(typeof a){case"undefined":a=o[s]=Object.create(null);break;case"object":break;default:d(`Ignoring ${b} as ${v.slice(0,l+1).join(".")} is ${JSON.stringify(a)}`);return}o=a}if(typeof o=="object"&&o!==null)try{o[r]=m}catch{d(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=A;function T(f,b){const m=b.split(".");E(f,m)}e.removeFromValueTree=T;function E(f,b){const m=b.shift();if(b.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const d=f[m];typeof d=="object"&&!Array.isArray(d)&&(E(d,b),Object.keys(d).length===0&&delete f[m])}}function _(f,b,m){function d(o,l){let s=o;for(const a of l){if(typeof s!="object"||s===null)return;s=s[a]}return s}const v=b.split("."),r=d(f,v);return typeof r>"u"?m:r}e.getConfigurationValue=_;function w(f,b,m){Object.keys(b).forEach(d=>{d!=="__proto__"&&(d in f?c.isObject(f[d])&&c.isObject(b[d])?w(f[d],b[d],m):m&&(f[d]=b[d]):f[d]=b[d])})}e.merge=w;function h(f,b,m){const d=f.inspect(b),v=f.inspect(m);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:d.defaultValue}e.getMigratedSettingValue=h;function g(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(_e[53],ye([1,0,12,8,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",c.isMacintosh),P.set("isLinux",c.isLinux),P.set("isWindows",c.isWindows),P.set("isWeb",c.isWeb),P.set("isMacNative",c.isMacintosh&&!c.isWeb),P.set("isEdge",c.isEdge),P.set("isFirefox",c.isFirefox),P.set("isChrome",c.isChrome),P.set("isSafari",c.isSafari);const y=Object.prototype.hasOwnProperty;var k;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return T.INSTANCE}static true(){return E.INSTANCE}static has(L){return _.create(L)}static equals(L,U){return w.create(L,U)}static notEquals(L,U){return f.create(L,U)}static regex(L,U){return l.create(L,U)}static in(L,U){return h.create(L,U)}static notIn(L,U){return g.create(L,U)}static not(L){return b.create(L)}static and(...L){return u.create(L,null,!0)}static or(...L){return n.create(L,null,!0)}static greater(L,U){return d.create(L,U)}static greaterEquals(L,U){return v.create(L,U)}static smaller(L,U){return r.create(L,U)}static smallerEquals(L,U){return o.create(L,U)}static deserialize(L,U=!1){if(!!L)return this._deserializeOrExpression(L,U)}static _deserializeOrExpression(L,U){const F=L.split("||");return n.create(F.map(B=>this._deserializeAndExpression(B,U)),null,!0)}static _deserializeAndExpression(L,U){const F=L.split("&&");return u.create(F.map(B=>this._deserializeOne(B,U)),null,!0)}static _deserializeOne(L,U){if(L=L.trim(),L.indexOf("!=")>=0){const F=L.split("!=");return f.create(F[0].trim(),this._deserializeValue(F[1],U))}if(L.indexOf("==")>=0){const F=L.split("==");return w.create(F[0].trim(),this._deserializeValue(F[1],U))}if(L.indexOf("=~")>=0){const F=L.split("=~");return l.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(L.indexOf(" not in ")>=0){const F=L.split(" not in ");return g.create(F[0].trim(),this._deserializeValue(F[1],U))}if(L.indexOf(" in ")>=0){const F=L.split(" in ");return h.create(F[0].trim(),this._deserializeValue(F[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const F=L.split(">=");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const F=L.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const F=L.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const F=L.split("<");return r.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(L)?b.create(L.substr(1).trim()):_.create(L)}static _deserializeValue(L,U){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const F=/^'([^']*)'$/.exec(L);return F?F[1].trim():L}static _deserializeRegexValue(L,U){if((0,t.isFalsyOrWhitespace)(L)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=L.indexOf("/"),B=L.lastIndexOf("/");if(F===B||F<0){if(U)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const M=L.slice(F+1,B),z=L[B+1]==="i"?"i":"";try{return new RegExp(M,z)}catch(j){if(U)throw new Error(`bad regexp-value '${L}', parse error: ${j}`);return console.warn(`bad regexp-value '${L}', parse error: ${j}`),null}}}e.ContextKeyExpr=S;function C(x,L){const U=x?x.substituteConstants():void 0,F=L?L.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function A(x,L){return x.cmp(L)}class T{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class _{static create(L,U=null){const F=P.get(L);return typeof F=="boolean"?F?E.INSTANCE:T.INSTANCE:new _(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:T.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class w{static create(L,U,F=null){if(typeof U=="boolean")return U?_.create(L,F):b.create(L,F);const B=P.get(L);return typeof B=="boolean"?U===(B?"true":"false")?E.INSTANCE:T.INSTANCE:new w(L,U,F)}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?E.INSTANCE:T.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class h{static create(L,U){return new h(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.valueKey),F=L.getValue(this.key);return Array.isArray(U)?U.includes(F):typeof F=="string"&&typeof U=="object"&&U!==null?y.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class g{static create(L,U){return new g(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=11,this._negated=h.create(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class f{static create(L,U,F=null){if(typeof U=="boolean")return U?b.create(L,F):_.create(L,F);const B=P.get(L);return typeof B=="boolean"?U===(B?"true":"false")?T.INSTANCE:E.INSTANCE:new f(L,U,F)}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=P.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?T.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class b{static create(L,U=null){const F=P.get(L);return typeof F=="boolean"?F?T.INSTANCE:E.INSTANCE:new b(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:p(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=P.get(this.key);return typeof L=="boolean"?L?T.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function m(x,L){if(typeof x=="string"){const U=parseFloat(x);isNaN(U)||(x=U)}return typeof x=="string"||typeof x=="number"?L(x):T.INSTANCE}class d{static create(L,U,F=null){return m(U,B=>new d(L,B,F))}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class v{static create(L,U,F=null){return m(U,B=>new v(L,B,F))}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class r{static create(L,U,F=null){return m(U,B=>new r(L,B,F))}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class o{static create(L,U,F=null){return m(U,B=>new o(L,B,F))}constructor(L,U,F){this.key=L,this.value=U,this.negated=F,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class l{static create(L,U){return new l(L,U)}constructor(L,U){this.key=L,this.regexp=U,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const U=this.regexp?this.regexp.source:"",F=L.regexp?L.regexp.source:"";return U<F?-1:U>F?1:0}equals(L){if(L.type===this.type){const U=this.regexp?this.regexp.source:"",F=L.regexp?L.regexp.source:"";return this.key===L.key&&U===F}return!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=l;class s{static create(L){return new s(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new s(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function a(x){let L=null;for(let U=0,F=x.length;U<F;U++){const B=x[U].substituteConstants();if(x[U]!==B&&L===null){L=[];for(let M=0;M<U;M++)L[M]=x[M]}L!==null&&(L[U]=B)}return L===null?x:L}class u{static create(L,U,F){return u._normalizeArr(L,U,F)}constructor(L,U){this.expr=L,this.negated=U,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const B=A(this.expr[U],L.expr[U]);if(B!==0)return B}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:u.create(L,this.negated,!1)}evaluate(L){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(L))return!1;return!0}static _normalizeArr(L,U,F){const B=[];let M=!1;for(const z of L)if(!!z){if(z.type===1){M=!0;continue}if(z.type===0)return T.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&M)return E.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(A);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const j=B.pop(),$=B.length===0,Q=n.create(z.expr.map(K=>u.create([K,j],null,F)),null,$);Q&&(B.push(Q),B.sort(A))}if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let j=z+1;j<B.length;j++)if(B[z].negate().equals(B[j]))return T.INSTANCE;if(B.length===1)return B[0]}return new u(B,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new u(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());this.negated=n.create(L,this,!0)}return this.negated}}class n{static create(L,U,F){return n._normalizeArr(L,U,F)}constructor(L,U){this.expr=L,this.negated=U,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const B=A(this.expr[U],L.expr[U]);if(B!==0)return B}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:n.create(L,this.negated,!1)}evaluate(L){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(L))return!0;return!1}static _normalizeArr(L,U,F){let B=[],M=!1;if(L){for(let z=0,j=L.length;z<j;z++){const $=L[z];if(!!$){if($.type===0){M=!0;continue}if($.type===1)return E.INSTANCE;if($.type===9){B=B.concat($.expr);continue}B.push($)}}if(B.length===0&&M)return T.INSTANCE;B.sort(A)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(F){for(let z=0;z<B.length;z++)for(let j=z+1;j<B.length;j++)if(B[z].negate().equals(B[j]))return E.INSTANCE;if(B.length===1)return B[0]}return new n(B,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new n(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());for(;L.length>1;){const U=L.shift(),F=L.shift(),B=[];for(const M of V(U))for(const z of V(F))B.push(u.create([M,z],null,!1));L.unshift(n.create(B,null,!1))}this.negated=n.create(L,this,!0)}return this.negated}}class i extends _{static all(){return i._info.values()}constructor(L,U,F){super(L,null),this._defaultValue=U,typeof F=="object"?i._info.push({...F,key:L}):F!==!0&&i._info.push({key:L,description:F,type:U!=null?typeof U:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return w.create(this.key,L)}notEqualsTo(L){return f.create(this.key,L)}}e.RawContextKey=i,i._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(x,L){return x<L?-1:x>L?1:0}function D(x,L,U,F){return x<U?-1:x>U?1:L<F?-1:L>F?1:0}function R(x,L){if(x.type===0||L.type===1)return!0;if(x.type===9)return L.type===9?N(x.expr,L.expr):!1;if(L.type===9){for(const U of L.expr)if(R(x,U))return!0;return!1}if(x.type===6){if(L.type===6)return N(L.expr,x.expr);for(const U of x.expr)if(R(U,L))return!0;return!1}return x.equals(L)}e.implies=R;function N(x,L){let U=0,F=0;for(;U<x.length&&F<L.length;){const B=x[U].cmp(L[F]);if(B<0)return!1;B===0&&U++,F++}return U===x.length}function V(x){return x.type===9?x.expr:[x]}}),define(_e[192],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[121],ye([1,0,166,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(f,b){switch(f){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function k(f,b){return b==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function S(f,b,m){return k(b,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:C(m).includes(f)}e.isTargetPlatformCompatible=S;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A;var T;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var _;(function(f){f.Install="install",f.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var h;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(b,m){super(b),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(_e[193],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(_e[194],ye([1,0,44,14,9,12,106,29,114,168,193]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=C.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends E{openTerminal(d,v){return this.spawnTerminal(c,d,S.getWindowsShell(),v)}spawnTerminal(d,v,r,o){const l=v.windowsExec||_.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const s=I.basename(l).toLowerCase();if(s==="cmder"||s==="cmder.exe")return d.spawn(l,o?[o]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return l.indexOf(" ")>=0&&a.push('""'),a.push(l),(s==="wt"||s==="wt.exe")&&a.push("-d ."),new Promise((u,n)=>{const i=g(process),p=d.spawn(r,a,{cwd:o,env:i});p.on("error",n),p.on("exit",()=>u())})}runInTerminal(d,v,r,o,l){const s="windowsExec"in l&&l.windowsExec?l.windowsExec:_.getDefaultTerminalWindows();return new Promise((a,u)=>{const n=`"${v} - ${T}"`,i=`""${r.join('" "')}" & pause"`,p=["/c","start",n,"/wait",s,"/c",i],D=Object.assign({},g(process),o);Object.keys(D).filter(V=>D[V]===null).forEach(V=>delete D[V]);const R={cwd:v,env:D,windowsVerbatimArguments:!0};c.spawn(_.CMD,p,R).on("error",V=>{u(f(V))}),a(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_,_.CMD="cmd.exe";class w extends E{openTerminal(d,v){return this.spawnTerminal(c,d,v)}runInTerminal(d,v,r,o,l){const s=l.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((a,u)=>{if(s===A.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const n=s===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",d||T,"-w",v];for(const N of r)p.push("-a"),p.push(N);if(o){const N=Object.assign({},g(process),o);for(const V in N){const x=N[V];x===null?(p.push("-u"),p.push(V)):(p.push("-e"),p.push(`${V}=${x}`))}}let D="";const R=c.spawn(w.OSASCRIPT,p);R.on("error",N=>{u(f(N))}),R.stderr.on("data",N=>{D+=N.toString()}),R.on("exit",N=>{if(N===0)a(void 0);else if(D){const V=D.split(`
`,1);u(new Error(V[0]))}else u(new Error(C.localize(1,null,n,N)))})}else u(new Error(C.localize(2,null,s)))})}spawnTerminal(d,v,r){const o=v.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((l,s)=>{const a=["-a",o];r&&a.push(r);const u=g(process),n=d.spawn("/usr/bin/open",a,{cwd:r,env:u});n.on("error",s),n.on("exit",()=>l())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class h extends E{openTerminal(d,v){return this.spawnTerminal(c,d,v)}runInTerminal(d,v,r,o,l){const s=l.linuxExec?Promise.resolve(l.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((a,u)=>{const n=[];s.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${b(r)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;n.push(`''${p}''`);const D=Object.assign({},g(process),o);Object.keys(D).filter(x=>D[x]===null).forEach(x=>delete D[x]);const R={cwd:v,env:D};let N="";const V=c.spawn(i,n,R);V.on("error",x=>{u(f(x))}),V.stderr.on("data",x=>{N+=x.toString()}),V.on("exit",x=>{if(x===0)a(void 0);else if(N){const L=N.split(`
`,1);u(new Error(L[0]))}else u(new Error(C.localize(4,null,i,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const d=await k.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{d?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,v,r){const o=v.linuxExec?Promise.resolve(v.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((l,s)=>{o.then(a=>{const u=g(process),n=d.spawn(a,[],{cwd:r,env:u});n.on("error",s),n.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=C.localize(3,null);function g(m){const d={...m.env};return(0,y.sanitizeProcessEnvironment)(d),d}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(C.localize(5,null,m.path)):m}function b(m){let d="";for(const v of m)v.indexOf(" ")>=0?d+='"'+v+'"':d+=v,d+=" ";return d}}),define(_e[38],ye([1,0,64,9,8,11,2,169,3]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var A;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var T;(function(M){M[M.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var E;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=_;function w(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=w;function h(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=h;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;function b(M){return _(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var m;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(z,j){super(z),this.code=j}}e.FileSystemProviderError=d;function v(M,z){const j=new d(M.toString(),z);return o(j,z),j}e.createFileSystemProviderError=v;function r(M){return M||v((0,k.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=r;function o(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=o;function l(M){if(!M)return m.Unknown;if(M instanceof d)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return m.Unknown;switch(z[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=l;function s(M){if(M instanceof D)return M.fileOperationResult;switch(l(M)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class u{constructor(z,j,$){this.resource=z,this.operation=j,this.target=$}isOperation(z){return this.operation===z}}e.FileOperationEvent=u;var n;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(z,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const $=new Map;for(const Q of z){const K=$.get(Q.type);switch(K?K.push([Q.resource,Q]):$.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of $)switch(Q){case 1:this.added=c.TernarySearchTree.forUris(()=>j),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>j),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>j),this.deleted.fill(K);break}}contains(z,...j){return this.doContains(z,{includeChildren:!1},...j)}affects(z,...j){return this.doContains(z,{includeChildren:!0},...j)}doContains(z,j,...$){if(!z)return!1;const Q=$.length>0;return!!((!Q||$.includes(1))&&(this.added?.get(z)||j.includeChildren&&this.added?.findSuperstr(z))||(!Q||$.includes(0))&&(this.updated?.get(z)||j.includeChildren&&this.updated?.findSuperstr(z))||(!Q||$.includes(2))&&(this.deleted?.findSubstr(z)||j.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=i;function p(M,z,j){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==t.sep&&(z+=t.sep),j?(0,I.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=p;class D extends Error{constructor(z,j,$){super(z),this.fileOperationResult=j,this.options=$}}e.FileOperationError=D;class R extends D{constructor(z,j,$){super(z,2,$),this.stat=j}}e.NotModifiedSinceFileOperationError=R;var N;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=x;async function L(M,z){if(!z.hasProvider(y.URI.from({scheme:M.scheme})))return new Promise(j=>{const $=z.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===M.scheme&&Q.added&&($.dispose(),j())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(z){return(0,P.isNumber)(z)||(z=0),z<U.KB?(0,k.localize)(1,null,z.toFixed(0)):z<U.MB?(0,k.localize)(2,null,(z/U.KB).toFixed(2)):z<U.GB?(0,k.localize)(3,null,(z/U.MB).toFixed(2)):z<U.TB?(0,k.localize)(4,null,(z/U.GB).toFixed(2)):(0,k.localize)(5,null,(z/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*U.MB:16*U.GB,maxHeapSize:M===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=B}),define(_e[86],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...I){this._entries=new Map;for(const[P,y]of I)this.set(P,y)}set(I,P){const y=this._entries.get(I);return this._entries.set(I,P),y}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=c}),define(_e[195],ye([1,0,18,10,6,120,191,3,86,63]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class T extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,f=!1,b,m=A){this._services=g,this._strict=f,this._parent=b,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(k.IInstantiationService,this),this._globalGraph=m?b?._globalGraph??new y.Graph(d=>d):void 0}createChild(g){return new E(g,this._strict,this,this._enableTracing)}invokeFunction(g,...f){const b=w.traceInvocation(this._enableTracing,g);let m=!1;try{return g({get:v=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(v,b);if(!r)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...f)}finally{m=!0,b.stop()}}createInstance(g,...f){let b,m;return g instanceof P.SyncDescriptor?(b=w.traceCreation(this._enableTracing,g.ctor),m=this._createInstance(g.ctor,g.staticArguments.concat(f),b)):(b=w.traceCreation(this._enableTracing,g),m=this._createInstance(g,f,b)),b.stop(),m}_createInstance(g,f=[],b){const m=k._util.getServiceDependencies(g).sort((r,o)=>r.index-o.index),d=[];for(const r of m){const o=this._getOrCreateServiceInstance(r.id,b);o||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${r.id}.`,!1),d.push(o)}const v=m.length>0?m[0].index:f.length;if(f.length!==v){console.trace(`[createInstance] First service dependency of ${g.name} at position ${v+1} conflicts with ${f.length} static arguments`);const r=v-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,v)}return Reflect.construct(g,f.concat(d))}_setServiceInstance(g,f){if(this._services.get(g)instanceof P.SyncDescriptor)this._services.set(g,f);else if(this._parent)this._parent._setServiceInstance(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const f=this._services.get(g);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):f}_getOrCreateServiceInstance(g,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const b=this._getServiceInstanceOrDescriptor(g);return b instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,b,f.branch(g,!0)):(f.branch(g,!1),b)}_safeCreateAndCacheServiceInstance(g,f,b){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,f,b)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,f,b){const m=new y.Graph(r=>r.id.toString());let d=0;const v=[{id:g,desc:f,_trace:b}];for(;v.length;){const r=v.pop();if(m.lookupOrInsertNode(r),d++>1e3)throw new T(m);for(const o of k._util.getServiceDependencies(r.desc.ctor)){const l=this._getServiceInstanceOrDescriptor(o.id);if(l||this._throwIfStrict(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(o.id)),l instanceof P.SyncDescriptor){const s={id:o.id,desc:l,_trace:r._trace.branch(o.id,!0)};m.insertEdge(r,s),v.push(s)}}}for(;;){const r=m.roots();if(r.length===0){if(!m.isEmpty())throw new T(m);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof P.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}m.removeNode(o)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,f,b=[],m,d){if(this._services.get(g)instanceof P.SyncDescriptor)return this._createServiceInstance(g,f,b,m,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,f,b,m,d);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(g,f,b=[],m,d){if(m){const v=new E(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(g);const r=new Map,o=new c.IdleValue(()=>{const l=v._createInstance(f,b,d);for(const[s,a]of r){const u=l[s];if(typeof u=="function")for(const n of a)u.apply(l,n)}return r.clear(),l});return new Proxy(Object.create(null),{get(l,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let n=r.get(s);return n||(n=new C.LinkedList,r.set(s,n)),(p,D,R)=>{const N=n.push([p,D,R]);return(0,I.toDisposable)(N)}}if(s in l)return l[s];const a=o.value;let u=a[s];return typeof u!="function"||(u=u.bind(a),l[s]=u),u},set(l,s,a){return o.value[s]=a,!0}})}else return this._createInstance(f,b,d)}_throwIfStrict(g,f){if(f&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=E;var _;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(_||(_={}));class w{static traceInvocation(g,f){return g?new w(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(g,f){return g?new w(0,f.name):w._None}constructor(g,f){this.type=g,this.name=f,this._start=Date.now(),this._dep=[]}branch(g,f){const b=new w(2,g.toString());return this._dep.push([g,f,b]),b}stop(){const g=Date.now()-this._start;w._totals+=g;let f=!1;function b(d,v){const r=[],o=new Array(d+1).join("	");for(const[l,s,a]of v._dep)if(s&&a){f=!0,r.push(`${o}CREATES -> ${l}`);const u=b(d+1,a);u&&r.push(u)}else r.push(`${o}uses -> ${l}`);return r.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(g>2||f)&&w.all.add(m.join(`
`))}}e.Trace=w,w.all=new Set,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(_e[13],ye([1,0,50,4,6,28,12,2,3]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var A;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function T(u,n,i){switch(n){case A.Trace:u.trace(i);break;case A.Debug:u.debug(i);break;case A.Info:u.info(i);break;case A.Warning:u.warn(i);break;case A.Error:u.error(i);break;default:throw new Error("Invalid log level")}}e.log=T;function E(u){let n="";for(let i=0;i<u.length;i++){let p=u[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(i>0?" ":"")+p}return n}e.format=E;class _ extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class w extends _{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(A.Trace)&&this.log(A.Trace,E([n,...i]))}debug(n,...i){this.checkLogLevel(A.Debug)&&this.log(A.Debug,E([n,...i]))}info(n,...i){this.checkLogLevel(A.Info)&&this.log(A.Info,E([n,...i]))}warn(n,...i){this.checkLogLevel(A.Warning)&&this.log(A.Warning,E([n,...i]))}error(n,...i){if(this.checkLogLevel(A.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.log(A.Error,E(p))}else this.log(A.Error,E([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class h extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!y.isWindows}trace(n,...i){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}debug(n,...i){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}info(n,...i){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}warn(n,...i){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...i):console.warn(`[main ${C()}]`,n,...i))}error(n,...i){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...i):console.error(`[main ${C()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends _{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class b extends _{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const p of this.logServices)p.trace(n,...i)}debug(n,...i){for(const p of this.logServices)p.debug(n,...i)}info(n,...i){for(const p of this.logServices)p.info(n,...i)}warn(n,...i){for(const p of this.logServices)p.warn(n,...i)}error(n,...i){for(const p of this.logServices)p.error(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=b;class m extends I.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}flush(){this.logger.flush()}}e.LogService=m;class d extends I.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(i(p=>this.setLevel(p)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,i,p){let D=this.loggerItems.get(n)?.logger;return D||(p=i?.always?A.Trace:p,D=this.doCreateLogger(n,p??this.logLevel,i),this.loggerItems.set(n,{logger:D,logLevel:p})),D}setLevel(n,i){const p=k.URI.isUri(n)?n:void 0,D=p?i:n;if(p){const R=this.loggerItems.get(p);R&&R.logLevel!==D&&(R.logLevel=D,R.logger.setLevel(D))}else this.logLevel=D,this.loggerItems.forEach(({logLevel:R,logger:N})=>{R===void 0&&N.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=d;class v{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=v;class r extends v{}e.NullLogService=r;class o extends d{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,i,p){return new v}}e.NullLoggerService=o;function l(u){if(u.verbose)return A.Trace;if(typeof u.logLevel=="string"){const n=a(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function s(u){switch(u){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Off:return"off"}}e.LogLevelToString=s;function a(u){switch(u){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Error;case"off":return A.Off}}e.parseLogLevel=a}),define(_e[196],ye([1,0,38,13]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(I||(I={}));async function P(C,A,T,E,_){try{const w=await new Promise((g,f)=>{Z(["spdlog"],g,f)});w.setFlushOn(t.LogLevel.Trace);const h=await w.createAsyncRotatingLogger(C,A,T,E);return _?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(w){console.error(w)}return null}function y(C,A,T){switch(A){case t.LogLevel.Trace:C.trace(T);break;case t.LogLevel.Debug:C.debug(T);break;case t.LogLevel.Info:C.info(T);break;case t.LogLevel.Warning:C.warn(T);break;case t.LogLevel.Error:C.error(T);break;default:throw new Error("Invalid log level")}}function k(C,A){switch(A){case t.LogLevel.Trace:C.setLevel(I.Trace);break;case t.LogLevel.Debug:C.setLevel(I.Debug);break;case t.LogLevel.Info:C.setLevel(I.Info);break;case t.LogLevel.Warning:C.setLevel(I.Warning);break;case t.LogLevel.Error:C.setLevel(I.Error);break;case t.LogLevel.Off:C.setLevel(I.Off);break;default:throw new Error("Invalid log level")}}class S extends t.AbstractMessageLogger{constructor(A,T,E,_,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(A,T,E,_),this._register(this.onDidChangeLogLevel(h=>{this._logger&&k(this._logger,h)}))}async _createSpdLogLogger(A,T,E,_){const w=E?6:1,h=30/w*c.ByteSize.MB,g=await P(A,T,h,w,_);if(g){this._logger=g,k(this._logger,this.getLevel());for(const{level:f,message:b}of this.buffer)y(this._logger,f,b);this.buffer=[]}}log(A,T){this._logger?y(this._logger,A,T):this.getLevel()<=A&&this.buffer.push({level:A,message:T})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(_e[122],ye([1,0,42,170,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(w,h){return h-w}S.compare=C;const A=Object.create(null);A[S.Error]=(0,t.localize)(0,null),A[S.Warning]=(0,t.localize)(1,null),A[S.Info]=(0,t.localize)(2,null);function T(w){return A[w]||""}S.toString=T;function E(w){switch(w){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function _(w){switch(w){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=_}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const C="";function A(E){return T(E,!0)}S.makeKey=A;function T(E,_){const w=[C];return E.source?w.push(E.source.replace("\xA6","\\\xA6")):w.push(C),E.code?typeof E.code=="string"?w.push(E.code.replace("\xA6","\\\xA6")):w.push(E.code.value.replace("\xA6","\\\xA6")):w.push(C),E.severity!==void 0&&E.severity!==null?w.push(y.toString(E.severity)):w.push(C),E.message&&_?w.push(E.message.replace("\xA6","\\\xA6")):w.push(C),E.startLineNumber!==void 0&&E.startLineNumber!==null?w.push(E.startLineNumber.toString()):w.push(C),E.startColumn!==void 0&&E.startColumn!==null?w.push(E.startColumn.toString()):w.push(C),E.endLineNumber!==void 0&&E.endLineNumber!==null?w.push(E.endLineNumber.toString()):w.push(C),E.endColumn!==void 0&&E.endColumn!==null?w.push(E.endColumn.toString()):w.push(C),w.push(C),w.join("\xA6")}S.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(_e[197],ye([1,0,4,42,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(_e[123],ye([1,0,8,2,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function P(C,A){return t.URI.isUri(C)?(0,c.equalsIgnoreCase)(C.scheme,A):(0,c.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=P;function y(C,...A){return A.some(T=>P(C,T))}e.matchesSomeScheme=y;function k(C,A){return C.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.withSelection=k;function S(C){let A;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return T&&(A={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},C=C.with({fragment:""})),{selection:A,uri:C}}e.extractSelection=S}),define(_e[198],ye([1,0,14,12,36,22]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const k=t.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const k=(0,P.dirname)(c.FileAccess.asFileUri(""));if(y=Z.__$__nodeRequire((0,P.joinPath)(k,"product.json").fsPath),I.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const S=Z.__$__nodeRequire((0,P.joinPath)(k,"package.json").fsPath);Object.assign(y,{version:S.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(_e[199],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(Z,e){return function(c,t){e(c,t,Z)}};define(_e[124],ye([1,0,18,21,6,3]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{get value(){return this._value}constructor(T){this.callback=T}report(T){this._value=T,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(T,E){super(),this.deferred=new c.DeferredPromise,E.withProgress(T,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};S=je([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends I.Disposable{constructor(T){super(),this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(T){this.stop();const E=++this.currentOperationId,_=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:_.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(_e[43],ye([1,0,48,11]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(y,k){c.ok(t.isString(y)),c.ok(t.isObject(k)),c.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new I}),define(_e[125],ye([1,0,4,43]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[I(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(_e[126],ye([1,0,17,4,11,165,52,125,43]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=S.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const l=this.doRegisterConfigurations(r,o);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const l=[];l.push(...this.doDeregisterConfigurations(o)),l.push(...this.doRegisterConfigurations(r,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(l)})}registerDefaultConfigurations(r){const o=[],l=[];for(const{overrides:s,source:a}of r)for(const u in s)if(o.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.configurationDefaultsOverrides.get(u),i=n?.valuesSources??new Map;if(a)for(const N of Object.keys(s[u]))i.set(N,a);const p={...n?.value||{},...s[u]};this.configurationDefaultsOverrides.set(u,{source:a,value:p,valuesSources:i});const D=(0,y.getLanguageTagSettingPlainKey)(u),R={type:"object",default:p,description:P.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:I.isString(a)?void 0:a,defaultValueSource:a};l.push(...h(u)),this.configurationProperties[u]=R,this.defaultLanguageConfigurationOverridesNode.properties[u]=R}else{this.configurationDefaultsOverrides.set(u,{value:s[u],source:a});const n=this.configurationProperties[u];n&&(this.updatePropertyDefaultValue(u,n),this.updateSchema(u,n))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:l,source:s}of r)for(const a in l){const u=this.configurationDefaultsOverrides.get(a),n=I.isString(s)?s:s?.id,i=I.isString(u?.source)?u?.source:u?.source?.id;if(n===i)if(o.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const p=this.configurationProperties[a];p&&(this.updatePropertyDefaultValue(a,p),this.updateSchema(a,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const l=[];return r.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(r){const o=[],l=s=>{if(s.properties)for(const a in s.properties){o.push(a);const u=this.configurationProperties[a];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a])}s.allOf?.forEach(a=>l(a))};for(const s of r){l(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(r,o=!0,l,s,a=3){a=I.isUndefinedOrNull(r.scope)?a:r.scope;const u=[],n=r.properties;if(n)for(const p in n){const D=n[p];if(o&&m(p,D)){delete n[p];continue}if(D.source=l,D.defaultDefaultValue=n[p].default,this.updatePropertyDefaultValue(p,D),e.OVERRIDE_PROPERTY_REGEX.test(p)?D.scope=void 0:(D.scope=I.isUndefinedOrNull(D.scope)?a:D.scope,D.restricted=I.isUndefinedOrNull(D.restricted)?!!s?.includes(p):D.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.excludedConfigurationProperties[p]=n[p],delete n[p];continue}else this.configurationProperties[p]=n[p],n[p].policy?.name&&this.policyConfigurations.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),u.push(p)}const i=r.allOf;if(i)for(const p of i)u.push(...this.validateAndRegisterProperties(p,o,l,s,a));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=l=>{const s=l.properties;if(s)for(const u in s)this.updateSchema(u,s[u]);l.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,l={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const l=this.configurationDefaultsOverrides.get(r);let s=l?.value,a=l?.source;I.isUndefined(s)&&(s=o.defaultDefaultValue,a=void 0),I.isUndefined(s)&&(s=f(o.type)),o.default=s,o.defaultValueSource=a}}const _="\\[([^\\]]+)\\]",w=new RegExp(_,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${_})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(v){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let o=w.exec(v);for(;o?.length;){const l=o[1].trim();l&&r.push(l),o=w.exec(v)}}return(0,c.distinct)(r)}e.overrideIdentifiersFromKey=h;function g(v){return v.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function f(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const b=new E;S.Registry.add(e.Extensions.Configuration,b);function m(v,r){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?P.localize(7,null,v):b.getConfigurationProperties()[v]!==void 0?P.localize(8,null,v):r.policy?.name&&b.getPolicyConfigurations().get(r.policy?.name)!==void 0?P.localize(9,null,v,r.policy?.name,b.getPolicyConfigurations().get(r.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function d(){const v=[],r=b.getConfigurationProperties();for(const o of Object.keys(r))v.push([o,r[o].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=d}),define(_e[200],ye([1,0,17,4,144,6,28,24,11,2,52,126,43]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class _{constructor(o={},l=[],s=[],a){this._contents=o,this._keys=l,this._overrides=s,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const o=this.raw.map(l=>{if(l instanceof _)return l;const s=new w("");return s.parseRaw(l),s.configurationModel});this._rawConfiguration=o.reduce((l,s)=>s===l?s:l.merge(s),o[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,A.getConfigurationValue)(this.contents,o):this.contents}inspect(o,l){const s=this.rawConfiguration.getValue(o),a=l?this.rawConfiguration.getOverrideValue(o,l):void 0,u=l?this.rawConfiguration.override(l).getValue(o):s;return{value:s,override:a,merged:u}}getOverrideValue(o,l){const s=this.getContentsForOverrideIdentifer(l);return s?o?(0,A.getConfigurationValue)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const l=[];for(const s of this.overrides)s.identifiers.includes(o)&&l.push(...s.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const o=[];for(const l of this.overrides)o.push(...l.identifiers);return c.distinct(o)}override(o){let l=this.overrideConfigurations.get(o);return l||(l=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,l)),l}merge(...o){const l=k.deepClone(this.contents),s=k.deepClone(this.overrides),a=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of o)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.mergeContents(l,n.contents);for(const i of n.overrides){const[p]=s.filter(D=>c.equals(D.identifiers,i.identifiers));p?(this.mergeContents(p.contents,i.contents),p.keys.push(...i.keys),p.keys=c.distinct(p.keys)):s.push(k.deepClone(i))}for(const i of n.keys)a.indexOf(i)===-1&&a.push(i)}return new _(l,a,s,u.every(n=>n instanceof _)?void 0:u)}freeze(){return this.frozen=!0,this}clone(){return new _(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}createOverrideConfigurationModel(o){const l=this.getContentsForOverrideIdentifer(o);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const s={};for(const a of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let u=this.contents[a];const n=l[a];n&&(typeof u=="object"&&typeof n=="object"?(u=k.deepClone(u),this.mergeContents(u,n)):u=n),s[a]=u}return new _(s,this.keys,this.overrides)}mergeContents(o,l){for(const s of Object.keys(l)){if(s in o&&S.isObject(o[s])&&S.isObject(l[s])){this.mergeContents(o[s],l[s]);continue}o[s]=k.deepClone(l[s])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?k.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let l=null,s=null;const a=u=>{u&&(s?this.mergeContents(s,u):s=k.deepClone(u))};for(const u of this.overrides)c.equals(u.identifiers,[o])?l=u.contents:u.identifiers.includes(o)&&a(u.contents);return a(l),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,l){this.addKey(o),(0,A.addToValueTree)(this.contents,o,l,s=>{throw new Error(s)})}removeValue(o){this.removeKey(o)&&(0,A.removeFromValueTree)(this.contents,o)}addKey(o){let l=this.keys.length;for(let s=0;s<l;s++)o.indexOf(this.keys[s])===0&&(l=s);this.keys.splice(l,1,o)}removeKey(o){const l=this.keys.indexOf(o);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=_;class w{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,l){if(!S.isUndefinedOrNull(o)){const s=this.doParseContent(o);this.parseRaw(s,l)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,l){this._raw=o;const{contents:s,keys:a,overrides:u,restricted:n,hasExcludedProperties:i}=this.doParseRaw(o,l);this._configurationModel=new _(s,a,u,i?[o]:void 0),this._restrictedConfigurations=n||[]}doParseContent(o){let l={},s=null,a=[];const u=[],n=[];function i(D){Array.isArray(a)?a.push(D):s!==null&&(a[s]=D)}const p={onObjectBegin:()=>{const D={};i(D),u.push(a),a=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{const D=[];i(D),u.push(a),a=D,s=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:i,onError:(D,R,N)=>{n.push({error:D,offset:R,length:N})}};if(o)try{I.visit(o,p),l=a[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return l}doParseRaw(o,l){const s=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=this.filter(o,s,!0,l);o=a.raw;const u=(0,A.toValuesTree)(o,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),n=Object.keys(o),i=this.toOverrides(o,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:u,keys:n,overrides:i,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(o,l,s,a){let u=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:u};const n={},i=[];for(const p in o)if(T.OVERRIDE_PROPERTY_REGEX.test(p)&&s){const D=this.filter(o[p],l,!1,a);n[p]=D.raw,u=u||D.hasExcludedProperties,i.push(...D.restricted)}else{const D=l[p],R=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&i.push(p),(R===void 0||a.scopes===void 0||a.scopes.includes(R))&&!(a.skipRestricted&&D?.restricted)?n[p]=o[p]:u=!0}return{raw:n,restricted:i,hasExcludedProperties:u}}toOverrides(o,l){const s=[];for(const a of Object.keys(o))if(T.OVERRIDE_PROPERTY_REGEX.test(a)){const u={};for(const n in o[a])u[n]=o[a][n];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(a),keys:Object.keys(u),contents:(0,A.toValuesTree)(u,l)})}return s}}e.ConfigurationModelParser=w;class h extends P.Disposable{constructor(o,l,s,a){super(),this.userSettingsResource=o,this.scopes=l,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&s.isEqual(u.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class g{constructor(o,l,s,a,u,n,i,p,D,R,N,V,x){this.key=o,this.overrides=l,this.value=s,this.overrideIdentifiers=a,this.defaultConfiguration=u,this.policyConfiguration=n,this.applicationConfiguration=i,this.userConfiguration=p,this.localUserConfiguration=D,this.remoteUserConfiguration=R,this.workspaceConfiguration=N,this.folderConfigurationModel=V,this.memoryInspectValue=x}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(o,l,s,a,u=new _,n=new _,i=new y.ResourceMap,p=new _,D=new y.ResourceMap,R=!0){this._defaultConfiguration=o,this._policyConfiguration=l,this._applicationConfiguration=s,this._localUserConfiguration=a,this._remoteUserConfiguration=u,this._workspaceConfiguration=n,this._folderConfigurations=i,this._memoryConfiguration=p,this._memoryConfigurationByResource=D,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(o,l,s){return this.getConsolidatedConfigurationModel(o,l,s).getValue(o)}updateValue(o,l,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new _,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,l===void 0?a.removeValue(o):a.setValue(o,l),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,l,s){const a=this.getConsolidatedConfigurationModel(o,l,s),u=c.distinct(a.overrides.map(p=>p.identifiers).flat()).filter(p=>a.getOverrideValue(o,p)!==void 0),n=this.getFolderConfigurationModelForResource(l.resource,s),i=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration;return new g(o,l,a.getValue(o),u.length?u:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this._workspaceConfiguration.freeze():void 0,n?n.freeze():void 0,i.inspect(o,l.overrideIdentifier))}keys(o){const l=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,l){this._folderConfigurations.set(o,l),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,l){const s=[];if(!l){const{added:a,updated:u,removed:n}=d(this._defaultConfiguration,o);l=[...a,...u,...n]}for(const a of l)for(const u of(0,T.overrideIdentifiersFromKey)(a)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(u),i=o.getKeysForOverrideIdentifier(u),p=[...i.filter(D=>n.indexOf(D)===-1),...n.filter(D=>i.indexOf(D)===-1),...n.filter(D=>!k.equals(this._defaultConfiguration.override(u).getValue(D),o.override(u).getValue(D)))];s.push([u,p])}return this.updateDefaultConfiguration(o),{keys:l,overrides:s}}compareAndUpdatePolicyConfiguration(o){const{added:l,updated:s,removed:a}=d(this._policyConfiguration,o),u=[...l,...s,...a];return u.length&&this.updatePolicyConfiguration(o),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:l,updated:s,removed:a,overrides:u}=d(this.applicationConfiguration,o),n=[...l,...s,...a];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(o){const{added:l,updated:s,removed:a,overrides:u}=d(this.localUserConfiguration,o),n=[...l,...s,...a];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(o){const{added:l,updated:s,removed:a,overrides:u}=d(this.remoteUserConfiguration,o),n=[...l,...s,...a];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(o){const{added:l,updated:s,removed:a,overrides:u}=d(this.workspaceConfiguration,o),n=[...l,...s,...a];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(o,l){const s=this.folderConfigurations.get(o),{added:a,updated:u,removed:n,overrides:i}=d(s,l),p=[...a,...u,...n];return(p.length||!s)&&this.updateFolderConfiguration(o,l),{keys:p,overrides:i}}compareAndDeleteFolderConfiguration(o){const l=this.folderConfigurations.get(o);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:a,removed:u,overrides:n}=d(l,void 0);return{keys:[...s,...a,...u],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,l,s){let a=this.getConsolidatedConfigurationModelForResource(l,s);return l.overrideIdentifier&&(a=a.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:o},l){let s=this.getWorkspaceConsolidatedConfiguration();if(l&&o){const a=l.getFolder(o);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const u=this._memoryConfigurationByResource.get(o);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let l=this._foldersConsolidatedConfigurations.get(o);if(!l){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(o);a?(l=s.merge(a),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(o,l)):l=s}return l}getFolderConfigurationModelForResource(o,l){if(l&&o){const s=l.getFolder(o);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,l)=>{const{contents:s,overrides:a,keys:u}=this._folderConfigurations.get(l);return o.push([l,{contents:s,overrides:a,keys:u}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>o.add(l)),this.userConfiguration.freeze().keys.forEach(l=>o.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>o.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(s=>o.add(s))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>o.add(l)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>o.add(l)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>o.add(l)),this._folderConfigurations.forEach(l=>l.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>l.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>l.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(a=>l.add(a))),[...l.values()]}static parse(o){const l=this.parseConfigurationModel(o.defaults),s=this.parseConfigurationModel(o.policy),a=this.parseConfigurationModel(o.application),u=this.parseConfigurationModel(o.user),n=this.parseConfigurationModel(o.workspace),i=o.folders.reduce((p,D)=>(p.set(C.URI.revive(D[0]),this.parseConfigurationModel(D[1])),p),new y.ResourceMap);return new f(l,s,a,u,new _,n,i,new _,new y.ResourceMap,!1)}static parseConfigurationModel(o){return new _(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=f;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const o=new Set,l=new Map;for(const a of r)a.keys.forEach(u=>o.add(u)),a.overrides.forEach(([u,n])=>{const i=(0,y.getOrSet)(l,u,new Set);n.forEach(p=>i.add(p))});const s=[];return l.forEach((a,u)=>s.push([u,[...a.values()]])),{keys:[...o.values()],overrides:s}}e.mergeChanges=b;class m{constructor(o,l,s,a){this.change=o,this.previous=l,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;o.keys.forEach(i=>u.add(i)),o.overrides.forEach(([,i])=>i.forEach(p=>u.add(p))),this.affectedKeys=[...u.values()];const n=new _;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(l){const s=this.previousConfiguration?this.previousConfiguration.getValue(o,l,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(o,l,this.currentWorkspace);return!k.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(o,l){let s=(0,A.toValuesTree)({[l]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(o=o[a],!o)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=m;function d(r,o){const{added:l,removed:s,updated:a}=v(o?.rawConfiguration,r?.rawConfiguration),u=[],n=r?.getAllOverrideIdentifiers()||[],i=o?.getAllOverrideIdentifiers()||[];if(o){const p=i.filter(D=>!n.includes(D));for(const D of p)u.push([D,o.getKeysForOverrideIdentifier(D)])}if(r){const p=n.filter(D=>!i.includes(D));for(const D of p)u.push([D,r.getKeysForOverrideIdentifier(D)])}if(o&&r){for(const p of n)if(i.includes(p)){const D=v({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)});u.push([p,[...D.added,...D.removed,...D.updated]])}}return{added:l,removed:s,updated:a,overrides:u}}function v(r,o){const l=r?o?r.keys.filter(u=>o.keys.indexOf(u)===-1):[...r.keys]:[],s=o?r?o.keys.filter(u=>r.keys.indexOf(u)===-1):[...o.keys]:[],a=[];if(r&&o){for(const u of o.keys)if(r.keys.indexOf(u)!==-1){const n=(0,A.getConfigurationValue)(o.contents,u),i=(0,A.getConfigurationValue)(r.contents,u);k.equals(n,i)||a.push(u)}}return{added:l,removed:s,updated:a}}}),define(_e[127],ye([1,0,10,3]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends c.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof P&&k._code===I.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof P&&k._code===I.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof P&&k._code===I.NoResolverFound}static isHandled(k){return k instanceof P&&k.isHandled}constructor(k,S=I.Unknown,C){super(k),this._message=k,this._code=S,this._detail=C,this.isHandled=S===I.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(_e[87],ye([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===c.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const A=C.indexOf("+");return A<0?C:C.substr(0,A)}e.getRemoteName=I;function P(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(C){const{host:A,port:T}=S(C);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:T}}e.parseAuthorityWithPort=y;function k(C,A){let{host:T,port:E}=S(C);return typeof E>"u"&&(E=A),{host:T,port:E}}e.parseAuthorityWithOptionalPort=k;function S(C){const A=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const T=C.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const E=C.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:C,port:void 0}}}),define(_e[26],ye([1,0,8,3,87]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,g){if(typeof h>"u"||h===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof h=="string"||typeof g=="string"){const f=typeof h=="string"?h:h.value,b=typeof g=="string"?g:g.value;return c.equalsIgnoreCase(f,b)}return h._lower===g._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=C;function A(w){return T(w)}e.isApplicationScopedExtension=A;function T(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function _(w,h){if(h){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(h)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[201],ye([1,0,8,121,26,12,2,10,36]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,c.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=C;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{static create(l){const s=l.manifest?l.manifest.version:l.version,a=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new T(l.identifier,s,a)}static parse(l){const s=A.exec(l);return s&&s[1]&&s[2]?new T({id:s[1]},s[2],s[4]||void 0):null}constructor(l,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof T?C(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=T;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(o){const l=E.exec(o);return l&&l[1]?[h(l[1]),l[2]]:[h(o),void 0]}e.getIdAndVersion=_;function w(o,l){return`${o}.${l}`}e.getExtensionId=w;function h(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function g(o,l){return h(w(o,l))}e.getGalleryExtensionId=g;function f(o,l){const s=[],a=u=>{for(const n of s)if(n.some(i=>C(l(i),l(u))))return n;return null};for(const u of o){const n=a(u);n?n.push(u):s.push([u])}return s}e.groupByExtension=f;function b(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function m(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(o,l){const s=[],a=l.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const u=a.shift();if(u&&s.every(n=>!C(n.identifier,{id:u}))){const n=o.filter(i=>C(i.identifier,{id:u}));n.length===1&&(s.push(n[0]),a.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=d;async function v(o,l){if(!P.isLinux)return!1;let s;try{s=(await o.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){l.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=v;async function r(o,l){const s=await v(o,l),a=(0,t.getTargetPlatform)(s?"alpine":P.platform,S.arch);return l.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(_e[202],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.validators=new Map}vsda(){return new Promise((I,P)=>Z(["vsda"],I,P))}async createNewMessage(I){try{const P=await this.vsda(),y=new P.validator;if(y){const k=String(c._nextId++);return this.validators.set(k,y),{id:k,data:y.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,P){if(!I.id)return!0;const y=this.validators.get(I.id);if(!y)return!1;this.validators.delete(I.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(I){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(I)}catch{}return I}}e.SignService=c,c._nextId=1}),define(_e[203],ye([1,0,12,36,2,30]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(C){if(c.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function k(C,A,T,E,_,w,h,g,f,b){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,P.generateUuid)()+Date.now(),m.commitHash=_,m.version=w,m["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,c.PlatformToString)(c.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=b||"desktop",g&&(m["common.msftInternal"]=g);let d=0;const v=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),c.isLinuxSnap&&(m["common.snap"]="true");const r=y(T);r&&(m["common.platformDetail"]=r);try{const o=await C.readFile(I.URI.file(f));m["common.source"]=o.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=k;function S(C){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const T=A.toLowerCase();return C.some(E=>T===E)}e.verifyMicrosoftInternalDomain=S}),define(_e[204],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(_e[205],ye([1,0,24,158,11,52,203,204]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class C{async publicLog(a,u,n){}async publicLogError(a,u,n){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(s,a){return a.onDidChangeConfiguration(u=>{u.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(u.source),configurationKeys:b(u.sourceConfig)})})}e.configurationTelemetry=A;function T(s,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!s.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=T;function E(s,a){return!(a.isBuilt||a.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=E;function _(s){const a=s.getValue(k.TELEMETRY_SETTING_ID),u=s.getValue("telemetry.enableCrashReporter");if(s.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=_;function w(s){const a={},u={},n={};f(s,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const p=n[i];typeof p=="number"?u[i]=p:typeof p=="boolean"?u[i]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${p.length}`),a[i]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(a[i]=p)}return{properties:a,measurements:u}}e.validateTelemetryData=w;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(s){if(!s)return"none";for(const a of h)if(s.startsWith(`${a}+`))return a;return"other"}e.cleanRemoteAuthority=g;function f(s,a,u=0,n){if(!!s)for(const i of Object.getOwnPropertyNames(s)){const p=s[i],D=n?n+i:i;Array.isArray(p)?a[D]=(0,c.safeStringify)(p):p instanceof Date?a[D]=p.toISOString():(0,I.isObject)(p)?u<2?f(p,a,u+1,D+"."):a[D]=(0,c.safeStringify)(p):a[D]=p}}function b(s){if(!s)return[];const a=[];return m(a,"",s),a}function m(s,a,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(n=>m(s,a?`${a}.${n}`:n,u[n])):s.push(a)}function d(s,a){const u=s.msftInternalDomains||[],n=a.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(u)||n}e.isInternalTelemetry=d;function v(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=v;function r(s,a){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let u=s;const n=[];for(const R of a)for(;;){const N=R.exec(s);if(!N)break;n.push([N.index,R.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(u="";;){const R=p.exec(s);if(!R)break;const N=n.some(([V,x])=>R.index<x&&V<p.lastIndex);!i.test(R[0])&&!N&&(u+=s.substring(D,R.index)+"<REDACTED: user-file-path>",D=p.lastIndex)}return D<s.length&&(u+=s.substr(D)),u}function o(s){if(!s)return s;const a=s.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of u)if(n.regex.test(a))return`<REDACTED: ${n.label}>`;return s}function l(s,a){return(0,c.cloneAndChange)(s,u=>{if(typeof u=="string"){let n=u;n=r(n,a);for(const i of a)n=n.replace(i,"");return n=o(n),n}})}e.cleanData=l}),define(_e[206],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,P,y=5){const k=P(S=>{const C=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(I);if(A){A.data.push(C);return}const T=setTimeout(()=>this.flushBuffer(I),y);A={data:[C],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,A)});return k}stopBuffering(I){this._terminalBufferMap.get(I)?.dispose()}flushBuffer(I){const P=this._terminalBufferMap.get(I);P&&(this._terminalBufferMap.delete(I),this._callback(I,P.data.join("")))}}e.TerminalDataBufferer=c}),define(_e[207],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===c.HIGH_CONTRAST_DARK||P===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(P){return P===c.DARK||P===c.HIGH_CONTRAST_DARK}e.isDark=I}),define(_e[88],ye([1,0,77,4,6,3,43,207]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(g){function f(b){return b&&typeof b=="object"&&typeof b.id=="string"}g.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var A;(function(g){function f(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||S.isThemeColor(s.color))}g.isThemeIcon=f;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function m(s){const a=b.exec(s);if(!a)return;const[,u]=a;return{id:u}}g.fromString=m;function d(s){return{id:s}}g.fromId=d;function v(s,a){let u=s.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),a&&(u=`${u}~${a}`),{id:u}}g.modify=v;function r(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}g.getModifier=r;function o(s,a){return s.id===a.id&&s.color?.id===a.color?.id}g.isEqual=o;function l(s,a){return{id:s.id,color:a?C(a):void 0}}g.asThemeIcon=l,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function T(g){switch(g){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,I.toDisposable)(()=>{const b=this.themingParticipants.indexOf(f);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const _=new E;y.Registry.add(e.Extensions.ThemingContribution,_);function w(g){return _.onColorThemeChange(g)}e.registerThemingParticipant=w;class h extends I.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,b){let m=this.theme.getColor(f);return m&&b&&(m=b(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(_e[128],ye([1,0,4,52,3,13]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var y;(function(h){h.Http="http",h.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=T;function E(h,g,f,b){if(f===1)return!1;if(f===2&&T(g)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(m?.length===4&&parseInt(m[1])>=18)return!1}return h<1024}e.isPortPrivileged=E;class _{constructor(g,f,b){this.remoteAddress=g,this.localAddress=f,this._dispose=b,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let w=class{constructor(g,f){this.logService=g,this.configurationService=f,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],f=Array.from(this._tunnels.values());for(const b of f){const m=Array.from(b.values());for(const d of m){const v=await d.value;v&&g.push(v)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:f}of g.values())await f.then(b=>b?.dispose());g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,f,b,m,d){this.addTunnelToMap(g,f,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:f,localAddress:b,privacy:m,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,f){(T(g)||A(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const b=this.getTunnelFromMap(g,f);if(b)return++b.refcount,b.value}openTunnel(g,f,b,m,d=!1,v,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${b} on local port ${m}.`),!g)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(b)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(g,f,b,m,d,v,r);return o?o.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const f=this._tunnels.get(g.tunnelRemoteHost);if(f){const b=f.get(g.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,b))}}}}async tryDisposeTunnel(g,f,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${f}.`);const m=b.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(f),m}}async closeTunnel(g,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${f} `);const b=this._tunnels.get(g);if(b&&b.has(f)){const m=b.get(f);m.refcount=0,await this.tryDisposeTunnel(g,f,m)}}addTunnelToMap(g,f,b){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(f,{refcount:1,value:b})}async removeEmptyTunnelFromMap(g,f){const b=this._tunnels.get(g);b&&(await b.get(f)||b.delete(f),b.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,f){const b=[g];A(g)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):T(g)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const m=b.map(d=>this._tunnels.get(d));for(const d of m){const v=d?.get(f);if(v)return v}}canTunnel(g){return!!C(g)}createWithProvider(g,f,b,m,d,v,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${b} on local port ${m}.`);const o=b;this._factoryInProgress.add(o);const l=m===void 0?b:m,s={elevationRequired:d?this.isPortPrivileged(l):!1},a={remoteAddress:{host:f,port:b},localAddressPort:m,privacy:v,public:v?v!==k.Private:void 0,protocol:r},u=g.forwardPort(a,s);return u?(this.addTunnelToMap(f,b,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),u}};w=je([He(0,P.ILogService),He(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(_e[208],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(_e[209],ye([1,0,14]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function P(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=P;function y(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=y;function k(S){return I(S)!==void 0}e.isVirtualWorkspace=k}),define(_e[45],ye([1,0,171,9,64,22,2,3,14]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function C(o){const l=o;return typeof l?.id=="string"&&y.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(o,l){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const s=o;if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=A;function T(o){const l=o;return typeof l?.id=="string"&&y.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=T;function E(o){const l=o;if(l?.uri)return{id:l.id,uri:y.URI.revive(l.uri)};const s=o;if(s?.configPath)return{id:s.id,configPath:y.URI.revive(s.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var _;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function w(o){const l=o;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=w;function h(o){const l=o;return!!(l&&typeof l=="object"&&y.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(l,s,a,u,n){this._id=l,this._transient=a,this._configuration=u,this._ignorePathCasing=n,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(l,s){this.raw=s,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function b(o){return new f({uri:o,index:0,name:(0,P.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(o,l){return P.extUriBiasedIgnorePathCase.isEqualOrParent(o,l.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function d(o){let l;return y.URI.isUri(o)?l=o:l=o.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=d;function v(o,l){return!m(o,l)&&!d(o)}e.isSavedWorkspace=v;function r(o){return(typeof o=="string"?(0,t.extname)(o):(0,P.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(_e[89],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const P=this._idPool++;return this._data.set(P,I),this.logDebugInfo(),P}get(I,P){return this._data.has(I)?this._data.get(I)[P]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(_e[46],ye([1,0,14,22,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(_e[25],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(_e[210],ye([1,0,18]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,k,S){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of C.values())A.complete()}catch(A){for(const T of C.values())T.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,k){let S=this._value[y];return typeof S>"u"&&(S=k),S}update(y,k){this._value[y]=k;const S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const C=new c.DeferredPromise;return this._deferredPromises.set(y,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,k){super(y.identifier.value,!0,k),this._extension=y}}e.ExtensionGlobalMemento=I}),define(_e[211],ye([1,0,4,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,k,S,C){const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(k.value,S,C);this._onDidChangeNotebookDocument.fire(T)}$acceptDirtyStateChanged(y,k){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(k)}$acceptModelSaved(y){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(_e[16],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[212],ye([1,0,26,4]),function(Z,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(k,S){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(k.identifier),tt(this,I,S,"f"),Ne(this,I,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(k){return Ne(this,I,"f").get(this._id,k)}store(k,S){return Ne(this,I,"f").store(this._id,k,S)}delete(k){return Ne(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=P,I=new WeakMap}),define(_e[54],ye([1,0,3,128,4,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function C(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:T.protocol}}S.fromApiTunnel=C;function A(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==t.TunnelPrivacyId.ConstantPrivate&&T.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}S.fromServiceTunnel=A})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let k=class{constructor(C){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,A){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,A){return{dispose:()=>{}}}async $providePortAttributes(C,A,T,E,_){return[]}async $forwardPort(C,A){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([He(0,P.IExtHostRpcService)],k),e.ExtHostTunnelService=k}),define(_e[55],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(_e[213],ye([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function I(k,S){if(S.serializeBuffersForPostMessage){const C=new t,A=(_,w)=>{if(w instanceof ArrayBuffer){const h=C.add(w);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(w)){const h=P(w);if(h){const g=C.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},T=JSON.stringify(k,A),E=C.buffers.map(_=>{const w=new Uint8Array(_);return c.VSBuffer.wrap(w)});return{message:T,buffers:E}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function P(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,S){const C=S.map(E=>{const _=new ArrayBuffer(E.byteLength);return new Uint8Array(_).set(E.buffer),_}),A=S.length?(E,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const w=_,{index:h}=w,g=C[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return _}:void 0;return{message:JSON.parse(k,A),arrayBuffers:C}}e.deserializeWebviewMessage=y}),define(_e[214],ye([1,0,112]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function I(P){return new c.URITransformer(t(P))}e.createURITransformer=I}),define(_e[129],ye([1,0,181,11,2,6,3,43,38,14]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(j){j[j.PROGRAMMATIC=1]="PROGRAMMATIC",j[j.USER=2]="USER",j[j.EDIT=3]="EDIT",j[j.NAVIGATION=4]="NAVIGATION",j[j.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var T;(function(j){j[j.IDENTICAL=1]="IDENTICAL",j[j.SIMILAR=2]="SIMILAR",j[j.DIFFERENT=3]="DIFFERENT"})(T=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(j){const $=j;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=E;function _(j,$,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===$&&j.matches(K.input))return K.getViewState()}e.findViewStateForEditor=_;function w(j){if(a(j))return!1;const $=j;return I.URI.isUri($?.resource)}e.isResourceEditorInput=w;function h(j){if(a(j))return!1;const $=j;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=h;function g(j){if(a(j)||h(j))return!1;const $=j;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function f(j){if(a(j))return!1;const $=j;return $?$.resource===void 0||$.resource.scheme===C.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const b=/Untitled-\d+/;function m(j){return j.scheme===C.Schemas.untitled&&j.path.length>1&&!b.test(j.path)}e.isUntitledWithAssociatedResource=m;function d(j){if(a(j))return!1;const $=j;return I.URI.isUri($?.base?.resource)&&I.URI.isUri($?.input1?.resource)&&I.URI.isUri($?.input2?.resource)&&I.URI.isUri($?.result?.resource)}e.isResourceMergeEditorInput=d;var v;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var r;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.mapIdToSaveSource=new Map}registerSource($,Q){let K=this.mapIdToSaveSource.get($);return K||(K={source:$,label:Q},this.mapIdToSaveSource.set($,K)),K.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new o;var l;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription",j[j.CanDropIntoEditor=128]="CanDropIntoEditor",j[j.MultipleEditors=256]="MultipleEditors"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends P.Disposable{}e.AbstractEditorInput=s;function a(j){return j instanceof s}e.isEditorInput=a;function u(j){const $=j;return I.URI.isUri($?.preferredResource)}function n(j){const $=j;return a($?.primary)&&a($?.secondary)}e.isSideBySideEditorInput=n;function i(j){const $=j;return a($?.modified)&&a($?.original)}e.isDiffEditorInput=i;function p(j){return a(j?.editor)}e.isEditorInputWithOptions=p;function D(j){const $=j;return p(j)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=D;function R(j){const $=j;return typeof $?.groupId=="number"&&a($.editor)}e.isEditorIdentifier=R;var N;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(N=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(j){j[j.GROUP_ACTIVE=0]="GROUP_ACTIVE",j[j.GROUP_INDEX=1]="GROUP_INDEX",j[j.GROUP_LOCKED=2]="GROUP_LOCKED",j[j.EDITOR_OPEN=3]="EDITOR_OPEN",j[j.EDITOR_CLOSE=4]="EDITOR_CLOSE",j[j.EDITOR_MOVE=5]="EDITOR_MOVE",j[j.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",j[j.EDITOR_LABEL=7]="EDITOR_LABEL",j[j.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",j[j.EDITOR_PIN=9]="EDITOR_PIN",j[j.EDITOR_STICKY=10]="EDITOR_STICKY",j[j.EDITOR_DIRTY=11]="EDITOR_DIRTY",j[j.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri($,Q){if(!$)return;if(d($))return e.EditorResourceAccessor.getOriginalUri($.result,Q);if(Q?.supportSideBySide){const{primary:ue,secondary:re}=this.getSideEditors($);if(ue&&re){if(Q?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===x.ANY)return this.getOriginalUri(ue,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(re,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===x.PRIMARY?ue:re}}if(h($)||g($)||d($))return;const K=u($)?$.preferredResource:$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors($){return n($)||g($)?{primary:$.primary,secondary:$.secondary}:i($)||h($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,Q){if(!$)return;if(d($))return e.EditorResourceAccessor.getCanonicalUri($.result,Q);if(Q?.supportSideBySide){const{primary:ue,secondary:re}=this.getSideEditors($);if(ue&&re){if(Q?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===x.ANY)return this.getCanonicalUri(ue,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===x.PRIMARY?ue:re}}if(h($)||g($)||d($))return;const K=$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri($,Q){if(Array.isArray(Q)){if(Q.some(K=>$.scheme===K))return $}else if(Q===$.scheme)return $}}e.EditorResourceAccessor=new L;var U;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(U=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const Q=this.instantiationService=$.get(y.IInstantiationService);for(const[K,ue]of this.editorSerializerConstructors)this.createEditorSerializer(K,ue,Q);this.editorSerializerConstructors.clear()}createEditorSerializer($,Q,K){const ue=K.createInstance(Q);this.editorSerializerInstances.set($,ue)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,Q){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,Q,this.instantiationService):this.editorSerializerConstructors.set($,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(j,$,Q){return!j||!j.length?[]:await Promise.all(j.map(async K=>{const ue=I.URI.revive(K.fileUri);if(!ue){Q.info("Cannot resolve the path because it is not valid.",K);return}if(!await $.canHandleResource(ue)){Q.info("Cannot resolve the path because it cannot be handled",K);return}let de=K.exists,Y=K.type;if(typeof de!="boolean"||typeof Y!="number")try{Y=(await $.stat(ue)).isDirectory?S.FileType.Directory:S.FileType.Unknown,de=!0}catch(be){Q.error(be),de=!1}if(!de&&K.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",K);return}if(Y===S.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",K);return}const pe={...K.options,pinned:!0};return de?{resource:ue,options:pe}:{resource:ue,options:pe,forceUntitled:!0}}))}e.pathsToEditors=B;var M;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function z(j){const $=j;if(!$)return!1;const Q=$;if(Q.modified)return z(Q.modified);const K=$;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=z}),define(_e[90],ye([1,0,14,2]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===c.Schemas.http||k.scheme===c.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===c.Schemas.file&&(k=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:k.path})),t.URI.from({scheme:c.Schemas.https,authority:`${k.scheme}+${P(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function P(k){return k.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function y(k){return k.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=y}),define(_e[215],ye([1,0,4,6,90]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(k,S,C){this._proxy=k,this._editors=S,this._remoteInfo=C,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const T of this._insets.values())A.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,C,A,T){let E;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===k){E=m;break}if(!E)throw new Error("not a visible editor");const _=this,w=this._handlePool++,h=new c.Emitter,g=new c.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,I.asWebviewUri)(m,_._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(m){this._options=m,_._proxy.$setOptions(w,m)}get options(){return this._options}set html(m){this._html=m,_._proxy.$setHtml(w,m)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(m){return _._proxy.$postMessage(w,m)}},b=new class{constructor(){this.editor=k,this.line=S,this.height=C,this.webview=f,this.onDidDispose=g.event}dispose(){_._insets.has(w)&&(_._insets.delete(w),_._proxy.$disposeEditorInset(w),g.fire(),g.dispose(),h.dispose())}};return this._proxy.$createEditorInset(w,E.id,E.value.document.uri,S+1,C,A||{},T.identifier,T.extensionLocation),this._insets.set(w,{editor:k,inset:b,onDidReceiveMessage:h}),b}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){this._insets.get(k)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(_e[130],ye([1,0,4,18,182]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,C,A){const T={command:k};if(S&&Object.keys(S).length>0&&(T.arguments=S),this.internalSend("request",T),typeof A=="number"){const E=setTimeout(()=>{clearTimeout(E);const _=this.pendingRequests.get(T.seq);if(_){this.pendingRequests.delete(T.seq);const w={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,I.localize)(0,null,A,k)};_(w)}},A)}return C&&this.pendingRequests.set(T.seq,C),T.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback?.(k);break;case"request":this.requestCallback?.(k);break;case"response":{const S=k,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,C)=>k.set(C,S)),await(0,t.timeout)(500),k.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(_e[216],ye([1,0,183,53,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(49,null)});const P=E=>c.localize(50,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(51,null)};var y;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(y=e.State||(e.State={}));function k(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var T;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(_e[217],ye([1,0,8,2,9,24,14]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(l,s,a){return l.replace(k,function(u,n){return s&&n.length>0&&n[0]!=="_"?u:a&&a.hasOwnProperty(n)?a[n]:u})}e.formatPII=S;function C(l){const s={};for(const a of Object.keys(l))a.startsWith("!")||(s[a]=l[a]);return s}e.filterExceptionsFromTelemetry=C;function A(l){return l.configuration.request==="attach"&&!T(l)&&(!l.parentSession||A(l.parentSession))}e.isSessionAttach=A;function T(l){let s=l.configuration.type;if(!!s)return s==="vslsShare"&&(s=l.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(s,"extensionhost")||(0,c.equalsIgnoreCase)(s,"pwa-extensionhost")?l:l.parentSession?T(l.parentSession):void 0}e.getExtensionHostDebugSession=T;function E(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=E;function _(l,s,a){let u,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=i.exec(l);){const D=p.index+1,R=D+p[0].length;if(D<=s&&R>=a){u=p[0],n=D;break}}if(u){const D=/\w+/g;let R=null;for(;(R=D.exec(u))&&!(R.index+1+n+R[0].length>=a););R&&(u=u.substring(0,D.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(l){return!!(l&&l.match(w))}e.isUri=h;function g(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(h(l.path))return t.URI.parse(l.path);if((0,I.isAbsolute)(l.path))return t.URI.file(l.path)}return l.path}function f(l){if(typeof l.path=="object"){const s=t.URI.revive(l.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return l.path}function b(l,s){const a=s?g:f,u=(0,P.deepClone)(l);return d(u,(n,i)=>{n&&i&&(i.path=a(i))}),u}e.convertToDAPaths=b;function m(l,s){const a=s?g:f,u=(0,P.deepClone)(l);return d(u,(n,i)=>{!n&&i&&(i.path=a(i))}),u}e.convertToVSCPaths=m;function d(l,s){switch(l.type){case"event":{const a=l;switch(a.event){case"output":s(!1,a.body.source);break;case"loadedSource":s(!1,a.body.source);break;case"breakpoint":s(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=l;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(u=>s(!1,u));break;default:break}break}case"response":{const a=l;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(u=>s(!1,u.source));break;case"loadedSources":a.body.sources.forEach(u=>s(!1,u));break;case"scopes":a.body.scopes.forEach(u=>s(!1,u.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(u=>s(!1,u.source));break;case"setBreakpoints":a.body.breakpoints.forEach(u=>s(!1,u.source));break;case"disassemble":a.body?.instructions.forEach(n=>s(!1,n.location));break;default:break}break}}}function v(l){return l.filter(s=>!s.presentation?.hidden).sort((s,a)=>s.presentation?a.presentation?s.presentation.group?a.presentation.group?s.presentation.group!==a.presentation.group?s.presentation.group.localeCompare(a.presentation.group):r(s.presentation.order,a.presentation.order):-1:a.presentation.group?1:r(s.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=v;function r(l,s){return typeof l!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:l-s}async function o(l,s){const a=l.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(a!=="none"&&(await s.saveAll(),a==="allEditorsInActiveGroup")){const u=s.activeEditorPane;u&&u.input.resource?.scheme===y.Schemas.untitled&&await s.save({editor:u.input,groupId:u.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(_e[218],ye([1,0,44,219,24,9,12,8,29,184,130]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(f,b){this.outputStream=b,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,f.on("data",m=>this.handleData(m))}sendMessage(f){if(this.outputStream){const b=JSON.stringify(f);this.outputStream.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${T.TWO_CRLF}${b}`,"utf8")}}handleData(f){for(this.rawData=Buffer.concat([this.rawData,f]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const b=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(m){this._onError.fire(new Error((m.message||m)+`
`+b))}continue}}else{const b=this.rawData.indexOf(T.TWO_CRLF);if(b!==-1){const d=this.rawData.toString("utf8",0,b).split(T.HEADER_LINESEPARATOR);for(const v of d){const r=v.split(T.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(b+T.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=T,T.TWO_CRLF=`\r
\r
`,T.HEADER_LINESEPARATOR=/\r?\n/,T.HEADER_FIELDSEPARATOR=/: */;class E extends T{startSession(){return new Promise((f,b)=>{let m=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),f(),m=!0}),this.socket.on("close",()=>{m?this._onError.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.socket.on("error",d=>{m?this._onError.fire(d):b(d)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class _ extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",f)}}e.SocketDebugAdapter=_;class w extends E{constructor(f){super(),this.adapterServer=f}createConnection(f){return t.createConnection(this.adapterServer.path,f)}}e.NamedPipeDebugAdapter=w;class h extends T{constructor(f,b){super(),this.adapterExecutable=f,this.debugType=b}async startSession(){const f=this.adapterExecutable.command,b=this.adapterExecutable.args,m=this.adapterExecutable.options||{};try{if(f)if(P.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(C.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let d=process.env;if(m.env&&Object.keys(m.env).length>0&&(d=I.mixin(I.deepClone(process.env),m.env)),f==="node")if(Array.isArray(b)&&b.length>0){const v=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:d,execArgv:v?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(r.cwd=m.cwd);const o=c.fork(b[0],b.slice(1),r);if(!o.pid)throw new Error(C.localize(2,null,b[0]));this.serverProcess=o}else throw new Error(C.localize(3,null));else{const v={env:d};m.cwd&&(v.cwd=m.cwd),this.serverProcess=c.spawn(f,b,v)}this.serverProcess.on("error",v=>{this._onError.fire(v)}),this.serverProcess.on("exit",(v,r)=>{this._onExit.fire(v)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",v=>{this._onError.fire(v)}),this.serverProcess.stdin.on("error",v=>{this._onError.fire(v)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(d){this._onError.fire(d)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((f,b)=>{const m=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(d,v,r){if(d)return b(d)});m.on("exit",f),m.on("error",b)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(f,b){if(!f)return;const m=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?m.runtime=P.join(b,f.runtime):m.runtime=f.runtime),f.runtimeArgs&&(m.runtimeArgs=f.runtimeArgs),f.program&&(P.isAbsolute(f.program)?m.program=f.program:m.program=P.join(b,f.program)),f.args&&(m.args=f.args);const d=f;return d.win&&(m.win=h.extract(d.win,b)),d.winx86&&(m.winx86=h.extract(d.winx86,b)),d.windows&&(m.windows=h.extract(d.windows,b)),d.osx&&(m.osx=h.extract(d.osx,b)),d.linux&&(m.linux=h.extract(d.linux,b)),m}static platformAdapterExecutable(f,b){let m=Object.create(null);b=b.toLowerCase();for(const s of f)if(s.contributes){const a=s.contributes.debuggers;a&&a.length>0&&a.filter(u=>typeof u.type=="string"&&k.equalsIgnoreCase(u.type,b)).forEach(u=>{const n=h.extract(u,s.extensionLocation.fsPath);m=I.mixin(m,n,s.isBuiltin)})}let d;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=m.winx86||m.win||m.windows:y.isWindows?d=m.win||m.windows:y.isMacintosh?d=m.osx:y.isLinux&&(d=m.linux),d=d||m;const v=d.program||m.program,r=d.args||m.args,o=d.runtime||m.runtime,l=d.runtimeArgs||m.runtimeArgs;if(o)return{type:"executable",command:o,args:(l||[]).concat(typeof v=="string"?[v]:[]).concat(r||[])};if(v)return{type:"executable",command:v,args:r||[]}}}e.ExecutableDebugAdapter=h}),define(_e[220],ye([1,0,44,32,12]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(C,A){return new Promise((T,E)=>{let _="";const w=c.spawn(C,A);w.pid&&w.stdout.on("data",h=>{_+=h.toString()}),w.on("error",h=>{E(h)}),w.on("close",h=>{T(_)})})}async function y(C){if(C)if(I.isWindows){const A=await new Promise((T,E)=>{Z(["windows-process-tree"],T,E)});return new Promise(T=>{A.getProcessTree(C,E=>{T(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(C)]).then(A=>{const T=A.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var k;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(k||(k={}));function S(C,A,T,E,_){C=C.trim().toLowerCase();let w;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?w=1:C.indexOf("cmd.exe")>=0?w=0:C.indexOf("bash")>=0?w=2:I.isWindows?w=0:w=2;let h,g=" ";switch(w){case 1:if(h=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}:; `),g+=`cd ${h(E)}; `}if(_)for(const f in _){const b=_[f];b===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${b}'; `}if(A.length>0){const f=A.shift(),b=T?f:h(f);g+=b[0]==="'"?`& ${b} `:`${b} `;for(const m of A)g+=m==="<"||m===">"||T?m:h(m),g+=" "}break;case 0:if(h=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>f.includes(b))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(g+=`${f}: && `),g+=`cd ${h(E)} && `}if(_){g+='cmd /C "';for(const f in _){let b=_[f];b===null?g+=`set "${f}=" && `:(b=b.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${f}=${b}" && `)}}for(const f of A)g+=f==="<"||f===">"||T?f:h(f),g+=" ";_&&(g+='"');break;case 2:{h=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const f=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(E&&(g+=`cd ${h(E)} ; `),_){g+="/usr/bin/env";for(const b in _){const m=_[b];m===null?g+=` -u ${f(b)}`:g+=` ${f(`${b}=${m}`)}`}g+=" "}for(const b of A)g+=b==="<"||b===">"||T?b:h(b),g+=" ";break}}return g}e.prepareCommand=S}),define(_e[91],ye([1,0,23,37,62,81,14,9,12,53]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var b;(function(B){B.scheme=y.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${M.join("")}]+`),j=7;function $(Y,pe){const be=pe.toString(j),Re=`${be.length<M.length?M[be.length-1]:"z"}${be}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:B.scheme,fragment:Re})}B.generate=$;function Q(Y){if(Y.scheme!==B.scheme)return;const pe=Y.fragment.indexOf("s");if(pe<0)return;const be=parseInt(Y.fragment.substring(0,pe).replace(z,""),j),Ce=(0,c.decodeBase64)(Y.fragment.substring(pe+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:Ce,fragment:null})}}B.parse=Q;function K(Y,pe){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}B.generateCellOutputUri=K;function ue(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!pe)return;const be=pe[1]&&pe[1]!==""?pe[1]:void 0,Ce=pe[2];return{outputId:be,notebook:Y.with({scheme:Ce||y.Schemas.file,fragment:null})}}B.parseCellOutputUri=ue;function re(Y,pe,be){return B.generate(Y,pe).with({scheme:be})}B.generateCellPropertyUri=re;function de(Y,pe){if(Y.scheme===pe)return B.parse(Y.with({scheme:B.scheme}))}B.parseCellPropertyUri=de})(b=e.CellUri||(e.CellUri={}));const m=B=>S.isWindows?B.replace(/\//g,"\\"):B;class d{constructor(M=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set(M)].map(j=>({pattern:j,matches:t.parse(m(j))}))}sort(M){const z=new Map(I.Iterable.map(M,$=>[$,m($)]));let j=[];for(const{matches:$}of this.order)for(const[Q,K]of z)if($(K)){j.push(Q),z.delete(Q);break}return z.size&&(j=j.concat([...z.keys()].sort(($,Q)=>this.defaultOrder.indexOf($)-this.defaultOrder.indexOf(Q)))),j}prioritize(M,z){const j=this.findIndex(M);if(j===-1){this.order.unshift({pattern:M,matches:t.parse(m(M))});return}const $=new Set(z.map(K=>this.findIndex(K,j)));$.delete(-1);const Q=Array.from($).sort();this.order.splice(j+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(M=>M.pattern)}findIndex(M,z=this.order.length){const j=m(M);for(let $=0;$<z;$++)if(this.order[$].matches(j))return $;return-1}}e.MimeTypeDisplayOrder=d;function v(B,M,z,j=($,Q)=>$===Q){const $=[];function Q(re,de,Y){if(de===0&&Y.length===0)return;const pe=$[$.length-1];pe&&pe.start+pe.deleteCount===re?(pe.deleteCount+=de,pe.toInsert.push(...Y)):$.push({start:re,deleteCount:de,toInsert:Y})}let K=0,ue=0;for(;;){if(K===B.length){Q(K,0,M.slice(ue));break}if(ue===M.length){Q(K,B.length-K,[]);break}const re=B[K],de=M[ue];if(j(re,de)){K+=1,ue+=1;continue}z(de)?(Q(K,1,[]),K+=1):(Q(K,0,[de]),ue+=1)}return $}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const M=B;return!!((typeof M.include=="string"||t.isRelativePattern(M.include))&&(typeof M.exclude=="string"||t.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=o;function l(B,M,z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(M)>=0||B.viewType===M)return!0;if(B.filenamePattern){const j=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,$=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(j,(0,k.basename)(z.fsPath).toLowerCase()))return!($&&t.match($,(0,k.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var s;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(s=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(M){return`${a._prefix}${M}`}static parse(M){if(M.startsWith(a._prefix))return M.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function u(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=u;const n=new TextDecoder;function i(B){const M=[];let z=!1;for(const j of B)(M.length===0||z)&&(M.push(j),z=!0);return N(M),F(c.VSBuffer.concat(M.map(j=>c.VSBuffer.wrap(j))))}e.compressOutputItemStreams=i;const p=`${String.fromCharCode(27)}[A`,D=p.split("").map(B=>B.charCodeAt(0)),R=10;function N(B){B.forEach((M,z)=>{if(z===0||M.length<p.length)return;const j=B[z-1],$=M.subarray(0,p.length);if($[0]===D[0]&&$[1]===D[1]&&$[2]===D[2]){const Q=j.lastIndexOf(R);if(Q===-1)return;B[z-1]=j.subarray(0,Q),B[z]=M.subarray(p.length)}})}function V(B){let M=B;do B=M,M=B.replace(/[^\n]\x08/gm,"");while(M.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const M=B.match(/^(.*)\r+/m)[1];let z=B.match(/\r+(.*)$/m)[1];z=z+M.slice(z.length,M.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return B}const L="\b".charCodeAt(0),U="\r".charCodeAt(0);function F(B){return!B.buffer.includes(L)&&!B.buffer.includes(U)?B:c.VSBuffer.fromString(x(V(n.decode(B.buffer))))}}),define(_e[221],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(_e[222],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=c;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function I(y){return Array.from(y.entries()).map(k=>[k[0],c(k[1].map)])}e.serializeEnvironmentVariableCollections=I;function P(y){return new Map(y.map(k=>[k[0],{map:t(k[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(_e[56],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(y,k,S=y.parent){if(y._isRoot)return new I([k]);const C=[y.id];for(let A=S;A&&A.id!==k;A=A.parent)C.push(A.id);return C.push(k),new I(C.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const k=y.indexOf("\0");return k===-1?y:y.slice(0,k)}static fromString(y){return new I(y.split("\0"))}static join(y,k){return new I([...y.path,k])}static joinToString(y,k){return y.toString()+"\0"+k}static parentId(y){const k=y.lastIndexOf("\0");return k===-1?void 0:y.slice(0,k)}static compare(y,k){return y===k?0:k.startsWith(y+"\0")?2:y.startsWith(k+"\0")?3:1}constructor(y,k=y.length){if(this.path=y,this.viewEnd=k,y.length===0||k<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new I(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new I(this.path,y)}compare(y){if(typeof y=="string")return I.compare(this.toString(),y);for(let k=0;k<y.viewEnd&&k<this.viewEnd;k++)if(y.path[k]!==this.path[k])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=I}),define(_e[67],ye([1,0,2,35,56]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(n){n.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),n.deserialize=i=>({range:t.Range.lift(i.range),uri:c.URI.revive(i.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(n){n.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&k.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&k.deserialize(i.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,i)=>`${i?"s":"e"}${n}`;e.getMarkId=A;var T;(function(n){n.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&k.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&k.deserialize(i.location)})})(T=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=i=>i.type===0?C.serialize(i):T.serialize(i),n.deserialize=i=>i.type===0?C.deserialize(i):T.deserialize(i)})(E=e.ITestMessage||(e.ITestMessage={}));var _;(function(n){n.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),n.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.serialize)}),n.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.deserialize)})})(_=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",h=(n,i)=>n+w+i;e.namespaceTestTag=h;const g=n=>{const i=n.indexOf(w);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=g;var f;(function(n){n.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),n.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?c.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(f=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(n){n.serialize=i=>({expand:i.expand,item:f.serialize(i.item)}),n.deserialize=i=>({controllerId:I.TestId.root(i.item.extId),expand:i.expand,item:f.deserialize(i.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var d;(function(n){n.serialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.uri!==void 0&&(p.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(p.range=i.item.range?.toJSON()),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}},n.deserialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.range!==void 0&&(p.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}}})(d=e.ITestItemUpdate||(e.ITestItemUpdate={}));const v=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=v;var r;(function(n){n.serializeWithoutMessages=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serializeWithoutMessages),retired:i.retired}),n.serialize=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.serialize),retired:i.retired}),n.deserialize=i=>({...m.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(_.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var o;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(n){n.deserialize=i=>i.op===0?{op:i.op,item:m.deserialize(i.item)}:i.op===1?{op:i.op,item:d.deserialize(i.item)}:i.op===2?{op:i.op,uri:c.URI.revive(i.uri),docv:i.docv}:i,n.serialize=i=>i.op===0?{op:i.op,item:m.serialize(i.item)}:i.op===1?{op:i.op,item:d.serialize(i.item)}:i})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=a;class u{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const D of i)switch(D.op){case 0:{const R=m.deserialize(D.item),N=I.TestId.parentId(R.item.extId)?.toString();if(N){if(this.items.has(N)){const V=this.items.get(N);V.children.add(R.item.extId);const x=this.createItem(R,V);this.items.set(R.item.extId,x),p.add(x)}}else{const V=this.createItem(R);this.roots.add(V),this.items.set(R.item.extId,V),p.add(V)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=d.deserialize(D.item),N=this.items.get(R.extId);if(!N)break;R.expand!==void 0&&(N.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(N,R),p.update(N);break}case 3:{const R=this.items.get(D.itemId);if(!R)break;const N=I.TestId.parentId(R.item.extId)?.toString();N?this.items.get(N).children.delete(R.item.extId):this.roots.delete(R);const V=[[D.itemId]];for(;V.length;)for(const x of V.pop()){const L=this.items.get(x);L&&(V.push(L.children),this.items.delete(x),p.remove(L,L!==R),L.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(D.itemId);break;case 4:this.updatePendingRoots(D.amount);break;case 6:this._tags.set(D.tag.id,D.tag);break;case 7:this._tags.delete(D.id);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=u}),define(_e[92],ye([1,0,18,4,6,48,67,56]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(f,b)=>f===b,A={range:(f,b)=>f===b?!0:!f||!b?!1:f.equalsRange(b),busy:C,label:C,description:C,error:C,tags:(f,b)=>!(f.length!==b.length||f.some(m=>!b.includes(m)))},T=(f,b)=>{let m;for(const[d,v]of Object.entries(A))v(f[d],b[d])||(m?m[d]=b[d]:m={[d]:b[d]});return m};class E extends I.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const m of this.diff)if(m.op===2&&m.uri===b.uri){m.docv=b.docv;return}break}case 1:{const m=this.diff[this.diff.length-1];if(m){if(m.op===1&&m.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(m.item,b.item);return}if(m.op===0&&m.item.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(m.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,m){const d=this.tree.get(b);if(!!d){if((d.expandLevels===void 0||m>d.expandLevels)&&(d.expandLevels=m),d.expand===1){const v=this.resolveChildren(d);return v.isOpen()?this.expandChildren(d,m-1):v.wait().then(()=>this.expandChildren(d,m-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,m-1)):this.expandChildren(d,m-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,m){switch(m.op){case 3:this.removeItem(k.TestId.joinToString(b.fullId,m.id));break;case 0:this.upsertItem(m.item,b);break;case 5:for(const d of m.ops)this.onTestItemEvent(b,d);break;case 1:this.diffTagRefs(m.new,m.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:m.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,P.assertNever)(m)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,m){const d=k.TestId.fromExtHostTestItem(b,this.root.id,m?.actual),v=this.options.getApiFor(b);v.parent&&v.parent!==m?.actual&&this.options.getChildren(v.parent).delete(b.id);let r=this.tree.get(d.toString());if(!r){r={fullId:d,actual:b,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(b,m),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,r,m);return}if(r.actual===b){this.connectItem(b,r,m);return}const o=this.options.getChildren(r.actual),l=r.actual,s=T(this.options.toITestItem(l),this.options.toITestItem(b));this.options.getApiFor(l).listener=void 0,r.actual=b,r.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,l.tags,d.toString()),delete s.tags),this.onTestItemEvent(r,{op:4,update:s})),this.connectItemAndChildren(b,r,m);for(const[a,u]of o)this.options.getChildren(b).get(u.id)||this.removeItem(k.TestId.joinToString(d,u.id));this.documentSynced(r.actual.uri)}diffTagRefs(b,m,d){const v=new Set(m.map(r=>r.id));for(const r of b)v.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:d,item:{tags:b.map(r=>(0,y.namespaceTestTag)(this.options.controllerId,r.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const m=this.tags.get(b.id);m?m.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const m=this.tags.get(b);m&&!--m.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,m){this.options.getApiFor(b).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(b,m,d){this.setItemParent(b,d);const v=this.options.getApiFor(b);v.parent=d?.actual,v.listener=r=>this.onTestItemEvent(m,r),this.updateExpandability(m)}connectItemAndChildren(b,m,d){this.connectItem(b,m,d);for(const[v,r]of this.options.getChildren(b))this.upsertItem(r,m)}updateExpandability(b){let m;this._resolveHandler?b.resolveBarrier?m=b.resolveBarrier.isOpen()?3:2:m=b.actual.canResolveChildren?1:0:m=0,m!==b.expand&&(b.expand=m,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:m}}),m===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,m){if(m<0)return;const d=[];for(const[v,r]of this.options.getChildren(b.actual)){const o=this.expand(k.TestId.joinToString(b.fullId,r.id),m);(0,c.isThenable)(o)&&d.push(o)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const r=new c.Barrier;return r.open(),r}b.expand=2,this.pushExpandStateUpdate(b);const m=b.resolveBarrier=new c.Barrier,d=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let v;try{v=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(r){d(r)}return(0,c.isThenable)(v)?v.catch(d).then(()=>{m.open(),this.updateExpandability(b)}):(m.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const m=this.tree.get(b);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const d=[m];for(;d.length;){const v=d.pop();if(!!v){this.options.getApiFor(v.actual).listener=void 0;for(const r of v.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(v.fullId.toString());for(const[r,o]of this.options.getChildren(v.actual))d.push(this.tree.get(k.TestId.joinToString(v.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=E;class _ extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=_;class w extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class h extends Error{constructor(b,m,d){super(`TestItem with ID "${b}" is from controller "${m}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=h;const g=(f,b,m)=>{let d=new Map;return{get size(){return d.size},forEach(v,r){for(const o of d.values())v.call(r,o,this)},[Symbol.iterator](){return d.entries()},replace(v){const r=new Map,o=new Set(d.keys()),l={op:5,ops:[]};for(const s of v){if(!(s instanceof m))throw new w(s.id);const a=b(s).controllerId;if(a!==f.controllerId)throw new h(s.id,a,f.controllerId);if(r.has(s.id))throw new _(s.id);r.set(s.id,s),o.delete(s.id),l.ops.push({op:0,item:s})}for(const s of o.keys())l.ops.push({op:3,id:s});f.listener?.(l),d=r},add(v){if(!(v instanceof m))throw new w(v.id);d.set(v.id,v),f.listener?.({op:0,item:v})},delete(v){d.delete(v)&&f.listener?.({op:3,id:v})},get(v){return d.get(v)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=g}),define(_e[131],ye([1,0,92]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(y,k)=>{const S={controllerId:k};return t.set(y,S),S};e.createPrivateApiFor=I;const P=y=>{const k=t.get(y);if(!k)throw new c.InvalidTestItemError(y?.id||"<unknown>");return k};e.getPrivateApiFor=P}),define(_e[223],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(y,k){super(k),this.variable=y}}e.VariableError=I}),define(_e[224],ye([1,0,9,36,11,24,12,111,187,223,8]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(_,w,h,g){this._contributedVariables=new Map,this._context=_,this._labelService=w,this._userHomePromise=h,g&&(this._envVariablesPromise=g.then(f=>this.prepareEnv(f)))}prepareEnv(_){if(y.isWindows){const w=Object.create(null);return Object.keys(_).forEach(h=>{w[h.toLowerCase()]=_[h]}),w}return _}resolveWithEnvironment(_,w,h){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(_,w){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,_?_.uri:void 0,w)}async resolveAnyBase(_,w,h,g){const f=P.deepClone(w);y.isWindows&&f.windows?Object.keys(f.windows).forEach(m=>f[m]=f.windows[m]):y.isMacintosh&&f.osx?Object.keys(f.osx).forEach(m=>f[m]=f.osx[m]):y.isLinux&&f.linux&&Object.keys(f.linux).forEach(m=>f[m]=f.linux[m]),delete f.windows,delete f.osx,delete f.linux;const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,_?_.uri:void 0,f,h,g)}async resolveAnyAsync(_,w,h){return this.resolveAnyBase(_,w,h)}async resolveAnyMap(_,w,h){const g=new Map;return{newConfig:await this.resolveAnyBase(_,w,h,g),resolvedVariables:g}}resolveWithInteractionReplace(_,w,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,w,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,w){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,w)}async recursiveResolve(_,w,h,g,f){if(I.isString(h))return this.resolveString(_,w,h,g,f);if(Array.isArray(h))return Promise.all(h.map(b=>this.recursiveResolve(_,w,b,g,f)));if(I.isObject(h)){const b=Object.create(null),m=await Promise.all(Object.keys(h).map(async d=>[await this.resolveString(_,w,d,g,f),await this.recursiveResolve(_,w,h[d],g,f)]));for(const[d,v]of m)b[d]=v;return b}return h}resolveString(_,w,h,g,f){return(0,A.replaceAsync)(h,T.VARIABLE_REGEXP,async(b,m)=>{if(m.includes(T.VARIABLE_LHS))return b;let d=await this.evaluateSingleVariable(_,b,m,w,g);return f?.set(m,d),d!==b&&I.isString(d)&&d.match(T.VARIABLE_REGEXP)&&(d=await this.resolveString(_,w,d,g,f)),d})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,w,h,g,f){let b;const m=h.split(":");m.length>1&&(h=m[0],b=m[1]);const d=o=>{const l=this._context.getFilePath();if(l)return l;throw new C.VariableError(o,(0,S.localize)(0,null,w))},v=o=>{const l=d(o);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new C.VariableError(o,(0,S.localize)(1,null,w,c.basename(l)))},r=o=>{if(b){const l=this._context.getFolderUri(b);if(l)return l;throw new C.VariableError(o,(0,S.localize)(2,null,w,b))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new C.VariableError(o,(0,S.localize)(3,null,w)):new C.VariableError(o,(0,S.localize)(4,null,w))};switch(h){case"env":if(b){if(_.env){const o=_.env[y.isWindows?b.toLowerCase():b];if(I.isString(o))return o}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,w));case"config":if(b){const o=this._context.getConfigurationValue(g,b);if(I.isUndefinedOrNull(o))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,w,b));if(I.isObject(o))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,w,b));return o}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,w));case"command":return this.resolveFromMap(C.VariableKind.Command,w,b,f,"command");case"input":return this.resolveFromMap(C.VariableKind.Input,w,b,f,"input");case"extensionInstallFolder":if(b){const o=await this._context.getExtension(b);if(!o)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,w,b));return this.fsPath(o.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r(C.VariableKind.WorkspaceFolder)));case"cwd":return g||b?(0,k.normalizeDriveLetter)(this.fsPath(r(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(r(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(_.userHome)return _.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,w))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,w))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,w))}case"file":return d(C.VariableKind.File);case"fileWorkspaceFolder":return v(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||b?c.relative(this.fsPath(r(C.VariableKind.RelativeFile)),d(C.VariableKind.RelativeFile)):d(C.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(d(C.VariableKind.RelativeFileDirname));if(g||b){const l=c.relative(this.fsPath(r(C.VariableKind.RelativeFileDirname)),o);return l.length===0?".":l}return o}case"fileDirname":return c.dirname(d(C.VariableKind.FileDirname));case"fileExtname":return c.extname(d(C.VariableKind.FileExtname));case"fileBasename":return c.basename(d(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(d(C.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(d(C.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||w}case"execInstallFolder":{const o=this._context.getAppRoot();return o||w}case"pathSeparator":return c.sep;default:try{const o=b?`${h}:${b}`:h;return this.resolveFromMap(C.VariableKind.Unknown,w,o,f,void 0)}catch{return w}}}}resolveFromMap(_,w,h,g,f){if(h&&g){const b=f===void 0?g[h]:g[f+":"+h];if(typeof b=="string")return b;throw new C.VariableError(_,(0,S.localize)(14,null,w))}return w}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(_e[132],ye([1,0,3,129]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(w){const h=w;return(0,t.isEditorInput)(h?.editor)&&(0,t.isEditorInput)(h?.replacement)}e.isEditorReplacement=C;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function E(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=E;function _(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(_e[225],ye([1,0,3,132]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=I}),define(_e[226],ye([1,0,3,192]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(_e[227],ye([1,0,26,4,9]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=P;class y{constructor(T){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let E of T.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(T)}}set(T){this._extensionDescriptions=T,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,E){this._extensionDescriptions=C(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(T);const _=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=C(this._extensionDescriptions,_.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(_)}static _findLoopingExtensions(T){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,b){this.addNode(f),this.addNode(b),this._arcs.has(f)?this._arcs.get(f).push(b):this._arcs.set(f,[b])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,b){const m=E.getArcs(f);for(let d=0;d<m.length;d++)if(!b.has(m[d]))return!1;return!0}getNodes(){return this._nodesArr}},_=new Map;for(const f of T){const b=c.ExtensionIdentifier.toKey(f.identifier);if(_.set(b,f),f.extensionDependencies)for(const m of f.extensionDependencies){const d=c.ExtensionIdentifier.toKey(m);E.addArc(b,d)}}const w=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>w.add(f));const h=E.getNodes().filter(f=>!w.has(f));let g;do{g=!1;for(let f=0;f<h.length;f++){const b=h[f];E.hasOnlyGoodArcs(b,w)&&(h.splice(f,1),f--,w.add(b),g=!0)}}while(g);return h.map(f=>_.get(f))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const E=this._activationMap.get(T);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const E=this._extensionsMap.get(c.ExtensionIdentifier.toKey(T));return E||void 0}getExtensionDescriptionByUUID(T){for(const E of this._extensionsArr)if(E.uuid===T)return E}getExtensionDescriptionByIdOrUUID(T,E){return this.getExtensionDescription(T)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=y;var k;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(k||(k={}));function S(A,T){const E=A.isBuiltin?0:A.isUnderDevelopment?2:1,_=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(E!==_)return E-_;const w=I.posix.basename(A.extensionLocation.path),h=I.posix.basename(T.extensionLocation.path);return w<h?-1:w>h?1:0}function C(A,T){const E=new Set;return T.forEach(_=>E.add(c.ExtensionIdentifier.toKey(_))),A.filter(_=>!E.has(c.ExtensionIdentifier.toKey(_.identifier)))}}),define(_e[228],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(T){T[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(T){T[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(A){delete A[t.ENV_KEY],delete A[I.ENV_KEY],delete A[P.ENV_KEY]}function k(A,T){y(T),A.serialize(T)}e.writeExtHostConnection=k;function S(A){if(A[t.ENV_KEY])return C(A,new t(A[t.ENV_KEY]));if(A[I.ENV_KEY])return C(A,new I);if(A[P.ENV_KEY])return C(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(A,T){return y(A),T}}),define(_e[93],ye([1,0,23]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(C){const A=c.VSBuffer.alloc(1);switch(C){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=y;function k(C,A){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=k;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(_e[94],ye([1,0,3,4,13,25,93,87,205,24,2]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=class{constructor(h,g){this.initData=h,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this._outputLogger=g.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(h,g){const f=this.getTelemetryDetails(),b=new E(g,h,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(h),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(h.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(h,g,f){this._level=h,this._inLoggingOnlyMode=g,this._productConfig=f??{usage:!0,error:!0}}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=h.name,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=_(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:g["common.uikind"]="web";break;case y.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,k.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(h){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=h;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(h,g){const f=this._telemetryLoggers.get(h.value);return f?(f.logError(g),!0):!1}};T=je([He(0,P.IExtHostInitDataService),He(1,I.ILoggerService)],T),e.ExtHostTelemetry=T;class E{constructor(h,g,f,b,m,d){this._extension=g,this._logger=f,this._inLoggingOnlyMode=b,this._commonProperties=m,this._onDidChangeEnableStates=new t.Emitter,this._appender=h,this._telemetryEnablements={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(h,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:h,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(h){let g=h.properties??h;return g=(0,S.cleanData)(g,[]),this._appender.additionalCommonProperties&&(g=(0,C.mixin)(g,this._appender.additionalCommonProperties)),this._appender.ignoreBuiltInCommonProperties||(g=(0,C.mixin)(g,this._commonProperties)),h.properties?h.properties=g:h=g,h}logEvent(h,g){this._extension.publisher==="vscode"?h=this._extension.name+"/"+h:h=this._extension.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this._inLoggingOnlyMode||this._appender.logEvent(h,g),this._logger.trace(h,g)}logUsage(h,g){!this._telemetryEnablements.isUsageEnabled||this.logEvent(h,g)}logError(h,g){!this._telemetryEnablements.isErrorsEnabled||(typeof h=="string"?this.logEvent(h,g):this._appender.logException(h,g))}get apiTelemetryLogger(){if(!this._apiObject){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return h._telemetryEnablements.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h._onDidChangeEnableStates.event.bind(h)};this._apiObject=Object.freeze(g)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function _(w){const h=Date.now()-new Date(w).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(_e[27],ye([1,0,4,2,3,26,201]),function(Z,e,c,t,I,P,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class A{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class T{constructor(u){this.dependency=u}}e.MissingExtensionDependency=T;var E;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=_;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(u,n){const i=[],p=[],D=[],R=[],N=f(this._allExtensions),V=f(u),x=(B,M)=>B.extensionLocation.toString()===M.extensionLocation.toString()||B.isBuiltin===M.isBuiltin||B.isUserBuiltin===M.isUserBuiltin||B.isUnderDevelopment===M.isUnderDevelopment;for(const B of this._allExtensions){const M=V.get(P.ExtensionIdentifier.toKey(B.identifier));if(!M){i.push(B.identifier),N.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}if(!x(B,M)){i.push(B.identifier),N.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of u){const M=N.get(P.ExtensionIdentifier.toKey(B.identifier));if(!M){p.push(B);continue}if(!x(M,B)){i.push(M.identifier),N.delete(P.ExtensionIdentifier.toKey(M.identifier));continue}}const L=g(this._myExtensions),U=g(n);for(const B of this._myExtensions)U.has(P.ExtensionIdentifier.toKey(B))||D.push(B);for(const B of n)L.has(P.ExtensionIdentifier.toKey(B))||R.push(B);const F={toRemove:i,toAdd:p,myToRemove:D,myToAdd:R};return this.delta(F),F}delta(u){const{toRemove:n,toAdd:i,myToRemove:p,myToAdd:D}=u,R=g(n),N=g(p);for(let V=0;V<this._allExtensions.length;V++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[V].identifier))&&(this._allExtensions.splice(V,1),V--);for(let V=0;V<this._myExtensions.length;V++)N.has(P.ExtensionIdentifier.toKey(this._myExtensions[V]))&&(this._myExtensions.splice(V,1),V--);for(const V of i)this._allExtensions.push(V);for(const V of D)this._myExtensions.push(V)}containsExtension(u){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=w;class h{constructor(u){if(this[k]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this._map.size}add(u){return this._map.set(this._toKey(u),u),this}clear(){this._map.clear()}delete(u){return this._map.delete(this._toKey(u))}has(u){return this._map.has(this._toKey(u))}forEach(u,n){this._map.forEach(i=>u.call(n,i,i,this))}*entries(){for(const[u,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function g(a){const u=new Set;for(const n of a)u.add(P.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=g;function f(a){const u=new Map;for(const n of a)u.set(P.ExtensionIdentifier.toKey(n.identifier),n);return u}function b(a,u){return a.enabledApiProposals?a.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=b;function m(a,u){if(!b(a,u))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=m;class d{constructor(u,n,i,p){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=p}}e.ActivationTimes=d;class v{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function o(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function l(a,u){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!u,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=l;class s{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,n){return Promise.resolve()}}e.NullExtensionService=s}),define(_e[229],ye([1,0,10,26,27,13,18]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class k{constructor(g,f,b,m){this.startup=g,this.codeLoadingTime=f,this.activateCallTime=b,this.activateResolvedTime=m}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,f){return g===-1||f===-1?-1:f-g}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(g,f,b,m,d,v){this.activationFailed=g,this.activationFailedError=f,this.activationTimes=b,this.module=m,this.exports=d,this.subscriptions=v}}e.ActivatedExtension=C;class A extends C{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class T extends C{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class E extends C{constructor(g){super(!0,g,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let _=class{constructor(g,f,b,m,d){this._logService=d,this._registry=g,this._resolvedExtensionsSet=new Set,f.forEach(v=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(v))),this._externalExtensionsMap=new Map,b.forEach(v=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(v),v)),this._host=m,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[g,f]of this._operations)f.dispose()}isActivated(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));return Boolean(f&&f.value)}getActivatedExtension(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));if(!f||!f.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return f.value}async activateByEvent(g,f){if(this._alreadyActivatedEvents[g])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(g);await this._activateExtensions(b.map(m=>({id:m.identifier,reason:{startup:f,extensionId:m.identifier,activationEvent:g}}))),this._alreadyActivatedEvents[g]=!0}activateById(g,f){const b=this._registry.getExtensionDescription(g);if(!b)throw new Error(`Extension '${g}' is not known`);return this._activateExtensions([{id:b.identifier,reason:f}])}async _activateExtensions(g){const f=g.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(f.map(b=>b.wait()))}_handleActivationRequest(g){if(this._operations.has(t.ExtensionIdentifier.toKey(g.id)))return this._operations.get(t.ExtensionIdentifier.toKey(g.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id)))return this._createAndSaveOperation(g,null,[],null);const f=this._registry.getExtensionDescription(g.id);if(!f){const d=new Error(`Cannot activate unknown extension '${g.id.value}'`),v=this._createAndSaveOperation(g,null,[],new E(d));return this._host.onExtensionActivationError(g.id,d,new I.MissingExtensionDependency(g.id.value)),v}const b=[],m=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const d of m){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(d)))continue;const v=this._operations.get(t.ExtensionIdentifier.toKey(d));if(v){b.push(v);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(d))){b.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(d)),reason:g.reason}));continue}const r=this._registry.getExtensionDescription(d);if(r){if(!r.main&&!r.browser)continue;b.push(this._handleActivationRequest({id:r.identifier,reason:g.reason}));continue}const o=f.displayName||f.identifier.value,l=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${d}'`),s=this._createAndSaveOperation(g,f.displayName,[],new E(l));return this._host.onExtensionActivationError(f.identifier,l,new I.MissingExtensionDependency(d)),s}return this._createAndSaveOperation(g,f.displayName,b,null)}_createAndSaveOperation(g,f,b,m){const d=new w(g.id,f,g.reason,b,m,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(g.id),d),d}};_=je([He(4,P.ILogService)],_),e.ExtensionsActivator=_;let w=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(g,f,b,m,d,v,r){this._id=g,this._displayName=f,this._reason=b,this._deps=m,this._value=d,this._host=v,this._logService=r,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let g=0;g<this._deps.length;g++){const f=this._deps[g];if(f.value&&!f.value.activationFailed){this._deps.splice(g,1),g--;continue}if(f.value&&f.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);b.detail=f.value.activationFailedError,this._value=new E(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(g=>g.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(g){const f=new Error;if(g&&g.name&&(f.name=g.name),g&&g.message?f.message=`Activating extension '${this._id.value}' failed: ${g.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${g}.`,g&&g.stack&&(f.stack=g.stack),this._value=new E(f),this._isDisposed&&c.isCancellationError(g))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(g)}}};w=je([He(6,P.ILogService)],w)}),define(_e[230],ye([1,0,13,25,27]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};P=je([He(0,c.ILoggerService),He(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[7],ye([1,0,17,10,110,28,81,8,11,2,30,38,127,91,27]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w){"use strict";var h,g,f,b,m,d,v,r,o,l,s,a,u,n,i,p,D,R,N,V,x,L,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(G){return Object.assign(G,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(G,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[he,...Ie]=arguments;return Reflect.construct(G,Ie,he.constructor)}}})}let B=d=class{static from(...H){let he=H;return new d(function(){if(he){for(const Ie of he)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();he=void 0}})}constructor(H){h.set(this,void 0),tt(this,h,H,"f")}dispose(){typeof Ne(this,h,"f")=="function"&&(Ne(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,B=d=je([F],B),e.Disposable=B;let M=v=class{static Min(...H){if(H.length===0)throw new TypeError;let he=H[0];for(let Ie=1;Ie<H.length;Ie++){const Ke=H[Ie];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...H){if(H.length===0)throw new TypeError;let he=H[0];for(let Ie=1;Ie<H.length;Ie++){const Ke=H[Ie];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(H){if(!H)return!1;if(H instanceof v)return!0;const{line:he,character:Ie}=H;return typeof he=="number"&&typeof Ie=="number"}static of(H){if(H instanceof v)return H;if(this.isPosition(H))return new v(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(H,he){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=he}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,he=0){if(H===null||he===null)throw(0,t.illegalArgument)();let Ie;return typeof H>"u"?Ie=0:typeof H=="number"?Ie=H:(Ie=typeof H.lineDelta=="number"?H.lineDelta:0,he=typeof H.characterDelta=="number"?H.characterDelta:0),Ie===0&&he===0?this:new v(this.line+Ie,this.character+he)}with(H,he=this.character){if(H===null||he===null)throw(0,t.illegalArgument)();let Ie;return typeof H>"u"?Ie=this.line:typeof H=="number"?Ie=H:(Ie=typeof H.line=="number"?H.line:this.line,he=typeof H.character=="number"?H.character:this.character),Ie===this.line&&he===this.character?this:new v(Ie,he)}toJSON(){return{line:this.line,character:this.character}}};M=v=je([F],M),e.Position=M;let z=r=class{static isRange(H){return H instanceof r?!0:H?M.isPosition(H.start)&&M.isPosition(H.end):!1}static of(H){if(H instanceof r)return H;if(this.isRange(H))return new r(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(H,he,Ie,Ke){let et,ct;if(typeof H=="number"&&typeof he=="number"&&typeof Ie=="number"&&typeof Ke=="number"?(et=new M(H,he),ct=new M(Ie,Ke)):M.isPosition(H)&&M.isPosition(he)&&(et=M.of(H),ct=M.of(he)),!et||!ct)throw new Error("Invalid arguments");et.isBefore(ct)?(this._start=et,this._end=ct):(this._start=ct,this._end=et)}contains(H){return r.isRange(H)?this.contains(H.start)&&this.contains(H.end):M.isPosition(H)?!(M.of(H).isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const he=M.Max(H.start,this._start),Ie=M.Min(H.end,this._end);if(!he.isAfter(Ie))return new r(he,Ie)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const he=M.Min(H.start,this._start),Ie=M.Max(H.end,this.end);return new r(he,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,he=this.end){if(H===null||he===null)throw(0,t.illegalArgument)();let Ie;return H?M.isPosition(H)?Ie=H:(Ie=H.start||this.start,he=H.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&he.isEqual(this.end)?this:new r(Ie,he)}toJSON(){return[this.start,this.end]}};z=r=je([F],z),e.Range=z;let j=o=class extends z{static isSelection(H){return H instanceof o?!0:H?z.isRange(H)&&M.isPosition(H.anchor)&&M.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(H,he,Ie,Ke){let et,ct;if(typeof H=="number"&&typeof he=="number"&&typeof Ie=="number"&&typeof Ke=="number"?(et=new M(H,he),ct=new M(Ie,Ke)):M.isPosition(H)&&M.isPosition(he)&&(et=M.of(H),ct=M.of(he)),!et||!ct)throw new Error("Invalid arguments");super(et,ct),this._anchor=et,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};j=o=je([F],j),e.Selection=j;class ${constructor(H,he,Ie){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Ie<"u"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(he),this.connectionToken=Ie}}e.ResolvedAuthority=$;class Q extends Error{static NotAvailable(H,he){return new Q(H,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(H){return new Q(H,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,he=E.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(H),this._message=H,this._code=he,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var ue;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(ue=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let re=l=class{static isTextEdit(H){return H instanceof l?!0:H?z.isRange(H)&&typeof H.newText=="string":!1}static replace(H,he){return new l(H,he)}static insert(H,he){return l.replace(new z(H,H),he)}static delete(H){return l.replace(H,"")}static setEndOfLine(H){const he=new l(new z(new M(0,0),new M(0,0)),"");return he.newEol=H,he}get range(){return this._range}set range(H){if(H&&!z.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}constructor(H,he){this._range=H,this._newText=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};re=l=je([F],re),e.TextEdit=re;let de=s=class{static isNotebookCellEdit(H){return H instanceof s?!0:H?jt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,he){return new s(H,he)}static insertCells(H,he){return new s(new jt(H,H),he)}static deleteCells(H){return new s(H,[])}static updateCellMetadata(H,he){const Ie=new s(new jt(H,H),[]);return Ie.newCellMetadata=he,Ie}static updateNotebookMetadata(H){const he=new s(new jt(0,0),[]);return he.newNotebookMetadata=H,he}constructor(H,he){this.range=H,this.newCells=he}};de=s=je([F],de),e.NotebookEdit=de;class Y{static isSnippetTextEdit(H){return H instanceof Y?!0:H?z.isRange(H.range)&&Ce.isSnippetString(H.snippet):!1}static replace(H,he){return new Y(H,he)}static insert(H,he){return Y.replace(new z(H,H),he)}constructor(H,he){this.range=H,this.snippet=he}}e.SnippetTextEdit=Y;var pe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,he,Ie,Ke){this._edits.push({_type:1,from:H,to:he,options:Ie,metadata:Ke})}createFile(H,he,Ie){this._edits.push({_type:1,from:void 0,to:H,options:he,metadata:Ie})}deleteFile(H,he,Ie){this._edits.push({_type:1,from:H,to:void 0,options:he,metadata:Ie})}replaceNotebookMetadata(H,he,Ie){this._edits.push({_type:3,metadata:Ie,uri:H,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells(H,he,Ie,Ke){const et=he.start,ct=he.end;(et!==ct||Ie.length>0)&&this._edits.push({_type:5,uri:H,index:et,count:ct-et,cells:Ie,metadata:Ke})}replaceNotebookCellMetadata(H,he,Ie,Ke){this._edits.push({_type:3,metadata:Ke,uri:H,edit:{editType:8,index:he,metadata:Ie}})}replace(H,he,Ie,Ke){this._edits.push({_type:2,uri:H,edit:new re(he,Ie),metadata:Ke})}insert(H,he,Ie,Ke){this.replace(H,new z(he,he),Ie,Ke)}delete(H,he,Ie){this.replace(H,he,"",Ie)}has(H){return this._edits.some(he=>he._type===2&&he.uri.toString()===H.toString())}set(H,he){if(he)for(const Ie of he){if(!Ie)continue;let Ke,et;Array.isArray(Ie)?(Ke=Ie[0],et=Ie[1]):Ke=Ie,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(H,Ke.range.start,Ke.newCellMetadata,et):Ke.newNotebookMetadata?this.replaceNotebookMetadata(H,Ke.newNotebookMetadata,et):this.replaceNotebookCells(H,Ke.range,Ke.newCells,et):Y.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:H,range:Ke.range,edit:Ke.snippet,metadata:et}):this._edits.push({_type:2,uri:H,edit:Ke,metadata:et})}else{for(let Ie=0;Ie<this._edits.length;Ie++){const Ke=this._edits[Ie];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===H.toString()&&(this._edits[Ie]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get(H){const he=[];for(const Ie of this._edits)Ie._type===2&&Ie.uri.toString()===H.toString()&&he.push(Ie.edit);return he}entries(){const H=new P.ResourceMap;for(const he of this._edits)if(he._type===2){let Ie=H.get(he.uri);Ie||(Ie=[he.uri,[]],H.set(he.uri,Ie)),Ie[1].push(he.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([F],be),e.WorkspaceEdit=be;let Ce=a=class{static isSnippetString(H){return H instanceof a?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this._tabstop=1,this.value=H||""}appendText(H){return this.value+=a._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,he=this._tabstop++){if(typeof H=="function"){const Ie=new a;Ie._tabstop=this._tabstop,H(Ie),this._tabstop=Ie._tabstop,H=Ie.value}else H=a._escape(H);return this.value+="${",this.value+=he,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,he=this._tabstop++){const Ie=H.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(H,he){if(typeof he=="function"){const Ie=new a;Ie._tabstop=this._tabstop,he(Ie),this._tabstop=Ie._tabstop,he=Ie.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Ce=a=je([F],Ce),e.SnippetString=Ce;var Re;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var We;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(We=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ne=u=class{static isLocation(H){return H instanceof u?!0:H?z.isRange(H.range)&&C.URI.isUri(H.uri):!1}constructor(H,he){if(this.uri=H,he)if(z.isRange(he))this.range=z.of(he);else if(M.isPosition(he))this.range=new z(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ne=u=je([F],ne),e.Location=ne;let ce=class{static is(H){return H?typeof H.message=="string"&&H.location&&z.isRange(H.location.range)&&C.URI.isUri(H.location.uri):!1}constructor(H,he){this.location=H,this.message=he}static isEqual(H,he){return H===he?!0:!H||!he?!1:H.message===he.message&&H.location.range.isEqual(he.location.range)&&H.location.uri.toString()===he.location.uri.toString()}};ce=je([F],ce),e.DiagnosticRelatedInformation=ce;let fe=class{constructor(H,he,Ie=We.Error){if(!z.isRange(H))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=H,this.message=he,this.severity=Ie}toJSON(){return{severity:We[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,he){return H===he?!0:!H||!he?!1:H.message===he.message&&H.severity===he.severity&&H.code===he.code&&H.severity===he.severity&&H.source===he.source&&H.range.isEqual(he.range)&&(0,c.equals)(H.tags,he.tags)&&(0,c.equals)(H.relatedInformation,he.relatedInformation,ce.isEqual)}};fe=je([F],fe),e.Diagnostic=fe;let J=class{constructor(H,he){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=he}};J=je([F],J),e.Hover=J;var ie;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let te=class{constructor(H,he=ie.Text){this.range=H,this.kind=he}toJSON(){return{range:this.range,kind:ie[this.kind]}}};te=je([F],te),e.DocumentHighlight=te;var O;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(O=e.SymbolKind||(e.SymbolKind={}));var W;(function(G){G[G.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let q=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,he,Ie,Ke,et){this.name=H,this.kind=he,this.containerName=et,typeof Ie=="string"&&(this.containerName=Ie),Ke instanceof ne?this.location=Ke:Ie instanceof z&&(this.location=new ne(Ke,Ie)),n.validate(this)}toJSON(){return{name:this.name,kind:O[this.kind],location:this.location,containerName:this.containerName}}};q=n=je([F],q),e.SymbolInformation=q;let X=i=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(i.validate)}constructor(H,he,Ie,Ke,et){this.name=H,this.detail=he,this.kind=Ie,this.range=Ke,this.selectionRange=et,this.children=[],i.validate(this)}};X=i=je([F],X),e.DocumentSymbol=X;var ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor(H,he){this.title=H,this.kind=he}};ve=je([F],ve),e.CodeAction=ve;let Te=p=class{constructor(H){this.value=H}append(H){return new p(this.value?this.value+p.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+p.sep)}};Te.sep=".",Te=p=je([F],Te),e.CodeActionKind=Te,Te.Empty=new Te(""),Te.QuickFix=Te.Empty.append("quickfix"),Te.Refactor=Te.Empty.append("refactor"),Te.RefactorExtract=Te.Refactor.append("extract"),Te.RefactorInline=Te.Refactor.append("inline"),Te.RefactorMove=Te.Refactor.append("move"),Te.RefactorRewrite=Te.Refactor.append("rewrite"),Te.Source=Te.Empty.append("source"),Te.SourceOrganizeImports=Te.Source.append("organizeImports"),Te.SourceFixAll=Te.Source.append("fixAll");let ge=class{constructor(H,he){if(this.range=H,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ge=je([F],ge),e.SelectionRange=ge;class ke{constructor(H,he,Ie,Ke,et,ct){this.kind=H,this.name=he,this.detail=Ie,this.uri=Ke,this.range=et,this.selectionRange=ct}}e.CallHierarchyItem=ke;class De{constructor(H,he){this.fromRanges=he,this.from=H}}e.CallHierarchyIncomingCall=De;class xe{constructor(H,he){this.fromRanges=he,this.to=H}}e.CallHierarchyOutgoingCall=xe;var qe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(H,he){this.range=H,this.command=he}get isResolved(){return!!this.command}};nt=je([F],nt),e.CodeLens=nt;let Xe=D=class{static isMarkdownString(H){return H instanceof D?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,he=!1){g.set(this,void 0),tt(this,g,new I.MarkdownString(H,{supportThemeIcons:he}),"f")}get value(){return Ne(this,g,"f").value}set value(H){Ne(this,g,"f").value=H}get isTrusted(){return Ne(this,g,"f").isTrusted}set isTrusted(H){Ne(this,g,"f").isTrusted=H}get supportThemeIcons(){return Ne(this,g,"f").supportThemeIcons}set supportThemeIcons(H){Ne(this,g,"f").supportThemeIcons=H}get supportHtml(){return Ne(this,g,"f").supportHtml}set supportHtml(H){Ne(this,g,"f").supportHtml=H}get baseUri(){return Ne(this,g,"f").baseUri}set baseUri(H){Ne(this,g,"f").baseUri=H}appendText(H){return Ne(this,g,"f").appendText(H),this}appendMarkdown(H){return Ne(this,g,"f").appendMarkdown(H),this}appendCodeblock(H,he){return Ne(this,g,"f").appendCodeblock(he??"",H),this}};g=new WeakMap,Xe=D=je([F],Xe),e.MarkdownString=Xe;let st=class{constructor(H,he){this.label=H,this.documentation=he}};st=je([F],st),e.ParameterInformation=st;let Be=class{constructor(H,he){this.label=H,this.documentation=he,this.parameters=[]}};Be=je([F],Be),e.SignatureInformation=Be;let dt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};dt=je([F],dt),e.SignatureHelp=dt;var se;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var oe;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(oe=e.InlayHintKind||(e.InlayHintKind={}));let Se=class{constructor(H){this.value=H}};Se=je([F],Se),e.InlayHintLabelPart=Se;let le=class{constructor(H,he,Ie){this.position=H,this.label=he,this.kind=Ie}};le=je([F],le),e.InlayHint=le;var Pe;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Fe;(function(G){G[G.Deprecated=1]="Deprecated"})(Fe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor(H,he){this.label=H,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=je([F],Ge),e.CompletionItem=Ge;let Je=class{constructor(H=[],he=!1){this.items=H,this.isIncomplete=he}};Je=je([F],Je),e.CompletionList=Je;let it=class{constructor(H,he,Ie){this.insertText=H,this.range=he,this.command=Ie}};it=je([F],it),e.InlineSuggestion=it;let vt=class{constructor(H){this.commands=void 0,this.items=H}};vt=je([F],vt),e.InlineSuggestionList=vt;var rt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(rt=e.ViewColumn||(e.ViewColumn={}));var Ze;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ze=e.StatusBarAlignment||(e.StatusBarAlignment={}));var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(wt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Et;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Tt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Tt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Rt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Rt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(he){switch(he){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor(H,he){if(he&&!C.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!z.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=he}};Lt=je([F],Lt),e.DocumentLink=Lt;let Qe=class{constructor(H,he,Ie,Ke){this.red=H,this.green=he,this.blue=Ie,this.alpha=Ke}};Qe=je([F],Qe),e.Color=Qe;let At=class{constructor(H,he){if(he&&!(he instanceof Qe))throw(0,t.illegalArgument)("color");if(!z.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=he}};At=je([F],At),e.ColorInformation=At;let Mt=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Mt=je([F],Mt),e.ColorPresentation=Mt;var Wt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var It;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(It=e.TerminalExitReason||(e.TerminalExitReason={}));class Ct{constructor(H,he,Ie){if(this.startIndex=H,this.length=he,this.tooltip=Ie,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ct;var Ae;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(H){if(this.options=H,typeof H!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Me;var Ee;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var ee;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(ee=e.TaskPanelKind||(e.TaskPanelKind={}));let Oe=R=class{static from(H){switch(H){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(H,he){if(this.label=he,typeof H!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=H}get id(){return this._id}};Oe.Clean=new R("clean","Clean"),Oe.Build=new R("build","Build"),Oe.Rebuild=new R("rebuild","Rebuild"),Oe.Test=new R("test","Test"),Oe=R=je([F],Oe),e.TaskGroup=Oe;function ze(G){let H="";for(let he=0;he<G.length;he++)H+=G[he].replace(/,/g,",,")+",";return H}let Ye=class{constructor(H,he,Ie){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=Ie):this._options=he)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(const he of this._args)H.push(he);return ze(H)}};Ye=je([F],Ye),e.ProcessExecution=Ye;let Ve=class{constructor(H,he,Ie){if(this._args=[],Array.isArray(he)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=he,this._options=Ie}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=he}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const he of this._args)H.push(typeof he=="string"?he:he.value);return ze(H)}};Ve=je([F],Ve),e.ShellExecution=Ve;var at;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(at=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class Ot{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=Ot;let bt=N=class{constructor(H,he,Ie,Ke,et,ct){this.__deprecated=!1,this._definition=this.definition=H;let ut;typeof he=="string"?(this._name=this.name=he,this._source=this.source=Ie,this.execution=Ke,ut=et,this.__deprecated=!0):he===mt.Global||he===mt.Workspace?(this.target=he,this._name=this.name=Ie,this._source=this.source=Ke,this.execution=et,ut=ct):(this.target=he,this._name=this.name=Ie,this._source=this.source=Ke,this.execution=et,ut=ct),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:N.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ve?this._definition={type:N.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:N.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:N.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const he=this._definition.type;(N.EmptyType===he||N.ProcessType===he||N.ShellType===he||N.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=N=je([F],bt),e.Task=bt;var St;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));var ht;(function(G){function H(he){const Ie=he;return(0,S.isNumber)(Ie.value)?Ie.tooltip&&!(0,S.isString)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}G.isViewBadge=H})(ht=e.ViewBadge||(e.ViewBadge={}));let Nt=V=class{static isTreeItem(H,he){if(H instanceof V)return!0;const Ie=H;if(Ie.label!==void 0&&!(0,S.isString)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,S.isString)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,S.isString)(Ie.iconPath)&&!C.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,S.isString)(Ie.iconPath.id))){const Ke=Ie.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}if(Ie.description!==void 0&&!(0,S.isString)(Ie.description)&&typeof Ie.description!="boolean")return console.log("INVALID tree item, invalid description",Ie.description),!1;if(Ie.resourceUri!==void 0&&!C.URI.isUri(Ie.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1;if(Ie.tooltip!==void 0&&!(0,S.isString)(Ie.tooltip)&&!(Ie.tooltip instanceof Xe))return console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1;if(Ie.command!==void 0&&!Ie.command.command)return console.log("INVALID tree item, invalid command",Ie.command),!1;if(Ie.collapsibleState!==void 0&&Ie.collapsibleState<Gt.None&&Ie.collapsibleState>Gt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1;if(Ie.contextValue!==void 0&&!(0,S.isString)(Ie.contextValue))return console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1;if(Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1;if(Ie.checkboxState!==void 0){(0,w.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Ie.checkboxState)?Ie.checkboxState:(0,S.isObject)(Ie.checkboxState)&&(0,S.isNumber)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,et=!(0,S.isNumber)(Ie.checkboxState)&&(0,S.isObject)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==_t.Checked&&Ke!==_t.Unchecked||et!==void 0&&!(0,S.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}return!0}constructor(H,he=Gt.None){this.collapsibleState=he,C.URI.isUri(H)?this.resourceUri=H:this.label=H}};Nt=V=je([F],Nt),e.TreeItem=Nt;var Gt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Gt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var _t;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(_t=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let xt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,he){this.value=H,this.id=he??(0,A.generateUuid)()}};xt=je([F],xt),e.DataTransferItem=xt;let rn=class{constructor(H){f.set(this,new Map);for(const[he,Ie]of H??[]){const Ke=Ne(this,f,"f").get(he);Ke?Ke.push(Ie):Ne(this,f,"f").set(he,[Ie])}}get(H){return Ne(this,f,"f").get(H)?.[0]}set(H,he){Ne(this,f,"f").set(H,[he])}forEach(H,he){for(const[Ie,Ke]of Ne(this,f,"f"))for(const et of Ke)H.call(he,et,Ie,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[H,he]of Ne(this,f,"f"))for(const Ie of he)yield[H,Ie]}};rn=je([F],rn),e.DataTransfer=rn;let sn=class{constructor(H){this.insertText=H}};sn=je([F],sn),e.DocumentDropEdit=sn;let gn=class{constructor(H){this.insertText=H}};gn=je([F],gn),e.DocumentPasteEdit=gn;let Dt=class{constructor(H,he){this.id=H,this.color=he}};Dt=je([F],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let on=class{constructor(H){this.id=H}};on=je([F],on),e.ThemeColor=on;var Rn;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Rn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(H){this._base=H,this._baseUri=C.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}constructor(H,he){if(typeof H!="string"&&(!H||!C.URI.isUri(H)&&!C.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=C.URI.file(H):C.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=je([F],Jt),e.RelativePattern=Jt;let zt=class{constructor(H,he,Ie,Ke){this.enabled=typeof H=="boolean"?H:!0,typeof he=="string"&&(this.condition=he),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};zt=je([F],zt),e.Breakpoint=zt;let lt=class extends zt{constructor(H,he,Ie,Ke,et){if(super(he,Ie,Ke,et),H===null)throw(0,t.illegalArgument)("location");this.location=H}};lt=je([F],lt),e.SourceBreakpoint=lt;let pn=class extends zt{constructor(H,he,Ie,Ke,et){super(he,Ie,Ke,et),this.functionName=H}};pn=je([F],pn),e.FunctionBreakpoint=pn;let Ht=class extends zt{constructor(H,he,Ie,Ke,et,ct,ut){if(super(Ke,et,ct,ut),!he)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=he,this.canPersist=Ie}};Ht=je([F],Ht),e.DataBreakpoint=Ht;let Kt=class{constructor(H,he,Ie){this.command=H,this.args=he||[],this.options=Ie}};Kt=je([F],Kt),e.DebugAdapterExecutable=Kt;let an=class{constructor(H,he){this.port=H,this.host=he}};an=je([F],an),e.DebugAdapterServer=an;let vn=class{constructor(H){this.path=H}};vn=je([F],vn),e.DebugAdapterNamedPipeServer=vn;let cn=class{constructor(H){this.implementation=H}};cn=je([F],cn),e.DebugAdapterInlineImplementation=cn;let bn=class{constructor(H,he){this.range=H,this.expression=he}};bn=je([F],bn),e.EvaluatableExpression=bn;var Dn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor(H,he){this.range=H,this.text=he}};Zt=je([F],Zt),e.InlineValueText=Zt;let wn=class{constructor(H,he,Ie=!0){this.range=H,this.variableName=he,this.caseSensitiveLookup=Ie}};wn=je([F],wn),e.InlineValueVariableLookup=wn;let en=class{constructor(H,he){this.range=H,this.expression=he}};en=je([F],en),e.InlineValueEvaluatableExpression=en;let tn=class{constructor(H,he){this.frameId=H,this.stoppedLocation=he}};tn=je([F],tn),e.InlineValueContext=tn;var Ln;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ln=e.FileChangeType||(e.FileChangeType={}));let En=x=class extends Error{static FileExists(H){return new x(H,T.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(H){return new x(H,T.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(H){return new x(H,T.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(H){return new x(H,T.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(H){return new x(H,T.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(H){return new x(H,T.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(H,he=T.FileSystemProviderErrorCode.Unknown,Ie){super(C.URI.isUri(H)?H.toString(!0):H),this.code=Ie?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};En=x=je([F],En),e.FileSystemError=En;let Xt=class{constructor(H,he,Ie){this.start=H,this.end=he,this.kind=Ie}};Xt=je([F],Xt),e.FoldingRange=Xt;var On;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(On=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Fn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Mn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Mn=e.CommentMode||(e.CommentMode={}));var Nn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Nn=e.CommentThreadState||(e.CommentThreadState={}));class Sn{constructor(H,he=[]){this.tokenTypes=H,this.tokenModifiers=he}}e.SemanticTokensLegend=Sn;function In(G){return typeof G>"u"||(0,S.isStringArray)(G)}class ln{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let he=0,Ie=H.tokenTypes.length;he<Ie;he++)this._tokenTypeStrToInt.set(H.tokenTypes[he],he);for(let he=0,Ie=H.tokenModifiers.length;he<Ie;he++)this._tokenModifierStrToInt.set(H.tokenModifiers[he],he)}}push(H,he,Ie,Ke,et){if(typeof H=="number"&&typeof he=="number"&&typeof Ie=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(H,he,Ie,Ke,et);if(z.isRange(H)&&typeof he=="string"&&In(Ie))return this._push(H,he,Ie);throw(0,t.illegalArgument)()}_push(H,he,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=H.start.line,et=H.start.character,ct=H.end.character-H.start.character,ut=this._tokenTypeStrToInt.get(he);let Ft=0;if(Ie)for(const Bt of Ie){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Bt);Ft|=1<<$t>>>0}this._pushEncoded(Ke,et,ct,ut,Ft)}_pushEncoded(H,he,Ie,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ft=this._data.length/5|0;let Bt=0,$t=0;for(let qt=0;qt<Ft;qt++){let Qt=this._data[5*qt],yn=this._data[5*qt+1];Qt===0?(Qt=Bt,yn+=$t):Qt+=Bt,this._data[5*qt]=Qt,this._data[5*qt+1]=yn,Bt=Qt,$t=yn}}let ct=H,ut=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=H,this._prevChar=he}static _sortAndDeltaEncode(H){const he=[],Ie=H.length/5|0;for(let ut=0;ut<Ie;ut++)he[ut]=ut;he.sort((ut,Ft)=>{const Bt=H[5*ut],$t=H[5*Ft];if(Bt===$t){const qt=H[5*ut+1],Qt=H[5*Ft+1];return qt-Qt}return Bt-$t});const Ke=new Uint32Array(H.length);let et=0,ct=0;for(let ut=0;ut<Ie;ut++){const Ft=5*he[ut],Bt=H[Ft+0],$t=H[Ft+1],qt=H[Ft+2],Qt=H[Ft+3],yn=H[Ft+4],Jn=Bt-et,_i=Jn===0?$t-ct:$t,Cn=5*ut;Ke[Cn+0]=Jn,Ke[Cn+1]=_i,Ke[Cn+2]=qt,Ke[Cn+3]=Qt,Ke[Cn+4]=yn,et=Bt,ct=$t}return Ke}build(H){return this._dataIsSortedAndDeltaEncoded?new $e(new Uint32Array(this._data),H):new $e(ln._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=ln;class $e{constructor(H,he){this.resultId=he,this.data=H}}e.SemanticTokens=$e;class Vt{constructor(H,he,Ie){this.start=H,this.deleteCount=he,this.data=Ie}}e.SemanticTokensEdit=Vt;class kn{constructor(H,he){this.resultId=he,this.edits=H}}e.SemanticTokensEdits=kn;var gt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let un=class{constructor(){}};un.Back={iconPath:new Dt("arrow-left")},un=je([F],un),e.QuickInputButtons=un;var Un;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Un=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Tn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Tn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Bn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Bn=e.ExtensionKind||(e.ExtensionKind={}));class dn{static validate(H){if(H.badge){let he=(0,k.nextCharLength)(H.badge,0);if(he<H.badge.length&&(he+=(0,k.nextCharLength)(H.badge,he)),H.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,he,Ie){this.badge=H,this.tooltip=he,this.color=Ie}}e.FileDecoration=dn;let _n=class{constructor(H){this.kind=H}};_n=je([F],_n),e.ColorTheme=_n;var Wn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Wn=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(H){return H instanceof jt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(H,he){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");H<=he?(this._start=H,this._end=he):(this._start=he,this._end=H)}with(H){let he=this._start,Ie=this._end;return H.start!==void 0&&(he=H.start),H.end!==void 0&&(Ie=H.end),he===this._start&&Ie===this._end?this:new jt(he,Ie)}}e.NotebookRange=jt;class nn{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(he=>nn.isNotebookCellData(he))}static isNotebookCellData(H){return!0}constructor(H,he,Ie,Ke,et,ct,ut){this.kind=H,this.value=he,this.languageId=Ie,this.mime=Ke,this.outputs=et??[],this.metadata=ct,this.executionSummary=ut,nn.validate(this)}}e.NotebookCellData=nn;class zn{constructor(H){this.cells=H}}e.NotebookData=zn;class Ut{static isNotebookCellOutputItem(H){return H instanceof Ut?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const he={name:H.name,message:H.message,stack:H.stack};return Ut.json(he,"application/vnd.code.notebook.error")}static stdout(H){return Ut.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Ut.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,he="application/octet-stream"){return new Ut(H,he)}static text(H,he=y.Mimes.text){const Ie=Ne(Ut,b,"f",m).encode(String(H));return new Ut(Ie,he)}static json(H,he="text/x-json"){const Ie=JSON.stringify(H,void 0,"	");return Ut.text(Ie,he)}constructor(H,he){this.data=H,this.mime=he;const Ie=(0,y.normalizeMimeType)(he,!0);if(!Ie)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.NotebookCellOutputItem=Ut,b=Ut,m={value:new TextEncoder};class hn{static isNotebookCellOutput(H){return H instanceof hn?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,he=!1){const Ie=new Set,Ke=new Set;for(let et=0;et<H.length;et++){const ct=H[et],ut=(0,y.normalizeMimeType)(ct.mime);if(!Ie.has(ut)||(0,_.isTextStreamMime)(ut)){Ie.add(ut);continue}Ke.add(et),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?H:H.filter((et,ct)=>!Ke.has(ct))}constructor(H,he,Ie){this.items=hn.ensureUniqueMimeTypes(H,!0),typeof he=="string"?(this.id=he,this.metadata=Ie):(this.id=(0,A.generateUuid)(),this.metadata=he??Ie)}}e.NotebookCellOutput=hn;var Hn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Hn=e.NotebookCellKind||(e.NotebookCellKind={}));var $n;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})($n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(xn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var me;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(me=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class we{constructor(H,he){this.text=H,this.alignment=he}}e.NotebookCellStatusBarItem=we;var Ue;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ue=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ot;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(ot=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class yt{constructor(H,he=[]){this.uri=H,this.provides=(0,c.asArray)(he)}}e.NotebookRendererScript=yt;let Pt=class{constructor(H,he){this.label=H,this.timestamp=he}};Pt=je([F],Pt),e.TimelineItem=Pt;var ni;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ni=e.ExtensionMode||(e.ExtensionMode={}));var ii;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ii=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ri;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(ri=e.StandardTokenType||(e.StandardTokenType={}));class si{constructor(H,he){this.ranges=H,this.wordPattern=he}}e.LinkedEditingRanges=si;class oi{constructor(H,he){this._port=H,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=oi;var ai;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ai=e.TestResultState||(e.TestResultState={}));var ci;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ci=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vn=class{constructor(H=void 0,he=void 0,Ie=void 0){this.include=H,this.exclude=he,this.profile=Ie}};Vn=je([F],Vn),e.TestRunRequest=Vn;let jn=L=class{static diff(H,he,Ie){const Ke=new L(H);return Ke.expectedOutput=he,Ke.actualOutput=Ie,Ke}constructor(H){this.message=H}};jn=L=je([F],jn),e.TestMessage=jn;let qn=class{constructor(H){this.id=H}};qn=je([F],qn),e.TestTag=qn;let fn=class{constructor(H,he){this.covered=H,this.total=he}};fn=je([F],fn),e.CoveredCount=fn;let Gn=U=class{static fromDetails(H,he){const Ie=new fn(0,0),Ke=new fn(0,0),et=new fn(0,0);for(const ut of he)if("branches"in ut){Ie.total+=1,Ie.covered+=ut.executionCount>0?1:0;for(const Ft of ut.branches)Ke.total+=1,Ke.covered+=Ft.executionCount>0?1:0}else et.total+=1,et.covered+=ut.executionCount>0?1:0;const ct=new U(H,Ie,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return ct.detailedCoverage=he,ct}constructor(H,he,Ie,Ke){this.uri=H,this.statementCoverage=he,this.branchCoverage=Ie,this.functionCoverage=Ke}};Gn=U=je([F],Gn),e.FileCoverage=Gn;let Kn=class{constructor(H,he,Ie=[]){this.executionCount=H,this.location=he,this.branches=Ie}};Kn=je([F],Kn),e.StatementCoverage=Kn;let Xn=class{constructor(H,he){this.executionCount=H,this.location=he}};Xn=je([F],Xn),e.BranchCoverage=Xn;let Qn=class{constructor(H,he){this.executionCount=H,this.location=he}};Qn=je([F],Qn),e.FunctionCoverage=Qn;var li;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(li=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ui;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ui=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var di;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(di=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hi{constructor(H,he,Ie,Ke,et,ct){this.kind=H,this.name=he,this.detail=Ie,this.uri=Ke,this.range=et,this.selectionRange=ct}}e.TypeHierarchyItem=hi;class fi{constructor(H){this.uri=H}}e.TextTabInput=fi;class mi{constructor(H,he){this.original=H,this.modified=he}}e.TextDiffTabInput=mi;class gi{constructor(H,he,Ie,Ke){this.base=H,this.input1=he,this.input2=Ie,this.result=Ke}}e.TextMergeTabInput=gi;class pi{constructor(H,he){this.uri=H,this.viewType=he}}e.CustomEditorTabInput=pi;class vi{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=vi;class bi{constructor(H,he){this.uri=H,this.notebookType=he}}e.NotebookEditorTabInput=bi;class wi{constructor(H,he,Ie){this.original=H,this.modified=he,this.notebookType=Ie}}e.NotebookDiffEditorTabInput=wi;class Ei{constructor(){}}e.TerminalEditorTabInput=Ei;class Si{constructor(H,he){this.uri=H,this.inputBoxUri=he}}e.InteractiveWindowInput=Si}),define(_e[133],ye([1,0,48,14,8,161,104,7,17]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function A(w,h){h?C.set(w,h):C.delete(w)}e.setWordDefinitionFor=A;function T(w){return C.get(w)}class E extends P.MirrorTextModel{constructor(h,g,f,b,m,d,v,r){super(g,f,b,m),this._proxy=h,this._languageId=d,this._isDirty=v,this.notebook=r,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,S.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===t.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(g){return g?h._getTextInRange(g):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(g){return h._lineAt(g)},offsetAt(g){return h._offsetAt(g)},positionAt(g){return h._positionAt(g)},validateRange(g){return h._validateRange(g)},validatePosition(g){return h._validatePosition(g)},getWordRangeAtPosition(g,f){return h._getWordRangeAtPosition(g,f)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,c.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,c.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const g=this._validateRange(h);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const f=this._eol,b=g.start.line,m=g.end.line,d=[];d.push(this._lines[b].substring(g.start.character));for(let v=b+1;v<m;v++)d.push(this._lines[v]);return d.push(this._lines[m].substring(0,g.end.character)),d.join(f)}_lineAt(h){let g;if(h instanceof k.Position?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new _(g,this._lines[g],g===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(h),f=this._lines[g.index].length;return new k.Position(g.index,Math.min(g.remainder,f))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const g=this._validatePosition(h.start),f=this._validatePosition(h.end);return g===h.start&&f===h.end?h:new k.Range(g.line,g.character,f.line,f.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:g,character:f}=h,b=!1;if(g<0)g=0,f=0,b=!0;else if(g>=this._lines.length)g=this._lines.length-1,f=this._lines[g].length,b=!0;else{const m=this._lines[g].length;f<0?(f=0,b=!0):f>m&&(f=m,b=!0)}return b?new k.Position(g,f):h}_getWordRangeAtPosition(h,g){const f=this._validatePosition(h);if(!g)g=T(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const b=(0,y.getWordAtText)(f.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[f.line],0);if(b)return new k.Range(f.line,b.startColumn-1,f.line,b.endColumn-1)}}e.ExtHostDocumentData=E;class _{constructor(h,g,f){this._line=h,this._text=g,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(_e[231],ye([1,0,7,16,4]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(k){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S;switch(k){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(_e[15],ye([1,0,17,23,146,61,110,28,145,83,81,24,11,2,35,66,122,131,129,91,56,67,225,7]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Ae){function Me(ee){const{selectionStartLineNumber:Oe,selectionStartColumn:ze,positionLineNumber:Ye,positionColumn:Ve}=ee,at=new o.Position(Oe-1,ze-1),mt=new o.Position(Ye-1,Ve-1);return new o.Selection(at,mt)}Ae.to=Me;function Ee(ee){const{anchor:Oe,active:ze}=ee;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ae.from=Ee})(l=e.Selection||(e.Selection={}));var s;(function(Ae){function Me(ee){if(!ee)return;const{start:Oe,end:ze}=ee;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ae.from=Me;function Ee(ee){if(!ee)return;const{startLineNumber:Oe,startColumn:ze,endLineNumber:Ye,endColumn:Ve}=ee;return new o.Range(Oe-1,ze-1,Ye-1,Ve-1)}Ae.to=Ee})(s=e.Range||(e.Range={}));var a;(function(Ae){function Me(Ee){switch(Ee){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ae.to=Me})(a=e.TokenType||(e.TokenType={}));var u;(function(Ae){function Me(ee){return new o.Position(ee.lineNumber-1,ee.column-1)}Ae.to=Me;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ae.from=Ee})(u=e.Position||(e.Position={}));var n;(function(Ae){function Me(Oe,ze){return(0,c.coalesce)((0,c.asArray)(Oe).map(Ye=>Ee(Ye,ze)))}Ae.from=Me;function Ee(Oe,ze){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ee(Oe.scheme,ze),pattern:le.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function ee(Oe,ze){return ze&&typeof Oe=="string"?ze.transformOutgoingScheme(Oe):Oe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ae){function Me(ee){switch(ee){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ae.from=Me;function Ee(ee){switch(ee){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(Ae){function Me(ee){let Oe;return ee.code&&((0,E.isString)(ee.code)||(0,E.isNumber)(ee.code)?Oe=String(ee.code):Oe={value:String(ee.code.value),target:ee.code.target}),{...s.from(ee.range),message:ee.message,source:ee.source,code:Oe,severity:R.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(D.from),tags:Array.isArray(ee.tags)?(0,c.coalesce)(ee.tags.map(i.from)):void 0}}Ae.from=Me;function Ee(ee){const Oe=new o.Diagnostic(s.to(ee),ee.message,R.to(ee.severity));return Oe.source=ee.source,Oe.code=(0,E.isString)(ee.code)?ee.code:ee.code?.value,Oe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(D.to),Oe.tags=ee.tags&&(0,c.coalesce)(ee.tags.map(i.to)),Oe}Ae.to=Ee})(p=e.Diagnostic||(e.Diagnostic={}));var D;(function(Ae){function Me(ee){return{...s.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Ae.from=Me;function Ee(ee){return new o.DiagnosticRelatedInformation(new o.Location(ee.resource,s.to(ee)),ee.message)}Ae.to=Ee})(D=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var R;(function(Ae){function Me(ee){switch(ee){case o.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ae.from=Me;function Ee(ee){switch(ee){case g.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ae.to=Ee})(R=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var N;(function(Ae){function Me(ee){return typeof ee=="number"&&ee>=o.ViewColumn.One?ee-1:ee===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}Ae.from=Me;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(N=e.ViewColumn||(e.ViewColumn={}));function V(Ae){return typeof Ae.range<"u"}function x(Ae){return Ae.length===0?!0:!!V(Ae[0])}e.isDecorationOptionsArr=x;var L;(function(Ae){function Me(Ve){return Ve.map(Ae.from)}Ae.fromMany=Me;function Ee(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function ee(Ve){let at;if(Ee(Ve)){const{language:St,value:ht}=Ve;at={value:"```"+St+`
`+ht+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ve)?at={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?at={value:Ve}:at={value:""};const mt=Object.create(null);at.uris=mt;const Ot=St=>{try{let ht=_.URI.parse(St,!0);ht=ht.with({query:Oe(ht.query,mt)}),mt[St]=ht}catch{}return""},bt=new S.marked.Renderer;return bt.link=Ot,bt.image=St=>typeof St=="string"?Ot(y.parseHrefAndDimensions(St).href):"",(0,S.marked)(at.value,{renderer:bt}),at}Ae.from=ee;function Oe(Ve,at){if(!Ve)return Ve;let mt;try{mt=(0,C.parse)(Ve)}catch{}if(!mt)return Ve;let Ot=!1;return mt=(0,T.cloneAndChange)(mt,bt=>{if(_.URI.isUri(bt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[St]=bt,Ot=!0,St}else return}),Ot?JSON.stringify(mt):Ve}function ze(Ve){const at=new o.MarkdownString(Ve.value,Ve.supportThemeIcons);return at.isTrusted=Ve.isTrusted,at.supportHtml=Ve.supportHtml,at.baseUri=Ve.baseUri?_.URI.from(Ve.baseUri):void 0,at}Ae.to=ze;function Ye(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Ye})(L=e.MarkdownString||(e.MarkdownString={}));function U(Ae){return x(Ae)?Ae.map(Me=>({range:s.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?L.fromMany(Me.hoverMessage):Me.hoverMessage?L.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ae.map(Me=>({range:s.from(Me)}))}e.fromRangeOrRangeWithMessage=U;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?_.URI.file(Ae):Ae}e.pathOrURIToURI=F;var B;(function(Ae){function Me(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Me})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Ae){function Me(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Me})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Ae){function Me(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Me})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(Ae){function Me(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?z.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?M.from(Ee.light):void 0,dark:Ee.dark?M.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Me})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ae){function Me(ee){return{text:ee.newText,eol:ee.newEol&&Be.from(ee.newEol),range:s.from(ee.range)}}Ae.from=Me;function Ee(ee){const Oe=new o.TextEdit(s.to(ee.range),ee.text);return Oe.newEol=typeof ee.eol>"u"?void 0:Be.to(ee.eol),Oe}Ae.to=Ee})($=e.TextEdit||(e.TextEdit={}));var Q;(function(Ae){function Me(ee,Oe){const ze={edits:[]};if(ee instanceof o.WorkspaceEdit){const Ye=new k.ResourceSet;for(const Ve of ee._allEntries())Ve._type===1&&_.URI.isUri(Ve.to)&&Ve.from===void 0&&Ye.add(Ve.to);for(const Ve of ee._allEntries())Ve._type===1?ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?ze.edits.push({resource:Ve.uri,textEdit:$.from(Ve.edit),versionId:Ye.has(Ve.uri)?void 0:Oe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?ze.edits.push({resource:Ve.uri,textEdit:{range:s.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ve.uri)?void 0:Oe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(vt.from)}})}return ze}Ae.from=Me;function Ee(ee){const Oe=new o.WorkspaceEdit;for(const ze of ee.edits)ze.textEdit?Oe.replace(_.URI.revive(ze.resource),s.to(ze.textEdit.range),ze.textEdit.text):Oe.renameFile(_.URI.revive(ze.oldResource),_.URI.revive(ze.newResource),ze.options);return Oe}Ae.to=Ee})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(Ae){const Me=Object.create(null);Me[o.SymbolKind.File]=0,Me[o.SymbolKind.Module]=1,Me[o.SymbolKind.Namespace]=2,Me[o.SymbolKind.Package]=3,Me[o.SymbolKind.Class]=4,Me[o.SymbolKind.Method]=5,Me[o.SymbolKind.Property]=6,Me[o.SymbolKind.Field]=7,Me[o.SymbolKind.Constructor]=8,Me[o.SymbolKind.Enum]=9,Me[o.SymbolKind.Interface]=10,Me[o.SymbolKind.Function]=11,Me[o.SymbolKind.Variable]=12,Me[o.SymbolKind.Constant]=13,Me[o.SymbolKind.String]=14,Me[o.SymbolKind.Number]=15,Me[o.SymbolKind.Boolean]=16,Me[o.SymbolKind.Array]=17,Me[o.SymbolKind.Object]=18,Me[o.SymbolKind.Key]=19,Me[o.SymbolKind.Null]=20,Me[o.SymbolKind.EnumMember]=21,Me[o.SymbolKind.Struct]=22,Me[o.SymbolKind.Event]=23,Me[o.SymbolKind.Operator]=24,Me[o.SymbolKind.TypeParameter]=25;function Ee(Oe){return typeof Me[Oe]=="number"?Me[Oe]:6}Ae.from=Ee;function ee(Oe){for(const ze in Me)if(Me[ze]===Oe)return Number(ze);return o.SymbolKind.Property}Ae.to=ee})(K=e.SymbolKind||(e.SymbolKind={}));var ue;(function(Ae){function Me(ee){switch(ee){case o.SymbolTag.Deprecated:return 1}}Ae.from=Me;function Ee(ee){switch(ee){case 1:return o.SymbolTag.Deprecated}}Ae.to=Ee})(ue=e.SymbolTag||(e.SymbolTag={}));var re;(function(Ae){function Me(ee){return{name:ee.name,kind:K.from(ee.kind),tags:ee.tags&&ee.tags.map(ue.from),containerName:ee.containerName,location:Ce.from(ee.location)}}Ae.from=Me;function Ee(ee){const Oe=new o.SymbolInformation(ee.name,K.to(ee.kind),ee.containerName,Ce.to(ee.location));return Oe.tags=ee.tags&&ee.tags.map(ue.to),Oe}Ae.to=Ee})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Ae){function Me(ee){const Oe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:s.from(ee.range),selectionRange:s.from(ee.selectionRange),kind:K.from(ee.kind),tags:ee.tags?.map(ue.from)??[]};return ee.children&&(Oe.children=ee.children.map(Me)),Oe}Ae.from=Me;function Ee(ee){const Oe=new o.DocumentSymbol(ee.name,ee.detail,K.to(ee.kind),s.to(ee.range),s.to(ee.selectionRange));return(0,c.isNonEmptyArray)(ee.tags)&&(Oe.tags=ee.tags.map(ue.to)),ee.children&&(Oe.children=ee.children.map(Ee)),Oe}Ae.to=Ee})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Ae){function Me(ee){const Oe=new o.CallHierarchyItem(K.to(ee.kind),ee.name,ee.detail||"",_.URI.revive(ee.uri),s.to(ee.range),s.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ae.to=Me;function Ee(ee,Oe,ze){if(Oe=Oe??ee._sessionId,ze=ze??ee._itemId,Oe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:ze,name:ee.name,detail:ee.detail,kind:K.from(ee.kind),uri:ee.uri,range:s.from(ee.range),selectionRange:s.from(ee.selectionRange),tags:ee.tags?.map(ue.from)}}Ae.from=Ee})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Ae){function Me(Ee){return new o.CallHierarchyIncomingCall(Y.to(Ee.from),Ee.fromRanges.map(ee=>s.to(ee)))}Ae.to=Me})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Ae){function Me(Ee){return new o.CallHierarchyOutgoingCall(Y.to(Ee.to),Ee.fromRanges.map(ee=>s.to(ee)))}Ae.to=Me})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ce;(function(Ae){function Me(ee){return{range:ee.range&&s.from(ee.range),uri:ee.uri}}Ae.from=Me;function Ee(ee){return new o.Location(_.URI.revive(ee.uri),s.to(ee.range))}Ae.to=Ee})(Ce=e.location||(e.location={}));var Re;(function(Ae){function Me(ee){const Oe=ee,ze=ee;return{originSelectionRange:Oe.originSelectionRange?s.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:ze.uri,range:s.from(Oe.targetRange?Oe.targetRange:ze.range),targetSelectionRange:Oe.targetSelectionRange?s.from(Oe.targetSelectionRange):void 0}}Ae.from=Me;function Ee(ee){return{targetUri:_.URI.revive(ee.uri),targetRange:s.to(ee.range),targetSelectionRange:ee.targetSelectionRange?s.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?s.to(ee.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var We;(function(Ae){function Me(ee){return{range:s.from(ee.range),contents:L.fromMany(ee.contents)}}Ae.from=Me;function Ee(ee){return new o.Hover(ee.contents.map(L.to),s.to(ee.range))}Ae.to=Ee})(We=e.Hover||(e.Hover={}));var ne;(function(Ae){function Me(ee){return{range:s.from(ee.range),expression:ee.expression}}Ae.from=Me;function Ee(ee){return new o.EvaluatableExpression(s.to(ee.range),ee.expression)}Ae.to=Ee})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ce;(function(Ae){function Me(ee){if(ee instanceof o.InlineValueText)return{type:"text",range:s.from(ee.range),text:ee.text};if(ee instanceof o.InlineValueVariableLookup)return{type:"variable",range:s.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Me;function Ee(ee){switch(ee.type){case"text":return{range:s.to(ee.range),text:ee.text};case"variable":return{range:s.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:s.to(ee.range),expression:ee.expression}}}Ae.to=Ee})(ce=e.InlineValue||(e.InlineValue={}));var fe;(function(Ae){function Me(ee){return{frameId:ee.frameId,stoppedLocation:s.from(ee.stoppedLocation)}}Ae.from=Me;function Ee(ee){return new o.InlineValueContext(ee.frameId,s.to(ee.stoppedLocation))}Ae.to=Ee})(fe=e.InlineValueContext||(e.InlineValueContext={}));var J;(function(Ae){function Me(ee){return{range:s.from(ee.range),kind:ee.kind}}Ae.from=Me;function Ee(ee){return new o.DocumentHighlight(s.to(ee.range),ee.kind)}Ae.to=Ee})(J=e.DocumentHighlight||(e.DocumentHighlight={}));var ie;(function(Ae){function Me(Ee){switch(Ee){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ae.to=Me})(ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var te;(function(Ae){function Me(Ee){return{triggerKind:ie.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Me})(te=e.CompletionContext||(e.CompletionContext={}));var O;(function(Ae){function Me(ee){switch(ee){case o.CompletionItemTag.Deprecated:return 1}}Ae.from=Me;function Ee(ee){switch(ee){case 1:return o.CompletionItemTag.Deprecated}}Ae.to=Ee})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Ae){const Me=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Ee(ze){return Me.get(ze)??9}Ae.from=Ee;const ee=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(ze){return ee.get(ze)??o.CompletionItemKind.Property}Ae.to=Oe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(Ae){function Me(Ee,ee){const Oe=new o.CompletionItem(Ee.label);return Oe.insertText=Ee.insertText,Oe.kind=W.to(Ee.kind),Oe.tags=Ee.tags?.map(O.to),Oe.detail=Ee.detail,Oe.documentation=y.isMarkdownString(Ee.documentation)?L.to(Ee.documentation):Ee.documentation,Oe.sortText=Ee.sortText,Oe.filterText=Ee.filterText,Oe.preselect=Ee.preselect,Oe.commitCharacters=Ee.commitCharacters,w.Range.isIRange(Ee.range)?Oe.range=s.to(Ee.range):typeof Ee.range=="object"&&(Oe.range={inserting:s.to(Ee.range.insert),replacing:s.to(Ee.range.replace)}),Oe.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Oe.insertText=new o.SnippetString(Ee.insertText):(Oe.insertText=Ee.insertText,Oe.textEdit=Oe.range instanceof o.Range?new o.TextEdit(Oe.range,Oe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Ee.additionalTextEdits.map(ze=>$.to(ze))),Oe.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Oe}Ae.to=Me})(q=e.CompletionItem||(e.CompletionItem={}));var X;(function(Ae){function Me(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:L.fromStrict(ee.documentation)}}Ae.from=Me;function Ee(ee){return{label:ee.label,documentation:y.isMarkdownString(ee.documentation)?L.to(ee.documentation):ee.documentation}}Ae.to=Ee})(X=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(Ae){function Me(ee){return{label:ee.label,documentation:L.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(X.from):[],activeParameter:ee.activeParameter}}Ae.from=Me;function Ee(ee){return{label:ee.label,documentation:y.isMarkdownString(ee.documentation)?L.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(X.to):[],activeParameter:ee.activeParameter}}Ae.to=Ee})(ae=e.SignatureInformation||(e.SignatureInformation={}));var ve;(function(Ae){function Me(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ae.from):[]}}Ae.from=Me;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ae.to):[]}}Ae.to=Ee})(ve=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Ae){function Me(Ee,ee){const Oe=new o.InlayHint(u.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ge.to.bind(void 0,Ee)),ee.kind&&ke.to(ee.kind));return Oe.textEdits=ee.textEdits&&ee.textEdits.map($.to),Oe.tooltip=y.isMarkdownString(ee.tooltip)?L.to(ee.tooltip):ee.tooltip,Oe.paddingLeft=ee.paddingLeft,Oe.paddingRight=ee.paddingRight,Oe}Ae.to=Me})(Te=e.InlayHint||(e.InlayHint={}));var ge;(function(Ae){function Me(Ee,ee){const Oe=new o.InlayHintLabelPart(ee.label);return Oe.tooltip=y.isMarkdownString(ee.tooltip)?L.to(ee.tooltip):ee.tooltip,h.Command.is(ee.command)&&(Oe.command=Ee.fromInternal(ee.command)),ee.location&&(Oe.location=Ce.to(ee.location)),Oe}Ae.to=Me})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ke;(function(Ae){function Me(ee){return ee}Ae.from=Me;function Ee(ee){return ee}Ae.to=Ee})(ke=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(Ae){function Me(ee){return{range:s.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ae.from=Me;function Ee(ee){let Oe;if(ee.url)try{Oe=typeof ee.url=="string"?_.URI.parse(ee.url,!0):_.URI.revive(ee.url)}catch{}return new o.DocumentLink(s.to(ee.range),Oe)}Ae.to=Ee})(De=e.DocumentLink||(e.DocumentLink={}));var xe;(function(Ae){function Me(ee){const Oe=new o.ColorPresentation(ee.label);return ee.textEdit&&(Oe.textEdit=$.to(ee.textEdit)),ee.additionalTextEdits&&(Oe.additionalTextEdits=ee.additionalTextEdits.map(ze=>$.to(ze))),Oe}Ae.to=Me;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?$.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Oe=>$.from(Oe)):void 0}}Ae.from=Ee})(xe=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Ae){function Me(ee){return new o.Color(ee[0],ee[1],ee[2],ee[3])}Ae.to=Me;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ae.from=Ee})(qe=e.Color||(e.Color={}));var nt;(function(Ae){function Me(ee){return{range:s.from(ee.range)}}Ae.from=Me;function Ee(ee){return new o.SelectionRange(s.to(ee.range))}Ae.to=Ee})(nt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ae){function Me(Ee){switch(Ee){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ae.to=Me})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var st;(function(Ae){function Me(ee){switch(ee){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Me;function Ee(ee){switch(ee){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Be;(function(Ae){function Me(ee){if(ee===o.EndOfLine.CRLF)return 1;if(ee===o.EndOfLine.LF)return 0}Ae.from=Me;function Ee(ee){if(ee===1)return o.EndOfLine.CRLF;if(ee===0)return o.EndOfLine.LF}Ae.to=Ee})(Be=e.EndOfLine||(e.EndOfLine={}));var dt;(function(Ae){function Me(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Me})(dt=e.ProgressLocation||(e.ProgressLocation={}));var se;(function(Ae){function Me(Ee){const ee={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(ee.kind=oe.from(Ee.kind)),ee}Ae.from=Me})(se=e.FoldingRange||(e.FoldingRange={}));var oe;(function(Ae){function Me(Ee){if(Ee)switch(Ee){case o.FoldingRangeKind.Comment:return h.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return h.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return h.FoldingRangeKind.Region}}Ae.from=Me})(oe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Se;(function(Ae){function Me(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?s.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Me})(Se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(Ae){function Me(ze){return ze instanceof o.RelativePattern?ze.toJSON():typeof ze=="string"?ze:Ee(ze)||ee(ze)?new o.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ae.from=Me;function Ee(ze){const Ye=ze;return Ye?_.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function ee(ze){const Ye=ze;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Oe(ze){return typeof ze=="string"?ze:new o.RelativePattern(_.URI.revive(ze.baseUri),ze.pattern)}Ae.to=Oe})(le=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(Ae){function Me(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Me);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:le.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Ae.from=Me})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(Ae){function Me(ee){return{start:ee.start,end:ee.end}}Ae.from=Me;function Ee(ee){return new o.NotebookRange(ee.start,ee.end)}Ae.to=Ee})(Le=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Ae){function Me(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ae.to=Me;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Ae.from=Ee})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ge;(function(Ae){function Me(Ee){if(Ee===m.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Ee===m.NotebookCellExecutionState.Pending)return;if(Ee===m.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Me})(Ge=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(Ae){function Me(ee){switch(ee){case o.NotebookCellKind.Markup:return m.CellKind.Markup;case o.NotebookCellKind.Code:default:return m.CellKind.Code}}Ae.from=Me;function Ee(ee){switch(ee){case m.CellKind.Markup:return o.NotebookCellKind.Markup;case m.CellKind.Code:default:return o.NotebookCellKind.Code}}Ae.to=Ee})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Ae){function Me(ee){const Oe={metadata:ee.metadata??Object.create(null),cells:[]};for(const ze of ee.cells)o.NotebookCellData.validate(ze),Oe.cells.push(vt.from(ze));return Oe}Ae.from=Me;function Ee(ee){const Oe=new o.NotebookData(ee.cells.map(vt.to));return(0,E.isEmptyObject)(ee.metadata)||(Oe.metadata=ee.metadata),Oe}Ae.to=Ee})(it=e.NotebookData||(e.NotebookData={}));var vt;(function(Ae){function Me(ee){return{cellKind:Je.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:Fe.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Ze.from):[]}}Ae.from=Me;function Ee(ee){return new o.NotebookCellData(Je.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Ze.to):void 0,ee.metadata,ee.internalMetadata?Fe.to(ee.internalMetadata):void 0)}Ae.to=Ee})(vt=e.NotebookCellData||(e.NotebookCellData={}));var rt;(function(Ae){function Me(ee){return{mime:ee.mime,valueBytes:t.VSBuffer.wrap(ee.data)}}Ae.from=Me;function Ee(ee){return new o.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Ae.to=Ee})(rt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ze;(function(Ae){function Me(ee){return{outputId:ee.id,items:ee.items.map(rt.from),metadata:ee.metadata}}Ae.from=Me;function Ee(ee){const Oe=ee.items.map(rt.to);return new o.NotebookCellOutput(Oe,ee.outputId,ee.metadata)}Ae.to=Ee})(Ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var wt;(function(Ae){function Me(Oe){return ee(Oe)?{include:(0,E.withNullAsUndefined)(le.from(Oe.include)),exclude:(0,E.withNullAsUndefined)(le.from(Oe.exclude))}:(0,E.withNullAsUndefined)(le.from(Oe))}Ae.from=Me;function Ee(Oe){return ee(Oe)?{include:le.to(Oe.include),exclude:le.to(Oe.exclude)}:le.to(Oe)}Ae.to=Ee;function ee(Oe){const ze=Oe;return ze?!(0,E.isUndefinedOrNull)(ze.include)&&!(0,E.isUndefinedOrNull)(ze.exclude):!1}})(wt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Et;(function(Ae){function Me(Ee,ee,Oe){const ze=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(ze,Oe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Me})(Et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Ae){function Me(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Me})(kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ft;(function(Ae){function Me(ee){return{uri:ee.uri,provides:ee.provides}}Ae.from=Me;function Ee(ee){return new o.NotebookRendererScript(_.URI.revive(ee.uri),ee.provides)}Ae.to=Ee})(ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(Ae){function Me(ee){return{message:L.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,location:ee.location&&{range:s.from(ee.location.range),uri:ee.location.uri}}}Ae.from=Me;function Ee(ee){const Oe=new o.TestMessage(typeof ee.message=="string"?ee.message:L.to(ee.message));return Oe.actualOutput=ee.actual,Oe.expectedOutput=ee.expected,Oe.location=ee.location?Ce.to(ee.location):void 0,Oe}Ae.to=Ee})(Tt=e.TestMessage||(e.TestMessage={}));var Rt;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(Rt=e.TestTag||(e.TestTag={}));var Lt;(function(Ae){function Me(ee){const Oe=(0,f.getPrivateApiFor)(ee).controllerId;return{extId:d.TestId.fromExtHostTestItem(ee,Oe).toString(),label:ee.label,uri:_.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(ze=>Rt.namespace(Oe,ze.id)),range:w.Range.lift(s.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&L.fromStrict(ee.error)||null}}Ae.from=Me;function Ee(ee){return{parent:void 0,error:void 0,id:d.TestId.fromString(ee.extId).localId,label:ee.label,uri:_.URI.revive(ee.uri),tags:(ee.tags||[]).map(Oe=>{const{tagId:ze}=Rt.denamespace(Oe);return new o.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Ae.toPlain=Ee})(Lt=e.TestItem||(e.TestItem={})),function(Ae){function Me(ee){return{id:ee.id}}Ae.from=Me;function Ee(ee){return new o.TestTag(ee.id)}Ae.to=Ee}(Rt=e.TestTag||(e.TestTag={}));var Qe;(function(Ae){const Me=(ee,Oe)=>{const ze=[];for(const[Ve,at]of Oe)d.TestId.compare(at.item.extId,Ve)===2&&(Oe.delete(Ve),ze.push(at));const Ye={...Lt.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(at=>at.type===0).map(Tt.to)})),children:ze.map(Ve=>Me(Ve,Oe))};for(const Ve of Ye.children)Ve.parent=Ye;return Ye};function Ee(ee){const Oe=[],ze=new Map;for(const Ye of ee.items){ze.set(Ye.item.extId,Ye);const Ve=d.TestId.root(Ye.item.extId);ee.request.targets.some(at=>at.controllerId===Ve&&at.testIds.includes(Ye.item.extId))&&Oe.push(Ye)}return{completedAt:ee.completedAt,results:Oe.map(Ye=>Me(Ye,ze))}}Ae.to=Ee})(Qe=e.TestResults||(e.TestResults={}));var At;(function(Ae){function Me(ze){return{covered:ze.covered,total:ze.covered}}function Ee(ze){return"line"in ze?u.from(ze):s.from(ze)}function ee(ze){return"branches"in ze?{count:ze.executionCount,location:Ee(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Ee(Ye.location)})):void 0}:{type:0,count:ze.executionCount,location:Ee(ze.location)}}Ae.fromDetailed=ee;function Oe(ze){return{uri:ze.uri,statement:Me(ze.statementCoverage),branch:ze.branchCoverage&&Me(ze.branchCoverage),function:ze.functionCoverage&&Me(ze.functionCoverage),details:ze.detailedCoverage?.map(ee)}}Ae.fromFile=Oe})(At=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Ae){function Me(Ee){switch(Ee){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ae.to=Me})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Wt;(function(Ae){function Me(ee){const Oe=new o.TypeHierarchyItem(K.to(ee.kind),ee.name,ee.detail||"",_.URI.revive(ee.uri),s.to(ee.range),s.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ae.to=Me;function Ee(ee,Oe,ze){if(Oe=Oe??ee._sessionId,ze=ze??ee._itemId,Oe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:ze,kind:K.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:s.from(ee.range),selectionRange:s.from(ee.selectionRange),tags:ee.tags?.map(ue.from)}}Ae.from=Ee})(Wt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var pt;(function(Ae){function Me(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Me})(pt=e.ViewBadge||(e.ViewBadge={}));var It;(function(Ae){function Me(ze,Ye,Ve){const at=Ye.fileData;return at?new class extends o.DataTransferItem{asFile(){return{name:at.name,uri:_.URI.revive(at.uri),data:(0,P.once)(()=>Ve())}}}("",Ye.id):ze===A.Mimes.uriList&&Ye.uriListData?new o.DataTransferItem(Oe(Ye.uriListData)):new o.DataTransferItem(Ye.asString)}Ae.to=Me;async function Ee(ze,Ye){const Ve=await Ye.asString();if(ze===A.Mimes.uriList)return{id:Ye.id,asString:"",fileData:void 0,uriListData:ee(Ve)};const at=Ye.asFile();return{id:Ye.id,asString:Ve,fileData:at?{name:at.name,uri:at.uri}:void 0}}Ae.from=Ee;function ee(ze){return I.UriList.split(ze).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return _.URI.parse(Ye)}catch{}return Ye})}function Oe(ze){return I.UriList.create(ze.map(Ye=>typeof Ye=="string"?Ye:_.URI.revive(Ye)))}})(It=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(Ae){function Me(ee,Oe){const ze=ee.items.map(([Ye,Ve])=>[Ye,It.to(Ye,Ve,()=>Oe(Ve.id))]);return new o.DataTransfer(ze)}Ae.toDataTransfer=Me;async function Ee(ee){const Oe={items:[]},ze=[];return ee.forEach((Ye,Ve)=>{ze.push((async()=>{Oe.items.push([Ve,await It.from(Ve,Ye)])})())}),await Promise.all(ze),Oe}Ae.toDataTransferDTO=Ee})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(_e[232],ye([1,0,2,10,7,15,63]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(C,A,T,E={timeout:1500,errors:3}){this._logService=C,this._documents=A,this._mainThreadBulkEdits=T,this._thresholds=E,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(A,T,E)=>{const w={dispose:this._callbacks.push([A,T,C])};return Array.isArray(E)&&E.push(w),w}}async $participateInSave(C,A){const T=c.URI.revive(C);let E=!1;const _=setTimeout(()=>E=!0,this._thresholds.timeout),w=[];try{for(const h of[...this._callbacks]){if(E)break;const g=this._documents.getDocument(T),f=await this._deliverEventAsyncAndBlameBadListeners(h,{document:g,reason:P.TextDocumentSaveReason.to(A)});w.push(f)}}finally{clearTimeout(_)}return w}_deliverEventAsyncAndBlameBadListeners([C,A,T],E){const _=this._badListeners.get(C);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,C,A,E).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const h=this._badListeners.get(C);this._badListeners.set(C,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,A,T,E){const _=[],w=Date.now(),{document:h,reason:g}=E,{version:f}=h,b=Object.freeze({document:h,reason:g,waitUntil(m){if(Object.isFrozen(_))throw(0,t.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(m))}});try{A.apply(T,[b])}catch(m){return Promise.reject(m)}return Object.freeze(_),new Promise((m,d)=>{const v=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(v),m(r)}).catch(r=>{clearTimeout(v),d(r)})}).then(m=>{const d={edits:[]};for(const v of m)if(Array.isArray(v)&&v.every(r=>r instanceof I.TextEdit))for(const{newText:r,newEol:o,range:l}of v)d.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:l&&P.Range.from(l),text:r,eol:o&&P.EndOfLine.from(o)}});if(d.edits.length!==0)return f===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(_e[233],ye([1,0,14,2,15,7,91]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(T,E,_,w){this.start=T,this.deletedCount=E,this.deletedItems=_,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(T,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,E,_){this.notebook=T,this._extHostDocument=E,this._cellData=_,this.handle=_.handle,this.uri=t.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const T=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const _={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return T._mime},set mime(w){T._mime=w},get outputs(){return T._outputs.slice(0)},get metadata(){return T._metadata},get executionSummary(){return T._previousResult}};this._apiCell=Object.freeze(_)}return this._apiCell}setOutputs(T){this._outputs=T.map(I.NotebookCellOutput.to)}setOutputItems(T,E,_){const w=_.map(I.NotebookCellOutputItem.to),h=this._outputs.find(g=>g.id===T);if(h&&(E||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(g=>y.isTextStreamMime(g.mime)))){const g=new Map,f=[];h.items.forEach(b=>{let m;g.has(b.mime)?m=g.get(b.mime):(m=[],g.set(b.mime,m),f.push(b.mime)),m.push(b.data)}),h.items.length=0,f.forEach(b=>{const m=y.compressOutputItemStreams(g.get(b));h.items.push({mime:b,data:m.buffer})})}}setMetadata(T){this._metadata=Object.freeze(T)}setInternalMetadata(T){this._internalMetadata=T,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=S;class C{constructor(T,E,_,w,h){this._proxy=T,this._textDocumentsAndEditors=E,this._textDocuments=_,this.uri=w,this.handle=C._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const T=this,E={get uri(){return T.uri},get version(){return T._versionId},get notebookType(){return T._notebookType},get isDirty(){return T._isDirty},get isUntitled(){return T.uri.scheme===c.Schemas.untitled},get isClosed(){return T._disposed},get metadata(){return T._metadata},get cellCount(){return T._cells.length},cellAt(_){return _=T._validateIndex(_),T._cells[_].apiCell},getCells(_){return(_?T._getCells(_):T._cells).map(h=>h.apiCell)},save(){return T._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(T){T.metadata&&(this._metadata=Object.freeze({...this._metadata,...T.metadata}))}acceptDirty(T){this._isDirty=T}acceptModelChanged(T,E,_){this._versionId=T.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:_});const w={notebook:this.apiNotebook,metadata:_,cellChanges:[],contentChanges:[]},h=[];for(const f of T.rawEvents)f.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,w.contentChanges):f.kind===y.NotebookCellsChangeType.Move?this._moveCells(f.index,f.length,f.newIdx,w.contentChanges):f.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),h.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===y.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),h.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),h.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<h.length;f++){const b=h[f],m=g.get(b.cell);if(m===void 0){const d=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});g.set(b.cell,d-1)}else w.cellChanges[m]={...w.cellChanges[m],...b}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(T){return T=T|0,T<0?0:T>=this._cells.length?this._cells.length-1:T}_validateRange(T){let E=T.start|0,_=T.end|0;return E<0&&(E=0),_>this._cells.length&&(_=this._cells.length),T.with({start:E,end:_})}_getCells(T){T=this._validateRange(T);const E=[];for(let _=T.start;_<T.end;_++)E.push(this._cells[_]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(T,E,_){if(this._disposed)return;const w=[],h=[],g=[];if(T.reverse().forEach(f=>{const m=f[2].map(r=>{const o=new S(this,this._textDocumentsAndEditors,r);return E||h.push(S.asModelAddData(this.apiNotebook,r)),o}),d=new k(f[0],f[1],[],m),v=this._cells.splice(f[0],f[1],...m);for(const r of v)g.push(r.uri),d.deletedItems.push(r.apiCell);w.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),_)for(const f of w)_.push(f.asApiEvent())}_moveCells(T,E,_,w){const h=this._cells.splice(T,E);this._cells.splice(_,0,...h);const g=[new k(T,E,h.map(f=>f.apiCell),[]),new k(_,0,[],h)];for(const f of g)w.push(f.asApiEvent())}_setCellOutputs(T,E){this._cells[T].setOutputs(E)}_setCellOutputItems(T,E,_,w){this._cells[T].setOutputItems(E,_,w)}_changeCellLanguage(T,E){const _=this._cells[T];_.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(_.uri,E)}_changeCellMime(T,E){const _=this._cells[T];_.apiCell.mime=E}_changeCellMetadata(T,E){this._cells[T].setMetadata(E)}_changeCellInternalMetadata(T,E){this._cells[T].setInternalMetadata(E)}getCellFromApiCell(T){return this._cells.find(E=>E.apiCell===T)}getCellFromIndex(T){return this._cells[T]}getCell(T){return this._cells.find(E=>E.handle===T)}getCellIndex(T){return this._cells.indexOf(T)}}e.ExtHostNotebookDocument=C,C._handlePool=0}),define(_e[134],ye([1,0,10,15,7]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(k,S,C,A,T,E){this.id=k,this._proxy=S,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=T,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const k=this;this._editor={get notebook(){return k.notebookData.apiNotebook},get selection(){return k._selections[0]},set selection(S){this.selections=[S]},get selections(){return k._selections},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");k._selections=S,k._trySetSelections(S)},get visibleRanges(){return k._visibleRanges},revealRange(S,C){k._proxy.$tryRevealRange(k.id,t.NotebookRange.from(S),C??I.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_trySetSelections(k){this._proxy.$trySetSelections(this.id,k.map(t.NotebookRange.from))}_acceptViewColumn(k){this._viewColumn=k}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(_e[234],ye([1,0,4,13,15]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,S);const C=this._notebooksAndEditors.getEditorById(k);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const S in k)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(k[S]))}};P=je([He(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(_e[235],ye([1,0,15,124,174,21,60,10]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,_,w){const h=this._handles++,{title:g,location:f,cancellable:b}=_,m={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(h,{location:c.ProgressLocation.from(f),title:g,source:m,cancellable:b},E.isUnderDevelopment?void 0:E.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(h,w,!!b)}_withProgress(E,_,w){let h;w&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,h));const g=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),h?.dispose()};let f;try{f=_(new A(this._proxy,E),w&&h?h.token:P.CancellationToken.None)}catch(b){throw g(E),b}return f.then(b=>g(E),b=>g(E)),f}$acceptProgressCanceled(E){const _=this._mapHandleToCancellationSource.get(E);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=S;function C(T,E){return T.message=E.message,typeof E.increment=="number"&&(typeof T.increment=="number"?T.increment+=E.increment:T.increment=E.increment),T}class A extends t.Progress{constructor(E,_){super(w=>this.throttledReport(w)),this._proxy=E,this._handle=_}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}je([(0,y.throttle)(100,(T,E)=>C(T,E),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(_e[135],ye([1,0,35,131,56,92,67,15,2]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(m,d,v,r)=>{let o=d;return{enumerable:!0,configurable:!1,get(){return o},set(l){if(!v(o,l)){const s=o;o=l,m.listener?.(r(l,s))}}}},A=(m,d)=>m===d,T={range:(m,d)=>m===d?!0:!m||!d?!1:m.isEqual(d),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(m,d)=>!(m.length!==d.length||m.some(v=>!d.find(r=>v.id===r.id)))},E=m=>d=>({op:4,update:m(d)}),_=(m,d)=>({range:(()=>{let v;const r=E(o=>({range:c.Range.lift(k.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return v},set(o){m.listener?.({op:6}),T.range(v,o)||(v=o,m.listener?.(r(o)))}}})(),label:C(m,d,T.label,E(v=>({label:v}))),description:C(m,void 0,T.description,E(v=>({description:v}))),sortText:C(m,void 0,T.sortText,E(v=>({sortText:v}))),canResolveChildren:C(m,!1,T.canResolveChildren,v=>({op:2,state:v})),busy:C(m,!1,T.busy,E(v=>({busy:v}))),error:C(m,void 0,T.error,E(v=>({error:k.MarkdownString.fromStrict(v)||null}))),tags:C(m,[],T.tags,(v,r)=>({op:1,new:v.map(k.TestTag.from),old:r.map(k.TestTag.from)}))}),w=m=>{const d=I.TestId.fromString(m.extId),v=new g(d.controllerId,d.localId,m.label,S.URI.revive(m.uri)||void 0);return v.range=k.Range.to(m.range||void 0),v.description=m.description||void 0,v.sortText=m.sortText||void 0,v.tags=m.tags.map(r=>k.TestTag.to({id:(0,y.denamespaceTestTag)(r).tagId})),v},h=m=>{let d;for(const v of m.tests){const r=w(v.item);(0,t.getPrivateApiFor)(r).parent=d,d=r}return d};e.toItemFromContext=h;class g{constructor(d,v,r,o){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const l=(0,t.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof f?void 0:l.parent}},children:{value:(0,P.createTestItemChildren)(l,t.getPrivateApiFor,g),enumerable:!0,writable:!1},..._(l,r)})}}e.TestItemImpl=g;class f extends g{constructor(d,v){super(d,d,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class b extends P.TestItemCollection{constructor(d,v,r){super({controllerId:d,getDocumentVersion:o=>o&&r.getDocument(o)?.version,getApiFor:t.getPrivateApiFor,getChildren:o=>o.children,root:new f(d,v),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(_e[136],ye([1,0,48,10,99,15,7]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(E,_,w){const h=k._Keys.nextId();E.$registerTextEditorDecorationType(_.identifier,h,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){E.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,_){this._throwIfFinalized();let w=null;if(E instanceof y.Position)w=new y.Range(E,E);else if(E instanceof y.Range)w=E;else throw new Error("Unrecognized location");this._pushEdit(w,_,!1)}insert(E,_){this._throwIfFinalized(),this._pushEdit(new y.Range(E,E),_,!0)}delete(E){this._throwIfFinalized();let _=null;if(E instanceof y.Range)_=E;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(E,_,w){const h=this._document.validateRange(E);this._collectedEdits.push({range:h,text:_,forceMoveMarkers:w})}setEndOfLine(E){if(this._throwIfFinalized(),E!==y.EndOfLine.LF&&E!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class C{constructor(E,_,w,h){this._proxy=E,this._id=_,this._accept(w),this._logService=h;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(f){g._setTabSize(f)},get insertSpaces(){return g._insertSpaces},set insertSpaces(f){g._setInsertSpaces(f)},get cursorStyle(){return g._cursorStyle},set cursorStyle(f){g._setCursorStyle(f)},get lineNumbers(){return g._lineNumbers},set lineNumbers(f){g._setLineNumbers(f)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const _=Math.floor(E);return _>0?_:null}if(typeof E=="string"){const _=parseInt(E,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(E){const _=this._validateTabSize(E);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const _=this._validateInsertSpaces(E);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const _={};let w=!1;if(typeof E.tabSize<"u"){const h=this._validateTabSize(E.tabSize);h==="auto"?(w=!0,_.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,w=!0,_.tabSize=h)}if(typeof E.insertSpaces<"u"){const h=this._validateInsertSpaces(E.insertSpaces);h==="auto"?(w=!0,_.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,w=!0,_.insertSpaces=h)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,w=!0,_.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,w=!0,_.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(E,_){_.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=C;class A{constructor(E,_,w,h,g,f,b,m){this.id=E,this._proxy=_,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new C(this._proxy,this.id,f,w),this._visibleRanges=b,this._viewColumn=m;const d=this;this.value=Object.freeze({get document(){return h.getValue()},set document(v){throw(0,t.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,t.illegalArgument)("selection");d._selections=[v],d._trySetSelection()},get selections(){return d._selections},set selections(v){if(!Array.isArray(v)||v.some(r=>!(r instanceof y.Selection)))throw(0,t.illegalArgument)("selections");d._selections=v,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(v){throw(0,t.readonly)("visibleRanges")},get options(){return d._options.value},set options(v){d._disposed||d._options.assign(v)},get viewColumn(){return d._viewColumn},set viewColumn(v){throw(0,t.readonly)("viewColumn")},edit(v,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(h.getValue(),r);return v(o),d._applyEdit(o)},insertSnippet(v,r,o={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!r||Array.isArray(r)&&r.length===0)l=d._selections.map(s=>P.Range.from(s));else if(r instanceof y.Position){const{lineNumber:s,column:a}=P.Position.from(r);l=[{startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a}]}else if(r instanceof y.Range)l=[P.Range.from(r)];else{l=[];for(const s of r)if(s instanceof y.Range)l.push(P.Range.from(s));else{const{lineNumber:a,column:u}=P.Position.from(s);l.push({startLineNumber:a,startColumn:u,endLineNumber:a,endColumn:u})}}return _.$tryInsertSnippet(E,h.getValue().version,v.value,l,o)},setDecorations(v,r){const o=r.length===0;o&&!d._hasDecorationsForKey.has(v.key)||(o?d._hasDecorationsForKey.delete(v.key):d._hasDecorationsForKey.add(v.key),d._runOnProxy(()=>{if(P.isDecorationOptionsArr(r))return _.$trySetDecorations(E,v.key,P.fromRangeOrRangeWithMessage(r));{const l=new Array(4*r.length);for(let s=0,a=r.length;s<a;s++){const u=r[s];l[4*s]=u.start.line+1,l[4*s+1]=u.start.character+1,l[4*s+2]=u.end.line+1,l[4*s+3]=u.end.character+1}return _.$trySetDecorationsFast(E,v.key,l)}}))},revealRange(v,r){d._runOnProxy(()=>_.$tryRevealRange(E,P.Range.from(v),r||y.TextEditorRevealType.Default))},show(v){_.$tryShowEditor(E,P.ViewColumn.from(v))},hide(){_.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,c.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,c.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,c.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const _=E.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const w=_.edits.map(g=>g.range);w.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=w.length-1;g<f;g++){const b=w[g].end;if(w[g+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=_.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,h,{setEndOfLine:typeof _.setEndOfLine=="number"?P.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=A}),define(_e[236],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(_e[237],ye([1,0,188,10,42,121,125,43,26,236,199]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const T=k.Registry.as(y.Extensions.JSONContribution);class E{constructor(d,v,r){this._messageHandler=d,this._extension=v,this._extensionPointId=r}_msg(d,v){this._messageHandler({type:d,message:v,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(I.default.Error,d)}warn(d){this._msg(I.default.Warning,d)}info(d){this._msg(I.default.Info,d)}}e.ExtensionMessageCollector=E;class _{static _toSet(d){const v=new Set;for(let r=0,o=d.length;r<o;r++)v.add(S.ExtensionIdentifier.toKey(d[r].description.identifier));return v}static compute(d,v){if(!d||!d.length)return new _(v,[]);if(!v||!v.length)return new _([],d);const r=this._toSet(d),o=this._toSet(v),l=v.filter(a=>!r.has(S.ExtensionIdentifier.toKey(a.description.identifier))),s=d.filter(a=>!o.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new _(l,s)}constructor(d,v){this.added=d,this.removed=v}}e.ExtensionPointUserDelta=_;class w{constructor(d,v){this.name=d,this.defaultExtensionKind=v,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=_.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,t.onUnexpectedError)(d)}}}e.ExtensionPoint=w;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},activationEvents:{description:c.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(30,null)},{label:"onUri",body:"onUri",description:c.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(35,null)},{label:"onRenderer",description:c.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(38,null)},{label:"*",description:c.localize(39,null),body:"*"}]}},badges:{type:"array",description:c.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(41,null)},href:{type:"string",description:c.localize(42,null)},description:{type:"string",description:c.localize(43,null)}}}},markdown:{type:"string",description:c.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(49,null)},{body:["workspace"],description:c.localize(50,null)},{body:["ui","workspace"],description:c.localize(51,null)},{body:["workspace","ui"],description:c.localize(52,null)},{body:[],description:c.localize(53,null)}]},capabilities:{description:c.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(57,null),c.localize(58,null),c.localize(59,null)]},description:{type:"string",markdownDescription:c.localize(60,null)}}},untrustedWorkspaces:{description:c.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)]},restrictedConfigurations:{description:c.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(67,null)}}}}},sponsor:{description:c.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(70,null),type:"string"},"vscode:uninstall":{description:c.localize(71,null),type:"string"}}},icon:{type:"string",description:c.localize(72,null)},l10n:{type:"string",description:c.localize(73,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const v=new w(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,v),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,T.registerSchema(g,e.schema),v}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const b={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(b.ExtensionsRegistry,new f),e.ExtensionsRegistry=k.Registry.as(b.ExtensionsRegistry),T.registerSchema(g,e.schema),T.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(_e[238],ye([1,0,185,11,24,237,53,4]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var C;(function(E){function _(w,h,g){if(!w)return;const f=t.isString(w.type)?w.type:void 0;if(!f||f.length===0){g.error(c.localize(3,null));return}const b=[];if(Array.isArray(w.required))for(const m of w.required)t.isString(m)&&b.push(m);return{extensionId:h.value,taskType:f,required:b,properties:w.properties?I.deepClone(w.properties):{},when:w.when?y.ContextKeyExpr.deserialize(w.when):void 0}}E.from=_})(C||(C={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class T{constructor(){this._onDefinitionsChanged=new k.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((_,w)=>{A.setHandler((h,g)=>{this._schema=void 0;try{for(const f of g.removed){const b=f.value;for(const m of b)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const f of g.added){const b=f.value;for(const m of b){const d=C.from(m,f.description.identifier,f.collector);d&&(this.taskTypes[d.taskType]=d)}}(g.removed.length>0||g.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}_(void 0)})})}onReady(){return this.readyPromise}get(_){return this.taskTypes[_]}all(){return Object.keys(this.taskTypes).map(_=>this.taskTypes[_])}getJsonSchema(){if(this._schema===void 0){const _=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=I.deepClone(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},_.push(h)}this._schema={oneOf:_}}return this._schema}}e.TaskDefinitionRegistry=new T}),define(_e[239],ye([1,0,186,11,22,24,53,238]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(M){if(!M)return F.Strong;switch(M.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(F){function B(M){switch(M.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(A=e.RevealKind||(e.RevealKind={}));var T;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(M){switch(M.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function B(M){switch(M.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(E=e.PanelKind||(e.PanelKind={}));var _;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:T.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(_=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(F){function B(z){switch(z.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function M(z){switch(z){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=M}(w=e.RuntimeType||(e.RuntimeType={}));var h;(function(F){function B(M){return t.isString(M)?M:M.value}F.value=B})(h=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(z){return z===F.Clean._id||z===F.Build._id||z===F.Rebuild._id||z===F.Test._id}F.is=B;function M(z){if(z!==void 0)return t.isString(z)?B(z)?{_id:z,isDefault:!1}:void 0:z}F.from=M})(g=e.TaskGroup||(e.TaskGroup={}));var f;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var b;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(M){switch(M){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(F){F.parallel="parallel",F.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var d;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(d=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:d.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class r{constructor(B,M,z,j,$,Q){this._label="",this._id=B,M&&(this._label=M),z&&(this.type=z),this.runOptions=j,this.configurationProperties=$,this._source=Q}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.getFolderId(),id:this._id};return JSON.stringify(B)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,M=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||M&&B===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),B&&(this._taskLoadMessages=this._taskLoadMessages.concat(B))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class o extends r{constructor(B,M,z,j,$,Q,K,ue){super(B,z,void 0,K,ue,M),this.command={},this._source=M,this.hasDefinedMatchers=Q,$&&(this.command=$)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case w.Shell:M="shell";break;case w.Process:M="process";break;case w.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let M=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(M+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:M};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class l extends r{constructor(B,M,z,j,$,Q,K){super(B,z,j,Q,K,M),this._source=M,this.configures=$}static is(B){return B instanceof l}fromObject(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.getFolderId();if(!B)return;let M=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(M+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:M};return JSON.stringify(z)}}e.ConfiguringTask=l;class s extends r{constructor(B,M,z,j,$,Q,K,ue,re){super(B,z,j,ue,re,M),this.defines=$,this.hasDefinedMatchers=K,this.command=Q,this.icon=re.icon,this.hide=re.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof s}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.getFolderId(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(B){return new s(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=s;class a extends r{constructor(B,M,z,j,$,Q){super(B,z,j,$,Q,M),this._source=M}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(B){return new a(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=a;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(B){this._order=new Map;for(let M=0;M<B.length;M++)this._order.set(B[M].uri.toString(),M)}compare(B,M){const z=B.getWorkspaceFolder(),j=M.getWorkspaceFolder();if(z&&j){let $=this._order.get(z.uri.toString());$=$===void 0?0:$+1;let Q=this._order.get(j.uri.toString());return Q=Q===void 0?0:Q+1,$===Q?B._label.localeCompare(M._label):$-Q}else return!z&&j?-1:z&&!j?1:0}}e.TaskSorter=i;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var D;(function(F){F.SingleRun="singleRun",F.Background="background"})(D=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(F){function B(M,z,j,$){if(z){const Q={kind:M,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:j,__task:z};return M==="start"?Q.resolvedVariables=$:M==="processStarted"?Q.processId=$:M==="processEnded"&&(Q.exitCode=$),Object.freeze(Q)}else return Object.freeze({kind:"changed"})}F.create=B})(N=e.TaskEvent||(e.TaskEvent={}));var V;(function(F){function B(z){const j=Object.keys(z).sort();let $="";for(const Q of j){let K=z[Q];K instanceof Object?K=B(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),$+=Q+","+K+","}return $}function M(z){const $={_key:B(z),type:z.taskType};return Object.assign($,z),$}F.create=M})(V=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(F){function B(M,z){const j=k.TaskDefinitionRegistry.get(M.type);if(j===void 0){const ue=P.deepClone(M);return delete ue._key,V.create(ue)}const $=Object.create(null);$.type=j.taskType;const Q=new Set;j.required.forEach(ue=>Q.add(ue));const K=j.properties;for(const ue of Object.keys(K)){const re=M[ue];if(re!=null)$[ue]=re;else if(Q.has(ue)){const de=K[ue];if(de.default!==void 0)$[ue]=P.deepClone(de.default);else switch(de.type){case"boolean":$[ue]=!1;break;case"number":case"integer":$[ue]=0;break;case"string":$[ue]="";break;default:z.error(c.localize(2,null,JSON.stringify(M,void 0,0),ue));return}}}return V.create($)}F.createTaskIdentifier=B})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(_e[240],ye([1,0,10]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,k)=>{this._actualOk=y,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,c.onUnexpectedError)(y))}then(y,k){return this._ensureActual().then(y,k)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class I extends t{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=I}),define(_e[57],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function I(k){const S=new c(k);return t[S.nid]=S,S}e.createProxyIdentifier=I;function P(k){return t[k].sid}e.getStringIdentifierForProxy=P;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(_e[5],ye([1,0,57]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var P;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(g){return g._id=T._n++,g}}e.IdObject=T,T._n=0;var E;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(_e[68],ye([1,0,3,13,5,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,C,A){const T=this.getUsageKey(S,C);this._reportedUsages.has(T)||(this._reportedUsages.add(T),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};y=je([He(0,P.IExtHostRpcService),He(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,C){}})}),define(_e[241],ye([1,0,4,5,7,26]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,C,A,T={}){const E=P.ExtensionIdentifier.toKey(S.identifier),_=this._inFlightRequests.get(E)||[],w=[...A].sort().join(" ");let h=_.find(g=>g.providerId===C&&g.scopes===w);if(h)return h.result;{const g=this._getSession(S,E,C,A,T);h={providerId:C,scopes:w,result:g},_.push(h),this._inFlightRequests.set(E,_);try{await g}finally{const f=_.findIndex(b=>b.providerId===C&&b.scopes===w);f>-1&&(_.splice(f),this._inFlightRequests.set(E,_))}return g}}async _getSession(S,C,A,T,E={}){await this._proxy.$ensureProvider(A);const _=S.displayName||S.name;return this._proxy.$getSession(A,T,C,_,E)}async removeSession(S,C){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,A,T){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:A,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===S)||this._providers.push({id:S,label:C});const E=A.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(S,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,C,T?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(S);const _=this._providers.findIndex(w=>w.id===S);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(_e[242],ye([1,0,5,16,15]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(k,S){this._proxy=k.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k,S,C){const A=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,C?.isRefactoring??!1)}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(_e[243],ye([1,0,5]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[39],ye([1,0,11,7,15,24,5,17,13,83,35,49,2,6,3,16,135,23,57,50]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m){"use strict";var d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(n,i){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,v.set(this,void 0),tt(this,d,n.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=i,tt(this,v,n.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,p=>{const D=this._apiCommands.get(p);return D?.result===s.Void?D:void 0},i),this._argumentProcessors=[{processArgument(p){return(0,C.revive)(p)}},{processArgument(p){return(0,P.cloneAndChange)(p,function(D){if(A.Range.isIRange(D))return I.Range.to(D);if(T.Position.isIPosition(D))return I.Position.to(D);if(A.Range.isIRange(D.range)&&E.URI.isUri(D.uri))return I.location.to(D);if(D instanceof f.VSBuffer)return D.buffer.buffer;if(!Array.isArray(D))return D})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const i=this.registerCommand(!1,n.id,async(...p)=>{const D=n.args.map((N,V)=>{if(!N.validate(p[V]))throw new Error(`Invalid argument '${N.name}' when running '${n.id}', received: ${p[V]}`);return N.convert(p[V])}),R=await this.executeCommand(n.internalId,...D);return n.result.convert(R,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{i.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,i,p,D,R,N){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:p,thisArg:D,description:R,extension:N}),n&&Ne(this,d,"f").$registerCommand(i),new t.Disposable(()=>{this._commands.delete(i)&&n&&Ne(this,d,"f").$unregisterCommand(i)})}executeCommand(n,...i){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,i,!0)}async _doExecuteCommand(n,i,p){if(this._commands.has(n))return Ne(this,d,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,i,!1);{let D=!1;const R=(0,P.cloneAndChange)(i,function(N){if(N instanceof t.Position)return I.Position.from(N);if(N instanceof t.Range)return I.Range.from(N);if(N instanceof t.Location)return I.location.from(N);if(t.NotebookRange.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return D=!0,f.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return D=!0,f.VSBuffer.wrap(N);if(N instanceof f.VSBuffer)return D=!0,N;if(!Array.isArray(N))return N});try{const N=await Ne(this,d,"f").$executeCommand(n,D?new b.SerializableObjectWithBuffers(R):R,p);return(0,C.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(n,i,!1);throw N}}}async _executeContributedCommand(n,i,p){const D=this._commands.get(n);if(!D)throw new Error("Unknown command");const{callback:R,thisArg:N,description:V}=D;if(V)for(let L=0;L<V.args.length;L++)try{(0,c.validateConstraint)(i[L],V.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${V.args[L].name}' - ${V.args[L].description}`)}const x=Date.now();try{return await R.apply(N,i)}catch(L){if(n===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...i);U&&(n=U.command)}throw this._logService.error(L,n,D.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)(L)),this.id=n,this.source=D.extension?.displayName??D.extension?.name}}:L}finally{this._reportTelemetry(D,n,Date.now()-x)}}_reportTelemetry(n,i,p){!n.extension||n.extension.isBuiltin||Ne(this,v,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:i,duration:p})}$executeContributedCommand(n,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(i=i.map(p=>this._argumentProcessors.reduce((D,R)=>R.processArgument(D),p)),this._executeContributedCommand(n,i,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Ne(this,d,"f").$getCommands().then(i=>(n&&(i=i.filter(p=>p[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[i,p]of this._commands){const{description:D}=p;D&&(n[i]=D)}return Promise.resolve(n)}};d=new WeakMap,v=new WeakMap,r=je([He(0,h.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class o{constructor(n,i,p){this._commands=n,this._lookupApiCommand=i,this._logService=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,i){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const D=this._lookupApiCommand(n.command);if(D)p.id=D.internalId,p.arguments=D.args.map((R,N)=>R.convert(n.arguments&&n.arguments[N]));else if((0,k.isNonEmptyArray)(n.arguments)){const R=`${n.command}/${++this._cachIdPool}`;this._cache.set(R,n),i.add((0,_.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),p.$ident=R,p.id=this.delegatingCommandId,p.arguments=[R],this._logService.trace("CommandsConverter#CREATE",n.command,R)}return p}fromInternal(n){return typeof n.$ident=="string"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const i=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=o;class l{constructor(n,i,p,D){this.name=n,this.description=i,this.validate=p,this.convert=D}optional(){return new l(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,i){return new l(n??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",u=>E.URI.isUri(u),u=>u),l.Position=new l("position","A position in a text document",u=>t.Position.isPosition(u),I.Position.from),l.Range=new l("range","A range in a text document",u=>t.Range.isRange(u),I.Range.from),l.Selection=new l("selection","A selection in a text document",u=>t.Selection.isSelection(u),I.Selection.from),l.Number=new l("number","",u=>typeof u=="number",u=>u),l.String=new l("string","",u=>typeof u=="string",u=>u),l.CallHierarchyItem=new l("item","A call hierarchy item",u=>u instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",u=>u instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",u=>u instanceof g.TestItemImpl,I.TestItem.from);class s{constructor(n,i){this.description=n,this.convert=i}}e.ApiCommandResult=s,s.Void=new s("no result",u=>u);class a{constructor(n,i,p,D,R){this.id=n,this.internalId=i,this.description=p,this.args=D,this.result=R}}e.ApiCommand=a}),define(_e[244],ye([1,0,2,15,7,66,39,17,118,123,14]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,k.isFalsyOrEmpty)(h))return;class f extends I.SymbolInformation{static to(m){const d=new f(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new I.Location(g[0],t.Range.to(m.range)));return d.detail=m.detail,d.range=d.location.range,d.selectionRange=t.Range.to(m.selectionRange),d.children=m.children?m.children.map(f.to):[],d}}return h.map(f.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>I.Position.isPosition(g)),h=>h.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(g=>{let f;for(const b of g.reverse())f=new I.SelectionRange(t.Range.to(b),f);return f}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:t.Range.to(h.range),placeholder:h.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return t.WorkspaceEdit.to(h)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new I.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,S.decodeSemanticTokensDto)(h);if(g.type==="full")return new I.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,g,f)=>{if(!h)return new I.CompletionList([]);const b=h.suggestions.map(m=>t.CompletionItem.to(m,f));return new I.CompletionList(b,h.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return t.SignatureHelp.to(h)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,g,f)=>_(b=>new I.CodeLens(t.Range.to(b.range),b.command&&f.fromInternal(b.command)))(h))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>I.Range.isRange(h),h=>I.Selection.isSelection(h)?t.Selection.from(h):t.Range.from(h)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,g,f)=>_(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(b.command)}else{const m=new I.CodeAction(b.title,b.kind?new I.CodeActionKind(b.kind):void 0);return b.edit&&(m.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(m.command=f.fromInternal(b.command)),m.isPreferred=b.isPreferred,m}})(h))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new I.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",h=>h instanceof I.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:t.Range.from(h.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,g,f)=>h.map(t.InlayHint.to.bind(void 0,f)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>c.URI.isUri(h)||typeof h=="string"&&(0,C.matchesSomeScheme)(h,A.Schemas.http,A.Schemas.https),h=>h),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[t.ViewColumn.from(h),void 0]:[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[t.ViewColumn.from(h.viewColumn),t.TextEditorOpenOptions.from(h)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class E{static register(g){T.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function _(h){return g=>{if(Array.isArray(g))return g.map(h)}}function w(h){if(!Array.isArray(h))return;const g=[];for(const f of h)P.isLocationLink(f)?g.push(t.DefinitionLink.to(f)):g.push(t.location.to(f));return g}}),define(_e[245],ye([1,0,18,60,4,6,2,66,26,15,7,27,5]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function _(w,h,g){const f=w.getProxy(E.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this._commentControllers.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this._commentControllers.get(u.commentControlHandle);if(!n)return u;const i=n.getCommentThread(u.commentThreadHandle);return i?i.value:u}else if(u&&u.$mid===8){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const i=n.getCommentThread(u.thread.commentThreadHandle);return i?{thread:i.value,text:u.text}:u}else if(u&&u.$mid===9){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const i=n.getCommentThread(u.thread.commentThreadHandle);if(!i)return u;const p=u.commentUniqueId,D=i.getCommentByUniqueId(p);return D||u}else if(u&&u.$mid===10){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const i=n.getCommentThread(u.thread.commentThreadHandle);if(!i)return u;const p=u.text,D=u.commentUniqueId,R=i.getCommentByUniqueId(D);return R?(typeof R.body=="string"?R.body=p:R.body.value=p,R):u}return u}})}createCommentController(u,n,i){const p=b.handlePool++,D=new d(u,p,n,i);this._commentControllers.set(D.handle,D);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(D),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(u.identifier),R),D.value}$createCommentThreadTemplate(u,n,i){const p=this._commentControllers.get(u);!p||p.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(u,n,i){const p=this._commentControllers.get(u);!p||p.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(u,n){this._commentControllers.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,i){const p=this._commentControllers.get(u);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const D=g.getDocument(y.URI.revive(n));return(0,c.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(D,i)).then(R=>R?R.map(N=>C.Range.from(N)):void 0)}$toggleReaction(u,n,i,p,D){const R=this._commentControllers.get(u);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const N=R.getCommentThread(n);if(N){const V=N.getCommentByUniqueId(p.uniqueIdInThread);if(R!==void 0&&V&&R.reactionHandler)return R.reactionHandler(V,o(D))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class m{set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(u){(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,n,i,p,D,R,N,V){this._commentControllerHandle=n,this._id=i,this._uri=p,this._range=D,this._comments=R,this.extensionDescription=N,this._isTemplate=V,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),f.$createCommentThread(n,this.handle,this._id,this._uri,C.Range.from(this._range),N.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(n,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(L){x.range=L},get comments(){return x.comments},set comments(L){x.comments=L},get collapsibleState(){return x.collapsibleState},set collapsibleState(L){x.collapsibleState=L},get canReply(){return x.canReply},set canReply(L){x.canReply=L},get contextValue(){return x.contextValue},set contextValue(L){x.contextValue=L},get label(){return x.label},set label(L){x.label=L},get state(){return x.state},set state(L){x.state=L},dispose:()=>{x.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=i=>Object.prototype.hasOwnProperty.call(this.modifications,i),n={};u("range")&&(n.range=C.Range.from(this._range)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this._comments.map(i=>v(this,i,this._commentsMap))),u("collapsibleState")&&(n.collapseState=l(this._collapseState)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=s(this._state)),u("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(u){for(const n of this._commentsMap){const i=n[0],p=n[1];if(u===p)return i}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}m._handlePool=0,je([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class d{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,n,i,p){this._extension=u,this._handle=n,this._id=i,this._label=p,this._threads=new Map,f.$registerCommentController(this.handle,i,p);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(R){D.options=R},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(R){D.commentingRangeProvider=R},get reactionHandler(){return D.reactionHandler},set reactionHandler(R){D.reactionHandler=R},createCommentThread(R,N,V){return D.createCommentThread(R,N,V).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,i,p){if(typeof u=="string"){const D=new m(this.id,this.handle,u,n,i,p,this._extension,!1);return this._threads.set(D.handle,D),D}else{const D=new m(this.id,this.handle,void 0,u,n,i,this._extension,!1);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(u,n){const i=new m(this.id,this.handle,void 0,y.URI.revive(u),C.Range.to(n),[],this._extension,!0);return i.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(u,n){const i=this._threads.get(u);i&&(i.range=C.Range.to(n))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function v(a,u,n){let i=n.get(u);i||(i=++a.commentHandle,n.set(u,i));const p=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:i,body:typeof u.body=="string"?u.body:C.MarkdownString.from(u.body),userName:u.author.name,userIconPath:p,label:u.label,commentReactions:u.reactions?u.reactions.map(D=>r(D)):void 0,timestamp:u.timestamp?.toJSON()}}function r(a){return{label:a.label,iconPath:a.iconPath?C.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function o(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?y.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function l(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function s(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new b}e.createExtHostComments=_}),define(_e[246],ye([1,0,24,5,25,16]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(A,T){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=T.consoleForward.includeStack,this._logNative=T.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,T){const E=this,_=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){E._handleConsoleCall(A,T,_,arguments)}})}_handleConsoleCall(A,T,E,_){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:T,arguments:S(_,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,E,_)}};y=je([He(0,P.IExtHostRpcService),He(1,I.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const k=1e5;function S(C,A){const T=[];if(C.length)for(let E=0;E<C.length;E++){let _=C[E];if(typeof _>"u")_="undefined";else if(_ instanceof Error){const w=_;w.stack?_=w.stack:_=w.toString()}T.push(_)}if(A){const E=new Error().stack;E&&T.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(T);return E.length>k?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(_e[137],ye([1,0,2,5,7,3,16,13,17,8,9]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class Pn{constructor(_,w){this._logService=w,this._provider=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(_,w){const h=Pn._handlePool++;this._provider.set(h,{provider:_,extensionId:w}),this._proxy.$registerDecorationProvider(h,w.value);const g=_.onDidChangeFileDecorations&&_.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(h,null);return}const b=(0,S.asArray)(f);if(b.length<=Pn._maxEventSize){this._proxy.$onDidChange(h,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,b.length);const m=b.map(r=>({uri:r,rank:(0,C.count)(r.path,"/")})),d=(0,S.groupBy)(m,(r,o)=>r.rank-o.rank||(0,C.compare)(r.uri.path,o.uri.path)),v=[];e:for(const r of d){let o;for(const l of r){const s=(0,A.dirname)(l.uri.path);if(o!==s&&(o=s,v.push(l.uri)>=Pn._maxEventSize))break e}}this._proxy.$onDidChange(h,v)});return new I.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(_,w,h){if(!this._provider.has(_))return Object.create(null);const g=Object.create(null),{provider:f,extensionId:b}=this._provider.get(_);return await Promise.all(w.map(async m=>{try{const{uri:d,id:v}=m,r=await Promise.resolve(f.provideFileDecoration(c.URI.revive(d),h));if(!r)return;try{I.FileDecoration.validate(r),g[v]=[r.propagate,r.tooltip,r.badge,r.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${b.value}': ${o}`)}}catch(d){this._logService.error(d)}})),g}};T._handlePool=0,T._maxEventSize=250,T=je([He(0,y.IExtHostRpcService),He(1,k.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[247],ye([1,0,172,122,2,5,7,15,4,13,28,46]),function(Z,e,c,t,I,P,y,k,S,C,A,T){"use strict";var E,_,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(b,m,d,v,r,o,l){this._name=b,this._owner=m,this._maxDiagnosticsPerFile=d,this._modelVersionIdProvider=v,E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,tt(this,w,new A.ResourceMap(s=>r.getComparisonKey(s)),"f"),tt(this,E,o,"f"),tt(this,_,l,"f")}dispose(){this._isDisposed||(Ne(this,_,"f").fire([...Ne(this,w,"f").keys()]),Ne(this,E,"f")?.$clear(this._owner),Ne(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,m){if(!b){this.clear();return}this._checkDisposed();let d=[];if(I.URI.isUri(b)){if(!m){this.delete(b);return}Ne(this,w,"f").set(b,m.slice()),d=[b]}else if(Array.isArray(b)){d=[];let r;b=[...b].sort(h._compareIndexedTuplesByUri);for(const o of b){const[l,s]=o;if((!r||l.toString()!==r.toString())&&(r&&Ne(this,w,"f").get(r).length===0&&Ne(this,w,"f").delete(r),r=l,d.push(l),Ne(this,w,"f").set(l,[])),s)Ne(this,w,"f").get(l)?.push(...s);else{const a=Ne(this,w,"f").get(l);a&&(a.length=0)}}}if(Ne(this,_,"f").fire(d),!Ne(this,E,"f"))return;const v=[];for(const r of d){let o=[];const l=Ne(this,w,"f").get(r);if(l)if(l.length>this._maxDiagnosticsPerFile){o=[];const s=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const u of l)if(u.severity===s[a]&&o.push({...k.Diagnostic.from(u),modelVersionId:this._modelVersionIdProvider(r)})===this._maxDiagnosticsPerFile)break e;o.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=l.map(s=>({...k.Diagnostic.from(s),modelVersionId:this._modelVersionIdProvider(r)}));v.push([r,o])}Ne(this,E,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Ne(this,_,"f").fire([b]),Ne(this,w,"f").delete(b),Ne(this,E,"f")?.$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ne(this,_,"f").fire([...Ne(this,w,"f").keys()]),Ne(this,w,"f").clear(),Ne(this,E,"f")?.$clear(this._owner)}forEach(b,m){this._checkDisposed();for(const[d,v]of this)b.call(m,d,v,this)}*[(E=new WeakMap,_=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const b of Ne(this,w,"f").keys())yield[b,this.get(b)]}get(b){this._checkDisposed();const m=Ne(this,w,"f").get(b);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ne(this,w,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,m){return b[0].toString()<m[0].toString()?-1:b[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=h;let g=class mn{static _mapper(b){const m=new A.ResourceMap;for(const d of b)m.set(d,d);return{uris:Object.freeze(Array.from(m.values()))}}constructor(b,m,d,v){this._logService=m,this._fileSystemInfoService=d,this._extHostDocumentsAndEditors=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,mn._mapper),this._proxy=b.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,m){const{_collections:d,_proxy:v,_onDidChangeDiagnostics:r,_logService:o,_fileSystemInfoService:l,_extHostDocumentsAndEditors:s}=this,a=new class{$changeMany(i,p){v.$changeMany(i,p),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,i,p.length===0?"CLEARING":p)}$clear(i){v.$clear(i),o.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,i)}dispose(){v.dispose()}};let u;if(!m)m="_generated_diagnostic_collection_name_#"+mn._idPool++,u=m;else if(!d.has(m))u=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do u=m+mn._idPool++;while(d.has(u))}return new class extends h{constructor(){super(m,u,mn._maxDiagnosticsPerFile,i=>s.getDocument(i)?.version,l.extUri,a,r),d.set(u,this)}dispose(){super.dispose(),d.delete(u)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const m=new Map,d=[];for(const v of this._collections.values())v.forEach((r,o)=>{let l=m.get(r.toString());typeof l>"u"&&(l=d.length,m.set(r.toString(),l),d.push([r,[]])),d[l][1]=d[l][1].concat(...o)});return d}}_getDiagnostics(b){let m=[];for(const d of this._collections.values())d.has(b)&&(m=m.concat(d.get(b)));return m}$acceptMarkersChange(b){if(!this._mirrorCollection){const m="_generated_mirror",d=new h(m,m,mn._maxDiagnosticsPerFile,v=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,d),this._mirrorCollection=d}for(const[m,d]of b)this._mirrorCollection.set(I.URI.revive(m),d.map(k.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([He(1,C.ILogService),He(2,T.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(_e[248],ye([1,0,2,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?c.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(_e[249],ye([1,0,10,2,7,5,14,21,8]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(T,E,_){this._documentsAndEditors=E,this._logService=_,this._documentContentProviders=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,E){if(Object.keys(y.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const _=C._handlePool++;this._documentContentProviders.set(_,E),this._proxy.$registerTextContentProvider(_,T);let w;return typeof E.onDidChange=="function"&&(w=E.onDidChange(h=>{if(h.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(_,h).then(g=>{if(!g&&typeof g!="string")return;const f=this._documentsAndEditors.getDocument(h);if(!f)return;const b=(0,S.splitLines)(g);if(!f.equalLines(b))return this._proxy.$onVirtualDocumentChange(h,g)},c.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(T,E){const _=this._documentContentProviders.get(T);return _?Promise.resolve(_.provideTextDocumentContent(t.URI.revive(E),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(_e[250],ye([1,0,4,6,2,5,133,15,11,24,7]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(_,w){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const g of h)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const g of h)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const w=this._documentsAndEditors.getDocument(_);if(w)return w}getDocument(_){const w=this.getDocumentData(_);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return w.document}ensureDocumentData(_){const w=this._documentsAndEditors.getDocument(_);if(w)return Promise.resolve(w);let h=this._documentLoader.get(_.toString());return h||(h=this._proxy.$tryOpenDocument(_).then(g=>{this._documentLoader.delete(_.toString());const f=I.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(f))},g=>(this._documentLoader.delete(_.toString()),Promise.reject(g))),this._documentLoader.set(_.toString(),h)),h}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(w=>I.URI.revive(w))}$acceptModelLanguageChanged(_,w){const h=I.URI.revive(_),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(w),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(_){const w=I.URI.revive(_),h=this._documentsAndEditors.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(_,w){const h=I.URI.revive(_),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,w,h){const g=I.URI.revive(_),f=this._documentsAndEditors.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),f.onEvents(w);let b;w.isUndoing?b=A.TextDocumentChangeReason.Undo:w.isRedoing&&(b=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:f.document,contentChanges:w.changes.map(m=>({range:k.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:b}))}setWordDefinitionFor(_,w){(0,y.setWordDefinitionFor)(_,w)}}e.ExtHostDocuments=T}),define(_e[58],ye([1,0,48,4,6,2,3,5,133,16,136,15,13,28,14,62,79]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let b=class{constructor(d,v){this._extHostRpc=d,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const v=[],r=[],o=[];if(d.removedDocuments)for(const l of d.removedDocuments){const s=P.URI.revive(l),a=this._documents.get(s);a?.unref()&&(this._documents.delete(s),v.push(a.value))}if(d.addedDocuments)for(const l of d.addedDocuments){const s=P.URI.revive(l.uri);let a=this._documents.get(s);if(a&&s.scheme!==w.Schemas.vscodeNotebookCell&&s.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);a||(a=new f(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),s,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this._documents.set(s,a),r.push(a.value)),a.ref()}if(d.removedEditors)for(const l of d.removedEditors){const s=this._editors.get(l);this._editors.delete(l),s&&o.push(s)}if(d.addedEditors)for(const l of d.addedEditors){const s=P.URI.revive(l.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const a=this._documents.get(s).value,u=new A.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>a.document),l.selections.map(T.Selection.to),l.options,l.visibleRanges.map(n=>T.Range.to(n)),typeof l.editorPosition=="number"?T.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,u)}d.newActiveEditor!==void 0&&(c.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,I.dispose)(v),(0,I.dispose)(o),d.removedDocuments&&this._onDidRemoveDocuments.fire(v),d.addedDocuments&&this._onDidAddDocuments.fire(r),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return d?v:v?.value}allEditors(){return[...this._editors.values()]}};b=je([He(0,C.IExtHostRpcService),He(1,E.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[59],ye([1,0,15,5,2,4,3,7,16,11,78]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class T{constructor(g,f,b){this._activeTabIdGetter=b,this._parentGroup=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get input(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 3:return new k.TextMergeTabInput(I.URI.revive(this._dto.input.base),I.URI.revive(this._dto.input.input1),I.URI.revive(this._dto.input.input2),I.URI.revive(this._dto.input.result));case 6:return new k.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new k.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(I.URI.revive(this._dto.input.uri),I.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(g,f){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=f;for(const b of g.tabs)b.isActive&&(this._activeTabId=b.id),this._tabs.push(new T(b,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return c.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(b=>b.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(b=>b.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabOperation(g){if(g.kind===0){const b=new T(g.tabDto,this,()=>this.activeTabId());return this._tabs.splice(g.index,0,b),g.tabDto.isActive&&(this._activeTabId=b.tabId),b}else if(g.kind===1){const b=this._tabs.splice(g.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return b.tabId===this._activeTabId&&(this._activeTabId=""),b}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this._tabs.splice(g.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this._tabs.splice(g.index,0,b),b}const f=this._tabs.find(b=>b.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this._activeTabId=g.tabDto.id:this._activeTabId===g.tabDto.id&&!g.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this._activeTabId}}let _=class{constructor(g){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,f={onDidChangeTabGroups:g._onDidChangeTabGroups.event,onDidChangeTabs:g._onDidChangeTabs.event,get all(){return Object.freeze(g._extHostTabGroups.map(b=>b.apiObject))},get activeTabGroup(){const b=g._activeGroupId;return(0,C.assertIsDefined)(g._extHostTabGroups.find(d=>d.groupId===b)?.apiObject)},close:async(b,m)=>{const d=Array.isArray(b)?b:[b];return d.length?w(d[0])?this._closeGroups(d,m):this._closeTabs(d,m):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(g){const f=new Set(this._extHostTabGroups.map(l=>l.groupId)),b=new Set(g.map(l=>l.groupId)),m=(0,A.diffSets)(f,b),d=this._extHostTabGroups.filter(l=>m.removed.includes(l.groupId)).map(l=>l.apiObject),v=[],r=[];this._extHostTabGroups=g.map(l=>{const s=new E(l,()=>this._activeGroupId);return m.added.includes(s.groupId)?v.push(s.apiObject):r.push(s.apiObject),s});const o=(0,C.assertIsDefined)(g.find(l=>l.isActive===!0)?.groupId);o!==void 0&&this._activeGroupId!==o&&(this._activeGroupId=o),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:d,changed:r}))}$acceptTabGroupUpdate(g){const f=this._extHostTabGroups.find(b=>b.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this._activeGroupId=g.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this._extHostTabGroups.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const b=f.acceptTabOperation(g);switch(g.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}_findExtHostTabFromApi(g){for(const f of this._extHostTabGroups)for(const b of f.tabs)if(b.apiObject===g)return b}_findExtHostTabGroupFromApi(g){return this._extHostTabGroups.find(f=>f.apiObject===g)}async _closeTabs(g,f){const b=[];for(const m of g){const d=this._findExtHostTabFromApi(m);if(!d)throw new Error("Tab close: Invalid tab not found!");b.push(d.tabId)}return this._proxy.$closeTab(b,f)}async _closeGroups(g,f){const b=[];for(const m of g){const d=this._findExtHostTabGroupFromApi(m);if(!d)throw new Error("Group close: Invalid group not found!");b.push(d.groupId)}return this._proxy.$closeGroup(b,f)}};_=je([He(0,S.IExtHostRpcService)],_),e.ExtHostEditorTabs=_;function w(h){return h.tabs!==void 0}}),define(_e[251],ye([1,0,2,5,6,7,15,151,8,23,27]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const h=this._schemes.indexOf(w);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),h=[];let g,f,b=14,m=14;for(const d of w){let v=g?(0,S.commonPrefixLength)(g,d):0;for(v===0?f=1:f=m;v<d.length;v++)v+1===d.length?(b=m,m=9):m+=1,h.push([f,d.toUpperCase().charCodeAt(v),m]),h.push([f,d.toLowerCase().charCodeAt(v),m]),f=m;g=d,m=b}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new k.StateMachine(h)}}provideDocumentLinks(w){this._initStateMachine();const h=[],g=k.LinkComputer.computeLinks({getLineContent(f){return w.lineAt(f-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const f of g){const b=y.DocumentLink.to(f);b.target&&h.push(b)}return h}}class E{constructor(w,h){this._extHostLanguageFeatures=h,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,h,g,f={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(b,g);let m=2;f.isCaseSensitive&&(m+=1024),f.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,A.checkProposedApiEnabled)(w,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(b,h,m).catch(v=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${h}`),console.error(v)});const d=g.onDidChangeFile(v=>{const r=[];for(const o of v){const{uri:l,type:s}=o;if(l.scheme!==h)continue;let a;switch(s){case P.FileChangeType.Changed:a=0;break;case P.FileChangeType.Created:a=1;break;case P.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:l,type:a})}this._proxy.$onFileSystemChange(b,r)});return(0,I.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(w){const{type:h,ctime:g,mtime:f,size:b,permissions:m}=w;return{type:h,ctime:g,mtime:f,size:b,permissions:m}}$stat(w,h){return Promise.resolve(this._getFsProvider(w).stat(c.URI.revive(h))).then(g=>E._asIStat(g))}$readdir(w,h){return Promise.resolve(this._getFsProvider(w).readDirectory(c.URI.revive(h)))}$readFile(w,h){return Promise.resolve(this._getFsProvider(w).readFile(c.URI.revive(h))).then(g=>C.VSBuffer.wrap(g))}$writeFile(w,h,g,f){return Promise.resolve(this._getFsProvider(w).writeFile(c.URI.revive(h),g.buffer,f))}$delete(w,h,g){return Promise.resolve(this._getFsProvider(w).delete(c.URI.revive(h),g))}$rename(w,h,g,f){return Promise.resolve(this._getFsProvider(w).rename(c.URI.revive(h),c.URI.revive(g),f))}$copy(w,h,g,f){const b=this._getFsProvider(w);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(c.URI.revive(h),c.URI.revive(g),f))}$mkdir(w,h){return Promise.resolve(this._getFsProvider(w).createDirectory(c.URI.revive(h)))}$watch(w,h,g,f){const b=this._getFsProvider(w).watch(c.URI.revive(g),f);this._watches.set(h,b)}$unwatch(w,h){const g=this._watches.get(h);g&&(g.dispose(),this._watches.delete(h))}$open(w,h,g){const f=this._getFsProvider(w);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(c.URI.revive(h),g))}$close(w,h){const g=this._getFsProvider(w);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(h))}$read(w,h,g,f){const b=this._getFsProvider(w);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const m=C.VSBuffer.alloc(f);return Promise.resolve(b.read(h,g,m.buffer,0,f)).then(d=>m.slice(0,d))}$write(w,h,g,f){const b=this._getFsProvider(w);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(h,g,f.buffer,0,f.byteLength))}_getFsProvider(w){const h=this._fsProvider.get(w);if(!h){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return h}}e.ExtHostFileSystem=E}),define(_e[69],ye([1,0,5,38,7,23,3,16,46,6]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Yt{constructor(E,_){this._fileSystemProvider=new Map,this._proxy=E.getProxy(c.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(h){try{const g=w._fileSystemProvider.get(h.scheme);if(!g)return await w._proxy.$stat(h);await w._proxy.$ensureActivation(h.scheme);const f=await g.stat(h);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(g){Yt._handleError(g)}},async readDirectory(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readDirectory(h)).slice()):await w._proxy.$readdir(h)}catch(g){return Yt._handleError(g)}},async createDirectory(h){try{return await w._proxy.$mkdir(h)}catch(g){return Yt._handleError(g)}},async readFile(h){try{const g=w._fileSystemProvider.get(h.scheme);return g?(await w._proxy.$ensureActivation(h.scheme),(await g.readFile(h)).slice()):(await w._proxy.$readFile(h)).buffer}catch(g){return Yt._handleError(g)}},async writeFile(h,g){try{return await w._proxy.$writeFile(h,P.VSBuffer.wrap(g))}catch(f){return Yt._handleError(f)}},async delete(h,g){try{const f=w._fileSystemProvider.get(h.scheme);return f?(await w._proxy.$ensureActivation(h.scheme),await f.delete(h,{recursive:!1,...g})):await w._proxy.$delete(h,{recursive:!1,useTrash:!1,...g})}catch(f){return Yt._handleError(f)}},async rename(h,g,f){try{return await w._proxy.$rename(h,g,{overwrite:!1,...f})}catch(b){return Yt._handleError(b)}},async copy(h,g,f){try{return await w._proxy.$copy(h,g,{overwrite:!1,...f})}catch(b){return Yt._handleError(b)}},isWritableFileSystem(h){const g=_.getCapabilities(h);if(typeof g=="number")return!(g&2048)}})}static _handleError(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,_){return this._fileSystemProvider.set(E,_),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(E))}};A=je([He(0,k.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[252],ye([1,0,4,37,2,5,15,7]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(T,E,_,w,h,g,f,b){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter;const m=this.ensureWatching(T,_,h);this._config=0,g&&(this._config+=1),f&&(this._config+=2),b&&(this._config+=4);const d=(0,t.parse)(h),v=typeof h=="string",r=w(o=>{if(!g)for(const l of o.created){const s=I.URI.revive(l);d(s.fsPath)&&(!v||E.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!f)for(const l of o.changed){const s=I.URI.revive(l);d(s.fsPath)&&(!v||E.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!b)for(const l of o.deleted){const s=I.URI.revive(l);d(s.fsPath)&&(!v||E.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=k.Disposable.from(m,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(T,E,_){const w=k.Disposable.from();if(typeof _=="string")return w;const h=T.getProxy(P.MainContext.MainThreadFileSystem);let g=!1;(_.pattern.includes(t.GLOBSTAR)||_.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const f=Math.random();return h.$watch(E.identifier.value,f,_.baseUri,{recursive:g,excludes:[]}),k.Disposable.from({dispose:()=>h.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(T,E,_){this._mainContext=T,this._logService=E,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(T,E,_,w,h,g){return new S(this._mainContext,T,E,this._onFileSystemEvent.event,y.GlobPattern.from(_),w,h,g)}$onFileEvent(T){this._onFileSystemEvent.fire(T)}$onDidRunFileOperation(T,E){switch(T){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(_=>({oldUri:I.URI.revive(_.source),newUri:I.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(_=>I.URI.revive(_.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(_=>I.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(T){return this._createWillExecuteEvent(T,this._onWillRenameFile)}getOnWillCreateFileEvent(T){return this._createWillExecuteEvent(T,this._onWillCreateFile)}getOnWillDeleteFileEvent(T){return this._createWillExecuteEvent(T,this._onWillDeleteFile)}_createWillExecuteEvent(T,E){return(_,w,h)=>{const g=function(b){_.call(w,b)};return g.extension=T,E.event(g,void 0,h)}}async $onWillRunFileOperation(T,E,_,w){switch(T){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},_,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(h=>I.URI.revive(h.target))},_,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(h=>I.URI.revive(h.target))},_,w)}}async _fireWillEvent(T,E,_,w){const h=new Set,g=[];if(await T.fireAsync(E,w,async(b,m)=>{const d=Date.now(),v=await Promise.resolve(b);v instanceof k.WorkspaceEdit&&(g.push([m.extension,v]),h.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-d>_&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),w.isCancellationRequested||g.length===0)return;const f={edits:[]};for(const[,b]of g){const{edits:m}=y.WorkspaceEdit.from(b,{getTextDocumentVersion:d=>this._extHostDocumentsAndEditors.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(m)}return{edit:f,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=C}),define(_e[253],ye([1,0,2,39]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(y,k,S,C,A){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=C;const T=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const _=this._extHostNotebooks.getEditorById(E.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",_.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:_.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(T)}$willAddInteractiveDocument(y,k,S,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=I}),define(_e[254],ye([1,0,6,5]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(_e[255],ye([1,0,2,24,15,7,66,5,8,35,17,11,147,21,6,118,99,89,51,10,18,27]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentSymbols(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(q,W);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(I.DocumentSymbol.from):r._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,ae)=>{let ve=X.location.range.start.compareTo(ae.location.range.start);return ve===0&&(ve=ae.location.range.end.compareTo(X.location.range.end)),ve});const W=[],q=[];for(const X of O){const ae={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(q.length===0){q.push(ae),W.push(ae);break}const ve=q[q.length-1];if(C.Range.containsRange(ve.range,ae.range)&&!C.Range.equalsRange(ve.range,ae.range)){ve.children?.push(ae),q.push(ae);break}q.pop()}}return W}}class o{constructor(O,W,q){this._documents=O,this._commands=W,this._provider=q,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(q,W);if(!X||W.isCancellationRequested)return;const ae=this._cache.add(X),ve=new w.DisposableStore;this._disposables.set(ae,ve);const Te={cacheId:ae,lenses:[]};for(let ge=0;ge<X.length;ge++)Te.lenses.push({cacheId:[ae,ge],range:I.Range.from(X[ge].range),command:this._commands.toInternal(X[ge].command,ve)});return Te}async resolveCodeLens(O,W){const q=O.cacheId&&this._cache.get(...O.cacheId);if(!q)return;let X;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?X=q:X=await this._provider.resolveCodeLens(q,W),X||(X=q),W.isCancellationRequested)return;const ae=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!ae)return O.command=this._commands.toInternal(X.command??o._badCmd,ae),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function l(te){return Array.isArray(te)?te.map(I.DefinitionLink.from):te?[I.DefinitionLink.from(te)]:[]}class s{constructor(O,W){this._documents=O,this._provider=W}async provideDefinition(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDefinition(X,ae,q);return l(ve)}}class a{constructor(O,W){this._documents=O,this._provider=W}async provideDeclaration(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDeclaration(X,ae,q);return l(ve)}}class u{constructor(O,W){this._documents=O,this._provider=W}async provideImplementation(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideImplementation(X,ae,q);return l(ve)}}class n{constructor(O,W){this._documents=O,this._provider=W}async provideTypeDefinition(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideTypeDefinition(X,ae,q);return l(ve)}}class i{constructor(O,W){this._documents=O,this._provider=W}async provideHover(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideHover(X,ae,q);if(!(!ve||(0,A.isFalsyOrEmpty)(ve.contents)))return ve.range||(ve.range=X.getWordRangeAtPosition(ae)),ve.range||(ve.range=new P.Range(ae,ae)),I.Hover.from(ve)}}class p{constructor(O,W){this._documents=O,this._provider=W}async provideEvaluatableExpression(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideEvaluatableExpression(X,ae,q);if(ve)return I.EvaluatableExpression.from(ve)}}class D{constructor(O,W){this._documents=O,this._provider=W}async provideInlineValues(O,W,q,X){const ae=this._documents.getDocument(O),ve=await this._provider.provideInlineValues(ae,I.Range.to(W),I.InlineValueContext.to(q),X);if(Array.isArray(ve))return ve.map(Te=>I.InlineValue.from(Te))}}class R{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentHighlights(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideDocumentHighlights(X,ae,q);if(Array.isArray(ve))return ve.map(I.DocumentHighlight.from)}}class N{constructor(O,W){this._documents=O,this._provider=W}async provideLinkedEditingRanges(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.provideLinkedEditingRanges(X,ae,q);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,A.coalesce)(ve.ranges.map(I.Range.from)),wordPattern:ve.wordPattern}}}class V{constructor(O,W){this._documents=O,this._provider=W}async provideReferences(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=await this._provider.provideReferences(ae,ve,q,X);if(Array.isArray(Te))return Te.map(I.location.from)}}class x{constructor(O,W,q,X,ae,ve,Te){this._documents=O,this._commands=W,this._diagnostics=q,this._provider=X,this._logService=ae,this._extension=ve,this._apiDeprecation=Te,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,W,q,X){const ae=this._documents.getDocument(O),ve=E.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),Te=[];for(const nt of this._diagnostics.getDiagnostics(O))if(ve.intersection(nt.range)&&Te.push(nt)>x._maxCodeActionsPerFile)break;const ge={diagnostics:Te,only:q.only?new P.CodeActionKind(q.only):void 0,triggerKind:I.CodeActionTriggerKind.to(q.trigger)},ke=await this._provider.provideCodeActions(ae,ve,ge,X);if(!(0,A.isNonEmptyArray)(ke)||X.isCancellationRequested)return;const De=this._cache.add(ke),xe=new w.DisposableStore;this._disposables.set(De,xe);const qe=[];for(let nt=0;nt<ke.length;nt++){const Xe=ke[nt];!Xe||(x._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,xe)})):(ge.only&&(Xe.kind?ge.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[De,nt],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,xe),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(I.Diagnostic.from),edit:Xe.edit&&I.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:De,actions:qe}}async resolveCodeAction(O,W){const[q,X]=O,ae=this._cache.get(q,X);if(!ae||x._isCommand(ae)||!this._provider.resolveCodeAction)return;const ve=await this._provider.resolveCodeAction(ae,W)??ae;return ve?.edit?I.WorkspaceEdit.from(ve.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}x._maxCodeActionsPerFile=1e3;class L{constructor(O,W,q,X){this._proxy=O,this._documents=W,this._provider=q,this._handle=X}async prepareDocumentPaste(O,W,q,X){if(!this._provider.prepareDocumentPaste)return;const ae=this._documents.getDocument(O),ve=W.map(ge=>I.Range.to(ge)),Te=I.DataTransfer.toDataTransfer(q,()=>{throw new m.NotImplementedError});return await this._provider.prepareDocumentPaste(ae,ve,Te,X),I.DataTransfer.toDataTransferDTO(Te)}async providePasteEdits(O,W,q,X,ae){const ve=this._documents.getDocument(W),Te=q.map(De=>I.Range.to(De)),ge=I.DataTransfer.toDataTransfer(X,async De=>(await this._proxy.$resolvePasteFileData(this._handle,O,De)).buffer),ke=await this._provider.provideDocumentPasteEdits(ve,Te,ge,ae);if(!!ke)return{insertText:typeof ke.insertText=="string"?ke.insertText:{snippet:ke.insertText.value},additionalEdit:ke.additionalEdit?I.WorkspaceEdit.from(ke.additionalEdit,void 0):void 0}}}class U{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentFormattingEdits(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideDocumentFormattingEdits(X,W,q);if(Array.isArray(ae))return ae.map(I.TextEdit.from)}}class F{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeFormattingEdits(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Range.to(W),Te=await this._provider.provideDocumentRangeFormattingEdits(ae,ve,q,X);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class B{constructor(O,W){this._documents=O,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,q,X,ae){const ve=this._documents.getDocument(O),Te=I.Position.to(W),ge=await this._provider.provideOnTypeFormattingEdits(ve,Te,q,X,ae);if(Array.isArray(ge))return ge.map(I.TextEdit.from)}}class M{constructor(O,W){this._provider=O,this._logService=W,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const q=await this._provider.provideWorkspaceSymbols(O,W);if(!(0,A.isNonEmptyArray)(q))return{symbols:[]};const X=this._cache.add(q),ae={cacheId:X,symbols:[]};for(let ve=0;ve<q.length;ve++){const Te=q[ve];if(!Te||!Te.name){this._logService.warn("INVALID SymbolInformation",Te);continue}ae.symbols.push({...I.WorkspaceSymbol.from(Te),cacheId:[X,ve]})}return ae}async resolveWorkspaceSymbol(O,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const q=this._cache.get(...O.cacheId);if(q){const X=await this._provider.resolveWorkspaceSymbol(q,W);return X&&(0,t.mixin)(O,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class z{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,q){this._documents=O,this._provider=W,this._logService=q}async provideRenameEdits(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W);try{const Te=await this._provider.provideRenameEdits(ae,ve,q,X);return Te?I.WorkspaceEdit.from(Te):void 0}catch(Te){const ge=z._asMessage(Te);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(O,W,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),ae=I.Position.to(W);try{const ve=await this._provider.prepareRename(X,ae,q);let Te,ge;if(P.Range.isRange(ve)?(Te=ve,ge=X.getText(ve)):(0,T.isObject)(ve)&&(Te=ve.range,ge=ve.placeholder),!Te||!ge)return;if(Te.start.line>ae.line||Te.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Te),text:ge}}catch(ve){const Te=z._asMessage(ve);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ve)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class j{constructor(O,W){this.resultId=O,this.tokens=W}}class ${constructor(O,W){this._documents=O,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,W,q){const X=this._documents.getDocument(O),ae=W!==0?this._previousResults.get(W):null;let ve=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,ae.resultId,q):await this._provider.provideDocumentSemanticTokens(X,q);return ae&&this._previousResults.delete(W),ve?(ve=$._fixProvidedSemanticTokens(ve),this._send($._convertToEdits(ae,ve),ve)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(W=>new P.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,W){if(!$._isSemanticTokens(W)||!O||!O.tokens)return W;const q=O.tokens,X=q.length,ae=W.data,ve=ae.length;let Te=0;const ge=Math.min(X,ve);for(;Te<ge&&q[Te]===ae[Te];)Te++;if(Te===X&&Te===ve)return new P.SemanticTokensEdits([],W.resultId);let ke=0;const De=ge-Te;for(;ke<De&&q[X-ke-1]===ae[ve-ke-1];)ke++;return new P.SemanticTokensEdits([{start:Te,deleteCount:X-Te-ke,data:ae.subarray(Te,ve-ke)}],W.resultId)}_send(O,W){if($._isSemanticTokens(O)){const q=this._nextResultId++;return this._previousResults.set(q,new j(O.resultId,O.data)),(0,h.encodeSemanticTokensDto)({id:q,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const q=this._nextResultId++;return $._isSemanticTokens(W)?this._previousResults.set(q,new j(W.resultId,W.data)):this._previousResults.set(q,new j(O.resultId)),(0,h.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class Q{constructor(O,W){this._documents=O,this._provider=W}async provideDocumentRangeSemanticTokens(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideDocumentRangeSemanticTokens(X,I.Range.to(W),q);return ae?this._send(ae):null}_send(O){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,q,X,ae){this._documents=O,this._commands=W,this._provider=q,this._apiDeprecation=X,this._extension=ae,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=ae.getWordRangeAtPosition(ve)||new P.Range(ve,ve),ge=Te.with({end:ve}),ke=new b.StopWatch(!0),De=await this._provider.provideCompletionItems(ae,ve,X,I.CompletionContext.to(q));if(!De||X.isCancellationRequested)return;const xe=Array.isArray(De)?new P.CompletionList(De):De,qe=K.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),nt=new w.DisposableStore;this._disposables.set(qe,nt);const Xe=[],st={x:qe,b:Xe,a:{replace:I.Range.from(Te),insert:I.Range.from(ge)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Be=0;Be<xe.items.length;Be++){const dt=xe.items[Be],se=this._convertCompletionItem(dt,[qe,Be],ge,Te);Xe.push(se)}return st}async resolveCompletionItem(O,W){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveCompletionItem(q,W);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,W,q,X){const ae=this._disposables.get(W[0]);if(!ae)throw Error("DisposableStore is missing...");const ve=this._commands.toInternal(O.command,ae),Te={x:W,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=O.textEdit.newText):typeof O.insertText=="string"?Te.h=O.insertText:O.insertText instanceof P.SnippetString&&(Te.h=O.insertText.value,Te.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),P.Range.isRange(ge)?Te.j=I.Range.from(ge):ge&&(!q?.isEqual(ge.inserting)||!X?.isEqual(ge.replacing))&&(Te.j={insert:I.Range.from(ge.inserting),replace:I.Range.from(ge.replacing)}),Te}}class ue{async provideInlineCompletions(O,W,q,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,W){}}class re extends ue{constructor(O,W,q,X){super(),this._extension=O,this._documents=W,this._provider=q,this._commands=X,this._references=new de,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=await this._provider.provideInlineCompletionItems(ae,ve,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:I.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},X);if(!Te||X.isCancellationRequested)return;const ge=Array.isArray(Te)?Te:Te.items,ke=this._isAdditionsProposedApiEnabled?Array.isArray(Te)?[]:Te.commands||[]:[];let De;return{pid:this._references.createReferenceId({dispose(){De?.dispose()},items:ge}),items:ge.map((qe,nt)=>{let Xe;qe.command&&(De||(De=new w.DisposableStore),Xe=this._commands.toInternal(qe.command,De));const st=qe.insertText;return{insertText:typeof st=="string"?st:{snippet:st.value},filterText:qe.filterText,range:qe.range?I.Range.from(qe.range):void 0,command:Xe,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?qe.completeBracketPairs:!1}}),commands:ke.map(qe=>(De||(De=new w.DisposableStore),this._commands.toInternal(qe,De)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W){const q=this._references.get(O)?.items[W];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class de{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const W=this._idPool++;return this._references.set(W,O),W}disposeReferenceId(O){const W=this._references.get(O);return this._references.delete(O),W}get(O){return this._references.get(O)}}class Y{constructor(O,W){this._documents=O,this._provider=W,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,W,q,X){const ae=this._documents.getDocument(O),ve=I.Position.to(W),Te=this.reviveContext(q),ge=await this._provider.provideSignatureHelp(ae,ve,X,Te);if(ge){const ke=this._cache.add([ge]);return{...I.SignatureHelp.from(ge),id:ke}}}reviveContext(O){let W;if(O.activeSignatureHelp){const q=I.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(W=X,W.activeSignature=q.activeSignature,W.activeParameter=q.activeParameter):W=q}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this._cache.delete(O)}}class pe{constructor(O,W,q,X,ae){this._documents=O,this._commands=W,this._provider=q,this._logService=X,this._extension=ae,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,W,q){const X=this._documents.getDocument(O),ae=I.Range.to(W),ve=await this._provider.provideInlayHints(X,ae,q);if(!Array.isArray(ve)||ve.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(q.isCancellationRequested)return;const Te=this._cache.add(ve);this._disposables.set(Te,new w.DisposableStore);const ge={hints:[],cacheId:Te};for(let ke=0;ke<ve.length;ke++)this._isValidInlayHint(ve[ke],ae)&&ge.hints.push(this._convertInlayHint(ve[ke],[Te,ke]));return this._logService.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ge}async resolveInlayHint(O,W){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveInlayHint(q,W);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}_convertInlayHint(O,W){const q=this._disposables.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const X={label:"",cacheId:W,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(ae=>{const ve={label:ae.value};return ve.tooltip=I.MarkdownString.fromStrict(ae.tooltip),P.Location.isLocation(ae.location)&&(ve.location=I.location.from(ae.location)),ae.command&&(ve.command=this._commands.toInternal(ae.command,q)),ve}),X}}class be{constructor(O,W){this._documents=O,this._provider=W,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(q,W);if(!(!Array.isArray(X)||X.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(be._validateLink).map(I.DocumentLink.from)};{const ae=this._cache.add(X),ve={links:[],cacheId:ae};for(let Te=0;Te<X.length;Te++){if(!be._validateLink(X[Te]))continue;const ge=I.DocumentLink.from(X[Te]);ge.cacheId=[ae,Te],ve.links.push(ge)}return ve}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveDocumentLink(q,W);if(!(!X||!be._validateLink(X)))return I.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Ce{constructor(O,W){this._documents=O,this._provider=W}async provideColors(O,W){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(q,W);return Array.isArray(X)?X.map(ve=>({color:I.Color.from(ve.color),range:I.Range.from(ve.range)})):[]}async provideColorPresentations(O,W,q){const X=this._documents.getDocument(O),ae=I.Range.to(W.range),ve=I.Color.to(W.color),Te=await this._provider.provideColorPresentations(ve,{document:X,range:ae},q);if(!!Array.isArray(Te))return Te.map(I.ColorPresentation.from)}}class Re{constructor(O,W){this._documents=O,this._provider=W}async provideFoldingRanges(O,W,q){const X=this._documents.getDocument(O),ae=await this._provider.provideFoldingRanges(X,W,q);if(!!Array.isArray(ae))return ae.map(I.FoldingRange.from)}}class We{constructor(O,W,q){this._documents=O,this._provider=W,this._logService=q}async provideSelectionRanges(O,W,q){const X=this._documents.getDocument(O),ae=W.map(I.Position.to),ve=await this._provider.provideSelectionRanges(X,ae,q);if(!(0,A.isNonEmptyArray)(ve))return[];if(ve.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let ge=0;ge<ae.length;ge++){const ke=[];Te.push(ke);let De=ae[ge],xe=ve[ge];for(;;){if(!xe.range.contains(De))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(I.SelectionRange.from(xe)),!xe.parent)break;De=xe.range,xe=xe.parent}}return Te}}class ne{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.prepareCallHierarchy(X,ae,q);if(!ve)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ve)?ve.map(ge=>this._cacheAndConvertItem(Te,ge)):[this._cacheAndConvertItem(Te,ve)]}async provideCallsTo(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(X,q);if(!!ae)return ae.map(ve=>({from:this._cacheAndConvertItem(O,ve.from),fromRanges:ve.fromRanges.map(Te=>I.Range.from(Te))}))}async provideCallsFrom(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(X,q);if(!!ae)return ae.map(ve=>({to:this._cacheAndConvertItem(O,ve.to),fromRanges:ve.fromRanges.map(Te=>I.Range.from(Te))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const q=this._cache.get(O),X=I.CallHierarchyItem.from(W,O,q.size.toString(36));return q.set(X._itemId,W),X}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class ce{constructor(O,W){this._documents=O,this._provider=W,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,W,q){const X=this._documents.getDocument(O),ae=I.Position.to(W),ve=await this._provider.prepareTypeHierarchy(X,ae,q);if(!ve)return;const Te=this._idPool.nextId();return this._cache.set(Te,new Map),Array.isArray(ve)?ve.map(ge=>this._cacheAndConvertItem(Te,ge)):[this._cacheAndConvertItem(Te,ve)]}async provideSupertypes(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(X,q);if(!!ae)return ae.map(ve=>this._cacheAndConvertItem(O,ve))}async provideSubtypes(O,W,q){const X=this._itemFromCache(O,W);if(!X)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(X,q);if(!!ae)return ae.map(ve=>this._cacheAndConvertItem(O,ve))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,W){const q=this._cache.get(O),X=I.TypeHierarchyItem.from(W,O,q.size.toString(36));return q.set(X._itemId,W),X}_itemFromCache(O,W){return this._cache.get(O)?.get(W)}}class fe{constructor(O,W,q,X){this._proxy=O,this._documents=W,this._provider=q,this._handle=X}async provideDocumentOnDropEdits(O,W,q,X,ae){const ve=this._documents.getDocument(W),Te=I.Position.to(q),ge=I.DataTransfer.toDataTransfer(X,async De=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,De)).buffer),ke=await this._provider.provideDocumentDropEdits(ve,Te,ge,ae);if(!!ke)return{insertText:typeof ke.insertText=="string"?ke.insertText:{snippet:ke.insertText.value},additionalEdit:ke.additionalEdit?I.WorkspaceEdit.from(ke.additionalEdit,void 0):void 0}}}class J{constructor(O,W){this.adapter=O,this.extension=W}}class ie{constructor(O,W,q,X,ae,ve,Te,ge){this._uriTransformer=W,this._documents=q,this._commands=X,this._diagnostics=ae,this._logService=ve,this._apiDeprecation=Te,this._extensionTelemetry=ge,this._adapter=new Map,this._proxy=O.getProxy(k.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return I.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ie._handlePool++}async _withAdapter(O,W,q,X,ae,ve=!1){const Te=this._adapter.get(O);if(!Te||!(Te.adapter instanceof W))return X;const ge=Date.now();ve||this._logService.trace(`[${Te.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const ke=q(Te.adapter,Te.extension);return Promise.resolve(ke).catch(De=>{(0,m.isCancellationError)(De)||(this._logService.error(`[${Te.extension.identifier.value}] provider FAILED`),this._logService.error(De),this._extensionTelemetry.onExtensionError(Te.extension.identifier,De))}).finally(()=>{ve||this._logService.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),_.CancellationToken.isCancellationToken(ae)?(0,d.raceCancellationError)(ke,ae):ke}_addNewAdapter(O,W){const q=this._nextHandle();return this._adapter.set(q,new J(O,W)),q}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,q,X){const ae=this._addNewAdapter(new r(this._documents,q),O),ve=X&&X.label||ie._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(W),ve),this._createDisposable(ae)}$provideDocumentSymbols(O,W,q){return this._withAdapter(O,r,X=>X.provideDocumentSymbols(c.URI.revive(W),q),void 0,q)}registerCodeLensProvider(O,W,q){const X=this._nextHandle(),ae=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new J(new o(this._documents,this._commands.converter,q),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(W),ae);let ve=this._createDisposable(X);if(ae!==void 0){const Te=q.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(ae));ve=P.Disposable.from(ve,Te)}return ve}$provideCodeLenses(O,W,q){return this._withAdapter(O,o,X=>X.provideCodeLenses(c.URI.revive(W),q),void 0,q)}$resolveCodeLens(O,W,q){return this._withAdapter(O,o,X=>X.resolveCodeLens(W,q),void 0,void 0)}$releaseCodeLenses(O,W){this._withAdapter(O,o,q=>Promise.resolve(q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,q){const X=this._addNewAdapter(new s(this._documents,q),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDefinition(O,W,q,X){return this._withAdapter(O,s,ae=>ae.provideDefinition(c.URI.revive(W),q,X),[],X)}registerDeclarationProvider(O,W,q){const X=this._addNewAdapter(new a(this._documents,q),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDeclaration(O,W,q,X){return this._withAdapter(O,a,ae=>ae.provideDeclaration(c.URI.revive(W),q,X),[],X)}registerImplementationProvider(O,W,q){const X=this._addNewAdapter(new u(this._documents,q),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideImplementation(O,W,q,X){return this._withAdapter(O,u,ae=>ae.provideImplementation(c.URI.revive(W),q,X),[],X)}registerTypeDefinitionProvider(O,W,q){const X=this._addNewAdapter(new n(this._documents,q),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideTypeDefinition(O,W,q,X){return this._withAdapter(O,n,ae=>ae.provideTypeDefinition(c.URI.revive(W),q,X),[],X)}registerHoverProvider(O,W,q,X){const ae=this._addNewAdapter(new i(this._documents,q),O);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(W)),this._createDisposable(ae)}$provideHover(O,W,q,X){return this._withAdapter(O,i,ae=>ae.provideHover(c.URI.revive(W),q,X),void 0,X)}registerEvaluatableExpressionProvider(O,W,q,X){const ae=this._addNewAdapter(new p(this._documents,q),O);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(W)),this._createDisposable(ae)}$provideEvaluatableExpression(O,W,q,X){return this._withAdapter(O,p,ae=>ae.provideEvaluatableExpression(c.URI.revive(W),q,X),void 0,X)}registerInlineValuesProvider(O,W,q,X){const ae=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ve=this._addNewAdapter(new D(this._documents,q),O);this._proxy.$registerInlineValuesProvider(ve,this._transformDocumentSelector(W),ae);let Te=this._createDisposable(ve);if(ae!==void 0){const ge=q.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(ae));Te=P.Disposable.from(Te,ge)}return Te}$provideInlineValues(O,W,q,X,ae){return this._withAdapter(O,D,ve=>ve.provideInlineValues(c.URI.revive(W),q,X,ae),void 0,ae)}registerDocumentHighlightProvider(O,W,q){const X=this._addNewAdapter(new R(this._documents,q),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentHighlights(O,W,q,X){return this._withAdapter(O,R,ae=>ae.provideDocumentHighlights(c.URI.revive(W),q,X),void 0,X)}registerLinkedEditingRangeProvider(O,W,q){const X=this._addNewAdapter(new N(this._documents,q),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideLinkedEditingRanges(O,W,q,X){return this._withAdapter(O,N,async ae=>{const ve=await ae.provideLinkedEditingRanges(c.URI.revive(W),q,X);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?ie._serializeRegExp(ve.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,W,q){const X=this._addNewAdapter(new V(this._documents,q),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideReferences(O,W,q,X,ae){return this._withAdapter(O,V,ve=>ve.provideReferences(c.URI.revive(W),q,X,ae),void 0,ae)}registerCodeActionProvider(O,W,q,X){const ae=new w.DisposableStore,ve=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,q,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ve,this._transformDocumentSelector(W),{providedKinds:X?.providedCodeActionKinds?.map(Te=>Te.value),documentation:X?.documentation?.map(Te=>({kind:Te.kind.value,command:this._commands.converter.toInternal(Te.command,ae)}))},ie._extLabel(O),Boolean(q.resolveCodeAction)),ae.add(this._createDisposable(ve)),ae}$provideCodeActions(O,W,q,X,ae){return this._withAdapter(O,x,ve=>ve.provideCodeActions(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveCodeAction(O,W,q){return this._withAdapter(O,x,X=>X.resolveCodeAction(W,q),void 0,void 0)}$releaseCodeActions(O,W){this._withAdapter(O,x,q=>Promise.resolve(q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,q){const X=this._addNewAdapter(new U(this._documents,q),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,W,q,X){return this._withAdapter(O,U,ae=>ae.provideDocumentFormattingEdits(c.URI.revive(W),q,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,W,q){const X=this._addNewAdapter(new F(this._documents,q),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(W),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,W,q,X,ae){return this._withAdapter(O,F,ve=>ve.provideDocumentRangeFormattingEdits(c.URI.revive(W),q,X,ae),void 0,ae)}registerOnTypeFormattingEditProvider(O,W,q,X){const ae=this._addNewAdapter(new B(this._documents,q),O);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(W),X,O.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(O,W,q,X,ae,ve){return this._withAdapter(O,B,Te=>Te.provideOnTypeFormattingEdits(c.URI.revive(W),q,X,ae,ve),void 0,ve)}registerWorkspaceSymbolProvider(O,W){const q=this._addNewAdapter(new M(W,this._logService),O);return this._proxy.$registerNavigateTypeSupport(q,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(O,W,q){return this._withAdapter(O,M,X=>X.provideWorkspaceSymbols(W,q),{symbols:[]},q)}$resolveWorkspaceSymbol(O,W,q){return this._withAdapter(O,M,X=>X.resolveWorkspaceSymbol(W,q),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this._withAdapter(O,M,q=>q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,q){const X=this._addNewAdapter(new z(this._documents,q,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(W),z.supportsResolving(q)),this._createDisposable(X)}$provideRenameEdits(O,W,q,X,ae){return this._withAdapter(O,z,ve=>ve.provideRenameEdits(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveRenameLocation(O,W,q,X){return this._withAdapter(O,z,ae=>ae.resolveRenameLocation(c.URI.revive(W),q,X),void 0,X)}registerDocumentSemanticTokensProvider(O,W,q,X){const ae=this._addNewAdapter(new $(this._documents,q),O),ve=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(W),X,ve);let Te=this._createDisposable(ae);if(ve){const ge=q.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(ve));Te=P.Disposable.from(Te,ge)}return Te}$provideDocumentSemanticTokens(O,W,q,X){return this._withAdapter(O,$,ae=>ae.provideDocumentSemanticTokens(c.URI.revive(W),q,X),null,X)}$releaseDocumentSemanticTokens(O,W){this._withAdapter(O,$,q=>q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,q,X){const ae=this._addNewAdapter(new Q(this._documents,q),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(W),X),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(O,W,q,X){return this._withAdapter(O,Q,ae=>ae.provideDocumentRangeSemanticTokens(c.URI.revive(W),q,X),null,X)}registerCompletionItemProvider(O,W,q,X){const ae=this._addNewAdapter(new K(this._documents,this._commands.converter,q,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(ae,this._transformDocumentSelector(W),X,K.supportsResolving(q),`${O.identifier.value}(${X.join("")})`),this._createDisposable(ae)}$provideCompletionItems(O,W,q,X,ae){return this._withAdapter(O,K,ve=>ve.provideCompletionItems(c.URI.revive(W),q,X,ae),void 0,ae)}$resolveCompletionItem(O,W,q){return this._withAdapter(O,K,X=>X.resolveCompletionItem(W,q),void 0,q)}$releaseCompletionItems(O,W){this._withAdapter(O,K,q=>q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,q){const X=new re(O,this._documents,q,this._commands.converter),ae=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(W),X.supportsHandleDidShowCompletionItem),this._createDisposable(ae)}$provideInlineCompletions(O,W,q,X,ae){return this._withAdapter(O,ue,ve=>ve.provideInlineCompletions(c.URI.revive(W),q,X,ae),void 0,ae)}$handleInlineCompletionDidShow(O,W,q){this._withAdapter(O,ue,async X=>{X.handleDidShowCompletionItem(W,q)},void 0,void 0)}$freeInlineCompletionsList(O,W){this._withAdapter(O,ue,async q=>{q.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,q,X){const ae=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,ve=this._addNewAdapter(new Y(this._documents,q),O);return this._proxy.$registerSignatureHelpProvider(ve,this._transformDocumentSelector(W),ae),this._createDisposable(ve)}$provideSignatureHelp(O,W,q,X,ae){return this._withAdapter(O,Y,ve=>ve.provideSignatureHelp(c.URI.revive(W),q,X,ae),void 0,ae)}$releaseSignatureHelp(O,W){this._withAdapter(O,Y,q=>q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,q){const X=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new pe(this._documents,this._commands.converter,q,this._logService,O),O);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(W),typeof q.resolveInlayHint=="function",X,ie._extLabel(O));let ve=this._createDisposable(ae);if(X!==void 0){const Te=q.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(X));ve=P.Disposable.from(ve,Te)}return ve}$provideInlayHints(O,W,q,X){return this._withAdapter(O,pe,ae=>ae.provideInlayHints(c.URI.revive(W),q,X),void 0,X)}$resolveInlayHint(O,W,q){return this._withAdapter(O,pe,X=>X.resolveInlayHint(W,q),void 0,q)}$releaseInlayHints(O,W){this._withAdapter(O,pe,q=>q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,q){const X=this._addNewAdapter(new be(this._documents,q),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(W),typeof q.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,W,q){return this._withAdapter(O,be,X=>X.provideLinks(c.URI.revive(W),q),void 0,q,W.scheme==="output")}$resolveDocumentLink(O,W,q){return this._withAdapter(O,be,X=>X.resolveLink(W,q),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this._withAdapter(O,be,q=>q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,q){const X=this._addNewAdapter(new Ce(this._documents,q),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentColors(O,W,q){return this._withAdapter(O,Ce,X=>X.provideColors(c.URI.revive(W),q),[],q)}$provideColorPresentations(O,W,q,X){return this._withAdapter(O,Ce,ae=>ae.provideColorPresentations(c.URI.revive(W),q,X),void 0,X)}registerFoldingRangeProvider(O,W,q){const X=this._nextHandle(),ae=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new J(new Re(this._documents,q),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(W),O.identifier,ae);let ve=this._createDisposable(X);if(ae!==void 0){const Te=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));ve=P.Disposable.from(ve,Te)}return ve}$provideFoldingRanges(O,W,q,X){return this._withAdapter(O,Re,ae=>ae.provideFoldingRanges(c.URI.revive(W),q,X),void 0,X)}registerSelectionRangeProvider(O,W,q){const X=this._addNewAdapter(new We(this._documents,q,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideSelectionRanges(O,W,q,X){return this._withAdapter(O,We,ae=>ae.provideSelectionRanges(c.URI.revive(W),q,X),[],X)}registerCallHierarchyProvider(O,W,q){const X=this._addNewAdapter(new ne(this._documents,q),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$prepareCallHierarchy(O,W,q,X){return this._withAdapter(O,ne,ae=>Promise.resolve(ae.prepareSession(c.URI.revive(W),q,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,W,q,X){return this._withAdapter(O,ne,ae=>ae.provideCallsTo(W,q,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,W,q,X){return this._withAdapter(O,ne,ae=>ae.provideCallsFrom(W,q,X),void 0,X)}$releaseCallHierarchy(O,W){this._withAdapter(O,ne,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,q){const X=this._addNewAdapter(new ce(this._documents,q),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$prepareTypeHierarchy(O,W,q,X){return this._withAdapter(O,ce,ae=>Promise.resolve(ae.prepareSession(c.URI.revive(W),q,X)),void 0,X)}$provideTypeHierarchySupertypes(O,W,q,X){return this._withAdapter(O,ce,ae=>ae.provideSupertypes(W,q,X),void 0,X)}$provideTypeHierarchySubtypes(O,W,q,X){return this._withAdapter(O,ce,ae=>ae.provideSubtypes(W,q,X),void 0,X)}$releaseTypeHierarchy(O,W){this._withAdapter(O,ce,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,q){const X=this._nextHandle();return this._adapter.set(X,new J(new fe(this._proxy,this._documents,q,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(W)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,W,q,X,ae,ve){return this._withAdapter(O,fe,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(W,c.URI.revive(q),X,ae,ve)),void 0,void 0)}registerDocumentPasteEditProvider(O,W,q,X){const ae=this._nextHandle();return this._adapter.set(ae,new J(new L(this._proxy,this._documents,q,ae),O)),this._proxy.$registerPasteEditProvider(ae,this._transformDocumentSelector(W),!!q.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(ae)}$prepareDocumentPaste(O,W,q,X,ae){return this._withAdapter(O,L,ve=>ve.prepareDocumentPaste(c.URI.revive(W),q,X,ae),void 0,ae)}$providePasteEdits(O,W,q,X,ae,ve){return this._withAdapter(O,L,Te=>Te.providePasteEdits(W,c.URI.revive(q),X,ae,ve),void 0,ve)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ie._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ie._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ie._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ie._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ie._serializeRegExp(O.beforeText),afterText:O.afterText?ie._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ie._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ie._serializeOnEnterRule)}setLanguageConfiguration(O,W,q){const{wordPattern:X}=q;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(W,X):this._documents.setWordDefinitionFor(W,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const ae=this._nextHandle(),ve={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ie._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ie._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ie._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ae,W,ve),this._createDisposable(ae)}$setWordDefinitions(O){for(const W of O)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ie,ie._handlePool=0}),define(_e[256],ye([1,0,5,15,7,42,18,6]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,T,E,_){this._documents=T,this._commands=E,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,T){await this._proxy.$changeLanguage(A,T);const E=this._documents.getDocumentData(A);if(!E)throw new Error(`document '${A.toString()}' NOT found`);return E.document}async tokenAtPosition(A,T){const E=A.version,_=t.Position.from(T),w=await this._proxy.$tokensAtPosition(A.uri,_),h={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(T)??new I.Range(T.line,T.character,T.line,T.character)};if(!w)return h;const g={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!g.range.contains(T)||E!==A.version?h:g}createLanguageStatusItem(A,T,E){const _=this._handlePool++,w=this._proxy,h=this._ids,g=`${A.identifier.value}/${T}`;if(h.has(g))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);h.add(g);const f={selector:E,id:T,name:A.displayName??A.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const m=new k.DisposableStore,d=()=>{b?.dispose(),b=(0,y.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(_,{id:g,name:f.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?P.default.Error:f.severity===I.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,m),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},v={dispose(){m.dispose(),b?.dispose(),w.$removeLanguageStatus(_),h.delete(g)},get id(){return f.id},get name(){return f.name},set name(r){f.name=r,d()},get selector(){return f.selector},set selector(r){f.selector=r,d()},get text(){return f.text},set text(r){f.text=r,d()},get detail(){return f.detail},set detail(r){f.detail=r,d()},get severity(){return f.severity},set severity(r){f.severity=r,d()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(r){f.accessibilityInformation=r,d()},get command(){return f.command},set command(r){f.command=r,d()},get busy(){return f.busy},set busy(r){f.busy=r,d()}};return d(),v}}e.ExtHostLanguages=S}),define(_e[95],ye([1,0,12,8,2,3,13,5,25,16]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(E,_,w){this.logService=w,this.bundleCache=new Map,this._proxy=_.getProxy(k.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(E,_){const{message:w,args:h,comment:g}=_;if(this.isDefaultLanguage)return(0,t.format2)(w,h??{});let f=w;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join():g}`);const b=this.bundleCache.get(E)?.contents[f];return b||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(b??f,h??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let _;const w=await this.getBundleLocation(E);if(!w){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const h=await this._proxy.$fetchBundleContents(w),g=JSON.parse(h);_=E.isBuiltin?g.contents?.bundle:g}catch(h){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${w}: ${h.message}`);return}_&&this.bundleCache.set(E.identifier.value,{contents:_,uri:w})}async getBundleLocation(E){if(E.isBuiltin){const _=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(_)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=je([He(0,S.IExtHostInitDataService),He(1,C.IExtHostRpcService),He(2,y.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(_e[138],ye([1,0,13,5,25,16,2,4,11]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends c.AbstractLoggerService{constructor(E,_){super(_.logLevel,k.Event.None),this._proxy=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,_){_?this.setLevel(y.URI.revive(_),E):(0,S.isUndefined)(E)||this.setLevel(E)}doCreateLogger(E,_,w){return new A(this._proxy,E,_,w)}};C=je([He(0,P.IExtHostRpcService),He(1,I.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class A extends c.AbstractMessageLogger{constructor(E,_,w,h){super(h?.always),this.proxy=E,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(_,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,_){const w=[[E,_]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(E){this.proxy.$log(this.file,E)}}}),define(_e[257],ye([1,0,5,13,27]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(k){return k&&k.title}let y=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,C,A,T,E){const _={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof T=="string"||P(T)?w=[T,...E]:(_.modal=T?.modal,_.useCustom=T?.useCustom,_.detail=T?.detail,w=E),_.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const h=[];for(let g=0;g<w.length;g++){const f=w[g];if(typeof f=="string")h.push({title:f,handle:g,isCloseAffordance:!1});else if(typeof f=="object"){const{title:b,isCloseAffordance:m}=f;h.push({title:b,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(C,A,_,h).then(g=>{if(typeof g=="number")return w[g]})}};y=je([He(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(_e[258],ye([1,0,23,4,6,28,8,11,2,89,5,39,15,7,57,233,134]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}constructor(m,d,v,r){this._textDocumentsAndEditors=v,this._textDocuments=r,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new C.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=m.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const l=o.notebookEditor?.notebookUri,s=o.cell.handle,u=this._documents.get(l)?.getCell(s);if(u)return u.apiCell}if(o&&o.$mid===13){const l=o.uri,s=this._documents.get(l);if(s)return s.apiNotebook}return o}}),f._registerApiCommands(d)}getEditorById(m){const d=this._editors.get(m);if(!d)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(m){for(const[d,v]of this._editors)if(v.apiEditor===m)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,d){const v=this._documents.get(m);if(!v&&!d)throw new Error(`NO notebook document for '${m}'`);return v}static _convertNotebookRegistrationData(m,d){if(!d)return;const v=d.filenamePattern.map(r=>E.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(d.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:d.displayName,filenamePattern:v,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,d,v){const r=f._notebookStatusBarItemProviderHandlePool++,o=typeof v.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,o,d);let l;return o!==void 0&&(l=v.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(o))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,o),l?.dispose()})}async createNotebookDocument(m){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(d)}async openNotebookDocument(m){const d=this._documents.get(m);if(d)return d.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(m),r=this._documents.get(S.URI.revive(v));return(0,k.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(m,d){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let v;typeof d=="object"?v={position:E.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(E.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:v={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,v),o=r&&this._editors.get(r)?.apiEditor;if(o)return o;throw r?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,d,v,r){const o=this._notebookStatusBarItemProviders.get(m),l=S.URI.revive(d),s=this._documents.get(l);if(!s||!o)return;const a=s.getCellFromIndex(v);if(!a)return;const u=await o.provideCellStatusBarItems(a.apiCell,r);if(!u)return;const n=new I.DisposableStore,i=this._statusBarCache.add([n]),D=(Array.isArray(u)?u:[u]).map(R=>E.NotebookStatusBarItem.from(R,this._commandsConverter,n));return{cacheId:i,items:D}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,d,v,r,o){if((0,y.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const l=this._handlePool++;return this._notebookSerializer.set(l,v),this._notebookProxy.$registerNotebookSerializer(l,{id:m.identifier,location:m.extensionLocation},d,E.NotebookDocumentContentOptions.from(r),f._convertNotebookRegistrationData(m,o)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(l)})}async $dataToNotebook(m,d,v){const r=this._notebookSerializer.get(m);if(!r)throw new Error("NO serializer found");const o=await r.deserializeNotebook(d.buffer,v);return new w.SerializableObjectWithBuffers(E.NotebookData.from(o))}async $notebookToData(m,d,v){const r=this._notebookSerializer.get(m);if(!r)throw new Error("NO serializer found");const o=await r.serializeNotebook(E.NotebookData.to(d.value),v);return c.VSBuffer.wrap(o)}_createExtHostEditor(m,d,v){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const r=new g.ExtHostNotebookEditor(d,this._notebookEditorsProxy,m,v.visibleRanges.map(E.NotebookRange.to),v.selections.map(E.NotebookRange.to),typeof v.viewColumn=="number"?E.ViewColumn.to(v.viewColumn):void 0);this._editors.set(d,r)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const v of m.value.removedDocuments){const r=S.URI.revive(v),o=this._documents.get(r);o&&(o.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(l=>l.document.uri)}),this._onDidCloseNotebookDocument.fire(o.apiNotebook));for(const l of this._editors.values())l.notebookData.uri.toString()===r.toString()&&this._editors.delete(l.id)}if(m.value.addedDocuments){const v=[];for(const r of m.value.addedDocuments){const o=S.URI.revive(r.uri);if(this._documents.has(o))throw new Error(`adding EXISTING notebook ${o} `);const l=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,o,r);v.push(...r.cells.map(s=>h.ExtHostCell.asModelAddData(l.apiNotebook,s))),this._documents.get(o)?.dispose(),this._documents.set(o,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(m.value.addedEditors)for(const v of m.value.addedEditors){if(this._editors.has(v.id))return;const r=S.URI.revive(v.documentUri),o=this._documents.get(r);o&&this._createExtHostEditor(o,v.id,v)}const d=[];if(m.value.removedEditors)for(const v of m.value.removedEditors){const r=this._editors.get(v);r&&(this._editors.delete(v),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),d.push(r))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const v=new Set;this._visibleNotebookEditors.forEach(r=>v.add(r.id));for(const r of this._editors.values()){const o=v.has(r.id);r._acceptVisibility(o)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(m){const d=T.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new T.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>c.VSBuffer.wrap(o))],new T.ApiCommandResult("Notebook Data",o=>E.NotebookData.to(o.value))),r=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new w.SerializableObjectWithBuffers(E.NotebookData.from(o)))],new T.ApiCommandResult("Bytes",o=>o.buffer));m.registerApiCommand(v),m.registerApiCommand(r)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(_e[259],ye([1,0,17,18,21,4,6,28,2,26,13,5,39,15,7,90,221,27,57]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(s,a,u,n,i){this._initData=a,this._extHostNotebook=u,this._commands=n,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(T.MainContext.MainThreadNotebookKernels);const p=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const R=this._extHostNotebook.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:R}}else if(D&&"notebookEditor"in D){const R=this._extHostNotebook.getIdByEditor(D.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:R}}return D})],E.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(s,a,u,n,i,p){for(const K of this._kernelData.values())if(K.controller.id===a&&C.ExtensionIdentifier.equals(s.identifier,K.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const D=this._handlePool++,R=this;this._logService.trace(`NotebookController[${D}], CREATED by ${s.identifier.value}, ${a}`);const N=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${s.identifier}'`);let V=!1;const x=new y.DisposableStore,L=new P.Emitter,U=new P.Emitter,F={id:o(s.identifier,a),notebookType:u,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:n||s.identifier.value,preloads:p?p.map(_.NotebookRendererScript.from):[]};let B=i??N,M;this._proxy.$addKernel(D,F).catch(K=>{console.log(K),V=!0});let z=0;const j=()=>{if(V)return;const K=++z;Promise.resolve().then(()=>{K===z&&this._proxy.$updateKernel(D,F)})},$=new k.ResourceMap,Q={get id(){return a},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return F.label},set label(K){F.label=K??s.displayName??s.name,j()},get detail(){return F.detail??""},set detail(K){F.detail=K,j()},get description(){return F.description??""},set description(K){F.description=K,j()},get kind(){return(0,f.checkProposedApiEnabled)(s,"notebookControllerKind"),F.kind??""},set kind(K){(0,f.checkProposedApiEnabled)(s,"notebookControllerKind"),F.kind=K,j()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(K){F.supportedLanguages=K,j()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(K){F.supportsExecutionOrder=K,j()},get rendererScripts(){return F.preloads?F.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(K){B=K??N},get interruptHandler(){return M},set interruptHandler(K){M=K,F.supportsInterrupt=Boolean(K),j()},createNotebookCellExecution(K){if(V)throw new Error("notebook controller is DISPOSED");if(!$.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,o(s.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${D}], DISPOSED`),V=!0,this._kernelData.delete(D),x.dispose(),L.dispose(),U.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(K,ue){ue===w.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(D,K.uri,ue)},onDidReceiveMessage:U.event,postMessage(K,ue){return(0,f.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(D,ue&&R._extHostNotebook.getIdByEditor(ue),K)},asWebviewUri(K){return(0,f.checkProposedApiEnabled)(s,"notebookMessaging"),(0,h.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(D,{extensionId:s.identifier,controller:Q,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:$}),Q}getIdByController(s){for(const[a,u]of this._kernelData)if(u.controller===s)return o(u.extensionId,s.id);return null}$acceptNotebookAssociation(s,a,u){const n=this._kernelData.get(s);if(n){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));u?n.associatedNotebooks.set(i.uri,!0):n.associatedNotebooks.delete(i.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,i.uri.toString(),u),n.onDidChangeSelection.fire({selected:u,notebook:i.apiNotebook})}}async $executeCells(s,a,u){const n=this._kernelData.get(s);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a)),p=[];for(const D of u){const R=i.getCell(D);R&&p.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,i.uri.toString(),p.length),await n.controller.executeHandler.call(n.controller,p,i.apiNotebook,n.controller)}catch(D){this._logService.error(`NotebookController[${s}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(s,a,u){const n=this._kernelData.get(s);if(!n)return;const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,i.apiNotebook);else for(const p of u){const D=i.getCell(p);D&&this._activeExecutions.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,a,u){const n=this._kernelData.get(s);if(!n)return;const i=this._extHostNotebook.getEditorById(a);n.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:u}))}$cellExecutionChanged(s,a,u){const i=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)).getCell(a);if(i){const p=u?_.NotebookCellExecutionState.to(u):w.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:i.apiCell,state:p})}}_createNotebookCellExecution(s,a){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new v(a,n,this._proxy);this._activeExecutions.set(n.uri,i);const p=i.onDidChangeState(()=>{i.state===d.Resolved&&(i.dispose(),p.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};m=je([He(4,A.ILogService)],m),e.ExtHostNotebookKernels=m;var d;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(d||(d={}));class v extends y.Disposable{get state(){return this._state}constructor(s,a,u){super(),this._cell=a,this._proxy=u,this._handle=v.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new r(10,n=>this.update(n)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const a=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(a))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let a=this._cell;if(s&&(a=this._cell.notebook.getCellFromApiCell(s)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(s){return s.map(a=>{const u=w.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return u===a.items?_.NotebookCellOutput.from(a):_.NotebookCellOutput.from({items:u,id:a.id,metadata:a.metadata})})}async updateOutputs(s,a,u){const n=this.cellIndexToHandle(a),i=this.validateAndConvertOutputs((0,c.asArray)(s));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,cellHandle:n,append:u,outputs:i})}async updateOutputItems(s,a,u){return s=w.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(s),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,items:s.map(_.NotebookCellOutputItem.from),outputId:a.id,append:u})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(u){s._executionOrder=u,s.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(u){if(s._state===d.Resolved||s._state===d.Started)throw new Error("Cannot call start again");s._state=d.Started,s._onDidChangeState.fire(),s.update({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,n){if(s._state===d.Resolved)throw new Error("Cannot call resolve twice");s._state=d.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:u}))},clearOutput(u){return s.verifyStateForOutput(),s.updateOutputs([],u,!1)},appendOutput(u,n){return s.verifyStateForOutput(),s.updateOutputs(u,n,!0)},replaceOutput(u,n){return s.verifyStateForOutput(),s.updateOutputs(u,n,!1)},appendOutputItems(u,n){return s.verifyStateForOutput(),s.updateOutputItems(u,n,!0)},replaceOutputItems(u,n){return s.verifyStateForOutput(),s.updateOutputItems(u,n,!1)}})}}v.HANDLE=0;class r{constructor(s,a){this.delay=s,this.callback=a,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const a=this.batch;return this.batch=[],this.callback(a).finally(()=>s.complete())}}function o(l,s){return`${l.value}/${s}`}e.createKernelId=o}),define(_e[260],ye([1,0,4,5,134]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(k,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,S,C){const A=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(S)?.fire({editor:A.apiEditor,message:C})}createRendererMessaging(k,S){if(!k.contributes?.notebookRenderer?.some(A=>A.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(A,T,E)=>this.getOrCreateEmitterFor(S).event(A,T,E),postMessage:(A,T)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,T]=[T,A]);const E=T&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.proxy.$postMessage(E?.id,S,A)}}}getOrCreateEmitterFor(k){let S=this._rendererMessageEmitters.get(k);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,S),S)}}e.ExtHostNotebookRenderers=P}),define(_e[261],ye([1,0,21,4,6,5,2,7,10,17,42,88]),function(Z,e,c,t,I,P,y,k,S,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(_,w,h){const g=_.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(a,u){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=u}showQuickPick(a,u,n=c.CancellationToken.None){this._onDidSelectItem=void 0;const i=Promise.resolve(a),p=++this._instances,D=g.$show(p,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),R={},N=D.then(()=>R);return Promise.race([N,i]).then(V=>{if(V!==R)return i.then(x=>{const L=[];for(let U=0;U<x.length;U++){const F=x[U];typeof F=="string"?L.push({label:F,handle:U}):F.kind===k.QuickPickItemKind.Separator?L.push({type:"separator",label:F.label}):L.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:U})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{u.onDidSelectItem(x[U])}),g.$setItems(p,L),D.then(U=>{if(typeof U=="number")return x[U];if(Array.isArray(U))return U.map(F=>x[F])})})}).then(void 0,V=>{if(!(0,S.isCancellationError)(V))return g.$setError(p,V),Promise.reject(V)})}$onItemSelected(a){this._onDidSelectItem?.(a)}showInput(a,u=c.CancellationToken.None){return this._validateInput=a?.validateInput,g.$input(a,typeof this._validateInput=="function",u).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(a){if(!this._validateInput)return;const u=await this._validateInput(a);if(!u||typeof u=="string")return u;let n;switch(u.severity){case k.InputBoxValidationSeverity.Info:n=A.default.Info;break;case k.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case k.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=u.message?A.default.Error:A.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(a,u=c.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!n)return;const i=await this._workspace.getWorkspaceFolders2();if(!!i)return i.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(a){const u=new o(a,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(a){const u=new l(a,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(a,u){this._sessions.get(a)?._fireDidChangeValue(u)}$onDidAccept(a){this._sessions.get(a)?._fireDidAccept()}$onDidChangeActive(a,u){const n=this._sessions.get(a);n instanceof o&&n._fireDidChangeActive(u)}$onDidChangeSelection(a,u){const n=this._sessions.get(a);n instanceof o&&n._fireDidChangeSelection(u)}$onDidTriggerButton(a,u){this._sessions.get(a)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(a,u,n){const i=this._sessions.get(a);i instanceof o&&i._fireDidTriggerItemButton(u,n)}$onDidHide(a){this._sessions.get(a)?._fireDidHide()}}class b{constructor(a,u){this._extensionId=a,this._onDidDispose=u,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((u,n)=>{const i=u===k.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(i,u)}),this.update({buttons:a.map((u,n)=>({...r(u),tooltip:u.tooltip,handle:u===k.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const u=this._handlesToButtons.get(a);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const u of Object.keys(a)){const n=a[u];this._pendingUpdate[u]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function m(s){if(s instanceof k.ThemeIcon)return{id:s.id};const a=v(s),u=d(s);return{dark:typeof a=="string"?y.URI.file(a):a,light:typeof u=="string"?y.URI.file(u):u}}function d(s){return typeof s=="object"&&"light"in s?s.light:s}function v(s){return typeof s=="object"&&"dark"in s?s.dark:s}function r(s){const a=m(s.iconPath);let u,n;return"id"in a?n=T.ThemeIcon.asClassName(a):u=a,{iconPath:u,iconClass:n}}class o extends b{constructor(a,u){super(a.identifier,u),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((n,i)=>{this._handlesToItems.set(i,n),this._itemsToHandles.set(n,i)});const u=[];for(let n=0;n<a.length;n++){const i=a[n];i.kind===k.QuickPickItemKind.Separator?u.push({type:"separator",label:i.label}):u.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((p,D)=>({...r(p),tooltip:p.tooltip,handle:D}))})}this.update({items:u})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(a){const u=(0,C.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(a){const u=(0,C.coalesce)(a.map(n=>this._handlesToItems.get(n)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(a,u){const n=this._handlesToItems.get(a);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[u];i&&this._onDidTriggerItemButtonEmitter.fire({button:i,item:n})}}class l extends b{constructor(a,u){super(a.identifier,u),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get valueSelection(){return this._valueSelection}set valueSelection(a){this._valueSelection=a,this.update({valueSelection:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,a?typeof a=="string"?this.update({validationMessage:a,severity:A.default.Error}):this.update({validationMessage:a.message,severity:a.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new f(w,h)}e.createExtHostQuickOpen=E});var Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c};define(_e[262],ye([1,0,2,4,60,6,18,5,17,108,13,26,88,15,27]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w){"use strict";var h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(i){if(i)return typeof i.iconPath=="string"?c.URI.file(i.iconPath):c.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function b(i,p){if(!i.iconPath&&!p.iconPath)return 0;if(i.iconPath){if(!p.iconPath)return 1}else return-1;const D=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,R=typeof p.iconPath=="string"?p.iconPath:c.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,C.comparePaths)(D,R)}function m(i,p){let D=0;if(i.strikeThrough!==p.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==p.faded)return i.faded?1:-1;if(i.tooltip!==p.tooltip)return(i.tooltip||"").localeCompare(p.tooltip||"");if(D=b(i,p),D!==0)return D;if(i.light&&p.light)D=b(i.light,p.light);else{if(i.light)return 1;if(p.light)return-1}if(D!==0)return D;if(i.dark&&p.dark)D=b(i.dark,p.dark);else{if(i.dark)return 1;if(p.dark)return-1}return D}function d(i,p){if(i.command!==p.command)return i.command<p.command?-1:1;if(i.title!==p.title)return i.title<p.title?-1:1;if(i.tooltip!==p.tooltip){if(i.tooltip!==void 0&&p.tooltip!==void 0)return i.tooltip<p.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(i.arguments===p.arguments)return 0;if(i.arguments)if(p.arguments){if(i.arguments.length!==p.arguments.length)return i.arguments.length-p.arguments.length}else return 1;else return-1;for(let D=0;D<i.arguments.length;D++){const R=i.arguments[D],N=p.arguments[D];if(R!==N)return R<N?-1:1}return 0}function v(i,p){let D=(0,C.comparePaths)(i.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(D!==0)return D;if(i.command&&p.command)D=d(i.command,p.command);else{if(i.command)return 1;if(p.command)return-1}if(D!==0)return D;if(i.decorations&&p.decorations)D=m(i.decorations,p.decorations);else{if(i.decorations)return 1;if(p.decorations)return-1}return D}function r(i,p){for(let D=0;D<i.length;D++)if(i[D]!==p[D])return!1;return!0}function o(i,p){return i.command===p.command&&i.title===p.title&&i.tooltip===p.tooltip&&(i.arguments&&p.arguments?r(i.arguments,p.arguments):i.arguments===p.arguments)}function l(i,p){return(0,S.equals)(i,p,o)}class s{get value(){return this._value}set value(p){p=p??"",Ne(this,h,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Ne(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Ne(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Ne(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Ne(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,D,R){this._extension=p,this._sourceControlHandle=R,h.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,h,D,"f")}showValidationMessage(p,D){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Ne(this,h,"f").$showValidationMessage(this._sourceControlHandle,p,D)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=s,h=new WeakMap;class a{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,D,R,N,V){this._proxy=p,this._commands=D,this._sourceControlHandle=R,this._id=N,this._label=V,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,D){const R=this._resourceStatesCommandsMap.get(p);return R?(0,y.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(v),R=(0,S.sortedDiff)(this._resourceSnapshot,p,v).map(x=>{const L=x.toInsert.map(U=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,U);const B=U.resourceUri;let M;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const pe=new P.DisposableStore;M=this._commands.converter.toInternal(U.command,pe),this._resourceStatesDisposablesMap.set(F,pe)}else this._resourceStatesCommandsMap.set(F,U.command);const z=f(U.decorations),j=U.decorations&&f(U.decorations.light)||z,$=U.decorations&&f(U.decorations.dark)||z,Q=[j,$],K=U.decorations&&U.decorations.tooltip||"",ue=U.decorations&&!!U.decorations.strikeThrough,re=U.decorations&&!!U.decorations.faded,de=U.contextValue||"";return{rawResource:[F,B,Q,K,ue,re,de,M],handle:F}});return{start:x.start,deleteCount:x.deleteCount,toInsert:L}}),N=R.map(({start:x,deleteCount:L,toInsert:U})=>[x,L,U.map(F=>F.rawResource)]),V=R.reverse();for(const{start:x,deleteCount:L,toInsert:U}of V){const F=U.map(M=>M.handle),B=this._handlesSnapshot.splice(x,L,...F);for(const M of B)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=p,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class u{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Ne(this,g,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Ne(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Ne(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const D=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Ne(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:D})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const D=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(R=>R.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Ne(this,g,"f").$updateSourceControl(this.handle,{actionButton:D??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&l(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const D=(p||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ne(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}constructor(p,D,R,N,V,x){this._extension=p,this._commands=R,this._id=N,this._label=V,this._rootUri=x,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,g,D,"f"),this._inputBox=new s(p,Ne(this,g,"f"),this.handle),Ne(this,g,"f").$registerSourceControl(this.handle,N,V,x)}createResourceGroup(p,D){const R=new a(Ne(this,g,"f"),this._commands,this.handle,p,D),N=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,N),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const p=[],D=[];for(const[R,N]of this.createdResourceGroups){N.dispose();const V=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),V.dispose(),this._groups.delete(R.handle),Ne(this,g,"f").$unregisterGroup(this.handle,R.handle)}),p.push([R.handle,R.id,R.label,R.features]);const x=R._takeResourceStateSnapshot();x.length>0&&D.push([R.handle,x]),this._groups.set(R.handle,R)}Ne(this,g,"f").$registerGroups(this.handle,p,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(D=>{const R=D._takeResourceStateSnapshot();R.length!==0&&p.push([D.handle,R])}),p.length>0&&Ne(this,g,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Ne(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,u._handlePool=0,je([(0,I.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class Zn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,D,R){this._commands=D,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(k.MainContext.MainThreadSCM),this._telemetry=p.getProxy(k.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const V=this._sourceControls.get(N.sourceControlHandle);if(!V)return N;const x=V.getResourceGroup(N.groupHandle);return x?x.getResourceState(N.handle):N}else if(N&&N.$mid===4){const V=this._sourceControls.get(N.sourceControlHandle);return V?V.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const V=this._sourceControls.get(N.handle);return V||N}return N}})}createSourceControl(p,D,R,N){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,D,R,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const V=Zn._handlePool++,x=new u(p,this._proxy,this._commands,D,R,N);this._sourceControls.set(V,x);const L=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(p.identifier))||[];return L.push(x),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(p.identifier),L),x}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const D=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(p.identifier)),R=D&&D[D.length-1];return R&&R.inputBox}$provideOriginalResource(p,D,R){const N=c.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,N.toString());const V=this._sourceControls.get(p);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>V.quickDiffProvider.provideOriginalResource(N,R)).then(x=>x||null)}$onInputBoxValueChange(p,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const R=this._sourceControls.get(p);return R&&R.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(p,D,R,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,D,R);const V=this._sourceControls.get(p);if(!V)return Promise.resolve(void 0);const x=V.getResourceGroup(D);return x?x.$executeResourceCommand(R,N):Promise.resolve(void 0)}$validateInput(p,D,R){this.logService.trace("ExtHostSCM#$validateInput",p);const N=this._sourceControls.get(p);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>N.inputBox.validateInput(D,R)).then(V=>{if(!V)return Promise.resolve(void 0);const x=_.MarkdownString.fromStrict(V.message);return x?Promise.resolve([x,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};n._handlePool=0,n=je([He(2,A.ILogService)],n),e.ExtHostSCM=n}),define(_e[96],ye([1,0,5,4,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,C){return this._proxy.$setPassword(k,S,C)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[263],ye([1,0,7,5,175,6,15,11]),function(Z,e,c,t,I,P,y,k){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(w,h,g,f,b=c.StatusBarAlignment.Left,m){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,S,w,"f"),tt(this,C,h,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=f,this._alignment=b,this._priority=this.validatePriority(m)}validatePriority(w){if(!!(0,k.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!A.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Ne(this,C,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Ne(this,C,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let h;this._name?h=this._name:h=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=y.MarkdownString.fromStrict(this._tooltip);Ne(this,S,"f").$setEntry(this._entryId,w,h,this._text,f,this._command?.internal,g,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,C=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const h={message:w};return this._messages.unshift(h),this._update(),new c.Disposable(()=>{const g=this._messages.indexOf(h);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(w,h){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new T(this)}createStatusBarEntry(w,h,g,f){return new A(this._proxy,this._commands,w,h,g,f)}setStatusBarMessage(w,h){const g=this._statusMessage.setMessage(w);let f;return typeof h=="number"?f=setTimeout(()=>g.dispose(),h):typeof h<"u"&&h.then(()=>g.dispose(),()=>g.dispose()),new c.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(_e[97],ye([1,0,5,4,3]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}initializeExtensionStorage(k,S,C){return this._proxy.$initializeExtensionStorage(k,S).then(A=>A||C)}setValue(k,S,C){return this._proxy.$setValue(k,S,C)}$acceptValue(k,S,C){this._onDidChangeStorage.fire({shared:k,key:S,value:C})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(_e[70],ye([1,0,3,25,13,69,2]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let k=class{constructor(C,A,T){this._logService=A,this._extHostFileSystem=T,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(C){return y.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,A=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(C){if(this._value)return y.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return y.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([He(0,t.IExtHostInitDataService),He(1,I.ILogService),He(2,P.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(_e[40],ye([1,0,4,5,3,2,16,6,7,176,10,222,21,30,206,88,11,18,15]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class m{constructor(n,i,p,D){this._proxy=n,this._id=i,this._creationOptions=p,this._name=D,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(N,V=!0){R._checkDisposed(),R._proxy.$sendText(R._id,N,V)},show(N){R._checkDisposed(),R._proxy.$show(R._id,N)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(s(n.iconPath)),color:h.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this._serializeParentTerminal(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,p,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:h.ThemeColor.isThemeColor(D)?D.id:void 0,location:this._serializeParentTerminal(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,i){this._exitStatus=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=m;class d{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,i){this._pty.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose?.((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions?.(i=>{i&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this._pty.onDidChangeName?.(i=>{this._onDidChangeProperty.fire({type:"title",value:i})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let v=1,r=class extends k.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,i){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=i.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[p,D]of this._terminalProcesses)D.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,i){const p=new m(this._proxy,(0,_.generateUuid)(),n,n.name),D=new d(n.pty);return p.createExtensionTerminal(n.location,this._serializeParentTerminal(n,i).resolvedExtHostIdentifier,s(n.iconPath),a(n.color)).then(R=>{const N=this._setupExtHostProcessListeners(R,D);this._terminalProcessDisposables[R]=N}),this._terminals.push(p),p.value}_serializeParentTerminal(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const D=this._terminals.find(R=>R.value===p);D&&(i.resolvedExtHostIdentifier=D._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const D=new d(i),R=this._setupExtHostProcessListeners(n,D);this._terminalProcessDisposables[n]=R}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(n);p&&(this._activeTerminal=p,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const p=this._getTerminalById(n);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:i})}async $acceptTerminalDimensions(n,i,p){const D=this._getTerminalById(n);D&&D.setDimensions(i,p)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,p){this._terminalProcesses.get(n)?.resize(i,p)}async $acceptTerminalTitleChange(n,i){const p=this._getTerminalById(n);p&&(p.name=i)}async $acceptTerminalClosed(n,i,p){const D=this._getTerminalObjectIndexById(this._terminals,n);if(D!==null){const R=this._terminals.splice(D,1)[0];R.setExitStatus(i,p),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(n,i,p,D){if(i){const V=this._getTerminalObjectIndexById(this._terminals,i);if(V!==null){this._terminals[V]._id=n,this._onDidOpenTerminal.fire(this.terminals[V]),this._terminals[V].isOpen=!0;return}}const R={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:P.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},N=new m(this._proxy,n,R,p);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(n,i){this._getTerminalById(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const p=this._getTerminalById(n);if(!p)return{message:(0,C.localize)(0,null,n)};p.isOpen||await new Promise(R=>{const N=this.onDidOpenTerminal(async V=>{V===p.value&&(N.dispose(),R())})});const D=this._terminalProcesses.get(n);D?D.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const p=new k.DisposableStore;p.add(i.onProcessReady(R=>this._proxy.$sendProcessReady(n,R.pid,R.cwd))),p.add(i.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(n,R))),this._bufferer.startBuffering(n,i.onProcessData),p.add(i.onProcessExit(R=>this._onProcessExit(n,R))),this._terminalProcesses.set(n,i);const D=this._extensionTerminalAwaitingStart[n];return D&&i instanceof d&&(i.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),p}$acceptProcessAckDataEvent(n,i){this._terminalProcesses.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this._terminalProcesses.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this._getTerminalById(n);i?.setInteractedWith()&&this._onDidChangeTerminalState.fire(i.value)}$acceptProcessResize(n,i,p){try{this._terminalProcesses.get(n)?.resize(i,p)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(n,i){this._terminalProcesses.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(i=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i,p){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,p),this._proxy.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(n,i){const p=new E.CancellationTokenSource().token;let D=await this._profileProviders.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,i);return}this.createTerminalFromOptions(D.options,i)}}async $provideLinks(n,i){const p=this._getTerminalById(n);if(!p)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const R=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,R);const N=[],V={terminal:p.value,line:i},x=[];for(const F of this._linkProviders)x.push(f.Promises.withAsyncBody(async B=>{R.token.onCancellationRequested(()=>B({provider:F,links:[]}));const M=await F.provideTerminalLinks(V,R.token)||[];R.token.isCancellationRequested||B({provider:F,links:M})}));const L=await Promise.all(x);if(R.token.isCancellationRequested)return[];const U=new Map;for(const F of L)F&&F.links.length>0&&N.push(...F.links.map(B=>{const M={id:v++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return U.set(M.id,{provider:F.provider,link:B}),M}));return this._terminalLinkCache.set(n,U),N}$activateLink(n,i){const p=this._terminalLinkCache.get(n)?.get(i);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const p=this._terminalProcessDisposables[n];p&&(p.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const p=this._getTerminalObjectIndexById(n,i);return p!==null?n[p]:null}_getTerminalObjectIndexById(n,i){let p=null;return n.some((D,R)=>D._id===i?(p=R,!0):!1),p}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new o,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const p=(0,T.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const p=i[0],D=new o(i[1]);this._setEnvironmentVariableCollection(p,D)})}$acceptDefaultProfile(n,i){const p=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=i,p?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};r=je([He(1,y.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class o{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const p=this.map.get(n);(!p||p.value!==i.value||p.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((p,D)=>n.call(i,D,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let l=class extends r{constructor(n){super(!1,n)}createTerminal(n,i,p){throw new A.NotSupportedError}createTerminalFromOptions(n,i){throw new A.NotSupportedError}};l=je([He(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function s(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function a(u){return h.ThemeColor.isThemeColor(u)?u:void 0}});var Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)},tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c};define(_e[264],ye([1,0,17,23,21,4,61,82,6,24,11,30,5,16,135,15,7,56,92,67]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m){"use strict";var d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(V,x,L){this.editors=L,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=V.getProxy(E.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new l(this.proxy),x.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==14)return U;const F=U,B=F.tests[F.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(B))?.collection.tree.get(B)?.actual??(0,w.toItemFromContext)(U)}})}createTestController(V,x,L){if(this.controllers.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const U=new S.DisposableStore,F=U.add(new w.ExtHostTestItemCollection(V,x,this.editors));F.root.label=x;const B=new Map,M=this.proxy,z={items:F.root.children,get label(){return x},set label($){x=$,F.root.label=$,M.$updateController(V,{label:x})},get refreshHandler(){return L},set refreshHandler($){L=$,M.$updateController(V,{canRefresh:!!$})},get id(){return V},createRunProfile:($,Q,K,ue,re)=>{let de=(0,k.hash)($);for(;B.has(de);)de++;return new D(this.proxy,B,V,de,$,Q,K,ue,re)},createTestItem($,Q,K){return new w.TestItemImpl(V,$,Q,K)},createTestRun:($,Q,K=!0)=>this.runTracker.createTestRun(V,F,$,Q,K),set resolveHandler($){F.resolveHandler=$},get resolveHandler(){return F.resolveHandler},dispose:()=>{U.dispose()}};M.$registerTestController(V,x,!!L),U.add((0,S.toDisposable)(()=>M.$unregisterTestController(V)));const j={controller:z,collection:F,profiles:B};return this.controllers.set(V,j),U.add((0,S.toDisposable)(()=>this.controllers.delete(V))),U.add(F.onDidGenerateDiff($=>M.$publishDiff(V,$.map(m.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(V,x=I.CancellationToken.None){const L=s(V);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(L.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:V.include?.map(F=>f.TestId.fromExtHostTestItem(F,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:R[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:V.exclude?.map(F=>F.id)},x)}$syncTests(){for(const{collection:V}of this.controllers.values())V.flushDiff();return Promise.resolve()}$provideFileCoverage(V,x,L){return(0,c.mapFind)(this.runTracker.trackers,F=>F.id===V?F.getCoverage(x):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(V,x,L,U){return(0,c.mapFind)(this.runTracker.trackers,B=>B.id===V?B.getCoverage(x):void 0)?.resolveFileCoverage(L,U)??Promise.resolve([])}$configureRunProfile(V,x){this.controllers.get(V)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(V,x){await this.controllers.get(V)?.controller.refreshHandler?.(x)}$publishTestResults(V){this.results=Object.freeze(V.map(x=>(0,C.deepFreeze)(h.TestResults.to(x))).concat(this.results).sort((x,L)=>L.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(V,x){const L=this.controllers.get(f.TestId.fromString(V).controllerId)?.collection;L&&(await L.expand(V,x<0?1/0:x),L.flushDiff())}$acceptDiff(V){this.observer.applyDiff(V.map(m.TestsDiffOp.deserialize))}async $runControllerTests(V,x){return Promise.all(V.map(L=>this.runControllerTestRequest(L,x)))}async runControllerTestRequest(V,x){const L=this.controllers.get(V.controllerId);if(!L)return{};const{collection:U,profiles:F}=L,B=F.get(V.profileId);if(!B)return{};const M=V.testIds.map(Q=>U.tree.get(Q)).filter(A.isDefined),z=V.excludeExtIds.map(Q=>L.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>M.some(K=>K.fullId.compare(Q.fullId)===2));if(!M.length)return{};const j=new g.TestRunRequest(M.some(Q=>Q.actual instanceof w.TestItemRootImpl)?void 0:M.map(Q=>Q.actual),z.map(Q=>Q.actual),B),$=this.runTracker.prepareForMainThreadTestRun(j,a.fromInternal(V,L.collection),x);try{return await B.runHandler(j,x),{}}catch(Q){return{error:String(Q)}}finally{$.isRunning&&!x.isCancellationRequested&&await P.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(V){V===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(V)}};r=je([He(0,_.IExtHostRpcService)],r),e.ExtHostTesting=r;class o extends S.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(V,x,L){super(),this.dto=V,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}getCoverage(V){return this.tasks.get(V)?.coverage}createRun(V){const x=this.dto.id,L=this.dto.controllerId,U=(0,T.generateUuid)(),F=new u(this.proxy,x,U),B=$=>(Q,...K)=>{if(z){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),$(Q,...K))},M=($,Q)=>{const K=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if($.uri&&$.range){const ue={range:h.Range.from($.range),uri:$.uri};for(const re of K)re.location=re.location||ue}this.proxy.$appendTestMessagesInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),K)};let z=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:V,get coverageProvider(){return F.coverageProvider},set coverageProvider($){F.coverageProvider=$},enqueued:B($=>{this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),1)}),skipped:B($=>{this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),5)}),started:B($=>{this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),2)}),errored:B(($,Q,K)=>{M($,Q),this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),6,K)}),failed:B(($,Q,K)=>{M($,Q),this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,L).toString(),4,K)}),passed:B(($,Q)=>{this.proxy.$updateTestStateInRun(x,U,f.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,Q)}),appendOutput:($,Q,K)=>{z||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(x,U,t.VSBuffer.fromString($),Q&&h.location.from(Q),K&&f.TestId.fromExtHostTestItem(K,L).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(x,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:j,coverage:F}),this.proxy.$startedTestRunTask(x,{id:U,name:V,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(V){if(!(V instanceof w.TestItemImpl))throw new b.InvalidTestItemError(V.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString()))return;const x=[],L=this.dto.colllection.root;for(;;){const U=h.TestItem.from(V);if(x.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),V===L))break;V=V.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class l{get trackers(){return this.tracked.values()}constructor(V){this.proxy=V,this.tracked=new Map}prepareForMainThreadTestRun(V,x,L){return this.getTracker(V,x,L)}cancelRunById(V){for(const x of this.tracked.values())if(x.id===V){x.dispose();return}}cancelAllRuns(){for(const V of this.tracked.values())V.dispose()}createTestRun(V,x,L,U,F){const B=this.tracked.get(L);if(B)return B.createRun(U);const M=a.fromPublic(V,x,L,F),z=s(L);this.proxy.$startedExtensionTestRun({controllerId:V,profile:z&&{group:R[z.kind],id:z.profileId},exclude:L.exclude?.map($=>f.TestId.fromExtHostTestItem($,x.root.id).toString())??[],id:M.id,include:L.include?.map($=>f.TestId.fromExtHostTestItem($,x.root.id).toString())??[x.root.id],persist:F});const j=this.getTracker(L,M);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(M.id)),j.createRun(U)}getTracker(V,x,L){const U=new o(x,this.proxy,L);return this.tracked.set(V,U),U.onEnd(()=>this.tracked.delete(V)),U}}e.TestRunCoordinator=l;const s=N=>{if(!!N.profile){if(!(N.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class a{static fromPublic(V,x,L,U){return new a(V,(0,T.generateUuid)(),L.include?.map(F=>f.TestId.fromExtHostTestItem(F,V).toString())??[V],L.exclude?.map(F=>f.TestId.fromExtHostTestItem(F,V).toString())??[],U,x)}static fromInternal(V,x){return new a(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,x)}constructor(V,x,L,U,F,B){this.controllerId=V,this.id=x,this.isPersisted=F,this.colllection=B,this.includePrefix=L.map(M=>M+"\0"),this.excludePrefix=U.map(M=>M+"\0")}isIncluded(V){const x=f.TestId.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(x===L||x.startsWith(L))return!1;for(const L of this.includePrefix)if(x===L||x.startsWith(L))return!0;return!1}}e.TestRunDto=a;class u{set coverageProvider(V){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!V||(this._coverageProvider=V,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(V,x,L){this.proxy=V,this.runId=x,this.taskId=L}async provideFileCoverage(V){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(V))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(V,x){const L=await this.fileCoverage;let U=L?.[V];return!this._coverageProvider||!L||!U?[]:(U.detailedCoverage||(U=L[V]=await this._coverageProvider.resolveFileCoverage?.(U,x)??U),U.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class n extends m.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(V){super(),this.emitter=V,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(V){this.added.add(V)}update(V){Object.assign(V.revived,h.TestItem.toPlain(V.item)),this.added.has(V)||this.updated.add(V)}remove(V){if(this.added.has(V)){this.added.delete(V);return}this.updated.delete(V);const x=f.TestId.parentId(V.item.extId);if(x&&this.alreadyRemoved.has(x.toString())){this.alreadyRemoved.add(V.item.extId);return}this.removed.add(V)}getChangeEvent(){const{added:V,updated:x,removed:L}=this;return{get added(){return[...V].map(U=>U.revived)},get updated(){return[...x].map(U=>U.revived)},get removed(){return[...L].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(V){return this.items.get(V)}getMirroredTestDataByReference(V){return this.items.get(V.id)}createItem(V,x){return{...V,revived:h.TestItem.toPlain(V.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=i;class p{constructor(V){this.proxy=V}checkout(){this.current||(this.current=this.createObserverData());const V=this.current;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(x=>x.revived)},dispose:(0,y.once)(()=>{--V.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(V){return this.current?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.current?.tests.apply(V)}createObserverData(){const V=new i;return this.proxy.$subscribeToDiffs(),{observers:0,tests:V}}}class D{get label(){return this._label}set label(V){V!==this._label&&(this._label=V,Ne(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:V}))}get isDefault(){return this._isDefault}set isDefault(V){V!==this._isDefault&&(this._isDefault=V,Ne(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,Ne(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:V?h.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(V){V!==this._configureHandler&&(this._configureHandler=V,Ne(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!V}))}constructor(V,x,L,U,F,B,M,z=!1,j=void 0){this.controllerId=L,this.profileId=U,this._label=F,this.kind=B,this.runHandler=M,this._isDefault=z,this._tag=j,d.set(this,void 0),v.set(this,void 0),tt(this,d,V,"f"),tt(this,v,x,"f"),x.set(U,this);const $=R[B];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${B}`);Ne(this,d,"f").$publishTestRunProfile({profileId:U,controllerId:L,tag:j?h.TestTag.namespace(this.controllerId,j.id):null,label:F,group:$,isDefault:z,hasConfigurationHandler:!1})}dispose(){Ne(this,v,"f")?.delete(this.profileId)&&(tt(this,v,void 0,"f"),Ne(this,d,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=D,d=new WeakMap,v=new WeakMap;const R={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(_e[265],ye([1,0,17,4,5,136,15,7]),function(Z,e,c,t,I,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const T=this._extHostDocumentsAndEditors.allEditors();return A?T:T.map(E=>E.value)}async showTextDocument(A,T,E){let _;typeof T=="number"?_={position:y.ViewColumn.from(T),preserveFocus:E}:typeof T=="object"?_={position:y.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?y.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:_={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(A.uri,_),h=w&&this._extHostDocumentsAndEditors.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,T){return new P.TextEditorDecorationType(this._proxy,A,T).value}$acceptEditorPropertiesChanged(A,T){const E=this._extHostDocumentsAndEditors.getEditor(A);if(!E)throw new Error("unknown text editor");if(T.options&&E._acceptOptions(T.options),T.selections){const _=T.selections.selections.map(y.Selection.to);E._acceptSelections(_)}if(T.visibleRanges){const _=c.coalesce(T.visibleRanges.map(y.Range.to));E._acceptVisibleRanges(_)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...T.options,lineNumbers:y.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const _=k.TextEditorSelectionChangeKind.fromValue(T.selections.source),w=T.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:w,kind:_})}if(T.visibleRanges){const _=c.coalesce(T.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:_})}}$acceptEditorPositionData(A){for(const T in A){const E=this._extHostDocumentsAndEditors.getEditor(T);if(!E)throw new Error("Unknown text editor");const _=y.ViewColumn.to(A[T]);E.value.viewColumn!==_&&(E._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:_}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(_e[266],ye([1,0,2,3,5,6,7,15,11]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(E,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const h=w.uri===void 0?void 0:c.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(A(h))?.get(w.handle)}return w}})}async $getTimeline(E,_,w,h){return this._providers.get(E)?.provideTimeline(c.URI.revive(_),w,h)}registerTimelineProvider(E,_,w,h){const g=new P.DisposableStore,f=this.convertTimelineItem(_.id,h,g).bind(this);let b;_.onDidChange&&(b=_.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:_.id}),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:E,onDidChange:void 0,async provideTimeline(d,v,r){v?.resetCache&&(g.clear(),m.get(_.id)?.clear());const o=await _.provideTimeline(d,v,r);if(o==null)return;const l=f(d,v);return{...o,source:_.id,items:o.items.map(l)}},dispose(){for(const d of m.values())d.get(_.id)?.clear();b?.dispose(),g.dispose()}})}convertTimelineItem(E,_,w){return(h,g)=>{let f;if(g?.cacheResults){let b=this._itemsBySourceAndUriMap.get(E);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(E,b));const m=A(h);f=b.get(m),f===void 0&&(f=new Map,b.set(m,f))}return b=>{const{iconPath:m,...d}=b,v=`${E}|${b.id??b.timestamp}`;f?.set(v,b);let r,o,l;b.iconPath&&(m instanceof y.ThemeIcon?l={id:m.id,color:m.color}:c.URI.isUri(m)?(r=m,o=m):{light:r,dark:o}=m);let s;return y.MarkdownString.isMarkdownString(d.tooltip)?s=k.MarkdownString.from(d.tooltip):(0,S.isString)(d.tooltip)?s=d.tooltip:y.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=k.MarkdownString.from(d.detail)):(0,S.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=d.detail),{...d,id:d.id??void 0,handle:v,source:E,command:b.command?_.toInternal(b.command,w):void 0,icon:r,iconDark:o,themeIcon:l,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=C;function A(T){return T?.toString()}}),define(_e[267],ye([1,0,6,14,2,5]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,A,T){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const E=T.schemes.find(_=>!y.supportedSchemes.has(_));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,A),this._proxy.$registerUriOpener(C,T.schemes,S,T.label),(0,c.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,A){const T=this._openers.get(S);if(!T)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(C);return T.canOpenExternalUri(E,A)}async $openUri(S,C,A){const T=this._openers.get(S);if(!T)throw new Error(`Unknown opener id: '${S}'`);return T.openExternalUri(I.URI.revive(C.resolvedUri),{sourceUri:I.URI.revive(C.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(_e[268],ye([1,0,5,2,6,10,26]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(C,A){if(this.handles.has(y.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const T=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(C)),this.handlers.set(T,A),this._proxy.$registerUriHandler(T,C),(0,I.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(C)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(C,A){const T=this.handlers.get(C);if(!T)return Promise.resolve(void 0);try{T.handleUri(t.URI.revive(A))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[71],ye([1,0,4,14,24,2,190,213,90,5]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";var A,T,E,_,w,h,g,f,b,m,d,v,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(R,N,V,x,L,U,F){A.set(this,void 0),T.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,""),f.set(this,void 0),b.set(this,!1),m.set(this,!1),d.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new c.Emitter),this._onDidDispose=Ne(this,r,"f").event,tt(this,A,R,"f"),tt(this,T,N,"f"),tt(this,f,V,"f"),tt(this,_,x,"f"),tt(this,w,L,"f"),tt(this,h,U,"f"),tt(this,d,l(U),"f"),tt(this,v,s(U),"f"),tt(this,E,F,"f")}dispose(){tt(this,b,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return tt(this,m,!0,"f"),(0,S.asWebviewUri)(R,Ne(this,_,"f"))}get cspSource(){const R=Ne(this,h,"f").extensionLocation;if(R.scheme===t.Schemas.https||R.scheme===t.Schemas.http){let N=R.toString();return N.endsWith("/")||(N+="/"),N+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,g,"f")}set html(R){this.assertNotDisposed(),Ne(this,g,"f")!==R&&(tt(this,g,R,"f"),Ne(this,v,"f")&&!Ne(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(tt(this,m,!0,"f"),Ne(this,E,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,T,"f").$setHtml(Ne(this,A,"f"),this.rewriteOldResourceUrlsIfNeeded(R)))}get options(){return this.assertNotDisposed(),Ne(this,f,"f")}set options(R){this.assertNotDisposed(),I.equals(Ne(this,f,"f"),R)||Ne(this,T,"f").$setOptions(Ne(this,A,"f"),n(Ne(this,h,"f"),Ne(this,w,"f"),R)),tt(this,f,R,"f")}async postMessage(R){if(Ne(this,b,"f"))return!1;const N=(0,k.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Ne(this,d,"f")});return Ne(this,T,"f").$postMessage(Ne(this,A,"f"),N.message,...N.buffers)}assertNotDisposed(){if(Ne(this,b,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(R){if(!Ne(this,v,"f"))return R;const N=Ne(this,h,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,V=Ne(this,h,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ne(this,h,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,U,F,B,M)=>{const z=P.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),j=(0,S.asWebviewUri)(z,{isRemote:N,authority:V}).toString();return`${L}${j}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,L,U,F,B,M)=>{const z=P.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),j=(0,S.asWebviewUri)(z,{isRemote:N,authority:V}).toString();return`${L}${j}${M}`})}}e.ExtHostWebview=o,A=new WeakMap,T=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,d=new WeakMap,v=new WeakMap,r=new WeakMap;function l(D){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(D.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;function s(D){try{const R=(0,y.normalizeVersion)((0,y.parseVersion)(D.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class a{constructor(R,N,V,x,L){this.remoteInfo=N,this.workspace=V,this._logService=x,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=R.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(R,N,V){const x=this.getWebview(R);if(x){const{message:L}=(0,k.deserializeWebviewMessage)(N,V.value);x._onMessageEmitter.fire(L)}}$onMissingCsp(R,N){this._logService.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,N,V){const x=new o(R,this._webviewProxy,i(N),this.remoteInfo,this.workspace,V,this._deprecationService);return this._webviews.set(R,x),x._onDidDispose(()=>{this._webviews.delete(R)}),x}deleteWebview(R){this._webviews.delete(R)}getWebview(R){return this._webviews.get(R)}}e.ExtHostWebviews=a;function u(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=u;function n(D,R,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||p(D,R)}}e.serializeWebviewOptions=n;function i(D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots?.map(R=>P.URI.from(R))}}function p(D,R){return[...(R?.getWorkspaceFolders()||[]).map(N=>N.uri),D.extensionLocation]}}),define(_e[269],ye([1,0,21,82,6,14,22,2,15,71,89,5,7]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(o,l){this.document=o,this._storagePath=l,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,l){await this.getEdit(o).undo(),l||this.disposeBackup()}async redo(o,l){await this.getEdit(o).redo(),l||this.disposeBackup()}disposeEdits(o){for(const l of o)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=v(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const l=this._edits.get(o,0);if(!l)throw new Error("No edit found");return l}}class w{constructor(){this._documents=new Map}get(o,l){return this._documents.get(this.key(o,l))}add(o,l,s){const a=this.key(o,l.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${o} resource:${l.uri}`);const u=new _(l,s);return this._documents.set(a,u),u}delete(o,l){const s=this.key(o,l.uri);this._documents.delete(s)}key(o,l){return`${o}@@@${l}`}}var h;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this._providers=new Map}addTextProvider(o,l,s){return this.add(0,o,l,s)}addCustomProvider(o,l,s){return this.add(1,o,l,s)}get(o){return this._providers.get(o)}add(o,l,s,a){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:o,extension:s,provider:a}),new E.Disposable(()=>this._providers.delete(l))}}class f{constructor(o,l,s,a,u){this._extHostDocuments=l,this._extensionStoragePaths=s,this._extHostWebview=a,this._extHostWebviewPanels=u,this._editorProviders=new g,this._documents=new w,this._proxy=o.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,l,s,a){const u=new I.DisposableStore;return m(s)?(u.add(this._editorProviders.addTextProvider(l,o,s)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(o),l,a.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(o))):(u.add(this._editorProviders.addCustomProvider(l,o,s)),b(s)&&u.add(s.onDidChangeCustomDocument(n=>{const i=this.getCustomDocumentEntry(l,n.document.uri);if(d(n)){const p=i.addEdit(n);this._proxy.$onDidEdit(n.document.uri,l,p,n.label)}else this._proxy.$onContentChange(n.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(o),l,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(o))),E.Disposable.from(u,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(o,l,s,a,u){const n=this._editorProviders.get(l);if(!n)throw new Error(`No provider found for '${l}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${l}'`);const i=k.URI.revive(o),p=await n.provider.openCustomDocument(i,{backupId:s,untitledDocumentData:a?.buffer},u);let D;return b(n.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(l,p,D),{editable:b(n.provider)}}async $disposeCustomDocument(o,l){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${l}'`);const a=k.URI.revive(o),{document:u}=this.getCustomDocumentEntry(l,a);this._documents.delete(l,u),u.dispose()}async $resolveWebviewEditor(o,l,s,a,u,n){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);const p=S.ViewColumn.to(u),D=this._extHostWebview.createNewWebview(l,a.contentOptions,i.extension),R=this._extHostWebviewPanels.createNewWebviewPanel(l,s,a.title,p,a.options,D,!0),N=k.URI.revive(o);switch(i.type){case 1:{const{document:V}=this.getCustomDocumentEntry(s,N);return i.provider.resolveCustomEditor(V,R,n)}case 0:{const V=this._extHostDocuments.getDocument(N);return i.provider.resolveCustomTextEditor(V,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,l,s){this.getCustomDocumentEntry(l,o).disposeEdits(s)}async $onMoveCustomEditor(o,l,s){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(o);if(!u)throw new Error("No webview found");const n=k.URI.revive(l),i=this._extHostDocuments.getDocument(n);await a.provider.moveCustomTextEditor(i,u,c.CancellationToken.None)}async $undo(o,l,s,a){return this.getCustomDocumentEntry(l,o).undo(s,a)}async $redo(o,l,s,a){return this.getCustomDocumentEntry(l,o).redo(s,a)}async $revert(o,l,s){const a=this.getCustomDocumentEntry(l,o);await this.getCustomEditorProvider(l).revertCustomDocument(a.document,s),a.disposeBackup()}async $onSave(o,l,s){const a=this.getCustomDocumentEntry(l,o);await this.getCustomEditorProvider(l).saveCustomDocument(a.document,s),a.disposeBackup()}async $onSaveAs(o,l,s,a){const u=this.getCustomDocumentEntry(l,o);return this.getCustomEditorProvider(l).saveCustomDocumentAs(u.document,k.URI.revive(s),a)}async $backup(o,l,s){const a=this.getCustomDocumentEntry(l,o),n=await this.getCustomEditorProvider(l).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},s);return a.updateBackup(n),n.id}getCustomDocumentEntry(o,l){const s=this._documents.get(o,k.URI.revive(l));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(o){const s=this._editorProviders.get(o)?.provider;if(!s||!b(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=f;function b(r){return!!r.onDidChangeCustomDocument}function m(r){return typeof r.resolveCustomTextEditor=="function"}function d(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function v(r){const o=r.scheme===P.Schemas.file||r.scheme===P.Schemas.untitled?r.fsPath:r.toString();return(0,t.hash)(o)+""}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[270],ye([1,0,4,6,2,30,15,71,5,7]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";var A,T,E,_,w,h,g,f,b,m,d,v,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends t.Disposable{constructor(u,n,i,p){super(),A.set(this,void 0),T.set(this,void 0),E.set(this,void 0),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,void 0),b.set(this,!0),m.set(this,void 0),d.set(this,!1),v.set(this,this._register(new c.Emitter)),this.onDidDispose=Ne(this,v,"f").event,r.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ne(this,r,"f").event,tt(this,A,u,"f"),tt(this,T,n,"f"),tt(this,_,i,"f"),tt(this,E,p.viewType,"f"),tt(this,w,p.panelOptions,"f"),tt(this,f,p.viewColumn,"f"),tt(this,h,p.title,"f"),tt(this,m,p.active,"f")}dispose(){Ne(this,d,"f")||(tt(this,d,!0,"f"),Ne(this,v,"f").fire(),Ne(this,T,"f").$disposeWebview(Ne(this,A,"f")),Ne(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,_,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,E,"f")}get title(){return this.assertNotDisposed(),Ne(this,h,"f")}set title(u){this.assertNotDisposed(),Ne(this,h,"f")!==u&&(tt(this,h,u,"f"),Ne(this,T,"f").$setTitle(Ne(this,A,"f"),u))}get iconPath(){return this.assertNotDisposed(),Ne(this,g,"f")}set iconPath(u){this.assertNotDisposed(),Ne(this,g,"f")!==u&&(tt(this,g,u,"f"),Ne(this,T,"f").$setIconPath(Ne(this,A,"f"),I.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Ne(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,f,"f")=="number"&&Ne(this,f,"f")<0))return Ne(this,f,"f")}get active(){return this.assertNotDisposed(),Ne(this,m,"f")}get visible(){return this.assertNotDisposed(),Ne(this,b,"f")}_updateViewState(u){Ne(this,d,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,m,u.active,"f"),tt(this,b,u.visible,"f"),tt(this,f,u.viewColumn,"f"),Ne(this,r,"f").fire({webviewPanel:this}))}reveal(u,n){this.assertNotDisposed(),Ne(this,T,"f").$reveal(Ne(this,A,"f"),{viewColumn:typeof u>"u"?void 0:y.ViewColumn.from(u),preserveFocus:!!n})}assertNotDisposed(){if(Ne(this,d,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,T=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,d=new WeakMap,v=new WeakMap,r=new WeakMap;class l{static newHandle(){return(0,P.generateUuid)()}constructor(u,n,i){this.webviews=n,this.workspace=i,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,i,p,D={}){const R=typeof p=="object"?p.viewColumn:p,N={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},V=(0,k.shouldSerializeBuffersForPostMessage)(u),x=l.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(u),x,n,{title:i,panelOptions:s(D),webviewOptions:(0,k.serializeWebviewOptions)(u,this.workspace,D),serializeBuffersForPostMessage:V},N);const L=this.webviews.createNewWebview(x,D,u);return this.createNewWebviewPanel(x,n,i,R,D,L,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((i,p)=>{const D=u[i],R=u[p];return D.active?1:R.active?-1:+D.visible-+R.visible});for(const i of n){const p=this.getWebviewPanel(i);if(!p)continue;const D=u[i];p._updateViewState({active:D.active,visible:D.visible,viewColumn:y.ViewColumn.to(D.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,n,i){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:i,extension:u}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(u)}),new C.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,i,p){const D=this._serializers.get(n);if(!D)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:N}=D,V=this.webviews.createNewWebview(u,i.webviewOptions,N),x=this.createNewWebviewPanel(u,n,i.title,p,i.panelOptions,V,i.active);await R.deserializeWebviewPanel(x,i.state)}createNewWebviewPanel(u,n,i,p,D,R,N){const V=new o(u,this._proxy,R,{viewType:n,title:i,viewColumn:p,panelOptions:D,active:N});return this._webviewPanels.set(u,V),V}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=l;function s(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[271],ye([1,0,4,6,71,15,5,7]),function(Z,e,c,t,I,P,y,k){"use strict";var S,C,A,T,E,_,w,h,g,f,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(r,o,l,s,a,u){super(),S.set(this,void 0),C.set(this,void 0),A.set(this,void 0),T.set(this,void 0),E.set(this,!1),_.set(this,void 0),w.set(this,void 0),h.set(this,void 0),g.set(this,void 0),f.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ne(this,f,"f").event,b.set(this,this._register(new c.Emitter)),this.onDidDispose=Ne(this,b,"f").event,tt(this,A,l,"f"),tt(this,w,s,"f"),tt(this,S,r,"f"),tt(this,C,o,"f"),tt(this,T,a,"f"),tt(this,_,u,"f")}dispose(){Ne(this,E,"f")||(tt(this,E,!0,"f"),Ne(this,b,"f").fire(),Ne(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,w,"f")}set title(r){this.assertNotDisposed(),Ne(this,w,"f")!==r&&(tt(this,w,r,"f"),Ne(this,C,"f").$setWebviewViewTitle(Ne(this,S,"f"),r))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(r){this.assertNotDisposed(),Ne(this,h,"f")!==r&&(tt(this,h,r,"f"),Ne(this,C,"f").$setWebviewViewDescription(Ne(this,S,"f"),r))}get visible(){return Ne(this,_,"f")}get webview(){return Ne(this,T,"f")}get viewType(){return Ne(this,A,"f")}_setVisible(r){r===Ne(this,_,"f")||Ne(this,E,"f")||(tt(this,_,r,"f"),Ne(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Ne(this,g,"f")}set badge(r){this.assertNotDisposed(),!(r?.value===Ne(this,g,"f")?.value&&r?.tooltip===Ne(this,g,"f")?.tooltip)&&(tt(this,g,P.ViewBadge.from(r),"f"),Ne(this,C,"f").$setWebviewViewBadge(Ne(this,S,"f"),r))}show(r){this.assertNotDisposed(),Ne(this,C,"f").$show(Ne(this,S,"f"),!!r)}assertNotDisposed(){if(Ne(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,A=new WeakMap,T=new WeakMap,E=new WeakMap,_=new WeakMap,w=new WeakMap,h=new WeakMap,g=new WeakMap,f=new WeakMap,b=new WeakMap;class d{constructor(r,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,o,l,s){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:l,extension:r}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(r),o,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(r)}),new k.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(r,o,l,s,a){const u=this._viewProviders.get(o);if(!u)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:i}=u,p=this._extHostWebview.createNewWebview(r,{},i),D=new m(r,this._proxy,o,l,p,!0);this._webviewViews.set(r,D),await n.resolveWebviewView(D,{state:s},a)}async $onDidChangeWebviewViewVisibility(r,o){this.getWebviewView(r)._setVisible(o)}async $disposeWebviewView(r){const o=this.getWebviewView(r);this._webviewViews.delete(r),o.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const o=this._webviewViews.get(r);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=d}),define(_e[139],ye([1,0,4,5,2,14,8,3,16]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ei{get state(){return this._state}constructor(T){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ei.InitialState,this._proxy=T.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,E){let _;if(typeof T=="string"){_=T;try{T=I.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,y.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,_,E)}async asExternalUri(T,E){if((0,y.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(T,E);return I.URI.from(_)}};C.InitialState={focused:!0},C=je([He(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(_e[272],ye([1,0,117,273,65,39,2,13,45]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(E,_,w){this._commands=E,this.logService=_,this._ipcHandlePath=w,this._server=t.createServer((h,g)=>this.onRequest(h,g)),this.setup().catch(h=>(_.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,_){const w=(g,f)=>{_.writeHead(g,{"content-type":"application/json"}),_.end(JSON.stringify(f||null),b=>b&&this.logService.error(b))},h=[];E.setEncoding("utf8"),E.on("data",g=>h.push(g)),E.on("end",async()=>{try{const g=JSON.parse(h.join(""));let f;switch(g.type){case"open":f=await this.open(g);break;case"openExternal":f=await this.openExternal(g);break;case"status":f=await this.getStatus(g);break;case"extensionManagement":f=await this.manageExtensions(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);w(500,f),this.logService.error("Error while processing pipe request",g)}})}async open(E){const{fileURIs:_,folderURIs:w,forceNewWindow:h,diffMode:g,mergeMode:f,addMode:b,forceReuseWindow:m,gotoLineMode:d,waitMarkerFilePath:v,remoteAuthority:r}=E,o=[];if(Array.isArray(w))for(const u of w)try{o.push({folderUri:y.URI.parse(u)})}catch{}if(Array.isArray(_))for(const u of _)try{(0,S.hasWorkspaceFileExtension)(u)?o.push({workspaceUri:y.URI.parse(u)}):o.push({fileUri:y.URI.parse(u)})}catch{}const l=v?y.URI.file(v):void 0,a={forceNewWindow:h,diffMode:g,mergeMode:f,addMode:b,gotoLineMode:d,forceReuseWindow:m,preferNewWindow:!m&&!l&&!b,waitMarkerFileURI:l,remoteAuthority:r};return this._commands.executeCommand("_remoteCLI.windowOpen",o,a),""}async openExternal(E){for(const _ of E.uris){const w=y.URI.parse(_),h=w.scheme==="file"?w:_;await this._commands.executeCommand("_remoteCLI.openExternal",h)}}async manageExtensions(E){const _=h=>h?.map(g=>/\.vsix$/i.test(g)?y.URI.parse(g):g),w={list:E.list,install:_(E.install),uninstall:_(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let A=class extends C{constructor(E,_){super(E,_,(0,c.createRandomIPCHandle)())}};A=je([He(0,P.IExtHostCommands),He(1,k.ILogService)],A),e.CLIServer=A}),define(_e[274],ye([1,0,246,25,16]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends c.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,C,A){const T=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,T.write(`
START_NATIVE_LOG
`),C.apply(console,A),T.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,C){const A=process[S],T=A.write;let E="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(_,w,h)=>{if(!this._isMakingConsoleCall){E+=_.toString(w);const g=E.length>P?E.length:E.lastIndexOf(`
`);g!==-1&&(console[C](E.slice(0,g)),E=E.slice(g+1))}T.call(A,_,w,h)}})}};y=je([He(0,I.IExtHostRpcService),He(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(_e[275],ye([1,0,9,84,30,39,6,5,2,16]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends y.Disposable{constructor(E,_){super();const w=E.getProxy(k.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await w.$download(h,g),g})}};A=je([He(0,C.IExtHostRpcService),He(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(_e[276],ye([1,0,138,14,196,30]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends c.ExtHostLoggerService{doCreateLogger(S,C,A){return S.scheme===t.Schemas.file?new I.SpdLogLogger(A?.name||(0,P.generateUuid)(),S.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,C):super.doCreateLogger(S,C,A)}}e.ExtHostLoggerService=y}),define(_e[277],ye([1,0,65,9,2,70,6,14,18,29]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(r){const o=await super._getWorkspaceStorageURI(r);if(o.scheme!==k.Schemas.file)return o;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const l=o.fsPath;let s=0;do{let a;s===0?a=l:a=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${s}`:`${l}-${s}`,await T(a);const u=t.join(a,"vscode.lock"),n=await h(this._logService,u,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),I.URI.file(a);s++}while(s<10);return o}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function T(v){try{await C.Promises.stat(v);return}catch{}try{await C.Promises.mkdir(v,{recursive:!0})}catch{}}const E=1e3,_=10*60*1e3;class w extends y.Disposable{constructor(r,o){super(),this.logService=r,this.filename=o,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const l=await g(r,o);(!l||l.pid!==process.pid)&&(r.info(`Lock '${o}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(o,new Date,new Date)}catch(s){r.error(s),r.info(`Lock '${o}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(r){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+r};await C.Promises.writeFile(this.filename,JSON.stringify(o),{flag:"w"})}catch(o){this.logService.error(o)}}}async function h(v,r,o){try{const s={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(r,JSON.stringify(s),{flag:"wx"})}catch(s){v.error(s)}const l=await g(v,r);return!l||l.pid!==process.pid?o?(v.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),m(v,r)):(v.info(`Lock '${r}': Lock acquired.`),new w(v,r))}async function g(v,r){let o;try{o=await C.Promises.readFile(r)}catch(l){return v.error(l),null}try{return JSON.parse(String(o))}catch(l){return v.error(l),null}}async function f(v,r){let o;try{o=await C.Promises.stat(r)}catch(l){return v.error(l),0}return o.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch{return!1}}async function m(v,r){const o=await g(v,r);if(!o)return v.info(`Lock '${r}': Could not read pid of lock holder.`),d(v,r);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?v.info(`Lock '${r}': The lockfile is scheduled to be released in ${n} ms.`):v.info(`Lock '${r}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(v,r)===0)return d(v,r);n=o.willReleaseAt-Date.now()}return d(v,r)}}if(!b(o.pid))return v.info(`Lock '${r}': The pid ${o.pid} appears to be gone.`),d(v,r);const l=await f(v,r),s=Date.now()-l;if(s<=_)return v.info(`Lock '${r}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;v.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const a=await f(v,r),u=Date.now()-a;return u<=_?(v.info(`Lock '${r}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(v.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),d(v,r))}async function d(v,r){v.info(`Lock '${r}': Deleting a stale lock.`);try{await C.Promises.unlink(r)}catch{}return h(v,r,!0)}}),define(_e[278],ye([1,0,30,16,40]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,C){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:C})}createTerminalFromOptions(k,S){const C=new I.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),k,k.name);return this._terminals.push(C),C.create(k,this._serializeParentTerminal(k,S)),C.value}};P=je([He(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(_e[279],ye([1,0,5,16,180,6,25,2,44,22,29,7,12,54,4,128,100,13]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class b extends h.DisposableTunnel{}function m(n){const i=n.trim().split(`
`),p=[];return i.forEach(R=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);N&&N.length>=3&&p.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),p.reduce((R,N)=>(R[N.socket]=N,R),{})}e.getSockets=m;function d(...n){const i=[].concat(...n.map(r));return[...new Map(i.filter(p=>p.st==="0A").map(p=>{const D=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:v(D[0]),port:parseInt(D[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=d;function v(n){let i="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)i+=parseInt(n.substr(p,2),16),p!==0&&(i+=".");else for(let p=n.length-4;p>=0;p-=4)i+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(i+=":");return i}function r(n){const i=n.trim().split(`
`),p=i.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return i.map(R=>R.trim().split(/\s+/).reduce((N,V,x)=>(N[p[x]||x]=V,N),{}))}e.loadConnectionTable=r;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function l(n){const i=n.trim().split(`
`),p=[];return i.forEach(D=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);R&&R.length>=4&&p.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),p}e.getRootProcesses=l;async function s(n,i,p){const D=p.reduce((N,V)=>(N[V.pid]=V,N),{}),R=[];return n.forEach(({socket:N,ip:V,port:x})=>{const L=i[N]?i[N].pid:void 0,U=L?D[L]?.cmd:void 0;L&&U&&!o(U)&&R.push({host:V,port:x,detail:U,pid:L})}),R}e.findPorts=s;function a(n,i,p){const D=new Map,R=l(i);for(const N of n){const V=p.get(N.port);if(V){D.set(N.port,V);continue}const x=R.find(L=>L.cmd.includes(`${N.port}`));if(x){let L=x,U;do U=R.find(F=>F.ppid===L.pid),U&&(L=U);while(U);D.set(N.port,{host:N.ip,port:N.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else D.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=a;let u=class extends P.Disposable{constructor(i,p,D){super(),this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=i.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(i,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(p,i.displayName);if(D){const R=new b(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(i){return Math.max(i*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(i,p){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:i,provider:p}),this._proxy.$registerPortsAttributesProvider(i,D),new T.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(i,p,D,R,N){const V=[];for(const L of i){const U=this._portAttributesProviders.get(L);if(!U)return[];V.push(...await Promise.all(p.map(async F=>U.provider.providePortAttributes(F,D,R,N))))}const x=V.filter(L=>!!L);return x.length>0?x.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(i){if(i&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=i;const p=new g.MovingAverage;let D;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),N=(await this.findCandidatePorts()).filter(x=>(0,h.isLocalhost)(x.host)||(0,h.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(x=>x.port).join(", ")}`);const V=new Date().getTime()-R;p.update(V),(!D||JSON.stringify(D)!==JSON.stringify(N))&&(D=N,await this._proxy.$onFoundNewCandidates(D)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(p.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,this._proxy.$setCandidateFilter()),i.tunnelFactory){this._forwardPortProvider=i.tunnelFactory;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const D=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this._proxy.$setTunnelProvider(D)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,p){if(this._extensionTunnels.has(i.host)){const D=this._extensionTunnels.get(i.host);D.has(i.port)&&(p&&D.get(i.port).disposeListener.dispose(),await D.get(i.port).tunnel.dispose(),D.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(i,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const R=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const N=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:R,disposeListener:N}),_.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const p=await Promise.all(i.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),D=i.filter((R,N)=>p[N]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(R=>R.port).join(", ")} to ${D.map(R=>R.port).join(", ")}`),D}async findCandidatePorts(){let i="",p="";try{i=await A.Promises.readFile("/proc/net/tcp","utf8"),p=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const D=d(i,p),R=await new Promise(M=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,j,$)=>{M(j)})}),N=m(R),V=await A.Promises.readdir("/proc"),x=[];for(const M of V)try{const z=Number(M),j=C.joinPath(k.URI.file("/proc"),M);if((await A.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(z)){const Q=await A.Promises.readlink(C.joinPath(j,"cwd").fsPath),K=await A.Promises.readFile(C.joinPath(j,"cmdline").fsPath,"utf8");x.push({pid:z,cwd:Q,cmd:K})}}catch{}const L=[],U=D.filter(M=>{const z=N[M.socket];return z||L.push(M),z}),F=s(U,N,x);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const M=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(j,$,Q)=>{z($)})});this._foundRootPorts=a(L,M,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return F.then(M=>B?M.concat(B):M)}};u=je([He(0,t.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,f.ILogService)],u),e.ExtHostTunnelService=u}),define(_e[280],ye([1,0,18,23,21,10,4,6,112,240,57]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(D,R){try{return JSON.stringify(D,R)}catch{return"null"}}const _="$$ref$$",w={[_]:-1};class h{constructor(R,N){this.jsonString=R,this.referencedBuffers=N}}function g(D,R=null,N=!1){const V=[];return{jsonString:(N?E:JSON.stringify)(D,(L,U)=>{if(typeof U>"u")return w;if(typeof U=="object"){if(U instanceof t.VSBuffer){const F=V.push(U)-1;return{[_]:F}}if(R)return R(L,U)}return U}),referencedBuffers:V}}e.stringifyJsonWithBufferRefs=g;function f(D,R,N){return JSON.parse(D,(V,x)=>{if(x){const L=x[_];if(typeof L=="number")return R[L];if(N&&x.$mid===1)return N.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=f;function b(D,R){return JSON.stringify(D,R)}function m(D){return D?(R,N)=>N&&N.$mid===1?D.transformOutgoing(N):N:null}var d;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},o=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class s extends k.Disposable{constructor(R,N=null,V=null){super(),this[T]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=N,this._uriTransformer=V,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,L=A.ProxyIdentifier.count;x<L;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,S.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:N,sid:V}=R;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,V)),this._proxies[N]}_createProxy(R,N){const V={get:(x,L)=>(typeof L=="string"&&!x[L]&&L.charCodeAt(0)===36&&(x[L]=(...U)=>this._remoteCall(R,L,U)),L===l?N:x[L])};return new Proxy(Object.create(null),V)}set(R,N){return this._locals[R.nid]=N,N}assertRegistered(R){for(let N=0,V=R.length;N<V;N++){const x=R[N];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const N=R.byteLength,V=a.read(R,0),x=V.readUInt8(),L=V.readUInt32();switch(x){case 1:case 2:{let{rpcId:U,method:F,args:B}=n.deserializeRequestJSONArgs(V);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(N,L,U,F,B,x===2);break}case 3:case 4:{let{rpcId:U,method:F,args:B}=n.deserializeRequestMixedArgs(V);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(N,L,U,F,B,x===4);break}case 5:{this._logger?.logIncoming(N,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(N,L);break}case 7:{this._receiveReply(N,L,void 0);break}case 9:{let U=n.deserializeReplyOKJSON(V);this._uriTransformer&&(U=(0,S.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(N,L,U);break}case 10:{const U=n.deserializeReplyOKJSONWithBuffers(V,this._uriTransformer);this._receiveReply(N,L,U);break}case 8:{const U=n.deserializeReplyOKVSBuffer(V);this._receiveReply(N,L,U);break}case 11:{let U=n.deserializeReplyErrError(V);this._uriTransformer&&(U=(0,S.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(N,L,U);break}case 12:{this._receiveReplyErr(N,L,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,N,V,x,L,U){this._logger?.logIncoming(R,N,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(V)}.${x}(`,L);const F=String(N);let B,M;if(U){const j=new I.CancellationTokenSource;L.push(j.token),B=this._invokeHandler(V,x,L),M=()=>j.cancel()}else B=this._invokeHandler(V,x,L),M=r;this._cancelInvokedHandlers[F]=M;const z=n.serializeAcknowledged(N);this._logger?.logOutgoing(z.byteLength,N,1,"ack"),this._protocol.send(z),B.then(j=>{delete this._cancelInvokedHandlers[F];const $=n.serializeReplyOK(N,j,this._uriReplacer);this._logger?.logOutgoing($.byteLength,N,1,"reply:",j),this._protocol.send($)},j=>{delete this._cancelInvokedHandlers[F];const $=n.serializeReplyErr(N,j);this._logger?.logOutgoing($.byteLength,N,1,"replyErr:",j),this._protocol.send($)})}_receiveCancel(R,N){this._logger?.logIncoming(R,N,1,"receiveCancel");const V=String(N);this._cancelInvokedHandlers[V]?.()}_receiveReply(R,N,V){this._logger?.logIncoming(R,N,0,"receiveReply:",V);const x=String(N);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const L=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],L.resolveOk(V)}_receiveReplyErr(R,N,V){this._logger?.logIncoming(R,N,0,"receiveReplyErr:",V);const x=String(N);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const L=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let U;V&&(V.$isError?(U=new Error,U.name=V.name,U.message=V.message,U.stack=V.stack):U=V),L.resolveErr(U)}_invokeHandler(R,N,V){try{return Promise.resolve(this._doInvokeHandler(R,N,V))}catch(x){return Promise.reject(x)}}_doInvokeHandler(R,N,V){const x=this._locals[R];if(!x)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(R));const L=x[N];if(typeof L!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.getStringIdentifierForProxy)(R));return L.apply(x,V)}_remoteCall(R,N,V){if(this._isDisposed)return new C.CanceledLazyPromise;let x=null;if(V.length>0&&I.CancellationToken.isCancellationToken(V[V.length-1])&&(x=V.pop()),x&&x.isCancellationRequested)return Promise.reject(P.canceled());const L=n.serializeRequestArguments(V,this._uriReplacer),U=++this._lastMessageId,F=String(U),B=new C.LazyPromise;x&&x.onCancellationRequested(()=>{const z=n.serializeCancel(U);this._logger?.logOutgoing(z.byteLength,U,0,"cancel"),this._protocol.send(n.serializeCancel(U))}),this._pendingRPCReplies[F]=B,this._onWillSendRequest(U);const M=n.serializeRequest(U,R,N,L,!!x);return this._logger?.logOutgoing(M.byteLength,U,0,`request: ${(0,A.getStringIdentifierForProxy)(R)}.${N}(`,V),this._protocol.send(M),B}}e.RPCProtocol=s,T=o,s.UNRESPONSIVE_TIME=3*1e3;class a{static alloc(R,N,V){const x=new a(t.VSBuffer.alloc(V+1+4),0);return x.writeUInt8(R),x.writeUInt32(N),x}static read(R,N){return new a(R,N)}get buffer(){return this._buff}constructor(R,N){this._buff=R,this._offset=N}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const V=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,V}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,N}static sizeMixedArray(R){let N=0;N+=1;for(let V=0,x=R.length;V<x;V++){const L=R[V];switch(N+=1,L.type){case 1:N+=this.sizeLongString(L.value);break;case 2:N+=this.sizeVSBuffer(L.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(L.value);for(let U=0;U<L.buffers.length;++U)N+=this.sizeVSBuffer(L.buffers[U]);break;case 4:break}}return N}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let N=0,V=R.length;N<V;N++){const x=R[N];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let L=0;L<x.buffers.length;++L)this.writeBuffer(x.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:N[V]=this.readLongString();break;case 2:N[V]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),U=this.readLongString(),F=[];for(let B=0;B<L;++B)F.push(this.readVSBuffer());N[V]=new A.SerializableObjectWithBuffers(f(U,F,null));break}case 4:N[V]=void 0;break}return N}}a.sizeUInt32=4;var u;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(u||(u={}));class n{static _useMixedArgSerialization(R){for(let N=0,V=R.length;N<V;N++)if(R[N]instanceof t.VSBuffer||R[N]instanceof A.SerializableObjectWithBuffers||typeof R[N]>"u")return!0;return!1}static serializeRequestArguments(R,N){if(this._useMixedArgSerialization(R)){const V=[];for(let x=0,L=R.length;x<L;x++){const U=R[x];if(U instanceof t.VSBuffer)V[x]={type:2,value:U};else if(typeof U>"u")V[x]={type:4};else if(U instanceof A.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=g(U.value,N);V[x]={type:3,value:t.VSBuffer.fromString(F),buffers:B}}else V[x]={type:1,value:t.VSBuffer.fromString(b(U,N))}}return{type:1,args:V}}return{type:0,args:b(R,N)}}static serializeRequest(R,N,V,x,L){switch(x.type){case 0:return this._requestJSONArgs(R,N,V,x.args,L);case 1:return this._requestMixedArgs(R,N,V,x.args,L)}}static _requestJSONArgs(R,N,V,x,L){const U=t.VSBuffer.fromString(V),F=t.VSBuffer.fromString(x);let B=0;B+=a.sizeUInt8(),B+=a.sizeShortString(U),B+=a.sizeLongString(F);const M=a.alloc(L?2:1,R,B);return M.writeUInt8(N),M.writeShortString(U),M.writeLongString(F),M.buffer}static deserializeRequestJSONArgs(R){const N=R.readUInt8(),V=R.readShortString(),x=R.readLongString();return{rpcId:N,method:V,args:JSON.parse(x)}}static _requestMixedArgs(R,N,V,x,L){const U=t.VSBuffer.fromString(V);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(U),F+=a.sizeMixedArray(x);const B=a.alloc(L?4:3,R,F);return B.writeUInt8(N),B.writeShortString(U),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(R){const N=R.readUInt8(),V=R.readShortString(),x=R.readMixedArray(),L=new Array(x.length);for(let U=0,F=x.length;U<F;U++){const B=x[U];typeof B=="string"?L[U]=JSON.parse(B):L[U]=B}return{rpcId:N,method:V,args:L}}static serializeAcknowledged(R){return a.alloc(5,R,0).buffer}static serializeCancel(R){return a.alloc(6,R,0).buffer}static serializeReplyOK(R,N,V){if(typeof N>"u")return this._serializeReplyOKEmpty(R);if(N instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,N);if(N instanceof A.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:L}=g(N.value,V,!0);return this._serializeReplyOKJSONWithBuffers(R,x,L)}else return this._serializeReplyOKJSON(R,E(N,V))}static _serializeReplyOKEmpty(R){return a.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,N){let V=0;V+=a.sizeVSBuffer(N);const x=a.alloc(8,R,V);return x.writeVSBuffer(N),x.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,N){const V=t.VSBuffer.fromString(N);let x=0;x+=a.sizeLongString(V);const L=a.alloc(9,R,x);return L.writeLongString(V),L.buffer}static _serializeReplyOKJSONWithBuffers(R,N,V){const x=t.VSBuffer.fromString(N);let L=0;L+=a.sizeUInt32,L+=a.sizeLongString(x);for(const F of V)L+=a.sizeVSBuffer(F);const U=a.alloc(10,R,L);U.writeUInt32(V.length),U.writeLongString(x);for(const F of V)U.writeBuffer(F);return U.buffer}static deserializeReplyOKJSON(R){const N=R.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(R,N){const V=R.readUInt32(),x=R.readLongString(),L=[];for(let U=0;U<V;++U)L.push(R.readVSBuffer());return new A.SerializableObjectWithBuffers(f(x,L,N))}static serializeReplyErr(R,N){const V=N?E(P.transformErrorForSerialization(N),null):void 0;if(typeof V!="string")return this._serializeReplyErrEmpty(R);const x=t.VSBuffer.fromString(V);let L=0;L+=a.sizeLongString(x);const U=a.alloc(11,R,L);return U.writeLongString(x),U.buffer}static deserializeReplyErrError(R){const N=R.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(R){return a.alloc(12,R,0).buffer}}var i;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var p;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(p||(p={}))}),define(_e[281],ye([1,0,4,43,53,3,38,10,18]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(h=>w.push(h)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new A);function T(_,w,h,g,f){return(0,S.createCancelablePromise)(async b=>{await(0,y.whenProviderRegistered)(h,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(h,1,g,f,b),m.registerChannel({id:_,label:w,file:h,log:!0})}catch(d){(0,k.isCancellationError)(d)||f.error("Error while registering log channel",h.toString(),(0,k.getErrorMessage)(d))}})}e.registerLogChannel=T;async function E(_,w,h,g,f){if(!await h.exists(_)){if(f.isCancellationRequested)throw new k.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",_.toString()),await(0,S.timeout)(1e3,f),await E(_,w+1,h,g,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(_e[140],ye([1,0,5,3,16,26,13,281,69,25,46,154,23,11,38,4,6]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends y.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,r,o,l,s){super(),this.id=v,this.name=r,this.logger=o,this.proxy=l,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this._register(o.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.logger.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,v)}replace(v){const r=this.offset;this.info(v),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,r),this.visible&&this.logger.flush()}show(v,r){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:r))}hide(){this.proxy.$close(this.id)}log(v,r){this.offset+=E.VSBuffer.fromString(r).byteLength,(0,y.log)(this.logger,v,r),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class b extends f{appendLine(v){this.append(v)}}let m=class{constructor(v,r,o,l,s,a){this.initData=r,this.extHostFileSystem=o,this.extHostFileSystemInfo=l,this.loggerService=s,this.logService=a,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(r.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[r,o]of this.channels)o.visible=r===this.visibleChannelId}createOutputChannel(v,r,o){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const l=typeof r=="object"&&r.log,s=(0,_.isString)(r)?r:void 0;if((0,_.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const u=this.initData.environment.extensionLogLevel?.find(([i])=>P.ExtensionIdentifier.equals(o.identifier,i))?.[1];u&&(a=(0,y.parseLogLevel)(u));const n=l?this.doCreateLogOutputChannel(v,a,o):this.doCreateOutputChannel(v,s,o);return n.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(v,a??this.logService.getLevel(),n):this.createExtHostOutputChannel(v,n)}async doCreateOutputChannel(v,r,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(v,s,!1,r,o.identifier.value);return new f(u,v,a,this.proxy,o)}async doCreateLogOutputChannel(v,r,o){const l=await this.createExtensionLogDirectory(o),s=this.extHostFileSystemInfo.extUri.joinPath(l,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(s,{name:v},r),u=await this.proxy.$register(v,s,!0,void 0,o.identifier.value);return new b(u,v,a,this.proxy,o)}createExtensionLogDirectory(v){let r=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!r){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,r=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(l){if((0,w.toFileSystemProviderErrorCode)(l)!==w.FileSystemProviderErrorCode.FileExists)throw l}return o})())}return r}createExtHostOutputChannel(v,r){let o=!1;const l=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return v},append(s){l(),r.then(a=>a.append(s))},appendLine(s){l(),r.then(a=>a.appendLine(s))},clear(){l(),r.then(s=>s.clear())},replace(s){l(),r.then(a=>a.replace(s))},show(s,a){l(),r.then(u=>u.show(s,a))},hide(){l(),r.then(s=>s.hide())},dispose(){o=!0,r.then(s=>s.dispose())}}}createExtHostLogOutputChannel(v,r,o){const l=new g.DisposableStore,s=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},a=l.add(new h.Emitter);return o.then(u=>{l.add(u),l.add(u.onDidChangeLogLevel(n=>{r=n,a.fire(n)}))}),{...this.createExtHostOutputChannel(v,o),get logLevel(){return r},onDidChangeLogLevel:a.event,trace(u,...n){s(),o.then(i=>i.trace(u,...n))},debug(u,...n){s(),o.then(i=>i.debug(u,...n))},info(u,...n){s(),o.then(i=>i.info(u,...n))},warn(u,...n){s(),o.then(i=>i.warn(u,...n))},error(u,...n){s(),o.then(i=>i.error(u,...n))},dispose(){l.dispose()}}}};m=je([He(0,I.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,A.IExtHostFileSystemInfo),He(4,y.ILoggerService),He(5,y.ILogService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(_e[282],ye([1,0,3]),function(Z,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(_e[283],ye([1,0,32,14,9,12,22,2,3,209,45,226,282]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let _=class ti{constructor(h,g,f,b){this.localUserHome=h,this.remoteAgentService=g,this.environmentService=f,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome??h})()}hasValidBasename(h,g,f){return typeof g=="string"||typeof g>"u"?this.resolveOS.then(b=>this.doHasValidBasename(h,b,g)):this.doHasValidBasename(h,g,f)}doHasValidBasename(h,g,f){return h.scheme===t.Schemas.file||h.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(f??(0,y.basename)(h),g===1):!0}get defaultUriScheme(){return ti.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,g){if(h.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,C.getVirtualWorkspaceScheme)(g.getWorkspace());if(f)return f;const b=g.getWorkspace().folders[0];if(b)return b.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?I.win32:I.posix)}async fileURI(h){let g="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const b=h.indexOf("/",2);b===-1?(g=h.substring(2),h="/"):(g=h.substring(2,b),h=h.substring(b)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:g,path:h,query:"",fragment:""})}};_=je([He(1,E.IRemoteAgentService),He(2,T.IWorkbenchEnvironmentService),He(3,A.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(_e[72],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new c(0,0)}with(y){return new c(0,0)}}e.Position=c;class t{constructor(y,k,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(y,k),this.end=new c(S,C)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var I;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(_e[31],ye([1,0,17,37,24,32,8,3,9,10,72,18]),function(Z,e,c,t,I,P,y,k,S,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",_=" characters skipped \u27EB",w=(E.length+_.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var h;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function f(K){return!!K.preview}e.resultIsMatch=f;function b(K){return!!K.resource}e.isFileMatch=b;function m(K){return!!K.message}e.isProgressMessage=m;var d;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=v;class r{constructor(ue,re,de){this.ranges=re;const Y=Array.isArray(re)?re:[re];if(de&&de.matchLines===1&&o(Y)){ue=(0,y.getNLines)(ue,de.matchLines);let pe="",be=0,Ce=0;const Re=Math.floor(de.charsPerLine/5),We=[];for(const ne of Y){const ce=Math.max(ne.startColumn-Re,0),fe=ne.startColumn+de.charsPerLine;if(ce>Ce+Re+w){const J=E+(ce-Ce)+_;pe+=J+ue.slice(ce,fe),be+=ce-(Ce+J.length)}else pe+=ue.slice(Ce,fe);We.push(new s(0,ne.startColumn-be,ne.endColumn-be)),Ce=fe}this.preview={text:pe,matches:Array.isArray(this.ranges)?We:We[0]}}else{const pe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ue,matches:(0,c.mapArrayOrNot)(re,be=>new l(be.startLineNumber-pe,be.startColumn,be.endLineNumber-pe,be.endColumn))}}}}e.TextSearchMatch=r;function o(K){const ue=K[0].startLineNumber;for(const re of K)if(re.startLineNumber!==ue||re.endLineNumber!==ue)return!1;return!0}class l{constructor(ue,re,de,Y){this.startLineNumber=ue,this.startColumn=re,this.endLineNumber=de,this.endColumn=Y}}e.SearchRange=l;class s extends l{constructor(ue,re,de){super(ue,re,ue,de)}}e.OneLineRange=s;var a;(function(K){K.List="list",K.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var u;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,ue=!0){const re=K&&K.files&&K.files.exclude,de=ue&&K&&K.search&&K.search.exclude;if(!re&&!de)return;if(!re||!de)return re||de;let Y=Object.create(null);return Y=I.mixin(Y,I.deepClone(re)),Y=I.mixin(Y,I.deepClone(de),!0),Y}e.getExcludes=n;function i(K,ue){return K.excludePattern&&t.match(K.excludePattern,ue)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,ue)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(re=>{const de=re.folder.fsPath;if(P.isEqualOrParent(ue,de)){const Y=S.relative(de,ue);return!re.includePattern||!!t.match(re.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var p;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(ue,re){super(ue),this.code=re}}e.SearchError=D;function R(K){const ue=K.message;if((0,C.isCancellationError)(K))return new D(ue,p.canceled);try{const re=JSON.parse(ue);return new D(re.message,re.code)}catch{return new D(ue,p.other)}}e.deserializeSearchError=R;function N(K){const ue={message:K.message,code:K.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=N;function V(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=V;function x(K){return K.type==="success"}e.isSerializedSearchSuccess=x;function L(K){return!!K.path}e.isSerializedFileMatch=L;function U(K,ue){const re=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(re,ue)}e.isFilePatternMatch=U;class F{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(K,ue){const re={...K||{},...ue||{}};return Object.keys(re).filter(de=>{const Y=re[de];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=B;class M{constructor(ue,re){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...re.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let de=ue.includePattern;re.includePattern&&(de?de={...de,...re.includePattern}:de=re.includePattern),de&&(this._parsedIncludeExpression=t.parse(de))}matchesExcludesSync(ue,re,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,re,de))}includedInQuerySync(ue,re,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,re,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,re,de))}includedInQuery(ue,re,de){const Y=this._parsedExcludeExpression(ue,re,de),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,re,de):!0;return(0,T.isThenable)(Y)?Y.then(be=>be?!1:pe()):pe()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=M;function z(K){for(const ue in K)if(typeof K[ue]!="boolean")return!0;return!1}function j(K){if(!K)return;let ue;return re=>(ue||(ue=(K()||Promise.resolve([])).then(de=>de?Q(de):{})),ue.then(de=>!!de[re]))}e.hasSiblingPromiseFn=j;function $(K){if(!K)return;let ue;return re=>{if(!ue){const de=K();ue=de?Q(de):{}}return!!ue[re]}}e.hasSiblingFn=$;function Q(K){const ue={};for(const re of K)ue[re]=!0;return ue}}),define(_e[33],ye([1,0,17,18,21,4,6,64,14,100,22,8,11,2,178,3,13,197,45,46,25,16,15,7,55,31,5]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v,r,o,l,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(x,L,U){return new A.ExtUri(F=>D(F,U)).isEqual(x,L)}function n(x,L,U){return u(x.uri,L.uri,U)?0:(0,T.compare)(x.uri.toString(),L.uri.toString())}function i(x,L,U){return x.index!==L.index?x.index<L.index?-1:1:u(x.uri,L.uri,U)?(0,T.compare)(x.name,L.name):(0,T.compare)(x.uri.toString(),L.uri.toString())}function p(x,L,U,F){const B=x.slice(0).sort((z,j)=>U(z,j,F)),M=L.slice(0).sort((z,j)=>U(z,j,F));return(0,c.delta)(B,M,(z,j)=>U(z,j,F))}function D(x,L){const U=L.getCapabilities(x.scheme);return!(U&&U&1024)}class R extends b.Workspace{static toExtHostWorkspace(L,U,F,B){if(!L)return{workspace:null,added:[],removed:[]};const{id:M,name:z,folders:j,configuration:$,transient:Q,isUntitled:K}=L,ue=[],re=U;U?j.forEach((be,Ce)=>{const Re=_.URI.revive(be.uri),We=R._findFolder(F||U,Re,B);We?(We.name=be.name,We.index=be.index,ue.push(We)):ue.push({uri:Re,name:be.name,index:Ce})}):ue.push(...j.map(({uri:be,name:Ce,index:Re})=>({uri:_.URI.revive(be),name:Ce,index:Re}))),ue.sort((be,Ce)=>be.index<Ce.index?-1:1);const de=new R(M,z,ue,!!Q,$?_.URI.revive($):null,!!K,be=>D(be,B)),{added:Y,removed:pe}=p(re?re.workspaceFolders:[],de.workspaceFolders,n,B);return{workspace:de,added:Y,removed:pe}}static _findFolder(L,U,F){for(let B=0;B<L.folders.length;B++){const M=L.workspaceFolders[B];if(u(M.uri,U,F))return M}}constructor(L,U,F,B,M,z,j){super(L,F.map($=>new b.WorkspaceFolder($)),B,M,j),this._name=U,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(j),F.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let N=class{constructor(L,U,F,B,M){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=B,this._extHostFileSystemInfo=F,this._uriTransformerService=M,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(a.MainContext.MainThreadMessageService);const z=U.workspace;this._confirmedWorkspace=z?new R(z.id,z.name,[],!!z.transient,z.configuration?_.URI.revive(z.configuration):null,!!z.isUntitled,j=>D(j,F)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:S.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,F,...B){const M=[];if(Array.isArray(B)&&B.forEach(K=>{_.URI.isUri(K.uri)&&!M.some(ue=>u(ue.uri,K.uri,this._extHostFileSystemInfo))&&M.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[U,F].some(K=>typeof K!="number"||K<0)||F===0&&M.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+F>z.length)return!1;const j=z.slice(0);j.splice(U,F,...M.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<j.length;K++){const ue=j[K];if(j.some((re,de)=>de!==K&&u(ue.uri,re.uri,this._extHostFileSystemInfo)))return!1}j.forEach((K,ue)=>K.index=ue);const{added:$,removed:Q}=p(z,j,i,this._extHostFileSystemInfo);if($.length===0&&Q.length===0)return!1;if(this._proxy){const K=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(K,U,F,M).then(void 0,ue=>{this._unconfirmedWorkspace=void 0;const re={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(f.Severity.Error,(0,w.localize)(0,null,K,ue.toString()),re,[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(L,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let F,B="";if(typeof L=="string"?(F=_.URI.file(L),B=L):typeof L<"u"&&(F=L,B=L.fsPath),!F)return B;const M=this.getWorkspaceFolder(F,!0);if(!M)return B;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let z=(0,A.relativePath)(M.uri,F);return U&&M.name&&(z=`${M.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:F,removed:B}=R.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:B}))}findFiles(L,U,F,B,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let z;if(U===null?z=!1:U&&(typeof U=="string"?z=U:z=U.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:$}=V(r.GlobPattern.from(L));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(j),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(z),(0,E.withUndefinedAsNull)(F),M).then(Q=>Array.isArray(Q)?Q.map(K=>_.URI.revive(K)):[])}async findTextInFiles(L,U,F,B,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),j=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:$,folder:Q}=V(r.GlobPattern.from(U.include)),K=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ue={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:j,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:$,excludePattern:K},re=!1;if(this._activeSearchCallbacks[z]=de=>{if(re)return;const Y=_.URI.revive(de.resource);de.results.forEach(pe=>{(0,s.resultIsMatch)(pe)?F({uri:Y,preview:{text:pe.preview.text,matches:(0,c.mapArrayOrNot)(pe.preview.matches,be=>new o.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(pe.ranges,be=>new o.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):F({uri:Y,text:pe.text,lineNumber:pe.lineNumber})})},M.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(L,(0,E.withUndefinedAsNull)(Q),ue,z,M);return delete this._activeSearchCallbacks[z],de||{}}catch(de){throw delete this._activeSearchCallbacks[z],de}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,U){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,U);const F=this._uriTransformerService.transformOutgoingScheme(L),B=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(B,F),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(L,U){this._logService.info("Getting edit session identifier for workspaceFolder",L);const F=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const M=await B.provideEditSessionIdentity(F,U);if(this._logService.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(L,U,F,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const M=await this.resolveWorkspaceFolder(_.URI.revive(L));if(!M){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const z=this._editSessionIdentityProviders.get(M.uri.scheme);if(this._logService.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!z),!z)return;const j=await z.provideEditSessionIdentityMatch?.(U,F,B);if(this._logService.info("Provider returned edit session identifier match result: ",j),!!j)return j}};N=je([He(0,v.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,m.IExtHostFileSystemInfo),He(3,g.ILogService),He(4,l.IURITransformerService)],N),e.ExtHostWorkspace=N,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function V(x){let L,U;return x&&(typeof x=="string"?L=x:(L=x.pattern,U=_.URI.revive(x.baseUri))),{includePattern:L,folder:U}}}),define(_e[34],ye([1,0,24,4,33,5,7,200,126,11,18,3,16,13,2]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(o,l){if(l){const s=l.split(".");let a=o;for(let u=0;a&&u<s.length;u++)a=a[s[u]];return a}}function g(o){return o instanceof w.URI}function f(o){return o&&o.uri instanceof w.URI&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function m(o){return o&&o.uri instanceof w.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function d(o){if(g(o))return{resource:o};if(f(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(b(o))return{overrideIdentifier:o.languageId};if(m(o))return{resource:o.uri};if(o===null)return{resource:null}}let v=class{constructor(l,s,a){this._proxy=l.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=a,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new r(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,s){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(l,s))}};v=je([He(0,E.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,_.ILogService)],v),e.ExtHostConfiguration=v;class r{constructor(l,s,a,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=l,this._logService=u,this._extHostWorkspace=s,this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,s){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,a))}getConfiguration(l,s,a){const u=d(s)||{},n=this._toReadonlyValue(l?h(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,u,a?.identifier);function i(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(D){return typeof h(n,D)<"u"},get:(D,R)=>{this._validateConfigurationAccess(l?`${l}.${D}`:D,u,a?.identifier);let N=h(n,D);if(typeof N>"u")N=R;else{let V;const x=(L,U)=>{let F;const B=()=>{V=V||(0,c.deepClone)(n),F=F||h(V,U)};return(0,C.isObject)(L)?new Proxy(L,{get:(M,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>F;if(V)return F=F||h(V,U),F[z];const j=M[z];return typeof z=="string"?x(j,`${U}.${z}`):j},set:(M,z,j)=>(B(),F&&(F[z]=j),!0),deleteProperty:(M,z)=>(B(),F&&delete F[z],!0),defineProperty:(M,z,j)=>(B(),F&&Object.defineProperty(F,z,j),!0)}):L};N=x(N,D)}return N},update:(D,R,N,V)=>{D=l?`${l}.${D}`:D;const x=i(N);return R!==void 0?this._proxy.$updateConfigurationOption(x,D,R,u,V):this._proxy.$removeConfigurationOption(x,D,u,V)},inspect:D=>{D=l?`${l}.${D}`:D;const R=this._configuration.inspect(D,u,this._extHostWorkspace.workspace);if(R)return{key:D,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(p,n,!1),Object.freeze(p)}_toReadonlyValue(l){const s=a=>(0,C.isObject)(a)?new Proxy(a,{get:(u,n)=>s(u[n]),set:(u,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return s(l)}_validateConfigurationAccess(l,s,a){const u=S.OVERRIDE_PROPERTY_REGEX.test(l)?4:this._configurationScopes.get(l),n=a?`[${a.value}] `:"";if(u===4){typeof s?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){s?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,s){const a=new k.ConfigurationChangeEvent(l,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,n)=>a.affectsConfiguration(u,d(n))})}_toMap(l){return l.reduce((s,a)=>(s.set(a[0],a[1]),s),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[73],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,14,12,13,68,239,10]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(L){function U(B){if(B!=null)return B}L.from=U;function F(B){if(B!=null)return B}L.to=F})(r||(r={}));var o;(function(L){function U(B){if(B!=null)return B}L.from=U;function F(B){if(B!=null)return B}L.to=F})(o||(o={}));var l;(function(L){function U(B){if(B!=null)return B}L.from=U;function F(B){if(B!=null)return B}L.to=F})(l||(l={}));var s;(function(L){function U(M){if(M){const z=M;return z&&!!z.process}else return!1}L.is=U;function F(M){if(M==null)return;const z={process:M.process,args:M.args};return M.options&&(z.options=l.from(M.options)),z}L.from=F;function B(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}L.to=B})(s||(s={}));var a;(function(L){function U(B){if(B!=null)return B}L.from=U;function F(B){if(B!=null)return B}L.to=F})(a||(a={}));var u;(function(L){function U(M){if(M){const z=M;return z&&(!!z.commandLine||!!z.command)}else return!1}L.is=U;function F(M){if(M==null)return;const z={};return M.commandLine!==void 0?z.commandLine=M.commandLine:(z.command=M.command,z.args=M.args),M.options&&(z.options=a.from(M.options)),z}L.from=F;function B(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}L.to=B})(u||(u={}));var n;(function(L){function U(M){if(M){const z=M;return z&&z.customExecution==="customExecution"}else return!1}L.is=U;function F(M){return{customExecution:"customExecution"}}L.from=F;function B(M,z){return z.get(M)}L.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(L){function U(F,B){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===y.TaskScope.Workspace&&B&&B.workspaceFile?M=B.workspaceFile:M=m.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}L.from=U})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(L){function U(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}L.from=U})(p||(p={}));var D;(function(L){function U(M,z){if(M==null)return[];const j=[];for(const $ of M){const Q=F($,z);Q&&j.push(Q)}return j}L.fromMany=U;function F(M,z){if(M==null)return;let j;M.execution instanceof y.ProcessExecution?j=s.from(M.execution):M.execution instanceof y.ShellExecution?j=u.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(j=n.from(M.execution));const $=r.from(M.definition);let Q;return M.scope?typeof M.scope=="number"?Q=M.scope:Q=M.scope.uri:Q=y.TaskScope.Workspace,!$||!Q?void 0:{_id:M._id,definition:$,name:M.name,source:{extensionId:z.identifier.value,label:M.source,scope:Q},execution:j,isBackground:M.isBackground,group:p.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}L.from=F;async function B(M,z,j){if(M==null)return;let $;s.is(M.execution)?$=s.to(M.execution):u.is(M.execution)?$=u.to(M.execution):n.is(M.execution)&&($=n.to(M._id,j));const Q=r.to(M.definition);let K;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?K=M.source.scope:K=await z.resolveWorkspaceFolder(c.URI.revive(M.source.scope)):K=y.TaskScope.Workspace),!Q||!K)return;const ue=new y.Task(Q,K,M.name,M.source.label,$,M.problemMatchers);return M.isBackground!==void 0&&(ue.isBackground=M.isBackground),M.group!==void 0&&(ue.group=y.TaskGroup.from(M.group._id),ue.group&&M.group.isDefault&&(ue.group=new y.TaskGroup(ue.group.id,ue.group.label),M.group.isDefault===!0&&(ue.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ue.presentationOptions=o.to(M.presentationOptions)),M._id&&(ue._id=M._id),M.detail&&(ue.detail=M.detail),ue}L.to=B})(D=e.TaskDTO||(e.TaskDTO={}));var R;(function(L){function U(B){return B}L.from=U;function F(B){if(!!B)return Object.assign(Object.create(null),B)}L.to=F})(R||(R={}));class N{constructor(U,F,B){this._id=F,this._task=B,v.set(this,void 0),tt(this,v,U,"f")}get task(){return this._task}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}v=new WeakMap;let V=class{constructor(U,F,B,M,z,j,$,Q){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=U.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=M,this._configurationService=z,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,F,B){if(!B)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:B,extension:U}),this._proxy.$registerTaskProvider(M,F),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(U,F){this._proxy.$registerTaskSystem(U,F)}fetchTasks(U){return this._proxy.$fetchTasks(R.from(U)).then(async F=>{const B=[];for(const M of F){const z=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);z&&B.push(z)}return B})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(F=>U.push(F)),U}terminateTask(U){if(!(U instanceof N))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,F,B){const M=this._providedCustomExecutions2.get(U.id);M&&(this._activeCustomExecutions2.set(U.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(B))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const F=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const F=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:F,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const F=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:U.exitCode})}$provideTasks(U,F){const B=this._handlers.get(U);if(!B)return Promise.reject(new Error("no handler found"));const M=[],z=(0,t.asPromise)(()=>B.provider.provideTasks(A.CancellationToken.None)).then(j=>this.provideTasksInternal(F,M,B,j));return new Promise(j=>{z.then($=>{Promise.all(M).then(()=>{j($)})})})}async $resolveTask(U,F){const B=this._handlers.get(U);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const M=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(M,A.CancellationToken.None);if(!z)return;this.checkDeprecation(z,B);const j=D.from(z,B.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(j.execution)&&await this.addCustomExecution(j,z,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,F,B){const M=await this._proxy.$createTaskId(U);!B&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,F.execution)),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(U,F){if(typeof U=="string"){const z=this._taskExecutionPromises.get(U);if(!z)throw new d.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const B=this._taskExecutionPromises.get(U.id);if(B)return B;const M=new Promise((z,j)=>{function $(Q,K,ue){ue?z(new N(Q,K.id,ue)):j("Unexpected: Task does not exist.")}F?$(this,U,F):D.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(Q=>$(this,U,Q))});return this._taskExecutionPromises.set(U.id,M),M.then(z=>(this._taskExecutions.set(U.id,z),z),z=>Promise.reject(z))}checkDeprecation(U,F){U._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const B=this._notProvidedCustomExecutions.values();let M=B.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=B.next()}};V=je([He(0,E.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,f.ILogService),He(7,b.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let x=class extends V{constructor(U,F,B,M,z,j,$,Q){super(U,F,B,M,z,j,$,Q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(U,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=D.from(F,U);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.addCustomExecution(B,F,!1);else throw new d.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),F);return this._proxy.$executeTask(B).catch(z=>{throw new Error(z)}),M}provideTasksInternal(U,F,B,M){const z=[];if(M)for(const j of M){this.checkDeprecation(j,B),(!j.definition||!U[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const $=D.from(j,B.extension);$&&n.is($.execution)?(z.push($),F.push(this.addCustomExecution($,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async resolveTaskInternal(U){if(n.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,F,B){}};x=je([He(0,E.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,T.IExtHostTerminalService),He(6,f.ILogService),He(7,b.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(_e[284],ye([1,0,9,21,50,37,22,51,31]),function(Z,e,c,t,I,P,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(E,_,w){this.config=E,this.provider=_,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const _=this.config.folderQueries||[];return new Promise((w,h)=>{const g=f=>{this.resultCount++,E(f)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const b=f.toString(),m=c.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,m)||this.matchFile(g,{base:f,basename:m})}),Promise.all(_.map(f=>this.searchInFolder(f,g))).then(f=>{w({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{h(new Error((0,I.toErrorMessage)(f)))})})}async searchInFolder(E,_){const w=new t.CancellationTokenSource,h=this.getSearchOptionsForFolder(E),g=this.initDirectoryTree(),f=new S.QueryGlobTester(this.config,E),b=!f.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(w),m=k.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,w.token),v=m.elapsed(),r=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(o=>{const l=c.posix.relative(E.folder.path,o.path);if(b){const s=c.basename(o.path);this.matchFile(_,{base:E.folder,relativePath:l,basename:s});return}this.addDirectoryEntries(g,E.folder,l,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,f,_),{providerTime:v,postProcessTime:r.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(E){const _=(0,S.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:w,includes:_,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},_,w,h){if(w===this.filePattern){const f=c.basename(this.filePattern);this.matchFile(h,{base:_,relativePath:this.filePattern,basename:f})}function g(f){const b=c.basename(f),m=c.dirname(f);let d=E[m];d||(d=E[m]=[],g(m)),d.push({base:_,relativePath:f,basename:b})}g(w)}matchDirectoryTree({rootEntries:E,pathToEntries:_},w,h){const g=this,f=this.filePattern;function b(m){const d=(0,S.hasSiblingFn)(()=>m.map(v=>v.basename));for(let v=0,r=m.length;v<r;v++){const o=m[v],{relativePath:l,basename:s}=o;if(w.matchesExcludesSync(l,s,f!==s?d:void 0))continue;const a=_[l];if(a)b(a);else{if(l===f)continue;g.matchFile(h,o)}if(g.isLimitHit)break}}b(E)}matchFile(E,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(_))}}class A{constructor(){this.sessions=new Map}fileSearch(E,_,w,h){const g=this.getSessionTokenSource(E.cacheKey),f=new C(E,_,g&&g.token);let b=0;const m=d=>{b+=d.length,w(d.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(f,A.BATCH_SIZE,m,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:d.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:y.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,_,w,h){h.onCancellationRequested(()=>{E.cancel()});const g=b=>{b&&(f.push(b),_>0&&f.length>=_&&(w(f),f=[]))};let f=[];return E.search(g).then(b=>(f.length&&w(f),b),b=>(f.length&&w(f),Promise.reject(b)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(_e[285],ye([1,0,17,78,37,111,28,14,9,22,8,11,2,162,189,52,13,45,132,283,31]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(p,D,R,N,V){this.configurationService=p,this.workspaceContextService=D,this.editorGroupsService=R,this.logService=N,this.pathService=V}text(p,D,R={}){p=this.getContentPattern(p,R);const N=this.configurationService.getValue(),V=D&&D.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(D?.map(f.toWorkspaceFolder),R),type:2,contentPattern:p,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:N.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(p,D){const R=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const N={...p,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(p,D)&&(N.isCaseSensitive=!0),this.isMultiline(p)&&(N.isMultiline=!0),N}file(p,D={}){return{...this.commonQuery(p,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}handleIncludeExclude(p,D){return p?(p=Array.isArray(p)?p.map(a):a(p),D?this.parseSearchPaths(p):{pattern:o(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],D={}){const R=this.handleIncludeExclude(D.includePattern,D.expandPatterns),N=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),V=p.length>1,x=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,D,N)):p.map(F=>this.getFolderQueryForRoot(F,D,N,V))).filter(F=>!!F),L={_reason:D._reason,folderQueries:x,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:N.pattern,includePattern:R.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const F=c.coalesce(c.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(j=>j.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(z=>(0,d.pathIncludedInQuery)(L,z.fsPath)),M=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(M)),{...L,...M}}const U=D.extraFileResources&&D.extraFileResources.filter(F=>(0,d.pathIncludedInQuery)(L,F.fsPath));return L.extraFileResources=U&&U.length?U:void 0,L}commonQueryFromFileList(p){const D=[],R=new y.ResourceMap,N={};let V=!1;return p.forEach(x=>{if(x.scheme===k.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(x)){const U=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let F=R.get(U);F||(V=!0,F={folder:U,includePattern:{}},D.push(F),R.set(U,F));const B=S.relative(U.fsPath,x.fsPath);(0,T.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else x.fsPath&&(V=!0,N[x.fsPath]=!0)}),{folderQueries:D,includePattern:N,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}isCaseSensitive(p,D){if(D.isSmartCase){if(p.isRegExp){if(A.containsUppercaseCharacter(p.pattern,!0))return!0}else if(A.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,_.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const D=M=>S.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),N=(Array.isArray(p)?p:l(p)).map(M=>{const z=this.pathService.resolvedUserHome;return z?(0,P.untildify)(M,z.scheme===k.Schemas.file?z.fsPath:z.path):M}),V=t.groupBy(N,M=>D(M)?"searchPaths":"exprSegments"),x=(V.exprSegments||[]).map(M=>A.rtrim(M,"/")).map(M=>A.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),s(M))),L={},U=this.expandSearchPathPatterns(V.searchPaths||[]);U&&U.length&&(L.searchPaths=U);const F=c.flatten(x),B=o(...F);return B&&(L.pattern=B),L}getExcludesForFolder(p,D){return D.disregardExcludeSettings?void 0:(0,d.getExcludes)(p,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const D=c.flatten(p.map(N=>{let{pathPortion:V,globPortion:x}=r(N);x&&(x=u(x));const L=this.expandOneSearchPath(V);return c.flatten(L.map(U=>this.resolveOneSearchPathPattern(U,x)))})),R=new Map;return D.forEach(N=>{const V=N.searchPath.toString(),x=R.get(V);x?N.pattern&&(x.pattern=x.pattern||{},x.pattern[N.pattern]=!0):R.set(V,{searchPath:N.searchPath,pattern:N.pattern?o(N.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(p){if(S.isAbsolute(p)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==k.Schemas.file?[{searchPath:D[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const N=S.posix.resolve(D.path,p);return[{searchPath:D.with({path:N})}]}const R=u(p);return[{searchPath:D,pattern:R}]}else{if(p==="./"||p===".\\")return[];{const D=p.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(V=>{const x=D.match(new RegExp(`^${A.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return x?{match:x,folder:V}:null}).filter(T.isDefined);if(N.length)return N.map(V=>{const x=V.match[1];return{searchPath:V.folder.uri,pattern:x&&u(x)}});{const V=p.match(/\.[\/\\](.+)[\/\\]?/),x=V?V[1]:p,L=w.localize(0,null,x);throw new Error(L)}}}}resolveOneSearchPathPattern(p,D){const R=p.pattern&&D?`${p.pattern}/${D}`:p.pattern||D,N=[{searchPath:p.searchPath,pattern:R}];return R&&!R.endsWith("**")&&N.push({searchPath:p.searchPath,pattern:R+"/**"}),N}getFolderQueryForSearchPath(p,D,R){const N=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(p.searchPath),D,R,!1);return N?{...N,includePattern:p.pattern}:null}getFolderQueryForRoot(p,D,R,N){let V;const x=E.URI.isUri(p)?p:p.uri;if(R.searchPaths){const M=R.searchPaths.filter(z=>(0,C.isEqual)(z.searchPath,x))[0];if(M&&!M.pattern)return null;M&&(V=M.pattern)}const L=this.configurationService.getValue({resource:x}),F={...this.getExcludesForFolder(L,D)||{},...V||{}},B=E.URI.isUri(p)?(0,C.basename)(p):p.name;return{folder:x,folderName:N?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!L.search.followSymlinks}}};v=je([He(0,h.IConfigurationService),He(1,f.IWorkspaceContextService),He(2,b.IEditorGroupsService),He(3,g.ILogService),He(4,m.IPathService)],v),e.QueryBuilder=v;function r(i){const p=i.match(/[\*\{\}\(\)\[\]\?]/);if(p){const D=p.index,R=i.substr(0,D).match(/[/|\\][^/\\]*$/);if(R){let N=i.substr(0,R.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:i.substr((R.index||0)+1)}}}return{pathPortion:i}}function o(...i){return i.length?i.reduce((p,D)=>(p[D]=!0,p),Object.create(null)):void 0}function l(i){return I.splitGlobAware(i,",").map(p=>p.trim()).filter(p=>!!p.length)}function s(i){return[`**/${i}/**`,`**/${i}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function a(i){return i.replace(/\\/g,"/")}function u(i){return a(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,p){i=c.distinct(i,N=>N.toString());const D=[],R=p.getWorkspace();return i&&i.forEach(N=>{let V;if(p.getWorkbenchState()===2)V=(0,C.relativePath)(R.folders[0].uri,N),V&&V!=="."&&(V="./"+V);else{const x=p.getWorkspaceFolder(N);if(x){const L=x.name;if(R.folders.filter(F=>F.name===L).length===1){const F=(0,C.relativePath)(x.uri,N);F===""?V=`./${x.name}`:V=`./${x.name}/${F}`}else V=N.fsPath}}V&&D.push(V)}),D}e.resolveResourcesForSearchIncludes=n}),define(_e[286],ye([1,0,22,2,21,10,3,285,31,45]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function T(h,g){const f=g.activationEvents;if(!f)return Promise.resolve(void 0);const b=[],m=[];for(const s of f)if(/^workspaceContains:/.test(s)){const a=s.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||h.forceUsingSearch?m.push(a):b.push(a)}if(b.length===0&&m.length===0)return Promise.resolve(void 0);let d;const v=new Promise((s,a)=>{d=s}),r=s=>d({activationEvent:s}),o=Promise.all(b.map(s=>E(h,s,r))).then(()=>{}),l=_(h,g.identifier,m,r);return Promise.all([o,l]).then(()=>{d(void 0)}),v}e.checkActivateWorkspaceContainsExtension=T;async function E(h,g,f){for(const b of h.folders)if(await h.exists(c.joinPath(t.URI.revive(b),g))){f(`workspaceContains:${g}`);return}}async function _(h,g,f,b){if(f.length===0)return Promise.resolve(void 0);const m=new I.CancellationTokenSource,d=h.checkExists(h.folders,f,m.token),v=setTimeout(async()=>{m.cancel(),h.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},A);let r=!1;try{r=await d}catch(o){P.isCancellationError(o)||P.onUnexpectedError(o)}m.dispose(),clearTimeout(v),r&&b(`workspaceContains:${f.join(",")}`)}function w(h,g,f,b){const m=h.get(y.IInstantiationService),d=h.get(S.ISearchService),r=m.createInstance(k.QueryBuilder).file(g.map(o=>(0,C.toWorkspaceFolder)(t.URI.revive(o))),{_reason:"checkExists",includePattern:f,exists:!0});return d.fileSearch(r,b).then(o=>!!o.limitHit,o=>P.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=w});var tt=this&&this.__classPrivateFieldSet||function(Z,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,c):I?I.value=c:e.set(Z,c),c},Ne=this&&this.__classPrivateFieldGet||function(Z,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(Z):t?t.value:e.get(Z)};define(_e[41],ye([1,0,173,9,74,22,18,6,64,2,13,5,34,229,97,33,27,227,10,26,23,210,7,127,3,25,70,16,86,54,40,4,286,96,212,14,95]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v,r,o,l,s,a,u,n,i,p,D,R,N,V,x,L){"use strict";var U,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let M=class An extends k.Disposable{constructor(re,de,Y,pe,be,Ce,Re,We,ne,ce,fe){super(),this._onDidChangeRemoteConnectionData=this._register(new D.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=pe,this._extHostConfiguration=be,this._logService=Ce,this._extHostTunnelService=ne,this._extHostTerminalService=ce,this._extHostLocalizationService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const J=(0,g.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry($(this._globalRegistry,J)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=re.createChild(new n.ServiceCollection([w.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));let ie=[],te=[];this._initData.remote.isRemote&&(ie=this._initData.allExtensions.filter(W=>!W.main&&!W.browser).map(W=>W.identifier),te=this._initData.allExtensions.filter(W=>!J.has(m.ExtensionIdentifier.toKey(W.identifier.value))).filter(W=>(W.main||W.browser)&&W.api==="none").map(W=>W.identifier));const O=(0,g.extensionIdentifiersArrayToSet)(te);this._activator=this._register(new _.ExtensionsActivator(this._myRegistry,ie,te,{onExtensionActivationError:(W,q,X)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(W,b.transformErrorForSerialization(q),X)},actualActivateExtension:async(W,q)=>{if(O.has(m.ExtensionIdentifier.toKey(W)))return await this._mainThreadExtensionsProxy.$activateExtension(W,q),new _.HostExtension;const X=this._myRegistry.getExtensionDescription(W);return this._activateExtension(X,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(re){b.onUnexpectedError(re)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let re=[];try{re=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(re)}terminate(re,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${re}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),b.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(re){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(re):!1}async getExtension(re){const de=await this._mainThreadExtensionsProxy.$getExtension(re);let Y;if(de?.browserNlsBundleUris){Y={};for(const pe of Object.keys(de.browserNlsBundleUris))Y[pe]=C.URI.revive(de.browserNlsBundleUris[pe])}return de&&{...de,identifier:new m.ExtensionIdentifier(de.identifier.value),extensionLocation:C.URI.revive(de.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(re,de){return this._activator.activateByEvent(re,de)}_activateById(re,de){return this._activator.activateById(re,de)}activateByIdWithErrors(re,de){return this._activateById(re,de).then(()=>{const Y=this._activator.getActivatedExtension(re);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(re=>this._myRegistry)}getExtensionExports(re){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(re).exports:null}async _realPathExtensionUri(re){if(re.scheme!==x.Schemas.file)return re;const de=await this._hostUtils.realpath(re.fsPath);return C.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(re=>new K(re))),this._extensionPathIndex}async _createExtensionPathIndex(re){const de=S.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(re.map(async Y=>{if(this._getEntryPoint(Y)){const pe=await this._realPathExtensionUri(Y.extensionLocation);de.set(pe,Y)}})),de}_deactivate(re){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(re))return de;const Y=this._activator.getActivatedExtension(re);if(!Y)return de;try{typeof Y.module.deactivate=="function"&&(de=Promise.resolve(Y.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${re.value}':`),this._logService.error(pe)}try{(0,k.dispose)(Y.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this._logService.error(pe)}return de}async _activateExtension(re,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier),this._doActivateExtension(re,de).then(Y=>{const pe=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(re.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,de),this._logExtensionActivationTimes(re,de,"success",pe),Y},Y=>{throw this._logExtensionActivationTimes(re,de,"failure"),Y})}_logExtensionActivationTimes(re,de,Y,pe){const be=z(re,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...pe||{},outcome:Y})}_doActivateExtension(re,de){const Y=z(re,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const pe=this._getEntryPoint(re);if(!pe)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${re.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const be=new _.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(re,(0,P.joinPath)(re.extensionLocation,pe),be),this._loadExtensionContext(re)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),An._callActivate(this._logService,re.identifier,Ce[0],Ce[1],be))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ce))}_loadExtensionContext(re){const de=new v.ExtensionGlobalMemento(re,this._storage),Y=new v.ExtensionMemento(re.identifier.value,!1,this._storage),pe=new V.ExtensionSecrets(re,this._secretState),be=re.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ce=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([de.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let We,ne;const ce=(0,g.isProposedApiEnabled)(re,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:Y,secrets:pe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(re.extensionLocation.fsPath,fe)},get storagePath(){return Re._storagePath.workspaceValue(re)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(re).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,re.identifier.value)},get logUri(){return C.URI.joinPath(Re._initData.logsLocation,re.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(re)},get globalStorageUri(){return Re._storagePath.globalValue(re)},get extensionMode(){return be},get extension(){return We===void 0&&(We=new j(Re,re.identifier,re,Ce,!1)),We},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(re,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!ne){if(!ce)return;const fe=D.Event.buffer(D.Event.fromDOMEventEmitter(ce,"message",J=>J.data));ce.start(),ne={onDidReceiveMessage:fe,postMessage:ce.postMessage.bind(ce)}}return ne}})})}static _callActivate(re,de,Y,pe,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(re,de,Y,pe,be).then(Ce=>new _.ActivatedExtension(!1,null,be.build(),Y,Ce,pe.subscriptions))}static _callActivateOptional(re,de,Y,pe,be){if(typeof Y.activate=="function")try{be.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${de.value}`);const Ce=typeof global=="object"?global:self,Re=Y.activate.apply(Ce,[pe]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(We=>(be.activateResolveStop(),We))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(Y)}_activateOneStartupFinished(re,de){this._activateById(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:de}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const re of this._myRegistry.getAllExtensionDescriptions())if(re.activationEvents)for(const de of re.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(re,de)}_handleEagerExtensions(){const re=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(de),pe=Promise.all([re,Y]).then(()=>{});return Promise.race([pe,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(re){return re.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(re,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(re,de){if(this.isActivated(de.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:re.map(Ce=>Ce.uri),forceUsingSearch:Y,exists:Ce=>this._hostUtils.exists(Ce.fsPath),checkExists:(Ce,Re,We)=>this._mainThreadWorkspaceProxy.$checkExists(Ce,Re,We)},be=await(0,R.checkActivateWorkspaceContainsExtension)(pe,de);if(!!be)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:be.activationEvent}).then(void 0,Ce=>this._logService.error(Ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(re){throw console.error(re),re}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:de}=this._initData.environment;if(!re||!de)throw new Error(c.localize(0,null));const Y=await this._loadCommonJSModule(null,de,new _.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(c.localize(1,null,de.toString()));return new Promise((pe,be)=>{const Ce=(ne,ce)=>{ne?be(ne):pe(typeof ce=="number"&&ce>0?1:0)},Re=(0,P.originalFSPath)(de),We=Y.run(Re,Ce);We&&We.then&&We.then(()=>{pe(0)}).catch(ne=>{be(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,de){return this._resolvers[re]=de,(0,k.toDisposable)(()=>{delete this._resolvers[re]})}async _activateAndGetResolver(re){const de=re.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const Y=re.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(re,de){this._logService.info(`$resolveAuthority invoked for authority (${Q(re)})`);const{authorityPrefix:Y,resolver:pe}=await this._activateAndGetResolver(re);if(!pe)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),I.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await pe.resolve(re,{resolveAttempt:de});I.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Ce={authority:re,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ce,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(I.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(re,de){this._logService.info(`$getCanonicalURI invoked for authority (${Q(re)})`);const{resolver:Y}=await this._activateAndGetResolver(re);if(!Y)return null;const pe=C.URI.revive(de);if(typeof Y.getCanonicalURI>"u")return pe;const be=await(0,y.asPromise)(()=>Y.getCanonicalURI(pe));return be||pe}static _applyExtensionsDelta(re,de,Y){const pe=new f.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());pe.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,g.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(m.ExtensionIdentifier.toKey(Re));const Ce=$(pe,be);return{globalRegistry:pe,myExtensions:Ce}}$startExtensionHost(re){re.toAdd.forEach(pe=>pe.extensionLocation=C.URI.revive(pe.extensionLocation));const{globalRegistry:de,myExtensions:Y}=An._applyExtensionsDelta(this._globalRegistry,this._myRegistry,re);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(re,de){return de===1?this._activateByEvent(re,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(re,!1))}async $activate(re,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(re)?(await this._activateById(re,de),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ce=>Ce.extensionLocation=C.URI.revive(Ce.extensionLocation));const{globalRegistry:de,myExtensions:Y}=An._applyExtensionsDelta(this._globalRegistry,this._myRegistry,re),pe=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const de=d.VSBuffer.alloc(re),Y=Math.random()%256;for(let pe=0;pe<re;pe++)de.writeUInt8(Y,pe);return de}async $updateRemoteConnectionData(re){this._remoteConnectionData=re,this._onDidChangeRemoteConnectionData.fire()}};M=je([He(0,l.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,E.IExtHostConfiguration),He(5,A.ILogService),He(6,s.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,i.IExtHostTunnelService),He(9,p.IExtHostTerminalService),He(10,L.IExtHostLocalizationService)],M),e.AbstractExtHostExtensionService=M;function z(ue,re){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class j{constructor(re,de,Y,pe,be){U.set(this,void 0),F.set(this,void 0),B.set(this,void 0),tt(this,U,re,"f"),tt(this,F,de,"f"),tt(this,B,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=pe,this.isFromDifferentExtensionHost=be}get isActive(){return Ne(this,U,"f").isActivated(Ne(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,U,"f").getExtensionExports(Ne(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,U,"f").activateByIdWithErrors(Ne(this,B,"f"),{startup:!1,extensionId:Ne(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=j,U=new WeakMap,F=new WeakMap,B=new WeakMap;function $(ue,re){return ue.getAllExtensionDescriptions().filter(de=>re.has(m.ExtensionIdentifier.toKey(de.identifier)))}function Q(ue){const re=ue.indexOf("+");return re===-1?ue:ue.substring(0,re)}class K{constructor(re){this._searchTree=re}setSearchTree(re){this._searchTree=re}findSubstr(re){return this._searchTree.findSubstr(re)}forEach(re){return this._searchTree.forEach(re)}}e.ExtensionPaths=K}),define(_e[287],ye([1,0,74,2,5,34,27,26,16,25,3,41,36,13,8]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(v,r,o,l,s,a,u){this._apiFactory=v,this._extensionRegistry=r,this._instaService=o,this._extHostConfiguration=l,this._extHostExtensionService=s,this._initData=a,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,r,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(b,r)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,r,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const r of v.nodeModuleName)this._factories.set(r,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(r=>v.alternativeModuleName(r))}};h=je([He(2,A.IInstantiationService),He(3,P.IExtHostConfiguration),He(4,T.IExtHostExtensionService),He(5,C.IExtHostInitDataService),He(6,_.ILogService)],h),e.RequireInterceptor=h;let g=class Yn{constructor(v){if(v.environment.appRoot&&Yn.aliased.size){const r=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),o="[a-z0-9_.-]",l=`@${o}+\\/${o}+|${o}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${s}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(v));if(!r)return;const[,o,l,s]=r,a=Yn.aliased.get(l);if(a!==void 0)return console.warn(`${l} as been renamed to ${a}, please update your imports`),o+a+s}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=je([He(0,C.IExtHostInitDataService)],g);class f{constructor(v,r,o,l,s){this._apiFactory=v,this._extensionPaths=r,this._extensionRegistry=o,this._configProvider=l,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,r){const o=this._extensionPaths.findSubstr(r);if(o){let l=this._extApiImpl.get(k.ExtensionIdentifier.toKey(o.identifier));return l||(l=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(o.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((s,a)=>l+=`	${a} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(v,r,o){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(I.MainContext.MainThreadTelemetry);const{environment:l}=o,s=r.getProxy(I.MainContext.MainThreadKeytar);if(l.appRoot){let a=l.appRoot.fsPath;E.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,u)=>s.$getPassword(a,u),setPassword:(a,u,n)=>s.$setPassword(a,u,n),deletePassword:(a,u)=>s.$deletePassword(a,u),findPassword:a=>s.$findPassword(a),findCredentials(a){return s.$findCredentials(a)}}}load(v,r){const o=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const r=v.length;if(r<=7||!this.alternativeNames)return;const o=r-7;if((v.charAt(o)==="/"||v.charAt(o)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};b=je([He(1,S.IExtHostRpcService),He(2,C.IExtHostInitDataService)],b);let m=class{constructor(v,r,o){this._extensionPaths=v,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(I.MainContext.MainThreadTelemetry);const l=o.getProxy(I.MainContext.MainThreadWindow);this._impl=(s,a)=>{const u=t.URI.parse(s);return a?this.callOriginal(s,a):u.scheme==="http"||u.scheme==="https"?l.$openUri(u,s,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?l.$openUri(u,s,{}):this.callOriginal(s,a)}}load(v,r,o){const l=this._extensionPaths.findSubstr(r);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=o(v),this._impl}callOriginal(v,r){return this.sendNoForwardTelemetry(),this._original(v,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([He(2,S.IExtHostRpcService)],m)}),define(_e[47],ye([1,0,79,6,9,36,3,58,59,41,7,33,224,34]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class w extends E.AbstractVariableResolverService{constructor(f,b,m,d,v,r,o){function l(){if(m){const s=m.activeEditor();if(s)return s.document.uri;const a=d.tabGroups.all.find(u=>u.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.TextDiffTabInput||a.input instanceof A.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof A.TextTabInput||a.input instanceof A.NotebookEditorTabInput||a.input instanceof A.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:s=>{const a=r.folders.filter(u=>u.name===s);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,a)=>v.getConfiguration(void 0,s).get(a),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=l();if(s)return I.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const s=l();if(s){const a=b.getWorkspaceFolder(s);if(a)return I.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(m){const s=m.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(m){const s=m.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>f.getExtension(s)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(P.env))}}let h=class extends t.Disposable{constructor(f,b,m,d,v){super(),this.extensionService=f,this.workspaceService=b,this.editorService=m,this.configurationService=d,this.editorTabs=v,this._resolver=new c.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),l={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{l.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,l,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=je([He(0,C.IExtHostExtensionService),He(1,T.IExtHostWorkspace),He(2,k.IExtHostDocumentsAndEditors),He(3,_.IExtHostConfiguration),He(4,S.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(_e[75],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,130,217,34,47]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(l,s,a,u,n,i){this._workspaceService=s,this._extensionService=a,this._configurationService=u,this._editorTabs=n,this._variableResolver=i,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=l.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(D=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(l,s){const a=l;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let u=`debug:${encodeURIComponent(a.path||"")}`,n="?";return s&&(u+=`${n}session=${encodeURIComponent(s.id)}`,n="&"),u+=`${n}ref=${a.sourceReference}`,P.URI.parse(u)}else{if(a.path)return P.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const s=[];for(const a of l.getAllExtensionDescriptions())if(a.contributes){const u=a.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,w.isDebuggerMainContribution)(n)&&s.push(n.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(s=>l.push(s)),l}addBreakpoints(l){this.startBreakpoints();const s=l.filter(n=>{const i=n.id;return this._breakpoints.has(i)?!1:(this._breakpoints.set(i,n),!0)});this.fireBreakpointChanges(s,[],[]);const a=[],u=new Map;for(const n of s)if(n instanceof T.SourceBreakpoint){let i=u.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),i),a.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof T.FunctionBreakpoint&&a.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(l){this.startBreakpoints();const s=l.filter(i=>this._breakpoints.delete(i.id));this.fireBreakpointChanges([],s,[]);const a=s.filter(i=>i instanceof T.SourceBreakpoint).map(i=>i.id),u=s.filter(i=>i instanceof T.FunctionBreakpoint).map(i=>i.id),n=s.filter(i=>i instanceof T.DataBreakpoint).map(i=>i.id);return this._debugServiceProxy.$unregisterBreakpoints(a,u,n)}startDebugging(l,s,a){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,s,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,s,a){if(!s)return new T.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:u,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,a,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,u),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(l,s,a){if(!a)return new T.Disposable(()=>{});if(!this.definesDebugType(l,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:u,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,u),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(l,s){if(!s)return new T.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:a,factory:s}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==s)})}async $runInTerminal(l,s){return Promise.resolve(void 0)}async $substituteVariables(l,s){let a;const u=await this.getFolder(l);return u&&(a={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(a,s)}createDebugAdapter(l,s){if(l.type==="implementation")return new v(l.implementation)}createSignService(){}async $startDASession(l,s){const a=this,u=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const i=this.convertToDto(n),p=this.createDebugAdapter(i,u);if(!p)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const D=p;return this._debugAdapters.set(l,D),this.getDebugAdapterTrackers(u).then(R=>(R&&this._debugAdaptersTrackers.set(l,R),D.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const V=N,x={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(V.arguments.value);x.body={signature:L},D.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,D.sendResponse(x)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(N),N=(0,w.convertToVSCPaths)(N,!0),a._debugServiceProxy.$acceptDAMessage(l,N)}),D.onError(N=>{R&&R.onError&&R.onError(N),this._debugServiceProxy.$acceptDAError(l,N.name,N.message,N.stack)}),D.onExit(N=>{R&&R.onExit&&R.onExit((0,I.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,I.withNullAsUndefined)(N),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),D.startSession()))})}$sendDAMessage(l,s){s=(0,w.convertToDAPaths)(s,!1);const a=this._debugAdaptersTrackers.get(l);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(s),this._debugAdapters.get(l)?.sendMessage(s)}$stopDASession(l){const s=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),s&&s.onWillStopSession&&s.onWillStopSession();const a=this._debugAdapters.get(l);return this._debugAdapters.delete(l),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const s=[],a=[],u=[];if(l.added)for(const n of l.added){const i=n.id;if(i&&!this._breakpoints.has(i)){let p;if(n.type==="function")p=new T.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new T.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const D=P.URI.revive(n.uri);p=new T.SourceBreakpoint(new T.Location(D,new T.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=i,this._breakpoints.set(i,p),s.push(p)}}if(l.removed)for(const n of l.removed){const i=this._breakpoints.get(n);i&&(this._breakpoints.delete(n),a.push(i))}if(l.changed){for(const n of l.changed)if(n.id){const i=this._breakpoints.get(n.id);if(i){if(i instanceof T.FunctionBreakpoint&&n.type==="function"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(i instanceof T.SourceBreakpoint&&n.type==="source"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new T.Location(P.URI.revive(n.uri),new T.Position(n.line,n.character))}u.push(i)}}}this.fireBreakpointChanges(s,a,u)}$provideDebugConfigurations(l,s,a){return(0,c.asPromise)(async()=>{const u=this.getConfigProviderByHandle(l);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(s);return u.provideDebugConfigurations(n,a)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(l,s,a,u){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.getFolder(s);return n.resolveDebugConfiguration(i,a,u)})}$resolveDebugConfigurationWithSubstitutedVariables(l,s,a,u){return(0,c.asPromise)(async()=>{const n=this.getConfigProviderByHandle(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.getFolder(s);return n.resolveDebugConfigurationWithSubstitutedVariables(i,a,u)})}async $provideDebugAdapter(l,s){const a=this.getAdapterDescriptorFactoryByHandle(l);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(s);return this.getAdapterDescriptor(a,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(l){const s=await this.getSession(l);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(l){const s=await this.getSession(l);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,s){(await this.getSession(l))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(l,s){const u={session:await this.getSession(l),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(l){if(l instanceof T.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof T.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const s=this._adapterFactories.filter(a=>a.type===l);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(l){const s=this._adapterFactories.filter(a=>a.handle===l);if(s.length>0)return s[0].factory}getConfigProviderByHandle(l){const s=this._configProviders.filter(a=>a.handle===l);if(s.length>0)return s[0].provider}definesDebugType(l,s){if(l.contributes){const a=l.contributes.debuggers;if(a&&a.length>0){for(const u of a)if(u.label&&u.type&&u.type===s)return!0}}return!1}getDebugAdapterTrackers(l){const a=l.configuration.type,u=this._trackerFactories.filter(n=>n.type===a||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(l)).then(i=>i,i=>null));return Promise.race([Promise.all(u).then(n=>{const i=n.filter(p=>!!p);if(i.length>0)return new d(i)}),new Promise((n,i)=>{const p=setTimeout(()=>{clearTimeout(p),i(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(l,s){const a=s.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new T.DebugAdapterServer(a));if(l){const n=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>l.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,n))).then(i=>{if(i)return i})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,u))}daExecutableFromPackage(l,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,s,a){(l.length>0||s.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:s,changed:a}))}async getSession(l){if(l)if(typeof l=="string"){const s=this._debugSessions.get(l);if(s)return s}else{let s=this._debugSessions.get(l.id);if(!s){const a=await this.getFolder(l.folderUri),u=l.parent?this._debugSessions.get(l.parent):void 0;s=new b(this._debugServiceProxy,l.id,l.type,l.name,a,l.configuration,u),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(l){if(l){const s=P.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};f=je([He(0,A.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class b{constructor(l,s,a,u,n,i,p){this._debugServiceProxy=l,this._id=s,this._type=a,this._name=u,this._workspaceFolder=n,this._configuration=i,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,s)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=b;class m{constructor(l){this.value=Object.freeze({append(s){l.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=m;class d{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(s=>s.onError?s.onError(l):void 0)}onExit(l,s){this.trackers.forEach(a=>a.onExit?a.onExit(l,s):void 0)}}class v extends _.AbstractDebugAdapter{constructor(l){super(),this.implementation=l,l.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends f{constructor(l,s,a,u,n,i){super(l,s,a,u,n,i)}};r=je([He(0,A.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,g.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(_e[288],ye([1,0,10,74,2,5,280,13,85,86,25,195,16,55,41,94]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const d=m.get(k.ILogService),r=m.get(E.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{d.error(o);const l=c.transformErrorForSerialization(o);r.$onUnexpectedError(l)})}static async installFullHandler(m){const d=m.get(k.ILogService),v=m.get(E.IExtHostRpcService),r=m.get(w.IExtHostExtensionService),o=m.get(h.IExtHostTelemetry),l=v.getProxy(P.MainContext.MainThreadExtensionService),s=v.getProxy(P.MainContext.MainThreadErrors),a=await r.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,i)=>{let p="",D,R;for(const N of i)p+=`
	at ${N.toString()}`,R=N.getFileName(),!D&&R&&(D=a.findSubstr(I.URI.file(R)));return u.set(n,D?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},c.setUnexpectedErrorHandler(n=>{d.error(n);const i=c.transformErrorForSerialization(n),p=u.get(n);if(!p){s.$onUnexpectedError(i);return}l.$onExtensionRuntimeError(p,i);const D=o.onExtensionError(p,n);d.trace("forwarded error to extension?",D,p)})}}Error.stackTraceLimit=100;class f{constructor(m,d,v,r,o){this._hostUtils=v,this._rpcProtocol=new y.RPCProtocol(m,null,r),d=f._transform(d,this._rpcProtocol);const l=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());l.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...d,messagePorts:o}),l.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),l.set(_.IURITransformerService,new _.URITransformerService(r)),l.set(w.IHostUtils,v);const s=new T.InstantiationService(l,!0);s.invokeFunction(g.installEarlyHandler),this._logService=s.invokeFunction(a=>a.get(k.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",d),this._extensionService=s.invokeFunction(a=>a.get(w.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const d=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return I.URI.revive(await d.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,d){m.allExtensions.forEach(r=>{r.extensionLocation=I.URI.revive(d.transformIncomingURIs(r.extensionLocation));const o={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(l=>o[l]=I.URI.revive(d.transformIncomingURIs(r.browserNlsBundleUris[l]))),r.browserNlsBundleUris=o)}),m.environment.appRoot=I.URI.revive(d.transformIncomingURIs(m.environment.appRoot));const v=m.environment.extensionDevelopmentLocationURI;return v&&(m.environment.extensionDevelopmentLocationURI=v.map(r=>I.URI.revive(d.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=I.URI.revive(d.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=I.URI.revive(d.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=I.URI.revive(d.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=I.URI.revive(d.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=I.URI.revive(d.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=I.URI.revive(d.transformIncomingURIs(m.logsLocation)),m.logFile=I.URI.revive(d.transformIncomingURIs(m.logFile)),m.workspace=d.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=f}),define(_e[289],ye([1,0,18,12,179,194,202,75,59,41,16,40,7,47,33,218,220,34]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends k.ExtHostDebugServiceBase{constructor(o,l,s,a,u,n,i){super(o,l,s,a,n,i),this._terminalService=u,this._integratedTerminalInstances=new v}createDebugAdapter(o,l){switch(o.type){case"server":return new h.SocketDebugAdapter(o);case"pipeServer":return new h.NamedPipeDebugAdapter(o);case"executable":return new h.ExecutableDebugAdapter(o,l.type)}return super.createDebugAdapter(o,l)}daExecutableFromPackage(o,l){const s=h.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),o.type);if(s)return new E.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new y.SignService}async $runInTerminal(o,l){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const s=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),u=this._terminalService.getDefaultShellArgs(!0),n=o.title||I.localize(0,null),i=JSON.stringify({shell:a,shellArgs:u});let p=await this._integratedTerminalInstances.checkout(i,n),D,R=!1;if(p)D=o.cwd;else{const L={shellPath:a,shellArgs:u,cwd:o.cwd,name:n,iconPath:new E.ThemeIcon("debug")};R=!0,p=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(p,i)}p.show(!0);const N=await p.processId;R?await new Promise(L=>setTimeout(L,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const V=(0,g.prepareCommand)(a,o.args,!!o.argsCanBeInterpretedByShell,D,o.env);p.sendText(V);const x=this.onDidTerminateDebugSession(L=>{L.id===l&&(this._integratedTerminalInstances.free(p),x.dispose())});return N}else if(o.kind==="external")return d(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,l)}};b=je([He(0,A.IExtHostRpcService),He(1,w.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,f.IExtHostConfiguration),He(4,T.IExtHostTerminalService),He(5,S.IExtHostEditorTabs),He(6,_.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let m;function d(r,o){if(!m)if(t.isWindows)m=new P.WindowsExternalTerminalService;else if(t.isMacintosh)m=new P.MacExternalTerminalService;else if(t.isLinux)m=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=o.getConfiguration("terminal");return m.runInTerminal(r.title,r.cwd,r.args,r.env||{},l.external||{})}class v{constructor(){this._terminalInstances=new Map}async checkout(o,l){const a=[...this._terminalInstances.entries()].map(([u,n])=>(0,c.createCancelablePromise)(async i=>{if(u.name!==l||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await u.processId))return null;const p=Date.now();return n.lastUsedAt+v.minUseDelay>p||i.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=p,u)}));return await(0,c.firstParallel)(a,u=>!!u)}insert(o,l){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:l})}free(o){const l=this._terminalInstances.get(o);l&&(l.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}v.minUseDelay=1e3}),define(_e[290],ye([1,0,9,2,114,33,58,34,45,40,16,25,73,14,13,68,22,84,47]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(v,r,o,l,s,a,u,n,i){super(v,r,o,l,s,a,u,n),this.workspaceService=o,this.variableResolver=i,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(_.Schemas.file,{scheme:_.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(v,r){const o=r;if(!r.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const l=E.TaskHandleDTO.from(o,this.workspaceService),s=await this._proxy.$getTaskExecution(l);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(s,r);return this._proxy.$executeTask(l).catch(()=>{}),a}else{const l=E.TaskDTO.from(r,v);if(l===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(l.execution)&&await this.addCustomExecution(l,r,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(l),r);return this._proxy.$executeTask(l).catch(()=>{}),s}}provideTasksInternal(v,r,o,l){const s=[];if(l)for(const a of l){this.checkDeprecation(a,o),(!a.definition||!v[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const u=E.TaskDTO.from(a,o.extension);u&&(s.push(u),E.CustomExecutionDTO.is(u.execution)&&r.push(this.addCustomExecution(u,a,!0)))}return{tasks:s,extension:o.extension}}async resolveTaskInternal(v){return v}async getAFolder(v){let r=v&&v.length>0?v[0]:void 0;if(!r){const o=t.URI.file((0,f.homedir)());r=new S.WorkspaceFolder({uri:o,name:g.basename(o),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(v,r){const o=t.URI.revive(v),l={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(o),a=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.variableResolver.getResolver(),n=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(const i of r.variables)l.variables[i]=await u.resolveAsync(n,i);if(r.process!==void 0){let i;if(r.process.path!==void 0){i=r.process.path.split(c.delimiter);for(let p=0;p<i.length;p++)i[p]=await u.resolveAsync(n,i[p])}l.process=await I.win32.findExecutable(await u.resolveAsync(n,r.process.name),r.process.cwd!==void 0?await u.resolveAsync(n,r.process.cwd):void 0,i)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(v,r,o){return I.win32.findExecutable(v,r,o)}};m=je([He(0,A.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,w.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,b.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(_e[291],ye([1,0,84,47]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(_e[141],ye([1,0,17,18,21,50,14,9,22,2,31]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(b,m,d,v){this.query=b,this.provider=m,this.fileUtils=d,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,m){const d=this.query.folderQueries||[],v=new I.CancellationTokenSource;return m.onCancellationRequested(()=>v.cancel()),new Promise((r,o)=>{this.collector=new _(b);let l=!1;const s=(a,u)=>{if(!l&&!this.isLimitHit){const n=this.resultSize(a);h(a)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,l=!0,v.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const i=this.resultSize(a);this.resultCount+=i,(i>0||!h(a))&&this.collector.add(a,u)}};Promise.all(d.map((a,u)=>this.searchInFolder(a,n=>s(n,u),v.token))).then(a=>{v.dispose(),this.collector.flush();const u=a.some(n=>!!n&&!!n.limitHit);r({limitHit:this.isLimitHit||u,messages:(0,c.flatten)(a.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},a=>{v.dispose();const u=(0,P.toErrorMessage)(a);o(new Error(u))})})}resultSize(b){return h(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,m){const d=Array.isArray(b.ranges)?b.ranges:[b.ranges],v=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:d.slice(0,m),preview:{matches:v.slice(0,m),text:b.preview.text},uri:b.uri}}async searchInFolder(b,m,d){const v=new A.QueryGlobTester(this.query,b),r=[],o={report:a=>{if(!this.validateProviderResult(a))return;const u=b.folder.scheme===y.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,n=S.relativePath(b.folder,a.uri);if(n){const i=v.includedInQuery(n,k.basename(n),u);(0,t.isThenable)(i)?r.push(i.then(p=>{p&&m(a)})):i&&m(a)}}},l=this.getSearchOptionsForFolder(b),s=await this.provider.provideTextSearchResults(E(this.query.contentPattern),l,o,d);return r.length&&await Promise.all(r),s}validateProviderResult(b){if(h(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const m=(0,A.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),d=(0,A.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),v={folder:C.URI.from(b.folder),excludes:d,includes:m,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=T;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class _{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,m=>this.sendItems(m))}add(b,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!S.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(w(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=_;function w(f){return h(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function h(f){return!!f.preview}e.extensionResultIsMatch=h;class g{constructor(b,m){this.maxBatchSize=b,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,m){!b||this.addItemToBatch(b,m)}addItems(b,m){!b||this.addItemsToBatch(b,m)}addItemToBatch(b,m){this.batch.push(b),this.batchSize+=m,this.onUpdate()}addItemsToBatch(b,m){this.batch=this.batch.concat(b),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(_e[76],ye([1,0,6,5,3,284,16,55,13,2,141]),function(Z,e,c,t,I,P,y,k,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let T=class{constructor(h,g,f){this.extHostRpc=h,this._uriTransformer=g,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const f=this._handlePool++;return this._textSearchProvider.set(f,g),this._proxy.$registerTextSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(h,g){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const f=this._handlePool++;return this._fileSearchProvider.set(f,g),this._proxy.$registerFileSearchProvider(f,this._transformScheme(h)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(h,g,f,b){const m=E(f),d=this._fileSearchProvider.get(h);if(d)return this._fileSearchManager.fileSearch(m,d,v=>{this._proxy.$handleFileMatch(h,g,v.map(r=>r.resource))},b);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,f,b){const m=this._textSearchProvider.get(h);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const d=E(f);return this.createTextSearchManager(d,m).search(r=>this._proxy.$handleTextMatch(h,g,r),b)}$enableExtensionHostSearch(){}createTextSearchManager(h,g){return new A.TextSearchManager(h,g,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};T=je([He(0,y.IExtHostRpcService),He(1,k.IURITransformerService),He(2,S.ILogService)],T),e.ExtHostSearch=T;function E(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(_),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>C.URI.revive(h))}}e.reviveQuery=E;function _(w){return{...w,folder:C.URI.revive(w.folder)}}}),define(_e[292],ye([1,0,85,140,33,137,34,39,58,40,73,75,76,97,54,68,139,69,46,96,94,59,138,13,230,47,95]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v,r,o,l,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,r.ExtHostLoggerService,1),(0,c.registerSingleton)(o.ILogService,l.ExtHostLogService,1),(0,c.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands,0),(0,c.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,0),(0,c.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,c.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage,0),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,c.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService,0),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,c.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,c.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,0),(0,c.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry,0),(0,c.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,c.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(_e[98],ye([1,0,17,13,31,72]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=y;function k(T,E,_,w){const h=(0,c.mapArrayOrNot)(_,S),g=new I.TextSearchMatch(E,h,w),f=g.preview.matches;return{ranges:(0,c.mapArrayOrNot)(h,C),uri:T,preview:{text:g.preview.text,matches:(0,c.mapArrayOrNot)(f,C)}}}e.createTextSearchResult=k;function S(T){return new I.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function C(T){return new P.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let A=class{constructor(E,_){this.prefix=E,this.logService=_}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};A=je([He(1,t.ILogService)],A),e.OutputChannel=A}),define(_e[293],ye([1,0,44,9,80,32,12,8,98,294]),function(Z,e,c,t,I,P,y,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(m,d,v,r){const o=E(m,d,v,r),l=d.folder.fsPath;return{cmd:c.spawn(A,o.args,{cwd:l}),rgDiskPath:A,siblingClauses:o.siblingClauses,rgArgs:o,cwd:l}}e.spawnRipgrepCmd=T;function E(m,d,v,r){const o=["--files","--hidden","--case-sensitive"];w([d],v,!1).forEach(s=>{const a=(0,S.anchorGlob)(s);if(o.push("-g",a),y.isMacintosh){const u=(0,I.normalizeNFD)(a);u!==a&&o.push("-g",u)}});const l=_([d],r,void 0,!1);return l.globArgs.forEach(s=>{const a=`!${(0,S.anchorGlob)(s)}`;if(o.push("-g",a),y.isMacintosh){const u=(0,I.normalizeNFD)(a);u!==a&&o.push("-g",u)}}),d.disregardIgnoreFiles!==!1?o.push("--no-ignore"):d.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),d.ignoreSymlinks||o.push("--follow"),m.exists&&o.push("--quiet"),o.push("--no-config"),d.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:l.siblingClauses}}function _(m,d,v,r=!0){const o=[];let l={};return m.forEach(s=>{const a=Object.assign({},s.excludePattern||{},d||{}),u=h(a,r?s.folder.fsPath:void 0,v);o.push(...u.globArgs),u.siblingClauses&&(l=Object.assign(l,u.siblingClauses))}),{globArgs:o,siblingClauses:l}}e.foldersToRgExcludeGlobs=_;function w(m,d,v=!0){const r=[];return m.forEach(o=>{const l=Object.assign({},d||{},o.includePattern||{}),s=h(l,v?o.folder.fsPath:void 0);r.push(...s.globArgs)}),r}e.foldersToIncludeGlobs=w;function h(m,d,v){const r=[],o={};return Object.keys(m).forEach(l=>{if(v&&v.has(l)||!l)return;const s=m[l];l=f(d?g(d,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof s=="boolean"&&s?(l.startsWith("\\\\")&&(l+="**"),r.push(b(l))):s&&s.when&&(o[l]=s)}),{globArgs:r,siblingClauses:o}}function g(m,d){return t.isAbsolute(d)?d:t.join(m,d)}e.getAbsoluteGlob=g;function f(m){return m=k.rtrim(m,"\\"),k.rtrim(m,"/")}function b(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=b}),define(_e[295],ye([1,0,44,65,9,296,17,50,37,80,32,12,51,8,11,29,31,293,109]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(l=>l())});class d{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&S.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&S.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(a=>{const u=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),n=a.folder.fsPath;s.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,A.isEqualOrParent)(i,n)&&(u[I.relative(n,i)]=!0)}),this.folderExcludePatterns.set(n,new r(u,n))})}cancel(){this.isCanceled=!0,m.forEach(s=>s())}walk(s,a,u,n,i){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return i(null,this.isLimitHit);a.forEach(p=>{const D=I.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,D)||this.matchFile(u,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(s,(p,D)=>{this.call(this.cmdTraversal,this,p,u,n,R=>{if(R){const N=(0,k.toErrorMessage)(R);console.error(N),this.errors.push(N),D(R,void 0)}else D(null,void 0)})},(p,D)=>{this.fileWalkSW.stop();const R=p?y.coalesce(p)[0]:null;i(R,this.isLimitHit)})}parallel(s,a,u){const n=new Array(s.length),i=new Array(s.length);let p=!1,D=0;if(s.length===0)return u(null,[]);s.forEach((R,N)=>{a(R,(V,x)=>{if(V?(p=!0,n[N]=null,i[N]=V):(n[N]=x,i[N]=null),++D===s.length)return u(p?i:null,n)})})}call(s,a,...u){try{s.apply(a,u)}catch(n){u[u.length-1](n)}}cmdTraversal(s,a,u,n){const i=s.folder.fsPath,p=T.isMacintosh,D=()=>L&&L.kill();m.add(D);let R=M=>{m.delete(D),R=()=>{},n(M)},N="";const V=this.initDirectoryTree(),x=(0,f.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression),L=x.cmd,U=!Object.keys(x.siblingClauses).length,F=x.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let B=`${x.rgDiskPath} ${F}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),u({message:B}),this.cmdResultCount=0,this.collectStdout(L,"utf8",u,(M,z,j)=>{if(M){R(M);return}if(this.isLimitHit){R();return}const Q=(N+(p?C.normalizeNFC(z||""):z)).split(`
`);if(j){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else N=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,U){for(const K of Q)if(this.matchFile(a,{base:i,relativePath:K,searchPath:this.getSearchPath(s,K)}),this.isLimitHit){D();break}(j||this.isLimitHit)&&R();return}this.addDirectoryEntries(s,V,i,Q,a),j&&(this.matchDirectoryTree(V,i,a),R())})}spawnFindCmd(s){const a=this.folderExcludePatterns.get(s.folder.fsPath),u=a.getBasenameTerms(),n=a.getPathTerms(),i=["-L","."];if(u.length||n.length){i.push("-not","(","(");for(const p of u)i.push("-name",p),i.push("-o");for(const p of n)i.push("-path",p),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),c.spawn("find",i,{cwd:s.folder.fsPath})}readStdout(s,a,u){let n="";this.collectStdout(s,a,()=>{},(i,p,D)=>{if(i){u(i);return}n+=p,D&&u(null,n)})}collectStdout(s,a,u,n){let i=(R,N,V)=>{(R||V)&&(i=()=>{},this.cmdSW?.stop()),n(R,N,V)},p=!1;s.stdout?(this.forwardData(s.stdout,a,i),s.stdout.once("data",()=>p=!0)):u({message:"stdout is null"});let D;s.stderr?D=this.collectData(s.stderr):u({message:"stderr is null"}),s.on("error",R=>{i(R)}),s.on("close",R=>{let N;!p&&(N=this.decodeData(D,a))&&o(N)?i(new Error(`command failed with error code ${R}: ${this.decodeData(D,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),i(null,"",!0))})}forwardData(s,a,u){const n=new P.StringDecoder(a);return s.on("data",i=>{u(null,n.write(i))}),n}collectData(s){const a=[];return s.on("data",u=>{a.push(u)}),a}decodeData(s,a){const u=new P.StringDecoder(a);return s.map(n=>u.write(n)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:a},u,n,i){n.indexOf(this.filePattern)!==-1&&this.matchFile(i,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const p=D=>{const R=I.basename(D),N=I.dirname(D);let V=a[N];V||(V=a[N]=[],p(N)),V.push({base:u,relativePath:D,basename:R,searchPath:this.getSearchPath(s,D)})};n.forEach(p)}matchDirectoryTree({rootEntries:s,pathToEntries:a},u,n){const i=this,p=this.folderExcludePatterns.get(u),D=this.filePattern;function R(N){i.directoriesWalked++;const V=(0,g.hasSiblingFn)(()=>N.map(x=>x.basename));for(let x=0,L=N.length;x<L;x++){const U=N[x],{relativePath:F,basename:B}=U;if(p.test(F,B,D!==B?V:void 0))continue;const M=a[F];if(M)R(M);else{if(i.filesWalked++,F===D)continue;i.matchFile(n,U)}if(i.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,a,u,n,i){const p=s.folder,D=(0,g.hasSiblingFn)(()=>u);this.parallel(u,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const V=a?[a,R].join(I.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(V,R,this.config.filePattern!==R?D:void 0))return N(null);const x=[p.fsPath,V].join(I.sep);t.lstat(x,(L,U)=>{if(L||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(x,U,(F,B)=>F||this.isCanceled||this.isLimitHit?N(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,U,(M,z)=>M||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?N(null):(this.walkedPaths[z]=!0,h.Promises.readdir(x).then(j=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(s,V,j,n,$=>N($||null))},j=>{N(null)})))):(this.filesWalked++,V===this.filePattern||this.maxFilesize&&w.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(n,{base:p.fsPath,relativePath:V,searchPath:this.getSearchPath(s,V)}),N(null,void 0)))})},R=>{const N=R&&y.coalesce(R);return i(N&&N.length>0?N[0]:void 0)})}matchFile(s,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,I.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(a))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,g.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,a,u){return a.isSymbolicLink()?t.stat(s,u):u(null,a)}realPathIfNeeded(s,a,u){return a.isSymbolicLink()?t.realpath(s,(n,i)=>n?u(n):u(null,i)):u(null,s)}getSearchPath(s,a){return s.folderName?I.join(s.folderName,a):a}}e.FileWalker=d;class v{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new d(s)}search(s,a,u){this.walker.walk(this.folderQueries,this.extraFiles,s,a,(n,i)=>{u(n,{limitHit:i,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class r{constructor(s,a){this.expression=s,this.root=a,this.init(s)}init(s){let a,u;Object.keys(s).filter(n=>s[n]).forEach(n=>{I.isAbsolute(n)?(a=a||S.getEmptyExpression(),a[n]=s[n]):(u=u||S.getEmptyExpression(),u[n]=s[n])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=u&&S.parse(u,{trimForExclusions:!0})}test(s,a,u){return this.relativeParsedExpr&&this.relativeParsedExpr(s,a,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,s),a,u)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...S.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...S.getPathTerms(this.relativeParsedExpr)),s}}function o(l){const s=l.trim().split(`
`),a=s[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return _.uppercaseFirstLetter(s[s.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=o}),define(_e[297],ye([1,0,101,23]),function(Z,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===l)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,k=512*8,S=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(s,a){super(s),this.decodeStreamErrorKind=a}}e.DecodeStreamError=A;class T{static async create(s){let a;if(s!==e.UTF8)a=(await new Promise((n,i)=>{Z(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(h(s));else{const u=new TextDecoder;a={write(n){return u.decode(n,{stream:!0})},end(){return u.decode()}}}return new T(a)}constructor(s){this.iconvLiteDecoder=s}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function E(l,s){const a=s.minBytesRequiredForDetection??s.guessEncoding?k:y;return new Promise((u,n)=>{const i=(0,c.newWriteableStream)(x=>x.join("")),p=[];let D=0,R,N;const V=async()=>{try{const x=await o({buffer:t.VSBuffer.concat(p),bytesRead:D},s.guessEncoding);if(x.seemsBinary&&s.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);x.encoding=await s.overwriteEncoding(x.encoding),R=await T.create(x.encoding);const L=R.write(t.VSBuffer.concat(p).buffer);i.write(L),p.length=0,D=0,u({stream:i,detected:x})}catch(x){N?.dispose(),i.destroy(),n(x)}};N=(0,c.listenStream)(l,{onData:async x=>{R?i.write(R.write(x.buffer)):(p.push(x),D+=x.byteLength,D>=a&&(l.pause(),await V(),setTimeout(()=>l.resume())))},onError:x=>i.error(x),onEnd:async()=>{R||await V(),i.end(R?.end())}})})}e.toDecodeStream=E;async function _(l,s,a){const n=(await new Promise((D,R)=>{Z(["@vscode/iconv-lite-umd"],D,R)})).getEncoder(h(s),a);let i=!1,p=!1;return{read(){if(p)return null;const D=l.read();if(typeof D!="string"){if(p=!0,!i&&a?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(i=!0,t.VSBuffer.wrap(R)):null}return i=!0,t.VSBuffer.wrap(n.write(D))}}}e.toEncodeReadable=_;async function w(l){return(await new Promise((a,u)=>{Z(["@vscode/iconv-lite-umd"],a,u)})).encodingExists(h(l))}e.encodingExists=w;function h(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=h;function g(l,s){if(!l||s<e.UTF16be_BOM.length)return null;const a=l.readUInt8(0),u=l.readUInt8(1);if(a===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const n=l.readUInt8(2);return a===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const f=["ascii","utf-16","utf-32"];async function b(l){const s=await new Promise((p,D)=>{Z(["jschardet"],p,D)}),a=l.slice(0,S),u=v(a.buffer),n=s.detect(u);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=f.indexOf(i)?null:d(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function d(l){const s=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[s]||s}function v(l){let s="";for(let a=0;a<l.length;a++)s+=String.fromCharCode(l[a]);return s}function r(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=l.match(/windows(\d+)/);return s?"windows-"+s[1]:l}}}e.toCanonicalName=r;function o({buffer:l,bytesRead:s},a){let u=g(l,s),n=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&l){let i=!0,p=!0,D=!1;for(let R=0;R<s&&R<P;R++){const N=R%2===1,V=l.readUInt8(R)===0;if(V&&(D=!0),i&&(N&&!V||!N&&V)&&(i=!1),p&&(N&&V||!N&&!V)&&(p=!1),V&&!i&&!p)break}D&&(i?u=e.UTF16le:p?u=e.UTF16be:n=!0)}return a&&!n&&!u&&l?b(l.slice(0,s)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:u}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(_e[142],ye([1,0,297,29,141]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends I.TextSearchManager{constructor(k,S,C=t,A="searchProcess"){super(k,S,{readdir:T=>C.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,c.toCanonicalName)(T)},A)}}e.NativeTextSearchManager=P}),define(_e[298],ye([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const P=this._dragOperations.get(I);return this._dragOperations.delete(I),P}}addDragOperationTransfer(I,P){this._dragOperations.set(I,P)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,P){this._renderedElements.set(I,P)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=c}),define(_e[299],ye([1,0,177,7,22,2,4,6,18,7,11,17,15,21,298,27]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,d){if((0,A.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let v;return Array.isArray(m.highlights)&&(v=m.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),v=v.length?v:void 0),{label:m.label,highlights:v}}}class f{constructor(d,v,r){this._proxy=d,this.commands=v,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function o(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}v.registerArgumentProcessor({processArgument:l=>o(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(s=>o(s)?this.convertArgument(s):s):l})}registerTreeDataProvider(d,v,r){const o=this.createTreeView(d,{treeDataProvider:v},r);return{dispose:()=>o.dispose()}}createTreeView(d,v,r){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=v.dragAndDropController?.dropMimeTypes??[],l=v.dragAndDropController?.dragMimeTypes??[],s=!!v.dragAndDropController?.handleDrag,a=!!v.dragAndDropController?.handleDrop,u=this.createExtHostTreeView(d,v,r),n=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany,dropMimeTypes:o,dragMimeTypes:l,hasHandleDrag:s,hasHandleDrop:a});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(r,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(i){u.message=i},get title(){return u.title},set title(i){u.title=i},get description(){return u.description},set description(i){u.description=i},get badge(){return u.badge},set badge(i){i!==void 0&&C.ViewBadge.isViewBadge(i)?u.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(u.badge=void 0)},reveal:(i,p)=>u.reveal(i,p),dispose:async()=>{await n,this.treeViews.delete(d),u.dispose()}}}$getChildren(d,v){const r=this.treeViews.get(d);return r?r.getChildren(v):Promise.reject(new Error((0,c.localize)(0,null,d)))}async $handleDrop(d,v,r,o,l,s,a,u){const n=this.treeViews.get(d);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,d)));const i=E.DataTransfer.toDataTransfer(r,async p=>(await this._proxy.$resolveDropFileData(d,v,p)).buffer);return a===d&&u&&await this.addAdditionalTransferItems(i,n,u,l,s),n.onDrop(i,o,l)}async addAdditionalTransferItems(d,v,r,o,l){const s=this.treeDragAndDropService.removeDragOperationTransfer(l);if(s)(await s)?.forEach((a,u)=>{a&&d.set(u,a)});else if(l&&v.handleDrag){const a=v.handleDrag(r,d,o);this.treeDragAndDropService.addDragOperationTransfer(l,a),await a}return d}async $handleDrag(d,v,r,o){const l=this.treeViews.get(d);if(!l)return Promise.reject(new Error((0,c.localize)(2,null,d)));const s=await this.addAdditionalTransferItems(new t.DataTransfer,l,v,o,r);if(!!s)return E.DataTransfer.toDataTransferDTO(s)}async $hasResolve(d){const v=this.treeViews.get(d);if(!v)throw new Error((0,c.localize)(3,null,d));return v.hasResolve}$resolve(d,v,r){const o=this.treeViews.get(d);if(!o)throw new Error((0,c.localize)(4,null,d));return o.resolveTreeItem(v,r)}$setExpanded(d,v,r){const o=this.treeViews.get(d);if(!o)throw new Error((0,c.localize)(5,null,d));o.setExpanded(v,r)}$setSelection(d,v){const r=this.treeViews.get(d);if(!r)throw new Error((0,c.localize)(6,null,d));r.setSelection(v)}$setFocus(d,v){const r=this.treeViews.get(d);if(!r)throw new Error((0,c.localize)(7,null,d));r.setFocus(v)}$setVisible(d,v){const r=this.treeViews.get(d);if(!r)throw new Error((0,c.localize)(8,null,d));r.setVisible(v)}$changeCheckboxState(d,v){const r=this.treeViews.get(d);if(!r)throw new Error((0,c.localize)(9,null,d));r.setCheckboxState(v)}createExtHostTreeView(d,v,r){const o=new b(d,v,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(d,o),o}convertArgument(d){const v=this.treeViews.get(d.$treeViewId);return v&&"$treeItemHandle"in d?v.getExtensionElement(d.$treeItemHandle):v&&"$focusedTreeItem"in d&&d.$focusedTreeItem?v.focusedElement:null}}e.ExtHostTreeViews=f;class b extends k.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,A.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,v,r,o,l,s){if(super(),this.viewId=d,this.proxy=r,this.commands=o,this.logService=l,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,s.contributes&&s.contributes.views)for(const n in s.contributes.views)for(const i of s.contributes.views[n])i.id===d&&(this._title=i.name);this.dataProvider=v.treeDataProvider,this.dndController=v.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let a,u;this._register(y.Event.debounce(this._onDidChangeData.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(a||(a=new Promise(p=>u=p),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=u;return a=null,this.refresh(i).then(()=>p())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(d){const v=d?this.getExtensionElement(d):void 0;if(d&&!v)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(d);return r||(r=await this.fetchChildrenNodes(v)),r?r.map(o=>o.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,v){v=v||{select:!0,focus:!1};const r=(0,A.isUndefinedOrNull)(v.select)?!0:v.select,o=(0,A.isUndefinedOrNull)(v.focus)?!1:v.focus,l=(0,A.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(s=>this.resolveTreeNode(d,s[s.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:s.map(u=>u.item)},{select:r,focus:o,expand:l})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:o,expand:l})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=E.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,v){const r=this.getExtensionElement(d);r&&(v?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(d){(0,T.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(d){this._focusedHandle=d}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const v=(await Promise.all(d.map(async r=>{const o=this.getExtensionElement(r.treeItemHandle);return o?{extensionItem:o,treeItem:await this.dataProvider.getTreeItem(o),newState:r.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);v.forEach(r=>{r.treeItem.checkboxState=r.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:v.map(r=>[r.extensionItem,r.newState])})}async handleDrag(d,v,r){const o=[];for(const l of d){const s=this.getExtensionElement(l);s&&o.push(s)}if(!(!this.dndController?.handleDrag||o.length===0))return await this.dndController.handleDrag(o,v,r),v}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,v,r){const o=v?this.getExtensionElement(v):void 0;if(!(!o&&v||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(o,d,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,v){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(d);if(r){const o=this.nodes.get(r);if(o){const l=await this.dataProvider.resolveTreeItem(o.extensionItem,r,v)??o.extensionItem;return this.validateTreeItem(l),o.item.tooltip=this.getTooltip(l.tooltip),o.item.command=this.getCommand(o.disposableStore,l.command),o.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(v=>v?this.resolveUnknownParentChain(v).then(r=>this.resolveTreeNode(v,r[r.length-1]).then(o=>(r.push(o),r))):Promise.resolve([]))}resolveParent(d){const v=this.nodes.get(d);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,v){const r=this.nodes.get(d);return r?Promise.resolve(r):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(o=>this.createHandle(d,o,v,!0)).then(o=>this.getChildren(v?v.item.handle:void 0).then(()=>{const l=this.getExtensionElement(o);if(l){const s=this.nodes.get(l);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(d){if(d){let v;if(typeof d=="string"){const r=this.getExtensionElement(d);v=r?this.nodes.get(r):void 0}else v=d;return v&&v.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const v=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=d?this.nodes.get(d):void 0,o=await this.dataProvider.getChildren(d);if(v.token.isCancellationRequested)return;const l=await Promise.all((0,T.coalesce)(o||[]).map(async s=>{const a=await this.dataProvider.getTreeItem(s);return a&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(s,a,r):null}));return v.token.isCancellationRequested?void 0:(0,T.coalesce)(l)}finally{v.dispose()}}refresh(d){if(d.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(d);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const v=new Set,r=d.map(l=>this.nodes.get(l));for(const l of r)if(l&&!v.has(l.item.handle)){let s=l;for(;s&&s.parent&&r.findIndex(a=>s&&s.parent&&a&&a.item.handle===s.parent.item.handle)===-1;){const a=this.elements.get(s.parent.item.handle);s=a?this.nodes.get(a):void 0}s&&!s.parent&&v.add(l.item.handle)}const o=[];return v.forEach(l=>{const s=this.elements.get(l);if(s){const a=this.nodes.get(s);a&&(!a.parent||!v.has(a.parent.item.handle))&&o.push(l)}}),o}refreshHandles(d){const v={};return Promise.all(d.map(r=>this.refreshNode(r).then(o=>{o&&(v[r]=o.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(d){const v=this.getExtensionElement(d);if(v){const r=this.nodes.get(v);if(r)return this.clearChildren(v),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(o=>{if(o){const l=this.createTreeNode(v,o,r.parent);return this.updateNodeCache(v,l,r,r.parent),r.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,v,r){const o=this.createTreeNode(d,v,r);if(v.id&&this.elements.has(o.item.handle))throw new Error((0,c.localize)(10,null,v.id));return this.addNodeToCache(d,o),this.addNodeToParentCache(o,r),o}getTooltip(d){return C.MarkdownString.isMarkdownString(d)?E.MarkdownString.from(d):d}getCommand(d,v){return v?{...this.commands.toInternal(v,d),originalId:v.command}:void 0}getCheckbox(d){if(!d.checkboxState)return;let v,r;return typeof d.checkboxState=="number"?v=d.checkboxState:(v=d.checkboxState.state,r=d.checkboxState.tooltip),{isChecked:v===C.TreeItemCheckboxState.Checked,tooltip:r}}validateTreeItem(d){if(!C.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,v,r){this.validateTreeItem(v);const o=new k.DisposableStore,l=this.createHandle(d,v,r),s=this.getLightIconPath(v);return{item:{handle:l,parentHandle:r?r.item.handle:void 0,label:g(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(o,v.command),contextValue:v.contextValue,icon:s,iconDark:this.getDarkIconPath(v)||s,themeIcon:this.getThemeIcon(v),collapsibleState:(0,A.isUndefinedOrNull)(v.collapsibleState)?C.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation,checkbox:this.getCheckbox(v)},extensionItem:v,parent:r,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(d){return d.iconPath instanceof C.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:v,label:r,resourceUri:o},l,s){if(v)return`${b.ID_HANDLE_PREFIX}/${v}`;const a=g(r,this.extension),u=l?l.item.handle:b.LABEL_HANDLE_PREFIX;let n=a?a.label:o?(0,I.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,p=this.getChildrenNodes(l)||[];let D,R=0;do{if(D=`${u}/${R}:${n}`,s||!this.elements.has(D)||i===D)break;R++}while(R<=p.length);return D}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof C.ThemeIcon))return typeof d.iconPath=="string"||P.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof C.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return P.URI.isUri(d)?d:P.URI.file(d)}addNodeToCache(d,v){this.elements.set(v.item.handle,d),this.nodes.set(d,v)}updateNodeCache(d,v,r,o){this.elements.delete(v.item.handle),this.nodes.delete(d),v.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(d,v);const l=this.getChildrenNodes(o)||[],s=l.filter(a=>a.item.handle===r.item.handle)[0];s&&l.splice(l.indexOf(s),1,v)}addNodeToParentCache(d,v){v?(v.children||(v.children=[]),v.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const v=this.nodes.get(d);if(v){if(v.children)for(const r of v.children){const o=this.elements.get(r.item.handle);o&&this.clear(o)}v.children=void 0}}else this.clearAll()}clear(d){const v=this.nodes.get(d);if(v){if(v.children)for(const r of v.children){const o=this.elements.get(r.item.handle);o&&this.clear(o)}this.nodes.delete(d),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(_e[300],ye([1,0,21,10,4,42,2,119,105,150,160,38,5,93,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,140,235,261,262,263,97,40,265,299,15,7,268,71,139,33,215,254,87,137,73,75,76,13,55,16,25,258,231,54,68,241,266,70,69,271,269,270,242,46,264,267,96,59,94,259,72,260,14,123,234,211,253,6,27,216,95,208]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d,v,r,o,l,s,a,u,n,i,p,D,R,N,V,x,L,U,F,B,M,z,j,$,Q,K,ue,re,de,Y,pe,be,Ce,Re,We,ne,ce,fe,J,ie,te,O,W,q,X,ae,ve,Te,ge,ke,De,xe,qe,nt,Xe,st,Be,dt,se,oe,Se,le,Pe,Le,Fe,Ge,Je,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function vt(rt){const Ze=rt.get(ce.IExtHostInitDataService),wt=rt.get(ke.IExtHostFileSystemInfo),Et=rt.get(X.IExtHostConsumerFileSystem),kt=rt.get(s.IExtHostExtensionService),ft=rt.get(K.IExtHostWorkspace),Tt=rt.get(Xe.IExtHostTelemetry),Rt=rt.get(b.IExtHostConfiguration),Lt=rt.get(We.IURITransformerService),Qe=rt.get(ne.IExtHostRpcService),At=rt.get(L.IExtHostStorage),Mt=rt.get(q.IExtensionStoragePaths),Wt=rt.get(Re.ILoggerService),pt=rt.get(Re.ILogService),It=rt.get(ie.IExtHostTunnelService),Ct=rt.get(te.IExtHostApiDeprecationService),Ae=rt.get(Q.IExtHostWindow),Me=rt.get(qe.IExtHostSecretState),Ee=rt.get(nt.IExtHostEditorTabs);Qe.set(E.ExtHostContext.ExtHostFileSystemInfo,wt),Qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Qe.set(E.ExtHostContext.ExtHostWorkspace,ft),Qe.set(E.ExtHostContext.ExtHostConfiguration,Rt),Qe.set(E.ExtHostContext.ExtHostExtensionService,kt),Qe.set(E.ExtHostContext.ExtHostStorage,At),Qe.set(E.ExtHostContext.ExtHostTunnelService,It),Qe.set(E.ExtHostContext.ExtHostWindow,Ae),Qe.set(E.ExtHostContext.ExtHostSecretState,Me),Qe.set(E.ExtHostContext.ExtHostTelemetry,Tt),Qe.set(E.ExtHostContext.ExtHostEditorTabs,Ee);const ee=Qe.set(E.ExtHostContext.ExtHostDecorations,rt.get(Y.IExtHostDecorations)),Oe=Qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(l.IExtHostDocumentsAndEditors)),ze=Qe.set(E.ExtHostContext.ExtHostCommands,rt.get(g.IExtHostCommands)),Ye=Qe.set(E.ExtHostContext.ExtHostTerminalService,rt.get(U.IExtHostTerminalService)),Ve=Qe.set(E.ExtHostContext.ExtHostDebugService,rt.get(be.IExtHostDebugService)),at=Qe.set(E.ExtHostContext.ExtHostSearch,rt.get(Ce.IExtHostSearch)),mt=Qe.set(E.ExtHostContext.ExtHostTask,rt.get(pe.IExtHostTask)),Ot=Qe.set(E.ExtHostContext.ExtHostOutputService,rt.get(D.IExtHostOutputService)),bt=Qe.set(E.ExtHostContext.ExtHostLocalization,rt.get(Je.IExtHostLocalizationService)),St=Qe.set(E.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(Qe)),ht=Qe.set(E.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Qe,Oe)),Nt=Qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Qe,Oe,pt)),Gt=Qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(pt,ht,Qe.getProxy(E.MainContext.MainThreadBulkEdits))),_t=Qe.set(E.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Qe,ze,Oe,ht)),xt=Qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new le.ExtHostNotebookDocuments(_t)),rn=Qe.set(E.ExtHostContext.ExtHostNotebookEditors,new Se.ExtHostNotebookEditors(pt,_t)),sn=Qe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Qe,Ze,_t,ze,pt)),gn=Qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new dt.ExtHostNotebookRenderers(Qe,_t)),Dt=Qe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Qe,Oe)),on=Qe.set(E.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Qe.getProxy(E.MainContext.MainThreadTreeViews),ze,pt)),Rn=Qe.set(E.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Qe.getProxy(E.MainContext.MainThreadEditorInsets),Dt,Ze.remote)),Jt=Qe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Qe,pt,wt,Oe)),zt=Qe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Qe,ht,ze.converter,Lt)),lt=Qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Qe,Lt,ht,ze,Jt,pt,Ct,Tt)),pn=Qe.set(E.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Qe,lt)),Ht=Qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Qe,pt,Oe)),Kt=Qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Qe,ft,ze)),an=Qe.set(E.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(Qe,ze,pt)),vn=Qe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Qe,ze,ht)),cn=Qe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Qe.getProxy(E.MainContext.MainThreadProgress))),bn=Qe.set(E.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(Qe)),Dn=Qe.set(E.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(Qe)),Zt=Qe.set(E.ExtHostContext.ExtHostAuthentication,new O.ExtHostAuthentication(Qe)),wn=Qe.set(E.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Qe,ze)),en=Qe.set(E.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Qe,Ze.remote,ft,pt,Ct)),tn=Qe.set(E.ExtHostContext.ExtHostWebviewPanels,new Te.ExtHostWebviewPanels(Qe,en,ft)),Ln=Qe.set(E.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(Qe,ht,Mt,en,tn)),En=Qe.set(E.ExtHostContext.ExtHostWebviewViews,new ae.ExtHostWebviewViews(Qe,en)),Xt=Qe.set(E.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Qe,ze,Oe)),On=Qe.set(E.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Qe));Qe.set(E.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(Qe,_t,Oe,ze,pt));const Fn=Object.values(E.ExtHostContext);Qe.assertRegistered(Fn);const Mn=new ge.ExtHostBulkEdits(Qe,Oe),Nn=new h.ExtHostClipboard(Qe),Sn=new p.ExtHostMessageService(Qe,pt),In=new d.ExtHostDialogs(Qe),ln=new x.ExtHostStatusBar(Qe,ze.converter);return w.ExtHostApiCommands.register(ze),function($e,Vt,kn){const gt=function(){let me=!$e.isUnderDevelopment;function we(){me||(pt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(ot){if(Array.isArray(ot))ot.forEach(Ue);else if(typeof ot=="string")we();else{const yt=ot;typeof yt.scheme>"u"&&we(),typeof yt.exclusive=="boolean"&&(0,Fe.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),un={getSession(me,we,Ue){return Zt.getSession($e,me,we,Ue)},async hasSession(me,we){return(0,Fe.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,me,we,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,ot){return Zt.registerAuthenticationProvider(me,we,Ue,ot)}},Un={registerCommand(me,we,Ue){return ze.registerCommand(!0,me,we,Ue,void 0,$e)},registerTextEditorCommand(me,we,Ue){return ze.registerCommand(!0,me,(...ot)=>{const yt=Dt.getActiveTextEditor();if(!yt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}return yt.edit(Pt=>{we.apply(Ue,[yt,Pt,...ot])}).then(Pt=>{Pt||pt.warn("Edits from command "+me+" were not applied.")},Pt=>{pt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,$e)},registerDiffInformationCommand:(me,we,Ue)=>((0,Fe.checkProposedApiEnabled)($e,"diffCommand"),ze.registerCommand(!0,me,async(...ot)=>{const yt=Oe.activeEditor(!0);if(!yt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Dt.getDiffInformation(yt.id);we.apply(Ue,[Pt,...ot])},void 0,void 0,$e)),executeCommand(me,...we){return ze.executeCommand(me,...we)},getCommands(me=!1){return ze.getCommands(me)}},Tn={get machineId(){return Ze.telemetryInfo.machineId},get sessionId(){return Ze.telemetryInfo.sessionId},get language(){return Ze.environment.appLanguage},get appName(){return Ze.environment.appName},get appRoot(){return Ze.environment.appRoot?.fsPath??""},get appHost(){return Ze.environment.appHost},get uriScheme(){return Ze.environment.appUriScheme},get clipboard(){return Nn.value},get shell(){return Ye.getDefaultShell(!1)},get onDidChangeShell(){return(0,Fe.checkProposedApiEnabled)($e,"envShellEvent"),Ye.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Fe.checkProposedApiEnabled)($e,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Fe.checkProposedApiEnabled)($e,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.isNewAppInstall)(Ze.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Fe.checkProposedApiEnabled)($e,"telemetryLogger"),Tt.instantiateLogger($e,me)},openExternal(me,we){return Ae.openUri(me,{allowTunneling:!!Ze.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===Ze.environment.appUriScheme)return St.createAppUri(me);try{return await Ae.asExternalUri(me,{allowTunneling:!!Ze.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,se.Schemas.http)||(0,oe.matchesScheme)(me,se.Schemas.https))return me;throw we}},get remoteName(){return(0,de.getRemoteName)(Ze.remote.authority)},get remoteAuthority(){return(0,Fe.checkProposedApiEnabled)($e,"resolvers"),Ze.remote.authority},get uiKind(){return Ze.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel}};Ze.environment.extensionTestsLocationURI||Object.freeze(Tn);const Bn={createTestController(me,we,Ue){return Xt.createTestController(me,we,Ue)},createTestObserver(){return(0,Fe.checkProposedApiEnabled)($e,"testObserver"),Xt.createTestObserver()},runTests(me){return(0,Fe.checkProposedApiEnabled)($e,"testObserver"),Xt.runTests(me)},get onDidChangeTestResults(){return(0,Fe.checkProposedApiEnabled)($e,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,Fe.checkProposedApiEnabled)($e,"testObserver"),Xt.results}},dn=Ze.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,_n={getExtension(me,we){(0,Fe.isProposedApiEnabled)($e,"extensionsAny")||(we=!1);const Ue=Vt.mine.getExtensionDescription(me);if(Ue)return new s.Extension(kt,$e.identifier,Ue,dn,!1);if(we){const ot=Vt.all.getExtensionDescription(me);if(ot)return new s.Extension(kt,$e.identifier,ot,dn,!0)}},get all(){const me=[];for(const we of Vt.mine.getAllExtensionDescriptions())me.push(new s.Extension(kt,$e.identifier,we,dn,!1));return me},get allAcrossExtensionHosts(){(0,Fe.checkProposedApiEnabled)($e,"extensionsAny");const me=new Fe.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of Vt.all.getAllExtensionDescriptions()){const ot=!me.has(Ue.identifier);we.push(new s.Extension(kt,$e.identifier,Ue,dn,ot))}return we},get onDidChange(){return(0,Fe.isProposedApiEnabled)($e,"extensionsAny")?I.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Wn={createDiagnosticCollection(me){return Jt.createDiagnosticCollection($e.identifier,me)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:me=>Jt.getDiagnostics(me),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(me,we){return zt.changeLanguage(me.uri,we)},match(me,we){const Ue=ht.getDocumentData(we.uri)?.notebook;return(0,A.score)(M.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return lt.registerCodeActionProvider($e,gt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Fe.checkProposedApiEnabled)($e,"documentPaste"),lt.registerDocumentPasteEditProvider($e,gt(me),we,Ue)},registerCodeLensProvider(me,we){return lt.registerCodeLensProvider($e,gt(me),we)},registerDefinitionProvider(me,we){return lt.registerDefinitionProvider($e,gt(me),we)},registerDeclarationProvider(me,we){return lt.registerDeclarationProvider($e,gt(me),we)},registerImplementationProvider(me,we){return lt.registerImplementationProvider($e,gt(me),we)},registerTypeDefinitionProvider(me,we){return lt.registerTypeDefinitionProvider($e,gt(me),we)},registerHoverProvider(me,we){return lt.registerHoverProvider($e,gt(me),we,$e.identifier)},registerEvaluatableExpressionProvider(me,we){return lt.registerEvaluatableExpressionProvider($e,gt(me),we,$e.identifier)},registerInlineValuesProvider(me,we){return lt.registerInlineValuesProvider($e,gt(me),we,$e.identifier)},registerDocumentHighlightProvider(me,we){return lt.registerDocumentHighlightProvider($e,gt(me),we)},registerLinkedEditingRangeProvider(me,we){return lt.registerLinkedEditingRangeProvider($e,gt(me),we)},registerReferenceProvider(me,we){return lt.registerReferenceProvider($e,gt(me),we)},registerRenameProvider(me,we){return lt.registerRenameProvider($e,gt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return lt.registerDocumentSymbolProvider($e,gt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return lt.registerWorkspaceSymbolProvider($e,me)},registerDocumentFormattingEditProvider(me,we){return lt.registerDocumentFormattingEditProvider($e,gt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return lt.registerDocumentRangeFormattingEditProvider($e,gt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...ot){return lt.registerOnTypeFormattingEditProvider($e,gt(me),we,[Ue].concat(ot))},registerDocumentSemanticTokensProvider(me,we,Ue){return lt.registerDocumentSemanticTokensProvider($e,gt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return lt.registerDocumentRangeSemanticTokensProvider($e,gt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...ot){return typeof Ue=="object"?lt.registerSignatureHelpProvider($e,gt(me),we,Ue):lt.registerSignatureHelpProvider($e,gt(me),we,typeof Ue>"u"?[]:[Ue,...ot])},registerCompletionItemProvider(me,we,...Ue){return lt.registerCompletionItemProvider($e,gt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Fe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider($e,gt(me),we)},registerDocumentLinkProvider(me,we){return lt.registerDocumentLinkProvider($e,gt(me),we)},registerColorProvider(me,we){return lt.registerColorProvider($e,gt(me),we)},registerFoldingRangeProvider(me,we){return lt.registerFoldingRangeProvider($e,gt(me),we)},registerSelectionRangeProvider(me,we){return lt.registerSelectionRangeProvider($e,me,we)},registerCallHierarchyProvider(me,we){return lt.registerCallHierarchyProvider($e,me,we)},registerTypeHierarchyProvider(me,we){return lt.registerTypeHierarchyProvider($e,me,we)},setLanguageConfiguration:(me,we)=>lt.setLanguageConfiguration($e,me,we),getTokenInformationAtPosition(me,we){return(0,Fe.checkProposedApiEnabled)($e,"tokenInformation"),zt.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return lt.registerInlayHintsProvider($e,me,we)},createLanguageStatusItem(me,we){return zt.createLanguageStatusItem($e,me,we)},registerDocumentDropEditProvider(me,we){return lt.registerDocumentOnDropEditProvider($e,me,we)}},jt={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return Ye.activeTerminal},get terminals(){return Ye.terminals},async showTextDocument(me,we,Ue){const ot=await(y.URI.isUri(me)?Promise.resolve(nn.openTextDocument(me)):Promise.resolve(me));return Dt.showTextDocument(ot,we,Ue)},createTextEditorDecorationType(me){return Dt.createTextEditorDecorationType($e,me)},onDidChangeActiveTextEditor(me,we,Ue){return Dt.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return Dt.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return Dt.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return Dt.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return Dt.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return Dt.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return Ye.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return Ye.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return Ye.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Fe.checkProposedApiEnabled)($e,"terminalDimensions"),Ye.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return Ye.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Fe.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),Ye.onDidWriteTerminalData(me,we,Ue)},get state(){return Ae.state},onDidChangeWindowState(me,we,Ue){return Ae.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return Sn.showMessage($e,P.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return Sn.showMessage($e,P.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return Sn.showMessage($e,P.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return Kt.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return Kt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Kt.showInput(me,we)},showOpenDialog(me){return In.showOpenDialog(me)},showSaveDialog(me){return In.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let ot,yt,Pt;return typeof me=="string"?(ot=me,yt=we,Pt=Ue):(yt=me,Pt=we),ln.createStatusBarEntry($e,ot,yt,Pt)},setStatusBarMessage(me,we){return ln.setStatusBarMessage(me,we)},withScmProgress(me){return Ct.report("window.withScmProgress",$e,"Use 'withProgress' instead."),cn.withProgress($e,{location:z.ProgressLocation.SourceControl},(we,Ue)=>me({report(ot){}}))},withProgress(me,we){return cn.withProgress($e,me,we)},createOutputChannel(me,we){return Ot.createOutputChannel(me,we,$e)},createWebviewPanel(me,we,Ue,ot){return tn.createWebviewPanel($e,me,we,Ue,ot)},createWebviewTextEditorInset(me,we,Ue,ot){return(0,Fe.checkProposedApiEnabled)($e,"editorInsets"),Rn.createWebviewEditorInset(me,we,Ue,ot,$e)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?Ye.createExtensionTerminal(me):Ye.createTerminalFromOptions(me):Ye.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return Ye.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ye.registerProfileProvider($e,me,we)},registerTreeDataProvider(me,we){return on.registerTreeDataProvider(me,we,$e)},createTreeView(me,we){return on.createTreeView(me,we,$e)},registerWebviewPanelSerializer:(me,we)=>tn.registerWebviewPanelSerializer($e,me,we),registerCustomEditorProvider:(me,we,Ue={})=>Ln.registerCustomEditorProvider($e,me,we,Ue),registerFileDecorationProvider(me){return ee.registerFileDecorationProvider(me,$e.identifier)},registerUriHandler(me){return St.registerUriHandler($e.identifier,me)},createQuickPick(){return Kt.createQuickPick($e)},createInputBox(){return Kt.createInputBox($e)},get activeColorTheme(){return Dn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return Dn.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return En.registerWebviewViewProvider($e,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return _t.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return _t.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return _t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return rn.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return rn.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return _t.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Fe.checkProposedApiEnabled)($e,"externalUriOpener"),On.registerExternalUriOpener($e.identifier,me,we,Ue)},get tabGroups(){return Ee.tabGroups}},nn={get rootPath(){return Ct.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>ft.updateWorkspaceFolders($e,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return ft.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>ft.getRelativePath(me,we),findFiles:(me,we,Ue,ot)=>ft.findFiles(me,we,Ue,$e.identifier,ot),findTextInFiles:(me,we,Ue,ot)=>{(0,Fe.checkProposedApiEnabled)($e,"findTextInFiles");let yt,Pt;return typeof we=="object"?(yt=we,Pt=Ue):(yt={},Pt=we,ot=Ue),ft.findTextInFiles(me,yt||{},Pt,$e.identifier,ot)},saveAll:me=>ft.saveAll(me),applyEdit(me,we){return Mn.applyWorkspaceEdit(me,$e,we)},createFileSystemWatcher:(me,we,Ue,ot)=>Ht.createFileSystemWatcher(ft,$e,me,we,Ue,ot),get textDocuments(){return ht.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(y.URI.file(me));else if(y.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=ht.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ot=>ht.ensureDocumentData(ot).then(yt=>yt.document))},onDidOpenTextDocument:(me,we,Ue)=>ht.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>ht.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>ht.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>ht.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>Gt.getOnWillSaveTextDocumentEvent($e)(me,we,Ue),get notebookDocuments(){return _t.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(y.URI.isUri(me))Ue=me,await _t.openNotebookDocument(me);else if(typeof me=="string")Ue=y.URI.revive(await _t.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return xt.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return xt.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,ot){return _t.registerNotebookSerializer($e,me,we,Ue,(0,Fe.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(me,we,Ue)=>kn.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,kn.getConfiguration(me,we,$e)},registerTextDocumentContentProvider(me,we){return Nt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ct.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider($e,me,we)),registerFileSystemProvider(me,we,Ue){return(0,Le.combinedDisposable)(pn.registerFileSystemProvider($e,me,we,Ue),Et.addFileSystemProvider(me,we))},get fs(){return Et.value},registerFileSearchProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"fileSearchProvider"),at.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"textSearchProvider"),at.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Fe.checkProposedApiEnabled)($e,"resolvers"),bn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>Ht.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>Ht.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>Ht.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>Ht.getOnWillCreateFileEvent($e)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>Ht.getOnWillDeleteFileEvent($e)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>Ht.getOnWillRenameFileEvent($e)(me,we,Ue),openTunnel:me=>((0,Fe.checkProposedApiEnabled)($e,"tunnels"),It.openTunnel($e,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Fe.checkProposedApiEnabled)($e,"tunnels"),It.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Fe.checkProposedApiEnabled)($e,"tunnels"),It.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"portsAttributes"),It.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"timeline"),wn.registerTimelineProvider(me,we,$e.identifier,ze.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,Fe.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>ft.onDidGrantWorkspaceTrust(me,we,Ue),registerEditSessionIdentityProvider:(me,we)=>((0,Fe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(me,we))},zn={get inputBox(){return Ct.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox($e)},createSourceControl(me,we,Ue){return an.createSourceControl($e,me,we,Ue)}},Ut={createCommentController(me,we){return vn.createCommentController($e,me,we)}},hn={get activeDebugSession(){return Ve.activeDebugSession},get activeDebugConsole(){return Ve.activeDebugConsole},get breakpoints(){return Ve.breakpoints},onDidStartDebugSession(me,we,Ue){return Ve.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return Ve.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return Ve.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return Ve.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return Ve.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return Ve.registerDebugConfigurationProvider(me,we,Ue||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return Ve.registerDebugAdapterDescriptorFactory($e,me,we)},registerDebugAdapterTrackerFactory(me,we){return Ve.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ve.startDebugging(me,we,{parentSession:Ue}):Ve.startDebugging(me,we,Ue||{})},stopDebugging(me){return Ve.stopDebugging(me)},addBreakpoints(me){return Ve.addBreakpoints(me)},removeBreakpoints(me){return Ve.removeBreakpoints(me)},asDebugSourceUri(me,we){return Ve.asDebugSourceUri(me,we)}},Hn={registerTaskProvider:(me,we)=>mt.registerTaskProvider($e,me,we),fetchTasks:me=>mt.fetchTasks(me),executeTask:me=>mt.executeTask($e,me),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(me,we,Ue)=>mt.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>mt.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>mt.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>mt.onDidEndTaskProcess(me,we,Ue)},$n={createNotebookController(me,we,Ue,ot,yt){return sn.createNotebookController($e,me,we,Ue,ot,(0,Fe.isProposedApiEnabled)($e,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>_t.registerNotebookCellStatusBarItemProvider($e,me,we),createRendererMessaging(me){return gn.createRendererMessaging($e,me)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Fe.checkProposedApiEnabled)($e,"notebookCellExecutionState"),sn.onDidChangeNotebookCellExecutionState(me,we,Ue)}},xn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return bt.getMessage($e.identifier.value,{message:we,args:Ue})}return bt.getMessage($e.identifier.value,me[0])},get bundle(){return bt.getBundle($e.identifier.value)},get uri(){return bt.getBundleUri($e.identifier.value)}};return{version:Ze.version,authentication:un,commands:Un,comments:Ut,debug:hn,env:Tn,extensions:_n,l10n:xn,languages:Wn,notebooks:$n,scm:zn,tasks:Hn,tests:Bn,window:jt,workspace:nn,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:C.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:_.UIKind,Uri:y.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TerminalExitReason:z.TerminalExitReason,LogLevel:Re.LogLevel,EditSessionIdentityMatch:it.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=vt}),define(_e[301],ye([1,0,273,310,311,2,312]),function(Z,e,c,t,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,E,_,w,h,g){const f=g.environment.useHostProxy,b=typeof f=="boolean"?f:!g.remote.isRemote,m=(0,y.createProxyResolver)({resolveProxy:v=>T.resolveProxy(v),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(v,r,...o)=>{switch(v){case y.LogLevel.Trace:w.trace(r,...o);break;case y.LogLevel.Debug:w.debug(r,...o);break;case y.LogLevel.Info:w.info(r,...o);break;case y.LogLevel.Warning:w.warn(r,...o);break;case y.LogLevel.Error:w.error(r,...o);break;case y.LogLevel.Critical:w.error(r,...o);break;case y.LogLevel.Off:break;default:l(v,r,o);break}function l(s,a,...u){w.error("Unknown log level",s),w.error(a,...u)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),d=S(E,m);return A(_,d)}e.connectProxyResolver=k;function S(T,E){const _={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(h=>{_.config=T.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(h=>{w.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"off"},w,!0)),on:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"on"},w,!0)),override:Object.assign({},c,(0,y.createHttpPatch)(c,E,{config:"override"},w,!0)),onRequest:Object.assign({},c,(0,y.createHttpPatch)(c,E,_,w,!0)),default:Object.assign(c,(0,y.createHttpPatch)(c,E,_,w,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"off"},w,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"on"},w,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,E,_,w,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,E,_,w,!1))},tls:Object.assign(I,(0,y.createTlsPatch)(I))}}const C=new Map;function A(T,E){return T.getExtensionPathIndex().then(_=>{const w=Z.__$__nodeRequire("module"),h=w._load;w._load=function(f,b,m){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return h.apply(this,arguments);const d=E[f],v=_.findSubstr(P.URI.file(b.filename));let r=C.get(v);if(r||C.set(v,r={}),!r[f]){const o=d.default;r[f]={...o}}return r[f]}})}}),define(_e[302],ye([1,0,74,300,287,301,41,275,2,14,7,272,113,274]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends I.RequireInterceptor{_installInterceptor(){const f=this,b=Z.__$__nodeRequire("module"),m=b._load;b._load=function(o,l,s){return o=v(o),f._factories.has(o)?f._factories.get(o).load(o,S.URI.file((0,E.realpathSync)(l.filename)),a=>m.apply(this,[a,l,s])):m.apply(this,arguments)};const d=b._resolveLookupPaths;b._resolveLookupPaths=(r,o)=>d.call(this,v(r),o);const v=r=>{for(const o of f._alternatives){const l=o(r);if(l){r=l;break}}return r}}}class h extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(_.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(k.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const d=this._instaService.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=d.ipcHandlePath}await this._instaService.createInstance(w,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}async _loadCommonJSModule(f,b,m){if(b.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let d=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();const v=f?.identifier.value;f&&await this._extHostLocalizationService.initializeLocalizedMessages(f);try{v&&c.mark(`code/extHost/willLoadExtensionCode/${v}`),d=Z.__$__nodeRequire(b.fsPath)}finally{v&&c.mark(`code/extHost/didLoadExtensionCode/${v}`),m.codeLoadingStop()}return d}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const b in f){const m=f[b];m===null?delete process.env[b]:process.env[b]=m}}}e.ExtHostExtensionService=h}),define(_e[143],ye([1,0,44,313,296,17,78,37,9,8,2,31,72,314,294,98]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(p){this.outputChannel=p}provideTextSearchResults(p,D,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((V,x)=>{N.onCancellationRequested(()=>$());const L=o(p,D),U=D.folder.fsPath,F=L.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${g} ${F}
 - cwd: ${U}`);let B=c.spawn(g,L,{cwd:U});B.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),x((0,T.serializeSearchError)(new T.SearchError(de&&de.message,T.SearchErrorCode.rgProcessError)))});let M=!1;const z=new d(D.maxResults,U,D.previewOptions);z.on("result",de=>{M=!0,K="",R.report(de)});let j=!1;const $=()=>{j=!0,B?.kill(),z?.cancel()};let Q=!1;z.on("hitLimit",()=>{Q=!0,$()});let K="";B.stdout.on("data",de=>{z.handleData(de),M||(K+=de)});let ue=!1;B.stdout.once("data",()=>ue=!0);let re="";B.stderr.on("data",de=>{const Y=de.toString();this.outputChannel.appendLine(Y),re.length+Y.length<1e6&&(re+=Y)}),B.on("close",()=>{if(this.outputChannel.appendLine(ue?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),j)V({limitHit:Q});else{z.flush(),B=null;let de;re&&!ue&&(de=b(re))?x((0,T.serializeSearchError)(new T.SearchError(de.message,de.code))):V({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=f;function b(i){const p=i.split(`
`),D=p[0].trim();if(p.some(N=>N.startsWith("regex parse error")))return new T.SearchError(m(p),T.SearchErrorCode.regexParseError);const R=D.match(/grep config error: unknown encoding: (.*)/);if(R)return new T.SearchError(`Unknown encoding: ${R[1]}`,T.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new T.SearchError(D.charAt(0).toUpperCase()+D.substr(1),T.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new T.SearchError(D.charAt(0).toUpperCase()+D.substr(1),T.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(D,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function m(i){const p=["Regex parse error"],D=i.filter(R=>R.startsWith("PCRE2:"));if(D.length>=1){const R=D[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];p.push(":"+N)}}return p.join("")}e.buildRegexParseError=m;class d extends t.EventEmitter{constructor(p,D,R){super(),this.maxResults=p,this.rootFolder=D,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(p,D){return super.on(p,D),this}handleData(p){if(this.isDone)return;const D=typeof p=="string"?p:this.stringDecoder.write(p);this.handleDecodedData(D)}handleDecodedData(p){let D=p.indexOf(`
`);const R=this.remainder+p;if(D>=0)D+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;D>=0;)this.handleLine(R.substring(N,D).trim()),N=D+1,D=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(p){if(this.isDone||!p)return;let D;try{D=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(D.type==="match"){const R=v(D.data.path),N=A.URI.file(S.join(this.rootFolder,R)),V=this.createTextSearchMatch(D.data,N);this.onResult(V),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const R=v(D.data.path),N=A.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(D.data,N).forEach(x=>this.onResult(x))}}createTextSearchMatch(p,D){const R=p.line_number-1,N=v(p.lines),V=Buffer.from(N);let x=0,L=0,U=R;p.submatches.length===0&&p.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(p.submatches.map((B,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=v(B.match),j=V.slice(x,B.start).toString(),$=r(j),Q=$.numLines>0?$.lastLineLength:$.lastLineLength+L,K=r(z),ue=$.numLines+U,re=K.numLines+ue,de=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return x=B.end,L=de,U=re,new E.Range(ue,Q,re,de)}));return(0,h.createTextSearchResult)(D,N,F,this.previewOptions)}createTextSearchContext(p,D){const R=v(p.lines),N=p.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((V,x)=>({text:V,uri:D,lineNumber:N+x}))}onResult(p){this.emit("result",p)}}e.RipgrepParser=d;function v(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function r(i){const p=/\n/g;let D=0,R=-1,N;for(;N=p.exec(i);)D++,R=N.index;const V=R>=0?i.length-R-1:i.length;return{numLines:D,lastLineLength:V}}function o(i,p){const D=["--hidden"];D.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,y.groupBy)(p.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const x=new Set;N.forEach(L=>{x.add(L)}),D.push("-g","!*"),x.forEach(L=>{l(L).map(h.anchorGlob).forEach(U=>{D.push("-g",U)})})}R&&R.length&&R.forEach(x=>{D.push("-g",x)}),p.excludes.map(h.anchorGlob).forEach(x=>D.push("-g",`!${x}`)),p.maxFileSize&&D.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),p.followSymlinks&&D.push("--follow"),p.encoding&&p.encoding!=="utf8"&&D.push("--encoding",p.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,C.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),p.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),i.isRegExp&&(i.pattern=s(i.pattern),D.push("--engine","auto"));let V;if(i.isWordMatch){const L=(0,C.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",L)}else if(i.isRegExp){let x=u(i.pattern);x=n(x),D.push("--regexp",x)}else V=i.pattern,D.push("--fixed-strings");return D.push("--no-config"),p.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),i.isMultiline&&D.push("--multiline"),p.beforeContext&&D.push("--before-context",p.beforeContext+""),p.afterContext&&D.push("--after-context",p.afterContext+""),D.push("--"),V&&D.push(V),D.push("."),D}function l(i){const p=(0,k.splitGlobAware)(i,"/");return p.map((D,R)=>p.slice(0,R+1).join("/"))}e.spreadGlobComponents=l;function s(i){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(p);)i=i.replace(p,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(D);)i=i.replace(D,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=s;const a=i=>i.type==="Assertion"&&i.kind==="lookbehind";function u(i){let p;try{p=new _.RegExpParser().parsePattern(i)}catch{return i}let D="",R=0;const N=(L,U,F)=>{D+=i.slice(R,L)+F,R=U},V=[];return new _.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const U=V[0];if(!U)N(L.start,L.end,"\\r?\\n");else if(!V.some(a))if(U.type==="CharacterClass")if(U.negate){const F=i.slice(U.start+2,L.start)+i.slice(L.end,U.end-1);U.parent?.type==="Quantifier"?N(U.start,U.end,F?`[^${F}]`:"."):N(U.start,U.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=i.slice(U.start+1,L.start)+i.slice(L.end,U.end-1);N(U.start,U.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else U.type==="Quantifier"&&N(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){V.unshift(L)},onQuantifierLeave(){V.shift()},onCharacterClassRangeEnter(L){V.unshift(L)},onCharacterClassRangeLeave(){V.shift()},onCharacterClassEnter(L){V.unshift(L)},onCharacterClassLeave(){V.shift()},onAssertionEnter(L){a(L)&&V.push(L)},onAssertionLeave(L){V[0]===L&&V.shift()}}).visit(p),D+=i.slice(R),D}e.fixRegexNewline=u;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(_e[303],ye([1,0,21,143,124,14]),function(Z,e,c,t,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,A,T,E){const _=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:P.Schemas.file})},h=new I.Progress(g=>T.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.withToken(E,g=>_.provideTextSearchResults(C,w,h,g))}else return this.withToken(E,w=>_.provideTextSearchResults(C,A,T,w))}async withToken(C,A){const T=k(C);this.inProgress.add(T);const E=await A(T.token);return this.inProgress.delete(T),E}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=y;function k(S){const C=new c.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(_e[304],ye([1,0,29,143,142]),function(Z,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(S){this.query=S}search(S,C,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(_){A({message:_})}},E=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(T),c);return new Promise((_,w)=>E.search(h=>{C(h.map(y))},S).then(h=>_({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.TextSearchEngineAdapter=P;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,C)=>{if(C.ranges){const A=C;return S+(Array.isArray(A.ranges)?A.ranges.length:1)}else return S+1},0)}}}),define(_e[305],ye([1,0,17,18,10,4,109,9,51,2,38,31,295,304]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(d="searchProcess"){this.processType=d,this.caches=Object.create(null)}fileSearch(d){let v;const r=f(d),o=new P.Emitter({onDidAddFirstListener:()=>{v=(0,t.createCancelablePromise)(l=>this.doFileSearchWithEngine(E.Engine,r,s=>o.fire(s),l)),v.then(l=>o.fire(l),l=>o.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{v.cancel()}});return o.event}textSearch(d){let v;const r=f(d),o=new P.Emitter({onDidAddFirstListener:()=>{v=(0,t.createCancelablePromise)(l=>this.ripgrepTextSearch(r,s=>o.fire(s),l)),v.then(l=>o.fire(l),l=>o.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{v.cancel()}});return o.event}ripgrepTextSearch(d,v,r){return d.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new _.TextSearchEngineAdapter(d).search(r,v,v)}doFileSearch(d,v,r){return this.doFileSearchWithEngine(E.Engine,d,v,r)}doFileSearchWithEngine(d,v,r,o,l=w.BATCH_SIZE){let s=0;const a=n=>{Array.isArray(n)?(s+=n.length,r(n.map(i=>this.rawMatchToSearchItem(i)))):n.relativePath?(s++,r(this.rawMatchToSearchItem(n))):r(n)};if(v.sortByScore){let n=this.trySortedSearchFromCache(v,a,o);if(!n){const i=v.maxResults?Object.assign({},v,{maxResults:null}):v,p=new d(i);n=this.doSortedSearch(p,v,r,a,o)}return new Promise((i,p)=>{n.then(([D,R])=>{const N=R.map(V=>this.rawMatchToSearchItem(V));this.sendProgress(N,r,l),i(D)},p)})}const u=new d(v);return this.doSearch(u,a,l,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(d){return{path:d.base?(0,k.join)(d.base,d.relativePath):d.relativePath}}doSortedSearch(d,v,r,o,l){const s=new P.Emitter;let a=(0,t.createCancelablePromise)(n=>{let i=[];const p=D=>{Array.isArray(D)?i=D:(o(D),s.fire(D))};return this.doSearch(d,p,-1,n).then(D=>[D,i])}),u;if(v.cacheKey){u=this.getOrCreateCache(v.cacheKey);const n={promise:a,event:s.event,resolved:!1};u.resultsToSearchCache[v.filePattern||""]=n,a.then(()=>{n.resolved=!0},i=>{delete u.resultsToSearchCache[v.filePattern||""]}),a=this.preventCancellation(a)}return a.then(([n,i])=>{const p=u?u.scorerCache:Object.create(null),D=(typeof v.maxResults!="number"||v.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(v,i,p,l).then(R=>{const N=D?D.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:v.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof v.maxResults=="number"&&i.length>v.maxResults},R]})})}getOrCreateCache(d){const v=this.caches[d];return v||(this.caches[d]=new h)}trySortedSearchFromCache(d,v,r){const o=d.cacheKey&&this.caches[d.cacheKey];if(!o)return;const l=this.getResultsFromCache(o,d.filePattern||"",v,r);if(l)return l.then(([s,a,u])=>{const n=S.StopWatch.create(!1);return this.sortResults(d,a,o.scorerCache,r).then(i=>{const p=n.elapsed(),D={fromCache:!0,detailStats:u,type:this.processType,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:s.limitHit||typeof d.maxResults=="number"&&a.length>d.maxResults,stats:D},i]})})}sortResults(d,v,r,o){const l=(0,y.prepareQuery)(d.filePattern||""),s=(u,n)=>(0,y.compareItemsByFuzzyScore)(u,n,l,!0,g,r),a=typeof d.maxResults=="number"?d.maxResults:Number.MAX_VALUE;return c.topAsync(v,s,a,1e4,o)}sendProgress(d,v,r){if(r&&r>0)for(let o=0;o<d.length;o+=r)v(d.slice(o,o+r));else v(d)}getResultsFromCache(d,v,r,o){const l=S.StopWatch.create(!1),s=v.indexOf(k.sep)>=0;let a;for(const p in d.resultsToSearchCache)if(v.startsWith(p)){if(s&&p.indexOf(k.sep)<0&&p!=="")continue;const D=d.resultsToSearchCache[p];a={promise:this.preventCancellation(D.promise),event:D.event,resolved:D.resolved};break}if(!a)return null;const u=l.elapsed(),n=S.StopWatch.create(!1),i=a.event(r);return o&&o.onCancellationRequested(()=>{i.dispose()}),a.promise.then(([p,D])=>{if(o&&o.isCancellationRequested)throw(0,I.canceled)();const R=[],N=(0,y.prepareQuery)(v).normalizedLowercase;for(const V of D)!(0,T.isFilePatternMatch)(V,N)||R.push(V);return[p,R,{cacheWasResolved:a.resolved,cacheLookupTime:u,cacheFilterTime:n.elapsed(),cacheEntryCount:D.length}]})}doSearch(d,v,r,o){return new Promise((l,s)=>{let a=[];o?.onCancellationRequested(()=>d.cancel()),d.search(u=>{u&&(r?(a.push(u),r>0&&a.length>=r&&(v(a),a=[])):v(u))},u=>{v(u)},(u,n)=>{a.length&&v(a),u?s(u):l(n)})})}clearCache(d){return delete this.caches[d],Promise.resolve(void 0)}preventCancellation(d){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(v,r){return d.then(v,r)}catch(v){return this.then(void 0,v)}finally(v){return d.finally(v)}}}}e.SearchService=w,w.BATCH_SIZE=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,k.basename)(m.relativePath)}getItemDescription(m){return(0,k.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(d=>C.URI.revive(d))}}function b(m){return{...m,folder:C.URI.revive(m.folder)}}}),define(_e[306],ye([1,0,6,14,2,29,13,25,16,76,55,31,305,303,98,142]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends C.ExtHostSearch{constructor(b,m,d,v){super(b,d,v),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const r=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new _.RipgrepSearchProvider(r)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new _.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,m){const d=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(b)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(b,m,d,v){const r=(0,C.reviveQuery)(d);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,m,r,v):super.$provideFileSearchResults(b,m,d,v)}doInternalFileSearch(b,m,d,v){const r=o=>{if((0,T.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this._proxy.$handleFileMatch(b,m,o.map(l=>I.URI.file(l.path)));return}o.message&&this._logService.debug("ExtHostSearch",o.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,r,v)}$clearCache(b){return this._internalFileSearchProvider?.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,m){return new h.NativeTextSearchManager(b,m,void 0,"textSearchProvider")}};g=je([He(0,S.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,A.IURITransformerService),He(3,y.ILogService)],g),e.NativeExtHostSearch=g}),define(_e[307],ye([1,0,85,278,290,289,306,302,279,75,41,76,73,40,54,70,277,276,13,291,47]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(A.IExtHostExtensionService,k.ExtHostExtensionService,0),(0,c.registerSingleton)(b.ILoggerService,f.ExtHostLoggerService,1),(0,c.registerSingleton)(h.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,c.registerSingleton)(C.IExtHostDebugService,P.ExtHostDebugService,0),(0,c.registerSingleton)(T.IExtHostSearch,y.NativeExtHostSearch,0),(0,c.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,c.registerSingleton)(_.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(d.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,0)}),define(_e[315],ye([1,0,219,316,74,10,116,117,198,93,288,23,29,113,18,119,214,228,292,307]),function(Z,e,c,t,I,P,y,k,S,C,A,T,E,_,w,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=Z.__$__nodeRequire("module"),u=a._load;a._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const m=process.exit.bind(process);function d(a){process.exit=function(u){if(a)m(u);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let v=function(a){m()};function r(){const a=(0,f.readExtHostConnection)(process.env);if(a.type===3)return new Promise((u,n)=>{const i=p=>{const D=p[0],R=new y.BufferedEmitter;D.on("message",N=>R.fire(T.VSBuffer.wrap(N.data))),D.on("close",()=>{v("renderer closed the MessagePort")}),D.start(),u({onMessage:R.event,send:N=>D.postMessage(N.buffer)})};process?.parentPort.on("message",p=>i(p.ports))});if(a.type===2)return new Promise((u,n)=>{let i=null;const p=setTimeout(()=>{v("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,R=3e5,N=new w.ProcessTimeRunOnceScheduler(()=>v("renderer disconnected for too long (1)"),D),V=new w.ProcessTimeRunOnceScheduler(()=>v("renderer disconnected for too long (2)"),R);process.on("message",(L,U)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const F=T.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let B;if(L.skipWebSocketFrames)B=new k.NodeSocket(U,"extHost-socket");else{const M=T.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));B=new k.WebSocketNodeSocket(new k.NodeSocket(U,"extHost-socket"),L.permessageDeflate,M,!1)}i?(N.cancel(),V.cancel(),i.beginAcceptReconnection(B,F),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(p),i=new y.PersistentProtocol(B,F),i.sendResume(),i.onDidDispose(()=>v("renderer disconnected")),u(i),i.onSocketClose(()=>{N.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(V.isScheduled())return;N.isScheduled()&&V.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const u=a.pipeName;return new Promise((n,i)=>{const p=c.createConnection(u,()=>{p.removeListener("error",i);const D=new y.PersistentProtocol(new k.NodeSocket(p,"extHost-renderer"));D.sendResume(),n(D)});p.once("error",i),p.on("close",()=>{v("renderer closed the socket")})})}}async function o(){const a=await r();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(u=>{(0,C.isMessageOfType)(u,2)?(this._terminating=!0,v("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||a.send(u)}async drain(){if(a.drain)return a.drain()}}}function l(a){return new Promise(u=>{const n=a.onMessage(i=>{n.dispose();const p=JSON.parse(i.toString()),D=p.commit,R=S.default.commit;if(D&&R&&D!==R&&m(55),p.parentPid){let N=0;setInterval(function(){try{process.kill(p.parentPid,0),N=0}catch(x){x&&x.code==="EPERM"?(N++,N>=3&&v(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):v(`parent process ${p.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let V;try{V=Z.__$__nodeRequire("native-watchdog"),V.start(p.parentPid)}catch(x){(0,P.onUnexpectedError)(x)}}a.send((0,C.createMessageOfType)(0)),u({protocol:a,initData:p})});a.send((0,C.createMessageOfType)(1))})}async function s(){const a=[];process.on("unhandledRejection",(N,V)=>{a.push(V),setTimeout(()=>{const x=a.indexOf(V);x>=0&&V.catch(L=>{a.splice(x,1),(0,P.isCancellationError)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),N&&(0,P.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const V=a.indexOf(N);V>=0&&a.splice(V,1)}),process.on("uncaughtException",function(N){(0,P.onUnexpectedError)(N)}),I.mark("code/extHost/willConnectToRenderer");const u=await o();I.mark("code/extHost/didConnectToRenderer");const n=await l(u);I.mark("code/extHost/didWaitForInitData");const{initData:i}=n;d(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,h.boolean)(b.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(V){m(V)}exists(V){return E.Promises.exists(V)}realpath(V){return(0,_.realpath)(V)}};let D=null;i.remote.authority&&b.transformURIs&&(D=(0,g.createURITransformer)(i.remote.authority));const R=new A.ExtensionHostMain(n.protocol,i,p,D);v=N=>R.terminate(N)}s().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef415578d1b1019db585718968a303eeca4b8979/core/vs/workbench/api/node/extensionHostProcess.js.map
