/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(te){for(var e=[],i=0,C=te.length;i<C;i++)e[i]=De[te[i]];return e};define(De[78],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(I,A){const y=Object.create(null);for(const k of I){const O=A(k);let S=y[O];S||(S=y[O]=[]),S.push(k)}return y}e.groupBy=i;function C(I,A){const y=[],k=[];for(const O of I)A.has(O)||y.push(O);for(const O of A)I.has(O)||k.push(O);return{removed:y,added:k}}e.diffSets=C;function w(I,A){const y=[],k=[];for(const[O,S]of I)A.has(O)||y.push(S);for(const[O,S]of A)I.has(O)||k.push(S);return{removed:y,added:k}}e.diffMaps=w;class M{constructor(){this.map=new Map}add(A,y){let k=this.map.get(A);k||(k=new Set,this.map.set(A,k)),k.add(y)}delete(A,y){const k=this.map.get(A);!k||(k.delete(y),k.size===0&&this.map.delete(A))}forEach(A,y){const k=this.map.get(A);!k||k.forEach(y)}}e.SetMap=M}),define(De[58],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(I){return(A,y,k)=>{let O=null,S=null;if(typeof k.value=="function"?(O="value",S=k.value):typeof k.get=="function"&&(O="get",S=k.get),!S)throw new Error("not supported");k[O]=I(S,y)}}function C(I,A,y){let k=null,O=null;if(typeof y.value=="function"?(k="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",O=y.get),!O)throw new Error("not supported");const S=`$memoize$${A}`;y[k]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[S]}}e.memoize=C;function w(I,A,y){return i((k,O)=>{const S=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...E){this[m]||(this[m]=y?y():void 0),clearTimeout(this[S]),A&&(this[m]=A(this[m],...E),E=[this[m]]),this[S]=setTimeout(()=>{k.apply(this,E),this[m]=y?y():void 0},I)}})}e.debounce=w;function M(I,A,y){return i((k,O)=>{const S=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...t){if(this[m]||(this[m]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...t)),this[f])return;const o=this[E]+I;o<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0},o-Date.now()))}})}e.throttle=M}),define(De[79],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(De[106],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var C;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function I(n,s=!1){let a=0;const l=n.length;let u="",d=0,r=16,h=0;function v(F){let R=0,x=0;for(;R<F;){const B=n.charCodeAt(a);if(B>=48&&B<=57)x=x*16+B-48;else if(B>=65&&B<=70)x=x*16+B-65+10;else if(B>=97&&B<=102)x=x*16+B-97+10;else break;a++,R++}return R<F&&(x=-1),x}function P(F){a=F,u="",d=0,r=16,h=0}function L(){const F=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&k(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&k(n.charCodeAt(a)))for(a++;a<n.length&&k(n.charCodeAt(a));)a++;else return h=3,n.substring(F,a);let R=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&k(n.charCodeAt(a))){for(a++;a<n.length&&k(n.charCodeAt(a));)a++;R=a}else h=3;return n.substring(F,R)}function j(){let F="",R=a;for(;;){if(a>=l){F+=n.substring(R,a),h=2;break}const x=n.charCodeAt(a);if(x===34){F+=n.substring(R,a),a++;break}if(x===92){if(F+=n.substring(R,a),a++,a>=l){h=2;break}switch(n.charCodeAt(a++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=v(4);H>=0?F+=String.fromCharCode(H):h=4;break}default:h=5}R=a;continue}if(x>=0&&x<=31)if(y(x)){F+=n.substring(R,a),h=2;break}else h=6;a++}return F}function V(){if(u="",h=0,d=a,a>=l)return d=l,r=17;let F=n.charCodeAt(a);if(A(F)){do a++,u+=String.fromCharCode(F),F=n.charCodeAt(a);while(A(F));return r=15}if(y(F))return a++,u+=String.fromCharCode(F),F===13&&n.charCodeAt(a)===10&&(a++,u+=`
`),r=14;switch(F){case 123:return a++,r=1;case 125:return a++,r=2;case 91:return a++,r=3;case 93:return a++,r=4;case 58:return a++,r=6;case 44:return a++,r=5;case 34:return a++,u=j(),r=10;case 47:{const R=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<l&&!y(n.charCodeAt(a));)a++;return u=n.substring(R,a),r=12}if(n.charCodeAt(a+1)===42){a+=2;const x=l-1;let B=!1;for(;a<x;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,B=!0;break}a++}return B||(a++,h=1),u=n.substring(R,a),r=13}return u+=String.fromCharCode(F),a++,r=16}case 45:if(u+=String.fromCharCode(F),a++,a===l||!k(n.charCodeAt(a)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=L(),r=11;default:for(;a<l&&W(F);)a++,F=n.charCodeAt(a);if(d!==a){switch(u=n.substring(d,a),u){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return u+=String.fromCharCode(F),a++,r=16}}function W(F){if(A(F)||y(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let F;do F=V();while(F>=12&&F<=15);return F}return{setPosition:P,getPosition:()=>a,scan:s?T:V,getToken:()=>r,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>a-d,getTokenError:()=>h}}e.createScanner=I;function A(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function S(n,s){const a=[],l=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(v,P,L,j){d.value=v,d.offset=P,d.length=L,d.type=j,d.colonOffset=void 0,u=d}try{b(n,{onObjectBegin:(v,P)=>{if(s<=v)throw l;u=void 0,r=s>v,a.push("")},onObjectProperty:(v,P,L)=>{if(s<P||(h(v,P,L,"property"),a[a.length-1]=v,s<=P+L))throw l},onObjectEnd:(v,P)=>{if(s<=v)throw l;u=void 0,a.pop()},onArrayBegin:(v,P)=>{if(s<=v)throw l;u=void 0,a.push(0)},onArrayEnd:(v,P)=>{if(s<=v)throw l;u=void 0,a.pop()},onLiteralValue:(v,P,L)=>{if(s<P||(h(v,P,L,D(v)),s<=P+L))throw l},onSeparator:(v,P,L)=>{if(s<=P)throw l;if(v===":"&&u&&u.type==="property")u.colonOffset=P,r=!1,u=void 0;else if(v===","){const j=a[a.length-1];typeof j=="number"?a[a.length-1]=j+1:(r=!0,a[a.length-1]=""),u=void 0}}})}catch(v){if(v!==l)throw v}return{path:a,previousNode:u,isAtPropertyKey:r,matches:v=>{let P=0;for(let L=0;P<v.length&&L<a.length;L++)if(v[P]===a[L]||v[P]==="*")P++;else if(v[P]!=="**")return!1;return P===v.length}}}e.getLocation=S;function m(n,s=[],a=M.DEFAULT){let l=null,u=[];const d=[];function r(v){Array.isArray(u)?u.push(v):l!==null&&(u[l]=v)}return b(n,{onObjectBegin:()=>{const v={};r(v),d.push(u),u=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const v=[];r(v),d.push(u),u=v,l=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:r,onError:(v,P,L)=>{s.push({error:v,offset:P,length:L})}},a),u[0]}e.parse=m;function E(n,s=[],a=M.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(v){l.type==="property"&&(l.length=v-l.offset,l=l.parent)}function d(v){return l.children.push(v),v}b(n,{onObjectBegin:v=>{l=d({type:"object",offset:v,length:-1,parent:l,children:[]})},onObjectProperty:(v,P,L)=>{l=d({type:"property",offset:P,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:v,offset:P,length:L,parent:l})},onObjectEnd:(v,P)=>{l.length=v+P-l.offset,l=l.parent,u(v+P)},onArrayBegin:(v,P)=>{l=d({type:"array",offset:v,length:-1,parent:l,children:[]})},onArrayEnd:(v,P)=>{l.length=v+P-l.offset,l=l.parent,u(v+P)},onLiteralValue:(v,P,L)=>{d({type:D(v),offset:P,length:L,parent:l,value:v}),u(P+L)},onSeparator:(v,P,L)=>{l.type==="property"&&(v===":"?l.colonOffset=P:v===","&&u(P))},onError:(v,P,L)=>{s.push({error:v,offset:P,length:L})}},a);const h=l.children[0];return h&&delete h.parent,h}e.parseTree=E;function f(n,s){if(!n)return;let a=n;for(const l of s)if(typeof l=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const d of a.children)if(Array.isArray(d.children)&&d.children[0].value===l){a=d.children[1],u=!0;break}if(!u)return}else{const u=l;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}e.findNodeAtLocation=f;function t(n){if(!n.parent||!n.parent.children)return[];const s=t(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.getNodePath=t;function o(n){switch(n.type){case"array":return n.children.map(o);case"object":{const s=Object.create(null);for(const a of n.children){const l=a.children[1];l&&(s[a.children[0].value]=o(l))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=o;function c(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.contains=c;function g(n,s,a=!1){if(c(n,s,a)){const l=n.children;if(Array.isArray(l))for(let u=0;u<l.length&&l[u].offset<=s;u++){const d=g(l[u],s,a);if(d)return d}return n}}e.findNodeAtOffset=g;function b(n,s,a=M.DEFAULT){const l=I(n,!1);function u(le){return le?()=>le(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(le){return le?ue=>le(ue,l.getTokenOffset(),l.getTokenLength()):()=>!0}const r=u(s.onObjectBegin),h=d(s.onObjectProperty),v=u(s.onObjectEnd),P=u(s.onArrayBegin),L=u(s.onArrayEnd),j=d(s.onLiteralValue),V=d(s.onSeparator),W=u(s.onComment),T=d(s.onError),F=a&&a.disallowComments,R=a&&a.allowTrailingComma;function x(){for(;;){const le=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(le){case 12:case 13:F?B(10):W();break;case 16:B(1);break;case 15:case 14:break;default:return le}}}function B(le,ue=[],Q=[]){if(T(le),ue.length+Q.length>0){let ge=l.getToken();for(;ge!==17;){if(ue.indexOf(ge)!==-1){x();break}else if(Q.indexOf(ge)!==-1)break;ge=x()}}}function H(le){const ue=l.getTokenValue();return le?j(ue):h(ue),x(),!0}function G(){switch(l.getToken()){case 11:{let le=0;try{le=JSON.parse(l.getTokenValue()),typeof le!="number"&&(B(2),le=0)}catch{B(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return x(),!0}function ee(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(V(":"),x(),me()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function de(){r(),x();let le=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(le||B(4,[],[]),V(","),x(),l.getToken()===2&&R)break}else le&&B(6,[],[]);ee()||B(4,[],[2,5]),le=!0}return v(),l.getToken()!==2?B(7,[2],[]):x(),!0}function ne(){P(),x();let le=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(le||B(4,[],[]),V(","),x(),l.getToken()===4&&R)break}else le&&B(6,[],[]);me()||B(4,[],[4,5]),le=!0}return L(),l.getToken()!==4?B(8,[4],[]):x(),!0}function me(){switch(l.getToken()){case 3:return ne();case 1:return de();case 10:return H(!0);default:return G()}}return x(),l.getToken()===17?a.allowEmptyContent?!0:(B(4,[],[]),!1):me()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=b;function p(n,s){const a=I(n),l=[];let u,d=0,r;do switch(r=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:d!==r&&l.push(n.substring(d,r)),s!==void 0&&l.push(a.getTokenValue().replace(/[^\r\n]/g,s)),d=a.getPosition();break}while(u!==17);return l.join("")}e.stripComments=p;function D(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(De[28],Ie([1,0]),function(te,e){"use strict";var i,C,w;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(f,t,o){let c=f.get(t);return c===void 0&&(c=o,f.set(t,c)),c}e.getOrSet=M;function I(f){const t=[];return f.forEach((o,c)=>{t.push(`${c} => ${o}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=I;function A(f){const t=[];return f.forEach(o=>{t.push(o)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=A;class y{constructor(t,o){this.uri=t,this.value=o}}class k{constructor(t,o){this[i]="ResourceMap",t instanceof k?(this.map=new Map(t.map),this.toKey=o??k.defaultToKey):(this.map=new Map,this.toKey=t??k.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new y(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[c,g]of this.map)t(g.value,g.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=k,k.defaultToKey=f=>f.toString();class O{constructor(t,o){this[C]="ResourceSet",!t||typeof t=="function"?this._map=new k(t):(this._map=new k(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((c,g)=>t.call(o,g,g,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var S;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class m{constructor(){this[w]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const c=this._map.get(t);if(!!c)return o!==0&&this.touch(c,o),c.value}set(t,o,c=0){let g=this._map.get(t);if(g)g.value=o,c!==0&&this.touch(g,c);else{switch(g={key:t,value:o,next:void 0,previous:void 0},c){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(t,g),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const c=this._state;let g=this._head;for(;g;){if(o?t.bind(o)(g.value,g.key,this):t(g.value,g.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const t=this,o=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:c.key,done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return g}values(){const t=this,o=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:c.value,done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return g}entries(){const t=this,o=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const b={value:[c.key,c.value],done:!1};return c=c.next,b}else return{value:void 0,done:!0}}};return g}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,c=this.size;for(;o&&c>t;)this._map.delete(o.key),o=o.next,c--;this._head=o,this._size=c,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,c=t.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const c=t.next,g=t.previous;t===this._tail?(g.next=void 0,this._tail=g):(c.previous=g,g.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const c=t.next,g=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=g,g.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,c)=>{t.push([c,o])}),t}fromJSON(t){this.clear();for(const[o,c]of t)this.set(o,c)}}e.LinkedMap=m;class E extends m{constructor(t,o=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[107],Ie([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Ce,ye){for(var Te=0;Te<ye.length;Te++){var se=ye[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ce,se.key,se)}}function i(Ce,ye,Te){return ye&&e(Ce.prototype,ye),Te&&e(Ce,Te),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function C(Ce,ye){if(!!Ce){if(typeof Ce=="string")return w(Ce,ye);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return w(Ce,ye)}}function w(Ce,ye){(ye==null||ye>Ce.length)&&(ye=Ce.length);for(var Te=0,se=new Array(ye);Te<ye;Te++)se[Te]=Ce[Te];return se}function M(Ce,ye){var Te=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(Te)return(Te=Te.call(Ce)).next.bind(Te);if(Array.isArray(Ce)||(Te=C(Ce))||ye&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var se=0;return function(){return se>=Ce.length?{done:!0}:{done:!1,value:Ce[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=I();function A(Ce){te.defaults=Ce}var y=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ye){return m[ye]};function f(Ce,ye){if(ye){if(y.test(Ce))return Ce.replace(k,E)}else if(O.test(Ce))return Ce.replace(S,E);return Ce}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(t,function(ye,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var c=/(^|[^\[])\^/g;function g(Ce,ye){Ce=typeof Ce=="string"?Ce:Ce.source,ye=ye||"";var Te={replace:function(ae,J){return J=J.source||J,J=J.replace(c,"$1"),Ce=Ce.replace(ae,J),Te},getRegex:function(){return new RegExp(Ce,ye)}};return Te}var b=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Ce,ye,Te){if(Ce){var se;try{se=decodeURIComponent(o(Te)).replace(b,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ye&&!p.test(Te)&&(Te=u(ye,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Ce,ye){n[" "+Ce]||(s.test(Ce)?n[" "+Ce]=Ce+"/":n[" "+Ce]=v(Ce,"/",!0)),Ce=n[" "+Ce];var Te=Ce.indexOf(":")===-1;return ye.substring(0,2)==="//"?Te?ye:Ce.replace(a,"$1")+ye:ye.charAt(0)==="/"?Te?ye:Ce.replace(l,"$1")+ye:Ce+ye}var d={exec:function(){}};function r(Ce){for(var ye=1,Te,se;ye<arguments.length;ye++){Te=arguments[ye];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Ce[se]=Te[se])}return Ce}function h(Ce,ye){var Te=Ce.replace(/\|/g,function(J,_,N){for(var $=!1,q=_;--q>=0&&N[q]==="\\";)$=!$;return $?"|":" |"}),se=Te.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ye)se.splice(ye);else for(;se.length<ye;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function v(Ce,ye,Te){var se=Ce.length;if(se===0)return"";for(var ae=0;ae<se;){var J=Ce.charAt(se-ae-1);if(J===ye&&!Te)ae++;else if(J!==ye&&Te)ae++;else break}return Ce.slice(0,se-ae)}function P(Ce,ye){if(Ce.indexOf(ye[1])===-1)return-1;for(var Te=Ce.length,se=0,ae=0;ae<Te;ae++)if(Ce[ae]==="\\")ae++;else if(Ce[ae]===ye[0])se++;else if(Ce[ae]===ye[1]&&(se--,se<0))return ae;return-1}function L(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Ce,ye){if(ye<1)return"";for(var Te="";ye>1;)ye&1&&(Te+=Ce),ye>>=1,Ce+=Ce;return Te+Ce}function V(Ce,ye,Te,se){var ae=ye.href,J=ye.title?f(ye.title):null,_=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){se.state.inLink=!0;var N={type:"link",raw:Te,href:ae,title:J,text:_,tokens:se.inlineTokens(_)};return se.state.inLink=!1,N}return{type:"image",raw:Te,href:ae,title:J,text:f(_)}}function W(Ce,ye){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return ye;var se=Te[1];return ye.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var _=J[0];return _.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var T=function(){function Ce(Te){this.options=Te||te.defaults}var ye=Ce.prototype;return ye.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ye.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:v(J,`
`)}}},ye.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var J=ae[0],_=W(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:_}}},ye.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var _=v(J,"#");(this.options.pedantic||!_||/ $/.test(_))&&(J=_.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},ye.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},ye.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},ye.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var J,_,N,$,q,Z,ce,we,oe,be,ve,Ue,ze=ae[1].trim(),et=ze.length>1,Ge={type:"list",raw:"",ordered:et,start:et?+ze.slice(0,-1):"",loose:!1,items:[]};ze=et?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=et?ze:"[*+-]");for(var tt=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ue=!1,!(!(ae=tt.exec(se))||this.rules.block.hr.test(se)));){if(J=ae[0],se=se.substring(J.length),we=ae[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?($=2,ve=we.trimLeft()):($=ae[2].search(/[^ ]/),$=$>4?1:$,ve=we.slice($),$+=ae[1].length),Z=!1,!we&&/^ *$/.test(oe)&&(J+=oe+`
`,se=se.substring(oe.length+1),Ue=!0),!Ue)for(var Fe=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:```|~~~)"),Y=new RegExp("^ {0,"+Math.min(3,$-1)+"}#");se&&(be=se.split(`
`,1)[0],we=be,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(we)||Y.test(we)||Fe.test(we)||ht.test(se)));){if(we.search(/[^ ]/)>=$||!we.trim())ve+=`
`+we.slice($);else if(!Z)ve+=`
`+we;else break;!Z&&!we.trim()&&(Z=!0),J+=be+`
`,se=se.substring(be.length+1)}Ge.loose||(ce?Ge.loose=!0:/\n *\n *$/.test(J)&&(ce=!0)),this.options.gfm&&(_=/^\[[ xX]\] /.exec(ve),_&&(N=_[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:J,task:!!_,checked:N,loose:!1,text:ve}),Ge.raw+=J}Ge.items[Ge.items.length-1].raw=J.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var pe=Ge.items.length;for(q=0;q<pe;q++){this.lexer.state.top=!1,Ge.items[q].tokens=this.lexer.blockTokens(Ge.items[q].text,[]);var Ne=Ge.items[q].tokens.filter(function(qe){return qe.type==="space"}),je=Ne.every(function(qe){for(var He=qe.raw.split(""),Ze=0,nt=M(He),lt;!(lt=nt()).done;){var Dt=lt.value;if(Dt===`
`&&(Ze+=1),Ze>1)return!0}return!1});!Ge.loose&&Ne.length&&je&&(Ge.loose=!0,Ge.items[q].loose=!0)}return Ge}},ye.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var _=this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]);J.type="paragraph",J.text=_,J.tokens=this.lexer.inline(_)}return J}},ye.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},ye.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var J={type:"table",header:h(ae[1]).map(function(ce){return{text:ce}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var _=J.align.length,N,$,q,Z;for(N=0;N<_;N++)/^ *-+: *$/.test(J.align[N])?J.align[N]="right":/^ *:-+: *$/.test(J.align[N])?J.align[N]="center":/^ *:-+ *$/.test(J.align[N])?J.align[N]="left":J.align[N]=null;for(_=J.rows.length,N=0;N<_;N++)J.rows[N]=h(J.rows[N],J.header.length).map(function(ce){return{text:ce}});for(_=J.header.length,$=0;$<_;$++)J.header[$].tokens=this.lexer.inline(J.header[$].text);for(_=J.rows.length,$=0;$<_;$++)for(Z=J.rows[$],q=0;q<Z.length;q++)Z[q].tokens=this.lexer.inline(Z[q].text);return J}}},ye.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ye.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},ye.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ye.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:f(ae[1])}},ye.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]):ae[0]}},ye.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var _=v(J.slice(0,-1),"\\");if((J.length-_.length)%2===0)return}else{var N=P(ae[2],"()");if(N>-1){var $=ae[0].indexOf("!")===0?5:4,q=$+ae[1].length+N;ae[2]=ae[2].substring(0,N),ae[0]=ae[0].substring(0,q).trim(),ae[3]=""}}var Z=ae[2],ce="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);we&&(Z=we[1],ce=we[3])}else ce=ae[3]?ae[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(J)?Z=Z.slice(1):Z=Z.slice(1,-1)),V(ae,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ye.reflink=function(se,ae){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var _=(J[2]||J[1]).replace(/\s+/g," ");if(_=ae[_.toLowerCase()],!_||!_.href){var N=J[0].charAt(0);return{type:"text",raw:N,text:N}}return V(J,_,J[0],this.lexer)}},ye.emStrong=function(se,ae,J){J===void 0&&(J="");var _=this.rules.inline.emStrong.lDelim.exec(se);if(!!_&&!(_[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=_[1]||_[2]||"";if(!N||N&&(J===""||this.rules.inline.punctuation.exec(J))){var $=_[0].length-1,q,Z,ce=$,we=0,oe=_[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,ae=ae.slice(-1*se.length+$);(_=oe.exec(ae))!=null;)if(q=_[1]||_[2]||_[3]||_[4]||_[5]||_[6],!!q){if(Z=q.length,_[3]||_[4]){ce+=Z;continue}else if((_[5]||_[6])&&$%3&&!(($+Z)%3)){we+=Z;continue}if(ce-=Z,!(ce>0)){if(Z=Math.min(Z,Z+ce+we),Math.min($,Z)%2){var be=se.slice(1,$+_.index+Z);return{type:"em",raw:se.slice(0,$+_.index+Z+1),text:be,tokens:this.lexer.inlineTokens(be)}}var ve=se.slice(2,$+_.index+Z-1);return{type:"strong",raw:se.slice(0,$+_.index+Z+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var J=ae[2].replace(/\n/g," "),_=/[^ ]/.test(J),N=/^ /.test(J)&&/ $/.test(J);return _&&N&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ae[0],text:J}}},ye.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},ye.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ye.autolink=function(se,ae){var J=this.rules.inline.autolink.exec(se);if(J){var _,N;return J[2]==="@"?(_=f(this.options.mangle?ae(J[1]):J[1]),N="mailto:"+_):(_=f(J[1]),N=_),{type:"link",raw:J[0],text:_,href:N,tokens:[{type:"text",raw:_,text:_}]}}},ye.url=function(se,ae){var J;if(J=this.rules.inline.url.exec(se)){var _,N;if(J[2]==="@")_=f(this.options.mangle?ae(J[0]):J[0]),N="mailto:"+_;else{var $;do $=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while($!==J[0]);_=f(J[0]),J[1]==="www."?N="http://"+_:N=_}return{type:"link",raw:J[0],text:_,href:N,tokens:[{type:"text",raw:_,text:_}]}}},ye.inlineText=function(se,ae){var J=this.rules.inline.text.exec(se);if(J){var _;return this.lexer.state.inRawBlock?_=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:_=f(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:_}}},Ce}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=g(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=g(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=g(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=g(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=g(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=r({},F),F.gfm=r({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=g(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=r({},F.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:g(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=g(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=g(F._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=g(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=g(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=g(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=g(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=g(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=g(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=g(R.reflink).replace("label",R._label).replace("ref",F._label).getRegex(),R.nolink=g(R.nolink).replace("ref",F._label).getRegex(),R.reflinkSearch=g(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=r({},R),R.pedantic=r({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=r({},R.normal,{escape:g(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=g(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=r({},R.gfm,{br:g(R.br).replace("{2,}","*").getRegex(),text:g(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Ce){var ye="",Te,se,ae=Ce.length;for(Te=0;Te<ae;Te++)se=Ce.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),ye+="&#"+se+";";return ye}var H=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||te.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:F.normal,inline:R.normal};this.options.pedantic?(se.block=F.pedantic,se.inline=R.pedantic):this.options.gfm&&(se.block=F.gfm,this.options.breaks?se.inline=R.breaks:se.inline=R.gfm),this.tokenizer.rules=se}Ce.lex=function(se,ae){var J=new Ce(ae);return J.lex(se)},Ce.lexInline=function(se,ae){var J=new Ce(ae);return J.inlineTokens(se)};var ye=Ce.prototype;return ye.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ye.blockTokens=function(se,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ce,we,oe){return we+"    ".repeat(oe.length)});for(var _,N,$,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(_=ce.call({lexer:J},se,ae))?(se=se.substring(_.raw.length),ae.push(_),!0):!1}))){if(_=this.tokenizer.space(se)){se=se.substring(_.raw.length),_.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(_);continue}if(_=this.tokenizer.code(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_);continue}if(_=this.tokenizer.fences(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.heading(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.hr(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.blockquote(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.list(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.html(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.def(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+_.raw,N.text+=`
`+_.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[_.tag]||(this.tokens.links[_.tag]={href:_.href,title:_.title});continue}if(_=this.tokenizer.table(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.lheading(se)){se=se.substring(_.raw.length),ae.push(_);continue}if($=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,we=se.slice(1),oe=void 0;J.options.extensions.startBlock.forEach(function(be){oe=be.call({lexer:this},we),typeof oe=="number"&&oe>=0&&(ce=Math.min(ce,oe))}),ce<1/0&&ce>=0&&($=se.substring(0,ce+1))}(),this.state.top&&(_=this.tokenizer.paragraph($))){N=ae[ae.length-1],q&&N.type==="paragraph"?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_),q=$.length!==se.length,se=se.substring(_.raw.length);continue}if(_=this.tokenizer.text(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=`
`+_.raw,N.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ae.push(_);continue}if(se){var Z="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ae},ye.inline=function(se,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:se,tokens:ae}),ae},ye.inlineTokens=function(se,ae){var J=this;ae===void 0&&(ae=[]);var _,N,$,q=se,Z,ce,we;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)oe.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,Z.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ce||(we=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(_=ve.call({lexer:J},se,ae))?(se=se.substring(_.raw.length),ae.push(_),!0):!1}))){if(_=this.tokenizer.escape(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.tag(se)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&_.type==="text"&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(_=this.tokenizer.link(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(_.raw.length),N=ae[ae.length-1],N&&_.type==="text"&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(_=this.tokenizer.emStrong(se,q,we)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.codespan(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.br(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.del(se)){se=se.substring(_.raw.length),ae.push(_);continue}if(_=this.tokenizer.autolink(se,B)){se=se.substring(_.raw.length),ae.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(se,B))){se=se.substring(_.raw.length),ae.push(_);continue}if($=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ue=se.slice(1),ze=void 0;J.options.extensions.startInline.forEach(function(et){ze=et.call({lexer:this},Ue),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&($=se.substring(0,ve+1))}(),_=this.tokenizer.inlineText($,x)){se=se.substring(_.raw.length),_.raw.slice(-1)!=="_"&&(we=_.raw.slice(-1)),ce=!0,N=ae[ae.length-1],N&&N.type==="text"?(N.raw+=_.raw,N.text+=_.text):ae.push(_);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ae},i(Ce,null,[{key:"rules",get:function(){return{block:F,inline:R}}}]),Ce}(),G=function(){function Ce(Te){this.options=Te||te.defaults}var ye=Ce.prototype;return ye.code=function(se,ae,J){var _=(ae||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(se,_);N!=null&&N!==se&&(J=!0,se=N)}return se=se.replace(/\n$/,"")+`
`,_?'<pre><code class="'+this.options.langPrefix+f(_,!0)+'">'+(J?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:f(se,!0))+`</code></pre>
`},ye.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ye.html=function(se){return se},ye.heading=function(se,ae,J,_){if(this.options.headerIds){var N=this.options.headerPrefix+_.slug(J);return"<h"+ae+' id="'+N+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(se,ae,J){var _=ae?"ol":"ul",N=ae&&J!==1?' start="'+J+'"':"";return"<"+_+N+`>
`+se+"</"+_+`>
`},ye.listitem=function(se){return"<li>"+se+`</li>
`},ye.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(se){return"<p>"+se+`</p>
`},ye.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},ye.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ye.tablecell=function(se,ae){var J=ae.header?"th":"td",_=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return _+se+("</"+J+`>
`)},ye.strong=function(se){return"<strong>"+se+"</strong>"},ye.em=function(se){return"<em>"+se+"</em>"},ye.codespan=function(se){return"<code>"+se+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(se){return"<del>"+se+"</del>"},ye.link=function(se,ae,J){if(se=D(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<a href="'+f(se)+'"';return ae&&(_+=' title="'+ae+'"'),_+=">"+J+"</a>",_},ye.image=function(se,ae,J){if(se=D(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<img src="'+se+'" alt="'+J+'"';return ae&&(_+=' title="'+ae+'"'),_+=this.options.xhtml?"/>":">",_},ye.text=function(se){return se},Ce}(),ee=function(){function Ce(){}var ye=Ce.prototype;return ye.strong=function(se){return se},ye.em=function(se){return se},ye.codespan=function(se){return se},ye.del=function(se){return se},ye.html=function(se){return se},ye.text=function(se){return se},ye.link=function(se,ae,J){return""+J},ye.image=function(se,ae,J){return""+J},ye.br=function(){return""},Ce}(),de=function(){function Ce(){this.seen={}}var ye=Ce.prototype;return ye.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(se,ae){var J=se,_=0;if(this.seen.hasOwnProperty(J)){_=this.seen[se];do _++,J=se+"-"+_;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[se]=_,this.seen[J]=0),J},ye.slug=function(se,ae){ae===void 0&&(ae={});var J=this.serialize(se);return this.getNextSafeSlug(J,ae.dryrun)},Ce}(),ne=function(){function Ce(Te){this.options=Te||te.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new de}Ce.parse=function(se,ae){var J=new Ce(ae);return J.parse(se)},Ce.parseInline=function(se,ae){var J=new Ce(ae);return J.parseInline(se)};var ye=Ce.prototype;return ye.parse=function(se,ae){ae===void 0&&(ae=!0);var J="",_,N,$,q,Z,ce,we,oe,be,ve,Ue,ze,et,Ge,tt,Fe,ht,X,Y,pe=se.length;for(_=0;_<pe;_++){if(ve=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Y=this.options.extensions.renderers[ve.type].call({parser:this},ve),Y!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){J+=Y||"";continue}switch(ve.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(oe="",we="",q=ve.header.length,N=0;N<q;N++)we+=this.renderer.tablecell(this.parseInline(ve.header[N].tokens),{header:!0,align:ve.align[N]});for(oe+=this.renderer.tablerow(we),be="",q=ve.rows.length,N=0;N<q;N++){for(ce=ve.rows[N],we="",Z=ce.length,$=0;$<Z;$++)we+=this.renderer.tablecell(this.parseInline(ce[$].tokens),{header:!1,align:ve.align[$]});be+=this.renderer.tablerow(we)}J+=this.renderer.table(oe,be);continue}case"blockquote":{be=this.parse(ve.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(Ue=ve.ordered,ze=ve.start,et=ve.loose,q=ve.items.length,be="",N=0;N<q;N++)tt=ve.items[N],Fe=tt.checked,ht=tt.task,Ge="",tt.task&&(X=this.renderer.checkbox(Fe),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=X+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=X+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:X}):Ge+=X),Ge+=this.parse(tt.tokens,et),be+=this.renderer.listitem(Ge,ht,Fe);J+=this.renderer.list(be,Ue,ze);continue}case"html":{J+=this.renderer.html(ve.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(be=ve.tokens?this.parseInline(ve.tokens):ve.text;_+1<pe&&se[_+1].type==="text";)ve=se[++_],be+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);J+=ae?this.renderer.paragraph(be):be;continue}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return J},ye.parseInline=function(se,ae){ae=ae||this.renderer;var J="",_,N,$,q=se.length;for(_=0;_<q;_++){if(N=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&($=this.options.extensions.renderers[N.type].call({parser:this},N),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){J+=$||"";continue}switch(N.type){case"escape":{J+=ae.text(N.text);break}case"html":{J+=ae.html(N.text);break}case"link":{J+=ae.link(N.href,N.title,this.parseInline(N.tokens,ae));break}case"image":{J+=ae.image(N.href,N.title,N.text);break}case"strong":{J+=ae.strong(this.parseInline(N.tokens,ae));break}case"em":{J+=ae.em(this.parseInline(N.tokens,ae));break}case"codespan":{J+=ae.codespan(N.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline(N.tokens,ae));break}case"text":{J+=ae.text(N.text);break}default:{var Z='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return J},Ce}();function me(Ce,ye,Te){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ye=="function"&&(Te=ye,ye=null),ye=r({},me.defaults,ye||{}),L(ye),Te){var se=ye.highlight,ae;try{ae=H.lex(Ce,ye)}catch(q){return Te(q)}var J=function(Z){var ce;if(!Z)try{ye.walkTokens&&me.walkTokens(ae,ye.walkTokens),ce=ne.parse(ae,ye)}catch(we){Z=we}return ye.highlight=se,Z?Te(Z):Te(null,ce)};if(!se||se.length<3||(delete ye.highlight,!ae.length))return J();var _=0;me.walkTokens(ae,function(q){q.type==="code"&&(_++,setTimeout(function(){se(q.text,q.lang,function(Z,ce){if(Z)return J(Z);ce!=null&&ce!==q.text&&(q.text=ce,q.escaped=!0),_--,_===0&&J()})},0))}),_===0&&J();return}function N(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+f(q.message+"",!0)+"</pre>";throw q}try{var $=H.lex(Ce,ye);if(ye.walkTokens){if(ye.async)return Promise.all(me.walkTokens($,ye.walkTokens)).then(function(){return ne.parse($,ye)}).catch(N);me.walkTokens($,ye.walkTokens)}return ne.parse($,ye)}catch(q){N(q)}}me.options=me.setOptions=function(Ce){return r(me.defaults,Ce),A(me.defaults),me},me.getDefaults=I,me.defaults=te.defaults,me.use=function(){for(var Ce=arguments.length,ye=new Array(Ce),Te=0;Te<Ce;Te++)ye[Te]=arguments[Te];var se=r.apply(void 0,[{}].concat(ye)),ae=me.defaults.extensions||{renderers:{},childTokens:{}},J;ye.forEach(function(_){if(_.extensions&&(J=!0,_.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var q=ae.renderers?ae.renderers[$.name]:null;q?ae.renderers[$.name]=function(){for(var Z=arguments.length,ce=new Array(Z),we=0;we<Z;we++)ce[we]=arguments[we];var oe=$.renderer.apply(this,ce);return oe===!1&&(oe=q.apply(this,ce)),oe}:ae.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[$.level]?ae[$.level].unshift($.tokenizer):ae[$.level]=[$.tokenizer],$.start&&($.level==="block"?ae.startBlock?ae.startBlock.push($.start):ae.startBlock=[$.start]:$.level==="inline"&&(ae.startInline?ae.startInline.push($.start):ae.startInline=[$.start]))}$.childTokens&&(ae.childTokens[$.name]=$.childTokens)})),_.renderer&&function(){var $=me.defaults.renderer||new G,q=function(we){var oe=$[we];$[we]=function(){for(var be=arguments.length,ve=new Array(be),Ue=0;Ue<be;Ue++)ve[Ue]=arguments[Ue];var ze=_.renderer[we].apply($,ve);return ze===!1&&(ze=oe.apply($,ve)),ze}};for(var Z in _.renderer)q(Z);se.renderer=$}(),_.tokenizer&&function(){var $=me.defaults.tokenizer||new T,q=function(we){var oe=$[we];$[we]=function(){for(var be=arguments.length,ve=new Array(be),Ue=0;Ue<be;Ue++)ve[Ue]=arguments[Ue];var ze=_.tokenizer[we].apply($,ve);return ze===!1&&(ze=oe.apply($,ve)),ze}};for(var Z in _.tokenizer)q(Z);se.tokenizer=$}(),_.walkTokens){var N=me.defaults.walkTokens;se.walkTokens=function($){var q=[];return q.push(_.walkTokens.call(this,$)),N&&(q=q.concat(N.call(this,$))),q}}J&&(se.extensions=ae),me.setOptions(se)})},me.walkTokens=function(Ce,ye){for(var Te=[],se=function(){var N=J.value;switch(Te=Te.concat(ye.call(me,N)),N.type){case"table":{for(var $=M(N.header),q;!(q=$()).done;){var Z=q.value;Te=Te.concat(me.walkTokens(Z.tokens,ye))}for(var ce=M(N.rows),we;!(we=ce()).done;)for(var oe=we.value,be=M(oe),ve;!(ve=be()).done;){var Ue=ve.value;Te=Te.concat(me.walkTokens(Ue.tokens,ye))}break}case"list":{Te=Te.concat(me.walkTokens(N.items,ye));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[N.type]?me.defaults.extensions.childTokens[N.type].forEach(function(ze){Te=Te.concat(me.walkTokens(N[ze],ye))}):N.tokens&&(Te=Te.concat(me.walkTokens(N.tokens,ye)))}},ae=M(Ce),J;!(J=ae()).done;)se();return Te},me.parseInline=function(Ce,ye){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ye=r({},me.defaults,ye||{}),L(ye);try{var Te=H.lexInline(Ce,ye);return ye.walkTokens&&me.walkTokens(Te,ye.walkTokens),ne.parseInline(Te,ye)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},me.Parser=ne,me.parser=ne.parse,me.Renderer=G,me.TextRenderer=ee,me.Lexer=H,me.lexer=H.lex,me.Tokenizer=T,me.Slugger=de,me.parse=me;var le=me.options,ue=me.setOptions,Q=me.use,ge=me.walkTokens,Se=me.parseInline,Oe=me,xe=ne.parse,Qe=H.lex;te.Lexer=H,te.Parser=ne,te.Renderer=G,te.Slugger=de,te.TextRenderer=ee,te.Tokenizer=T,te.getDefaults=I,te.lexer=Qe,te.marked=me,te.options=le,te.parse=Oe,te.parseInline=Se,te.parser=xe,te.setOptions=ue,te.use=Q,te.walkTokens=ge,Object.defineProperty(te,"__esModule",{value:!0})}),define(De[108],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,y,k){return Math.min(Math.max(A,y),k)}e.clamp=i;function C(A,y){return(y+A%y)%y}e.rot=C;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class M{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class I{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const k=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function te(w){const M=[];typeof w=="number"&&M.push("code/timeOrigin",w);function I(y){M.push(y,Date.now())}function A(){const y=[];for(let k=0;k<M.length;k+=2)y.push({name:M[k],startTime:M[k+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const I of performance.getEntriesByType("mark"))M.push({name:I.name,startTime:Math.round(w+I.startTime)});return M}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function i(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=i(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var C in i)(typeof exports=="object"?exports:te)[C]=i[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function i(C){if(e[C])return e[C].exports;var w=e[C]={i:C,l:!1,exports:{}};return te[C].call(w.exports,w,w.exports,i),w.l=!0,w.exports}return i.m=te,i.c=e,i.d=function(C,w,M){i.o(C,w)||Object.defineProperty(C,w,{enumerable:!0,get:M})},i.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},i.t=function(C,w){if(1&w&&(C=i(C)),8&w||4&w&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&w&&typeof C!="string")for(var I in C)i.d(M,I,function(A){return C[A]}.bind(null,I));return M},i.n=function(C){var w=C&&C.__esModule?function(){return C.default}:function(){return C};return i.d(w,"a",w),w},i.o=function(C,w){return Object.prototype.hasOwnProperty.call(C,w)},i.p="",i(i.s=0)}([function(te,e,i){(function(C){var w;e=te.exports=Q,w=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],k=0,O=k++;y[O]="0|[1-9]\\d*";var S=k++;y[S]="[0-9]+";var m=k++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;y[E]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var f=k++;y[f]="("+y[S]+")\\.("+y[S]+")\\.("+y[S]+")";var t=k++;y[t]="(?:"+y[O]+"|"+y[m]+")";var o=k++;y[o]="(?:"+y[S]+"|"+y[m]+")";var c=k++;y[c]="(?:-("+y[t]+"(?:\\."+y[t]+")*))";var g=k++;y[g]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var b=k++;y[b]="[0-9A-Za-z-]+";var p=k++;y[p]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var D=k++,n="v?"+y[E]+y[c]+"?"+y[p]+"?";y[D]="^"+n+"$";var s="[v=\\s]*"+y[f]+y[g]+"?"+y[p]+"?",a=k++;y[a]="^"+s+"$";var l=k++;y[l]="((?:<|>)?=?)";var u=k++;y[u]=y[S]+"|x|X|\\*";var d=k++;y[d]=y[O]+"|x|X|\\*";var r=k++;y[r]="[v=\\s]*("+y[d]+")(?:\\.("+y[d]+")(?:\\.("+y[d]+")(?:"+y[c]+")?"+y[p]+"?)?)?";var h=k++;y[h]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[g]+")?"+y[p]+"?)?)?";var v=k++;y[v]="^"+y[l]+"\\s*"+y[r]+"$";var P=k++;y[P]="^"+y[l]+"\\s*"+y[h]+"$";var L=k++;y[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;y[j]="(?:~>?)";var V=k++;y[V]="(\\s*)"+y[j]+"\\s+",A[V]=new RegExp(y[V],"g");var W=k++;y[W]="^"+y[j]+y[r]+"$";var T=k++;y[T]="^"+y[j]+y[h]+"$";var F=k++;y[F]="(?:\\^)";var R=k++;y[R]="(\\s*)"+y[F]+"\\s+",A[R]=new RegExp(y[R],"g");var x=k++;y[x]="^"+y[F]+y[r]+"$";var B=k++;y[B]="^"+y[F]+y[h]+"$";var H=k++;y[H]="^"+y[l]+"\\s*("+s+")$|^$";var G=k++;y[G]="^"+y[l]+"\\s*("+n+")$|^$";var ee=k++;y[ee]="(\\s*)"+y[l]+"\\s*("+s+"|"+y[r]+")",A[ee]=new RegExp(y[ee],"g");var de=k++;y[de]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var ne=k++;y[ne]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var me=k++;y[me]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)w(le,y[le]),A[le]||(A[le]=new RegExp(y[le]));function ue(oe,be){if(oe instanceof Q)return oe;if(typeof oe!="string"||oe.length>M||!(be?A[a]:A[D]).test(oe))return null;try{return new Q(oe,be)}catch{return null}}function Q(oe,be){if(oe instanceof Q){if(oe.loose===be)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Q))return new Q(oe,be);w("SemVer",oe,be),this.loose=be;var ve=oe.trim().match(be?A[a]:A[D]);if(!ve)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var ze=+Ue;if(ze>=0&&ze<I)return ze}return Ue}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ue,e.valid=function(oe,be){var ve=ue(oe,be);return ve?ve.version:null},e.clean=function(oe,be){var ve=ue(oe.trim().replace(/^[=v]+/,""),be);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(oe){return w("SemVer.compare",this.version,this.loose,oe),oe instanceof Q||(oe=new Q(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},Q.prototype.compareMain=function(oe){return oe instanceof Q||(oe=new Q(oe,this.loose)),Se(this.major,oe.major)||Se(this.minor,oe.minor)||Se(this.patch,oe.patch)},Q.prototype.comparePre=function(oe){if(oe instanceof Q||(oe=new Q(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var be=0;do{var ve=this.prerelease[be],Ue=oe.prerelease[be];if(w("prerelease compare",be,ve,Ue),ve===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ue)return Se(ve,Ue)}while(++be)},Q.prototype.inc=function(oe,be){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,be,ve,Ue){typeof ve=="string"&&(Ue=ve,ve=void 0);try{return new Q(oe,ve).inc(be,Ue).version}catch{return null}},e.diff=function(oe,be){if(Ce(oe,be))return null;var ve=ue(oe),Ue=ue(be);if(ve.prerelease.length||Ue.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return ze},e.compareIdentifiers=Se;var ge=/^[0-9]+$/;function Se(oe,be){var ve=ge.test(oe),Ue=ge.test(be);return ve&&Ue&&(oe=+oe,be=+be),ve&&!Ue?-1:Ue&&!ve?1:oe<be?-1:oe>be?1:0}function Oe(oe,be,ve){return new Q(oe,ve).compare(new Q(be,ve))}function xe(oe,be,ve){return Oe(oe,be,ve)>0}function Qe(oe,be,ve){return Oe(oe,be,ve)<0}function Ce(oe,be,ve){return Oe(oe,be,ve)===0}function ye(oe,be,ve){return Oe(oe,be,ve)!==0}function Te(oe,be,ve){return Oe(oe,be,ve)>=0}function se(oe,be,ve){return Oe(oe,be,ve)<=0}function ae(oe,be,ve,Ue){var ze;switch(be){case"===":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe===ve;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe!==ve;break;case"":case"=":case"==":ze=Ce(oe,ve,Ue);break;case"!=":ze=ye(oe,ve,Ue);break;case">":ze=xe(oe,ve,Ue);break;case">=":ze=Te(oe,ve,Ue);break;case"<":ze=Qe(oe,ve,Ue);break;case"<=":ze=se(oe,ve,Ue);break;default:throw new TypeError("Invalid operator: "+be)}return ze}function J(oe,be){if(oe instanceof J){if(oe.loose===be)return oe;oe=oe.value}if(!(this instanceof J))return new J(oe,be);w("comparator",oe,be),this.loose=be,this.parse(oe),this.semver===_?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(oe,be){return Se(be,oe)},e.major=function(oe,be){return new Q(oe,be).major},e.minor=function(oe,be){return new Q(oe,be).minor},e.patch=function(oe,be){return new Q(oe,be).patch},e.compare=Oe,e.compareLoose=function(oe,be){return Oe(oe,be,!0)},e.rcompare=function(oe,be,ve){return Oe(be,oe,ve)},e.sort=function(oe,be){return oe.sort(function(ve,Ue){return e.compare(ve,Ue,be)})},e.rsort=function(oe,be){return oe.sort(function(ve,Ue){return e.rcompare(ve,Ue,be)})},e.gt=xe,e.lt=Qe,e.eq=Ce,e.neq=ye,e.gte=Te,e.lte=se,e.cmp=ae,e.Comparator=J;var _={};function N(oe,be){if(oe instanceof N)return oe.loose===be?oe:new N(oe.raw,be);if(oe instanceof J)return new N(oe.value,be);if(!(this instanceof N))return new N(oe,be);if(this.loose=be,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function $(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function q(oe,be,ve,Ue,ze,et,Ge,tt,Fe,ht,X,Y,pe){return((be=$(ve)?"":$(Ue)?">="+ve+".0.0":$(ze)?">="+ve+"."+Ue+".0":">="+be)+" "+(tt=$(Fe)?"":$(ht)?"<"+(+Fe+1)+".0.0":$(X)?"<"+Fe+"."+(+ht+1)+".0":Y?"<="+Fe+"."+ht+"."+X+"-"+Y:"<="+tt)).trim()}function Z(oe,be){for(var ve=0;ve<oe.length;ve++)if(!oe[ve].test(be))return!1;if(be.prerelease.length){for(ve=0;ve<oe.length;ve++)if(w(oe[ve].semver),oe[ve].semver!==_&&oe[ve].semver.prerelease.length>0){var Ue=oe[ve].semver;if(Ue.major===be.major&&Ue.minor===be.minor&&Ue.patch===be.patch)return!0}return!1}return!0}function ce(oe,be,ve){try{be=new N(be,ve)}catch{return!1}return be.test(oe)}function we(oe,be,ve,Ue){var ze,et,Ge,tt,Fe;switch(oe=new Q(oe,Ue),be=new N(be,Ue),ve){case">":ze=xe,et=se,Ge=Qe,tt=">",Fe=">=";break;case"<":ze=Qe,et=Te,Ge=xe,tt="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(oe,be,Ue))return!1;for(var ht=0;ht<be.set.length;++ht){var X=be.set[ht],Y=null,pe=null;if(X.forEach(function(Ne){Ne.semver===_&&(Ne=new J(">=0.0.0")),Y=Y||Ne,pe=pe||Ne,ze(Ne.semver,Y.semver,Ue)?Y=Ne:Ge(Ne.semver,pe.semver,Ue)&&(pe=Ne)}),Y.operator===tt||Y.operator===Fe||(!pe.operator||pe.operator===tt)&&et(oe,pe.semver)||pe.operator===Fe&&Ge(oe,pe.semver))return!1}return!0}J.prototype.parse=function(oe){var be=this.loose?A[H]:A[G],ve=oe.match(be);if(!ve)throw new TypeError("Invalid comparator: "+oe);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=_},J.prototype.toString=function(){return this.value},J.prototype.test=function(oe){return w("Comparator.test",oe,this.loose),this.semver===_||(typeof oe=="string"&&(oe=new Q(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},J.prototype.intersects=function(oe,be){if(!(oe instanceof J))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new N(oe.value,be),ce(this.value,ve,be);if(oe.operator==="")return ve=new N(this.value,be),ce(oe.semver,ve,be);var Ue=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),et=this.semver.version===oe.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),tt=ae(this.semver,"<",oe.semver,be)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Fe=ae(this.semver,">",oe.semver,be)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ue||ze||et&&Ge||tt||Fe},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(oe){var be=this.loose;oe=oe.trim(),w("range",oe,be);var ve=be?A[ne]:A[de];oe=oe.replace(ve,q),w("hyphen replace",oe),oe=oe.replace(A[ee],"$1$2$3"),w("comparator trim",oe,A[ee]),oe=(oe=(oe=oe.replace(A[V],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ue=be?A[H]:A[G],ze=oe.split(" ").map(function(et){return function(Ge,tt){return w("comp",Ge),Ge=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Y,pe){w("caret",Y,pe);var Ne=pe?A[B]:A[x];return Y.replace(Ne,function(je,qe,He,Ze,nt){var lt;return w("caret",Y,je,qe,He,Ze,nt),$(qe)?lt="":$(He)?lt=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Ze)?lt=qe==="0"?">="+qe+"."+He+".0 <"+qe+"."+(+He+1)+".0":">="+qe+"."+He+".0 <"+(+qe+1)+".0.0":nt?(w("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),lt=qe==="0"?He==="0"?">="+qe+"."+He+"."+Ze+nt+" <"+qe+"."+He+"."+(+Ze+1):">="+qe+"."+He+"."+Ze+nt+" <"+qe+"."+(+He+1)+".0":">="+qe+"."+He+"."+Ze+nt+" <"+(+qe+1)+".0.0"):(w("no pr"),lt=qe==="0"?He==="0"?">="+qe+"."+He+"."+Ze+" <"+qe+"."+He+"."+(+Ze+1):">="+qe+"."+He+"."+Ze+" <"+qe+"."+(+He+1)+".0":">="+qe+"."+He+"."+Ze+" <"+(+qe+1)+".0.0"),w("caret return",lt),lt})}(X,ht)}).join(" ")}(Ge,tt),w("caret",Ge),Ge=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Y,pe){var Ne=pe?A[T]:A[W];return Y.replace(Ne,function(je,qe,He,Ze,nt){var lt;return w("tilde",Y,je,qe,He,Ze,nt),$(qe)?lt="":$(He)?lt=">="+qe+".0.0 <"+(+qe+1)+".0.0":$(Ze)?lt=">="+qe+"."+He+".0 <"+qe+"."+(+He+1)+".0":nt?(w("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),lt=">="+qe+"."+He+"."+Ze+nt+" <"+qe+"."+(+He+1)+".0"):lt=">="+qe+"."+He+"."+Ze+" <"+qe+"."+(+He+1)+".0",w("tilde return",lt),lt})}(X,ht)}).join(" ")}(Ge,tt),w("tildes",Ge),Ge=function(Fe,ht){return w("replaceXRanges",Fe,ht),Fe.split(/\s+/).map(function(X){return function(Y,pe){Y=Y.trim();var Ne=pe?A[P]:A[v];return Y.replace(Ne,function(je,qe,He,Ze,nt,lt){w("xRange",Y,je,qe,He,Ze,nt,lt);var Dt=$(He),rt=Dt||$(Ze),it=rt||$(nt);return qe==="="&&it&&(qe=""),Dt?je=qe===">"||qe==="<"?"<0.0.0":"*":qe&&it?(rt&&(Ze=0),it&&(nt=0),qe===">"?(qe=">=",rt?(He=+He+1,Ze=0,nt=0):it&&(Ze=+Ze+1,nt=0)):qe==="<="&&(qe="<",rt?He=+He+1:Ze=+Ze+1),je=qe+He+"."+Ze+"."+nt):rt?je=">="+He+".0.0 <"+(+He+1)+".0.0":it&&(je=">="+He+"."+Ze+".0 <"+He+"."+(+Ze+1)+".0"),w("xRange return",je),je})}(X,ht)}).join(" ")}(Ge,tt),w("xrange",Ge),Ge=function(Fe,ht){return w("replaceStars",Fe,ht),Fe.trim().replace(A[me],"")}(Ge,tt),w("stars",Ge),Ge}(et,be)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(et){return!!et.match(Ue)})),ze=ze.map(function(et){return new J(et,be)})},N.prototype.intersects=function(oe,be){if(!(oe instanceof N))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ue){return oe.set.some(function(ze){return ze.every(function(et){return Ue.intersects(et,be)})})})})},e.toComparators=function(oe,be){return new N(oe,be).set.map(function(ve){return ve.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},N.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new Q(oe,this.loose));for(var be=0;be<this.set.length;be++)if(Z(this.set[be],oe))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(oe,be,ve){var Ue=null,ze=null;try{var et=new N(be,ve)}catch{return null}return oe.forEach(function(Ge){et.test(Ge)&&(Ue&&ze.compare(Ge)!==-1||(ze=new Q(Ue=Ge,ve)))}),Ue},e.minSatisfying=function(oe,be,ve){var Ue=null,ze=null;try{var et=new N(be,ve)}catch{return null}return oe.forEach(function(Ge){et.test(Ge)&&(Ue&&ze.compare(Ge)!==1||(ze=new Q(Ue=Ge,ve)))}),Ue},e.validRange=function(oe,be){try{return new N(oe,be).range||"*"}catch{return null}},e.ltr=function(oe,be,ve){return we(oe,be,"<",ve)},e.gtr=function(oe,be,ve){return we(oe,be,">",ve)},e.outside=we,e.prerelease=function(oe,be){var ve=ue(oe,be);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(oe,be,ve){return oe=new N(oe,ve),be=new N(be,ve),oe.intersects(be)},e.coerce=function(oe){if(oe instanceof Q)return oe;if(typeof oe!="string")return null;var be=oe.match(A[L]);return be==null?null:ue((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,i(1))},function(te,e){var i,C,w=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(o){if(i===setTimeout)return setTimeout(o,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var y,k=[],O=!1,S=-1;function m(){O&&y&&(O=!1,y.length?k=y.concat(k):S=-1,k.length&&E())}function E(){if(!O){var o=A(m);O=!0;for(var c=k.length;c;){for(y=k,k=[];++S<c;)y&&y[S].run();S=-1,c=k.length}y=null,O=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(o)}}function f(o,c){this.fun=o,this.array=c}function t(){}w.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)c[g-1]=arguments[g];k.push(new f(o,c)),k.length!==1||O||A(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=t,w.addListener=t,w.once=t,w.off=t,w.removeListener=t,w.removeAllListeners=t,w.emit=t,w.prependListener=t,w.prependOnceListener=t,w.listeners=function(o){return[]},w.binding=function(o){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(o){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(De[109],Ie([1,0,12,7]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(p){const D=p;return D?typeof D.read=="function":!1}e.isReadable=w;function M(p){const D=p;return D?[D.on,D.pause,D.resume,D.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=M;function I(p){const D=p;return D?M(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(p,D){return new y(p,D)}e.newWriteableStream=A;class y{constructor(D,n){this.reducer=D,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D<"u"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(n=>n(D))}emitError(D){this.listeners.error.length===0?(0,i.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(n=>n(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,n){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(D,n){if(this.state.destroyed)return;let s;switch(D){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(p,D){const n=[];let s;for(;(s=p.read())!==null;)n.push(s);return D(n)}e.consumeReadable=k;function O(p,D,n){const s=[];let a;for(;(a=p.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?D(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const l=a;return a=void 0,l}return p.read()}}}e.peekReadable=O;function S(p,D){return new Promise((n,s)=>{const a=[];m(p,{onData:l=>{D&&a.push(l)},onError:l=>{D?s(l):n(void 0)},onEnd:()=>{n(D?D(a):void 0)}})})}e.consumeStream=S;function m(p,D){let n=!1;return p.on("error",s=>{n||D.onError(s)}),p.on("end",()=>{n||D.onEnd()}),p.on("data",s=>{n||D.onData(s)}),(0,C.toDisposable)(()=>n=!0)}e.listenStream=m;function E(p,D){return new Promise((n,s)=>{const a=new C.DisposableStore,l=[],u=h=>{if(l.push(h),l.length>D)return a.dispose(),p.pause(),n({stream:p,buffer:l,ended:!1})},d=h=>s(h),r=()=>n({stream:p,buffer:l,ended:!0});a.add((0,C.toDisposable)(()=>p.removeListener("error",d))),p.on("error",d),a.add((0,C.toDisposable)(()=>p.removeListener("end",r))),p.on("end",r),a.add((0,C.toDisposable)(()=>p.removeListener("data",u))),p.on("data",u)})}e.peekStream=E;function f(p,D){const n=A(D);return n.end(p),n}e.toStream=f;function t(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=t;function o(p){let D=!1;return{read:()=>D?null:(D=!0,p)}}e.toReadable=o;function c(p,D,n){const s=A(n);return m(p,{onData:a=>s.write(D.data(a)),onError:a=>s.error(D.error?D.error(a):a),onEnd:()=>s.end()}),s}e.transform=c;function g(p,D,n){let s=!1;return{read:()=>{const a=D.read();return s?a:(s=!0,a!==null?n([p,a]):p)}}}e.prefixedReadable=g;function b(p,D,n){let s=!1;const a=A(n);return m(D,{onData:l=>s?a.write(l):(s=!0,a.write(n([p,l]))),onError:l=>a.error(l),onEnd:()=>{s||(s=!0,a.write(p)),a.end()}}),a}e.prefixedStream=b}),define(De[24],Ie([1,0,109]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let w,M;class I{static alloc(h){return C?new I(Buffer.allocUnsafe(h)):new I(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new I(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(h)):(w||(w=new TextEncoder),new I(w.encode(h)))}static fromByteArray(h){const v=I.alloc(h.length);for(let P=0,L=h.length;P<L;P++)v.buffer[P]=h[P];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let j=0,V=h.length;j<V;j++)v+=h[j].byteLength}const P=I.alloc(v);let L=0;for(let j=0,V=h.length;j<V;j++){const W=h[j];P.set(W,L),L+=W.byteLength}return P}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=I.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,v){return new I(this.buffer.subarray(h,v))}set(h,v){if(h instanceof I)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,v){O(this.buffer,h,v)}readUInt32LE(h){return S(this.buffer,h)}writeUInt32LE(h,v){m(this.buffer,h,v)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,v){f(this.buffer,h,v)}}e.VSBuffer=I;function A(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=A;function y(r,h,v){r[v+0]=h&255,h=h>>>8,r[v+1]=h&255}e.writeUInt16LE=y;function k(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=k;function O(r,h,v){r[v+3]=h,h=h>>>8,r[v+2]=h,h=h>>>8,r[v+1]=h,h=h>>>8,r[v]=h}e.writeUInt32BE=O;function S(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=S;function m(r,h,v){r[v+0]=h&255,h=h>>>8,r[v+1]=h&255,h=h>>>8,r[v+2]=h&255,h=h>>>8,r[v+3]=h&255}e.writeUInt32LE=m;function E(r,h){return r[h]}e.readUInt8=E;function f(r,h,v){r[v]=h}e.writeUInt8=f;function t(r){return i.consumeReadable(r,h=>I.concat(h))}e.readableToBuffer=t;function o(r){return i.toReadable(r)}e.bufferToReadable=o;function c(r){return i.consumeStream(r,h=>I.concat(h))}e.streamToBuffer=c;async function g(r){return r.ended?I.concat(r.buffer):I.concat([...r.buffer,await c(r.stream)])}e.bufferedStreamToBuffer=g;function b(r){return i.toStream(r,h=>I.concat(h))}e.bufferToStream=b;function p(r){return i.transform(r,{data:h=>typeof h=="string"?I.fromString(h):I.wrap(h)},h=>I.concat(h))}e.streamToBufferReadableStream=p;function D(r){return i.newWriteableStream(h=>I.concat(h),r)}e.newWriteableBufferStream=D;function n(r,h){return i.prefixedReadable(r,h,v=>I.concat(v))}e.prefixedBufferReadable=n;function s(r,h){return i.prefixedStream(r,h,v=>I.concat(v))}e.prefixedBufferStream=s;function a(r){let h=0,v=0,P=0;const L=new Uint8Array(Math.floor(r.length/4*3)),j=W=>{switch(v){case 3:L[P++]=h|W,v=0;break;case 2:L[P++]=h|W>>>2,h=W<<6,v=3;break;case 1:L[P++]=h|W>>>4,h=W<<4,v=2;break;default:h=W<<2,v=1}};for(let W=0;W<r.length;W++){const T=r.charCodeAt(W);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${r[W]}`)}}const V=P;for(;v>0;)j(0);return I.wrap(L).slice(0,V)}e.decodeBase64=a;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:r},h=!0,v=!1){const P=v?u:l;let L="";const j=r.byteLength%3;let V=0;for(;V<r.byteLength-j;V+=3){const W=r[V+0],T=r[V+1],F=r[V+2];L+=P[W>>>2],L+=P[(W<<4|T>>>4)&63],L+=P[(T<<2|F>>>6)&63],L+=P[F&63]}if(j===1){const W=r[V+0];L+=P[W>>>2],L+=P[W<<4&63],h&&(L+="==")}else if(j===2){const W=r[V+0],T=r[V+1];L+=P[W>>>2],L+=P[(W<<4|T>>>4)&63],L+=P[T<<2&63],h&&(L+="=")}return L}e.encodeBase64=d}),define(De[34],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(w){return i.test(w)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){w(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,k="";return k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k}}()}),define(De[110],Ie([1,0,16,34]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function w(A){return{id:(0,C.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=w;function M(A,y,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=M;class I{constructor(){this._entries=new Map}get size(){return this._entries.size}has(y){return this._entries.has(this.toKey(y))}get(y){return this._entries.get(this.toKey(y))?.[0]}append(y,k){const O=this._entries.get(y);O?O.push(k):this._entries.set(this.toKey(y),[k])}replace(y,k){this._entries.set(this.toKey(y),[k])}delete(y){this._entries.delete(this.toKey(y))}*entries(){for(const[y,k]of this._entries.entries())for(const O of k)yield[y,O]}values(){return Array.from(this._entries.values()).flat()}forEach(y){for(const[k,O]of this.entries())y(O,k)}toKey(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,i.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(De[111],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[112],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class C{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,k=A.notIn.length;y<k;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(k);return this.isOK(O)}_findNeutralCharacterInRange(A,y){for(let k=A;k<=y;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=w;function M(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(De[113],Ie([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(De[114],Ie([1,0,113]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,w=C*60,M=w*24,I=M*7,A=M*30,y=M*365;function k(S,m,E){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,i.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<C?(t=f,m?t===1?E?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):E?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?E?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):E?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<w?(t=Math.floor(f/C),m?t===1?E?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):E?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?E?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):E?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<M?(t=Math.floor(f/w),m?t===1?E?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):E?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?E?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):E?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<I?(t=Math.floor(f/M),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<A?(t=Math.floor(f/I),m?t===1?E?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):E?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?E?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):E?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<y?(t=Math.floor(f/A),m?t===1?E?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):E?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?E?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):E?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/y),m?t===1?E?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):E?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?E?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):E?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function O(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[115],Ie([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,16,9,115]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,m){return m&&(S.stack||S.stacktrace)?w.localize(0,null,A(S),I(S.stack)||I(S.stacktrace)):A(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function A(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?w.localize(1,null,S.message):S.message||w.localize(2,null)}function y(S=null,m=!1){if(!S)return w.localize(3,null);if(Array.isArray(S)){const E=i.coalesce(S),f=y(E[0],m);return E.length>1?w.localize(4,null,f,E.length):f}if(C.isString(S))return S;if(S.detail){const E=S.detail;if(E.error)return M(E.error,m);if(E.exception)return M(E.exception,m)}return S.stack?M(S,m):S.message?S.message:w.localize(5,null)}e.toErrorMessage=y;function k(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(S,m){let E;return typeof S=="string"?E=new Error(S):E=S,E.actions=m,E}e.createErrorWithActions=O}),define(De[59],Ie([1,0,19]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const S=(0,i.extname)(O),m=C[S.toLowerCase()];return m!==void 0?m:I(O)}e.getMediaOrTextMime=M;function I(O){const S=(0,i.extname)(O);return w[S.toLowerCase()]}e.getMediaMime=I;function A(O){for(const S in w)if(w[S]===O)return S}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function k(O,S){const m=y.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:O}e.normalizeMimeType=k}),define(De[116],Ie([1,0,4,7]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const w=I=>({onDidChange:i.Event.None,value:I});e.staticObservableValue=w;class M extends C.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new i.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=M}),define(De[39],Ie([1,0,19,21,10,9]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(u){return u===47||u===92}e.isPathSeparator=I;function A(u){return u.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function y(u){return u.indexOf("/")===-1&&(u=A(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=y;function k(u,d=i.posix.sep){if(!u)return"";const r=u.length,h=u.charCodeAt(0);if(I(h)){if(I(u.charCodeAt(1))&&!I(u.charCodeAt(2))){let P=3;const L=P;for(;P<r&&!I(u.charCodeAt(P));P++);if(L!==P&&!I(u.charCodeAt(P+1))){for(P+=1;P<r;P++)if(I(u.charCodeAt(P)))return u.slice(0,P+1).replace(/[\\/]/g,d)}}return d}else if(c(h)&&u.charCodeAt(1)===58)return I(u.charCodeAt(2))?u.slice(0,2)+d:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<r;v++)if(I(u.charCodeAt(v)))return u.slice(0,v+1)}return""}e.getRoot=k;function O(u){if(!C.isWindows||!u||u.length<5)return!1;let d=u.charCodeAt(0);if(d!==92||(d=u.charCodeAt(1),d!==92))return!1;let r=2;const h=r;for(;r<u.length&&(d=u.charCodeAt(r),d!==92);r++);return!(h===r||(d=u.charCodeAt(r+1),isNaN(d)||d===92))}e.isUNC=O;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(u,d=C.isWindows){const r=d?S:m;return!(!u||u.length===0||/^\s+$/.test(u)||(r.lastIndex=0,r.test(u))||d&&E.test(u)||u==="."||u===".."||d&&u[u.length-1]==="."||d&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=f;function t(u,d,r){const h=u===d;return!r||h?h:!u||!d?!1:(0,w.equalsIgnoreCase)(u,d)}e.isEqual=t;function o(u,d,r,h=i.sep){if(u===d)return!0;if(!u||!d||d.length>u.length)return!1;if(r){if(!(0,w.startsWithIgnoreCase)(u,d))return!1;if(d.length===u.length)return!0;let P=d.length;return d.charAt(d.length-1)===h&&P--,u.charAt(P)===h}return d.charAt(d.length-1)!==h&&(d+=h),u.indexOf(d)===0}e.isEqualOrParent=o;function c(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=c;function g(u,d){return C.isWindows&&u.endsWith(":")&&(u+=i.sep),(0,i.isAbsolute)(u)||(u=(0,i.join)(d,u)),u=(0,i.normalize)(u),C.isWindows?(u=(0,w.rtrim)(u,i.sep),u.endsWith(":")&&(u+=i.sep)):(u=(0,w.rtrim)(u,i.sep),u||(u=i.sep)),u}e.sanitizeFilePath=g;function b(u){const d=(0,i.normalize)(u);return C.isWindows?u.length>3?!1:p(d)&&(u.length===2||d.charCodeAt(2)===92):d===i.posix.sep}e.isRootOrDriveLetter=b;function p(u,d=C.isWindows){return d?c(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function D(u){return p(u)?u[0]:void 0}e.getDriveLetter=D;function n(u,d,r){return d.length>u.length?-1:u===d?0:(r&&(u=u.toLowerCase(),d=d.toLowerCase()),u.indexOf(d))}e.indexOfPath=n;function s(u){const d=u.split(":");let r,h,v;for(const P of d){const L=Number(P);(0,M.isNumber)(L)?h===void 0?h=L:v===void 0&&(v=L):r=r?[r,P].join(":"):P}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(u,d,r=8){let h="";for(let P=0;P<r;P++)h+=a.charAt(Math.floor(Math.random()*a.length));let v;return d?v=`${d}-${h}`:v=h,u?(0,i.join)(u,v):v}e.randomPath=l}),define(De[117],Ie([1,0,28,10]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...J){return function(_,N){for(let $=0,q=J.length;$<q;$++){const Z=J[$](_,N);if(Z)return Z}return null}}e.or=w,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,_,N){if(!N||N.length<_.length)return null;let $;return J?$=C.startsWithIgnoreCase(N,_):$=N.indexOf(_)===0,$?_.length>0?[{start:0,end:_.length}]:[]:null}function I(J,_){const N=_.toLowerCase().indexOf(J.toLowerCase());return N===-1?null:[{start:N,end:N+J.length}]}e.matchesContiguousSubString=I;function A(J,_){return y(J.toLowerCase(),_.toLowerCase(),0,0)}e.matchesSubString=A;function y(J,_,N,$){if(N===J.length)return[];if($===_.length)return null;if(J[N]===_[$]){let q=null;return(q=y(J,_,N+1,$+1))?c({start:$,end:$+1},q):null}return y(J,_,N,$+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function S(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>E.add(J.charCodeAt(0)));function f(J){return m(J)||E.has(J)}function t(J,_){return J===_||f(J)&&f(_)}function o(J){return k(J)||O(J)||S(J)}function c(J,_){return _.length===0?_=[J]:J.end===_[0].start?_[0].start=J.start:_.unshift(J),_}function g(J,_){for(let N=_;N<J.length;N++){const $=J.charCodeAt(N);if(O($)||S($)||N>0&&!o(J.charCodeAt(N-1)))return N}return J.length}function b(J,_,N,$){if(N===J.length)return[];if($===_.length)return null;if(J[N]!==_[$].toLowerCase())return null;{let q=null,Z=$+1;for(q=b(J,_,N+1,$+1);!q&&(Z=g(_,Z))<_.length;)q=b(J,_,N+1,Z),Z++;return q===null?null:c({start:$,end:$+1},q)}}function p(J){let _=0,N=0,$=0,q=0,Z=0;for(let ve=0;ve<J.length;ve++)Z=J.charCodeAt(ve),O(Z)&&_++,k(Z)&&N++,o(Z)&&$++,S(Z)&&q++;const ce=_/J.length,we=N/J.length,oe=$/J.length,be=q/J.length;return{upperPercent:ce,lowerPercent:we,alphaPercent:oe,numericPercent:be}}function D(J){const{upperPercent:_,lowerPercent:N}=J;return N===0&&_>.6}function n(J){const{upperPercent:_,lowerPercent:N,alphaPercent:$,numericPercent:q}=J;return N>.2&&_<.8&&$>.6&&q<.2}function s(J){let _=0,N=0,$=0,q=0;for(let Z=0;Z<J.length;Z++)$=J.charCodeAt(Z),O($)&&_++,k($)&&N++,m($)&&q++;return(_===0||N===0)&&q===0?J.length<=30:_<=5}function a(J,_){if(!_||(_=_.trim(),_.length===0)||!s(J)||_.length>60)return null;const N=p(_);if(!n(N)){if(!D(N))return null;_=_.toLowerCase()}let $=null,q=0;for(J=J.toLowerCase();q<_.length&&($=b(J,_,0,q))===null;)q=g(_,q+1);return $}e.matchesCamelCase=a;function l(J,_,N=!1){if(!_||_.length===0)return null;let $=null,q=0;for(J=J.toLowerCase(),_=_.toLowerCase();q<_.length&&($=u(J,_,0,q,N))===null;)q=d(_,q+1);return $}e.matchesWords=l;function u(J,_,N,$,q){if(N===J.length)return[];if($===_.length)return null;if(t(J.charCodeAt(N),_.charCodeAt($))){let Z=null,ce=$+1;if(Z=u(J,_,N+1,$+1,q),!q)for(;!Z&&(ce=d(_,ce))<_.length;)Z=u(J,_,N+1,ce,q),ce++;return Z?J.charCodeAt(N)!==_.charCodeAt($)?Z:c({start:$,end:$+1},Z):null}else return null}function d(J,_){for(let N=_;N<J.length;N++)if(f(J.charCodeAt(N))||N>0&&f(J.charCodeAt(N-1)))return N;return J.length}const r=w(e.matchesPrefix,a,I),h=w(e.matchesPrefix,a,A),v=new i.LRUCache(1e4);function P(J,_,N=!1){if(typeof J!="string"||typeof _!="string")return null;let $=v.get(J);$||($=new RegExp(C.convertSimple2RegExpPattern(J),"i"),v.set(J,$));const q=$.exec(_);return q?[{start:q.index,end:q.index+q[0].length}]:N?h(J,_):r(J,_)}e.matchesFuzzy=P;function L(J,_){const N=xe(J,J.toLowerCase(),0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?V(N):null}e.matchesFuzzy2=L;function j(J,_,N,$,q,Z){const ce=Math.min(13,J.length);for(;N<ce;N++){const we=xe(J,_,N,$,q,Z,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,Z]}e.anyScore=j;function V(J){if(typeof J>"u")return[];const _=[],N=J[1];for(let $=J.length-1;$>1;$--){const q=J[$]+N,Z=_[_.length-1];Z&&Z.end===q?Z.end=q+1:_.push({start:q,end:q+1})}return _}e.createMatches=V;const W=128;function T(){const J=[],_=[];for(let N=0;N<=W;N++)_[N]=0;for(let N=0;N<=W;N++)J.push(_.slice(0));return J}function F(J){const _=[];for(let N=0;N<=J;N++)_[N]=0;return _}const R=F(2*W),x=F(2*W),B=T(),H=T(),G=T(),ee=!1;function de(J,_,N,$,q){function Z(we,oe,be=" "){for(;we.length<oe;)we=be+we;return we}let ce=` |   |${$.split("").map(we=>Z(we,3)).join("|")}
`;for(let we=0;we<=N;we++)we===0?ce+=" |":ce+=`${_[we-1]}|`,ce+=J[we].slice(0,q+1).map(oe=>Z(oe.toString(),3)).join("|")+`
`;return ce}function ne(J,_,N,$){J=J.substr(_),N=N.substr($),console.log(de(H,J,J.length,N,N.length)),console.log(de(G,J,J.length,N,N.length)),console.log(de(B,J,J.length,N,N.length))}function me(J,_){if(_<0||_>=J.length)return!1;const N=J.codePointAt(_);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(N)}}function le(J,_){if(_<0||_>=J.length)return!1;switch(J.charCodeAt(_)){case 32:case 9:return!0;default:return!1}}function ue(J,_,N){return _[J]!==N[J]}function Q(J,_,N,$,q,Z,ce=!1){for(;_<N&&q<Z;)J[_]===$[q]&&(ce&&(R[_]=q),_+=1),q+=1;return _===N}e.isPatternInWord=Q;var ge;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Se;(function(J){J.Default=[-100,0];function _(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}J.isDefault=_})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Oe{constructor(_,N){this.firstMatchCanBeWeak=_,this.boostFullMatch=N}}e.FuzzyScoreOptions=Oe,Oe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function xe(J,_,N,$,q,Z,ce=Oe.default){const we=J.length>W?W:J.length,oe=$.length>W?W:$.length;if(N>=we||Z>=oe||we-N>oe-Z||!Q(_,N,we,q,Z,oe,!0))return;Qe(we,oe,N,Z,_,q);let be=1,ve=1,Ue=N,ze=Z;const et=[!1];for(be=1,Ue=N;Ue<we;be++,Ue++){const X=R[Ue],Y=x[Ue],pe=Ue+1<we?x[Ue+1]:oe;for(ve=X-Z+1,ze=X;ze<pe;ve++,ze++){let Ne=Number.MIN_SAFE_INTEGER,je=!1;ze<=Y&&(Ne=Ce(J,_,Ue,N,$,q,ze,oe,Z,B[be-1][ve-1]===0,et));let qe=0;Ne!==Number.MAX_SAFE_INTEGER&&(je=!0,qe=Ne+H[be-1][ve-1]);const He=ze>X,Ze=He?H[be][ve-1]+(B[be][ve-1]>0?-5:0):0,nt=ze>X+1&&B[be][ve-1]>0,lt=nt?H[be][ve-2]+(B[be][ve-2]>0?-5:0):0;if(nt&&(!He||lt>=Ze)&&(!je||lt>=qe))H[be][ve]=lt,G[be][ve]=3,B[be][ve]=0;else if(He&&(!je||Ze>=qe))H[be][ve]=Ze,G[be][ve]=2,B[be][ve]=0;else if(je)H[be][ve]=qe,G[be][ve]=1,B[be][ve]=B[be-1][ve-1]+1;else throw new Error("not possible")}}if(ee&&ne(J,N,$,Z),!et[0]&&!ce.firstMatchCanBeWeak)return;be--,ve--;const Ge=[H[be][ve],Z];let tt=0,Fe=0;for(;be>=1;){let X=ve;do{const Y=G[be][X];if(Y===3)X=X-2;else if(Y===2)X=X-1;else break}while(X>=1);tt>1&&_[N+be-1]===q[Z+ve-1]&&!ue(X+Z-1,$,q)&&tt+1>B[be][X]&&(X=ve),X===ve?tt++:tt=1,Fe||(Fe=X),be--,ve=X-1,Ge.push(ve)}oe===we&&ce.boostFullMatch&&(Ge[0]+=2);const ht=Fe-we;return Ge[0]-=ht,Ge}e.fuzzyScore=xe;function Qe(J,_,N,$,q,Z){let ce=J-1,we=_-1;for(;ce>=N&&we>=$;)q[ce]===Z[we]&&(x[ce]=we,ce--),we--}function Ce(J,_,N,$,q,Z,ce,we,oe,be,ve){if(_[N]!==Z[ce])return Number.MIN_SAFE_INTEGER;let Ue=1,ze=!1;return ce===N-$?Ue=J[N]===q[ce]?7:5:ue(ce,q,Z)&&(ce===0||!ue(ce-1,q,Z))?(Ue=J[N]===q[ce]?7:5,ze=!0):me(Z,ce)&&(ce===0||!me(Z,ce-1))?Ue=5:(me(Z,ce-1)||le(Z,ce-1))&&(Ue=5,ze=!0),Ue>1&&N===$&&(ve[0]=!0),ze||(ze=ue(ce,q,Z)||me(Z,ce-1)||le(Z,ce-1)),N===$?ce>oe&&(Ue-=ze?3:5):be?Ue+=ze?2:0:Ue+=ze?0:1,ce+1===we&&(Ue-=ze?3:5),Ue}function ye(J,_,N,$,q,Z,ce){return se(J,_,N,$,q,Z,!0,ce)}e.fuzzyScoreGracefulAggressive=ye;function Te(J,_,N,$,q,Z,ce){return se(J,_,N,$,q,Z,!1,ce)}e.fuzzyScoreGraceful=Te;function se(J,_,N,$,q,Z,ce,we){let oe=xe(J,_,N,$,q,Z,we);if(oe&&!ce)return oe;if(J.length>=3){const be=Math.min(7,J.length-1);for(let ve=N+1;ve<be;ve++){const Ue=ae(J,ve);if(Ue){const ze=xe(Ue,Ue.toLowerCase(),N,$,q,Z,we);ze&&(ze[0]-=3,(!oe||ze[0]>oe[0])&&(oe=ze))}}}return oe}function ae(J,_){if(_+1>=J.length)return;const N=J[_],$=J[_+1];if(N!==$)return J.slice(0,_)+$+N+J.slice(_+2)}}),define(De[118],Ie([1,0,119,117,10]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",I=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(i.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${I.source}`,"g");function k(c){return c.replace(y,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=k;const O=new RegExp(`\\\\${I.source}`,"g");function S(c){return c.replace(O,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=S;const m=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function E(c){return c.indexOf(M)===-1?c:c.replace(m,(g,b,p,D)=>p?g:b||D||"")}e.stripIcons=E;function f(c){const g=c.indexOf(M);return g===-1?{text:c}:t(c,g)}e.parseLabelWithIcons=f;function t(c,g){const b=[];let p="";function D(h){if(h){p+=h;for(const v of h)b.push(a)}}let n=-1,s="",a=0,l,u,d=g;const r=c.length;for(D(c.substr(0,g));d<r;)l=c[d],u=c[d+1],l===M[0]&&u===M[1]?(n=d,D(s),s=M,d++):l===")"&&n!==-1?(a+=d-n+1,n=-1,s=""):n!==-1?A.test(l)?s+=l:(D(s),n=-1,s=""):D(l),d++;return D(s),{text:p,iconOffsets:b}}function o(c,g,b=!1){const{text:p,iconOffsets:D}=g;if(!D||D.length===0)return(0,C.matchesFuzzy)(c,p,b);const n=(0,w.ltrim)(p," "),s=p.length-n.length,a=(0,C.matchesFuzzy)(c,n,b);if(a)for(const l of a){const u=D[l.start+s]+s;l.start+=u,l.end+=u}return a}e.matchesFuzzyIconAware=o}),define(De[29],Ie([1,0,10]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(C||(C={})),function(w){const M="error",I="warning",A="warn",y="info",k="ignore";function O(m){return m?i.equalsIgnoreCase(M,m)?w.Error:i.equalsIgnoreCase(I,m)||i.equalsIgnoreCase(A,m)?w.Warning:i.equalsIgnoreCase(y,m)?w.Info:w.Ignore:w.Ignore}w.fromValue=O;function S(m){switch(m){case w.Error:return M;case w.Warning:return I;case w.Info:return y;default:return k}}w.toString=S}(C||(C={})),e.default=C}),define(De[46],Ie([1,0,16,10]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class w{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const f=E.charCodeAt(0),t=this._value.charCodeAt(this._pos);return f-t}value(){return this._value[this._pos]}}e.StringIterator=w;class M{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,C.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class I{constructor(E=!0,f=!0){this._splitOnBackslash=E,this._caseSensitive=f}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let f=E.length-1;f>=0;f--,this._valueLen--){const t=this._value.charCodeAt(f);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,C.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var A;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(E,f){this._ignorePathCasing=E,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,C.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(O||(O={}));class S{static forUris(E=()=>!1,f=()=>!1){return new S(new y(E,f))}static forPaths(E=!1){return new S(new I(void 0,!E))}static forStrings(){return new S(new w)}static forConfigKeys(){return new S(new M)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o,E)}else{const t=E.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o[0],o[1])}}set(E,f){const t=this._iter.reset(E);let o;this._root||(this._root=new k,this._root.segment=t.value());const c=[];for(o=this._root;;){const b=t.cmp(o.segment);if(b>0)o.left||(o.left=new k,o.left.segment=t.value()),c.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new k,o.right.segment=t.value()),c.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new k,o.mid.segment=t.value()),c.push([0,o]),o=o.mid;else break}const g=o.value;o.value=f,o.key=E;for(let b=c.length-1;b>=0;b--){const p=c[b][1];p.updateHeight();const D=p.balanceFactor();if(D<-1||D>1){const n=c[b][0],s=c[b+1][0];if(n===1&&s===1)c[b][1]=p.rotateLeft();else if(n===-1&&s===-1)c[b][1]=p.rotateRight();else if(n===1&&s===-1)p.right=c[b+1][1]=c[b+1][1].rotateRight(),c[b][1]=p.rotateLeft();else if(n===-1&&s===1)p.left=c[b+1][1]=c[b+1][1].rotateLeft(),c[b][1]=p.rotateRight();else throw new Error;if(b>0)switch(c[b-1][0]){case-1:c[b-1][1].left=c[b][1];break;case 1:c[b-1][1].right=c[b][1];break;case 0:c[b-1][1].mid=c[b][1];break}else this._root=c[0][1]}}return g}get(E){return this._getNode(E)?.value}_getNode(E){const f=this._iter.reset(E);let t=this._root;for(;t;){const o=f.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(E){const f=this._getNode(E);return!(f?.value===void 0&&f?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,f){const t=this._iter.reset(E),o=[];let c=this._root;for(;c;){const g=t.cmp(c.segment);if(g>0)o.push([-1,c]),c=c.left;else if(g<0)o.push([1,c]),c=c.right;else if(t.hasNext())t.next(),o.push([0,c]),c=c.mid;else break}if(!!c){if(f?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const g=this._min(c.right);if(g.key){const{key:b,value:p,segment:D}=g;this._delete(g.key,!1),c.key=b,c.value=p,c.segment=D}}else{const g=c.left??c.right;if(o.length>0){const[b,p]=o[o.length-1];switch(b){case-1:p.left=g;break;case 0:p.mid=g;break;case 1:p.right=g;break}}else this._root=g}for(let g=o.length-1;g>=0;g--){const b=o[g][1];b.updateHeight();const p=b.balanceFactor();if(p>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[g][1]=b.rotateLeft()):p<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[g][1]=b.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this._root=o[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const f=this._iter.reset(E);let t=this._root,o;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(E){const f=this._iter.reset(E);let t=this._root;for(;t;){const o=f.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(E){for(const[f,t]of this)E(t,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const f=[];return this._dfsEntries(E,f),f[Symbol.iterator]()}_dfsEntries(E,f){!E||(E.left&&this._dfsEntries(E.left,f),E.value&&f.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,f),E.right&&this._dfsEntries(E.right,f))}_isBalanced(){const E=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:E(f.left)&&E(f.right)};return E(this._root)}}e.TernarySearchTree=S}),define(De[80],Ie([1,0,24,10,2]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,A)}e.stringify=M;function I(k){let O=JSON.parse(k);return O=y(O),O}e.parse=I;function A(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function y(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return w.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 15:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let S=0;S<k.length;++S)k[S]=y(k[S],O+1);else for(const S in k)Object.hasOwnProperty.call(k,S)&&(k[S]=y(k[S],O+1))}return k}e.revive=y}),define(De[13],Ie([1,0,21,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${w.vscodeRemoteResource}`}set(k,O,S){this._hosts[k]=O,this._ports[k]=S}setConnectionToken(k,O){this._connectionTokens[k]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const O=k.authority;let S=this._hosts[O];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const m=this._ports[O],E=this._connectionTokens[O];let f=`path=${encodeURIComponent(k.path)}`;return typeof E=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),C.URI.from({scheme:i.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${S}:${m}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(k){const O=this.toUri(k,te);return this.uriToBrowserUri(O)}uriToBrowserUri(k){return k.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===w.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${w.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?k.with({scheme:w.vscodeFileResource,authority:k.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(k){const O=this.toUri(k,te);return this.uriToFileUri(O)}uriToFileUri(k){return k.scheme===w.vscodeFileResource?k.with({scheme:w.file,authority:k.authority!==I.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(k,O){return C.URI.isUri(k)?k:C.URI.parse(O.toUrl(k))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I;var A;(function(y){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function S(E){let f;typeof E=="string"?f=new URL(E).searchParams:E instanceof URL?f=E.searchParams:C.URI.isUri(E)&&(f=new URL(E.toString(!0)).searchParams);const t=f?.get(O);if(!!t)return k.get(t)}y.getHeadersFromQuery=S;function m(E,f,t){if(!globalThis.crossOriginIsolated)return;const o=f&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(O,o):E[O]=o}y.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,39,13,19,21,10,2]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=y;class k{constructor(f){this._ignorePathCasing=f}compare(f,t,o=!1){return f===t?0:(0,I.compare)(this.getComparisonKey(f,o),this.getComparisonKey(t,o))}isEqual(f,t,o=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,o)===this.getComparisonKey(t,o)}getComparisonKey(f,t=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,t,o=!1){if(f.scheme===t.scheme){if(f.scheme===C.Schemas.file)return i.isEqualOrParent(y(f),y(t),this._ignorePathCasing(f))&&f.query===t.query&&(o||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this._ignorePathCasing(f),"/")&&f.query===t.query&&(o||f.fragment===t.fragment)}return!1}joinPath(f,...t){return A.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return w.posix.basename(f.path)}extname(f){return w.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===C.Schemas.file?t=A.URI.file(w.dirname(y(f))).path:(t=w.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===C.Schemas.file?t=A.URI.file(w.normalize(y(f))).path:t=w.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===C.Schemas.file){const g=w.relative(y(f),y(t));return M.isWindows?i.toSlashes(g):g}let o=f.path||"/";const c=t.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const b=Math.min(o.length,c.length);g<b&&!(o.charCodeAt(g)!==c.charCodeAt(g)&&o.charAt(g).toLowerCase()!==c.charAt(g).toLowerCase());g++);o=c.substr(0,g)+o.substr(g)}return w.posix.relative(o,c)}resolvePath(f,t){if(f.scheme===C.Schemas.file){const o=A.URI.file(w.resolve(y(f),t));return f.with({authority:o.authority,path:o.path})}return t=i.toPosixPath(t),f.with({path:w.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,I.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=w.sep){if(f.scheme===C.Schemas.file){const o=y(f);return o.length>i.getRoot(o).length&&o[o.length-1]===t}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=w.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=w.sep){let o=!1;if(f.scheme===C.Schemas.file){const c=y(f);o=c!==void 0&&c.length===i.getRoot(c).length&&c[c.length-1]===t}else{t="/";const c=f.path;o=c.length===1&&c.charCodeAt(c.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(E=>E.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(E,f){const t=[];for(let o=0;o<E.length;o++){const c=f(E[o]);E.some((g,b)=>b===o?!1:(0,e.isEqualOrParent)(c,f(g)))||t.push(E[o])}return t}e.distinctParents=O;var S;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function f(t){const o=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(b=>{const[p,D]=b.split(":");p&&D&&o.set(p,D)});const g=t.path.substring(0,t.path.indexOf(";"));return g&&o.set(E.META_DATA_MIME,g),o}E.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function m(E,f,t){if(f){let o=E.path;return o&&o[0]!==w.posix.sep&&(o=w.posix.sep+o),E.with({scheme:t,authority:f,path:o})}return E.with({scheme:t})}e.toLocalResource=m}),define(De[15],Ie([1,0,20,12,4,7,22,21]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=y;function k(ue){const Q=new i.CancellationTokenSource,ge=ue(Q.token),Se=new Promise((Oe,xe)=>{const Qe=Q.token.onCancellationRequested(()=>{Qe.dispose(),Q.dispose(),xe(new C.CancellationError)});Promise.resolve(ge).then(Ce=>{Qe.dispose(),Q.dispose(),Oe(Ce)},Ce=>{Qe.dispose(),Q.dispose(),xe(Ce)})});return new class{cancel(){Q.cancel()}then(Oe,xe){return Se.then(Oe,xe)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Se.finally(Oe)}}}e.createCancelablePromise=k;function O(ue,Q,ge){return new Promise((Se,Oe)=>{const xe=Q.onCancellationRequested(()=>{xe.dispose(),Se(ge)});ue.then(Se,Oe).finally(()=>xe.dispose())})}e.raceCancellation=O;function S(ue,Q){return new Promise((ge,Se)=>{const Oe=Q.onCancellationRequested(()=>{Oe.dispose(),Se(new C.CancellationError)});ue.then(ge,Se).finally(()=>Oe.dispose())})}e.raceCancellationError=S;async function m(ue){let Q=-1;const ge=ue.map((Oe,xe)=>Oe.then(Qe=>(Q=xe,Qe))),Se=await Promise.race(ge);return ue.forEach((Oe,xe)=>{xe!==Q&&Oe.cancel()}),Se}e.raceCancellablePromises=m;function E(ue,Q,ge){let Se;const Oe=setTimeout(()=>{Se?.(void 0),ge?.()},Q);return Promise.race([ue.finally(()=>clearTimeout(Oe)),new Promise(xe=>Se=xe)])}e.raceTimeout=E;function f(ue){return new Promise((Q,ge)=>{const Se=ue();y(Se)?Se.then(Q,ge):Q(Se)})}e.asPromise=f;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(ge,ge).then(Se)})}return new Promise((ge,Se)=>{this.queuedPromise.then(ge,Se)})}return this.activePromise=Q(),new Promise((ge,Se)=>{this.activePromise.then(Oe=>{this.activePromise=null,ge(Oe)},Oe=>{this.activePromise=null,Se(Oe)})})}}e.Throttler=t;class o{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=o;class c{constructor(){this.promiseMap=new Map}queue(Q,ge){const Oe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(Q)===Oe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Oe),Oe}}e.SequencerByKey=c;const g=(ue,Q)=>{let ge=!0;const Se=setTimeout(()=>{ge=!1,Q()},ue);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Se),ge=!1}}},b=ue=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ue())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ge=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,xe)=>{this.doResolve=Oe,this.doReject=xe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?b(Se):g(ge,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class D{constructor(Q){this.delayer=new p(Q),this.throttler=new t}trigger(Q,ge){return this.delayer.trigger(()=>this.throttler.queue(Q),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class n{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ge)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function a(ue,Q){return Q?new Promise((ge,Se)=>{const Oe=setTimeout(()=>{xe.dispose(),ge()},ue),xe=Q.onCancellationRequested(()=>{clearTimeout(Oe),xe.dispose(),Se(new C.CancellationError)})}):k(ge=>a(ue,ge))}e.timeout=a;function l(ue,Q=0){const ge=setTimeout(ue,Q);return(0,M.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=l;function u(ue){const Q=[];let ge=0;const Se=ue.length;function Oe(){return ge<Se?ue[ge++]():null}function xe(Qe){Qe!=null&&Q.push(Qe);const Ce=Oe();return Ce?Ce.then(xe):Promise.resolve(Q)}return Promise.resolve(null).then(xe)}e.sequence=u;function d(ue,Q=Se=>!!Se,ge=null){let Se=0;const Oe=ue.length,xe=()=>{if(Se>=Oe)return Promise.resolve(ge);const Qe=ue[Se++];return Promise.resolve(Qe()).then(ye=>Q(ye)?Promise.resolve(ye):xe())};return xe()}e.first=d;function r(ue,Q=Se=>!!Se,ge=null){if(ue.length===0)return Promise.resolve(ge);let Se=ue.length;const Oe=()=>{Se=-1;for(const xe of ue)xe.cancel?.()};return new Promise((xe,Qe)=>{for(const Ce of ue)Ce.then(ye=>{--Se>=0&&Q(ye)?(Oe(),xe(ye)):Se===0&&xe(ge)}).catch(ye=>{--Se>=0&&(Oe(),Qe(ye))})})}e.firstParallel=r;class h{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ge,Se)=>{this.outstandingPromises.push({factory:Q,c:ge,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ge=Q.factory();ge.then(Q.c,Q.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new G;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,ge=I.extUri){const Se=ge.getComparisonKey(Q);let Oe=this.queues.get(Se);return Oe||(Oe=new v,w.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Oe)),Oe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class L{constructor(Q,ge){this._token=-1,typeof Q=="function"&&typeof ge=="number"&&this.setIfNotSet(Q,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ge)}setIfNotSet(Q,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ge))}}e.TimeoutTimer=L;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ge){this.cancel(),this._token=setInterval(()=>{Q()},ge)}}e.IntervalTimer=j;class V{constructor(Q,ge){this.timeoutToken=-1,this.runner=Q,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class W{constructor(Q,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=W;class T extends V{constructor(Q,ge){super(Q,ge),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class F extends M.Disposable{constructor(Q,ge){super(),this.options=Q,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,A.setTimeout0)(()=>{if(Q)return;const ge=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(ue,Q)=>{const ge=requestIdleCallback(ue,typeof Q=="number"?{timeout:Q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(ge))}}}}();class R{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function x(ue,Q,ge){let Se;for(let Oe=0;Oe<ge;Oe++)try{return await ue()}catch(xe){Se=xe,await a(Q)}throw Se}e.retry=x;class B{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Q,ge,Se){return this._pending={taskId:Q,cancel:()=>Se?.(),promise:ge},ge.then(()=>this.donePending(Q),()=>this.donePending(Q)),ge}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ge,Se;const Oe=new Promise((xe,Qe)=>{ge=xe,Se=Qe});this._next={run:Q,promise:Oe,promiseResolve:ge,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class H{constructor(Q,ge=()=>Date.now()){this.interval=Q,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ge)=>{this.completeCallback=Q,this.errorCallback=ge})}complete(Q){return new Promise(ge=>{this.completeCallback(Q),this.resolved=!0,ge()})}error(Q){return new Promise(ge=>{this.errorCallback(Q),this.rejected=!0,ge()})}cancel(){new Promise(Q=>{this.errorCallback(new C.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=G;var ee;(function(ue){async function Q(Se){let Oe;const xe=await Promise.all(Se.map(Qe=>Qe.then(Ce=>Ce,Ce=>{Oe||(Oe=Ce)})));if(typeof Oe<"u")throw Oe;return xe}ue.settled=Q;function ge(Se){return new Promise(async(Oe,xe)=>{try{await Se(Oe,xe)}catch(Qe){xe(Qe)}})}ue.withAsyncBody=ge})(ee=e.Promises||(e.Promises={}));var de;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(de||(de={}));class ne{static fromArray(Q){return new ne(ge=>{ge.emitMany(Q)})}static fromPromise(Q){return new ne(async ge=>{ge.emitMany(await Q)})}static fromPromises(Q){return new ne(async ge=>{await Promise.all(Q.map(async Se=>ge.emitOne(await Se)))})}static merge(Q){return new ne(async ge=>{await Promise.all(Q.map(async Se=>{for await(const Oe of Se)ge.emitOne(Oe)}))})}constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ge={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Q(ge)),this.resolve()}catch(Se){this.reject(Se)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ge){return new ne(async Se=>{for await(const Oe of Q)Se.emitOne(ge(Oe))})}map(Q){return ne.map(this,Q)}static filter(Q,ge){return new ne(async Se=>{for await(const Oe of Q)ge(Oe)&&Se.emitOne(Oe)})}filter(Q){return ne.filter(this,Q)}static coalesce(Q){return ne.filter(Q,ge=>!!ge)}coalesce(){return ne.coalesce(this)}static async toPromise(Q){const ge=[];for await(const Se of Q)ge.push(Se);return ge}toPromise(){return ne.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class me extends ne{constructor(Q,ge){super(ge),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=me;function le(ue){const Q=new i.CancellationTokenSource,ge=ue(Q.token);return new me(Q,async Se=>{const Oe=Q.token.onCancellationRequested(()=>{Oe.dispose(),Q.dispose(),Se.reject(new C.CancellationError)});try{for await(const xe of ge){if(Q.token.isCancellationRequested)return;Se.emitOne(xe)}Oe.dispose(),Q.dispose()}catch(xe){Oe.dispose(),Q.dispose(),Se.reject(xe)}})}e.createCancelableAsyncIterable=le}),define(De[120],Ie([1,0,15,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new i.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,P,L=!1){const j=v||"",V=P||"",W=w.value.collator.compare(j,V);return w.value.collatorIsNumeric&&W===0&&j!==V?j<V?-1:1:W}e.compareFileNames=A;function y(v,P){const L=M.value.collator;return v=v||"",P=P||"",D(L,v,P)}e.compareFileNamesDefault=y;function k(v,P){const L=M.value.collator;return v=v||"",P=P||"",l(v,P)||D(L,v,P)}e.compareFileNamesUpper=k;function O(v,P){const L=M.value.collator;return v=v||"",P=P||"",a(v,P)||D(L,v,P)}e.compareFileNamesLower=O;function S(v,P){return v=v||"",P=P||"",v===P?0:v<P?-1:1}e.compareFileNamesUnicode=S;function m(v,P,L=!1){L||(v=v&&v.toLowerCase(),P=P&&P.toLowerCase());const[j,V]=b(v),[W,T]=b(P);return j!==W?j<W?-1:1:V===T?0:V<T?-1:1}e.noIntlCompareFileNames=m;function E(v,P){const[L,j]=b(v),[V,W]=b(P);let T=w.value.collator.compare(j,W);if(T===0){if(w.value.collatorIsNumeric&&j!==W)return j<W?-1:1;if(T=w.value.collator.compare(L,V),w.value.collatorIsNumeric&&T===0&&L!==V)return L<V?-1:1}return T}e.compareFileExtensions=E;function f(v,P){v=v||"",P=P||"";const L=p(v),j=p(P),V=M.value.collator,W=I.value.collator;return D(W,L,j)||D(V,v,P)}e.compareFileExtensionsDefault=f;function t(v,P){v=v||"",P=P||"";const L=p(v),j=p(P),V=M.value.collator,W=I.value.collator;return D(W,L,j)||l(v,P)||D(V,v,P)}e.compareFileExtensionsUpper=t;function o(v,P){v=v||"",P=P||"";const L=p(v),j=p(P),V=M.value.collator,W=I.value.collator;return D(W,L,j)||a(v,P)||D(V,v,P)}e.compareFileExtensionsLower=o;function c(v,P){v=v||"",P=P||"";const L=p(v).toLowerCase(),j=p(P).toLowerCase();return L!==j?L<j?-1:1:v!==P?v<P?-1:1:0}e.compareFileExtensionsUnicode=c;const g=/^(.*?)(\.([^.]*))?$/;function b(v,P=!1){const L=v?g.exec(v):[];let j=[L&&L[1]||"",L&&L[3]||""];return P&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function p(v){const P=v?g.exec(v):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function D(v,P,L){const j=v.compare(P,L);return j!==0?j:P.length!==L.length?P.length<L.length?-1:1:0}function n(v){const P=v.charAt(0);return P.toLocaleUpperCase()!==P}function s(v){const P=v.charAt(0);return P.toLocaleLowerCase()!==P}function a(v,P){return n(v)&&s(P)?-1:s(v)&&n(P)?1:0}function l(v,P){return s(v)&&n(P)?-1:n(v)&&s(P)?1:0}function u(v,P,L=!1){return L||(v=v&&v.toLowerCase(),P=P&&P.toLowerCase()),v===P?0:v<P?-1:1}function d(v,P,L=!1){const j=v.split(C.sep),V=P.split(C.sep),W=j.length-1,T=V.length-1;let F,R;for(let x=0;;x++){if(F=W===x,R=T===x,F&&R)return A(j[x],V[x],L);if(F)return-1;if(R)return 1;const B=u(j[x],V[x],L);if(B!==0)return B}}e.comparePaths=d;function r(v,P,L){const j=v.toLowerCase(),V=P.toLowerCase(),W=h(v,P,L);if(W)return W;const T=j.endsWith(L),F=V.endsWith(L);if(T!==F)return T?-1:1;const R=A(j,V);return R!==0?R:j.localeCompare(V)}e.compareAnything=r;function h(v,P,L){const j=v.toLowerCase(),V=P.toLowerCase(),W=j.startsWith(L),T=V.startsWith(L);if(W!==T)return W?-1:1;if(W&&T){if(j.length<V.length)return-1;if(j.length>V.length)return 1}return 0}e.compareByPrefix=h}),define(De[35],Ie([1,0,16,15,39,28,19,21,10]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",S="[^/\\\\]",m=/\//g;function E(G,ee){switch(G){case 0:return"";case 1:return`${S}*?`;default:return`(?:${O}|${S}+${O}${ee?`|${O}${S}+`:""})*?`}}function f(G,ee){if(!G)return[];const de=[];let ne=!1,me=!1,le="";for(const ue of G){switch(ue){case ee:if(!ne&&!me){de.push(le),le="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":me=!0;break;case"]":me=!1;break}le+=ue}return le&&de.push(le),de}e.splitGlobAware=f;function t(G){if(!G)return"";let ee="";const de=f(G,e.GLOB_SPLIT);if(de.every(ne=>ne===e.GLOBSTAR))ee=".*";else{let ne=!1;de.forEach((me,le)=>{if(me===e.GLOBSTAR){if(ne)return;ee+=E(2,le===de.length-1)}else{let ue=!1,Q="",ge=!1,Se="";for(const Oe of me){if(Oe!=="}"&&ue){Q+=Oe;continue}if(ge&&(Oe!=="]"||!Se)){let xe;Oe==="-"?xe=Oe:(Oe==="^"||Oe==="!")&&!Se?xe="^":Oe===e.GLOB_SPLIT?xe="":xe=(0,y.escapeRegExpCharacters)(Oe),Se+=xe;continue}switch(Oe){case"{":ue=!0;continue;case"[":ge=!0;continue;case"}":{ee+=`(?:${f(Q,",").map(Ce=>t(Ce)).join("|")})`,ue=!1,Q="";break}case"]":{ee+="["+Se+"]",ge=!1,Se="";break}case"?":ee+=S;continue;case"*":ee+=E(1);continue;default:ee+=(0,y.escapeRegExpCharacters)(Oe)}}le<de.length-1&&(de[le+1]!==e.GLOBSTAR||le+2<de.length)&&(ee+=O)}ne=me===e.GLOBSTAR})}return ee}const o=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.LRUCache(1e4),s=function(){return!1},a=function(){return null};function l(G,ee){if(!G)return a;let de;typeof G!="string"?de=G.pattern:de=G,de=de.trim();const ne=`${de}_${!!ee.trimForExclusions}`;let me=n.get(ne);if(me)return u(me,G);let le;return o.test(de)?me=r(de.substr(4),de):(le=c.exec(d(de,ee)))?me=h(le[1],de):(ee.trimForExclusions?b:g).test(de)?me=v(de,ee):(le=p.exec(d(de,ee)))?me=P(le[1].substr(1),de,!0):(le=D.exec(d(de,ee)))?me=P(le[1],de,!1):me=L(de),n.set(ne,me),u(me,G)}function u(G,ee){if(typeof ee=="string")return G;const de=function(ne,me){return(0,w.isEqualOrParent)(ne,ee.base,!A.isLinux)?G(ne.substr(ee.base.length+1),me):null};return de.allBasenames=G.allBasenames,de.allPaths=G.allPaths,de.basenames=G.basenames,de.patterns=G.patterns,de}function d(G,ee){return ee.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function r(G,ee){return function(de,ne){return typeof de=="string"&&de.endsWith(G)?ee:null}}function h(G,ee){const de=`/${G}`,ne=`\\${G}`,me=function(ue,Q){return typeof ue!="string"?null:Q?Q===G?ee:null:ue===G||ue.endsWith(de)||ue.endsWith(ne)?ee:null},le=[G];return me.basenames=le,me.patterns=[ee],me.allBasenames=le,me}function v(G,ee){const de=B(G.slice(1,-1).split(",").map(Q=>l(Q,ee)).filter(Q=>Q!==a),G),ne=de.length;if(!ne)return a;if(ne===1)return de[0];const me=function(Q,ge){for(let Se=0,Oe=de.length;Se<Oe;Se++)if(de[Se](Q,ge))return G;return null},le=de.find(Q=>!!Q.allBasenames);le&&(me.allBasenames=le.allBasenames);const ue=de.reduce((Q,ge)=>ge.allPaths?Q.concat(ge.allPaths):Q,[]);return ue.length&&(me.allPaths=ue),me}function P(G,ee,de){const ne=I.sep===I.posix.sep,me=ne?G:G.replace(m,I.sep),le=I.sep+me,ue=I.posix.sep+G;let Q;return de?Q=function(ge,Se){return typeof ge=="string"&&(ge===me||ge.endsWith(le)||!ne&&(ge===G||ge.endsWith(ue)))?ee:null}:Q=function(ge,Se){return typeof ge=="string"&&(ge===me||!ne&&ge===G)?ee:null},Q.allPaths=[(de?"*/":"./")+G],Q}function L(G){try{const ee=new RegExp(`^${t(G)}$`);return function(de){return ee.lastIndex=0,typeof de=="string"&&ee.test(de)?G:null}}catch{return a}}function j(G,ee,de){return!G||typeof ee!="string"?!1:V(G)(ee,void 0,de)}e.match=j;function V(G,ee={}){if(!G)return s;if(typeof G=="string"||W(G)){const de=l(G,ee);if(de===a)return s;const ne=function(me,le){return!!de(me,le)};return de.allBasenames&&(ne.allBasenames=de.allBasenames),de.allPaths&&(ne.allPaths=de.allPaths),ne}return R(G,ee)}e.parse=V;function W(G){const ee=G;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.isRelativePattern=W;function T(G){return G.allBasenames||[]}e.getBasenameTerms=T;function F(G){return G.allPaths||[]}e.getPathTerms=F;function R(G,ee){const de=B(Object.getOwnPropertyNames(G).map(Q=>x(Q,G[Q],ee)).filter(Q=>Q!==a)),ne=de.length;if(!ne)return a;if(!de.some(Q=>!!Q.requiresSiblings)){if(ne===1)return de[0];const Q=function(Oe,xe){let Qe;for(let Ce=0,ye=de.length;Ce<ye;Ce++){const Te=de[Ce](Oe,xe);if(typeof Te=="string")return Te;(0,C.isThenable)(Te)&&(Qe||(Qe=[]),Qe.push(Te))}return Qe?(async()=>{for(const Ce of Qe){const ye=await Ce;if(typeof ye=="string")return ye}return null})():null},ge=de.find(Oe=>!!Oe.allBasenames);ge&&(Q.allBasenames=ge.allBasenames);const Se=de.reduce((Oe,xe)=>xe.allPaths?Oe.concat(xe.allPaths):Oe,[]);return Se.length&&(Q.allPaths=Se),Q}const me=function(Q,ge,Se){let Oe,xe;for(let Qe=0,Ce=de.length;Qe<Ce;Qe++){const ye=de[Qe];ye.requiresSiblings&&Se&&(ge||(ge=(0,I.basename)(Q)),Oe||(Oe=ge.substr(0,ge.length-(0,I.extname)(Q).length)));const Te=ye(Q,ge,Oe,Se);if(typeof Te=="string")return Te;(0,C.isThenable)(Te)&&(xe||(xe=[]),xe.push(Te))}return xe?(async()=>{for(const Qe of xe){const Ce=await Qe;if(typeof Ce=="string")return Ce}return null})():null},le=de.find(Q=>!!Q.allBasenames);le&&(me.allBasenames=le.allBasenames);const ue=de.reduce((Q,ge)=>ge.allPaths?Q.concat(ge.allPaths):Q,[]);return ue.length&&(me.allPaths=ue),me}function x(G,ee,de){if(ee===!1)return a;const ne=l(G,de);if(ne===a)return a;if(typeof ee=="boolean")return ne;if(ee){const me=ee.when;if(typeof me=="string"){const le=(ue,Q,ge,Se)=>{if(!Se||!ne(ue,Q))return null;const Oe=me.replace("$(basename)",ge),xe=Se(Oe);return(0,C.isThenable)(xe)?xe.then(Qe=>Qe?G:null):xe?G:null};return le.requiresSiblings=!0,le}}return ne}function B(G,ee){const de=G.filter(Q=>!!Q.basenames);if(de.length<2)return G;const ne=de.reduce((Q,ge)=>{const Se=ge.basenames;return Se?Q.concat(Se):Q},[]);let me;if(ee){me=[];for(let Q=0,ge=ne.length;Q<ge;Q++)me.push(ee)}else me=de.reduce((Q,ge)=>{const Se=ge.patterns;return Se?Q.concat(Se):Q},[]);const le=function(Q,ge){if(typeof Q!="string")return null;if(!ge){let Oe;for(Oe=Q.length;Oe>0;Oe--){const xe=Q.charCodeAt(Oe-1);if(xe===47||xe===92)break}ge=Q.substr(Oe)}const Se=ne.indexOf(ge);return Se!==-1?me[Se]:null};le.basenames=ne,le.patterns=me,le.allBasenames=ne;const ue=G.filter(Q=>!Q.basenames);return ue.push(le),ue}function H(G,ee){return(0,i.equals)(G,ee,(de,ne)=>typeof de=="string"&&typeof ne=="string"?de===ne:typeof de!="string"&&typeof ne!="string"?de.base===ne.base&&de.pattern===ne.pattern:!1)}e.patternsEquals=H}),define(De[81],Ie([1,0,12,118,22,10,2]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(c="",g=!1){if(this.value=c,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(c,g=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(c):c).replace(/([ \t]+)/g,(b,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,g){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(c,g,b){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(c),")"),b&&(this.value+=` "${this._escape(this._escape(b,'"'),")")}"`),this.value+=")",this}_escape(c,g){const b=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return c.replace(b,(p,D)=>c.charAt(D-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=y;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function S(o,c){return o===c?!0:!o||!c?!1:o.value===c.value&&o.isTrusted===c.isTrusted&&o.supportThemeIcons===c.supportThemeIcons&&o.supportHtml===c.supportHtml&&(o.baseUri===c.baseUri||!!o.baseUri&&!!c.baseUri&&(0,w.isEqual)(I.URI.from(o.baseUri),I.URI.from(c.baseUri)))}e.markdownStringEqual=S;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function E(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function t(o){const c=[],g=o.split("|").map(p=>p.trim());o=g[0];const b=g[1];if(b){const p=/height=(\d+)/.exec(b),D=/width=(\d+)/.exec(b),n=p?p[1]:"",s=D?D[1]:"",a=isFinite(parseInt(s)),l=isFinite(parseInt(n));a&&c.push(`width="${s}"`),l&&c.push(`height="${n}"`)}return{href:o,dimensions:c}}e.parseHrefAndDimensions=t}),define(De[82],Ie([1,0,16,39,19,21,22,10]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(a,l){const{os:u,tildify:d,relative:r}=l;if(r){const P=k(a,r,u);if(typeof P=="string")return P}let h=a.fsPath;if(u===1&&!M.isWindows?h=h.replace(/\//g,"\\"):u!==1&&M.isWindows&&(h=h.replace(/\\/g,"/")),u!==1&&d?.userHome){const P=d.userHome.fsPath;let L;a.scheme!==d.userHome.scheme&&a.path.startsWith(w.posix.sep)?L=d.userHome.with({path:a.path}).fsPath:L=a.fsPath,h=m(L,P,u)}return(u===1?w.win32:w.posix).normalize(O(h,u===1))}e.getPathLabel=y;function k(a,l,u){const d=u===1?w.win32:w.posix,r=u===3?I.extUri:I.extUriIgnorePathCase,h=l.getWorkspace(),v=(0,i.firstOrDefault)(h.folders);if(!v)return;a.scheme!==v.uri.scheme&&a.path.startsWith(w.posix.sep)&&(a=v.uri.with({path:a.path}));const P=l.getWorkspaceFolder(a);if(!P)return;let L;if(r.isEqual(P.uri,a)?L="":L=r.relativePath(P.uri,a)??"",L&&(L=d.normalize(L)),h.folders.length>1&&!l.noPrefix){const j=P.name?P.name:r.basenameOrAuthority(P.uri);L=L?`${j} \u2022 ${L}`:j}return L}function O(a,l=M.isWindows){return(0,C.hasDriveLetter)(a,l)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=O;let S=Object.create(null);function m(a,l,u=M.OS){if(u===1||!a||!l)return a;let d=S.original===l?S.normalized:void 0;d||(d=l,M.isWindows&&(d=(0,C.toSlashes)(d)),d=`${(0,A.rtrim)(d,w.posix.sep)}${w.posix.sep}`,S={original:l,normalized:d});let r=a;return M.isWindows&&(r=(0,C.toSlashes)(r)),(u===3?r.startsWith(d):(0,A.startsWithIgnoreCase)(r,d))?`~/${r.substr(d.length)}`:a}e.tildify=m;function E(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=E;const f="\u2026",t="\\\\",o="~";function c(a,l=w.sep){const u=new Array(a.length);let d=!1;for(let r=0;r<a.length;r++){const h=a[r];if(h===""){u[r]=`.${l}`;continue}if(!h){u[r]=h;continue}d=!0;let v="",P=h;P.indexOf(t)===0?(v=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(l)===0?(v=P.substr(0,P.indexOf(l)+l.length),P=P.substr(P.indexOf(l)+l.length)):P.indexOf(o)===0&&(v=P.substr(0,P.indexOf(o)+o.length),P=P.substr(P.indexOf(o)+o.length));const L=P.split(l);for(let j=1;d&&j<=L.length;j++)for(let V=L.length-j;d&&V>=0;V--){d=!1;let W=L.slice(V,V+j).join(l);for(let T=0;!d&&T<a.length;T++)if(T!==r&&a[T]&&a[T].indexOf(W)>-1){const F=V+j===L.length,R=V>0&&a[T].indexOf(l)>-1?l+W:W,x=a[T].endsWith(R);d=!F||x}if(!d){let T="";(L[0].endsWith(":")||v!=="")&&(V===1&&(V=0,j++,W=L[0]+l+W),V>0&&(T=L[0]+l),T=v+T),V>0&&(T=T+f+l),T=T+W,V+j<L.length&&(T=T+l+f),u[r]=T}}d&&(u[r]=h)}return u}e.shorten=c;var g;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function b(a,l=Object.create(null)){const u=[];let d=!1,r="";for(const h of a)if(h==="$"||d&&h==="{")r&&u.push({value:r,type:g.TEXT}),r="",d=!0;else if(h==="}"&&d){const v=l[r];if(typeof v=="string")v.length&&u.push({value:v,type:g.VARIABLE});else if(v){const P=u[u.length-1];(!P||P.type!==g.SEPARATOR)&&u.push({value:v.label,type:g.SEPARATOR})}r="",d=!1}else r+=h;return r&&!d&&u.push({value:r,type:g.TEXT}),u.filter((h,v)=>{if(h.type===g.SEPARATOR){const P=u[v-1],L=u[v+1];return[P,L].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=b;function p(a,l){return M.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):a.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function D(a,l){return M.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):M.isWindows?a.replace(/&&|&/g,u=>u==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function n(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(a){const l=a.indexOf("/")!==-1?w.posix:w.win32,u=l.basename(a),d=l.dirname(a);return u.length?{name:u,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(De[121],Ie([1,0,2]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class w{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:C(i.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:C(i.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:i.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,S,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return S.transformOutgoing(O);for(const E in O)if(Object.hasOwnProperty.call(O,E)){const f=M(O[E],S,m+1);f!==null&&(O[E]=f)}}return null}function I(O,S){const m=M(O,S,0);return m===null?O:m}e.transformOutgoingURIs=I;function A(O,S,m,E){if(!O||E>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?i.URI.revive(S.transformIncoming(O)):S.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const t=A(O[f],S,m,E+1);t!==null&&(O[f]=t)}}return null}function y(O,S){const m=A(O,S,!1,0);return m===null?O:m}e.transformIncomingURIs=y;function k(O,S){const m=A(O,S,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(De[122],Ie([1,0,35,19]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(M,I,A,y,k,O){if(Array.isArray(M)){let S=0;for(const m of M){const E=w(m,I,A,y,k,O);if(E===10)return E;E>S&&(S=E)}return S}else{if(typeof M=="string")return y?M==="*"?5:M===A?10:0:0;if(M){const{language:S,pattern:m,scheme:E,hasAccessToAllModels:f,notebookType:t}=M;if(!y&&!f)return 0;t&&k&&(I=k);let o=0;if(E)if(E===I.scheme)o=10;else if(E==="*")o=5;else return 0;if(S)if(S===A)o=10;else if(S==="*")o=Math.max(o,5);else return 0;if(t)if(t===O)o=10;else if(t==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(m){let c;if(typeof m=="string"?c=m:c={...m,base:(0,C.normalize)(m.base)},c===I.fsPath||(0,i.match)(c,I.fsPath))o=10;else return 0}return o}else return 0}}e.score=w}),define(De[83],Ie([1,0,24,21]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(w||(w={}));function M(S){for(let m=0,E=S.length;m<E;m+=4){const f=S[m+0],t=S[m+1],o=S[m+2],c=S[m+3];S[m+0]=c,S[m+1]=o,S[m+2]=t,S[m+3]=f}}function I(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return C.isLittleEndian()||M(m),i.VSBuffer.wrap(m)}function A(S){const m=S.buffer;if(C.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const E=new Uint8Array(m.byteLength);return E.set(m),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(S){const m=new Uint32Array(k(S));let E=0;if(m[E++]=S.id,S.type==="full")m[E++]=1,m[E++]=S.data.length,m.set(S.data,E),E+=S.data.length;else{m[E++]=2,m[E++]=S.deltas.length;for(const f of S.deltas)m[E++]=f.start,m[E++]=f.deleteCount,f.data?(m[E++]=f.data.length,m.set(f.data,E),E+=f.data.length):m[E++]=0}return I(m)}e.encodeSemanticTokensDto=y;function k(S){let m=0;if(m+=1+1,S.type==="full")m+=1+S.data.length;else{m+=1,m+=(1+1+1)*S.deltas.length;for(const E of S.deltas)E.data&&(m+=E.data.length)}return m}function O(S){const m=A(S);let E=0;const f=m[E++];if(m[E++]===1){const g=m[E++],b=m.subarray(E,E+g);return E+=g,{id:f,type:"full",data:b}}const o=m[E++],c=[];for(let g=0;g<o;g++){const b=m[E++],p=m[E++],D=m[E++];let n;D>0&&(n=m.subarray(E,E+D),E+=D),c[g]={start:b,deleteCount:p,data:n}}return{id:f,type:"delta",deltas:c}}e.decodeSemanticTokensDto=O}),define(De[123],Ie([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(De[124],Ie([1,0,123,21,125,16,23,111]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class S{constructor(Y,pe,Ne,je){this.id=Y,this.name=pe,this.defaultValue=Ne,this.schema=je}applyUpdate(Y,pe){return E(Y,pe)}compute(Y,pe,Ne){return Ne}}class m{constructor(Y,pe){this.newValue=Y,this.didChange=pe}}e.ApplyUpdateResult=m;function E(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new m(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Ne=Array.isArray(X)&&Array.isArray(Y)&&M.equals(X,Y);return new m(Y,!Ne)}let pe=!1;for(const Ne in Y)if(Y.hasOwnProperty(Ne)){const je=E(X[Ne],Y[Ne]);je.didChange&&(X[Ne]=je.newValue,pe=!0)}return new m(X,pe)}class f{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,pe){return E(Y,pe)}validate(Y){return this.defaultValue}}class t{constructor(Y,pe,Ne,je){this.id=Y,this.name=pe,this.defaultValue=Ne,this.schema=je}applyUpdate(Y,pe){return E(Y,pe)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,pe,Ne){return Ne}}function o(X,Y){return typeof X>"u"?Y:X==="false"?!1:Boolean(X)}e.boolean=o;class c extends t{constructor(Y,pe,Ne,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ne),super(Y,pe,Ne,je)}validate(Y){return o(Y,this.defaultValue)}}function g(X,Y,pe,Ne){if(typeof X>"u")return Y;let je=parseInt(X,10);return isNaN(je)?Y:(je=Math.max(pe,je),je=Math.min(Ne,je),je|0)}e.clampedInt=g;class b extends t{static clampedInt(Y,pe,Ne,je){return g(Y,pe,Ne,je)}constructor(Y,pe,Ne,je,qe,He=void 0){typeof He<"u"&&(He.type="integer",He.default=Ne,He.minimum=je,He.maximum=qe),super(Y,pe,Ne,He),this.minimum=je,this.maximum=qe}validate(Y){return b.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class p extends t{static clamp(Y,pe,Ne){return Y<pe?pe:Y>Ne?Ne:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y>"u")return pe;const Ne=parseFloat(Y);return isNaN(Ne)?pe:Ne}constructor(Y,pe,Ne,je,qe){typeof qe<"u"&&(qe.type="number",qe.default=Ne),super(Y,pe,Ne,qe),this.validationFn=je}validate(Y){return this.validationFn(p.float(Y,this.defaultValue))}}class D extends t{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ne),super(Y,pe,Ne,je)}validate(Y){return D.string(Y,this.defaultValue)}}function n(X,Y,pe){return typeof X!="string"||pe.indexOf(X)===-1?Y:X}e.stringSet=n;class s extends t{constructor(Y,pe,Ne,je,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=je,qe.default=Ne),super(Y,pe,Ne,qe),this._allowedValues=je}validate(Y){return n(Y,this.defaultValue,this._allowedValues)}}class a extends S{constructor(Y,pe,Ne,je,qe,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=qe,Ze.default=je),super(Y,pe,Ne,Ze),this._allowedValues=qe,this._convert=He}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,Ne){return Ne===0?Y.accessibilitySupport:Ne}}class d extends S{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function L(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class j extends f{constructor(){super(130)}compute(Y,pe,Ne){const je=["monaco-editor"];return pe.get(34)&&je.push(pe.get(34)),Y.extraEditorClassName&&je.push(Y.extraEditorClassName),pe.get(67)==="default"?je.push("mouse-default"):pe.get(67)==="copy"&&je.push("mouse-copy"),pe.get(101)&&je.push("showUnused"),pe.get(128)&&je.push("showDeprecated"),je.join(" ")}}class V extends c{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Y,pe,Ne){return Ne&&Y.emptySelectionClipboard}}class W extends S{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:i.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:i.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":n(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":n(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class T extends S{constructor(){super(46,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?T.OFF:Y==="true"?T.ON:Y:Boolean(Y)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class F extends f{constructor(){super(45)}compute(Y,pe,Ne){return Y.fontInfo}}class R extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(22,null)})}validate(Y){const pe=p.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Y,pe,Ne){return Y.fontInfo.fontSize}}class x extends S{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:i.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(b.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class B extends S{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[i.localize(25,null),i.localize(26,null),i.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ne,description:i.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ne,description:i.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ne,description:i.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ne,description:i.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ne,description:i.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{multiple:n(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??n(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??n(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??n(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??n(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??n(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends S{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:i.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:i.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:i.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:i.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class ee extends f{constructor(){super(133)}compute(Y,pe,Ne){return ee.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,Ne=Y.scrollBeyondLastLine?pe-1:0,je=(Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),qe=Math.floor(Y.viewLineCount/je);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:qe}}static _computeMinimapLayout(Y,pe){const Ne=Y.outerWidth,je=Y.outerHeight,qe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const He=pe.stableMinimapLayoutInput,Ze=He&&Y.outerHeight===He.outerHeight&&Y.lineHeight===He.lineHeight&&Y.typicalHalfwidthCharacterWidth===He.typicalHalfwidthCharacterWidth&&Y.pixelRatio===He.pixelRatio&&Y.scrollBeyondLastLine===He.scrollBeyondLastLine&&Y.minimap.enabled===He.minimap.enabled&&Y.minimap.side===He.minimap.side&&Y.minimap.size===He.minimap.size&&Y.minimap.showSlider===He.minimap.showSlider&&Y.minimap.renderCharacters===He.minimap.renderCharacters&&Y.minimap.maxColumn===He.minimap.maxColumn&&Y.minimap.scale===He.minimap.scale&&Y.verticalScrollbarWidth===He.verticalScrollbarWidth&&Y.isViewportWrapping===He.isViewportWrapping,nt=Y.lineHeight,lt=Y.typicalHalfwidthCharacterWidth,Dt=Y.scrollBeyondLastLine,rt=Y.minimap.renderCharacters;let it=qe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Mt=Y.minimap.maxColumn,Ot=Y.minimap.size,Ft=Y.minimap.side,ft=Y.verticalScrollbarWidth,It=Y.viewLineCount,kt=Y.remainingWidth,Pt=Y.isViewportWrapping,Ke=rt?2:3;let Tt=Math.floor(qe*je);const Lt=Tt/qe;let xt=!1,pt=!1,yt=Ke*it,St=it/qe,_e=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Be,extraLinesBeyondLastLine:ot,desiredRatio:mt,minimapLineCount:At}=ee.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Dt,height:je,lineHeight:nt,pixelRatio:qe});if(It/At>1)xt=!0,pt=!0,it=1,yt=1,St=it/qe;else{let Et=!1,dt=it+1;if(Ot==="fit"){const Nt=Math.ceil((It+ot)*yt);Pt&&Ze&&kt<=pe.stableFitRemainingWidth?(Et=!0,dt=pe.stableFitMaxMinimapScale):Et=Nt>Tt}if(Ot==="fill"||Et){xt=!0;const Nt=it;yt=Math.min(nt*qe,Math.max(1,Math.floor(1/mt))),Pt&&Ze&&kt<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),it=Math.min(dt,Math.max(1,Math.floor(yt/Ke))),it>Nt&&(_e=Math.min(2,it/Nt)),St=it/qe/_e,Tt=Math.ceil(Math.max(Be,It+ot)*yt),Pt?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=kt,pe.stableFitMaxMinimapScale=it):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Pe=Math.floor(Mt*St),fe=Math.min(Pe,Math.max(0,Math.floor((kt-ft-2)*St/(lt+St)))+e.MINIMAP_GUTTER_WIDTH);let K=Math.floor(qe*fe);const ke=K/qe;K=Math.floor(K*_e);const Le=rt?1:2,Xe=Ft==="left"?0:Ne-fe-ft;return{renderMinimap:Le,minimapLeft:Xe,minimapWidth:fe,minimapHeightIsEditorHeight:xt,minimapIsSampling:pt,minimapScale:it,minimapLineHeight:yt,minimapCanvasInnerWidth:K,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:ke,minimapCanvasOuterHeight:Lt}}static computeLayout(Y,pe){const Ne=pe.outerWidth|0,je=pe.outerHeight|0,qe=pe.lineHeight|0,He=pe.lineNumbersDigitCount|0,Ze=pe.typicalHalfwidthCharacterWidth,nt=pe.maxDigitWidth,lt=pe.pixelRatio,Dt=pe.viewLineCount,rt=Y.get(125),it=rt==="inherit"?Y.get(124):rt,Mt=it==="inherit"?Y.get(120):it,Ot=Y.get(123),Ft=pe.isDominatedByLongLines,ft=Y.get(51),It=Y.get(61).renderType!==0,kt=Y.get(62),Pt=Y.get(95),Ke=Y.get(66),Tt=Y.get(93),Lt=Tt.verticalScrollbarSize,xt=Tt.verticalHasArrows,pt=Tt.arrowSize,yt=Tt.horizontalScrollbarSize,St=Y.get(59),_e=Y.get(38),Pe=Y.get(100)!=="never";let fe;if(typeof St=="string"&&/^\d+(\.\d+)?ch$/.test(St)){const Ht=parseFloat(St.substr(0,St.length-2));fe=b.clampedInt(Ht*Ze,0,0,1e3)}else fe=b.clampedInt(St,0,0,1e3);_e&&Pe&&(fe+=16);let K=0;if(It){const Ht=Math.max(He,kt);K=Math.round(Ht*nt)}let ke=0;ft&&(ke=qe);let Le=0,Xe=Le+ke,Be=Xe+K,ot=Be+fe;const mt=Ne-ke-K-fe;let At=!1,vt=!1,Et=-1;it==="inherit"&&Ft?(At=!0,vt=!0):Mt==="on"||Mt==="bounded"?vt=!0:Mt==="wordWrapColumn"&&(Et=Ot);const dt=ee._computeMinimapLayout({outerWidth:Ne,outerHeight:je,lineHeight:qe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:lt,scrollBeyondLastLine:Pt,minimap:Ke,verticalScrollbarWidth:Lt,viewLineCount:Dt,remainingWidth:mt,isViewportWrapping:vt},pe.memory||new O);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Le+=dt.minimapWidth,Xe+=dt.minimapWidth,Be+=dt.minimapWidth,ot+=dt.minimapWidth);const Nt=mt-dt.minimapWidth,Kt=Math.max(1,Math.floor((Nt-Lt-2)/Ze)),bt=xt?pt:0;return vt&&(Et=Math.max(1,Kt),Mt==="bounded"&&(Et=Math.min(Et,Ot))),{width:Ne,height:je,glyphMarginLeft:Le,glyphMarginWidth:ke,lineNumbersLeft:Xe,lineNumbersWidth:K,decorationsLeft:Be,decorationsWidth:fe,contentLeft:ot,contentWidth:Nt,minimap:dt,viewportColumn:Kt,isWordWrapMinified:At,isViewportWrapping:vt,wrappingColumn:Et,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:yt,overviewRuler:{top:bt,width:Lt,height:je-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ee;class de extends S{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(43,null),i.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(45,null)}})}validate(Y){return n(Y,"simple",["simple","advanced"])}compute(Y,pe,Ne){return pe.get(2)===2?"advanced":Ne}}class ne extends S{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:i.localize(46,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}class me extends S{constructor(){const Y={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:i.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:i.localize(48,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends S{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:i.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(50,null),i.localize(51,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(52,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:i.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:i.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:i.localize(56,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:n(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class ue extends p{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>p.clamp(Y,0,150),{markdownDescription:i.localize(57,null)})}compute(Y,pe,Ne){return Y.fontInfo.lineHeight}}class Q extends S{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:i.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:i.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)],default:Y.size,description:i.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:i.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:i.localize(65,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:i.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:i.localize(68,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:n(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(pe.side,this.defaultValue.side,["right","left"]),showSlider:n(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(X){return X==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends S{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(70,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class Oe extends S{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:i.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:i.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class xe extends f{constructor(){super(131)}compute(Y,pe,Ne){return Y.pixelRatio}}class Qe extends S{constructor(){const Y={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(73,null),i.localize(74,null),i.localize(75,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Y.strings,description:i.localize(76,null)},comments:{anyOf:pe,default:Y.comments,description:i.localize(77,null)},other:{anyOf:pe,default:Y.other,description:i.localize(78,null)}},default:Y,markdownDescription:i.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const lt=Y?"on":"off";return{comments:lt,strings:lt,other:lt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:pe,comments:Ne,strings:je}=Y,qe=["on","inline","off"];let He,Ze,nt;return typeof pe=="boolean"?He=pe?"on":"off":He=n(pe,this.defaultValue.other,qe),typeof Ne=="boolean"?Ze=Ne?"on":"off":Ze=n(Ne,this.defaultValue.comments,qe),typeof je=="boolean"?nt=je?"on":"off":nt=n(je,this.defaultValue.strings,qe),{other:He,comments:Ze,strings:nt}}}var Ce;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Ce=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends S{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(80,null),i.localize(81,null),i.localize(82,null),i.localize(83,null)],default:"on",description:i.localize(84,null)})}validate(Y){let pe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(pe=4,Ne=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ne}}}function Te(X){const Y=X.get(88);return Y==="editable"?X.get(82):Y!=="on"}e.filterValidationDecorations=Te;class se extends S{constructor(){const Y=[],pe={type:"number",description:i.localize(85,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(86,null),format:"color-hex"}}}]},default:Y,description:i.localize(87,null)})}validate(Y){if(Array.isArray(Y)){const pe=[];for(const Ne of Y)if(typeof Ne=="number")pe.push({column:b.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const je=Ne;pe.push({column:b.clampedInt(je.column,0,0,1e4),color:je.color})}return pe.sort((Ne,je)=>Ne.column-je.column),pe}return this.defaultValue}}function ae(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends S{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(88,null),i.localize(89,null),i.localize(90,null)],default:"auto",description:i.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:i.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:i.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:i.localize(98,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,Ne=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(pe.vertical,this.defaultValue.vertical),horizontal:ae(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:je,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,je,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends S{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:i.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:i.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:i.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:i.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:i.localize(105,null)}})}applyUpdate(Y,pe){let Ne=!1;pe.allowedCharacters&&Y&&(I.equals(Y.allowedCharacters,pe.allowedCharacters)||(Y={...Y,allowedCharacters:pe.allowedCharacters},Ne=!0)),pe.allowedLocales&&Y&&(I.equals(Y.allowedLocales,pe.allowedLocales)||(Y={...Y,allowedLocales:pe.allowedLocales},Ne=!0));const je=super.applyUpdate(Y,pe);return Ne?new m(je.newValue,!0):je}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{nonBasicASCII:Z(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,pe){if(typeof Y!="object"||!Y)return pe;const Ne={};for(const[je,qe]of Object.entries(Y))qe===!0&&(Ne[je]=!0);return Ne}}class N extends S{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:i.localize(106,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:n(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class $ extends S{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:i.localize(108,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(109,null),i.localize(110,null),i.localize(111,null)],default:Y.bracketPairs,description:i.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(113,null),i.localize(114,null),i.localize(115,null)],default:Y.bracketPairsHorizontal,description:i.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:i.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:i.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:Y.highlightActiveIndentation,description:i.localize(122,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(X,Y,pe){const Ne=pe.indexOf(X);return Ne===-1?Y:pe[Ne]}class ce extends S{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(123,null),i.localize(124,null)],default:Y.insertMode,description:i.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:i.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:i.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:i.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:i.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:i.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:i.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:i.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:i.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:n(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:o(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:n(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class we extends S{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(166,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends f{constructor(){super(132)}compute(Y,pe,Ne){return pe.get(82)?!0:Y.tabFocusMode}}var be;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));class ve extends S{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(167,null),i.localize(168,null),i.localize(169,null),i.localize(170,null)],description:i.localize(171,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,pe,Ne){return pe.get(2)===2?0:Ne}}class Ue extends f{constructor(){super(134)}compute(Y,pe,Ne){const je=pe.get(133);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class ze extends S{constructor(){const Y={enabled:!0};super(32,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:i.localize(172,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",Ge="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ge:C.isLinux?tt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(X){return e.editorOptionsRegistry[X.id]=X,X}var ht;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(ht=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(173,null)})),acceptSuggestionOnEnter:Fe(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(174,null),""],markdownDescription:i.localize(175,null)})),accessibilitySupport:Fe(new u),accessibilityPageSize:Fe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(176,null),tags:["accessibility"]})),ariaLabel:Fe(new D(4,"ariaLabel",i.localize(177,null))),autoClosingBrackets:Fe(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(178,null),i.localize(179,null),""],description:i.localize(180,null)})),autoClosingDelete:Fe(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(181,null),""],description:i.localize(182,null)})),autoClosingOvertype:Fe(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(183,null),""],description:i.localize(184,null)})),autoClosingQuotes:Fe(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(185,null),i.localize(186,null),""],description:i.localize(187,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[i.localize(188,null),i.localize(189,null),i.localize(190,null),i.localize(191,null),i.localize(192,null)],description:i.localize(193,null)})),automaticLayout:Fe(new c(10,"automaticLayout",!1)),autoSurround:Fe(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(194,null),i.localize(195,null),i.localize(196,null),""],description:i.localize(197,null)})),bracketPairColorization:Fe(new $),bracketPairGuides:Fe(new q),stickyTabStops:Fe(new c(106,"stickyTabStops",!1,{description:i.localize(198,null)})),codeLens:Fe(new c(14,"codeLens",!0,{description:i.localize(199,null)})),codeLensFontFamily:Fe(new D(15,"codeLensFontFamily","",{description:i.localize(200,null)})),codeLensFontSize:Fe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(201,null)})),colorDecorators:Fe(new c(17,"colorDecorators",!0,{description:i.localize(202,null)})),columnSelection:Fe(new c(18,"columnSelection",!1,{description:i.localize(203,null)})),comments:Fe(new d),contextmenu:Fe(new c(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new c(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(204,null)})),cursorBlinking:Fe(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(205,null)})),cursorSmoothCaretAnimation:Fe(new c(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(206,null)})),cursorStyle:Fe(new a(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:i.localize(207,null)})),cursorSurroundingLines:Fe(new b(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(208,null)})),cursorSurroundingLinesStyle:Fe(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(209,null),i.localize(210,null)],description:i.localize(211,null)})),cursorWidth:Fe(new b(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(212,null)})),disableLayerHinting:Fe(new c(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new c(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new c(30,"domReadOnly",!1)),dragAndDrop:Fe(new c(31,"dragAndDrop",!0,{description:i.localize(213,null)})),emptySelectionClipboard:Fe(new V),dropIntoEditor:Fe(new ze),stickyScroll:Fe(new me),extraEditorClassName:Fe(new D(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new p(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:i.localize(214,null)})),find:Fe(new W),fixedOverflowWidgets:Fe(new c(37,"fixedOverflowWidgets",!1)),folding:Fe(new c(38,"folding",!0,{description:i.localize(215,null)})),foldingStrategy:Fe(new s(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),foldingHighlight:Fe(new c(40,"foldingHighlight",!0,{description:i.localize(219,null)})),foldingImportsByDefault:Fe(new c(41,"foldingImportsByDefault",!1,{description:i.localize(220,null)})),foldingMaximumRegions:Fe(new b(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(221,null)})),unfoldOnClickAfterEndOfLine:Fe(new c(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(222,null)})),fontFamily:Fe(new D(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(223,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new T),fontSize:Fe(new R),fontWeight:Fe(new x),formatOnPaste:Fe(new c(49,"formatOnPaste",!1,{description:i.localize(224,null)})),formatOnType:Fe(new c(50,"formatOnType",!1,{description:i.localize(225,null)})),glyphMargin:Fe(new c(51,"glyphMargin",!0,{description:i.localize(226,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new c(53,"hideCursorInOverviewRuler",!1,{description:i.localize(227,null)})),hover:Fe(new H),inDiffEditor:Fe(new c(55,"inDiffEditor",!1)),letterSpacing:Fe(new p(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>p.clamp(X,-5,20),{description:i.localize(228,null)})),lightbulb:Fe(new ne),lineDecorationsWidth:Fe(new t(59,"lineDecorationsWidth",10)),lineHeight:Fe(new ue),lineNumbers:Fe(new ye),lineNumbersMinChars:Fe(new b(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new c(63,"linkedEditing",!1,{description:i.localize(229,null)})),links:Fe(new c(64,"links",!0,{description:i.localize(230,null)})),matchBrackets:Fe(new s(65,"matchBrackets","always",["always","near","never"],{description:i.localize(231,null)})),minimap:Fe(new Q),mouseStyle:Fe(new s(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new p(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:i.localize(232,null)})),mouseWheelZoom:Fe(new c(69,"mouseWheelZoom",!1,{markdownDescription:i.localize(233,null)})),multiCursorMergeOverlapping:Fe(new c(70,"multiCursorMergeOverlapping",!0,{description:i.localize(234,null)})),multiCursorModifier:Fe(new a(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[i.localize(235,null),i.localize(236,null)],markdownDescription:i.localize(237,null)})),multiCursorPaste:Fe(new s(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(238,null),i.localize(239,null)],markdownDescription:i.localize(240,null)})),occurrencesHighlight:Fe(new c(73,"occurrencesHighlight",!0,{description:i.localize(241,null)})),overviewRulerBorder:Fe(new c(74,"overviewRulerBorder",!0,{description:i.localize(242,null)})),overviewRulerLanes:Fe(new b(75,"overviewRulerLanes",3,0,3)),padding:Fe(new Se),parameterHints:Fe(new Oe),peekWidgetDefaultFocus:Fe(new s(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(243,null),i.localize(244,null)],description:i.localize(245,null)})),definitionLinkOpensInPeek:Fe(new c(79,"definitionLinkOpensInPeek",!1,{description:i.localize(246,null)})),quickSuggestions:Fe(new Qe),quickSuggestionsDelay:Fe(new b(81,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(247,null)})),readOnly:Fe(new c(82,"readOnly",!1)),renameOnType:Fe(new c(83,"renameOnType",!1,{description:i.localize(248,null),markdownDeprecationMessage:i.localize(249,null)})),renderControlCharacters:Fe(new c(84,"renderControlCharacters",!0,{description:i.localize(250,null),restricted:!0})),renderFinalNewline:Fe(new c(85,"renderFinalNewline",!0,{description:i.localize(251,null)})),renderLineHighlight:Fe(new s(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(252,null)],description:i.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Fe(new c(87,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(254,null)})),renderValidationDecorations:Fe(new s(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new s(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(255,null),i.localize(256,null),i.localize(257,null),""],description:i.localize(258,null)})),revealHorizontalRightPadding:Fe(new b(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new c(91,"roundedSelection",!0,{description:i.localize(259,null)})),rulers:Fe(new se),scrollbar:Fe(new J),scrollBeyondLastColumn:Fe(new b(94,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(260,null)})),scrollBeyondLastLine:Fe(new c(95,"scrollBeyondLastLine",!0,{description:i.localize(261,null)})),scrollPredominantAxis:Fe(new c(96,"scrollPredominantAxis",!0,{description:i.localize(262,null)})),selectionClipboard:Fe(new c(97,"selectionClipboard",!0,{description:i.localize(263,null),included:C.isLinux})),selectionHighlight:Fe(new c(98,"selectionHighlight",!0,{description:i.localize(264,null)})),selectOnLineNumbers:Fe(new c(99,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new s(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(265,null),i.localize(266,null),i.localize(267,null)],description:i.localize(268,null)})),showUnused:Fe(new c(101,"showUnused",!0,{description:i.localize(269,null)})),showDeprecated:Fe(new c(128,"showDeprecated",!0,{description:i.localize(270,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new s(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(271,null),i.localize(272,null),i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),smartSelect:Fe(new we),smoothScrolling:Fe(new c(104,"smoothScrolling",!1,{description:i.localize(276,null)})),stopRenderingLineAfter:Fe(new b(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ce),inlineSuggest:Fe(new N),suggestFontSize:Fe(new b(109,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new b(110,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new c(111,"suggestOnTriggerCharacters",!0,{description:i.localize(279,null)})),suggestSelection:Fe(new s(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(280,null),i.localize(281,null),i.localize(282,null)],description:i.localize(283,null)})),tabCompletion:Fe(new s(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null)],description:i.localize(287,null)})),tabIndex:Fe(new b(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new _),unusualLineTerminators:Fe(new s(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),useShadowDOM:Fe(new c(117,"useShadowDOM",!0)),useTabStops:Fe(new c(118,"useTabStops",!0,{description:i.localize(292,null)})),wordSeparators:Fe(new D(119,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:i.localize(293,null)})),wordWrap:Fe(new s(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(294,null),i.localize(295,null),i.localize(296,null),i.localize(297,null)],description:i.localize(298,null)})),wordWrapBreakAfterCharacters:Fe(new D(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new D(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new b(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(299,null)})),wordWrapOverride1:Fe(new s(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new s(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new xe),tabFocusMode:Fe(new oe),layoutInfo:Fe(new ee),wrappingInfo:Fe(new Ue),wrappingIndent:Fe(new ve),wrappingStrategy:Fe(new de)}}),define(De[126],Ie([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[127],Ie([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[128],Ie([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[129],Ie([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(De[130],Ie([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(De[131],Ie([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(De[132],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[133],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[134],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(De[135],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[136],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[137],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[138],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[139],Ie([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(De[140],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[141],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[142],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[143],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[144],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[145],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[146],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[147],Ie([1,0,22,29,128,247]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(c){return c=c.trim(),c==="*"||I.test(c)}e.isValidVersionStr=y;function k(c){if(!y(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=c.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function O(c){if(!c)return null;const g=c.majorBase,b=c.majorMustEqual,p=c.minorBase;let D=c.minorMustEqual;const n=c.patchBase;let s=c.patchMustEqual;c.hasCaret&&(g===0||(D=!1),s=!1);let a=0;if(c.preRelease){const l=A.exec(c.preRelease);if(l){const[,u,d,r]=l;a=Date.UTC(Number(u),Number(d)-1,Number(r))}}return{majorBase:g,majorMustEqual:b,minorBase:p,minorMustEqual:D,patchBase:n,patchMustEqual:s,isMinimum:c.hasGreaterEquals,notBefore:a}}e.normalizeVersion=O;function S(c,g,b){let p;typeof c=="string"?p=O(k(c)):p=c;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let n;if(typeof b=="string"?n=O(k(b)):n=b,!p||!n)return!1;const s=p.majorBase,a=p.minorBase,l=p.patchBase;let u=n.majorBase,d=n.minorBase,r=n.patchBase;const h=n.notBefore;let v=n.majorMustEqual,P=n.minorMustEqual,L=n.patchMustEqual;return n.isMinimum?s>u?!0:s<u?!1:a>d?!0:a<d||D&&D<h?!1:l>=r:(s===1&&u===0&&(!v||!P||!L)&&(u=1,d=0,r=0,v=!0,P=!1,L=!1),s<u?!1:s>u?!v:a<d?!1:a>d?!P:l<r?!1:l>r?!L:!(D&&D<h))}e.isValidVersion=S;function m(c,g,b,p,D){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([C.default.Error,w.localize(0,null)]),n;if(typeof p.name!="string")return n.push([C.default.Error,w.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([C.default.Error,w.localize(2,null,"version")]),n;if(!p.engines)return n.push([C.default.Error,w.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([C.default.Error,w.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!o(p.extensionDependencies))return n.push([C.default.Error,w.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!o(p.activationEvents))return n.push([C.default.Error,w.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([C.default.Error,w.localize(7,null,"activationEvents","main")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([C.default.Warning,w.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([C.default.Error,w.localize(9,null,"main")]),n;{const l=(0,i.joinPath)(b,p.main);(0,i.isEqualOrParent)(l,b)||n.push([C.default.Warning,w.localize(10,null,l.path,b.path)])}if(typeof p.activationEvents>"u")return n.push([C.default.Error,w.localize(11,null,"activationEvents","main")]),n}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([C.default.Error,w.localize(12,null,"browser")]),n;{const l=(0,i.joinPath)(b,p.browser);(0,i.isEqualOrParent)(l,b)||n.push([C.default.Warning,w.localize(13,null,l.path,b.path)])}if(typeof p.activationEvents>"u")return n.push([C.default.Error,w.localize(14,null,"activationEvents","browser")]),n}if(!M.valid(p.version))return n.push([C.default.Error,w.localize(15,null)]),n;const s=[];if(!E(c,g,p,D,s))for(const l of s)n.push([C.default.Error,l]);return n}e.validateExtensionManifest=m;function E(c,g,b,p,D){return p||typeof b.main>"u"&&typeof b.browser>"u"?!0:t(c,g,b.engines.vscode,D)}e.isValidExtensionVersion=E;function f(c,g,b){return c==="*"||t(g,b,c)}e.isEngineValid=f;function t(c,g,b,p=[]){const D=O(k(b));if(!D)return p.push(w.localize(16,null,b)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return p.push(w.localize(17,null,b)),!1}else if(!D.majorMustEqual)return p.push(w.localize(18,null,b)),!1;return S(c,g,D)?!0:(p.push(w.localize(19,null,c,b)),!1)}function o(c){if(!Array.isArray(c))return!1;for(let g=0,b=c.length;g<b;g++)if(typeof c[g]!="string")return!1;return!0}}),define(De[84],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(w,M=[],I=!1){this.ctor=w,this.staticArguments=M,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=i}),define(De[60],Ie([1,0,84]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var w;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(w=e.InstantiationType||(e.InstantiationType={}));function M(A,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),C.push([A,y])}e.registerSingleton=M;function I(){return C}e.getSingletonServiceDescriptors=I}),define(De[148],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,I){this.key=M,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class C{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const I of this._nodes.values())I.outgoing.size===0&&M.push(I);return M}insertEdge(M,I){const A=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(I);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(M){const I=this._hashFn(M);this._nodes.delete(I);for(const A of this._nodes.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(M){const I=this._hashFn(M);let A=this._nodes.get(I);return A||(A=new i(I,M),this._nodes.set(I,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[I,A]of this._nodes)M.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,I]of this._nodes){const A=new Set([M]),y=this._findCycle(I,A);if(y)return y}}_findCycle(M,I){for(const[A,y]of M.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const k=this._findCycle(y,I);if(k)return k;I.delete(A)}}}e.Graph=C}),define(De[3],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function C(I,A,y){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:I,index:y}):(A[i.DI_DEPENDENCIES]=[{id:I,index:y}],A[i.DI_TARGET]=A)}function w(I){if(i.serviceIds.has(I))return i.serviceIds.get(I);const A=function(y,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,y,O)};return A.toString=()=>I,i.serviceIds.set(I,A),A}e.createDecorator=w;function M(I){return I}e.refineServiceDecorator=M}),define(De[40],Ie([1,0,9,2,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}e.isConfigurationOverrides=M;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(c,g){const b=Object.create(null);for(const p in c)O(b,p,c[p],g);return b}e.toValuesTree=k;function O(c,g,b,p){const D=g.split("."),n=D.pop();let s=c;for(let a=0;a<D.length;a++){const l=D[a];let u=s[l];switch(typeof u){case"undefined":u=s[l]=Object.create(null);break;case"object":break;default:p(`Ignoring ${g} as ${D.slice(0,a+1).join(".")} is ${JSON.stringify(u)}`);return}s=u}if(typeof s=="object"&&s!==null)try{s[n]=b}catch{p(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=O;function S(c,g){const b=g.split(".");m(c,b)}e.removeFromValueTree=S;function m(c,g){const b=g.shift();if(g.length===0){delete c[b];return}if(Object.keys(c).indexOf(b)!==-1){const p=c[b];typeof p=="object"&&!Array.isArray(p)&&(m(p,g),Object.keys(p).length===0&&delete c[b])}}function E(c,g,b){function p(s,a){let l=s;for(const u of a){if(typeof l!="object"||l===null)return;l=l[u]}return l}const D=g.split("."),n=p(c,D);return typeof n>"u"?b:n}e.getConfigurationValue=E;function f(c,g,b){Object.keys(g).forEach(p=>{p!=="__proto__"&&(p in c?i.isObject(c[p])&&i.isObject(g[p])?f(c[p],g[p],b):b&&(c[p]=g[p]):c[p]=g[p])})}e.merge=f;function t(c,g,b){const p=c.inspect(g),D=c.inspect(b);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof D.userValue<"u"||typeof D.workspaceValue<"u"||typeof D.workspaceFolderValue<"u"?D.value:p.defaultValue}e.getMigratedSettingValue=t;function o(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(De[41],Ie([1,0,21,10,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",i.isMacintosh),M.set("isLinux",i.isLinux),M.set("isWindows",i.isWindows),M.set("isWeb",i.isWeb),M.set("isMacNative",i.isMacintosh&&!i.isWeb),M.set("isEdge",i.isEdge),M.set("isFirefox",i.isFirefox),M.set("isChrome",i.isChrome),M.set("isSafari",i.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(T){return E.create(T)}static equals(T,F){return f.create(T,F)}static notEquals(T,F){return c.create(T,F)}static regex(T,F){return a.create(T,F)}static in(T,F){return t.create(T,F)}static notIn(T,F){return o.create(T,F)}static not(T){return g.create(T)}static and(...T){return d.create(T,null,!0)}static or(...T){return r.create(T,null,!0)}static greater(T,F){return p.create(T,F)}static greaterEquals(T,F){return D.create(T,F)}static smaller(T,F){return n.create(T,F)}static smallerEquals(T,F){return s.create(T,F)}static deserialize(T,F=!1){if(!!T)return this._deserializeOrExpression(T,F)}static _deserializeOrExpression(T,F){const R=T.split("||");return r.create(R.map(x=>this._deserializeAndExpression(x,F)),null,!0)}static _deserializeAndExpression(T,F){const R=T.split("&&");return d.create(R.map(x=>this._deserializeOne(x,F)),null,!0)}static _deserializeOne(T,F){if(T=T.trim(),T.indexOf("!=")>=0){const R=T.split("!=");return c.create(R[0].trim(),this._deserializeValue(R[1],F))}if(T.indexOf("==")>=0){const R=T.split("==");return f.create(R[0].trim(),this._deserializeValue(R[1],F))}if(T.indexOf("=~")>=0){const R=T.split("=~");return a.create(R[0].trim(),this._deserializeRegexValue(R[1],F))}if(T.indexOf(" not in ")>=0){const R=T.split(" not in ");return o.create(R[0].trim(),this._deserializeValue(R[1],F))}if(T.indexOf(" in ")>=0){const R=T.split(" in ");return t.create(R[0].trim(),this._deserializeValue(R[1],F))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const R=T.split(">=");return D.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const R=T.split(">");return p.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const R=T.split("<=");return s.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const R=T.split("<");return n.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(T)?g.create(T.substr(1).trim()):E.create(T)}static _deserializeValue(T,F){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const R=/^'([^']*)'$/.exec(T);return R?R[1].trim():T}static _deserializeRegexValue(T,F){if((0,C.isFalsyOrWhitespace)(T)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const R=T.indexOf("/"),x=T.lastIndexOf("/");if(R===x||R<0){if(F)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}const B=T.slice(R+1,x),H=T[x+1]==="i"?"i":"";try{return new RegExp(B,H)}catch(G){if(F)throw new Error(`bad regexp-value '${T}', parse error: ${G}`);return console.warn(`bad regexp-value '${T}', parse error: ${G}`),null}}}e.ContextKeyExpr=y;function k(W,T){const F=W?W.substituteConstants():void 0,R=T?T.substituteConstants():void 0;return!F&&!R?!0:!F||!R?!1:F.equals(R)}e.expressionsAreEqualWithConstantSubstitution=k;function O(W,T){return W.cmp(T)}class S{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class E{static create(T,F=null){const R=M.get(T);return typeof R=="boolean"?R?m.INSTANCE:S.INSTANCE:new E(T,F)}constructor(T,F){this.key=T,this.negated=F,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=M.get(this.key);return typeof T=="boolean"?T?m.INSTANCE:S.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class f{static create(T,F,R=null){if(typeof F=="boolean")return F?E.create(T,R):g.create(T,R);const x=M.get(T);return typeof x=="boolean"?F===(x?"true":"false")?m.INSTANCE:S.INSTANCE:new f(T,F,R)}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=M.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?m.INSTANCE:S.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class t{static create(T,F){return new t(T,F)}constructor(T,F){this.key=T,this.valueKey=F,this.type=10,this.negated=null}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.valueKey),R=T.getValue(this.key);return Array.isArray(F)?F.includes(R):typeof R=="string"&&typeof F=="object"&&F!==null?I.call(F,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=o.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=t;class o{static create(T,F){return new o(T,F)}constructor(T,F){this.key=T,this.valueKey=F,this.type=11,this._negated=t.create(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=o;class c{static create(T,F,R=null){if(typeof F=="boolean")return F?g.create(T,R):E.create(T,R);const x=M.get(T);return typeof x=="boolean"?F===(x?"true":"false")?S.INSTANCE:m.INSTANCE:new c(T,F,R)}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=M.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?S.INSTANCE:m.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=c;class g{static create(T,F=null){const R=M.get(T);return typeof R=="boolean"?R?S.INSTANCE:m.INSTANCE:new g(T,F)}constructor(T,F){this.key=T,this.negated=F,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=M.get(this.key);return typeof T=="boolean"?T?S.INSTANCE:m.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function b(W,T){if(typeof W=="string"){const F=parseFloat(W);isNaN(F)||(W=F)}return typeof W=="string"||typeof W=="number"?T(W):S.INSTANCE}class p{static create(T,F,R=null){return b(F,x=>new p(T,x,R))}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class D{static create(T,F,R=null){return b(F,x=>new D(T,x,R))}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=D;class n{static create(T,F,R=null){return b(F,x=>new n(T,x,R))}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class s{static create(T,F,R=null){return b(F,x=>new s(T,x,R))}constructor(T,F,R){this.key=T,this.value=F,this.negated=R,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class a{static create(T,F){return new a(T,F)}constructor(T,F){this.key=T,this.regexp=F,this.type=7,this.negated=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const F=this.regexp?this.regexp.source:"",R=T.regexp?T.regexp.source:"";return F<R?-1:F>R?1:0}equals(T){if(T.type===this.type){const F=this.regexp?this.regexp.source:"",R=T.regexp?T.regexp.source:"";return this.key===T.key&&F===R}return!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class l{static create(T){return new l(T)}constructor(T){this._actual=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new l(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function u(W){let T=null;for(let F=0,R=W.length;F<R;F++){const x=W[F].substituteConstants();if(W[F]!==x&&T===null){T=[];for(let B=0;B<F;B++)T[B]=W[B]}T!==null&&(T[F]=x)}return T===null?W:T}class d{static create(T,F,R){return d._normalizeArr(T,F,R)}constructor(T,F){this.expr=T,this.negated=F,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,R=this.expr.length;F<R;F++){const x=O(this.expr[F],T.expr[F]);if(x!==0)return x}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,R=this.expr.length;F<R;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=u(this.expr);return T===this.expr?this:d.create(T,this.negated,!1)}evaluate(T){for(let F=0,R=this.expr.length;F<R;F++)if(!this.expr[F].evaluate(T))return!1;return!0}static _normalizeArr(T,F,R){const x=[];let B=!1;for(const H of T)if(!!H){if(H.type===1){B=!0;continue}if(H.type===0)return S.INSTANCE;if(H.type===6){x.push(...H.expr);continue}x.push(H)}if(x.length===0&&B)return m.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(O);for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];for(;x.length>1;){const H=x[x.length-1];if(H.type!==9)break;x.pop();const G=x.pop(),ee=x.length===0,de=r.create(H.expr.map(ne=>d.create([ne,G],null,R)),null,ee);de&&(x.push(de),x.sort(O))}if(x.length===1)return x[0];if(R){for(let H=0;H<x.length;H++)for(let G=H+1;G<x.length;G++)if(x[H].negate().equals(x[G]))return S.INSTANCE;if(x.length===1)return x[0]}return new d(x,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new d(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){const T=[];for(const F of this.expr)T.push(F.negate());this.negated=r.create(T,this,!0)}return this.negated}}class r{static create(T,F,R){return r._normalizeArr(T,F,R)}constructor(T,F){this.expr=T,this.negated=F,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,R=this.expr.length;F<R;F++){const x=O(this.expr[F],T.expr[F]);if(x!==0)return x}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,R=this.expr.length;F<R;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=u(this.expr);return T===this.expr?this:r.create(T,this.negated,!1)}evaluate(T){for(let F=0,R=this.expr.length;F<R;F++)if(this.expr[F].evaluate(T))return!0;return!1}static _normalizeArr(T,F,R){let x=[],B=!1;if(T){for(let H=0,G=T.length;H<G;H++){const ee=T[H];if(!!ee){if(ee.type===0){B=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){x=x.concat(ee.expr);continue}x.push(ee)}}if(x.length===0&&B)return S.INSTANCE;x.sort(O)}if(x.length!==0){if(x.length===1)return x[0];for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];if(R){for(let H=0;H<x.length;H++)for(let G=H+1;G<x.length;G++)if(x[H].negate().equals(x[G]))return m.INSTANCE;if(x.length===1)return x[0]}return new r(x,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new r(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){const T=[];for(const F of this.expr)T.push(F.negate());for(;T.length>1;){const F=T.shift(),R=T.shift(),x=[];for(const B of V(F))for(const H of V(R))x.push(d.create([B,H],null,!1));T.unshift(r.create(x,null,!1))}this.negated=r.create(T,this,!0)}return this.negated}}class h extends E{static all(){return h._info.values()}constructor(T,F,R){super(T,null),this._defaultValue=F,typeof R=="object"?h._info.push({...R,key:T}):R!==!0&&h._info.push({key:T,description:R,type:F!=null?typeof F:void 0})}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return f.create(this.key,T)}notEqualsTo(T){return c.create(this.key,T)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(W,T){return W<T?-1:W>T?1:0}function P(W,T,F,R){return W<F?-1:W>F?1:T<R?-1:T>R?1:0}function L(W,T){if(W.type===0||T.type===1)return!0;if(W.type===9)return T.type===9?j(W.expr,T.expr):!1;if(T.type===9){for(const F of T.expr)if(L(W,F))return!0;return!1}if(W.type===6){if(T.type===6)return j(T.expr,W.expr);for(const F of W.expr)if(L(F,T))return!0;return!1}return W.equals(T)}e.implies=L;function j(W,T){let F=0,R=0;for(;F<W.length&&R<T.length;){const x=W[F].cmp(T[R]);if(x<0)return!1;x===0&&F++,R++}return F===W.length}function V(W){return W.type===9?W.expr:[W]}}),define(De[149],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ie([1,0,127,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function w(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function M(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function I(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(c,g){return g==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(c,g,b){return A(g,b)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===b?!0:k(b).includes(c)}e.isTargetPlatformCompatible=y;function k(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=O;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var E;(function(c){c.Install="install",c.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var t;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,b){super(g),this.code=b,this.name=b}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[36],Ie([1,0,46,19,10,9,2,129,3]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var S;(function(B){B[B.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=E;function f(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=t;function o(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function c(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=c;function g(B){return E(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var b;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(H,G){super(H),this.code=G}}e.FileSystemProviderError=p;function D(B,H){const G=new p(B.toString(),H);return s(G,H),G}e.createFileSystemProviderError=D;function n(B){return B||D((0,A.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=n;function s(B,H){return B.name=H?`${H} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=s;function a(B){if(!B)return b.Unknown;if(B instanceof p)return B.code;const H=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!H)return b.Unknown;switch(H[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=a;function l(B){if(B instanceof P)return B.fileOperationResult;switch(a(B)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var u;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class d{constructor(H,G,ee){this.resource=H,this.operation=G,this.target=ee}isOperation(H){return this.operation===H}}e.FileOperationEvent=d;var r;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class h{constructor(H,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const ee=new Map;for(const de of H){const ne=ee.get(de.type);switch(ne?ne.push([de.resource,de]):ee.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,ne]of ee)switch(de){case 1:this.added=i.TernarySearchTree.forUris(()=>G),this.added.fill(ne);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>G),this.updated.fill(ne);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>G),this.deleted.fill(ne);break}}contains(H,...G){return this.doContains(H,{includeChildren:!1},...G)}affects(H,...G){return this.doContains(H,{includeChildren:!0},...G)}doContains(H,G,...ee){if(!H)return!1;const de=ee.length>0;return!!((!de||ee.includes(1))&&(this.added?.get(H)||G.includeChildren&&this.added?.findSuperstr(H))||(!de||ee.includes(0))&&(this.updated?.get(H)||G.includeChildren&&this.updated?.findSuperstr(H))||(!de||ee.includes(2))&&(this.deleted?.findSubstr(H)||G.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(B,H,G){return!B||!H||B===H||H.length>B.length?!1:(H.charAt(H.length-1)!==C.sep&&(H+=C.sep),G?(0,w.startsWithIgnoreCase)(B,H):B.indexOf(H)===0)}e.isParent=v;class P extends Error{constructor(H,G,ee){super(H),this.fileOperationResult=G,this.options=ee}}e.FileOperationError=P;class L extends P{constructor(H,G,ee){super(H,2,ee),this.stat=G}}e.NotModifiedSinceFileOperationError=L;var j;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=W;async function T(B,H){if(!H.hasProvider(I.URI.from({scheme:B.scheme})))return new Promise(G=>{const ee=H.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===B.scheme&&de.added&&(ee.dispose(),G())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,M.isNumber)(H)||(H=0),H<F.KB?(0,A.localize)(1,null,H.toFixed(0)):H<F.MB?(0,A.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,A.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,A.localize)(4,null,(H/F.GB).toFixed(2)):(0,A.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var R;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function x(B){return{maxFileSize:B===0?300*F.MB:16*F.GB,maxHeapSize:B===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=x}),define(De[61],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...w){this._entries=new Map;for(const[M,I]of w)this.set(M,I)}set(w,M){const I=this._entries.get(w);return this._entries.set(w,M),I}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=i}),define(De[150],Ie([1,0,15,12,7,84,148,3,61,151]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class S extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new y.ServiceCollection,c=!1,g,b=O){this._services=o,this._strict=c,this._parent=g,this._enableTracing=b,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=b?g?._globalGraph??new I.Graph(p=>p):void 0}createChild(o){return new m(o,this._strict,this,this._enableTracing)}invokeFunction(o,...c){const g=f.traceInvocation(this._enableTracing,o);let b=!1;try{return o({get:D=>{if(b)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(D,g);if(!n)throw new Error(`[invokeFunction] unknown service '${D}'`);return n}},...c)}finally{b=!0,g.stop()}}createInstance(o,...c){let g,b;return o instanceof M.SyncDescriptor?(g=f.traceCreation(this._enableTracing,o.ctor),b=this._createInstance(o.ctor,o.staticArguments.concat(c),g)):(g=f.traceCreation(this._enableTracing,o),b=this._createInstance(o,c,g)),g.stop(),b}_createInstance(o,c=[],g){const b=A._util.getServiceDependencies(o).sort((n,s)=>n.index-s.index),p=[];for(const n of b){const s=this._getOrCreateServiceInstance(n.id,g);s||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(s)}const D=b.length>0?b[0].index:c.length;if(c.length!==D){console.trace(`[createInstance] First service dependency of ${o.name} at position ${D+1} conflicts with ${c.length} static arguments`);const n=D-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,D)}return Reflect.construct(o,c.concat(p))}_setServiceInstance(o,c){if(this._services.get(o)instanceof M.SyncDescriptor)this._services.set(o,c);else if(this._parent)this._parent._setServiceInstance(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const c=this._services.get(o);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):c}_getOrCreateServiceInstance(o,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const g=this._getServiceInstanceOrDescriptor(o);return g instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,c.branch(o,!0)):(c.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,c,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,c,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,c,g){const b=new I.Graph(n=>n.id.toString());let p=0;const D=[{id:o,desc:c,_trace:g}];for(;D.length;){const n=D.pop();if(b.lookupOrInsertNode(n),p++>1e3)throw new S(b);for(const s of A._util.getServiceDependencies(n.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(s.id);if(a||this._throwIfStrict(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.SyncDescriptor){const l={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};b.insertEdge(n,l),D.push(l)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new S(b);break}for(const{data:s}of n){if(this._getServiceInstanceOrDescriptor(s.id)instanceof M.SyncDescriptor){const l=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,l)}b.removeNode(s)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,c,g=[],b,p){if(this._services.get(o)instanceof M.SyncDescriptor)return this._createServiceInstance(o,c,g,b,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,c,g,b,p);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(o,c,g=[],b,p){if(b){const D=new m(void 0,this._strict,this,this._enableTracing);D._globalGraphImplicitDependency=String(o);const n=new Map,s=new i.IdleValue(()=>{const a=D._createInstance(c,g,p);for(const[l,u]of n){const d=a[l];if(typeof d=="function")for(const r of u)d.apply(a,r)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,l){if(!s.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let r=n.get(l);return r||(r=new k.LinkedList,n.set(l,r)),(v,P,L)=>{const j=r.push([v,P,L]);return(0,w.toDisposable)(j)}}if(l in a)return a[l];const u=s.value;let d=u[l];return typeof d!="function"||(d=d.bind(u),a[l]=d),d},set(a,l,u){return s.value[l]=u,!0}})}else return this._createInstance(c,g,p)}_throwIfStrict(o,c){if(c&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=m;var E;(function(t){t[t.Creation=0]="Creation",t[t.Invocation=1]="Invocation",t[t.Branch=2]="Branch"})(E||(E={}));class f{static traceInvocation(o,c){return o?new f(1,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(o,c){return o?new f(0,c.name):f._None}constructor(o,c){this.type=o,this.name=c,this._start=Date.now(),this._dep=[]}branch(o,c){const g=new f(2,o.toString());return this._dep.push([o,c,g]),g}stop(){const o=Date.now()-this._start;f._totals+=o;let c=!1;function g(p,D){const n=[],s=new Array(p+1).join("	");for(const[a,l,u]of D._dep)if(l&&u){c=!0,n.push(`${s}CREATES -> ${a}`);const d=g(p+1,u);d&&n.push(d)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(o>2||c)&&f.all.add(b.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(De[11],Ie([1,0,45,4,7,28,21,2,3]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function S(d,r,h){switch(r){case O.Trace:d.trace(h);break;case O.Debug:d.debug(h);break;case O.Info:d.info(h);break;case O.Warning:d.warn(h);break;case O.Error:d.error(h);break;default:throw new Error("Invalid log level")}}e.log=S;function m(d){let r="";for(let h=0;h<d.length;h++){let v=d[h];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}r+=(h>0?" ":"")+v}return r}e.format=m;class E extends w.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(r){super(),this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...h){this.checkLogLevel(O.Trace)&&this.log(O.Trace,m([r,...h]))}debug(r,...h){this.checkLogLevel(O.Debug)&&this.log(O.Debug,m([r,...h]))}info(r,...h){this.checkLogLevel(O.Info)&&this.log(O.Info,m([r,...h]))}warn(r,...h){this.checkLogLevel(O.Warning)&&this.log(O.Warning,m([r,...h]))}error(r,...h){if(this.checkLogLevel(O.Error))if(r instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=r.stack,this.log(O.Error,m(v))}else this.log(O.Error,m([r,...h]))}flush(){}}e.AbstractMessageLogger=f;class t extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.useColors=!I.isWindows}trace(r,...h){this.getLevel()<=O.Trace&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}debug(r,...h){this.getLevel()<=O.Debug&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}info(r,...h){this.getLevel()<=O.Info&&(this.useColors?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,r,...h):console.log(`[main ${k()}]`,r,...h))}warn(r,...h){this.getLevel()<=O.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,r,...h):console.warn(`[main ${k()}]`,r,...h))}error(r,...h){this.getLevel()<=O.Error&&(this.useColors?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,r,...h):console.error(`[main ${k()}]`,r,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class o extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...h){this.getLevel()<=O.Trace&&console.log("%cTRACE","color: #888",r,...h)}debug(r,...h){this.getLevel()<=O.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...h)}info(r,...h){this.getLevel()<=O.Info&&console.log("%c INFO","color: #33f",r,...h)}warn(r,...h){this.getLevel()<=O.Warning&&console.log("%c WARN","color: #993",r,...h)}error(r,...h){this.getLevel()<=O.Error&&console.log("%c  ERR","color: #f33",r,...h)}dispose(){}flush(){}}e.ConsoleLogger=o;class c extends E{constructor(r,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=r,this.setLevel(h)}trace(r,...h){this.getLevel()<=O.Trace&&this.adapter.log(O.Trace,[this.extractMessage(r),...h])}debug(r,...h){this.getLevel()<=O.Debug&&this.adapter.log(O.Debug,[this.extractMessage(r),...h])}info(r,...h){this.getLevel()<=O.Info&&this.adapter.log(O.Info,[this.extractMessage(r),...h])}warn(r,...h){this.getLevel()<=O.Warning&&this.adapter.log(O.Warning,[this.extractMessage(r),...h])}error(r,...h){this.getLevel()<=O.Error&&this.adapter.log(O.Error,[this.extractMessage(r),...h])}extractMessage(r){return typeof r=="string"?r:(0,i.toErrorMessage)(r,this.getLevel()<=O.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class g extends E{constructor(r){super(),this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const h of this.logServices)h.setLevel(r);super.setLevel(r)}trace(r,...h){for(const v of this.logServices)v.trace(r,...h)}debug(r,...h){for(const v of this.logServices)v.debug(r,...h)}info(r,...h){for(const v of this.logServices)v.info(r,...h)}warn(r,...h){for(const v of this.logServices)v.warn(r,...h)}error(r,...h){for(const v of this.logServices)v.error(r,...h)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=g;class b extends w.Disposable{constructor(r){super(),this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...h){this.logger.trace(r,...h)}debug(r,...h){this.logger.debug(r,...h)}info(r,...h){this.logger.info(r,...h)}warn(r,...h){this.logger.warn(r,...h)}error(r,...h){this.logger.error(r,...h)}flush(){this.logger.flush()}}e.LogService=b;class p extends w.Disposable{constructor(r,h){super(),this.logLevel=r,this.loggerItems=new M.ResourceMap,this._register(h(v=>this.setLevel(v)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:r})=>r)}getLogger(r){return this.loggerItems.get(r)?.logger}createLogger(r,h,v){let P=this.loggerItems.get(r)?.logger;return P||(v=h?.always?O.Trace:v,P=this.doCreateLogger(r,v??this.logLevel,h),this.loggerItems.set(r,{logger:P,logLevel:v})),P}setLevel(r,h){const v=A.URI.isUri(r)?r:void 0,P=v?h:r;if(v){const L=this.loggerItems.get(v);L&&L.logLevel!==P&&(L.logLevel=P,L.logger.setLevel(P))}else this.logLevel=P,this.loggerItems.forEach(({logLevel:L,logger:j})=>{L===void 0&&j.setLevel(this.logLevel)})}getLogLevel(r){return this.loggerItems.get(r)?.logLevel}dispose(){this.loggerItems.forEach(({logger:r})=>r.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=p;class D{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(r){}getLevel(){return O.Info}trace(r,...h){}debug(r,...h){}info(r,...h){}warn(r,...h){}error(r,...h){}critical(r,...h){}dispose(){}flush(){}}e.NullLogger=D;class n extends D{}e.NullLogService=n;class s extends p{constructor(){super(O.Info,C.Event.None)}doCreateLogger(r,h,v){return new D}}e.NullLoggerService=s;function a(d){if(d.verbose)return O.Trace;if(typeof d.logLevel=="string"){const r=u(d.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(d){switch(d){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=l;function u(d){switch(d){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=u}),define(De[86],Ie([1,0,29,130,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(f,t){return t-f}y.compare=k;const O=Object.create(null);O[y.Error]=(0,C.localize)(0,null),O[y.Warning]=(0,C.localize)(1,null),O[y.Info]=(0,C.localize)(2,null);function S(f){return O[f]||""}y.toString=S;function m(f){switch(f){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=m;function E(f){switch(f){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=E}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const k="";function O(m){return S(m,!0)}y.makeKey=O;function S(m,E){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(I.toString(m.severity)):f.push(k),m.message&&E?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}y.makeKeyOptionalMessage=S})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(De[152],Ie([1,0,4,29,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,w.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(De[87],Ie([1,0,10,2,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,w.createDecorator)("openerService");function M(k,O){return C.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,O):(0,i.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=M;function I(k,...O){return O.some(S=>M(k,S))}e.matchesSomeScheme=I;function A(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function y(k){let O;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return S&&(O={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=y}),define(De[153],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__decorate||function(te,e,i,C){var w=arguments.length,M=w<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,i,C);else for(var A=te.length-1;A>=0;A--)(I=te[A])&&(M=(w<3?I(M):w>3?I(e,i,M):I(e,i))||M);return w>3&&M&&Object.defineProperty(e,i,M),M},$e=this&&this.__param||function(te,e){return function(i,C){e(i,C,te)}};define(De[154],Ie([1,0,15,20,7,3]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(S){this.callback=S}report(S){this._value=S,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends w.Disposable{constructor(S,m){super(),this.deferred=new i.DeferredPromise,m.withProgress(S,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};y=We([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends w.Disposable{constructor(S){super(),this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(S){this.stop();const m=++this.currentOperationId,E=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:E.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(De[30],Ie([1,0,47,9]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(I,A){i.ok(C.isString(I)),i.ok(C.isObject(A)),i.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,A)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new w}),define(De[88],Ie([1,0,4,30]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[w(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new M;C.Registry.add(e.Extensions.JSONContribution,I)}),define(De[89],Ie([1,0,16,4,9,126,40,88,30]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=y.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=this.doRegisterConfigurations(n,s);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(n){const s=this.doDeregisterConfigurations(n);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=[];a.push(...this.doDeregisterConfigurations(s)),a.push(...this.doRegisterConfigurations(n,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,i.distinct)(a)})}registerDefaultConfigurations(n){const s=[],a=[];for(const{overrides:l,source:u}of n)for(const d in l)if(s.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const r=this.configurationDefaultsOverrides.get(d),h=r?.valuesSources??new Map;if(u)for(const j of Object.keys(l[d]))h.set(j,u);const v={...r?.value||{},...l[d]};this.configurationDefaultsOverrides.set(d,{source:u,value:v,valuesSources:h});const P=(0,I.getLanguageTagSettingPlainKey)(d),L={type:"object",default:v,description:M.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:w.isString(u)?void 0:u,defaultValueSource:u};a.push(...t(d)),this.configurationProperties[d]=L,this.defaultLanguageConfigurationOverridesNode.properties[d]=L}else{this.configurationDefaultsOverrides.set(d,{value:l[d],source:u});const r=this.configurationProperties[d];r&&(this.updatePropertyDefaultValue(d,r),this.updateSchema(d,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:a,source:l}of n)for(const u in a){const d=this.configurationDefaultsOverrides.get(u),r=w.isString(l)?l:l?.id,h=w.isString(d?.source)?d?.source:d?.source?.id;if(r===h)if(s.push(u),this.configurationDefaultsOverrides.delete(u),e.OVERRIDE_PROPERTY_REGEX.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const v=this.configurationProperties[u];v&&(this.updatePropertyDefaultValue(u,v),this.updateSchema(u,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s){const a=[];return n.forEach(l=>{a.push(...this.validateAndRegisterProperties(l,s,l.extensionInfo,l.restrictedProperties)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),a}doDeregisterConfigurations(n){const s=[],a=l=>{if(l.properties)for(const u in l.properties){s.push(u);const d=this.configurationProperties[u];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[u],this.removeFromSchema(u,l.properties[u])}l.allOf?.forEach(u=>a(u))};for(const l of n){a(l);const u=this.configurationContributors.indexOf(l);u!==-1&&this.configurationContributors.splice(u,1)}return s}validateAndRegisterProperties(n,s=!0,a,l,u=3){u=w.isUndefinedOrNull(n.scope)?u:n.scope;const d=[],r=n.properties;if(r)for(const v in r){const P=r[v];if(s&&b(v,P)){delete r[v];continue}if(P.source=a,P.defaultDefaultValue=r[v].default,this.updatePropertyDefaultValue(v,P),e.OVERRIDE_PROPERTY_REGEX.test(v)?P.scope=void 0:(P.scope=w.isUndefinedOrNull(P.scope)?u:P.scope,P.restricted=w.isUndefinedOrNull(P.restricted)?!!l?.includes(v):P.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.excludedConfigurationProperties[v]=r[v],delete r[v];continue}else this.configurationProperties[v]=r[v],r[v].policy?.name&&this.policyConfigurations.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),d.push(v)}const h=n.allOf;if(h)for(const v of h)d.push(...this.validateAndRegisterProperties(v,s,a,l,u));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=a=>{const l=a.properties;if(l)for(const d in l)this.updateSchema(d,l[d]);a.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const a=this.configurationDefaultsOverrides.get(n);let l=a?.value,u=a?.source;w.isUndefined(l)&&(l=s.defaultDefaultValue,u=void 0),w.isUndefined(l)&&(l=c(s.type)),s.default=l,s.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",f=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(D){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let s=f.exec(D);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=f.exec(D)}}return(0,i.distinct)(n)}e.overrideIdentifiersFromKey=t;function o(D){return D.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=o;function c(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const g=new m;y.Registry.add(e.Extensions.Configuration,g);function b(D,n){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?M.localize(7,null,D):g.getConfigurationProperties()[D]!==void 0?M.localize(8,null,D):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,D,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.validateProperty=b;function p(){const D=[],n=g.getConfigurationProperties();for(const s of Object.keys(n))D.push([s,n[s].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=p}),define(De[155],Ie([1,0,16,4,106,7,28,23,9,2,40,89,30]),function(te,e,i,C,w,M,I,A,y,k,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class E{constructor(s={},a=[],l=[],u){this._contents=s,this._keys=a,this._overrides=l,this.raw=u,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof E)return a;const l=new f("");return l.parseRaw(a),l.configurationModel});this._rawConfiguration=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,O.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const l=this.rawConfiguration.getValue(s),u=a?this.rawConfiguration.getOverrideValue(s,a):void 0,d=a?this.rawConfiguration.override(a).getValue(s):l;return{value:l,override:u,merged:d}}getOverrideValue(s,a){const l=this.getContentsForOverrideIdentifer(a);return l?s?(0,O.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return i.distinct(s)}override(s){let a=this.overrideConfigurations.get(s);return a||(a=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,a)),a}merge(...s){const a=A.deepClone(this.contents),l=A.deepClone(this.overrides),u=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const r of s)if(d.push(...r.raw?.length?r.raw:[r]),!r.isEmpty()){this.mergeContents(a,r.contents);for(const h of r.overrides){const[v]=l.filter(P=>i.equals(P.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=i.distinct(v.keys)):l.push(A.deepClone(h))}for(const h of r.keys)u.indexOf(h)===-1&&u.push(h)}return new E(a,u,l,d.every(r=>r instanceof E)?void 0:d)}freeze(){return this.frozen=!0,this}clone(){return new E(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(s){const a=this.getContentsForOverrideIdentifer(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const u of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let d=this.contents[u];const r=a[u];r&&(typeof d=="object"&&typeof r=="object"?(d=A.deepClone(d),this.mergeContents(d,r)):d=r),l[u]=d}return new E(l,this.keys,this.overrides)}mergeContents(s,a){for(const l of Object.keys(a)){if(l in s&&y.isObject(s[l])&&y.isObject(a[l])){this.mergeContents(s[l],a[l]);continue}s[l]=A.deepClone(a[l])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?A.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let a=null,l=null;const u=d=>{d&&(l?this.mergeContents(l,d):l=A.deepClone(d))};for(const d of this.overrides)i.equals(d.identifiers,[s])?a=d.contents:d.identifiers.includes(s)&&u(d.contents);return u(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,a){this.addKey(s),(0,O.addToValueTree)(this.contents,s,a,l=>{throw new Error(l)})}removeValue(s){this.removeKey(s)&&(0,O.removeFromValueTree)(this.contents,s)}addKey(s){let a=this.keys.length;for(let l=0;l<a;l++)s.indexOf(this.keys[l])===0&&(a=l);this.keys.splice(a,1,s)}removeKey(s){const a=this.keys.indexOf(s);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=E;class f{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,a){if(!y.isUndefinedOrNull(s)){const l=this.doParseContent(s);this.parseRaw(l,a)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,a){this._raw=s;const{contents:l,keys:u,overrides:d,restricted:r,hasExcludedProperties:h}=this.doParseRaw(s,a);this._configurationModel=new E(l,u,d,h?[s]:void 0),this._restrictedConfigurations=r||[]}doParseContent(s){let a={},l=null,u=[];const d=[],r=[];function h(P){Array.isArray(u)?u.push(P):l!==null&&(u[l]=P)}const v={onObjectBegin:()=>{const P={};h(P),d.push(u),u=P,l=null},onObjectProperty:P=>{l=P},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const P=[];h(P),d.push(u),u=P,l=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:h,onError:(P,L,j)=>{r.push({error:P,offset:L,length:j})}};if(s)try{w.visit(s,v),a=u[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return a}doParseRaw(s,a){const l=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),u=this.filter(s,l,!0,a);s=u.raw;const d=(0,O.toValuesTree)(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),r=Object.keys(s),h=this.toOverrides(s,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:d,keys:r,overrides:h,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(s,a,l,u){let d=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:d};const r={},h=[];for(const v in s)if(S.OVERRIDE_PROPERTY_REGEX.test(v)&&l){const P=this.filter(s[v],a,!1,u);r[v]=P.raw,d=d||P.hasExcludedProperties,h.push(...P.restricted)}else{const P=a[v],L=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&h.push(v),(L===void 0||u.scopes===void 0||u.scopes.includes(L))&&!(u.skipRestricted&&P?.restricted)?r[v]=s[v]:d=!0}return{raw:r,restricted:h,hasExcludedProperties:d}}toOverrides(s,a){const l=[];for(const u of Object.keys(s))if(S.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const r in s[u])d[r]=s[u][r];l.push({identifiers:(0,S.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,O.toValuesTree)(d,a)})}return l}}e.ConfigurationModelParser=f;class t extends M.Disposable{constructor(s,a,l,u){super(),this.userSettingsResource=s,this.scopes=a,this.fileService=u,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&l.isEqual(d.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class o{constructor(s,a,l,u,d,r,h,v,P,L,j,V,W){this.key=s,this.overrides=a,this.value=l,this.overrideIdentifiers=u,this.defaultConfiguration=d,this.policyConfiguration=r,this.applicationConfiguration=h,this.userConfiguration=v,this.localUserConfiguration=P,this.remoteUserConfiguration=L,this.workspaceConfiguration=j,this.folderConfigurationModel=V,this.memoryInspectValue=W}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class c{constructor(s,a,l,u,d=new E,r=new E,h=new I.ResourceMap,v=new E,P=new I.ResourceMap,L=!0){this._defaultConfiguration=s,this._policyConfiguration=a,this._applicationConfiguration=l,this._localUserConfiguration=u,this._remoteUserConfiguration=d,this._workspaceConfiguration=r,this._folderConfigurations=h,this._memoryConfiguration=v,this._memoryConfigurationByResource=P,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(s,a,l){return this.getConsolidatedConfigurationModel(s,a,l).getValue(s)}updateValue(s,a,l={}){let u;l.resource?(u=this._memoryConfigurationByResource.get(l.resource),u||(u=new E,this._memoryConfigurationByResource.set(l.resource,u))):u=this._memoryConfiguration,a===void 0?u.removeValue(s):u.setValue(s,a),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,a,l){const u=this.getConsolidatedConfigurationModel(s,a,l),d=i.distinct(u.overrides.map(v=>v.identifiers).flat()).filter(v=>u.getOverrideValue(s,v)!==void 0),r=this.getFolderConfigurationModelForResource(a.resource,l),h=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration;return new o(s,a,u.getValue(s),d.length?d:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),l?this._workspaceConfiguration.freeze():void 0,r?r.freeze():void 0,h.inspect(s,a.overrideIdentifier))}keys(s){const a=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,a){this._folderConfigurations.set(s,a),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:u,updated:d,removed:r}=p(this._defaultConfiguration,s);a=[...u,...d,...r]}for(const u of a)for(const d of(0,S.overrideIdentifiersFromKey)(u)){const r=this._defaultConfiguration.getKeysForOverrideIdentifier(d),h=s.getKeysForOverrideIdentifier(d),v=[...h.filter(P=>r.indexOf(P)===-1),...r.filter(P=>h.indexOf(P)===-1),...r.filter(P=>!A.equals(this._defaultConfiguration.override(d).getValue(P),s.override(d).getValue(P)))];l.push([d,v])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:u}=p(this._policyConfiguration,s),d=[...a,...l,...u];return d.length&&this.updatePolicyConfiguration(s),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:u,overrides:d}=p(this.applicationConfiguration,s),r=[...a,...l,...u];return r.length&&this.updateApplicationConfiguration(s),{keys:r,overrides:d}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:u,overrides:d}=p(this.localUserConfiguration,s),r=[...a,...l,...u];return r.length&&this.updateLocalUserConfiguration(s),{keys:r,overrides:d}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:u,overrides:d}=p(this.remoteUserConfiguration,s),r=[...a,...l,...u];return r.length&&this.updateRemoteUserConfiguration(s),{keys:r,overrides:d}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:u,overrides:d}=p(this.workspaceConfiguration,s),r=[...a,...l,...u];return r.length&&this.updateWorkspaceConfiguration(s),{keys:r,overrides:d}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:u,updated:d,removed:r,overrides:h}=p(l,a),v=[...u,...d,...r];return(v.length||!l)&&this.updateFolderConfiguration(s,a),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:u,removed:d,overrides:r}=p(a,void 0);return{keys:[...l,...u,...d],overrides:r}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,a,l){let u=this.getConsolidatedConfigurationModelForResource(a,l);return a.overrideIdentifier&&(u=u.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:s},a){let l=this.getWorkspaceConsolidatedConfiguration();if(a&&s){const u=a.getFolder(s);u&&(l=this.getFolderConsolidatedConfiguration(u.uri)||l);const d=this._memoryConfigurationByResource.get(s);d&&(l=l.merge(d))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let a=this._foldersConsolidatedConfigurations.get(s);if(!a){const l=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(s);u?(a=l.merge(u),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(s,a)):a=l}return a}getFolderConfigurationModelForResource(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,a)=>{const{contents:l,overrides:u,keys:d}=this._folderConfigurations.get(a);return s.push([a,{contents:l,overrides:u,keys:d}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>s.add(a)),this.userConfiguration.freeze().keys.forEach(a=>s.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>s.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(l=>s.add(l))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this._folderConfigurations.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u))),[...a.values()]}static parse(s){const a=this.parseConfigurationModel(s.defaults),l=this.parseConfigurationModel(s.policy),u=this.parseConfigurationModel(s.application),d=this.parseConfigurationModel(s.user),r=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((v,P)=>(v.set(k.URI.revive(P[0]),this.parseConfigurationModel(P[1])),v),new I.ResourceMap);return new c(a,l,u,d,new E,r,h,new E,new I.ResourceMap,!1)}static parseConfigurationModel(s){return new E(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=c;function g(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,a=new Map;for(const u of n)u.keys.forEach(d=>s.add(d)),u.overrides.forEach(([d,r])=>{const h=(0,I.getOrSet)(a,d,new Set);r.forEach(v=>h.add(v))});const l=[];return a.forEach((u,d)=>l.push([d,[...u.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=g;class b{constructor(s,a,l,u){this.change=s,this.previous=a,this.currentConfiguraiton=l,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;s.keys.forEach(h=>d.add(h)),s.overrides.forEach(([,h])=>h.forEach(v=>d.add(v))),this.affectedKeys=[...d.values()];const r=new E;this.affectedKeys.forEach(h=>r.setValue(h,{})),this.affectedKeysTree=r.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=c.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(a){const l=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(s,a,this.currentWorkspace);return!A.equals(l,u)}return!0}return!1}doesAffectedKeysTreeContains(s,a){let l=(0,O.toValuesTree)({[a]:!0},()=>{}),u;for(;typeof l=="object"&&(u=Object.keys(l)[0]);){if(s=s[u],!s)return!1;l=l[u]}return!0}}e.ConfigurationChangeEvent=b;function p(n,s){const{added:a,removed:l,updated:u}=D(s?.rawConfiguration,n?.rawConfiguration),d=[],r=n?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const v=h.filter(P=>!r.includes(P));for(const P of v)d.push([P,s.getKeysForOverrideIdentifier(P)])}if(n){const v=r.filter(P=>!h.includes(P));for(const P of v)d.push([P,n.getKeysForOverrideIdentifier(P)])}if(s&&n){for(const v of r)if(h.includes(v)){const P=D({contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)},{contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)});d.push([v,[...P.added,...P.removed,...P.updated]])}}return{added:a,removed:l,updated:u,overrides:d}}function D(n,s){const a=n?s?n.keys.filter(d=>s.keys.indexOf(d)===-1):[...n.keys]:[],l=s?n?s.keys.filter(d=>n.keys.indexOf(d)===-1):[...s.keys]:[],u=[];if(n&&s){for(const d of s.keys)if(n.keys.indexOf(d)!==-1){const r=(0,O.getConfigurationValue)(s.contents,d),h=(0,O.getConfigurationValue)(n.contents,d);A.equals(r,h)||u.push(d)}}return{added:a,removed:l,updated:u}}}),define(De[90],Ie([1,0,12,3]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var w;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends i.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof M&&A._code===w.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===w.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===w.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}constructor(A,y=w.Unknown,k){super(A),this._message=A,this._code=y,this._detail=k,this.isHandled=y===w.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(De[62],Ie([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function w(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=w;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function I(k){const{host:O,port:S}=y(k);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:S}}e.parseAuthorityWithPort=I;function A(k,O){let{host:S,port:m}=y(k);return typeof m>"u"&&(m=O),{host:S,port:m}}e.parseAuthorityWithOptionalPort=A;function y(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const S=k.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(De[25],Ie([1,0,10,3,62]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const c=typeof t=="string"?t:t.value,g=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(c,g)}return t._lower===o._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=k;function O(f){return S(f)}e.isApplicationScopedExtension=O;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function E(f,t){if(t){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(t)}`;return f.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[156],Ie([1,0,10,85,25,21,2,12,48]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,i.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(a){const l=a.manifest?a.manifest.version:a.version,u=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new S(a.identifier,l,u)}static parse(a){const l=O.exec(a);return l&&l[1]&&l[2]?new S({id:l[1]},l[2],l[4]||void 0):null}constructor(a,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof S?k(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(s){const a=m.exec(s);return a&&a[1]?[t(a[1]),a[2]]:[t(s),void 0]}e.getIdAndVersion=E;function f(s,a){return`${s}.${a}`}e.getExtensionId=f;function t(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function o(s,a){return t(f(s,a))}e.getGalleryExtensionId=o;function c(s,a){const l=[],u=d=>{for(const r of l)if(r.some(h=>k(a(h),a(d))))return r;return null};for(const d of s){const r=u(d);r?r.push(d):l.push([d])}return l}e.groupByExtension=c;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function b(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function p(s,a){const l=[],u=a.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const d=u.shift();if(d&&l.every(r=>!k(r.identifier,{id:d}))){const r=s.filter(h=>k(h.identifier,{id:d}));r.length===1&&(l.push(r[0]),u.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=p;async function D(s,a){if(!M.isLinux)return!1;let l;try{l=(await s.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){a.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=D;async function n(s,a){const l=await D(s,a),u=(0,C.getTargetPlatform)(l?"alpine":M.platform,y.arch);return a.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=n}),define(De[157],Ie([1,0,21,48,2,34]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function A(k,O,S,m,E,f,t,o,c,g){const b=Object.create(null);b["common.machineId"]=t,b.sessionID=(0,M.generateUuid)()+Date.now(),b.commitHash=E,b.version=f,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,i.PlatformToString)(i.platform),b["common.nodePlatform"]=C.platform,b["common.nodeArch"]=m,b["common.product"]=g||"desktop",o&&(b["common.msftInternal"]=o);let p=0;const D=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),i.isLinuxSnap&&(b["common.snap"]="true");const n=I(S);n&&(b["common.platformDetail"]=n);try{const s=await k.readFile(w.URI.file(c));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(k){const O=C.env.USERDNSDOMAIN;if(!O)return!1;const S=O.toLowerCase();return k.some(m=>S===m)}e.verifyMicrosoftInternalDomain=y}),define(De[158],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[159],Ie([1,0,23,116,9,40,157,158]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(u,d){return Promise.resolve(void 0)}publicLog2(u,d){return this.publicLog(u,d)}publicLogError(u,d){return Promise.resolve(void 0)}publicLogError2(u,d){return this.publicLogError(u,d)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class k{async publicLog(u,d,r){}async publicLogError(u,d,r){}}e.NullEndpointTelemetryService=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function O(l,u){return u.onDidChangeConfiguration(d=>{d.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(d.source),configurationKeys:g(d.sourceConfig)})})}e.configurationTelemetry=O;function S(l,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!l.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=S;function m(l,u){return!(u.isBuilt||u.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=m;function E(l){const u=l.getValue(A.TELEMETRY_SETTING_ID),d=l.getValue("telemetry.enableCrashReporter");if(l.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function f(l){const u={},d={},r={};c(l,r);for(let h in r){h=h.length>150?h.substr(h.length-149):h;const v=r[h];typeof v=="number"?d[h]=v:typeof v=="boolean"?d[h]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${v.length}`),u[h]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(u[h]=v)}return{properties:u,measurements:d}}e.validateTelemetryData=f;const t=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function o(l){if(!l)return"none";for(const u of t)if(l.startsWith(`${u}+`))return u;return"other"}e.cleanRemoteAuthority=o;function c(l,u,d=0,r){if(!!l)for(const h of Object.getOwnPropertyNames(l)){const v=l[h],P=r?r+h:h;Array.isArray(v)?u[P]=(0,i.safeStringify)(v):v instanceof Date?u[P]=v.toISOString():(0,w.isObject)(v)?d<2?c(v,u,d+1,P+"."):u[P]=(0,i.safeStringify)(v):u[P]=v}}function g(l){if(!l)return[];const u=[];return b(u,"",l),u}function b(l,u,d){d&&typeof d=="object"&&!Array.isArray(d)?Object.keys(d).forEach(r=>b(l,u?`${u}.${r}`:r,d[r])):l.push(u)}function p(l,u){const d=l.msftInternalDomains||[],r=u.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(d)||r}e.isInternalTelemetry=p;function D(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=D;function n(l,u){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let d=l;const r=[];for(const L of u)for(;;){const j=L.exec(l);if(!j)break;r.push([j.index,L.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(d="";;){const L=v.exec(l);if(!L)break;const j=r.some(([V,W])=>L.index<W&&V<v.lastIndex);!h.test(L[0])&&!j&&(d+=l.substring(P,L.index)+"<REDACTED: user-file-path>",P=v.lastIndex)}return P<l.length&&(d+=l.substr(P)),d}function s(l){if(!l)return l;const u=l.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of d)if(r.regex.test(u))return`<REDACTED: ${r.label}>`;return l}function a(l,u){return(0,i.cloneAndChange)(l,d=>{if(typeof d=="string"){let r=d;r=n(r,u);for(const h of u)r=r.replace(h,"");return r=s(r),r}})}e.cleanData=a}),define(De[160],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,M,I=5){const A=M(y=>{const k=typeof y=="string"?y:y.data;let O=this._terminalBufferMap.get(w);if(O){O.data.push(k);return}const S=setTimeout(()=>this.flushBuffer(w),I);O={data:[k],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,O)});return A}stopBuffering(w){this._terminalBufferMap.get(w)?.dispose()}flushBuffer(w){const M=this._terminalBufferMap.get(w);M&&(this._terminalBufferMap.delete(w),this._callback(w,M.data.join("")))}}e.TerminalDataBufferer=i}),define(De[161],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function C(M){return M===i.HIGH_CONTRAST_DARK||M===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function w(M){return M===i.DARK||M===i.HIGH_CONTRAST_DARK}e.isDark=w}),define(De[63],Ie([1,0,119,4,7,3,30,161]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var y;(function(o){function c(g){return g&&typeof g=="object"&&typeof g.id=="string"}o.isThemeColor=c})(y=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||y.isThemeColor(l.color))}o.isThemeIcon=c;const g=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function b(l){const u=g.exec(l);if(!u)return;const[,d]=u;return{id:d}}o.fromString=b;function p(l){return{id:l}}o.fromId=p;function D(l,u){let d=l.id;const r=d.lastIndexOf("~");return r!==-1&&(d=d.substring(0,r)),u&&(d=`${d}~${u}`),{id:d}}o.modify=D;function n(l){const u=l.id.lastIndexOf("~");if(u!==-1)return l.id.substring(u+1)}o.getModifier=n;function s(l,u){return l.id===u.id&&l.color?.id===u.color?.id}o.isEqual=s;function a(l,u){return{id:l.id,color:u?k(u):void 0}}o.asThemeIcon=a,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function S(o){switch(o){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(c){return this.themingParticipants.push(c),this.onThemingParticipantAddedEmitter.fire(c),(0,w.toDisposable)(()=>{const g=this.themingParticipants.indexOf(c);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const E=new m;I.Registry.add(e.Extensions.ThemingContribution,E);function f(o){return E.onColorThemeChange(o)}e.registerThemingParticipant=f;class t extends w.Disposable{constructor(c){super(),this.themeService=c,this.theme=c.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(c){this.theme=c,this.updateStyles()}updateStyles(){}getColor(c,g){let b=this.theme.getColor(c);return b&&g&&(b=g(b,this.theme)),b?b.toString():null}}e.Themable=t}),define(De[162],Ie([1,0,4,40,3,11]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var I;(function(t){t.Http="http",t.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=S;function m(t,o,c,g){if(c===1)return!1;if(c===2&&S(o)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(b?.length===4&&parseInt(b[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class E{constructor(o,c,g){this.remoteAddress=o,this.localAddress=c,this._dispose=g,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let f=class{constructor(o,c){this.logService=o,this.configurationService=c,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],c=Array.from(this._tunnels.values());for(const g of c){const b=Array.from(g.values());for(const p of b){const D=await p.value;D&&o.push(D)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:c}of o.values())await c.then(g=>g?.dispose());o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,c,g,b,p){this.addTunnelToMap(o,c,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:c,localAddress:g,privacy:b,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,c){(S(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(o,c);if(g)return++g.refcount,g.value}openTunnel(o,c,g,b,p=!1,D,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${b}.`),!o)return;if(c||(c="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(o,c,g,b,p,D,n);return s?s.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(a);return(a.tunnelRemoteHost!==c||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const c=this._tunnels.get(o.tunnelRemoteHost);if(c){const g=c.get(o.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async tryDisposeTunnel(o,c,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${c}.`);const b=g.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(c),b}}async closeTunnel(o,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${c} `);const g=this._tunnels.get(o);if(g&&g.has(c)){const b=g.get(c);b.refcount=0,await this.tryDisposeTunnel(o,c,b)}}addTunnelToMap(o,c,g){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(c,{refcount:1,value:g})}async removeEmptyTunnelFromMap(o,c){const g=this._tunnels.get(o);g&&(await g.get(c)||g.delete(c),g.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,c){const g=[o];O(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):S(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(p=>this._tunnels.get(p));for(const p of b){const D=p?.get(c);if(D)return D}}canTunnel(o){return!!k(o)}createWithProvider(o,c,g,b,p,D,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${b}.`);const s=g;this._factoryInProgress.add(s);const a=b===void 0?g:b,l={elevationRequired:p?this.isPortPrivileged(a):!1},u={remoteAddress:{host:c,port:g},localAddressPort:b,privacy:D,public:D?D!==A.Private:void 0,protocol:n},d=o.forwardPort(u,l);return d?(this.addTunnelToMap(c,g,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),d}};f=We([$e(0,M.ILogService),$e(1,C.IConfigurationService)],f),e.AbstractTunnelService=f}),define(De[163],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var C;(function(w){w[w.Complete=100]="Complete",w[w.Partial=50]="Partial",w[w.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[164],Ie([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=C;function w(y){if(y.folders.length)return y.folders.every(k=>C(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=w;function M(y){return w(y)?.scheme}e.getVirtualWorkspaceScheme=M;function I(y){return w(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return w(y)!==void 0}e.isVirtualWorkspace=A}),define(De[49],Ie([1,0,131,19,46,22,2,3,13]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(s){const a=s;return typeof a?.id=="string"&&I.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,C.basename)(s)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const l=s;if(l.configuration)return{id:l.id,configPath:l.configuration};if(l.folders.length===1)return{id:l.id,uri:l.folders[0].uri}}e.toWorkspaceIdentifier=O;function S(s){const a=s;return typeof a?.id=="string"&&I.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=S;function m(s){const a=s;if(a?.uri)return{id:a.id,uri:I.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=m;var E;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function f(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function t(s){const a=s;return!!(a&&typeof a=="object"&&I.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(a,l,u,d,r){this._id=a,this._transient=u,this._configuration=d,this._ignorePathCasing=r,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class c{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,M.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function g(s){return new c({uri:s,index:0,name:(0,M.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(s,a){return M.extUriBiasedIgnorePathCase.isEqualOrParent(s,a.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function p(s){let a;return I.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p;function D(s,a){return!b(s,a)&&!p(s)}e.isSavedWorkspace=D;function n(s){return(typeof s=="string"?(0,C.extname)(s):(0,M.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(De[64],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const M=this._idPool++;return this._data.set(M,w),this.logDebugInfo(),M}get(w,M){return this._data.has(w)?this._data.get(w)[M]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(De[37],Ie([1,0,13,22,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(De[165],Ie([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,A,y){this._deferredPromises=new Map,this._id=I,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of k.values())O.complete()}catch(O){for(const S of k.values())S.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,A){let y=this._value[I];return typeof y>"u"&&(y=A),y}update(I,A){this._value[I]=A;const y=this._deferredPromises.get(I);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this._deferredPromises.set(I,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class w extends C{setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this._extension=I}}e.ExtensionGlobalMemento=w}),define(De[166],Ie([1,0,4,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class w{constructor(I){this._notebooksAndEditors=I,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(I,A,y,k){const S=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(A.value,y,k);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(I,A){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(I));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=w}),define(De[14],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[167],Ie([1,0,25,4]),function(te,e,i,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,y){w.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Je(this,w,y,"f"),Ae(this,w,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Ae(this,w,"f").get(this._id,A)}store(A,y){return Ae(this,w,"f").store(this._id,A,y)}delete(A){return Ae(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=M,w=new WeakMap}),define(De[65],Ie([1,0,3,162,4,14]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function k(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:S.protocol}}y.fromApiTunnel=k;function O(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==C.TunnelPrivacyId.ConstantPrivate&&S.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}y.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,S,m,E){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=We([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(De[50],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(De[168],Ie([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function w(A,y){if(y.serializeBuffersForPostMessage){const k=new C,O=(E,f)=>{if(f instanceof ArrayBuffer){const t=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=M(f);if(t){const o=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},S=JSON.stringify(A,O),m=k.buffers.map(E=>{const f=new Uint8Array(E);return i.VSBuffer.wrap(f)});return{message:S,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const k=y.map(m=>{const E=new ArrayBuffer(m.byteLength);return new Uint8Array(E).set(m.buffer),E}),O=y.length?(m,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const f=E,{index:t}=f,o=k[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return E}:void 0;return{message:JSON.parse(A,O),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(De[91],Ie([1,0,139,9,2,7,3,30,36,13]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const ee=G;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=m;function E(G,ee,de){for(const ne of de.visibleEditorPanes)if(ne.group.id===ee&&G.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=E;function f(G){if(u(G))return!1;const ee=G;return w.URI.isUri(ee?.resource)}e.isResourceEditorInput=f;function t(G){if(u(G))return!1;const ee=G;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=t;function o(G){if(u(G)||t(G))return!1;const ee=G;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function c(G){if(u(G))return!1;const ee=G;return ee?ee.resource===void 0||ee.resource.scheme===k.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;const g=/Untitled-\d+/;function b(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!g.test(G.path)}e.isUntitledWithAssociatedResource=b;function p(G){if(u(G))return!1;const ee=G;return w.URI.isUri(ee?.base?.resource)&&w.URI.isUri(ee?.input1?.resource)&&w.URI.isUri(ee?.input2?.resource)&&w.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=p;var D;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var n;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(ee,de){let ne=this.mapIdToSaveSource.get(ee);return ne||(ne={source:ee,label:de},this.mapIdToSaveSource.set(ee,ne)),ne.source}getSourceLabel(ee){return this.mapIdToSaveSource.get(ee)?.label??ee}}e.SaveSourceRegistry=new s;var a;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends M.Disposable{}e.AbstractEditorInput=l;function u(G){return G instanceof l}e.isEditorInput=u;function d(G){const ee=G;return w.URI.isUri(ee?.preferredResource)}function r(G){const ee=G;return u(ee?.primary)&&u(ee?.secondary)}e.isSideBySideEditorInput=r;function h(G){const ee=G;return u(ee?.modified)&&u(ee?.original)}e.isDiffEditorInput=h;function v(G){return u(G?.editor)}e.isEditorInputWithOptions=v;function P(G){const ee=G;return v(G)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function L(G){const ee=G;return typeof ee?.groupId=="number"&&u(ee.editor)}e.isEditorIdentifier=L;var j;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var W;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(W=e.SideBySideEditor||(e.SideBySideEditor={}));class T{getOriginalUri(ee,de){if(!ee)return;if(p(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,de);if(de?.supportSideBySide){const{primary:me,secondary:le}=this.getSideEditors(ee);if(me&&le){if(de?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===W.ANY)return this.getOriginalUri(me,{filterByScheme:de.filterByScheme})??this.getOriginalUri(le,{filterByScheme:de.filterByScheme});ee=de.supportSideBySide===W.PRIMARY?me:le}}if(t(ee)||o(ee)||p(ee))return;const ne=d(ee)?ee.preferredResource:ee.resource;return!ne||!de||!de.filterByScheme?ne:this.filterUri(ne,de.filterByScheme)}getSideEditors(ee){return r(ee)||o(ee)?{primary:ee.primary,secondary:ee.secondary}:h(ee)||t(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,de){if(!ee)return;if(p(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,de);if(de?.supportSideBySide){const{primary:me,secondary:le}=this.getSideEditors(ee);if(me&&le){if(de?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===W.ANY)return this.getCanonicalUri(me,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:de.filterByScheme});ee=de.supportSideBySide===W.PRIMARY?me:le}}if(t(ee)||o(ee)||p(ee))return;const ne=ee.resource;return!ne||!de||!de.filterByScheme?ne:this.filterUri(ne,de.filterByScheme)}filterUri(ee,de){if(Array.isArray(de)){if(de.some(ne=>ee.scheme===ne))return ee}else if(de===ee.scheme)return ee}}e.EditorResourceAccessor=new T;var F;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(F=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ee){const de=this.instantiationService=ee.get(I.IInstantiationService);for(const[ne,me]of this.editorSerializerConstructors)this.createEditorSerializer(ne,me,de);this.editorSerializerConstructors.clear()}createEditorSerializer(ee,de,ne){const me=ne.createInstance(de);this.editorSerializerInstances.set(ee,me)}registerFileEditorFactory(ee){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ee}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ee,de){if(this.editorSerializerConstructors.has(ee)||this.editorSerializerInstances.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ee,de,this.instantiationService):this.editorSerializerConstructors.set(ee,de),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ee),this.editorSerializerInstances.delete(ee)})}getEditorSerializer(ee){return this.editorSerializerInstances.get(typeof ee=="string"?ee:ee.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function x(G,ee,de){return!G||!G.length?[]:await Promise.all(G.map(async ne=>{const me=w.URI.revive(ne.fileUri);if(!me){de.info("Cannot resolve the path because it is not valid.",ne);return}if(!await ee.canHandleResource(me)){de.info("Cannot resolve the path because it cannot be handled",ne);return}let ue=ne.exists,Q=ne.type;if(typeof ue!="boolean"||typeof Q!="number")try{Q=(await ee.stat(me)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ue=!0}catch(Se){de.error(Se),ue=!1}if(!ue&&ne.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",ne);return}if(Q===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",ne);return}const ge={...ne.options,pinned:!0};return ue?{resource:me,options:ge}:{resource:me,options:ge,forceUntitled:!0}}))}e.pathsToEditors=x;var B;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function H(G){const ee=G;if(!ee)return!1;const de=ee;if(de.modified)return H(de.modified);const ne=ee;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=H}),define(De[66],Ie([1,0,13,2]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function w(A,y){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===i.Schemas.file&&(A=C.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:A.path})),C.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function M(A){return A.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=I}),define(De[169],Ie([1,0,4,7,66]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,y,k){this._proxy=A,this._editors=y,this._remoteInfo=k,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const S of this._insets.values())O.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,k,O,S){let m;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===A){m=b;break}if(!m)throw new Error("not a visible editor");const E=this,f=this._handlePool++,t=new i.Emitter,o=new i.Emitter,c=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,w.asWebviewUri)(b,E._remoteInfo)}get cspSource(){return w.webviewGenericCspSource}set options(b){this._options=b,E._proxy.$setOptions(f,b)}get options(){return this._options}set html(b){this._html=b,E._proxy.$setHtml(f,b)}get html(){return this._html}get onDidReceiveMessage(){return t.event}postMessage(b){return E._proxy.$postMessage(f,b)}},g=new class{constructor(){this.editor=A,this.line=y,this.height=k,this.webview=c,this.onDidDispose=o.event}dispose(){E._insets.has(f)&&(E._insets.delete(f),E._proxy.$disposeEditorInset(f),o.fire(),o.dispose(),t.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,y+1,k,O||{},S.identifier,S.extensionLocation),this._insets.set(f,{editor:A,inset:g,onDidReceiveMessage:t}),g}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(De[170],Ie([1,0,4,15,140]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,k,O){const S={command:A};if(y&&Object.keys(y).length>0&&(S.arguments=y),this.internalSend("request",S),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const E=this.pendingRequests.get(S.seq);if(E){this.pendingRequests.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:A,message:(0,w.localize)(0,null,O,A)};E(f)}},O)}return k&&this.pendingRequests.set(S.seq,k),S.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,C.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,k)=>A.set(k,y)),await(0,C.timeout)(500),A.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(De[171],Ie([1,0,141,41,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const M=m=>i.localize(50,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,w.createDecorator)("debugService");var S;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[172],Ie([1,0,10,2,19,23,13]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(a,l,u){return a.replace(A,function(d,r){return l&&r.length>0&&r[0]!=="_"?d:u&&u.hasOwnProperty(r)?u[r]:d})}e.formatPII=y;function k(a){const l={};for(const u of Object.keys(a))u.startsWith("!")||(l[u]=a[u]);return l}e.filterExceptionsFromTelemetry=k;function O(a){return a.configuration.request==="attach"&&!S(a)&&(!a.parentSession||O(a.parentSession))}e.isSessionAttach=O;function S(a){let l=a.configuration.type;if(!!l)return l==="vslsShare"&&(l=a.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(l,"extensionhost")||(0,i.equalsIgnoreCase)(l,"pwa-extensionhost")?a:a.parentSession?S(a.parentSession):void 0}e.getExtensionHostDebugSession=S;function m(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=m;function E(a,l,u){let d,r=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(a);){const P=v.index+1,L=P+v[0].length;if(P<=l&&L>=u){d=v[0],r=P;break}}if(d){const P=/\w+/g;let L=null;for(;(L=P.exec(d))&&!(L.index+1+r+L[0].length>=u););L&&(d=d.substring(0,P.lastIndex))}return d?{start:r,end:r+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(a){return!!(a&&a.match(f))}e.isUri=t;function o(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(t(a.path))return C.URI.parse(a.path);if((0,w.isAbsolute)(a.path))return C.URI.file(a.path)}return a.path}function c(a){if(typeof a.path=="object"){const l=C.URI.revive(a.path);if(l)return l.scheme===I.Schemas.file?l.fsPath:l.toString()}return a.path}function g(a,l){const u=l?o:c,d=(0,M.deepClone)(a);return p(d,(r,h)=>{r&&h&&(h.path=u(h))}),d}e.convertToDAPaths=g;function b(a,l){const u=l?o:c,d=(0,M.deepClone)(a);return p(d,(r,h)=>{!r&&h&&(h.path=u(h))}),d}e.convertToVSCPaths=b;function p(a,l){switch(a.type){case"event":{const u=a;switch(u.event){case"output":l(!1,u.body.source);break;case"loadedSource":l(!1,u.body.source);break;case"breakpoint":l(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=a;switch(u.command){case"setBreakpoints":l(!0,u.arguments.source);break;case"breakpointLocations":l(!0,u.arguments.source);break;case"source":l(!0,u.arguments.source);break;case"gotoTargets":l(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(d=>l(!1,d));break;default:break}break}case"response":{const u=a;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(d=>l(!1,d.source));break;case"loadedSources":u.body.sources.forEach(d=>l(!1,d));break;case"scopes":u.body.scopes.forEach(d=>l(!1,d.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(d=>l(!1,d.source));break;case"setBreakpoints":u.body.breakpoints.forEach(d=>l(!1,d.source));break;case"disassemble":u.body?.instructions.forEach(r=>l(!1,r.location));break;default:break}break}}}function D(a){return a.filter(l=>!l.presentation?.hidden).sort((l,u)=>l.presentation?u.presentation?l.presentation.group?u.presentation.group?l.presentation.group!==u.presentation.group?l.presentation.group.localeCompare(u.presentation.group):n(l.presentation.order,u.presentation.order):-1:u.presentation.group?1:n(l.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=D;function n(a,l){return typeof a!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:a-l}async function s(a,l){const u=a.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(u!=="none"&&(await l.saveAll(),u==="allEditorsInActiveGroup")){const d=l.activeEditorPane;d&&d.input.resource?.scheme===I.Schemas.untitled&&await l.save({editor:d.input,groupId:d.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(De[67],Ie([1,0,24,35,173,59,13,19,21,41]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var g;(function(x){x.scheme=I.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${B.join("")}]+`),G=7;function ee(Q,ge){const Se=ge.toString(G),xe=`${Se.length<B.length?B[Se.length-1]:"z"}${Se}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:x.scheme,fragment:xe})}x.generate=ee;function de(Q){if(Q.scheme!==x.scheme)return;const ge=Q.fragment.indexOf("s");if(ge<0)return;const Se=parseInt(Q.fragment.substring(0,ge).replace(H,""),G),Oe=(0,i.decodeBase64)(Q.fragment.substring(ge+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Q.with({scheme:Oe,fragment:null})}}x.parse=de;function ne(Q,ge){return Q.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Q.scheme!==I.Schemas.file?Q.scheme:""}`})}x.generateCellOutputUri=ne;function me(Q){if(Q.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!ge)return;const Se=ge[1]&&ge[1]!==""?ge[1]:void 0,Oe=ge[2];return{outputId:Se,notebook:Q.with({scheme:Oe||I.Schemas.file,fragment:null})}}x.parseCellOutputUri=me;function le(Q,ge,Se){return x.generate(Q,ge).with({scheme:Se})}x.generateCellPropertyUri=le;function ue(Q,ge){if(Q.scheme===ge)return x.parse(Q.with({scheme:x.scheme}))}x.parseCellPropertyUri=ue})(g=e.CellUri||(e.CellUri={}));const b=x=>y.isWindows?x.replace(/\//g,"\\"):x;class p{constructor(B=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=H,this.order=[...new Set(B)].map(G=>({pattern:G,matches:C.parse(b(G))}))}sort(B){const H=new Map(w.Iterable.map(B,ee=>[ee,b(ee)]));let G=[];for(const{matches:ee}of this.order)for(const[de,ne]of H)if(ee(ne)){G.push(de),H.delete(de);break}return H.size&&(G=G.concat([...H.keys()].sort((ee,de)=>this.defaultOrder.indexOf(ee)-this.defaultOrder.indexOf(de)))),G}prioritize(B,H){const G=this.findIndex(B);if(G===-1){this.order.unshift({pattern:B,matches:C.parse(b(B))});return}const ee=new Set(H.map(ne=>this.findIndex(ne,G)));ee.delete(-1);const de=Array.from(ee).sort();this.order.splice(G+1,0,...de.map(ne=>this.order[ne]));for(let ne=de.length-1;ne>=0;ne--)this.order.splice(de[ne],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,H=this.order.length){const G=b(B);for(let ee=0;ee<H;ee++)if(this.order[ee].matches(G))return ee;return-1}}e.MimeTypeDisplayOrder=p;function D(x,B,H,G=(ee,de)=>ee===de){const ee=[];function de(le,ue,Q){if(ue===0&&Q.length===0)return;const ge=ee[ee.length-1];ge&&ge.start+ge.deleteCount===le?(ge.deleteCount+=ue,ge.toInsert.push(...Q)):ee.push({start:le,deleteCount:ue,toInsert:Q})}let ne=0,me=0;for(;;){if(ne===x.length){de(ne,0,B.slice(me));break}if(me===B.length){de(ne,x.length-ne,[]);break}const le=x[ne],ue=B[me];if(G(le,ue)){ne+=1,me+=1;continue}H(ue)?(de(ne,1,[]),ne+=1):(de(ne,0,[ue]),me+=1)}return ee}e.diff=D,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(x){x.default="default",x.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(x){const B=x;return!!((typeof B.include=="string"||C.isRelativePattern(B.include))&&(typeof B.exclude=="string"||C.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=s;function a(x,B,H){if(Array.isArray(x.viewType)&&x.viewType.indexOf(B)>=0||x.viewType===B)return!0;if(x.filenamePattern){const G=s(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,ee=s(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(C.match(G,(0,A.basename)(H.fsPath).toLowerCase()))return!(ee&&C.match(ee,(0,A.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var l;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(B){return`${u._prefix}${B}`}static parse(B){if(B.startsWith(u._prefix))return B.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/";function d(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=d;const r=new TextDecoder;function h(x){const B=[];let H=!1;for(const G of x)(B.length===0||H)&&(B.push(G),H=!0);return j(B),R(i.VSBuffer.concat(B.map(G=>i.VSBuffer.wrap(G))))}e.compressOutputItemStreams=h;const v=`${String.fromCharCode(27)}[A`,P=v.split("").map(x=>x.charCodeAt(0)),L=10;function j(x){x.forEach((B,H)=>{if(H===0||B.length<v.length)return;const G=x[H-1],ee=B.subarray(0,v.length);if(ee[0]===P[0]&&ee[1]===P[1]&&ee[2]===P[2]){const de=G.lastIndexOf(L);if(de===-1)return;x[H-1]=G.subarray(0,de),x[H]=B.subarray(v.length)}})}function V(x){let B=x;do x=B,B=x.replace(/[^\n]\x08/gm,"");while(B.length<x.length);return x}function W(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const B=x.match(/^(.*)\r+/m)[1];let H=x.match(/\r+(.*)$/m)[1];H=H+B.slice(H.length,B.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return x}const T="\b".charCodeAt(0),F="\r".charCodeAt(0);function R(x){return!x.buffer.includes(T)&&!x.buffer.includes(F)?x:i.VSBuffer.fromString(W(V(r.decode(x.buffer))))}}),define(De[174],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(De[175],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=i;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C;function w(I){return Array.from(I.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=w;function M(I){return new Map(I.map(A=>[A[0],{map:C(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(De[42],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class w{static fromExtHostTestItem(I,A,y=I.parent){if(I._isRoot)return new w([A]);const k=[I.id];for(let O=y;O&&O.id!==A;O=O.parent)k.push(O.id);return k.push(A),new w(k.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new w(I.split("\0"))}static join(I,A){return new w([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.viewEnd=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new w(this.path,I)}*idsToRoot(){for(let I=this.viewEnd;I>0;I--)yield new w(this.path,I)}compare(I){if(typeof I=="string")return w.compare(this.toString(),I);for(let A=0;A<I.viewEnd&&A<this.viewEnd;A++)if(I.path[A]!==this.path[A])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=w}),define(De[51],Ie([1,0,2,52,42]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var I;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(r){r.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),r.deserialize=h=>({range:C.Range.lift(h.range),uri:i.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var k;(function(r){r.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),r.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(r,h)=>`${h?"s":"e"}${r}`;e.getMarkId=O;var S;(function(r){r.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),r.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(r){r.serialize=h=>h.type===0?k.serialize(h):S.serialize(h),r.deserialize=h=>h.type===0?k.deserialize(h):S.deserialize(h)})(m=e.ITestMessage||(e.ITestMessage={}));var E;(function(r){r.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),r.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(m.serialize)}),r.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(m.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(r,h)=>r+f+h;e.namespaceTestTag=t;const o=r=>{const h=r.indexOf(f);return{ctrlId:r.slice(0,h),tagId:r.slice(h+1)}};e.denamespaceTestTag=o;var c;(function(r){r.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),r.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?i.URI.revive(h.uri):void 0,range:h.range?C.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(c=e.ITestItem||(e.ITestItem={}));var g;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(r){r.serialize=h=>({expand:h.expand,item:c.serialize(h.item)}),r.deserialize=h=>({controllerId:w.TestId.root(h.item.extId),expand:h.expand,item:c.deserialize(h.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.uri!==void 0&&(v.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(v.range=h.item.range?.toJSON()),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}},r.deserialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.range!==void 0&&(v.range=h.item.range?C.Range.lift(h.item.range):null),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const D=(r,h)=>{h.expand!==void 0&&(r.expand=h.expand),h.item!==void 0&&(r.item=r.item?Object.assign(r.item,h.item):h.item)};e.applyTestItemUpdate=D;var n;(function(r){r.serializeWithoutMessages=h=>({...b.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serializeWithoutMessages),retired:h.retired}),r.serialize=h=>({...b.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serialize),retired:h.retired}),r.deserialize=h=>({...b.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.deserialize),retired:!0})})(n=e.TestResultItem||(e.TestResultItem={}));var s;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=h=>h.op===0?{op:h.op,item:b.deserialize(h.item)}:h.op===1?{op:h.op,item:p.deserialize(h.item)}:h.op===2?{op:h.op,uri:i.URI.revive(h.uri),docv:h.docv}:h,r.serialize=h=>h.op===0?{op:h.op,item:b.serialize(h.item)}:h.op===1?{op:h.op,item:p.serialize(h.item)}:h})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class u{add(h){}update(h){}remove(h,v){}complete(){}}e.IncrementalChangeCollector=u;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const v=this.createChangeCollector();for(const P of h)switch(P.op){case 0:{const L=b.deserialize(P.item),j=w.TestId.parentId(L.item.extId)?.toString();if(j){if(this.items.has(j)){const V=this.items.get(j);V.children.add(L.item.extId);const W=this.createItem(L,V);this.items.set(L.item.extId,W),v.add(W)}}else{const V=this.createItem(L);this.roots.add(V),this.items.set(L.item.extId,V),v.add(V)}L.expand===2&&this.busyControllerCount++;break}case 1:{const L=p.deserialize(P.item),j=this.items.get(L.extId);if(!j)break;L.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,L.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,L),v.update(j);break}case 3:{const L=this.items.get(P.itemId);if(!L)break;const j=w.TestId.parentId(L.item.extId)?.toString();j?this.items.get(j).children.delete(L.item.extId):this.roots.delete(L);const V=[[P.itemId]];for(;V.length;)for(const W of V.pop()){const T=this.items.get(W);T&&(V.push(T.children),this.items.delete(W),v.remove(T,T!==L),T.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this._tags.set(P.tag.id,P.tag);break;case 7:this._tags.delete(P.id);break}v.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new u}}e.AbstractIncrementalTestCollection=d}),define(De[68],Ie([1,0,15,4,7,47,51,42]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(c,g)=>c===g,O={range:(c,g)=>c===g?!0:!c||!g?!1:c.equalsRange(g),busy:k,label:k,description:k,error:k,tags:(c,g)=>!(c.length!==g.length||c.some(b=>!g.includes(b)))},S=(c,g)=>{let b;for(const[p,D]of Object.entries(O))D(c[p],g[p])||(b?b[p]=g[p]:b={[p]:g[p]});return b};class m extends w.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case 2:{for(const b of this.diff)if(b.op===2&&b.uri===g.uri){b.docv=g.docv;return}break}case 1:{const b=this.diff[this.diff.length-1];if(b){if(b.op===1&&b.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(b.item,g.item);return}if(b.op===0&&b.item.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(b.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,b){const p=this.tree.get(g);if(!!p){if((p.expandLevels===void 0||b>p.expandLevels)&&(p.expandLevels=b),p.expand===1){const D=this.resolveChildren(p);return D.isOpen()?this.expandChildren(p,b-1):D.wait().then(()=>this.expandChildren(p,b-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,b-1)):this.expandChildren(p,b-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,b){switch(b.op){case 3:this.removeItem(A.TestId.joinToString(g.fullId,b.id));break;case 0:this.upsertItem(b.item,g);break;case 5:for(const p of b.ops)this.onTestItemEvent(g,p);break;case 1:this.diffTagRefs(b.new,b.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:b.update}});break;case 6:this.documentSynced(g.actual.uri);break;default:(0,M.assertNever)(b)}}documentSynced(g){g&&this.pushDiff({op:2,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,b){const p=A.TestId.fromExtHostTestItem(g,this.root.id,b?.actual),D=this.options.getApiFor(g);D.parent&&D.parent!==b?.actual&&this.options.getChildren(D.parent).delete(g.id);let n=this.tree.get(p.toString());if(!n){n={fullId:p,actual:g,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(g,b),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,n,b);return}if(n.actual===g){this.connectItem(g,n,b);return}const s=this.options.getChildren(n.actual),a=n.actual,l=S(this.options.toITestItem(a),this.options.toITestItem(g));this.options.getApiFor(a).listener=void 0,n.actual=g,n.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,a.tags,p.toString()),delete l.tags),this.onTestItemEvent(n,{op:4,update:l})),this.connectItemAndChildren(g,n,b);for(const[u,d]of s)this.options.getChildren(g).get(d.id)||this.removeItem(A.TestId.joinToString(p,d.id));this.documentSynced(n.actual.uri)}diffTagRefs(g,b,p){const D=new Set(b.map(n=>n.id));for(const n of g)D.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:p,item:{tags:g.map(n=>(0,I.namespaceTestTag)(this.options.controllerId,n.id))}}}),D.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const b=this.tags.get(g.id);b?b.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const b=this.tags.get(g);b&&!--b.refCount&&(this.tags.delete(g),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,b){this.options.getApiFor(g).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(g,b,p){this.setItemParent(g,p);const D=this.options.getApiFor(g);D.parent=p?.actual,D.listener=n=>this.onTestItemEvent(b,n),this.updateExpandability(b)}connectItemAndChildren(g,b,p){this.connectItem(g,b,p);for(const[D,n]of this.options.getChildren(g))this.upsertItem(n,b)}updateExpandability(g){let b;this._resolveHandler?g.resolveBarrier?b=g.resolveBarrier.isOpen()?3:2:b=g.actual.canResolveChildren?1:0:b=0,b!==g.expand&&(g.expand=b,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:b}}),b===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,b){if(b<0)return;const p=[];for(const[D,n]of this.options.getChildren(g.actual)){const s=this.expand(A.TestId.joinToString(g.fullId,n.id),b);(0,i.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const n=new i.Barrier;return n.open(),n}g.expand=2,this.pushExpandStateUpdate(g);const b=g.resolveBarrier=new i.Barrier,p=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let D;try{D=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(n){p(n)}return(0,i.isThenable)(D)?D.catch(p).then(()=>{b.open(),this.updateExpandability(g)}):(b.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const b=this.tree.get(g);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const p=[b];for(;p.length;){const D=p.pop();if(!!D){this.options.getApiFor(D.actual).listener=void 0;for(const n of D.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(D.fullId.toString());for(const[n,s]of this.options.getChildren(D.actual))p.push(this.tree.get(A.TestId.joinToString(D.fullId,s.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class E extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=E;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class t extends Error{constructor(g,b,p){super(`TestItem with ID "${g}" is from controller "${b}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const o=(c,g,b)=>{let p=new Map;return{get size(){return p.size},forEach(D,n){for(const s of p.values())D.call(n,s,this)},[Symbol.iterator](){return p.entries()},replace(D){const n=new Map,s=new Set(p.keys()),a={op:5,ops:[]};for(const l of D){if(!(l instanceof b))throw new f(l.id);const u=g(l).controllerId;if(u!==c.controllerId)throw new t(l.id,u,c.controllerId);if(n.has(l.id))throw new E(l.id);n.set(l.id,l),s.delete(l.id),a.ops.push({op:0,item:l})}for(const l of s.keys())a.ops.push({op:3,id:l});c.listener?.(a),p=n},add(D){if(!(D instanceof b))throw new f(D.id);p.set(D.id,D),c.listener?.({op:0,item:D})},delete(D){p.delete(D)&&c.listener?.({op:3,id:D})},get(D){return p.get(D)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=o}),define(De[92],Ie([1,0,68]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,w=(I,A)=>{const y={controllerId:A};return C.set(I,y),y};e.createPrivateApiFor=w;const M=I=>{const A=C.get(I);if(!A)throw new i.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(De[176],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class w extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=w}),define(De[177],Ie([1,0,19,48,9,23,21,82,144,176,10]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(E,f,t,o){this._contributedVariables=new Map,this._context=E,this._labelService=f,this._userHomePromise=t,o&&(this._envVariablesPromise=o.then(c=>this.prepareEnv(c)))}prepareEnv(E){if(I.isWindows){const f=Object.create(null);return Object.keys(E).forEach(t=>{f[t.toLowerCase()]=E[t]}),f}return E}resolveWithEnvironment(E,f,t){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(E,f){const t={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(t,E?E.uri:void 0,f)}async resolveAnyBase(E,f,t,o){const c=M.deepClone(f);I.isWindows&&c.windows?Object.keys(c.windows).forEach(b=>c[b]=c.windows[b]):I.isMacintosh&&c.osx?Object.keys(c.osx).forEach(b=>c[b]=c.osx[b]):I.isLinux&&c.linux&&Object.keys(c.linux).forEach(b=>c[b]=c.linux[b]),delete c.windows,delete c.osx,delete c.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,E?E.uri:void 0,c,t,o)}async resolveAnyAsync(E,f,t){return this.resolveAnyBase(E,f,t)}async resolveAnyMap(E,f,t){const o=new Map;return{newConfig:await this.resolveAnyBase(E,f,t,o),resolvedVariables:o}}resolveWithInteractionReplace(E,f,t,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,f,t,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,f){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,f)}async recursiveResolve(E,f,t,o,c){if(w.isString(t))return this.resolveString(E,f,t,o,c);if(Array.isArray(t))return Promise.all(t.map(g=>this.recursiveResolve(E,f,g,o,c)));if(w.isObject(t)){const g=Object.create(null),b=await Promise.all(Object.keys(t).map(async p=>[await this.resolveString(E,f,p,o,c),await this.recursiveResolve(E,f,t[p],o,c)]));for(const[p,D]of b)g[p]=D;return g}return t}resolveString(E,f,t,o,c){return(0,O.replaceAsync)(t,S.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(S.VARIABLE_LHS))return g;let p=await this.evaluateSingleVariable(E,g,b,f,o);return c?.set(b,p),p!==g&&w.isString(p)&&p.match(S.VARIABLE_REGEXP)&&(p=await this.resolveString(E,f,p,o,c)),p})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,f,t,o,c){let g;const b=t.split(":");b.length>1&&(t=b[0],g=b[1]);const p=s=>{const a=this._context.getFilePath();if(a)return a;throw new k.VariableError(s,(0,y.localize)(0,null,f))},D=s=>{const a=p(s);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new k.VariableError(s,(0,y.localize)(1,null,f,i.basename(a)))},n=s=>{if(g){const a=this._context.getFolderUri(g);if(a)return a;throw new k.VariableError(s,(0,y.localize)(2,null,f,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(s,(0,y.localize)(3,null,f)):new k.VariableError(s,(0,y.localize)(4,null,f))};switch(t){case"env":if(g){if(E.env){const s=E.env[I.isWindows?g.toLowerCase():g];if(w.isString(s))return s}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,f));case"config":if(g){const s=this._context.getConfigurationValue(o,g);if(w.isUndefinedOrNull(s))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,f,g));if(w.isObject(s))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,f,g));return s}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,f));case"command":return this.resolveFromMap(k.VariableKind.Command,f,g,c,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,f,g,c,"input");case"extensionInstallFolder":if(g){const s=await this._context.getExtension(g);if(!s)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,f,g));return this.fsPath(s.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(n(k.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,A.normalizeDriveLetter)(this.fsPath(n(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(n(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(E.userHome)return E.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,f))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,f))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,f))}case"file":return p(k.VariableKind.File);case"fileWorkspaceFolder":return D(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?i.relative(this.fsPath(n(k.VariableKind.RelativeFile)),p(k.VariableKind.RelativeFile)):p(k.VariableKind.RelativeFile);case"relativeFileDirname":{const s=i.dirname(p(k.VariableKind.RelativeFileDirname));if(o||g){const a=i.relative(this.fsPath(n(k.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return i.dirname(p(k.VariableKind.FileDirname));case"fileExtname":return i.extname(p(k.VariableKind.FileExtname));case"fileBasename":return i.basename(p(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=i.basename(p(k.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-i.extname(s).length)}case"fileDirnameBasename":return i.basename(i.dirname(p(k.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||f}case"execInstallFolder":{const s=this._context.getAppRoot();return s||f}case"pathSeparator":return i.sep;default:try{const s=g?`${t}:${g}`:t;return this.resolveFromMap(k.VariableKind.Unknown,f,s,c,void 0)}catch{return f}}}}resolveFromMap(E,f,t,o,c){if(t&&o){const g=c===void 0?o[t]:o[c+":"+t];if(typeof g=="string")return g;throw new k.VariableError(E,(0,y.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[93],Ie([1,0,3,91]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var w;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const t=f;return(0,C.isEditorInput)(t?.editor)&&(0,C.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(De[178],Ie([1,0,3,93]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(M){const I=M;return typeof M=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=w}),define(De[179],Ie([1,0,3,149]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(C.IEnvironmentService)}),define(De[180],Ie([1,0,25,4,19]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(S){this.removedDueToLooping=S}}e.DeltaExtensionsResult=M;class I{constructor(S){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=S,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const S of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(S.identifier))){console.error("Extension `"+S.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(S.identifier),S),this._extensionsArr.push(S),Array.isArray(S.activationEvents))for(let m of S.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(S.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(S)}}set(S){this._extensionDescriptions=S,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(S,m){this._extensionDescriptions=k(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(S);const E=I._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,E.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(E)}static _findLoopingExtensions(S){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(c){this._nodesSet.has(c)||(this._nodesSet.add(c),this._nodesArr.push(c))}addArc(c,g){this.addNode(c),this.addNode(g),this._arcs.has(c)?this._arcs.get(c).push(g):this._arcs.set(c,[g])}getArcs(c){return this._arcs.has(c)?this._arcs.get(c):[]}hasOnlyGoodArcs(c,g){const b=m.getArcs(c);for(let p=0;p<b.length;p++)if(!g.has(b[p]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const c of S){const g=i.ExtensionIdentifier.toKey(c.identifier);if(E.set(g,c),c.extensionDependencies)for(const b of c.extensionDependencies){const p=i.ExtensionIdentifier.toKey(b);m.addArc(g,p)}}const f=new Set;m.getNodes().filter(c=>m.getArcs(c).length===0).forEach(c=>f.add(c));const t=m.getNodes().filter(c=>!f.has(c));let o;do{o=!1;for(let c=0;c<t.length;c++){const g=t[c];m.hasOnlyGoodArcs(g,f)&&(t.splice(c,1),c--,f.add(g),o=!0)}}while(o);return t.map(c=>E.get(c))}containsActivationEvent(S){return this._activationMap.has(S)}containsExtension(S){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(S))}getExtensionDescriptionsForActivationEvent(S){const m=this._activationMap.get(S);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(S){const m=this._extensionsMap.get(i.ExtensionIdentifier.toKey(S));return m||void 0}getExtensionDescriptionByUUID(S){for(const m of this._extensionsArr)if(m.uuid===S)return m}getExtensionDescriptionByIdOrUUID(S,m){return this.getExtensionDescription(S)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,S){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,E=S.isBuiltin?0:S.isUnderDevelopment?2:1;if(m!==E)return m-E;const f=w.posix.basename(O.extensionLocation.path),t=w.posix.basename(S.extensionLocation.path);return f<t?-1:f>t?1:0}function k(O,S){const m=new Set;return S.forEach(E=>m.add(i.ExtensionIdentifier.toKey(E))),O.filter(E=>!m.has(i.ExtensionIdentifier.toKey(E.identifier)))}}),define(De[69],Ie([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var w;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function I(k){const O=i.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function A(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[70],Ie([1,0,3,4,11,26,69,62,159,23,2]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=class{constructor(t,o){this.initData=t,this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this._outputLogger=o.createLogger(O.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,o){const c=this.getTelemetryDetails(),g=new m(o,t,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled});return this._telemetryLoggers.set(t.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(t,o,c){this._level=t,this._inLoggingOnlyMode=o,this._productConfig=c??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const o={};switch(o["common.extname"]=t.name,o["common.extversion"]=t.version,o["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,o["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,o["common.vscodeversion"]=this.initData.version,o["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),o["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case I.UIKind.Web:o["common.uikind"]="web";break;case I.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),o}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const o=this.getTelemetryDetails();this._telemetryLoggers.forEach(c=>{c.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(t,o){const c=this._telemetryLoggers.get(t.value);return c?(c.logError(o),!0):!1}};S=We([$e(0,M.IExtHostInitDataService),$e(1,w.ILoggerService)],S),e.ExtHostTelemetry=S;class m{constructor(t,o,c,g,b,p){this._extension=o,this._logger=c,this._inLoggingOnlyMode=g,this._commonProperties=b,this._onDidChangeEnableStates=new C.Emitter,this._appender=t,this._telemetryEnablements={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(t,o){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:o},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){let o=t.properties??t;return o=(0,y.cleanData)(o,[]),this._appender.additionalCommonProperties&&(o=(0,k.mixin)(o,this._appender.additionalCommonProperties)),this._appender.ignoreBuiltInCommonProperties||(o=(0,k.mixin)(o,this._commonProperties)),t.properties?t.properties=o:t=o,t}logEvent(t,o){this._extension.publisher==="vscode"?t=this._extension.name+"/"+t:t=this._extension.identifier.value+"/"+t,o=this.mixInCommonPropsAndCleanData(o||{}),this._inLoggingOnlyMode||this._appender.logEvent(t,o),this._logger.trace(t,o)}logUsage(t,o){!this._telemetryEnablements.isUsageEnabled||this.logEvent(t,o)}logError(t,o){!this._telemetryEnablements.isErrorsEnabled||(typeof t=="string"?this.logEvent(t,o):this._appender.logException(t,o))}get apiTelemetryLogger(){if(!this._apiObject){const t=this,o={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(o)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=m;function E(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,4,2,3,25,156]),function(te,e,i,C,w,M,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class y{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(d){this.affinity=d,this.kind=2}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class S{constructor(d){this.dependency=d}}e.MissingExtensionDependency=S;var m;(function(u){u[u.LocalProcess=1]="LocalProcess",u[u.LocalWebWorker=2]="LocalWebWorker",u[u.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(u){if(u===null)return"None";switch(u){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,r){const h=[],v=[],P=[],L=[],j=c(this._allExtensions),V=c(d),W=(x,B)=>x.extensionLocation.toString()===B.extensionLocation.toString()||x.isBuiltin===B.isBuiltin||x.isUserBuiltin===B.isUserBuiltin||x.isUnderDevelopment===B.isUnderDevelopment;for(const x of this._allExtensions){const B=V.get(M.ExtensionIdentifier.toKey(x.identifier));if(!B){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}if(!W(x,B)){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of d){const B=j.get(M.ExtensionIdentifier.toKey(x.identifier));if(!B){v.push(x);continue}if(!W(B,x)){h.push(B.identifier),j.delete(M.ExtensionIdentifier.toKey(B.identifier));continue}}const T=o(this._myExtensions),F=o(r);for(const x of this._myExtensions)F.has(M.ExtensionIdentifier.toKey(x))||P.push(x);for(const x of r)T.has(M.ExtensionIdentifier.toKey(x))||L.push(x);const R={toRemove:h,toAdd:v,myToRemove:P,myToAdd:L};return this.delta(R),R}delta(d){const{toRemove:r,toAdd:h,myToRemove:v,myToAdd:P}=d,L=o(r),j=o(v);for(let V=0;V<this._allExtensions.length;V++)L.has(M.ExtensionIdentifier.toKey(this._allExtensions[V].identifier))&&(this._allExtensions.splice(V,1),V--);for(let V=0;V<this._myExtensions.length;V++)j.has(M.ExtensionIdentifier.toKey(this._myExtensions[V]))&&(this._myExtensions.splice(V,1),V--);for(const V of h)this._allExtensions.push(V);for(const V of P)this._myExtensions.push(V)}containsExtension(d){for(const r of this._myExtensions)if(M.ExtensionIdentifier.equals(r,d))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(d){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,d)for(const r of d)this.add(r)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,r){this._map.forEach(h=>d.call(r,h,h,this))}*entries(){for(const[d,r]of this._map)yield[r,r]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=t;function o(u){const d=new Set;for(const r of u)d.add(M.ExtensionIdentifier.toKey(r));return d}e.extensionIdentifiersArrayToSet=o;function c(u){const d=new Map;for(const r of u)d.set(M.ExtensionIdentifier.toKey(r.identifier),r);return d}function g(u,d){return u.enabledApiProposals?u.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=g;function b(u,d){if(!g(u,d))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(d,r,h,v){this.codeLoadingTime=d,this.activateCallTime=r,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=p;class D{constructor(d,r){this.description=d,this.value=r}}e.ExtensionPointContribution=D,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var n;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function s(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function a(u,d){return{identifier:new M.ExtensionIdentifier((0,I.getExtensionId)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!d,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,browserNlsBundleUris:u.browserNlsBundleUris}}e.toExtensionDescription=a;class l{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,r){return Promise.resolve(0)}getInspectPorts(d,r){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,r){return Promise.resolve()}}e.NullExtensionService=l}),define(De[181],Ie([1,0,12,25,27,11,15]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(o,c,g,b){this.startup=o,this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=b}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,c){return o===-1||c===-1?-1:c-o}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class k{constructor(o,c,g,b,p,D){this.activationFailed=o,this.activationFailedError=c,this.activationTimes=g,this.module=b,this.exports=p,this.subscriptions=D}}e.ActivatedExtension=k;class O extends k{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class S extends k{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class m extends k{constructor(o){super(!0,o,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(o,c,g,b,p){this._logService=p,this._registry=o,this._resolvedExtensionsSet=new Set,c.forEach(D=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(D))),this._externalExtensionsMap=new Map,g.forEach(D=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(D),D)),this._host=b,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,c]of this._operations)c.dispose()}isActivated(o){const c=this._operations.get(C.ExtensionIdentifier.toKey(o));return Boolean(c&&c.value)}getActivatedExtension(o){const c=this._operations.get(C.ExtensionIdentifier.toKey(o));if(!c||!c.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return c.value}async activateByEvent(o,c){if(this._alreadyActivatedEvents[o])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(g.map(b=>({id:b.identifier,reason:{startup:c,extensionId:b.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,c){const g=this._registry.getExtensionDescription(o);if(!g)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:g.identifier,reason:c}])}async _activateExtensions(o){const c=o.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(c.map(g=>g.wait()))}_handleActivationRequest(o){if(this._operations.has(C.ExtensionIdentifier.toKey(o.id)))return this._operations.get(C.ExtensionIdentifier.toKey(o.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(o.id)))return this._createAndSaveOperation(o,null,[],null);const c=this._registry.getExtensionDescription(o.id);if(!c){const p=new Error(`Cannot activate unknown extension '${o.id.value}'`),D=this._createAndSaveOperation(o,null,[],new m(p));return this._host.onExtensionActivationError(o.id,p,new w.MissingExtensionDependency(o.id.value)),D}const g=[],b=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const p of b){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(p)))continue;const D=this._operations.get(C.ExtensionIdentifier.toKey(p));if(D){g.push(D);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(p))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(p)),reason:o.reason}));continue}const n=this._registry.getExtensionDescription(p);if(n){if(!n.main&&!n.browser)continue;g.push(this._handleActivationRequest({id:n.identifier,reason:o.reason}));continue}const s=c.displayName||c.identifier.value,a=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),l=this._createAndSaveOperation(o,c.displayName,[],new m(a));return this._host.onExtensionActivationError(c.identifier,a,new w.MissingExtensionDependency(p)),l}return this._createAndSaveOperation(o,c.displayName,g,null)}_createAndSaveOperation(o,c,g,b){const p=new f(o.id,c,o.reason,g,b,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(o.id),p),p}};E=We([$e(4,M.ILogService)],E),e.ExtensionsActivator=E;let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,c,g,b,p,D,n){this._id=o,this._displayName=c,this._reason=g,this._deps=b,this._value=p,this._host=D,this._logService=n,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const c=this._deps[o];if(c.value&&!c.value.activationFailed){this._deps.splice(o,1),o--;continue}if(c.value&&c.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);g.detail=c.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const c=new Error;if(o&&o.name&&(c.name=o.name),o&&o.message?c.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:c.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(c.stack=o.stack),this._value=new m(c),this._isDisposed&&i.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,c,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};f=We([$e(6,M.ILogService)],f)}),define(De[182],Ie([1,0,11,26,27]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends i.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:w.ExtensionHostLogFileName}))}};M=We([$e(0,i.ILoggerService),$e(1,C.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[6],Ie([1,0,16,12,81,28,59,10,9,2,34,36,90,67,27]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f){"use strict";var t,o,c,g,b,p,D,n,s,a,l,u,d,r,h,v,P,L,j,V,W,T,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...Ee]=arguments;return Reflect.construct(z,Ee,ie.constructor)}}})}let x=p=class{static from(...U){let ie=U;return new p(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(U){t.set(this,void 0),Je(this,t,U,"f")}dispose(){typeof Ae(this,t,"f")=="function"&&(Ae(this,t,"f").call(this),Je(this,t,void 0,"f"))}};t=new WeakMap,x=p=We([R],x),e.Disposable=x;let B=D=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ve=U[Ee];Ve.isBefore(ie)&&(ie=Ve)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ve=U[Ee];Ve.isAfter(ie)&&(ie=Ve)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof D)return!0;const{line:ie,character:Ee}=U;return typeof ie=="number"&&typeof Ee=="number"}static of(U){if(U instanceof D)return U;if(this.isPosition(U))return new D(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=U,this._character=ie}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,C.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&ie===0?this:new D(this.line+Ee,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,C.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),Ee===this.line&&ie===this.character?this:new D(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};B=D=We([R],B),e.Position=B;let H=n=class{static isRange(U){return U instanceof n?!0:U?B.isPosition(U.start)&&B.isPosition(U.end):!1}static of(U){if(U instanceof n)return U;if(this.isRange(U))return new n(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,ie,Ee,Ve){let Ye,at;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Ye=new B(U,ie),at=new B(Ee,Ve)):B.isPosition(U)&&B.isPosition(ie)&&(Ye=B.of(U),at=B.of(ie)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this._start=Ye,this._end=at):(this._start=at,this._end=Ye)}contains(U){return n.isRange(U)?this.contains(U.start)&&this.contains(U.end):B.isPosition(U)?!(B.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ie=B.Max(U.start,this._start),Ee=B.Min(U.end,this._end);if(!ie.isAfter(Ee))return new n(ie,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=B.Min(U.start,this._start),Ee=B.Max(U.end,this.end);return new n(ie,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,C.illegalArgument)();let Ee;return U?B.isPosition(U)?Ee=U:(Ee=U.start||this.start,ie=U.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ie.isEqual(this.end)?this:new n(Ee,ie)}toJSON(){return[this.start,this.end]}};H=n=We([R],H),e.Range=H;let G=s=class extends H{static isSelection(U){return U instanceof s?!0:U?H.isRange(U)&&B.isPosition(U.anchor)&&B.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,ie,Ee,Ve){let Ye,at;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Ye=new B(U,ie),at=new B(Ee,Ve)):B.isPosition(U)&&B.isPosition(ie)&&(Ye=B.of(U),at=B.of(ie)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this._anchor=Ye,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=s=We([R],G),e.Selection=G;class ee{constructor(U,ie,Ee){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=ee;class de extends Error{static NotAvailable(U,ie){return new de(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=ie,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var ne;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ne=e.EndOfLine||(e.EndOfLine={}));var me;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(me=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=a=class{static isTextEdit(U){return U instanceof a?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new a(U,ie)}static insert(U,ie){return a.replace(new H(U,U),ie)}static delete(U){return a.replace(U,"")}static setEndOfLine(U){const ie=new a(new H(new B(0,0),new B(0,0)),"");return ie.newEol=U,ie}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,C.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this._newEol=U}constructor(U,ie){this._range=U,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=a=We([R],le),e.TextEdit=le;let ue=l=class{static isNotebookCellEdit(U){return U instanceof l?!0:U?jt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new l(U,ie)}static insertCells(U,ie){return new l(new jt(U,U),ie)}static deleteCells(U){return new l(U,[])}static updateCellMetadata(U,ie){const Ee=new l(new jt(U,U),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(U){const ie=new l(new jt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};ue=l=We([R],ue),e.NotebookEdit=ue;class Q{static isSnippetTextEdit(U){return U instanceof Q?!0:U?H.isRange(U.range)&&Oe.isSnippetString(U.snippet):!1}static replace(U,ie){return new Q(U,ie)}static insert(U,ie){return Q.replace(new H(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=Q;var ge;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(ge=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ie,Ee,Ve){this._edits.push({_type:1,from:U,to:ie,options:Ee,metadata:Ve})}createFile(U,ie,Ee){this._edits.push({_type:1,from:void 0,to:U,options:ie,metadata:Ee})}deleteFile(U,ie,Ee){this._edits.push({_type:1,from:U,to:void 0,options:ie,metadata:Ee})}replaceNotebookMetadata(U,ie,Ee){this._edits.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(U,ie,Ee,Ve){const Ye=ie.start,at=ie.end;(Ye!==at||Ee.length>0)&&this._edits.push({_type:5,uri:U,index:Ye,count:at-Ye,cells:Ee,metadata:Ve})}replaceNotebookCellMetadata(U,ie,Ee,Ve){this._edits.push({_type:3,metadata:Ve,uri:U,edit:{editType:8,index:ie,metadata:Ee}})}replace(U,ie,Ee,Ve){this._edits.push({_type:2,uri:U,edit:new le(ie,Ee),metadata:Ve})}insert(U,ie,Ee,Ve){this.replace(U,new H(ie,ie),Ee,Ve)}delete(U,ie,Ee){this.replace(U,ie,"",Ee)}has(U){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let Ve,Ye;Array.isArray(Ee)?(Ve=Ee[0],Ye=Ee[1]):Ve=Ee,ue.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.replaceNotebookCellMetadata(U,Ve.range.start,Ve.newCellMetadata,Ye):Ve.newNotebookMetadata?this.replaceNotebookMetadata(U,Ve.newNotebookMetadata,Ye):this.replaceNotebookCells(U,Ve.range,Ve.newCells,Ye):Q.isSnippetTextEdit(Ve)?this._edits.push({_type:6,uri:U,range:Ve.range,edit:Ve.snippet,metadata:Ye}):this._edits.push({_type:2,uri:U,edit:Ve,metadata:Ye})}else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ve=this._edits[Ee];switch(Ve._type){case 2:case 6:case 3:case 5:Ve.uri.toString()===U.toString()&&(this._edits[Ee]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(U){const ie=[];for(const Ee of this._edits)Ee._type===2&&Ee.uri.toString()===U.toString()&&ie.push(Ee.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this._edits)if(ie._type===2){let Ee=U.get(ie.uri);Ee||(Ee=[ie.uri,[]],U.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=We([R],Se),e.WorkspaceEdit=Se;let Oe=u=class{static isSnippetString(U){return U instanceof u?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=u._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this._tabstop++){if(typeof U=="function"){const Ee=new u;Ee._tabstop=this._tabstop,U(Ee),this._tabstop=Ee._tabstop,U=Ee.value}else U=u._escape(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this._tabstop++){const Ee=U.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const Ee=new u;Ee._tabstop=this._tabstop,ie(Ee),this._tabstop=Ee._tabstop,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Oe=u=We([R],Oe),e.SnippetString=Oe;var xe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(xe=e.DiagnosticTag||(e.DiagnosticTag={}));var Qe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Qe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Ce=d=class{static isLocation(U){return U instanceof d?!0:U?H.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(H.isRange(ie))this.range=H.of(ie);else if(B.isPosition(ie))this.range=new H(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Ce=d=We([R],Ce),e.Location=Ce;let ye=class{static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};ye=We([R],ye),e.DiagnosticRelatedInformation=ye;let Te=class{constructor(U,ie,Ee=Qe.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=Ee}toJSON(){return{severity:Qe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,i.equals)(U.tags,ie.tags)&&(0,i.equals)(U.relatedInformation,ie.relatedInformation,ye.isEqual)}};Te=We([R],Te),e.Diagnostic=Te;let se=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};se=We([R],se),e.Hover=se;var ae;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let J=class{constructor(U,ie=ae.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:ae[this.kind]}}};J=We([R],J),e.DocumentHighlight=J;var _;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(_=e.SymbolKind||(e.SymbolKind={}));var N;(function(z){z[z.Deprecated=1]="Deprecated"})(N=e.SymbolTag||(e.SymbolTag={}));let $=r=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,Ee,Ve,Ye){this.name=U,this.kind=ie,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ve instanceof Ce?this.location=Ve:Ee instanceof H&&(this.location=new Ce(Ve,Ee)),r.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};$=r=We([R],$),e.SymbolInformation=$;let q=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,ie,Ee,Ve,Ye){this.name=U,this.detail=ie,this.kind=Ee,this.range=Ve,this.selectionRange=Ye,this.children=[],h.validate(this)}};q=h=We([R],q),e.DocumentSymbol=q;var Z;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ce=class{constructor(U,ie){this.title=U,this.kind=ie}};ce=We([R],ce),e.CodeAction=ce;let we=v=class{constructor(U){this.value=U}append(U){return new v(this.value?this.value+v.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+v.sep)}};we.sep=".",we=v=We([R],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let oe=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=We([R],oe),e.SelectionRange=oe;class be{constructor(U,ie,Ee,Ve,Ye,at){this.kind=U,this.name=ie,this.detail=Ee,this.uri=Ve,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=be;class ve{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=ve;class Ue{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=Ue;var ze;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=We([R],et),e.CodeLens=et;let Ge=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new w.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Ae(this,o,"f").value}set value(U){Ae(this,o,"f").value=U}get isTrusted(){return Ae(this,o,"f").isTrusted}set isTrusted(U){Ae(this,o,"f").isTrusted=U}get supportThemeIcons(){return Ae(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Ae(this,o,"f").supportThemeIcons=U}get supportHtml(){return Ae(this,o,"f").supportHtml}set supportHtml(U){Ae(this,o,"f").supportHtml=U}get baseUri(){return Ae(this,o,"f").baseUri}set baseUri(U){Ae(this,o,"f").baseUri=U}appendText(U){return Ae(this,o,"f").appendText(U),this}appendMarkdown(U){return Ae(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Ae(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,Ge=P=We([R],Ge),e.MarkdownString=Ge;let tt=class{constructor(U,ie){this.label=U,this.documentation=ie}};tt=We([R],tt),e.ParameterInformation=tt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=We([R],Fe),e.SignatureInformation=Fe;let ht=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ht=We([R],ht),e.SignatureHelp=ht;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Y;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Y=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(U){this.value=U}};pe=We([R],pe),e.InlayHintLabelPart=pe;let Ne=class{constructor(U,ie,Ee){this.position=U,this.label=ie,this.kind=Ee}};Ne=We([R],Ne),e.InlayHint=Ne;var je;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(z){z[z.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=We([R],Ze),e.CompletionItem=Ze;let nt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};nt=We([R],nt),e.CompletionList=nt;let lt=class{constructor(U,ie,Ee){this.insertText=U,this.range=ie,this.command=Ee}};lt=We([R],lt),e.InlineSuggestion=lt;let Dt=class{constructor(U){this.commands=void 0,this.items=U}};Dt=We([R],Dt),e.InlineSuggestionList=Dt;var rt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(rt=e.ViewColumn||(e.ViewColumn={}));var it;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Pt=class{constructor(U,ie){if(ie&&!k.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ie}};Pt=We([R],Pt),e.DocumentLink=Pt;let Ke=class{constructor(U,ie,Ee,Ve){this.red=U,this.green=ie,this.blue=Ee,this.alpha=Ve}};Ke=We([R],Ke),e.Color=Ke;let Tt=class{constructor(U,ie){if(ie&&!(ie instanceof Ke))throw(0,C.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ie}};Tt=We([R],Tt),e.ColorInformation=Tt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Lt=We([R],Lt),e.ColorPresentation=Lt;var xt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(xt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var yt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(yt=e.TerminalExitReason||(e.TerminalExitReason={}));class St{constructor(U,ie,Ee){if(this.startIndex=U,this.length=ie,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=St;var _e;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(_e=e.TerminalLocation||(e.TerminalLocation={}));class Pe{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Pe;var fe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(fe=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=L=class{static from(U){switch(U){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this._id=U}get id(){return this._id}};ke.Clean=new L("clean","Clean"),ke.Build=new L("build","Build"),ke.Rebuild=new L("rebuild","Rebuild"),ke.Test=new L("test","Test"),ke=L=We([R],ke),e.TaskGroup=ke;function Le(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let Xe=class{constructor(U,ie,Ee){if(typeof U!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=U,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Ee):this._options=ie)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)U.push(ie);return Le(U)}};Xe=We([R],Xe),e.ProcessExecution=Xe;let Be=class{constructor(U,ie,Ee){if(this._args=[],Array.isArray(ie)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this._command=U,this._args=ie,this._options=Ee}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=U,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)U.push(typeof ie=="string"?ie:ie.value);return Le(U)}};Be=We([R],Be),e.ShellExecution=Be;var ot;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class At{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=At;let vt=j=class{constructor(U,ie,Ee,Ve,Ye,at){this.__deprecated=!1,this._definition=this.definition=U;let ut;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Ee,this.execution=Ve,ut=Ye,this.__deprecated=!0):ie===mt.Global||ie===mt.Workspace?(this.target=ie,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Ye,ut=at):(this.target=ie,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Ye,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof Be?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof At?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ie=this._definition.type;(j.EmptyType===ie||j.ProcessType===ie||j.ShellType===ie||j.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=j=We([R],vt),e.Task=vt;var Et;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));var dt;(function(z){function U(ie){const Ee=ie;return(0,y.isNumber)(Ee.value)?Ee.tooltip&&!(0,y.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}z.isViewBadge=U})(dt=e.ViewBadge||(e.ViewBadge={}));let Nt=V=class{static isTreeItem(U,ie){if(U instanceof V)return!0;const Ee=U;if(Ee.label!==void 0&&!(0,y.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,y.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,y.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,y.isString)(Ee.iconPath.id))){const Ve=Ee.iconPath;if(!Ve||!(0,y.isString)(Ve.light)&&!k.URI.isUri(Ve.light)&&!(0,y.isString)(Ve.dark)&&!k.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,y.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,y.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Kt.None&&Ee.collapsibleState>Kt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,y.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ve=(0,y.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,y.isObject)(Ee.checkboxState)&&(0,y.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Ee.checkboxState)&&(0,y.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==bt.Checked&&Ve!==bt.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(U,ie=Kt.None){this.collapsibleState=ie,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Nt=V=We([R],Nt),e.TreeItem=Nt;var Kt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Kt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var bt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(bt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,O.generateUuid)()}};Ht=We([R],Ht),e.DataTransferItem=Ht;let ni=class{constructor(U){c.set(this,new Map);for(const[ie,Ee]of U??[]){const Ve=Ae(this,c,"f").get(ie);Ve?Ve.push(Ee):Ae(this,c,"f").set(ie,[Ee])}}get(U){return Ae(this,c,"f").get(U)?.[0]}set(U,ie){Ae(this,c,"f").set(U,[ie])}forEach(U,ie){for(const[Ee,Ve]of Ae(this,c,"f"))for(const Ye of Ve)U.call(ie,Ye,Ee,this)}*[(c=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Ae(this,c,"f"))for(const Ee of ie)yield[U,Ee]}};ni=We([R],ni),e.DataTransfer=ni;let ri=class{constructor(U){this.insertText=U}};ri=We([R],ri),e.DocumentDropEdit=ri;let mi=class{constructor(U){this.insertText=U}};mi=We([R],mi),e.DocumentPasteEdit=mi;let _t=class{constructor(U,ie){this.id=U,this.color=ie}};_t=We([R],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let si=class{constructor(U){this.id=U}};si=We([R],si),e.ThemeColor=si;var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=k.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=We([R],Jt),e.RelativePattern=Jt;let zt=class{constructor(U,ie,Ee,Ve){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};zt=We([R],zt),e.Breakpoint=zt;let ct=class extends zt{constructor(U,ie,Ee,Ve,Ye){if(super(ie,Ee,Ve,Ye),U===null)throw(0,C.illegalArgument)("location");this.location=U}};ct=We([R],ct),e.SourceBreakpoint=ct;let gi=class extends zt{constructor(U,ie,Ee,Ve,Ye){super(ie,Ee,Ve,Ye),this.functionName=U}};gi=We([R],gi),e.FunctionBreakpoint=gi;let $t=class extends zt{constructor(U,ie,Ee,Ve,Ye,at,ut){if(super(Ve,Ye,at,ut),!ie)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=Ee}};$t=We([R],$t),e.DataBreakpoint=$t;let Gt=class{constructor(U,ie,Ee){this.command=U,this.args=ie||[],this.options=Ee}};Gt=We([R],Gt),e.DebugAdapterExecutable=Gt;let oi=class{constructor(U,ie){this.port=U,this.host=ie}};oi=We([R],oi),e.DebugAdapterServer=oi;let pi=class{constructor(U){this.path=U}};pi=We([R],pi),e.DebugAdapterNamedPipeServer=pi;let ai=class{constructor(U){this.implementation=U}};ai=We([R],ai),e.DebugAdapterInlineImplementation=ai;let vi=class{constructor(U,ie){this.range=U,this.expression=ie}};vi=We([R],vi),e.EvaluatableExpression=vi;var Di;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Di=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor(U,ie){this.range=U,this.text=ie}};Zt=We([R],Zt),e.InlineValueText=Zt;let Ei=class{constructor(U,ie,Ee=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=Ee}};Ei=We([R],Ei),e.InlineValueVariableLookup=Ei;let ei=class{constructor(U,ie){this.range=U,this.expression=ie}};ei=We([R],ei),e.InlineValueEvaluatableExpression=ei;let ti=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};ti=We([R],ti),e.InlineValueContext=ti;var Ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ri=e.FileChangeType||(e.FileChangeType={}));let bi=W=class extends Error{static FileExists(U){return new W(U,S.FileSystemProviderErrorCode.FileExists,W.FileExists)}static FileNotFound(U){return new W(U,S.FileSystemProviderErrorCode.FileNotFound,W.FileNotFound)}static FileNotADirectory(U){return new W(U,S.FileSystemProviderErrorCode.FileNotADirectory,W.FileNotADirectory)}static FileIsADirectory(U){return new W(U,S.FileSystemProviderErrorCode.FileIsADirectory,W.FileIsADirectory)}static NoPermissions(U){return new W(U,S.FileSystemProviderErrorCode.NoPermissions,W.NoPermissions)}static Unavailable(U){return new W(U,S.FileSystemProviderErrorCode.Unavailable,W.Unavailable)}constructor(U,ie=S.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};bi=W=We([R],bi),e.FileSystemError=bi;let Xt=class{constructor(U,ie,Ee){this.start=U,this.end=ie,this.kind=Ee}};Xt=We([R],Xt),e.FoldingRange=Xt;var Oi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Oi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Fi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Mi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Mi=e.CommentThreadState||(e.CommentThreadState={}));class wi{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=wi;function Ii(z){return typeof z>"u"||(0,y.isStringArray)(z)}class li{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ie=0,Ee=U.tokenTypes.length;ie<Ee;ie++)this._tokenTypeStrToInt.set(U.tokenTypes[ie],ie);for(let ie=0,Ee=U.tokenModifiers.length;ie<Ee;ie++)this._tokenModifierStrToInt.set(U.tokenModifiers[ie],ie)}}push(U,ie,Ee,Ve,Ye){if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(U,ie,Ee,Ve,Ye);if(H.isRange(U)&&typeof ie=="string"&&Ii(Ee))return this._push(U,ie,Ee);throw(0,C.illegalArgument)()}_push(U,ie,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ve=U.start.line,Ye=U.start.character,at=U.end.character-U.start.character,ut=this._tokenTypeStrToInt.get(ie);let Rt=0;if(Ee)for(const Bt of Ee){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Bt);Rt|=1<<Wt>>>0}this._pushEncoded(Ve,Ye,at,ut,Rt)}_pushEncoded(U,ie,Ee,Ve,Ye){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Bt=0,Wt=0;for(let qt=0;qt<Rt;qt++){let Qt=this._data[5*qt],_i=this._data[5*qt+1];Qt===0?(Qt=Bt,_i+=Wt):Qt+=Bt,this._data[5*qt]=Qt,this._data[5*qt+1]=_i,Bt=Qt,Wt=_i}}let at=U,ut=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Ye,this._prevLine=U,this._prevChar=ie}static _sortAndDeltaEncode(U){const ie=[],Ee=U.length/5|0;for(let ut=0;ut<Ee;ut++)ie[ut]=ut;ie.sort((ut,Rt)=>{const Bt=U[5*ut],Wt=U[5*Rt];if(Bt===Wt){const qt=U[5*ut+1],Qt=U[5*Rt+1];return qt-Qt}return Bt-Wt});const Ve=new Uint32Array(U.length);let Ye=0,at=0;for(let ut=0;ut<Ee;ut++){const Rt=5*ie[ut],Bt=U[Rt+0],Wt=U[Rt+1],qt=U[Rt+2],Qt=U[Rt+3],_i=U[Rt+4],Yi=Bt-Ye,_n=Yi===0?Wt-at:Wt,yi=5*ut;Ve[yi+0]=Yi,Ve[yi+1]=_n,Ve[yi+2]=qt,Ve[yi+3]=Qt,Ve[yi+4]=_i,Ye=Bt,at=Wt}return Ve}build(U){return this._dataIsSortedAndDeltaEncoded?new Me(new Uint32Array(this._data),U):new Me(li._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=li;class Me{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Me;class Vt{constructor(U,ie,Ee){this.start=U,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Vt;class Ci{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Ci;var gt;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ci=class{constructor(){}};ci.Back={iconPath:new _t("arrow-left")},ci=We([R],ci),e.QuickInputButtons=ci;var Ni;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ti;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Ti=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class ui{static validate(U){if(U.badge){let ie=(0,A.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,A.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,Ee){this.badge=U,this.tooltip=ie,this.color=Ee}}e.FileDecoration=ui;let Si=class{constructor(U){this.kind=U}};Si=We([R],Si),e.ColorTheme=Si;var Bi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Bi=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(U){return U instanceof jt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");U<=ie?(this._start=U,this._end=ie):(this._start=ie,this._end=U)}with(U){let ie=this._start,Ee=this._end;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(Ee=U.end),ie===this._start&&Ee===this._end?this:new jt(ie,Ee)}}e.NotebookRange=jt;class ii{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>ii.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,Ee,Ve,Ye,at,ut){this.kind=U,this.value=ie,this.languageId=Ee,this.mime=Ve,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ut,ii.validate(this)}}e.NotebookCellData=ii;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Ut{static isNotebookCellOutputItem(U){return U instanceof Ut?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Ut.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Ut.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ut.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Ut(U,ie)}static text(U,ie=I.Mimes.text){const Ee=Ae(Ut,g,"f",b).encode(String(U));return new Ut(Ee,ie)}static json(U,ie="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return Ut.text(Ee,ie)}constructor(U,ie){this.data=U,this.mime=ie;const Ee=(0,I.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=Ut,g=Ut,b={value:new TextEncoder};class di{static isNotebookCellOutput(U){return U instanceof di?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const Ee=new Set,Ve=new Set;for(let Ye=0;Ye<U.length;Ye++){const at=U[Ye],ut=(0,I.normalizeMimeType)(at.mime);if(!Ee.has(ut)||(0,E.isTextStreamMime)(ut)){Ee.add(ut);continue}Ve.add(Ye),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?U:U.filter((Ye,at)=>!Ve.has(at))}constructor(U,ie,Ee){this.items=di.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=di;var zi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(zi=e.NotebookCellKind||(e.NotebookCellKind={}));var $i;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})($i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Wi;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var re;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(re=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class he{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=he;var Re;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Re=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(st=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class wt{constructor(U,ie=[]){this.uri=U,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=wt;let Ct=class{constructor(U,ie){this.label=U,this.timestamp=ie}};Ct=We([R],Ct),e.TimelineItem=Ct;var tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(tn=e.ExtensionMode||(e.ExtensionMode={}));var nn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(nn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var rn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(rn=e.StandardTokenType||(e.StandardTokenType={}));class sn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=sn;class on{constructor(U,ie){this._port=U,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=on;var an;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(an=e.TestResultState||(e.TestResultState={}));var ln;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(ln=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(U=void 0,ie=void 0,Ee=void 0){this.include=U,this.exclude=ie,this.profile=Ee}};Hi=We([R],Hi),e.TestRunRequest=Hi;let Vi=T=class{static diff(U,ie,Ee){const Ve=new T(U);return Ve.expectedOutput=ie,Ve.actualOutput=Ee,Ve}constructor(U){this.message=U}};Vi=T=We([R],Vi),e.TestMessage=Vi;let ji=class{constructor(U){this.id=U}};ji=We([R],ji),e.TestTag=ji;let hi=class{constructor(U,ie){this.covered=U,this.total=ie}};hi=We([R],hi),e.CoveredCount=hi;let qi=F=class{static fromDetails(U,ie){const Ee=new hi(0,0),Ve=new hi(0,0),Ye=new hi(0,0);for(const ut of ie)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ve.total+=1,Ve.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const at=new F(U,Ee,Ve.total>0?Ve:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ie,at}constructor(U,ie,Ee,Ve){this.uri=U,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=Ve}};qi=F=We([R],qi),e.FileCoverage=qi;let Ki=class{constructor(U,ie,Ee=[]){this.executionCount=U,this.location=ie,this.branches=Ee}};Ki=We([R],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Gi=We([R],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Xi=We([R],Xi),e.FunctionCoverage=Xi;var cn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(cn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var un;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(un=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var dn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hn{constructor(U,ie,Ee,Ve,Ye,at){this.kind=U,this.name=ie,this.detail=Ee,this.uri=Ve,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=hn;class fn{constructor(U){this.uri=U}}e.TextTabInput=fn;class mn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=mn;class gn{constructor(U,ie,Ee,Ve){this.base=U,this.input1=ie,this.input2=Ee,this.result=Ve}}e.TextMergeTabInput=gn;class pn{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=pn;class vn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=vn;class En{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=En;class bn{constructor(U,ie,Ee){this.original=U,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=bn;class wn{constructor(){}}e.TerminalEditorTabInput=wn;class Sn{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=Sn}),define(De[94],Ie([1,0,47,13,10,248,125,6,16]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,t){t?k.set(f,t):k.delete(f)}e.setWordDefinitionFor=O;function S(f){return k.get(f)}class m extends M.MirrorTextModel{constructor(t,o,c,g,b,p,D,n){super(o,c,g,b),this._proxy=t,this._languageId=p,this._isDirty=D,this.notebook=n,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(t){return(0,y.equals)(this._lines,t)}get document(){if(!this._document){const t=this;this._document={get uri(){return t._uri},get fileName(){return t._uri.fsPath},get isUntitled(){return t._uri.scheme===C.Schemas.untitled},get languageId(){return t._languageId},get version(){return t._versionId},get isClosed(){return t._isDisposed},get isDirty(){return t._isDirty},save(){return t._save()},getText(o){return o?t._getTextInRange(o):t.getText()},get eol(){return t._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return t._lines.length},lineAt(o){return t._lineAt(o)},offsetAt(o){return t._offsetAt(o)},positionAt(o){return t._positionAt(o)},validateRange(o){return t._validateRange(o)},validatePosition(o){return t._validatePosition(o)},getWordRangeAtPosition(o,c){return t._getWordRangeAtPosition(o,c)}}}return Object.freeze(this._document)}_acceptLanguageId(t){(0,i.ok)(!this._isDisposed),this._languageId=t}_acceptIsDirty(t){(0,i.ok)(!this._isDisposed),this._isDirty=t}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(t){const o=this._validateRange(t);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const c=this._eol,g=o.start.line,b=o.end.line,p=[];p.push(this._lines[g].substring(o.start.character));for(let D=g+1;D<b;D++)p.push(this._lines[D]);return p.push(this._lines[b].substring(0,o.end.character)),p.join(c)}_lineAt(t){let o;if(t instanceof A.Position?o=t.line:typeof t=="number"&&(o=t),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this._lines[o],o===this._lines.length-1)}_offsetAt(t){return t=this._validatePosition(t),this._ensureLineStarts(),this._lineStarts.getPrefixSum(t.line-1)+t.character}_positionAt(t){t=Math.floor(t),t=Math.max(0,t),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(t),c=this._lines[o.index].length;return new A.Position(o.index,Math.min(o.remainder,c))}_validateRange(t){if(!(t instanceof A.Range))throw new Error("Invalid argument");const o=this._validatePosition(t.start),c=this._validatePosition(t.end);return o===t.start&&c===t.end?t:new A.Range(o.line,o.character,c.line,c.character)}_validatePosition(t){if(!(t instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return t.with(0,0);let{line:o,character:c}=t,g=!1;if(o<0)o=0,c=0,g=!0;else if(o>=this._lines.length)o=this._lines.length-1,c=this._lines[o].length,g=!0;else{const b=this._lines[o].length;c<0?(c=0,g=!0):c>b&&(c=b,g=!0)}return g?new A.Position(o,c):t}_getWordRangeAtPosition(t,o){const c=this._validatePosition(t);if(!o)o=S(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,I.getWordAtText)(c.character+1,(0,I.ensureValidWordDefinition)(o),this._lines[c.line],0);if(g)return new A.Range(c.line,g.startColumn-1,c.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class E{constructor(t,o,c){this._line=t,this._text=o,this._isLastLine=c}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(De[183],Ie([1,0,6,14,4]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=We([$e(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(De[8],Ie([1,0,16,24,110,184,81,28,107,80,59,23,9,2,52,71,86,92,91,67,42,51,178,6]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(_e){function Pe(K){const{selectionStartLineNumber:ke,selectionStartColumn:Le,positionLineNumber:Xe,positionColumn:Be}=K,ot=new s.Position(ke-1,Le-1),mt=new s.Position(Xe-1,Be-1);return new s.Selection(ot,mt)}_e.to=Pe;function fe(K){const{anchor:ke,active:Le}=K;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}_e.from=fe})(a=e.Selection||(e.Selection={}));var l;(function(_e){function Pe(K){if(!K)return;const{start:ke,end:Le}=K;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}_e.from=Pe;function fe(K){if(!K)return;const{startLineNumber:ke,startColumn:Le,endLineNumber:Xe,endColumn:Be}=K;return new s.Range(ke-1,Le-1,Xe-1,Be-1)}_e.to=fe})(l=e.Range||(e.Range={}));var u;(function(_e){function Pe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}_e.to=Pe})(u=e.TokenType||(e.TokenType={}));var d;(function(_e){function Pe(K){return new s.Position(K.lineNumber-1,K.column-1)}_e.to=Pe;function fe(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=fe})(d=e.Position||(e.Position={}));var r;(function(_e){function Pe(ke,Le){return(0,i.coalesce)((0,i.asArray)(ke).map(Xe=>fe(Xe,Le)))}_e.from=Pe;function fe(ke,Le){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:K(ke.scheme,Le),pattern:Ne.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType}}function K(ke,Le){return Le&&typeof ke=="string"?Le.transformOutgoingScheme(ke):ke}})(r=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(_e){function Pe(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}_e.from=Pe;function fe(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}_e.to=fe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(_e){function Pe(K){let ke;return K.code&&((0,m.isString)(K.code)||(0,m.isNumber)(K.code)?ke=String(K.code):ke={value:String(K.code.value),target:K.code.target}),{...l.from(K.range),message:K.message,source:K.source,code:ke,severity:L.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(P.from),tags:Array.isArray(K.tags)?(0,i.coalesce)(K.tags.map(h.from)):void 0}}_e.from=Pe;function fe(K){const ke=new s.Diagnostic(l.to(K),K.message,L.to(K.severity));return ke.source=K.source,ke.code=(0,m.isString)(K.code)?K.code:K.code?.value,ke.relatedInformation=K.relatedInformation&&K.relatedInformation.map(P.to),ke.tags=K.tags&&(0,i.coalesce)(K.tags.map(h.to)),ke}_e.to=fe})(v=e.Diagnostic||(e.Diagnostic={}));var P;(function(_e){function Pe(K){return{...l.from(K.location.range),message:K.message,resource:K.location.uri}}_e.from=Pe;function fe(K){return new s.DiagnosticRelatedInformation(new s.Location(K.resource,l.to(K)),K.message)}_e.to=fe})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(_e){function Pe(K){switch(K){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}_e.from=Pe;function fe(K){switch(K){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}_e.to=fe})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(_e){function Pe(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}_e.from=Pe;function fe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=fe})(j=e.ViewColumn||(e.ViewColumn={}));function V(_e){return typeof _e.range<"u"}function W(_e){return _e.length===0?!0:!!V(_e[0])}e.isDecorationOptionsArr=W;var T;(function(_e){function Pe(Be){return Be.map(_e.from)}_e.fromMany=Pe;function fe(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function K(Be){let ot;if(fe(Be)){const{language:Et,value:dt}=Be;ot={value:"```"+Et+`
`+dt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Be)?ot={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?ot={value:Be}:ot={value:""};const mt=Object.create(null);ot.uris=mt;const At=Et=>{try{let dt=E.URI.parse(Et,!0);dt=dt.with({query:ke(dt.query,mt)}),mt[Et]=dt}catch{}return""},vt=new y.marked.Renderer;return vt.link=At,vt.image=Et=>typeof Et=="string"?At(I.parseHrefAndDimensions(Et).href):"",(0,y.marked)(ot.value,{renderer:vt}),ot}_e.from=K;function ke(Be,ot){if(!Be)return Be;let mt;try{mt=(0,k.parse)(Be)}catch{}if(!mt)return Be;let At=!1;return mt=(0,S.cloneAndChange)(mt,vt=>{if(E.URI.isUri(vt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Et]=vt,At=!0,Et}else return}),At?JSON.stringify(mt):Be}function Le(Be){const ot=new s.MarkdownString(Be.value,Be.supportThemeIcons);return ot.isTrusted=Be.isTrusted,ot.supportHtml=Be.supportHtml,ot.baseUri=Be.baseUri?E.URI.from(Be.baseUri):void 0,ot}_e.to=Le;function Xe(Be){if(!!Be)return typeof Be=="string"?Be:_e.from(Be)}_e.fromStrict=Xe})(T=e.MarkdownString||(e.MarkdownString={}));function F(_e){return W(_e)?_e.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?T.fromMany(Pe.hoverMessage):Pe.hoverMessage?T.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):_e.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=F;function R(_e){return typeof _e>"u"?_e:typeof _e=="string"?E.URI.file(_e):_e}e.pathOrURIToURI=R;var x;(function(_e){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?R(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}_e.from=Pe})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(_e){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?R(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}_e.from=Pe})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(_e){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Pe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(_e){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?H.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?B.from(fe.light):void 0,dark:fe.dark?B.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?R(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}_e.from=Pe})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(_e){function Pe(K){return{text:K.newText,eol:K.newEol&&Fe.from(K.newEol),range:l.from(K.range)}}_e.from=Pe;function fe(K){const ke=new s.TextEdit(l.to(K.range),K.text);return ke.newEol=typeof K.eol>"u"?void 0:Fe.to(K.eol),ke}_e.to=fe})(ee=e.TextEdit||(e.TextEdit={}));var de;(function(_e){function Pe(K,ke){const Le={edits:[]};if(K instanceof s.WorkspaceEdit){const Xe=new A.ResourceSet;for(const Be of K._allEntries())Be._type===1&&E.URI.isUri(Be.to)&&Be.from===void 0&&Xe.add(Be.to);for(const Be of K._allEntries())Be._type===1?Le.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Le.edits.push({resource:Be.uri,textEdit:ee.from(Be.edit),versionId:Xe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Le.edits.push({resource:Be.uri,textEdit:{range:l.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Xe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Le.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Le.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(Dt.from)}})}return Le}_e.from=Pe;function fe(K){const ke=new s.WorkspaceEdit;for(const Le of K.edits)Le.textEdit?ke.replace(E.URI.revive(Le.resource),l.to(Le.textEdit.range),Le.textEdit.text):ke.renameFile(E.URI.revive(Le.oldResource),E.URI.revive(Le.newResource),Le.options);return ke}_e.to=fe})(de=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ne;(function(_e){const Pe=Object.create(null);Pe[s.SymbolKind.File]=0,Pe[s.SymbolKind.Module]=1,Pe[s.SymbolKind.Namespace]=2,Pe[s.SymbolKind.Package]=3,Pe[s.SymbolKind.Class]=4,Pe[s.SymbolKind.Method]=5,Pe[s.SymbolKind.Property]=6,Pe[s.SymbolKind.Field]=7,Pe[s.SymbolKind.Constructor]=8,Pe[s.SymbolKind.Enum]=9,Pe[s.SymbolKind.Interface]=10,Pe[s.SymbolKind.Function]=11,Pe[s.SymbolKind.Variable]=12,Pe[s.SymbolKind.Constant]=13,Pe[s.SymbolKind.String]=14,Pe[s.SymbolKind.Number]=15,Pe[s.SymbolKind.Boolean]=16,Pe[s.SymbolKind.Array]=17,Pe[s.SymbolKind.Object]=18,Pe[s.SymbolKind.Key]=19,Pe[s.SymbolKind.Null]=20,Pe[s.SymbolKind.EnumMember]=21,Pe[s.SymbolKind.Struct]=22,Pe[s.SymbolKind.Event]=23,Pe[s.SymbolKind.Operator]=24,Pe[s.SymbolKind.TypeParameter]=25;function fe(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}_e.from=fe;function K(ke){for(const Le in Pe)if(Pe[Le]===ke)return Number(Le);return s.SymbolKind.Property}_e.to=K})(ne=e.SymbolKind||(e.SymbolKind={}));var me;(function(_e){function Pe(K){switch(K){case s.SymbolTag.Deprecated:return 1}}_e.from=Pe;function fe(K){switch(K){case 1:return s.SymbolTag.Deprecated}}_e.to=fe})(me=e.SymbolTag||(e.SymbolTag={}));var le;(function(_e){function Pe(K){return{name:K.name,kind:ne.from(K.kind),tags:K.tags&&K.tags.map(me.from),containerName:K.containerName,location:Oe.from(K.location)}}_e.from=Pe;function fe(K){const ke=new s.SymbolInformation(K.name,ne.to(K.kind),K.containerName,Oe.to(K.location));return ke.tags=K.tags&&K.tags.map(me.to),ke}_e.to=fe})(le=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(_e){function Pe(K){const ke={name:K.name||"!!MISSING: name!!",detail:K.detail,range:l.from(K.range),selectionRange:l.from(K.selectionRange),kind:ne.from(K.kind),tags:K.tags?.map(me.from)??[]};return K.children&&(ke.children=K.children.map(Pe)),ke}_e.from=Pe;function fe(K){const ke=new s.DocumentSymbol(K.name,K.detail,ne.to(K.kind),l.to(K.range),l.to(K.selectionRange));return(0,i.isNonEmptyArray)(K.tags)&&(ke.tags=K.tags.map(me.to)),K.children&&(ke.children=K.children.map(fe)),ke}_e.to=fe})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(_e){function Pe(K){const ke=new s.CallHierarchyItem(ne.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),l.to(K.range),l.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}_e.to=Pe;function fe(K,ke,Le){if(ke=ke??K._sessionId,Le=Le??K._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,name:K.name,detail:K.detail,kind:ne.from(K.kind),uri:K.uri,range:l.from(K.range),selectionRange:l.from(K.selectionRange),tags:K.tags?.map(me.from)}}_e.from=fe})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(_e){function Pe(fe){return new s.CallHierarchyIncomingCall(Q.to(fe.from),fe.fromRanges.map(K=>l.to(K)))}_e.to=Pe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(_e){function Pe(fe){return new s.CallHierarchyOutgoingCall(Q.to(fe.to),fe.fromRanges.map(K=>l.to(K)))}_e.to=Pe})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Oe;(function(_e){function Pe(K){return{range:K.range&&l.from(K.range),uri:K.uri}}_e.from=Pe;function fe(K){return new s.Location(E.URI.revive(K.uri),l.to(K.range))}_e.to=fe})(Oe=e.location||(e.location={}));var xe;(function(_e){function Pe(K){const ke=K,Le=K;return{originSelectionRange:ke.originSelectionRange?l.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Le.uri,range:l.from(ke.targetRange?ke.targetRange:Le.range),targetSelectionRange:ke.targetSelectionRange?l.from(ke.targetSelectionRange):void 0}}_e.from=Pe;function fe(K){return{targetUri:E.URI.revive(K.uri),targetRange:l.to(K.range),targetSelectionRange:K.targetSelectionRange?l.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?l.to(K.originSelectionRange):void 0}}_e.to=fe})(xe=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(_e){function Pe(K){return{range:l.from(K.range),contents:T.fromMany(K.contents)}}_e.from=Pe;function fe(K){return new s.Hover(K.contents.map(T.to),l.to(K.range))}_e.to=fe})(Qe=e.Hover||(e.Hover={}));var Ce;(function(_e){function Pe(K){return{range:l.from(K.range),expression:K.expression}}_e.from=Pe;function fe(K){return new s.EvaluatableExpression(l.to(K.range),K.expression)}_e.to=fe})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(_e){function Pe(K){if(K instanceof s.InlineValueText)return{type:"text",range:l.from(K.range),text:K.text};if(K instanceof s.InlineValueVariableLookup)return{type:"variable",range:l.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Pe;function fe(K){switch(K.type){case"text":return{range:l.to(K.range),text:K.text};case"variable":return{range:l.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:l.to(K.range),expression:K.expression}}}_e.to=fe})(ye=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function Pe(K){return{frameId:K.frameId,stoppedLocation:l.from(K.stoppedLocation)}}_e.from=Pe;function fe(K){return new s.InlineValueContext(K.frameId,l.to(K.stoppedLocation))}_e.to=fe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(_e){function Pe(K){return{range:l.from(K.range),kind:K.kind}}_e.from=Pe;function fe(K){return new s.DocumentHighlight(l.to(K.range),K.kind)}_e.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(_e){function Pe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}_e.to=Pe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(_e){function Pe(fe){return{triggerKind:ae.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}_e.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var _;(function(_e){function Pe(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}_e.from=Pe;function fe(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}_e.to=fe})(_=e.CompletionItemTag||(e.CompletionItemTag={}));var N;(function(_e){const Pe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}_e.from=fe;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function ke(Le){return K.get(Le)??s.CompletionItemKind.Property}_e.to=ke})(N=e.CompletionItemKind||(e.CompletionItemKind={}));var $;(function(_e){function Pe(fe,K){const ke=new s.CompletionItem(fe.label);return ke.insertText=fe.insertText,ke.kind=N.to(fe.kind),ke.tags=fe.tags?.map(_.to),ke.detail=fe.detail,ke.documentation=I.isMarkdownString(fe.documentation)?T.to(fe.documentation):fe.documentation,ke.sortText=fe.sortText,ke.filterText=fe.filterText,ke.preselect=fe.preselect,ke.commitCharacters=fe.commitCharacters,f.Range.isIRange(fe.range)?ke.range=l.to(fe.range):typeof fe.range=="object"&&(ke.range={inserting:l.to(fe.range.insert),replacing:l.to(fe.range.replace)}),ke.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?ke.insertText=new s.SnippetString(fe.insertText):(ke.insertText=fe.insertText,ke.textEdit=ke.range instanceof s.Range?new s.TextEdit(ke.range,ke.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(ke.additionalTextEdits=fe.additionalTextEdits.map(Le=>ee.to(Le))),ke.command=K&&fe.command?K.fromInternal(fe.command):void 0,ke}_e.to=Pe})($=e.CompletionItem||(e.CompletionItem={}));var q;(function(_e){function Pe(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:T.fromStrict(K.documentation)}}_e.from=Pe;function fe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?T.to(K.documentation):K.documentation}}_e.to=fe})(q=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(_e){function Pe(K){return{label:K.label,documentation:T.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(q.from):[],activeParameter:K.activeParameter}}_e.from=Pe;function fe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?T.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(q.to):[],activeParameter:K.activeParameter}}_e.to=fe})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ce;(function(_e){function Pe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Z.from):[]}}_e.from=Pe;function fe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Z.to):[]}}_e.to=fe})(ce=e.SignatureHelp||(e.SignatureHelp={}));var we;(function(_e){function Pe(fe,K){const ke=new s.InlayHint(d.to(K.position),typeof K.label=="string"?K.label:K.label.map(oe.to.bind(void 0,fe)),K.kind&&be.to(K.kind));return ke.textEdits=K.textEdits&&K.textEdits.map(ee.to),ke.tooltip=I.isMarkdownString(K.tooltip)?T.to(K.tooltip):K.tooltip,ke.paddingLeft=K.paddingLeft,ke.paddingRight=K.paddingRight,ke}_e.to=Pe})(we=e.InlayHint||(e.InlayHint={}));var oe;(function(_e){function Pe(fe,K){const ke=new s.InlayHintLabelPart(K.label);return ke.tooltip=I.isMarkdownString(K.tooltip)?T.to(K.tooltip):K.tooltip,t.Command.is(K.command)&&(ke.command=fe.fromInternal(K.command)),K.location&&(ke.location=Oe.to(K.location)),ke}_e.to=Pe})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(_e){function Pe(K){return K}_e.from=Pe;function fe(K){return K}_e.to=fe})(be=e.InlayHintKind||(e.InlayHintKind={}));var ve;(function(_e){function Pe(K){return{range:l.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=Pe;function fe(K){let ke;if(K.url)try{ke=typeof K.url=="string"?E.URI.parse(K.url,!0):E.URI.revive(K.url)}catch{}return new s.DocumentLink(l.to(K.range),ke)}_e.to=fe})(ve=e.DocumentLink||(e.DocumentLink={}));var Ue;(function(_e){function Pe(K){const ke=new s.ColorPresentation(K.label);return K.textEdit&&(ke.textEdit=ee.to(K.textEdit)),K.additionalTextEdits&&(ke.additionalTextEdits=K.additionalTextEdits.map(Le=>ee.to(Le))),ke}_e.to=Pe;function fe(K){return{label:K.label,textEdit:K.textEdit?ee.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ke=>ee.from(ke)):void 0}}_e.from=fe})(Ue=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(_e){function Pe(K){return new s.Color(K[0],K[1],K[2],K[3])}_e.to=Pe;function fe(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=fe})(ze=e.Color||(e.Color={}));var et;(function(_e){function Pe(K){return{range:l.from(K.range)}}_e.from=Pe;function fe(K){return new s.SelectionRange(l.to(K.range))}_e.to=fe})(et=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(_e){function Pe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}_e.to=Pe})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(_e){function Pe(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Pe;function fe(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}_e.to=fe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Fe;(function(_e){function Pe(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}_e.from=Pe;function fe(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}_e.to=fe})(Fe=e.EndOfLine||(e.EndOfLine={}));var ht;(function(_e){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Pe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var X;(function(_e){function Pe(fe){const K={start:fe.start+1,end:fe.end+1};return fe.kind&&(K.kind=Y.from(fe.kind)),K}_e.from=Pe})(X=e.FoldingRange||(e.FoldingRange={}));var Y;(function(_e){function Pe(fe){if(fe)switch(fe){case s.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}_e.from=Pe})(Y=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pe;(function(_e){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?l.from(fe.selection):void 0,override:typeof fe.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Pe})(pe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ne;(function(_e){function Pe(Le){return Le instanceof s.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||K(Le)?new s.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}_e.from=Pe;function fe(Le){const Xe=Le;return Xe?E.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function K(Le){const Xe=Le;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(Le){return typeof Le=="string"?Le:new s.RelativePattern(E.URI.revive(Le.baseUri),Le.pattern)}_e.to=ke})(Ne=e.GlobPattern||(e.GlobPattern={}));var je;(function(_e){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const K=fe;return{language:K.language,scheme:K.scheme,pattern:Ne.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}_e.from=Pe})(je=e.LanguageSelector||(e.LanguageSelector={}));var qe;(function(_e){function Pe(K){return{start:K.start,end:K.end}}_e.from=Pe;function fe(K){return new s.NotebookRange(K.start,K.end)}_e.to=fe})(qe=e.NotebookRange||(e.NotebookRange={}));var He;(function(_e){function Pe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=Pe;function fe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}_e.from=fe})(He=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ze;(function(_e){function Pe(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}_e.to=Pe})(Ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var nt;(function(_e){function Pe(K){switch(K){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}_e.from=Pe;function fe(K){switch(K){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}_e.to=fe})(nt=e.NotebookCellKind||(e.NotebookCellKind={}));var lt;(function(_e){function Pe(K){const ke={metadata:K.metadata??Object.create(null),cells:[]};for(const Le of K.cells)s.NotebookCellData.validate(Le),ke.cells.push(Dt.from(Le));return ke}_e.from=Pe;function fe(K){const ke=new s.NotebookData(K.cells.map(Dt.to));return(0,m.isEmptyObject)(K.metadata)||(ke.metadata=K.metadata),ke}_e.to=fe})(lt=e.NotebookData||(e.NotebookData={}));var Dt;(function(_e){function Pe(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(it.from):[]}}_e.from=Pe;function fe(K){return new s.NotebookCellData(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(it.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}_e.to=fe})(Dt=e.NotebookCellData||(e.NotebookCellData={}));var rt;(function(_e){function Pe(K){return{mime:K.mime,valueBytes:C.VSBuffer.wrap(K.data)}}_e.from=Pe;function fe(K){return new s.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}_e.to=fe})(rt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var it;(function(_e){function Pe(K){return{outputId:K.id,items:K.items.map(rt.from),metadata:K.metadata}}_e.from=Pe;function fe(K){const ke=K.items.map(rt.to);return new s.NotebookCellOutput(ke,K.outputId,K.metadata)}_e.to=fe})(it=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Mt;(function(_e){function Pe(ke){return K(ke)?{include:(0,m.withNullAsUndefined)(Ne.from(ke.include)),exclude:(0,m.withNullAsUndefined)(Ne.from(ke.exclude))}:(0,m.withNullAsUndefined)(Ne.from(ke))}_e.from=Pe;function fe(ke){return K(ke)?{include:Ne.to(ke.include),exclude:Ne.to(ke.exclude)}:Ne.to(ke)}_e.to=fe;function K(ke){const Le=ke;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(Mt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ot;(function(_e){function Pe(fe,K,ke){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,ke),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}_e.from=Pe})(Ot=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ft;(function(_e){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}_e.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ft;(function(_e){function Pe(K){return{uri:K.uri,provides:K.provides}}_e.from=Pe;function fe(K){return new s.NotebookRendererScript(E.URI.revive(K.uri),K.provides)}_e.to=fe})(ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var It;(function(_e){function Pe(K){return{message:T.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:l.from(K.location.range),uri:K.location.uri}}}_e.from=Pe;function fe(K){const ke=new s.TestMessage(typeof K.message=="string"?K.message:T.to(K.message));return ke.actualOutput=K.actual,ke.expectedOutput=K.expected,ke.location=K.location?Oe.to(K.location):void 0,ke}_e.to=fe})(It=e.TestMessage||(e.TestMessage={}));var kt;(function(_e){_e.namespace=D.namespaceTestTag,_e.denamespace=D.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Pt;(function(_e){function Pe(K){const ke=(0,c.getPrivateApiFor)(K).controllerId;return{extId:p.TestId.fromExtHostTestItem(K,ke).toString(),label:K.label,uri:E.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Le=>kt.namespace(ke,Le.id)),range:f.Range.lift(l.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&T.fromStrict(K.error)||null}}_e.from=Pe;function fe(K){return{parent:void 0,error:void 0,id:p.TestId.fromString(K.extId).localId,label:K.label,uri:E.URI.revive(K.uri),tags:(K.tags||[]).map(ke=>{const{tagId:Le}=kt.denamespace(ke);return new s.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}_e.toPlain=fe})(Pt=e.TestItem||(e.TestItem={})),function(_e){function Pe(K){return{id:K.id}}_e.from=Pe;function fe(K){return new s.TestTag(K.id)}_e.to=fe}(kt=e.TestTag||(e.TestTag={}));var Ke;(function(_e){const Pe=(K,ke)=>{const Le=[];for(const[Be,ot]of ke)p.TestId.compare(ot.item.extId,Be)===2&&(ke.delete(Be),Le.push(ot));const Xe={...Pt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(ot=>ot.type===0).map(It.to)})),children:Le.map(Be=>Pe(Be,ke))};for(const Be of Xe.children)Be.parent=Xe;return Xe};function fe(K){const ke=[],Le=new Map;for(const Xe of K.items){Le.set(Xe.item.extId,Xe);const Be=p.TestId.root(Xe.item.extId);K.request.targets.some(ot=>ot.controllerId===Be&&ot.testIds.includes(Xe.item.extId))&&ke.push(Xe)}return{completedAt:K.completedAt,results:ke.map(Xe=>Pe(Xe,Le))}}_e.to=fe})(Ke=e.TestResults||(e.TestResults={}));var Tt;(function(_e){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?d.from(Le):l.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}_e.fromDetailed=K;function ke(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}_e.fromFile=ke})(Tt=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(_e){function Pe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}_e.to=Pe})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xt;(function(_e){function Pe(K){const ke=new s.TypeHierarchyItem(ne.to(K.kind),K.name,K.detail||"",E.URI.revive(K.uri),l.to(K.range),l.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}_e.to=Pe;function fe(K,ke,Le){if(ke=ke??K._sessionId,Le=Le??K._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,kind:ne.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:l.from(K.range),selectionRange:l.from(K.selectionRange),tags:K.tags?.map(me.from)}}_e.from=fe})(xt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var pt;(function(_e){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}_e.from=Pe})(pt=e.ViewBadge||(e.ViewBadge={}));var yt;(function(_e){function Pe(Le,Xe,Be){const ot=Xe.fileData;return ot?new class extends s.DataTransferItem{asFile(){return{name:ot.name,uri:E.URI.revive(ot.uri),data:(0,M.once)(()=>Be())}}}("",Xe.id):Le===O.Mimes.uriList&&Xe.uriListData?new s.DataTransferItem(ke(Xe.uriListData)):new s.DataTransferItem(Xe.asString)}_e.to=Pe;async function fe(Le,Xe){const Be=await Xe.asString();if(Le===O.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:K(Be)};const ot=Xe.asFile();return{id:Xe.id,asString:Be,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}}_e.from=fe;function K(Le){return w.UriList.split(Le).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return E.URI.parse(Xe)}catch{}return Xe})}function ke(Le){return w.UriList.create(Le.map(Xe=>typeof Xe=="string"?Xe:E.URI.revive(Xe)))}})(yt=e.DataTransferItem||(e.DataTransferItem={}));var St;(function(_e){function Pe(K,ke){const Le=K.items.map(([Xe,Be])=>[Xe,yt.to(Xe,Be,()=>ke(Be.id))]);return new s.DataTransfer(Le)}_e.toDataTransfer=Pe;async function fe(K){const ke={items:[]},Le=[];return K.forEach((Xe,Be)=>{Le.push((async()=>{ke.items.push([Be,await yt.from(Be,Xe)])})())}),await Promise.all(Le),ke}_e.toDataTransferDTO=fe})(St=e.DataTransfer||(e.DataTransfer={}))}),define(De[185],Ie([1,0,2,12,6,8,151]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,O,S,m={timeout:1500,errors:3}){this._logService=k,this._documents=O,this._mainThreadBulkEdits=S,this._thresholds=m,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(O,S,m)=>{const f={dispose:this._callbacks.push([O,S,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const S=i.URI.revive(k);let m=!1;const E=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const t of[...this._callbacks]){if(m)break;const o=this._documents.getDocument(S),c=await this._deliverEventAsyncAndBlameBadListeners(t,{document:o,reason:M.TextDocumentSaveReason.to(O)});f.push(c)}}finally{clearTimeout(E)}return f}_deliverEventAsyncAndBlameBadListeners([k,O,S],m){const E=this._badListeners.get(k);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,k,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this._badListeners.get(k);this._badListeners.set(k,t?t+1:1),typeof t=="number"&&t>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,O,S,m){const E=[],f=Date.now(),{document:t,reason:o}=m,{version:c}=t,g=Object.freeze({document:t,reason:o,waitUntil(b){if(Object.isFrozen(E))throw(0,C.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(b))}});try{O.apply(S,[g])}catch(b){return Promise.reject(b)}return Object.freeze(E),new Promise((b,p)=>{const D=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(D),b(n)}).catch(n=>{clearTimeout(D),p(n)})}).then(b=>{const p={edits:[]};for(const D of b)if(Array.isArray(D)&&D.every(n=>n instanceof w.TextEdit))for(const{newText:n,newEol:s,range:a}of D)p.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(p.edits.length!==0)return c===t.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(De[186],Ie([1,0,13,2,8,6,67]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(S,m,E,f){this.start=S,this.deletedCount=m,this.deletedItems=E,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(S,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,m,E){this.notebook=S,this._extHostDocument=m,this._cellData=E,this.handle=E.handle,this.uri=C.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(w.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:w.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return S._mime},set mime(f){S._mime=f},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(S){this._outputs=S.map(w.NotebookCellOutput.to)}setOutputItems(S,m,E){const f=E.map(w.NotebookCellOutputItem.to),t=this._outputs.find(o=>o.id===S);if(t&&(m||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(o=>I.isTextStreamMime(o.mime)))){const o=new Map,c=[];t.items.forEach(g=>{let b;o.has(g.mime)?b=o.get(g.mime):(b=[],o.set(g.mime,b),c.push(g.mime)),b.push(g.data)}),t.items.length=0,c.forEach(g=>{const b=I.compressOutputItemStreams(o.get(g));t.items.push({mime:g,data:b.buffer})})}}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=y;class k{constructor(S,m,E,f,t){this._proxy=S,this._textDocumentsAndEditors=m,this._textDocuments=E,this.uri=f,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=t.viewType,this._metadata=Object.freeze(t.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,t.cells]],!0,void 0),this._versionId=t.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,m={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===i.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(E){return E=S._validateIndex(E),S._cells[E].apiCell},getCells(E){return(E?S._getCells(E):S._cells).map(t=>t.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,m,E){this._versionId=S.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:E});const f={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},t=[];for(const c of S.rawEvents)c.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1,f.contentChanges):c.kind===I.NotebookCellsChangeType.Move?this._moveCells(c.index,c.length,c.newIdx,f.contentChanges):c.kind===I.NotebookCellsChangeType.Output?(this._setCellOutputs(c.index,c.outputs),t.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems),t.push({cell:this._cells[c.index].apiCell,outputs:this._cells[c.index].apiCell.outputs})):c.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(c.index,c.language),t.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document})):c.kind===I.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this._cells[c.index].apiCell,document:this._cells[c.index].apiCell.document}):c.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(c.index,c.metadata),t.push({cell:this._cells[c.index].apiCell,metadata:this._cells[c.index].apiCell.metadata})):c.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(c.index,c.internalMetadata),t.push({cell:this._cells[c.index].apiCell,executionSummary:this._cells[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<t.length;c++){const g=t[c],b=o.get(g.cell);if(b===void 0){const p=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,p-1)}else f.cellChanges[b]={...f.cellChanges[b],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let m=S.start|0,E=S.end|0;return m<0&&(m=0),E>this._cells.length&&(E=this._cells.length),S.with({start:m,end:E})}_getCells(S){S=this._validateRange(S);const m=[];for(let E=S.start;E<S.end;E++)m.push(this._cells[E]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,m,E){if(this._disposed)return;const f=[],t=[],o=[];if(S.reverse().forEach(c=>{const b=c[2].map(n=>{const s=new y(this,this._textDocumentsAndEditors,n);return m||t.push(y.asModelAddData(this.apiNotebook,n)),s}),p=new A(c[0],c[1],[],b),D=this._cells.splice(c[0],c[1],...b);for(const n of D)o.push(n.uri),p.deletedItems.push(n.apiCell);f.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:o}),E)for(const c of f)E.push(c.asApiEvent())}_moveCells(S,m,E,f){const t=this._cells.splice(S,m);this._cells.splice(E,0,...t);const o=[new A(S,m,t.map(c=>c.apiCell),[]),new A(E,0,[],t)];for(const c of o)f.push(c.asApiEvent())}_setCellOutputs(S,m){this._cells[S].setOutputs(m)}_setCellOutputItems(S,m,E,f){this._cells[S].setOutputItems(m,E,f)}_changeCellLanguage(S,m){const E=this._cells[S];E.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(E.uri,m)}_changeCellMime(S,m){const E=this._cells[S];E.apiCell.mime=m}_changeCellMetadata(S,m){this._cells[S].setMetadata(m)}_changeCellInternalMetadata(S,m){this._cells[S].setInternalMetadata(m)}getCellFromApiCell(S){return this._cells.find(m=>m.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(m=>m.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(De[95],Ie([1,0,12,8,6]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,y,k,O,S,m){this.id=A,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=S,this._visibleRanges=O,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(w.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,k){A._proxy.$tryRevealRange(A.id,C.NotebookRange.from(y),k??w.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(De[187],Ie([1,0,4,11,8]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const k=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(w.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(w.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(w.ViewColumn.to(A[y]))}};M=We([$e(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(De[188],Ie([1,0,8,154,134,20,58,12]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,E,f){const t=this._handles++,{title:o,location:c,cancellable:g}=E,b={label:(0,w.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(t,{location:i.ProgressLocation.from(c),title:o,source:b,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(t,f,!!g)}_withProgress(m,E,f){let t;f&&(t=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,t));const o=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),t?.dispose()};let c;try{c=E(new O(this._proxy,m),f&&t?t.token:M.CancellationToken.None)}catch(g){throw o(m),g}return c.then(g=>o(m),g=>o(m)),c}$acceptProgressCanceled(m){const E=this._mapHandleToCancellationSource.get(m);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=y;function k(S,m){return S.message=m.message,typeof m.increment=="number"&&(typeof S.increment=="number"?S.increment+=m.increment:S.increment=m.increment),S}class O extends C.Progress{constructor(m,E){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=E}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}We([(0,I.throttle)(100,(S,m)=>k(S,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[96],Ie([1,0,52,92,42,68,51,8,2]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,p,D,n)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!D(s,a)){const l=s;s=a,b.listener?.(n(a,l))}}}},O=(b,p)=>b===p,S={range:(b,p)=>b===p?!0:!b||!p?!1:b.isEqual(p),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,p)=>!(b.length!==p.length||b.some(D=>!p.find(n=>D.id===n.id)))},m=b=>p=>({op:4,update:b(p)}),E=(b,p)=>({range:(()=>{let D;const n=m(s=>({range:i.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return D},set(s){b.listener?.({op:6}),S.range(D,s)||(D=s,b.listener?.(n(s)))}}})(),label:k(b,p,S.label,m(D=>({label:D}))),description:k(b,void 0,S.description,m(D=>({description:D}))),sortText:k(b,void 0,S.sortText,m(D=>({sortText:D}))),canResolveChildren:k(b,!1,S.canResolveChildren,D=>({op:2,state:D})),busy:k(b,!1,S.busy,m(D=>({busy:D}))),error:k(b,void 0,S.error,m(D=>({error:A.MarkdownString.fromStrict(D)||null}))),tags:k(b,[],S.tags,(D,n)=>({op:1,new:D.map(A.TestTag.from),old:n.map(A.TestTag.from)}))}),f=b=>{const p=w.TestId.fromString(b.extId),D=new o(p.controllerId,p.localId,b.label,y.URI.revive(b.uri)||void 0);return D.range=A.Range.to(b.range||void 0),D.description=b.description||void 0,D.sortText=b.sortText||void 0,D.tags=b.tags.map(n=>A.TestTag.to({id:(0,I.denamespaceTestTag)(n).tagId})),D},t=b=>{let p;for(const D of b.tests){const n=f(D.item);(0,C.getPrivateApiFor)(n).parent=p,p=n}return p};e.toItemFromContext=t;class o{constructor(p,D,n,s){if(D.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(D)} symbol`);const a=(0,C.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:D,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof c?void 0:a.parent}},children:{value:(0,M.createTestItemChildren)(a,C.getPrivateApiFor,o),enumerable:!0,writable:!1},...E(a,n)})}}e.TestItemImpl=o;class c extends o{constructor(p,D){super(p,p,D,void 0),this._isRoot=!0}}e.TestItemRootImpl=c;class g extends M.TestItemCollection{constructor(p,D,n){super({controllerId:p,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:C.getPrivateApiFor,getChildren:s=>s.children,root:new c(p,D),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(De[97],Ie([1,0,47,12,79,8,6]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,E,f){const t=A._Keys.nextId();m.$registerTextEditorDecorationType(E.identifier,t,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class y{constructor(m,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,E){this._throwIfFinalized();let f=null;if(m instanceof I.Position)f=new I.Range(m,m);else if(m instanceof I.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,E,!1)}insert(m,E){this._throwIfFinalized(),this._pushEdit(new I.Range(m,m),E,!0)}delete(m){this._throwIfFinalized();let E=null;if(m instanceof I.Range)E=m;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(m,E,f){const t=this._document.validateRange(m);this._collectedEdits.push({range:t,text:E,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=y;class k{constructor(m,E,f,t){this._proxy=m,this._id=E,this._accept(f),this._logService=t;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(c){o._setTabSize(c)},get insertSpaces(){return o._insertSpaces},set insertSpaces(c){o._setInsertSpaces(c)},get cursorStyle(){return o._cursorStyle},set cursorStyle(c){o._setCursorStyle(c)},get lineNumbers(){return o._lineNumbers},set lineNumbers(c){o._setLineNumbers(c)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const E=Math.floor(m);return E>0?E:null}if(typeof m=="string"){const E=parseInt(m,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(m){const E=this._validateTabSize(m);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const E=this._validateInsertSpaces(m);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const E={};let f=!1;if(typeof m.tabSize<"u"){const t=this._validateTabSize(m.tabSize);t==="auto"?(f=!0,E.tabSize=t):typeof t=="number"&&this._tabSize!==t&&(this._tabSize=t,f=!0,E.tabSize=t)}if(typeof m.insertSpaces<"u"){const t=this._validateInsertSpaces(m.insertSpaces);t==="auto"?(f=!0,E.insertSpaces=t):this._insertSpaces!==t&&(this._insertSpaces=t,f=!0,E.insertSpaces=t)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,E.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(m,E){E.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,E,f,t,o,c,g,b){this.id=m,this._proxy=E,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new k(this._proxy,this.id,c,f),this._visibleRanges=g,this._viewColumn=b;const p=this;this.value=Object.freeze({get document(){return t.getValue()},set document(D){throw(0,C.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(D){if(!(D instanceof I.Selection))throw(0,C.illegalArgument)("selection");p._selections=[D],p._trySetSelection()},get selections(){return p._selections},set selections(D){if(!Array.isArray(D)||D.some(n=>!(n instanceof I.Selection)))throw(0,C.illegalArgument)("selections");p._selections=D,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(D){throw(0,C.readonly)("visibleRanges")},get options(){return p._options.value},set options(D){p._disposed||p._options.assign(D)},get viewColumn(){return p._viewColumn},set viewColumn(D){throw(0,C.readonly)("viewColumn")},edit(D,n={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(t.getValue(),n);return D(s),p._applyEdit(s)},insertSnippet(D,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=p._selections.map(l=>M.Range.from(l));else if(n instanceof I.Position){const{lineNumber:l,column:u}=M.Position.from(n);a=[{startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u}]}else if(n instanceof I.Range)a=[M.Range.from(n)];else{a=[];for(const l of n)if(l instanceof I.Range)a.push(M.Range.from(l));else{const{lineNumber:u,column:d}=M.Position.from(l);a.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return E.$tryInsertSnippet(m,t.getValue().version,D.value,a,s)},setDecorations(D,n){const s=n.length===0;s&&!p._hasDecorationsForKey.has(D.key)||(s?p._hasDecorationsForKey.delete(D.key):p._hasDecorationsForKey.add(D.key),p._runOnProxy(()=>{if(M.isDecorationOptionsArr(n))return E.$trySetDecorations(m,D.key,M.fromRangeOrRangeWithMessage(n));{const a=new Array(4*n.length);for(let l=0,u=n.length;l<u;l++){const d=n[l];a[4*l]=d.start.line+1,a[4*l+1]=d.start.character+1,a[4*l+2]=d.end.line+1,a[4*l+3]=d.end.character+1}return E.$trySetDecorationsFast(m,D.key,a)}}))},revealRange(D,n){p._runOnProxy(()=>E.$tryRevealRange(m,M.Range.from(D),n||I.TextEditorRevealType.Default))},show(D){E.$tryShowEditor(m,M.ViewColumn.from(D))},hide(){E.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,i.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,i.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,i.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const E=m.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(o=>o.range);f.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=f.length-1;o<c;o++){const g=f[o].end;if(f[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=E.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,t,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=O}),define(De[189],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[190],Ie([1,0,145,12,29,85,88,30,25,189,153]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=A.Registry.as(I.Extensions.JSONContribution);class m{constructor(p,D,n){this._messageHandler=p,this._extension=D,this._extensionPointId=n}_msg(p,D){this._messageHandler({type:p,message:D,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(p){this._msg(w.default.Error,p)}warn(p){this._msg(w.default.Warning,p)}info(p){this._msg(w.default.Info,p)}}e.ExtensionMessageCollector=m;class E{static _toSet(p){const D=new Set;for(let n=0,s=p.length;n<s;n++)D.add(y.ExtensionIdentifier.toKey(p[n].description.identifier));return D}static compute(p,D){if(!p||!p.length)return new E(D,[]);if(!D||!D.length)return new E([],p);const n=this._toSet(p),s=this._toSet(D),a=D.filter(u=>!n.has(y.ExtensionIdentifier.toKey(u.description.identifier))),l=p.filter(u=>!s.has(y.ExtensionIdentifier.toKey(u.description.identifier)));return new E(a,l)}constructor(p,D){this.added=p,this.removed=D}}e.ExtensionPointUserDelta=E;class f{constructor(p,D){this.name=p,this.defaultExtensionKind=D,this._handler=null,this._users=null,this._delta=null}setHandler(p){if(this._handler!==null)throw new Error("Handler already set!");this._handler=p,this._handle()}acceptUsers(p){this._delta=E.compute(this._users,p),this._users=p,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(p){(0,C.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onUri",body:"onUri",description:i.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(35,null)},{label:"onRenderer",description:i.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(38,null)},{label:"*",description:i.localize(39,null),body:"*"}]}},badges:{type:"array",description:i.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(41,null)},href:{type:"string",description:i.localize(42,null)},description:{type:"string",description:i.localize(43,null)}}}},markdown:{type:"string",description:i.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(48,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(49,null)},{body:["workspace"],description:i.localize(50,null)},{body:["ui","workspace"],description:i.localize(51,null)},{body:["workspace","ui"],description:i.localize(52,null)},{body:[],description:i.localize(53,null)}]},capabilities:{description:i.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(57,null),i.localize(58,null),i.localize(59,null)]},description:{type:"string",markdownDescription:i.localize(60,null)}}},untrustedWorkspaces:{description:i.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)]},restrictedConfigurations:{description:i.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(67,null)}}}}},sponsor:{description:i.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(70,null),type:"string"},"vscode:uninstall":{description:i.localize(71,null),type:"string"}}},icon:{type:"string",description:i.localize(72,null)},l10n:{type:"string",description:i.localize(73,null)}}};class c{constructor(){this._extensionPoints=new Map}registerExtensionPoint(p){if(this._extensionPoints.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const D=new f(p.extensionPoint,p.defaultExtensionKind);return this._extensionPoints.set(p.extensionPoint,D),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,S.registerSchema(o,e.schema),D}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=c;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new c),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),S.registerSchema(o,e.schema),S.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[191],Ie([1,0,142,9,23,190,41,4]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function E(f,t,o){if(!f)return;const c=C.isString(f.type)?f.type:void 0;if(!c||c.length===0){o.error(i.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const b of f.required)C.isString(b)&&g.push(b);return{extensionId:t.value,taskType:c,required:g,properties:f.properties?w.deepClone(f.properties):{},when:f.when?I.ContextKeyExpr.deserialize(f.when):void 0}}m.from=E})(k||(k={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class S{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,f)=>{O.setHandler((t,o)=>{this._schema=void 0;try{for(const c of o.removed){const g=c.value;for(const b of g)this.taskTypes&&b.type&&this.taskTypes[b.type]&&delete this.taskTypes[b.type]}for(const c of o.added){const g=c.value;for(const b of g){const p=k.from(b,c.description.identifier,c.collector);p&&(this.taskTypes[p.taskType]=p)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=w.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},E.push(t)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new S}),define(De[192],Ie([1,0,143,9,22,23,41,191]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function x(B){if(!B)return R.Strong;switch(B.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=x}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function x(B){switch(B.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=x}(O=e.RevealKind||(e.RevealKind={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function x(B){switch(B.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=x}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(R){function x(B){switch(B.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=x}(m=e.PanelKind||(e.PanelKind={}));var E;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(R){function x(H){switch(H.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=x;function B(H){switch(H){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=B}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(R){function x(B){return C.isString(B)?B:B.value}R.value=x})(t=e.CommandString||(e.CommandString={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function x(H){return H===R.Clean._id||H===R.Build._id||H===R.Rebuild._id||H===R.Test._id}R.is=x;function B(H){if(H!==void 0)return C.isString(H)?x(H)?{_id:H,isDefault:!1}:void 0:H}R.from=B})(o=e.TaskGroup||(e.TaskGroup={}));var c;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(c=e.TaskScope||(e.TaskScope={}));var g;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function x(B){switch(B){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=x})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(R){R.parallel="parallel",R.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var p;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var D;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(D=e.RunOptions||(e.RunOptions={}));class n{constructor(x,B,H,G,ee,de){this._label="",this._id=x,B&&(this._label=B),H&&(this.type=H),this.runOptions=G,this.configurationProperties=ee,this._source=de}getDefinition(x){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,B=!1){if(x===void 0)return!1;if(C.isString(x))return x===this._label||x===this.configurationProperties.identifier||B&&x===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class s extends n{constructor(x,B,H,G,ee,de,ne,me){super(x,H,void 0,ne,me,B),this.command={},this._source=B,this.hasDefinedMatchers=de,ee&&(this.command=ee)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case f.Shell:B="shell";break;case f.Process:B="process";break;case f.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(x){return x instanceof s}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(B+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new s(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=s;class a extends n{constructor(x,B,H,G,ee,de,ne){super(x,H,G,de,ne,B),this._source=B,this.configures=ee}static is(x){return x instanceof a}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(B+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(H)}}e.ConfiguringTask=a;class l extends n{constructor(x,B,H,G,ee,de,ne,me,le){super(x,H,G,me,le,B),this.defines=ee,this.hasDefinedMatchers=ne,this.command=de,this.icon=le.icon,this.hide=le.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof l}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new l(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=l;class u extends n{constructor(x,B,H,G,ee,de){super(x,H,G,ee,de,B),this._source=B}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new u(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=u;var d;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(x){this._order=new Map;for(let B=0;B<x.length;B++)this._order.set(x[B].uri.toString(),B)}compare(x,B){const H=x.getWorkspaceFolder(),G=B.getWorkspaceFolder();if(H&&G){let ee=this._order.get(H.uri.toString());ee=ee===void 0?0:ee+1;let de=this._order.get(G.uri.toString());return de=de===void 0?0:de+1,ee===de?x._label.localeCompare(B._label):ee-de}else return!H&&G?-1:H&&!G?1:0}}e.TaskSorter=h;var v;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(R){R.SingleRun="singleRun",R.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var L;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(R){function x(B,H,G,ee){if(H){const de={kind:B,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:G,__task:H};return B==="start"?de.resolvedVariables=ee:B==="processStarted"?de.processId=ee:B==="processEnded"&&(de.exitCode=ee),Object.freeze(de)}else return Object.freeze({kind:"changed"})}R.create=x})(j=e.TaskEvent||(e.TaskEvent={}));var V;(function(R){function x(H){const G=Object.keys(H).sort();let ee="";for(const de of G){let ne=H[de];ne instanceof Object?ne=x(ne):typeof ne=="string"&&(ne=ne.replace(/,/g,",,")),ee+=de+","+ne+","}return ee}function B(H){const ee={_key:x(H),type:H.taskType};return Object.assign(ee,H),ee}R.create=B})(V=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var W;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(W=e.TaskSettingId||(e.TaskSettingId={}));var T;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(T=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var F;(function(R){function x(B,H){const G=A.TaskDefinitionRegistry.get(B.type);if(G===void 0){const me=M.deepClone(B);return delete me._key,V.create(me)}const ee=Object.create(null);ee.type=G.taskType;const de=new Set;G.required.forEach(me=>de.add(me));const ne=G.properties;for(const me of Object.keys(ne)){const le=B[me];if(le!=null)ee[me]=le;else if(de.has(me)){const ue=ne[me];if(ue.default!==void 0)ee[me]=M.deepClone(ue.default);else switch(ue.type){case"boolean":ee[me]=!1;break;case"number":case"integer":ee[me]=0;break;case"string":ee[me]="";break;default:H.error(i.localize(2,null,JSON.stringify(B,void 0,0),me));return}}}return V.create(ee)}R.createTaskIdentifier=x})(F=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[193],Ie([1,0,12]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,A)=>{this._actualOk=I,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,i.onUnexpectedError)(I))}then(I,A){return this._ensureActual().then(I,A)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=C;class w extends C{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=w}),define(De[43],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const C=[];function w(A){const y=new i(A);return C[y.nid]=y,y}e.createProxyIdentifier=w;function M(A){return C[A].sid}e.getStringIdentifierForProxy=M;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(De[5],Ie([1,0,43]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var w;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(w=e.TabInputKind||(e.TabInputKind={}));var M;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(o){return o._id=S._n++,o}}e.IdObject=S,S._n=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(De[72],Ie([1,0,3,11,5,14]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(w.MainContext.MainThreadTelemetry)}report(y,k,O){const S=this.getUsageKey(y,k);this._reportedUsages.has(S)||(this._reportedUsages.add(S),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};I=We([$e(0,M.IExtHostRpcService),$e(1,C.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,k){}})}),define(De[194],Ie([1,0,4,5,6,25]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,k,O,S={}){const m=M.ExtensionIdentifier.toKey(y.identifier),E=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let t=E.find(o=>o.providerId===k&&o.scopes===f);if(t)return t.result;{const o=this._getSession(y,m,k,O,S);t={providerId:k,scopes:f,result:o},E.push(t),this._inFlightRequests.set(m,E);try{await o}finally{const c=E.findIndex(g=>g.providerId===k&&g.scopes===f);c>-1&&(E.splice(c),this._inFlightRequests.set(m,E))}return o}}async _getSession(y,k,O,S,m={}){await this._proxy.$ensureProvider(O);const E=y.displayName||y.name;return this._proxy.$getSession(O,S,k,E,m)}async removeSession(y,k){const O=this._authenticationProviders.get(y);return O?O.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,O,S){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:O,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===y)||this._providers.push({id:y,label:k});const m=O.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(y,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,k,S?.supportsMultipleAccounts??!1),new w.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const E=this._providers.findIndex(f=>f.id===y);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(De[195],Ie([1,0,5,14,8]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,y){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,k){const O=w.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};M=We([$e(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(De[196],Ie([1,0,5]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const I=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[38],Ie([1,0,9,6,8,23,5,16,11,80,52,249,2,7,3,14,96,24,43,45]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b){"use strict";var p,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(r,h){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,D.set(this,void 0),Je(this,p,r.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=h,Je(this,D,r.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new s(this,v=>{const P=this._apiCommands.get(v);return P?.result===l.Void?P:void 0},h),this._argumentProcessors=[{processArgument(v){return(0,k.revive)(v)}},{processArgument(v){return(0,M.cloneAndChange)(v,function(P){if(O.Range.isIRange(P))return w.Range.to(P);if(S.Position.isIPosition(P))return w.Position.to(P);if(O.Range.isIRange(P.range)&&m.URI.isUri(P.uri))return w.location.to(P);if(P instanceof c.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const h=this.registerCommand(!1,r.id,async(...v)=>{const P=r.args.map((j,V)=>{if(!j.validate(v[V]))throw new Error(`Invalid argument '${j.name}' when running '${r.id}', received: ${v[V]}`);return j.convert(v[V])}),L=await this.executeCommand(r.internalId,...P);return r.result.convert(L,v,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new C.Disposable(()=>{h.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,h,v,P,L,j){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:v,thisArg:P,description:L,extension:j}),r&&Ae(this,p,"f").$registerCommand(h),new C.Disposable(()=>{this._commands.delete(h)&&r&&Ae(this,p,"f").$unregisterCommand(h)})}executeCommand(r,...h){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,h,!0)}async _doExecuteCommand(r,h,v){if(this._commands.has(r))return Ae(this,p,"f").$fireCommandActivationEvent(r),this._executeContributedCommand(r,h,!1);{let P=!1;const L=(0,M.cloneAndChange)(h,function(j){if(j instanceof C.Position)return w.Position.from(j);if(j instanceof C.Range)return w.Range.from(j);if(j instanceof C.Location)return w.location.from(j);if(C.NotebookRange.isNotebookRange(j))return w.NotebookRange.from(j);if(j instanceof ArrayBuffer)return P=!0,c.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return P=!0,c.VSBuffer.wrap(j);if(j instanceof c.VSBuffer)return P=!0,j;if(!Array.isArray(j))return j});try{const j=await Ae(this,p,"f").$executeCommand(r,P?new g.SerializableObjectWithBuffers(L):L,v);return(0,k.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(r,h,!1);throw j}}}async _executeContributedCommand(r,h,v){const P=this._commands.get(r);if(!P)throw new Error("Unknown command");const{callback:L,thisArg:j,description:V}=P;if(V)for(let T=0;T<V.args.length;T++)try{(0,i.validateConstraint)(h[T],V.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${V.args[T].name}' - ${V.args[T].description}`)}const W=Date.now();try{return await L.apply(j,h)}catch(T){if(r===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...h);F&&(r=F.command)}throw this._logService.error(T,r,P.extension?.identifier),v?new class extends Error{constructor(){super((0,b.toErrorMessage)(T)),this.id=r,this.source=P.extension?.displayName??P.extension?.name}}:T}finally{this._reportTelemetry(P,r,Date.now()-W)}}_reportTelemetry(r,h,v){!r.extension||r.extension.isBuiltin||Ae(this,D,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:h,duration:v})}$executeContributedCommand(r,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(h=h.map(v=>this._argumentProcessors.reduce((P,L)=>L.processArgument(P),v)),this._executeContributedCommand(r,h,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),Ae(this,p,"f").$getCommands().then(h=>(r&&(h=h.filter(v=>v[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[h,v]of this._commands){const{description:P}=v;P&&(r[h]=P)}return Promise.resolve(r)}};p=new WeakMap,D=new WeakMap,n=We([$e(0,t.IExtHostRpcService),$e(1,y.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class s{constructor(r,h,v){this._commands=r,this._lookupApiCommand=h,this._logService=v,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,h){if(!r)return;const v={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return v;const P=this._lookupApiCommand(r.command);if(P)v.id=P.internalId,v.arguments=P.args.map((L,j)=>L.convert(r.arguments&&r.arguments[j]));else if((0,A.isNonEmptyArray)(r.arguments)){const L=`${r.command}/${++this._cachIdPool}`;this._cache.set(L,r),h.add((0,E.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),v.$ident=L,v.id=this.delegatingCommandId,v.arguments=[L],this._logService.trace("CommandsConverter#CREATE",r.command,L)}return v}fromInternal(r){return typeof r.$ident=="string"?this._cache.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const h=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${r[0]}`)}}e.CommandsConverter=s;class a{constructor(r,h,v,P){this.name=r,this.description=h,this.validate=v,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,h){return new a(r??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",d=>m.URI.isUri(d),d=>d),a.Position=new a("position","A position in a text document",d=>C.Position.isPosition(d),w.Position.from),a.Range=new a("range","A range in a text document",d=>C.Range.isRange(d),w.Range.from),a.Selection=new a("selection","A selection in a text document",d=>C.Selection.isSelection(d),w.Selection.from),a.Number=new a("number","",d=>typeof d=="number",d=>d),a.String=new a("string","",d=>typeof d=="string",d=>d),a.CallHierarchyItem=new a("item","A call hierarchy item",d=>d instanceof C.CallHierarchyItem,w.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",d=>d instanceof C.TypeHierarchyItem,w.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",d=>d instanceof o.TestItemImpl,w.TestItem.from);class l{constructor(r,h){this.description=r,this.convert=h}}e.ApiCommandResult=l,l.Void=new l("no result",d=>d);class u{constructor(r,h,v,P,L){this.id=r,this.internalId=h,this.description=v,this.args=P,this.result=L}}e.ApiCommand=u}),define(De[197],Ie([1,0,2,8,6,71,38,16,83,87,13]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,A.isFalsyOrEmpty)(t))return;class c extends w.SymbolInformation{static to(b){const p=new c(b.name,C.SymbolKind.to(b.kind),b.containerName||"",new w.Location(o[0],C.Range.to(b.range)));return p.detail=b.detail,p.range=p.location.range,p.selectionRange=C.Range.to(b.selectionRange),p.children=b.children?b.children.map(c.to):[],p}}return t.map(c.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new I.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>w.Position.isPosition(o)),t=>t.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let c;for(const g of o.reverse())c=new w.SelectionRange(C.Range.to(g),c);return c}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:C.Range.to(t.range),placeholder:t.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return C.WorkspaceEdit.to(t)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new w.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,y.decodeSemanticTokensDto)(t);if(o.type==="full")return new w.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,c)=>{if(!t)return new w.CompletionList([]);const g=t.suggestions.map(b=>C.CompletionItem.to(b,c));return new w.CompletionList(g,t.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return C.SignatureHelp.to(t)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,c)=>E(g=>new w.CodeLens(C.Range.to(g.range),g.command&&c.fromInternal(g.command)))(t))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>w.Range.isRange(t),t=>w.Selection.isSelection(t)?C.Selection.from(t):C.Range.from(t)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,c)=>E(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const b=new w.CodeAction(g.title,g.kind?new w.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(b.command=c.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(t))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new w.ColorInformation(C.Range.to(o.range),C.Color.to(o.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",t=>t instanceof w.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:C.Range.from(t.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,c)=>t.map(C.InlayHint.to.bind(void 0,c)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>C.NotebookExclusiveDocumentPattern.to(o))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,O.Schemas.http,O.Schemas.https),t=>t),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void)];class m{static register(o){S.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function E(t){return o=>{if(Array.isArray(o))return o.map(t)}}function f(t){if(!Array.isArray(t))return;const o=[];for(const c of t)M.isLocationLink(c)?o.push(C.DefinitionLink.to(c)):o.push(C.location.to(c));return o}}),define(De[198],Ie([1,0,15,58,4,7,2,71,25,8,6,27,5]),function(te,e,i,C,w,M,I,A,y,k,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(f,t,o){const c=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,t.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const r=this._commentControllers.get(d.handle);return r?r.value:d}else if(d&&d.$mid===7){const r=this._commentControllers.get(d.commentControlHandle);if(!r)return d;const h=r.getCommentThread(d.commentThreadHandle);return h?h.value:d}else if(d&&d.$mid===8){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const h=r.getCommentThread(d.thread.commentThreadHandle);return h?{thread:h.value,text:d.text}:d}else if(d&&d.$mid===9){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const h=r.getCommentThread(d.thread.commentThreadHandle);if(!h)return d;const v=d.commentUniqueId,P=h.getCommentByUniqueId(v);return P||d}else if(d&&d.$mid===10){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const h=r.getCommentThread(d.thread.commentThreadHandle);if(!h)return d;const v=d.text,P=d.commentUniqueId,L=h.getCommentByUniqueId(P);return L?(typeof L.body=="string"?L.body=v:L.body.value=v,L):d}return d}})}createCommentController(d,r,h){const v=g.handlePool++,P=new p(d,v,r,h);this._commentControllers.set(P.handle,P);const L=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(P),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(d.identifier),L),P.value}$createCommentThreadTemplate(d,r,h){const v=this._commentControllers.get(d);!v||v.$createCommentThreadTemplate(r,h)}async $updateCommentThreadTemplate(d,r,h){const v=this._commentControllers.get(d);!v||v.$updateCommentThreadTemplate(r,h)}$deleteCommentThread(d,r){this._commentControllers.get(d)?.$deleteCommentThread(r)}$provideCommentingRanges(d,r,h){const v=this._commentControllers.get(d);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const P=o.getDocument(I.URI.revive(r));return(0,i.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(P,h)).then(L=>L?L.map(j=>k.Range.from(j)):void 0)}$toggleReaction(d,r,h,v,P){const L=this._commentControllers.get(d);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=L.getCommentThread(r);if(j){const V=j.getCommentByUniqueId(v.uniqueIdInThread);if(L!==void 0&&V&&L.reactionHandler)return L.reactionHandler(V,s(P))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class b{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,r,h,v,P,L,j,V){this._commentControllerHandle=r,this._id=h,this._uri=v,this._range=P,this._comments=L,this.extensionDescription=j,this._isTemplate=V,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),c.$createCommentThread(r,this.handle,this._id,this._uri,k.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(r,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(T){W.range=T},get comments(){return W.comments},set comments(T){W.comments=T},get collapsibleState(){return W.collapsibleState},set collapsibleState(T){W.collapsibleState=T},get canReply(){return W.canReply},set canReply(T){W.canReply=T},get contextValue(){return W.contextValue},set contextValue(T){W.contextValue=T},get label(){return W.label},set label(T){W.label=T},get state(){return W.state},set state(T){W.state=T},dispose:()=>{W.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const d=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),r={};d("range")&&(r.range=k.Range.from(this._range)),d("label")&&(r.label=this.label),d("contextValue")&&(r.contextValue=this.contextValue??null),d("comments")&&(r.comments=this._comments.map(h=>D(this,h,this._commentsMap))),d("collapsibleState")&&(r.collapseState=a(this._collapseState)),d("canReply")&&(r.canReply=this.canReply),d("state")&&(r.state=l(this._state)),d("isTemplate")&&(r.isTemplate=this._isTemplate),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(d){for(const r of this._commentsMap){const h=r[0],v=r[1];if(d===v)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}b._handlePool=0,We([(0,C.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,r,h,v){this._extension=d,this._handle=r,this._id=h,this._label=v,this._threads=new Map,c.$registerCommentController(this.handle,h,v);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(L){P.options=L},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(L){P.commentingRangeProvider=L},get reactionHandler(){return P.reactionHandler},set reactionHandler(L){P.reactionHandler=L},createCommentThread(L,j,V){return P.createCommentThread(L,j,V).value},dispose:()=>{P.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(d,r,h,v){if(typeof d=="string"){const P=new b(this.id,this.handle,d,r,h,v,this._extension,!1);return this._threads.set(P.handle,P),P}else{const P=new b(this.id,this.handle,void 0,d,r,h,this._extension,!1);return this._threads.set(P.handle,P),P}}$createCommentThreadTemplate(d,r){const h=new b(this.id,this.handle,void 0,I.URI.revive(d),k.Range.to(r),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(d,r){const h=this._threads.get(d);h&&(h.range=k.Range.to(r))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function D(u,d,r){let h=r.get(d);h||(h=++u.commentHandle,r.set(d,h));const v=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:h,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:v,label:d.label,commentReactions:d.reactions?d.reactions.map(P=>n(P)):void 0,timestamp:d.timestamp?.toJSON()}}function n(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function s(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?I.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function a(u){if(u!==void 0)switch(u){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function l(u){if(u!==void 0)switch(u){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new g}e.createExtHostComments=E}),define(De[199],Ie([1,0,23,5,26,14]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(O,S){this._mainThreadConsole=O.getProxy(C.MainContext.MainThreadConsole),this._includeStack=S.consoleForward.includeStack,this._logNative=S.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,S){const m=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,S,E,arguments)}})}_handleConsoleCall(O,S,m,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:S,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,E)}};I=We([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function y(k,O){const S=[];if(k.length)for(let m=0;m<k.length;m++){let E=k[m];if(typeof E>"u")E="undefined";else if(E instanceof Error){const f=E;f.stack?E=f.stack:E=f.toString()}S.push(E)}if(O){const m=new Error().stack;m&&S.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(S);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(De[98],Ie([1,0,2,5,6,3,14,11,16,10,19]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class ki{constructor(E,f){this._logService=f,this._provider=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,f){const t=ki._handlePool++;this._provider.set(t,{provider:E,extensionId:f}),this._proxy.$registerDecorationProvider(t,f.value);const o=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(c=>{if(!c){this._proxy.$onDidChange(t,null);return}const g=(0,y.asArray)(c);if(g.length<=ki._maxEventSize){this._proxy.$onDidChange(t,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const b=g.map(n=>({uri:n,rank:(0,k.count)(n.path,"/")})),p=(0,y.groupBy)(b,(n,s)=>n.rank-s.rank||(0,k.compare)(n.uri.path,s.uri.path)),D=[];e:for(const n of p){let s;for(const a of n){const l=(0,O.dirname)(a.uri.path);if(s!==l&&(s=l,D.push(a.uri)>=ki._maxEventSize))break e}}this._proxy.$onDidChange(t,D)});return new w.Disposable(()=>{o?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(E,f,t){if(!this._provider.has(E))return Object.create(null);const o=Object.create(null),{provider:c,extensionId:g}=this._provider.get(E);return await Promise.all(f.map(async b=>{try{const{uri:p,id:D}=b,n=await Promise.resolve(c.provideFileDecoration(i.URI.revive(p),t));if(!n)return;try{w.FileDecoration.validate(n),o[D]=[n.propagate,n.tooltip,n.badge,n.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${g.value}': ${s}`)}}catch(p){this._logService.error(p)}})),o}};S._handlePool=0,S._maxEventSize=250,S=We([$e(0,I.IExtHostRpcService),$e(1,A.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[200],Ie([1,0,132,86,2,5,6,8,4,11,28,37]),function(te,e,i,C,w,M,I,A,y,k,O,S){"use strict";var m,E,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(g,b,p,D,n,s,a){this._name=g,this._owner=b,this._maxDiagnosticsPerFile=p,this._modelVersionIdProvider=D,m.set(this,void 0),E.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new O.ResourceMap(l=>n.getComparisonKey(l)),"f"),Je(this,m,s,"f"),Je(this,E,a,"f")}dispose(){this._isDisposed||(Ae(this,E,"f").fire([...Ae(this,f,"f").keys()]),Ae(this,m,"f")?.$clear(this._owner),Ae(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,b){if(!g){this.clear();return}this._checkDisposed();let p=[];if(w.URI.isUri(g)){if(!b){this.delete(g);return}Ae(this,f,"f").set(g,b.slice()),p=[g]}else if(Array.isArray(g)){p=[];let n;g=[...g].sort(t._compareIndexedTuplesByUri);for(const s of g){const[a,l]=s;if((!n||a.toString()!==n.toString())&&(n&&Ae(this,f,"f").get(n).length===0&&Ae(this,f,"f").delete(n),n=a,p.push(a),Ae(this,f,"f").set(a,[])),l)Ae(this,f,"f").get(a)?.push(...l);else{const u=Ae(this,f,"f").get(a);u&&(u.length=0)}}}if(Ae(this,E,"f").fire(p),!Ae(this,m,"f"))return;const D=[];for(const n of p){let s=[];const a=Ae(this,f,"f").get(n);if(a)if(a.length>this._maxDiagnosticsPerFile){s=[];const l=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const d of a)if(d.severity===l[u]&&s.push({...A.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(n)})===this._maxDiagnosticsPerFile)break e;s.push({severity:C.MarkerSeverity.Info,message:(0,i.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(l=>({...A.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(n)}));D.push([n,s])}Ae(this,m,"f").$changeMany(this._owner,D)}delete(g){this._checkDisposed(),Ae(this,E,"f").fire([g]),Ae(this,f,"f").delete(g),Ae(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Ae(this,E,"f").fire([...Ae(this,f,"f").keys()]),Ae(this,f,"f").clear(),Ae(this,m,"f")?.$clear(this._owner)}forEach(g,b){this._checkDisposed();for(const[p,D]of this)g.call(b,p,D,this)}*[(m=new WeakMap,E=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Ae(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const b=Ae(this,f,"f").get(g);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Ae(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,b){return g[0].toString()<b[0].toString()?-1:g[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=t;let o=class fi{static _mapper(g){const b=new O.ResourceMap;for(const p of g)b.set(p,p);return{uris:Object.freeze(Array.from(b.values()))}}constructor(g,b,p,D){this._logService=b,this._fileSystemInfoService=p,this._extHostDocumentsAndEditors=D,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,b){const{_collections:p,_proxy:D,_onDidChangeDiagnostics:n,_logService:s,_fileSystemInfoService:a,_extHostDocumentsAndEditors:l}=this,u=new class{$changeMany(h,v){D.$changeMany(h,v),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,h,v.length===0?"CLEARING":v)}$clear(h){D.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,h)}dispose(){D.dispose()}};let d;if(!b)b="_generated_diagnostic_collection_name_#"+fi._idPool++,d=b;else if(!p.has(b))d=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do d=b+fi._idPool++;while(p.has(d))}return new class extends t{constructor(){super(b,d,fi._maxDiagnosticsPerFile,h=>l.getDocument(h)?.version,a.extUri,u,n),p.set(d,this)}dispose(){super.dispose(),p.delete(d)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const b=new Map,p=[];for(const D of this._collections.values())D.forEach((n,s)=>{let a=b.get(n.toString());typeof a>"u"&&(a=p.length,b.set(n.toString(),a),p.push([n,[]])),p[a][1]=p[a][1].concat(...s)});return p}}_getDiagnostics(g){let b=[];for(const p of this._collections.values())p.has(g)&&(b=b.concat(p.get(g)));return b}$acceptMarkersChange(g){if(!this._mirrorCollection){const b="_generated_mirror",p=new t(b,b,fi._maxDiagnosticsPerFile,D=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,p),this._mirrorCollection=p}for(const[b,p]of g)this._mirrorCollection.set(w.URI.revive(b),p.map(A.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=We([$e(1,k.ILogService),$e(2,S.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[201],Ie([1,0,2,5]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(I){this._proxy=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(A=>A?A.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(A=>A?i.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(De[202],Ie([1,0,12,2,6,5,13,20,10]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(S,m,E){this._documentsAndEditors=m,this._logService=E,this._documentContentProviders=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(I.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const E=k._handlePool++;this._documentContentProviders.set(E,m),this._proxy.$registerTextContentProvider(E,S);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(t=>{if(t.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(t)&&this.$provideTextDocumentContent(E,t).then(o=>{if(!o&&typeof o!="string")return;const c=this._documentsAndEditors.getDocument(t);if(!c)return;const g=(0,y.splitLines)(o);if(!c.equalLines(g))return this._proxy.$onVirtualDocumentChange(t,o)},i.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,m){const E=this._documentContentProviders.get(S);return E?Promise.resolve(E.provideTextDocumentContent(C.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(De[203],Ie([1,0,4,7,2,5,94,8,9,23,6]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(E,f){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const o of t)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const o of t)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const f=this._documentsAndEditors.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this._documentsAndEditors.getDocument(E);if(f)return Promise.resolve(f);let t=this._documentLoader.get(E.toString());return t||(t=this._proxy.$tryOpenDocument(E).then(o=>{this._documentLoader.delete(E.toString());const c=w.URI.revive(o);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(c))},o=>(this._documentLoader.delete(E.toString()),Promise.reject(o))),this._documentLoader.set(E.toString(),t)),t}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(f=>w.URI.revive(f))}$acceptModelLanguageChanged(E,f){const t=w.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(f),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(E){const f=w.URI.revive(E),t=this._documentsAndEditors.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(E,f){const t=w.URI.revive(E),o=this._documentsAndEditors.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,t){const o=w.URI.revive(E),c=this._documentsAndEditors.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let g;f.isUndoing?g=O.TextDocumentChangeReason.Undo:f.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:c.document,contentChanges:f.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:g}))}setWordDefinitionFor(E,f){(0,I.setWordDefinitionFor)(E,f)}}e.ExtHostDocuments=S}),define(De[53],Ie([1,0,47,4,7,2,3,5,94,14,97,8,11,28,13,173,204]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class c{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(p,D){this._extHostRpc=p,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const D=[],n=[],s=[];if(p.removedDocuments)for(const a of p.removedDocuments){const l=M.URI.revive(a),u=this._documents.get(l);u?.unref()&&(this._documents.delete(l),D.push(u.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const l=M.URI.revive(a.uri);let u=this._documents.get(l);if(u&&l.scheme!==f.Schemas.vscodeNotebookCell&&l.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);u||(u=new c(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),l,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(l,u),n.push(u.value)),u.ref()}if(p.removedEditors)for(const a of p.removedEditors){const l=this._editors.get(a);this._editors.delete(a),l&&s.push(l)}if(p.addedEditors)for(const a of p.addedEditors){const l=M.URI.revive(a.documentUri);i.ok(this._documents.has(l),`document '${l}' does not exist`),i.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const u=this._documents.get(l).value,d=new O.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>u.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(r=>S.Range.to(r)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,d)}p.newActiveEditor!==void 0&&(i.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,w.dispose)(D),(0,w.dispose)(s),p.removedDocuments&&this._onDidRemoveDocuments.fire(D),p.addedDocuments&&this._onDidAddDocuments.fire(n),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return t.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return p?D:D?.value}allEditors(){return[...this._editors.values()]}};g=We([$e(0,k.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[54],Ie([1,0,8,5,2,4,3,6,14,9,78]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class S{constructor(o,c,g){this._activeTabIdGetter=g,this._parentGroup=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,c={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(c)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(w.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(w.URI.revive(this._dto.input.base),w.URI.revive(this._dto.input.input1),w.URI.revive(this._dto.input.input2),w.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(w.URI.revive(this._dto.input.uri),w.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(o,c){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=c;for(const g of o.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new S(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,c={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(g=>g.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(c)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const g=new S(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,g),o.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(o.kind===1){const g=this._tabs.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,g),g}const c=this._tabs.find(g=>g.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this._activeTabId}}let E=class{constructor(o){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,c={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=o._activeGroupId;return(0,k.assertIsDefined)(o._extHostTabGroups.find(p=>p.groupId===g)?.apiObject)},close:async(g,b)=>{const p=Array.isArray(g)?g:[g];return p.length?f(p[0])?this._closeGroups(p,b):this._closeTabs(p,b):!0}};this._apiObject=Object.freeze(c)}return this._apiObject}$acceptEditorTabModel(o){const c=new Set(this._extHostTabGroups.map(a=>a.groupId)),g=new Set(o.map(a=>a.groupId)),b=(0,O.diffSets)(c,g),p=this._extHostTabGroups.filter(a=>b.removed.includes(a.groupId)).map(a=>a.apiObject),D=[],n=[];this._extHostTabGroups=o.map(a=>{const l=new m(a,()=>this._activeGroupId);return b.added.includes(l.groupId)?D.push(l.apiObject):n.push(l.apiObject),l});const s=(0,k.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:D,closed:p,changed:n}))}$acceptTabGroupUpdate(o){const c=this._extHostTabGroups.find(g=>g.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this._extHostTabGroups.find(b=>b.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const g=c.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(o){for(const c of this._extHostTabGroups)for(const g of c.tabs)if(g.apiObject===o)return g}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(c=>c.apiObject===o)}async _closeTabs(o,c){const g=[];for(const b of o){const p=this._findExtHostTabFromApi(b);if(!p)throw new Error("Tab close: Invalid tab not found!");g.push(p.tabId)}return this._proxy.$closeTab(g,c)}async _closeGroups(o,c){const g=[];for(const b of o){const p=this._findExtHostTabGroupFromApi(b);if(!p)throw new Error("Group close: Invalid group not found!");g.push(p.groupId)}return this._proxy.$closeGroup(g,c)}};E=We([$e(0,y.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function f(t){return t.tabs!==void 0}}),define(De[205],Ie([1,0,2,5,7,6,8,250,10,24,27]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const t=this._schemes.indexOf(f);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),t=[];let o,c,g=14,b=14;for(const p of f){let D=o?(0,y.commonPrefixLength)(o,p):0;for(D===0?c=1:c=b;D<p.length;D++)D+1===p.length?(g=b,b=9):b+=1,t.push([c,p.toUpperCase().charCodeAt(D),b]),t.push([c,p.toLowerCase().charCodeAt(D),b]),c=b;o=p,b=g}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new A.StateMachine(t)}}provideDocumentLinks(f){this._initStateMachine();const t=[],o=A.LinkComputer.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const c of o){const g=I.DocumentLink.to(c);g.target&&t.push(g)}return t}}class m{constructor(f,t){this._extHostLanguageFeatures=t,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,t,o,c={}){if(this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(g,o);let b=2;c.isCaseSensitive&&(b+=1024),c.isReadonly&&(b+=2048),typeof o.copy=="function"&&(b+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(g,t,b).catch(D=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(D)});const p=o.onDidChangeFile(D=>{const n=[];for(const s of D){const{uri:a,type:l}=s;if(a.scheme!==t)continue;let u;switch(l){case M.FileChangeType.Changed:u=0;break;case M.FileChangeType.Created:u=1;break;case M.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:a,type:u})}this._proxy.$onFileSystemChange(g,n)});return(0,w.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:t,ctime:o,mtime:c,size:g,permissions:b}=f;return{type:t,ctime:o,mtime:c,size:g,permissions:b}}$stat(f,t){return Promise.resolve(this._getFsProvider(f).stat(i.URI.revive(t))).then(o=>m._asIStat(o))}$readdir(f,t){return Promise.resolve(this._getFsProvider(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this._getFsProvider(f).readFile(i.URI.revive(t))).then(o=>k.VSBuffer.wrap(o))}$writeFile(f,t,o,c){return Promise.resolve(this._getFsProvider(f).writeFile(i.URI.revive(t),o.buffer,c))}$delete(f,t,o){return Promise.resolve(this._getFsProvider(f).delete(i.URI.revive(t),o))}$rename(f,t,o,c){return Promise.resolve(this._getFsProvider(f).rename(i.URI.revive(t),i.URI.revive(o),c))}$copy(f,t,o,c){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(i.URI.revive(t),i.URI.revive(o),c))}$mkdir(f,t){return Promise.resolve(this._getFsProvider(f).createDirectory(i.URI.revive(t)))}$watch(f,t,o,c){const g=this._getFsProvider(f).watch(i.URI.revive(o),c);this._watches.set(t,g)}$unwatch(f,t){const o=this._watches.get(t);o&&(o.dispose(),this._watches.delete(t))}$open(f,t,o){const c=this._getFsProvider(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(i.URI.revive(t),o))}$close(f,t){const o=this._getFsProvider(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(t))}$read(f,t,o,c){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(c);return Promise.resolve(g.read(t,o,b.buffer,0,c)).then(p=>b.slice(0,p))}$write(f,t,o,c){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,o,c.buffer,0,c.byteLength))}_getFsProvider(f){const t=this._fsProvider.get(f);if(!t){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return t}}e.ExtHostFileSystem=m}),define(De[55],Ie([1,0,5,36,6,24,3,14,37,7]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(m,E){this._fileSystemProvider=new Map,this._proxy=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const o=f._fileSystemProvider.get(t.scheme);if(!o)return await f._proxy.$stat(t);await f._proxy.$ensureActivation(t.scheme);const c=await o.stat(t);return{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions}}catch(o){Yt._handleError(o)}},async readDirectory(t){try{const o=f._fileSystemProvider.get(t.scheme);return o?(await f._proxy.$ensureActivation(t.scheme),(await o.readDirectory(t)).slice()):await f._proxy.$readdir(t)}catch(o){return Yt._handleError(o)}},async createDirectory(t){try{return await f._proxy.$mkdir(t)}catch(o){return Yt._handleError(o)}},async readFile(t){try{const o=f._fileSystemProvider.get(t.scheme);return o?(await f._proxy.$ensureActivation(t.scheme),(await o.readFile(t)).slice()):(await f._proxy.$readFile(t)).buffer}catch(o){return Yt._handleError(o)}},async writeFile(t,o){try{return await f._proxy.$writeFile(t,M.VSBuffer.wrap(o))}catch(c){return Yt._handleError(c)}},async delete(t,o){try{const c=f._fileSystemProvider.get(t.scheme);return c?(await f._proxy.$ensureActivation(t.scheme),await c.delete(t,{recursive:!1,...o})):await f._proxy.$delete(t,{recursive:!1,useTrash:!1,...o})}catch(c){return Yt._handleError(c)}},async rename(t,o,c){try{return await f._proxy.$rename(t,o,{overwrite:!1,...c})}catch(g){return Yt._handleError(g)}},async copy(t,o,c){try{return await f._proxy.$copy(t,o,{overwrite:!1,...c})}catch(g){return Yt._handleError(g)}},isWritableFileSystem(t){const o=E.getCapabilities(t);if(typeof o=="number")return!(o&2048)}})}static _handleError(m){if(m instanceof w.FileSystemError)throw m;if(!(m instanceof Error))throw new w.FileSystemError(String(m));if(m.name==="ENOPRO")throw w.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(m.message);default:throw new w.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,E){return this._fileSystemProvider.set(m,E),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=We([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(De[206],Ie([1,0,4,35,2,5,8,6]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(S,m,E,f,t,o,c,g){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const b=this.ensureWatching(S,E,t);this._config=0,o&&(this._config+=1),c&&(this._config+=2),g&&(this._config+=4);const p=(0,C.parse)(t),D=typeof t=="string",n=f(s=>{if(!o)for(const a of s.created){const l=w.URI.revive(a);p(l.fsPath)&&(!D||m.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!c)for(const a of s.changed){const l=w.URI.revive(a);p(l.fsPath)&&(!D||m.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!g)for(const a of s.deleted){const l=w.URI.revive(a);p(l.fsPath)&&(!D||m.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}});this._disposable=A.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(S,m,E){const f=A.Disposable.from();if(typeof E=="string")return f;const t=S.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(E.pattern.includes(C.GLOBSTAR)||E.pattern.includes(C.GLOB_SPLIT))&&(o=!0);const c=Math.random();return t.$watch(m.identifier.value,c,E.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>t.$unwatch(c)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(S,m,E){this._mainContext=S,this._logService=m,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,m,E,f,t,o){return new y(this._mainContext,S,m,this._onFileSystemEvent.event,I.GlobPattern.from(E),f,t,o)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,m){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(E=>({oldUri:w.URI.revive(E.source),newUri:w.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(E=>w.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(E=>w.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,m){return(E,f,t)=>{const o=function(g){E.call(f,g)};return o.extension=S,m.event(o,void 0,t)}}async $onWillRunFileOperation(S,m,E,f){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(t=>({oldUri:w.URI.revive(t.source),newUri:w.URI.revive(t.target)}))},E,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(t=>w.URI.revive(t.target))},E,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(t=>w.URI.revive(t.target))},E,f)}}async _fireWillEvent(S,m,E,f){const t=new Set,o=[];if(await S.fireAsync(m,f,async(g,b)=>{const p=Date.now(),D=await Promise.resolve(g);D instanceof A.WorkspaceEdit&&(o.push([b.extension,D]),t.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-p>E&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const c={edits:[]};for(const[,g]of o){const{edits:b}=I.WorkspaceEdit.from(g,{getTextDocumentVersion:p=>this._extHostDocumentsAndEditors.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(b)}return{edit:c,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(De[207],Ie([1,0,2,38]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(I,A,y,k,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=k;const S=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(S)}$willAddInteractiveDocument(I,A,y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=w}),define(De[208],Ie([1,0,7,5]),function(te,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(I){this._handlePool=0,this._proxy=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,I),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(De[209],Ie([1,0,2,23,8,6,71,5,10,52,16,9,251,20,7,83,79,64,210,12,15,27]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentSymbols(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentSymbols($,N);if(!(0,O.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(w.DocumentSymbol.from):n._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(_){_=_.slice(0).sort((q,Z)=>{let ce=q.location.range.start.compareTo(Z.location.range.start);return ce===0&&(ce=Z.location.range.end.compareTo(q.location.range.end)),ce});const N=[],$=[];for(const q of _){const Z={name:q.name||"!!MISSING: name!!",kind:w.SymbolKind.from(q.kind),tags:q.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:w.Range.from(q.location.range),selectionRange:w.Range.from(q.location.range),children:[]};for(;;){if($.length===0){$.push(Z),N.push(Z);break}const ce=$[$.length-1];if(k.Range.containsRange(ce.range,Z.range)&&!k.Range.equalsRange(ce.range,Z.range)){ce.children?.push(Z),$.push(Z);break}$.pop()}}return N}}class s{constructor(_,N,$){this._documents=_,this._commands=N,this._provider=$,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideCodeLenses($,N);if(!q||N.isCancellationRequested)return;const Z=this._cache.add(q),ce=new f.DisposableStore;this._disposables.set(Z,ce);const we={cacheId:Z,lenses:[]};for(let oe=0;oe<q.length;oe++)we.lenses.push({cacheId:[Z,oe],range:w.Range.from(q[oe].range),command:this._commands.toInternal(q[oe].command,ce)});return we}async resolveCodeLens(_,N){const $=_.cacheId&&this._cache.get(..._.cacheId);if(!$)return;let q;if(typeof this._provider.resolveCodeLens!="function"||$.isResolved?q=$:q=await this._provider.resolveCodeLens($,N),q||(q=$),N.isCancellationRequested)return;const Z=_.cacheId&&this._disposables.get(_.cacheId[0]);if(!!Z)return _.command=this._commands.toInternal(q.command??s._badCmd,Z),_}releaseCodeLenses(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(J){return Array.isArray(J)?J.map(w.DefinitionLink.from):J?[w.DefinitionLink.from(J)]:[]}class l{constructor(_,N){this._documents=_,this._provider=N}async provideDefinition(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideDefinition(q,Z,$);return a(ce)}}class u{constructor(_,N){this._documents=_,this._provider=N}async provideDeclaration(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideDeclaration(q,Z,$);return a(ce)}}class d{constructor(_,N){this._documents=_,this._provider=N}async provideImplementation(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideImplementation(q,Z,$);return a(ce)}}class r{constructor(_,N){this._documents=_,this._provider=N}async provideTypeDefinition(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideTypeDefinition(q,Z,$);return a(ce)}}class h{constructor(_,N){this._documents=_,this._provider=N}async provideHover(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideHover(q,Z,$);if(!(!ce||(0,O.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(Z)),ce.range||(ce.range=new M.Range(Z,Z)),w.Hover.from(ce)}}class v{constructor(_,N){this._documents=_,this._provider=N}async provideEvaluatableExpression(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideEvaluatableExpression(q,Z,$);if(ce)return w.EvaluatableExpression.from(ce)}}class P{constructor(_,N){this._documents=_,this._provider=N}async provideInlineValues(_,N,$,q){const Z=this._documents.getDocument(_),ce=await this._provider.provideInlineValues(Z,w.Range.to(N),w.InlineValueContext.to($),q);if(Array.isArray(ce))return ce.map(we=>w.InlineValue.from(we))}}class L{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentHighlights(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideDocumentHighlights(q,Z,$);if(Array.isArray(ce))return ce.map(w.DocumentHighlight.from)}}class j{constructor(_,N){this._documents=_,this._provider=N}async provideLinkedEditingRanges(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.provideLinkedEditingRanges(q,Z,$);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,O.coalesce)(ce.ranges.map(w.Range.from)),wordPattern:ce.wordPattern}}}class V{constructor(_,N){this._documents=_,this._provider=N}async provideReferences(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Position.to(N),we=await this._provider.provideReferences(Z,ce,$,q);if(Array.isArray(we))return we.map(w.location.from)}}class W{constructor(_,N,$,q,Z,ce,we){this._documents=_,this._commands=N,this._diagnostics=$,this._provider=q,this._logService=Z,this._extension=ce,this._apiDeprecation=we,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(_,N,$,q){const Z=this._documents.getDocument(_),ce=m.Selection.isISelection(N)?w.Selection.to(N):w.Range.to(N),we=[];for(const et of this._diagnostics.getDiagnostics(_))if(ce.intersection(et.range)&&we.push(et)>W._maxCodeActionsPerFile)break;const oe={diagnostics:we,only:$.only?new M.CodeActionKind($.only):void 0,triggerKind:w.CodeActionTriggerKind.to($.trigger)},be=await this._provider.provideCodeActions(Z,ce,oe,q);if(!(0,O.isNonEmptyArray)(be)||q.isCancellationRequested)return;const ve=this._cache.add(be),Ue=new f.DisposableStore;this._disposables.set(ve,Ue);const ze=[];for(let et=0;et<be.length;et++){const Ge=be[et];!Ge||(W._isCommand(Ge)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Ge.title,command:this._commands.toInternal(Ge,Ue)})):(oe.only&&(Ge.kind?oe.only.contains(Ge.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[ve,et],title:Ge.title,command:Ge.command&&this._commands.toInternal(Ge.command,Ue),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(w.Diagnostic.from),edit:Ge.edit&&w.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:ve,actions:ze}}async resolveCodeAction(_,N){const[$,q]=_,Z=this._cache.get($,q);if(!Z||W._isCommand(Z)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(Z,N)??Z;return ce?.edit?w.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}static _isCommand(_){return typeof _.command=="string"&&typeof _.title=="string"}}W._maxCodeActionsPerFile=1e3;class T{constructor(_,N,$,q){this._proxy=_,this._documents=N,this._provider=$,this._handle=q}async prepareDocumentPaste(_,N,$,q){if(!this._provider.prepareDocumentPaste)return;const Z=this._documents.getDocument(_),ce=N.map(oe=>w.Range.to(oe)),we=w.DataTransfer.toDataTransfer($,()=>{throw new b.NotImplementedError});return await this._provider.prepareDocumentPaste(Z,ce,we,q),w.DataTransfer.toDataTransferDTO(we)}async providePasteEdits(_,N,$,q,Z){const ce=this._documents.getDocument(N),we=$.map(ve=>w.Range.to(ve)),oe=w.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolvePasteFileData(this._handle,_,ve)).buffer),be=await this._provider.provideDocumentPasteEdits(ce,we,oe,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?w.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class F{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentFormattingEdits(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideDocumentFormattingEdits(q,N,$);if(Array.isArray(Z))return Z.map(w.TextEdit.from)}}class R{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentRangeFormattingEdits(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Range.to(N),we=await this._provider.provideDocumentRangeFormattingEdits(Z,ce,$,q);if(Array.isArray(we))return we.map(w.TextEdit.from)}}class x{constructor(_,N){this._documents=_,this._provider=N,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(_,N,$,q,Z){const ce=this._documents.getDocument(_),we=w.Position.to(N),oe=await this._provider.provideOnTypeFormattingEdits(ce,we,$,q,Z);if(Array.isArray(oe))return oe.map(w.TextEdit.from)}}class B{constructor(_,N){this._provider=_,this._logService=N,this._cache=new c.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(_,N){const $=await this._provider.provideWorkspaceSymbols(_,N);if(!(0,O.isNonEmptyArray)($))return{symbols:[]};const q=this._cache.add($),Z={cacheId:q,symbols:[]};for(let ce=0;ce<$.length;ce++){const we=$[ce];if(!we||!we.name){this._logService.warn("INVALID SymbolInformation",we);continue}Z.symbols.push({...w.WorkspaceSymbol.from(we),cacheId:[q,ce]})}return Z}async resolveWorkspaceSymbol(_,N){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!_.cacheId)return _;const $=this._cache.get(..._.cacheId);if($){const q=await this._provider.resolveWorkspaceSymbol($,N);return q&&(0,C.mixin)(_,w.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(_){this._cache.delete(_)}}class H{static supportsResolving(_){return typeof _.prepareRename=="function"}constructor(_,N,$){this._documents=_,this._provider=N,this._logService=$}async provideRenameEdits(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Position.to(N);try{const we=await this._provider.provideRenameEdits(Z,ce,$,q);return we?w.WorkspaceEdit.from(we):void 0}catch(we){const oe=H._asMessage(we);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(_,N,$){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(_),Z=w.Position.to(N);try{const ce=await this._provider.prepareRename(q,Z,$);let we,oe;if(M.Range.isRange(ce)?(we=ce,oe=q.getText(ce)):(0,S.isObject)(ce)&&(we=ce.range,oe=ce.placeholder),!we||!oe)return;if(we.start.line>Z.line||we.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(we),text:oe}}catch(ce){const we=H._asMessage(ce);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(_){return typeof _=="string"?_:_ instanceof Error&&typeof _.message=="string"?_.message:void 0}}class G{constructor(_,N){this.resultId=_,this.tokens=N}}class ee{constructor(_,N){this._documents=_,this._provider=N,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(_,N,$){const q=this._documents.getDocument(_),Z=N!==0?this._previousResults.get(N):null;let ce=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,Z.resultId,$):await this._provider.provideDocumentSemanticTokens(q,$);return Z&&this._previousResults.delete(N),ce?(ce=ee._fixProvidedSemanticTokens(ce),this._send(ee._convertToEdits(Z,ce),ce)):null}async releaseDocumentSemanticColoring(_){this._previousResults.delete(_)}static _fixProvidedSemanticTokens(_){return ee._isSemanticTokens(_)?ee._isCorrectSemanticTokens(_)?_:new M.SemanticTokens(new Uint32Array(_.data),_.resultId):ee._isSemanticTokensEdits(_)?ee._isCorrectSemanticTokensEdits(_)?_:new M.SemanticTokensEdits(_.edits.map(N=>new M.SemanticTokensEdit(N.start,N.deleteCount,N.data?new Uint32Array(N.data):N.data)),_.resultId):_}static _isSemanticTokens(_){return _&&!!_.data}static _isCorrectSemanticTokens(_){return _.data instanceof Uint32Array}static _isSemanticTokensEdits(_){return _&&Array.isArray(_.edits)}static _isCorrectSemanticTokensEdits(_){for(const N of _.edits)if(!(N.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(_,N){if(!ee._isSemanticTokens(N)||!_||!_.tokens)return N;const $=_.tokens,q=$.length,Z=N.data,ce=Z.length;let we=0;const oe=Math.min(q,ce);for(;we<oe&&$[we]===Z[we];)we++;if(we===q&&we===ce)return new M.SemanticTokensEdits([],N.resultId);let be=0;const ve=oe-we;for(;be<ve&&$[q-be-1]===Z[ce-be-1];)be++;return new M.SemanticTokensEdits([{start:we,deleteCount:q-we-be,data:Z.subarray(we,ce-be)}],N.resultId)}_send(_,N){if(ee._isSemanticTokens(_)){const $=this._nextResultId++;return this._previousResults.set($,new G(_.resultId,_.data)),(0,t.encodeSemanticTokensDto)({id:$,type:"full",data:_.data})}if(ee._isSemanticTokensEdits(_)){const $=this._nextResultId++;return ee._isSemanticTokens(N)?this._previousResults.set($,new G(N.resultId,N.data)):this._previousResults.set($,new G(_.resultId)),(0,t.encodeSemanticTokensDto)({id:$,type:"delta",deltas:(_.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class de{constructor(_,N){this._documents=_,this._provider=N}async provideDocumentRangeSemanticTokens(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideDocumentRangeSemanticTokens(q,w.Range.to(N),$);return Z?this._send(Z):null}_send(_){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:_.data})}}class ne{static supportsResolving(_){return typeof _.resolveCompletionItem=="function"}constructor(_,N,$,q,Z){this._documents=_,this._commands=N,this._provider=$,this._apiDeprecation=q,this._extension=Z,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Position.to(N),we=Z.getWordRangeAtPosition(ce)||new M.Range(ce,ce),oe=we.with({end:ce}),be=new g.StopWatch(!0),ve=await this._provider.provideCompletionItems(Z,ce,q,w.CompletionContext.to($));if(!ve||q.isCancellationRequested)return;const Ue=Array.isArray(ve)?new M.CompletionList(ve):ve,ze=ne.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),et=new f.DisposableStore;this._disposables.set(ze,et);const Ge=[],tt={x:ze,b:Ge,a:{replace:w.Range.from(we),insert:w.Range.from(oe)},c:Ue.isIncomplete||void 0,d:be.elapsed()};for(let Fe=0;Fe<Ue.items.length;Fe++){const ht=Ue.items[Fe],X=this._convertCompletionItem(ht,[ze,Fe],oe,we);Ge.push(X)}return tt}async resolveCompletionItem(_,N){if(typeof this._provider.resolveCompletionItem!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveCompletionItem($,N);if(!!q)return this._convertCompletionItem(q,_)}releaseCompletionItems(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_convertCompletionItem(_,N,$,q){const Z=this._disposables.get(N[0]);if(!Z)throw Error("DisposableStore is missing...");const ce=this._commands.toInternal(_.command,Z),we={x:N,a:_.label,b:_.kind!==void 0?w.CompletionItemKind.from(_.kind):void 0,m:_.tags&&_.tags.map(w.CompletionItemTag.from),c:_.detail,d:typeof _.documentation>"u"?void 0:w.MarkdownString.fromStrict(_.documentation),e:_.sortText!==_.label?_.sortText:void 0,f:_.filterText!==_.label?_.filterText:void 0,g:_.preselect||void 0,i:_.keepWhitespace?1:0,k:_.commitCharacters?.join(""),l:_.additionalTextEdits&&_.additionalTextEdits.map(w.TextEdit.from),n:ce?.$ident,o:ce?.id,p:ce?.$ident?void 0:ce?.arguments};_.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=_.textEdit.newText):typeof _.insertText=="string"?we.h=_.insertText:_.insertText instanceof M.SnippetString&&(we.h=_.insertText.value,we.i|=4);let oe;return _.textEdit?oe=_.textEdit.range:_.range&&(oe=_.range),M.Range.isRange(oe)?we.j=w.Range.from(oe):oe&&(!$?.isEqual(oe.inserting)||!q?.isEqual(oe.replacing))&&(we.j={insert:w.Range.from(oe.inserting),replace:w.Range.from(oe.replacing)}),we}}class me{async provideInlineCompletions(_,N,$,q){}disposeCompletions(_){}handleDidShowCompletionItem(_,N){}}class le extends me{constructor(_,N,$,q){super(),this._extension=_,this._documents=N,this._provider=$,this._commands=q,this._references=new ue,this._isAdditionsProposedApiEnabled=(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Position.to(N),we=await this._provider.provideInlineCompletionItems(Z,ce,{selectedCompletionInfo:$.selectedSuggestionInfo?{range:w.Range.to($.selectedSuggestionInfo.range),text:$.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[$.triggerKind]},q);if(!we||q.isCancellationRequested)return;const oe=Array.isArray(we)?we:we.items,be=this._isAdditionsProposedApiEnabled?Array.isArray(we)?[]:we.commands||[]:[];let ve;return{pid:this._references.createReferenceId({dispose(){ve?.dispose()},items:oe}),items:oe.map((ze,et)=>{let Ge;ze.command&&(ve||(ve=new f.DisposableStore),Ge=this._commands.toInternal(ze.command,ve));const tt=ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:ze.filterText,range:ze.range?w.Range.from(ze.range):void 0,command:Ge,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?ze.completeBracketPairs:!1}}),commands:be.map(ze=>(ve||(ve=new f.DisposableStore),this._commands.toInternal(ze,ve)))}}disposeCompletions(_){this._references.disposeReferenceId(_)?.dispose()}handleDidShowCompletionItem(_,N){const $=this._references.get(_)?.items[N];$&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem($)}}class ue{constructor(){this._references=new Map,this._idPool=1}createReferenceId(_){const N=this._idPool++;return this._references.set(N,_),N}disposeReferenceId(_){const N=this._references.get(_);return this._references.delete(_),N}get(_){return this._references.get(_)}}class Q{constructor(_,N){this._documents=_,this._provider=N,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(_,N,$,q){const Z=this._documents.getDocument(_),ce=w.Position.to(N),we=this.reviveContext($),oe=await this._provider.provideSignatureHelp(Z,ce,q,we);if(oe){const be=this._cache.add([oe]);return{...w.SignatureHelp.from(oe),id:be}}}reviveContext(_){let N;if(_.activeSignatureHelp){const $=w.SignatureHelp.to(_.activeSignatureHelp),q=this._cache.get(_.activeSignatureHelp.id,0);q?(N=q,N.activeSignature=$.activeSignature,N.activeParameter=$.activeParameter):N=$}return{..._,activeSignatureHelp:N}}releaseSignatureHelp(_){this._cache.delete(_)}}class ge{constructor(_,N,$,q,Z){this._documents=_,this._commands=N,this._provider=$,this._logService=q,this._extension=Z,this._cache=new c.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(_,N,$){const q=this._documents.getDocument(_),Z=w.Range.to(N),ce=await this._provider.provideInlayHints(q,Z,$);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${N}`);return}if($.isCancellationRequested)return;const we=this._cache.add(ce);this._disposables.set(we,new f.DisposableStore);const oe={hints:[],cacheId:we};for(let be=0;be<ce.length;be++)this._isValidInlayHint(ce[be],Z)&&oe.hints.push(this._convertInlayHint(ce[be],[we,be]));return this._logService.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${N}`),oe}async resolveInlayHint(_,N){if(typeof this._provider.resolveInlayHint!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveInlayHint($,N);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,_)}releaseHints(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_isValidInlayHint(_,N){return _.label.length===0||Array.isArray(_.label)&&_.label.every($=>$.value.length===0)?(console.log("INVALID inlay hint, empty label",_),!1):!(N&&!N.contains(_.position))}_convertInlayHint(_,N){const $=this._disposables.get(N[0]);if(!$)throw Error("DisposableStore is missing...");const q={label:"",cacheId:N,tooltip:w.MarkdownString.fromStrict(_.tooltip),position:w.Position.from(_.position),textEdits:_.textEdits&&_.textEdits.map(w.TextEdit.from),kind:_.kind&&w.InlayHintKind.from(_.kind),paddingLeft:_.paddingLeft,paddingRight:_.paddingRight};return typeof _.label=="string"?q.label=_.label:q.label=_.label.map(Z=>{const ce={label:Z.value};return ce.tooltip=w.MarkdownString.fromStrict(Z.tooltip),M.Location.isLocation(Z.location)&&(ce.location=w.location.from(Z.location)),Z.command&&(ce.command=this._commands.toInternal(Z.command,$)),ce}),q}}class Se{constructor(_,N){this._documents=_,this._provider=N,this._cache=new c.Cache("DocumentLink")}async provideLinks(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentLinks($,N);if(!(!Array.isArray(q)||q.length===0)&&!N.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Se._validateLink).map(w.DocumentLink.from)};{const Z=this._cache.add(q),ce={links:[],cacheId:Z};for(let we=0;we<q.length;we++){if(!Se._validateLink(q[we]))continue;const oe=w.DocumentLink.from(q[we]);oe.cacheId=[Z,we],ce.links.push(oe)}return ce}}}static _validateLink(_){return _.target&&_.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(_,N){if(typeof this._provider.resolveDocumentLink!="function")return;const $=this._cache.get(..._);if(!$)return;const q=await this._provider.resolveDocumentLink($,N);if(!(!q||!Se._validateLink(q)))return w.DocumentLink.from(q)}releaseLinks(_){this._cache.delete(_)}}class Oe{constructor(_,N){this._documents=_,this._provider=N}async provideColors(_,N){const $=this._documents.getDocument(_),q=await this._provider.provideDocumentColors($,N);return Array.isArray(q)?q.map(ce=>({color:w.Color.from(ce.color),range:w.Range.from(ce.range)})):[]}async provideColorPresentations(_,N,$){const q=this._documents.getDocument(_),Z=w.Range.to(N.range),ce=w.Color.to(N.color),we=await this._provider.provideColorPresentations(ce,{document:q,range:Z},$);if(!!Array.isArray(we))return we.map(w.ColorPresentation.from)}}class xe{constructor(_,N){this._documents=_,this._provider=N}async provideFoldingRanges(_,N,$){const q=this._documents.getDocument(_),Z=await this._provider.provideFoldingRanges(q,N,$);if(!!Array.isArray(Z))return Z.map(w.FoldingRange.from)}}class Qe{constructor(_,N,$){this._documents=_,this._provider=N,this._logService=$}async provideSelectionRanges(_,N,$){const q=this._documents.getDocument(_),Z=N.map(w.Position.to),ce=await this._provider.provideSelectionRanges(q,Z,$);if(!(0,O.isNonEmptyArray)(ce))return[];if(ce.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let oe=0;oe<Z.length;oe++){const be=[];we.push(be);let ve=Z[oe],Ue=ce[oe];for(;;){if(!Ue.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(be.push(w.SelectionRange.from(Ue)),!Ue.parent)break;ve=Ue.range,Ue=Ue.parent}}return we}}class Ce{constructor(_,N){this._documents=_,this._provider=N,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.prepareCallHierarchy(q,Z,$);if(!ce)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(we,oe)):[this._cacheAndConvertItem(we,ce)]}async provideCallsTo(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(q,$);if(!!Z)return Z.map(ce=>({from:this._cacheAndConvertItem(_,ce.from),fromRanges:ce.fromRanges.map(we=>w.Range.from(we))}))}async provideCallsFrom(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(q,$);if(!!Z)return Z.map(ce=>({to:this._cacheAndConvertItem(_,ce.to),fromRanges:ce.fromRanges.map(we=>w.Range.from(we))}))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,N){const $=this._cache.get(_),q=w.CallHierarchyItem.from(N,_,$.size.toString(36));return $.set(q._itemId,N),q}_itemFromCache(_,N){return this._cache.get(_)?.get(N)}}class ye{constructor(_,N){this._documents=_,this._provider=N,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(_,N,$){const q=this._documents.getDocument(_),Z=w.Position.to(N),ce=await this._provider.prepareTypeHierarchy(q,Z,$);if(!ce)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(we,oe)):[this._cacheAndConvertItem(we,ce)]}async provideSupertypes(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(q,$);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(_,ce))}async provideSubtypes(_,N,$){const q=this._itemFromCache(_,N);if(!q)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(q,$);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(_,ce))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,N){const $=this._cache.get(_),q=w.TypeHierarchyItem.from(N,_,$.size.toString(36));return $.set(q._itemId,N),q}_itemFromCache(_,N){return this._cache.get(_)?.get(N)}}class Te{constructor(_,N,$,q){this._proxy=_,this._documents=N,this._provider=$,this._handle=q}async provideDocumentOnDropEdits(_,N,$,q,Z){const ce=this._documents.getDocument(N),we=w.Position.to($),oe=w.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,_,ve)).buffer),be=await this._provider.provideDocumentDropEdits(ce,we,oe,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?w.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(_,N){this.adapter=_,this.extension=N}}class ae{constructor(_,N,$,q,Z,ce,we,oe){this._uriTransformer=N,this._documents=$,this._commands=q,this._diagnostics=Z,this._logService=ce,this._apiDeprecation=we,this._extensionTelemetry=oe,this._adapter=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(_){return w.DocumentSelector.from(_,this._uriTransformer)}_createDisposable(_){return new M.Disposable(()=>{this._adapter.delete(_),this._proxy.$unregister(_)})}_nextHandle(){return ae._handlePool++}async _withAdapter(_,N,$,q,Z,ce=!1){const we=this._adapter.get(_);if(!we||!(we.adapter instanceof N))return q;const oe=Date.now();ce||this._logService.trace(`[${we.extension.identifier.value}] INVOKE provider '${$.toString().replace(/[\r\n]/g,"")}'`);const be=$(we.adapter,we.extension);return Promise.resolve(be).catch(ve=>{(0,b.isCancellationError)(ve)||(this._logService.error(`[${we.extension.identifier.value}] provider FAILED`),this._logService.error(ve),this._extensionTelemetry.onExtensionError(we.extension.identifier,ve))}).finally(()=>{ce||this._logService.trace(`[${we.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),E.CancellationToken.isCancellationToken(Z)?(0,p.raceCancellationError)(be,Z):be}_addNewAdapter(_,N){const $=this._nextHandle();return this._adapter.set($,new se(_,N)),$}static _extLabel(_){return _.displayName||_.name}registerDocumentSymbolProvider(_,N,$,q){const Z=this._addNewAdapter(new n(this._documents,$),_),ce=q&&q.label||ae._extLabel(_);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(N),ce),this._createDisposable(Z)}$provideDocumentSymbols(_,N,$){return this._withAdapter(_,n,q=>q.provideDocumentSymbols(i.URI.revive(N),$),void 0,$)}registerCodeLensProvider(_,N,$){const q=this._nextHandle(),Z=typeof $.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new s(this._documents,this._commands.converter,$),_)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(N),Z);let ce=this._createDisposable(q);if(Z!==void 0){const we=$.onDidChangeCodeLenses(oe=>this._proxy.$emitCodeLensEvent(Z));ce=M.Disposable.from(ce,we)}return ce}$provideCodeLenses(_,N,$){return this._withAdapter(_,s,q=>q.provideCodeLenses(i.URI.revive(N),$),void 0,$)}$resolveCodeLens(_,N,$){return this._withAdapter(_,s,q=>q.resolveCodeLens(N,$),void 0,void 0)}$releaseCodeLenses(_,N){this._withAdapter(_,s,$=>Promise.resolve($.releaseCodeLenses(N)),void 0,void 0)}registerDefinitionProvider(_,N,$){const q=this._addNewAdapter(new l(this._documents,$),_);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDefinition(_,N,$,q){return this._withAdapter(_,l,Z=>Z.provideDefinition(i.URI.revive(N),$,q),[],q)}registerDeclarationProvider(_,N,$){const q=this._addNewAdapter(new u(this._documents,$),_);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDeclaration(_,N,$,q){return this._withAdapter(_,u,Z=>Z.provideDeclaration(i.URI.revive(N),$,q),[],q)}registerImplementationProvider(_,N,$){const q=this._addNewAdapter(new d(this._documents,$),_);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideImplementation(_,N,$,q){return this._withAdapter(_,d,Z=>Z.provideImplementation(i.URI.revive(N),$,q),[],q)}registerTypeDefinitionProvider(_,N,$){const q=this._addNewAdapter(new r(this._documents,$),_);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideTypeDefinition(_,N,$,q){return this._withAdapter(_,r,Z=>Z.provideTypeDefinition(i.URI.revive(N),$,q),[],q)}registerHoverProvider(_,N,$,q){const Z=this._addNewAdapter(new h(this._documents,$),_);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(N)),this._createDisposable(Z)}$provideHover(_,N,$,q){return this._withAdapter(_,h,Z=>Z.provideHover(i.URI.revive(N),$,q),void 0,q)}registerEvaluatableExpressionProvider(_,N,$,q){const Z=this._addNewAdapter(new v(this._documents,$),_);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(N)),this._createDisposable(Z)}$provideEvaluatableExpression(_,N,$,q){return this._withAdapter(_,v,Z=>Z.provideEvaluatableExpression(i.URI.revive(N),$,q),void 0,q)}registerInlineValuesProvider(_,N,$,q){const Z=typeof $.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new P(this._documents,$),_);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(N),Z);let we=this._createDisposable(ce);if(Z!==void 0){const oe=$.onDidChangeInlineValues(be=>this._proxy.$emitInlineValuesEvent(Z));we=M.Disposable.from(we,oe)}return we}$provideInlineValues(_,N,$,q,Z){return this._withAdapter(_,P,ce=>ce.provideInlineValues(i.URI.revive(N),$,q,Z),void 0,Z)}registerDocumentHighlightProvider(_,N,$){const q=this._addNewAdapter(new L(this._documents,$),_);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentHighlights(_,N,$,q){return this._withAdapter(_,L,Z=>Z.provideDocumentHighlights(i.URI.revive(N),$,q),void 0,q)}registerLinkedEditingRangeProvider(_,N,$){const q=this._addNewAdapter(new j(this._documents,$),_);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideLinkedEditingRanges(_,N,$,q){return this._withAdapter(_,j,async Z=>{const ce=await Z.provideLinkedEditingRanges(i.URI.revive(N),$,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ae._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(_,N,$){const q=this._addNewAdapter(new V(this._documents,$),_);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideReferences(_,N,$,q,Z){return this._withAdapter(_,V,ce=>ce.provideReferences(i.URI.revive(N),$,q,Z),void 0,Z)}registerCodeActionProvider(_,N,$,q){const Z=new f.DisposableStore,ce=this._addNewAdapter(new W(this._documents,this._commands.converter,this._diagnostics,$,this._logService,_,this._apiDeprecation),_);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(N),{providedKinds:q?.providedCodeActionKinds?.map(we=>we.value),documentation:q?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,Z)}))},ae._extLabel(_),Boolean($.resolveCodeAction)),Z.add(this._createDisposable(ce)),Z}$provideCodeActions(_,N,$,q,Z){return this._withAdapter(_,W,ce=>ce.provideCodeActions(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveCodeAction(_,N,$){return this._withAdapter(_,W,q=>q.resolveCodeAction(N,$),void 0,void 0)}$releaseCodeActions(_,N){this._withAdapter(_,W,$=>Promise.resolve($.releaseCodeActions(N)),void 0,void 0)}registerDocumentFormattingEditProvider(_,N,$){const q=this._addNewAdapter(new F(this._documents,$),_);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(N),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentFormattingEdits(_,N,$,q){return this._withAdapter(_,F,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(N),$,q),void 0,q)}registerDocumentRangeFormattingEditProvider(_,N,$){const q=this._addNewAdapter(new R(this._documents,$),_);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(N),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(_,N,$,q,Z){return this._withAdapter(_,R,ce=>ce.provideDocumentRangeFormattingEdits(i.URI.revive(N),$,q,Z),void 0,Z)}registerOnTypeFormattingEditProvider(_,N,$,q){const Z=this._addNewAdapter(new x(this._documents,$),_);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(N),q,_.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(_,N,$,q,Z,ce){return this._withAdapter(_,x,we=>we.provideOnTypeFormattingEdits(i.URI.revive(N),$,q,Z,ce),void 0,ce)}registerWorkspaceSymbolProvider(_,N){const $=this._addNewAdapter(new B(N,this._logService),_);return this._proxy.$registerNavigateTypeSupport($,typeof N.resolveWorkspaceSymbol=="function"),this._createDisposable($)}$provideWorkspaceSymbols(_,N,$){return this._withAdapter(_,B,q=>q.provideWorkspaceSymbols(N,$),{symbols:[]},$)}$resolveWorkspaceSymbol(_,N,$){return this._withAdapter(_,B,q=>q.resolveWorkspaceSymbol(N,$),void 0,void 0)}$releaseWorkspaceSymbols(_,N){this._withAdapter(_,B,$=>$.releaseWorkspaceSymbols(N),void 0,void 0)}registerRenameProvider(_,N,$){const q=this._addNewAdapter(new H(this._documents,$,this._logService),_);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(N),H.supportsResolving($)),this._createDisposable(q)}$provideRenameEdits(_,N,$,q,Z){return this._withAdapter(_,H,ce=>ce.provideRenameEdits(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveRenameLocation(_,N,$,q){return this._withAdapter(_,H,Z=>Z.resolveRenameLocation(i.URI.revive(N),$,q),void 0,q)}registerDocumentSemanticTokensProvider(_,N,$,q){const Z=this._addNewAdapter(new ee(this._documents,$),_),ce=typeof $.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(N),q,ce);let we=this._createDisposable(Z);if(ce){const oe=$.onDidChangeSemanticTokens(be=>this._proxy.$emitDocumentSemanticTokensEvent(ce));we=M.Disposable.from(we,oe)}return we}$provideDocumentSemanticTokens(_,N,$,q){return this._withAdapter(_,ee,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(N),$,q),null,q)}$releaseDocumentSemanticTokens(_,N){this._withAdapter(_,ee,$=>$.releaseDocumentSemanticColoring(N),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(_,N,$,q){const Z=this._addNewAdapter(new de(this._documents,$),_);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(N),q),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(_,N,$,q){return this._withAdapter(_,de,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(N),$,q),null,q)}registerCompletionItemProvider(_,N,$,q){const Z=this._addNewAdapter(new ne(this._documents,this._commands.converter,$,this._apiDeprecation,_),_);return this._proxy.$registerCompletionsProvider(Z,this._transformDocumentSelector(N),q,ne.supportsResolving($),`${_.identifier.value}(${q.join("")})`),this._createDisposable(Z)}$provideCompletionItems(_,N,$,q,Z){return this._withAdapter(_,ne,ce=>ce.provideCompletionItems(i.URI.revive(N),$,q,Z),void 0,Z)}$resolveCompletionItem(_,N,$){return this._withAdapter(_,ne,q=>q.resolveCompletionItem(N,$),void 0,$)}$releaseCompletionItems(_,N){this._withAdapter(_,ne,$=>$.releaseCompletionItems(N),void 0,void 0)}registerInlineCompletionsProvider(_,N,$){const q=new le(_,this._documents,$,this._commands.converter),Z=this._addNewAdapter(q,_);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(N),q.supportsHandleDidShowCompletionItem),this._createDisposable(Z)}$provideInlineCompletions(_,N,$,q,Z){return this._withAdapter(_,me,ce=>ce.provideInlineCompletions(i.URI.revive(N),$,q,Z),void 0,Z)}$handleInlineCompletionDidShow(_,N,$){this._withAdapter(_,me,async q=>{q.handleDidShowCompletionItem(N,$)},void 0,void 0)}$freeInlineCompletionsList(_,N){this._withAdapter(_,me,async $=>{$.disposeCompletions(N)},void 0,void 0)}registerSignatureHelpProvider(_,N,$,q){const Z=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new Q(this._documents,$),_);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(N),Z),this._createDisposable(ce)}$provideSignatureHelp(_,N,$,q,Z){return this._withAdapter(_,Q,ce=>ce.provideSignatureHelp(i.URI.revive(N),$,q,Z),void 0,Z)}$releaseSignatureHelp(_,N){this._withAdapter(_,Q,$=>$.releaseSignatureHelp(N),void 0,void 0)}registerInlayHintsProvider(_,N,$){const q=typeof $.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new ge(this._documents,this._commands.converter,$,this._logService,_),_);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(N),typeof $.resolveInlayHint=="function",q,ae._extLabel(_));let ce=this._createDisposable(Z);if(q!==void 0){const we=$.onDidChangeInlayHints(oe=>this._proxy.$emitInlayHintsEvent(q));ce=M.Disposable.from(ce,we)}return ce}$provideInlayHints(_,N,$,q){return this._withAdapter(_,ge,Z=>Z.provideInlayHints(i.URI.revive(N),$,q),void 0,q)}$resolveInlayHint(_,N,$){return this._withAdapter(_,ge,q=>q.resolveInlayHint(N,$),void 0,$)}$releaseInlayHints(_,N){this._withAdapter(_,ge,$=>$.releaseHints(N),void 0,void 0)}registerDocumentLinkProvider(_,N,$){const q=this._addNewAdapter(new Se(this._documents,$),_);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(N),typeof $.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(_,N,$){return this._withAdapter(_,Se,q=>q.provideLinks(i.URI.revive(N),$),void 0,$,N.scheme==="output")}$resolveDocumentLink(_,N,$){return this._withAdapter(_,Se,q=>q.resolveLink(N,$),void 0,void 0,!0)}$releaseDocumentLinks(_,N){this._withAdapter(_,Se,$=>$.releaseLinks(N),void 0,void 0,!0)}registerColorProvider(_,N,$){const q=this._addNewAdapter(new Oe(this._documents,$),_);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentColors(_,N,$){return this._withAdapter(_,Oe,q=>q.provideColors(i.URI.revive(N),$),[],$)}$provideColorPresentations(_,N,$,q){return this._withAdapter(_,Oe,Z=>Z.provideColorPresentations(i.URI.revive(N),$,q),void 0,q)}registerFoldingRangeProvider(_,N,$){const q=this._nextHandle(),Z=typeof $.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new xe(this._documents,$),_)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(N),_.identifier,Z);let ce=this._createDisposable(q);if(Z!==void 0){const we=$.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ce=M.Disposable.from(ce,we)}return ce}$provideFoldingRanges(_,N,$,q){return this._withAdapter(_,xe,Z=>Z.provideFoldingRanges(i.URI.revive(N),$,q),void 0,q)}registerSelectionRangeProvider(_,N,$){const q=this._addNewAdapter(new Qe(this._documents,$,this._logService),_);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideSelectionRanges(_,N,$,q){return this._withAdapter(_,Qe,Z=>Z.provideSelectionRanges(i.URI.revive(N),$,q),[],q)}registerCallHierarchyProvider(_,N,$){const q=this._addNewAdapter(new Ce(this._documents,$),_);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$prepareCallHierarchy(_,N,$,q){return this._withAdapter(_,Ce,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(N),$,q)),void 0,q)}$provideCallHierarchyIncomingCalls(_,N,$,q){return this._withAdapter(_,Ce,Z=>Z.provideCallsTo(N,$,q),void 0,q)}$provideCallHierarchyOutgoingCalls(_,N,$,q){return this._withAdapter(_,Ce,Z=>Z.provideCallsFrom(N,$,q),void 0,q)}$releaseCallHierarchy(_,N){this._withAdapter(_,Ce,$=>Promise.resolve($.releaseSession(N)),void 0,void 0)}registerTypeHierarchyProvider(_,N,$){const q=this._addNewAdapter(new ye(this._documents,$),_);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$prepareTypeHierarchy(_,N,$,q){return this._withAdapter(_,ye,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(N),$,q)),void 0,q)}$provideTypeHierarchySupertypes(_,N,$,q){return this._withAdapter(_,ye,Z=>Z.provideSupertypes(N,$,q),void 0,q)}$provideTypeHierarchySubtypes(_,N,$,q){return this._withAdapter(_,ye,Z=>Z.provideSubtypes(N,$,q),void 0,q)}$releaseTypeHierarchy(_,N){this._withAdapter(_,ye,$=>Promise.resolve($.releaseSession(N)),void 0,void 0)}registerDocumentOnDropEditProvider(_,N,$){const q=this._nextHandle();return this._adapter.set(q,new se(new Te(this._proxy,this._documents,$,q),_)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(N)),this._createDisposable(q)}$provideDocumentOnDropEdits(_,N,$,q,Z,ce){return this._withAdapter(_,Te,we=>Promise.resolve(we.provideDocumentOnDropEdits(N,i.URI.revive($),q,Z,ce)),void 0,void 0)}registerDocumentPasteEditProvider(_,N,$,q){const Z=this._nextHandle();return this._adapter.set(Z,new se(new T(this._proxy,this._documents,$,Z),_)),this._proxy.$registerPasteEditProvider(Z,this._transformDocumentSelector(N),!!$.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(Z)}$prepareDocumentPaste(_,N,$,q,Z){return this._withAdapter(_,T,ce=>ce.prepareDocumentPaste(i.URI.revive(N),$,q,Z),void 0,Z)}$providePasteEdits(_,N,$,q,Z,ce){return this._withAdapter(_,T,we=>we.providePasteEdits(N,i.URI.revive($),q,Z,ce),void 0,ce)}static _serializeRegExp(_){return{pattern:_.source,flags:(0,y.regExpFlags)(_)}}static _serializeIndentationRule(_){return{decreaseIndentPattern:ae._serializeRegExp(_.decreaseIndentPattern),increaseIndentPattern:ae._serializeRegExp(_.increaseIndentPattern),indentNextLinePattern:_.indentNextLinePattern?ae._serializeRegExp(_.indentNextLinePattern):void 0,unIndentedLinePattern:_.unIndentedLinePattern?ae._serializeRegExp(_.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(_){return{beforeText:ae._serializeRegExp(_.beforeText),afterText:_.afterText?ae._serializeRegExp(_.afterText):void 0,previousLineText:_.previousLineText?ae._serializeRegExp(_.previousLineText):void 0,action:_.action}}static _serializeOnEnterRules(_){return _.map(ae._serializeOnEnterRule)}setLanguageConfiguration(_,N,$){const{wordPattern:q}=$;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(N,q):this._documents.setWordDefinitionFor(N,void 0),$.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",_,"Do not use."),$.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",_,"Do not use.");const Z=this._nextHandle(),ce={comments:$.comments,brackets:$.brackets,wordPattern:$.wordPattern?ae._serializeRegExp($.wordPattern):void 0,indentationRules:$.indentationRules?ae._serializeIndentationRule($.indentationRules):void 0,onEnterRules:$.onEnterRules?ae._serializeOnEnterRules($.onEnterRules):void 0,__electricCharacterSupport:$.__electricCharacterSupport,__characterPairSupport:$.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,N,ce),this._createDisposable(Z)}$setWordDefinitions(_){for(const N of _)this._documents.setWordDefinitionFor(N.languageId,new RegExp(N.regexSource,N.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae._handlePool=0}),define(De[211],Ie([1,0,5,8,6,29,15,7]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,S,m,E){this._documents=S,this._commands=m,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,S){await this._proxy.$changeLanguage(O,S);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,S){const m=O.version,E=C.Position.from(S),f=await this._proxy.$tokensAtPosition(O.uri,E),t={type:w.StandardTokenType.Other,range:O.getWordRangeAtPosition(S)??new w.Range(S.line,S.character,S.line,S.character)};if(!f)return t;const o={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!o.range.contains(S)||m!==O.version?t:o}createLanguageStatusItem(O,S,m){const E=this._handlePool++,f=this._proxy,t=this._ids,o=`${O.identifier.value}/${S}`;if(t.has(o))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);t.add(o);const c={selector:m,id:S,name:O.displayName??O.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const b=new A.DisposableStore,p=()=>{g?.dispose(),g=(0,I.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(E,{id:o,name:c.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(c.selector,this._uriTransformer),label:c.text,detail:c.detail??"",severity:c.severity===w.LanguageStatusSeverity.Error?M.default.Error:c.severity===w.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:c.command&&this._commands.toInternal(c.command,b),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},D={dispose(){b.dispose(),g?.dispose(),f.$removeLanguageStatus(E),t.delete(o)},get id(){return c.id},get name(){return c.name},set name(n){c.name=n,p()},get selector(){return c.selector},set selector(n){c.selector=n,p()},get text(){return c.text},set text(n){c.text=n,p()},get detail(){return c.detail},set detail(n){c.detail=n,p()},get severity(){return c.severity},set severity(n){c.severity=n,p()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(n){c.accessibilityInformation=n,p()},get command(){return c.command},set command(n){c.command=n,p()},get busy(){return c.busy},set busy(n){c.busy=n,p()}};return p(),D}}e.ExtHostLanguages=y}),define(De[73],Ie([1,0,21,10,2,3,11,5,26,14]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,E,f){this.logService=f,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=m.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(m,E){const{message:f,args:t,comment:o}=E;if(this.isDefaultLanguage)return(0,C.format2)(f,t??{});let c=f;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join():o}`);const g=this.bundleCache.get(m)?.contents[c];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,C.format2)(g??c,t??{})}getBundle(m){return this.bundleCache.get(m)?.contents}getBundleUri(m){return this.bundleCache.get(m)?.uri}async initializeLocalizedMessages(m){if(this.isDefaultLanguage||!m.l10n&&!m.isBuiltin||this.bundleCache.has(m.identifier.value))return;let E;const f=await this.getBundleLocation(m);if(!f){this.logService.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this._proxy.$fetchBundleContents(f),o=JSON.parse(t);E=m.isBuiltin?o.contents?.bundle:o}catch(t){this.logService.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${t.message}`);return}E&&this.bundleCache.set(m.identifier.value,{contents:E,uri:f})}async getBundleLocation(m){if(m.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(m.identifier.value);return w.URI.revive(E)}return m.l10n?w.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};O=We([$e(0,y.IExtHostInitDataService),$e(1,k.IExtHostRpcService),$e(2,I.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(De[212],Ie([1,0,11,5,26,14,2,4,9]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,E){super(E.logLevel,A.Event.None),this._proxy=m.getProxy(C.MainContext.MainThreadLogger)}$setLevel(m,E){E?this.setLevel(I.URI.revive(E),m):(0,y.isUndefined)(m)||this.setLevel(m)}doCreateLogger(m,E,f){return new O(this._proxy,m,E,f)}};k=We([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends i.AbstractMessageLogger{constructor(m,E,f,t){super(t?.always),this.proxy=m,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.proxy.$createLogger(E,t).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,E){const f=[[m,E]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(m){this.proxy.$log(this.file,m)}}}),define(De[213],Ie([1,0,5,11,27]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let I=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,O,S,m){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let f;typeof S=="string"||M(S)?f=[S,...m]:(E.modal=S?.modal,E.useCustom=S?.useCustom,E.detail=S?.detail,f=m),E.useCustom&&(0,w.checkProposedApiEnabled)(y,"resolvers");const t=[];for(let o=0;o<f.length;o++){const c=f[o];if(typeof c=="string")t.push({title:c,handle:o,isCloseAffordance:!1});else if(typeof c=="object"){const{title:g,isCloseAffordance:b}=c;t.push({title:g,isCloseAffordance:!!b,handle:o})}else this._logService.warn("Invalid message item:",c)}return this._proxy.$showMessage(k,O,E,t).then(o=>{if(typeof o=="number")return f[o]})}};I=We([$e(1,C.ILogService)],I),e.ExtHostMessageService=I}),define(De[214],Ie([1,0,24,4,7,28,10,9,2,64,5,38,8,6,43,186,95]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class c{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}constructor(b,p,D,n){this._textDocumentsAndEditors=D,this._textDocuments=n,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=b.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const a=s.notebookEditor?.notebookUri,l=s.cell.handle,d=this._documents.get(a)?.getCell(l);if(d)return d.apiCell}if(s&&s.$mid===13){const a=s.uri,l=this._documents.get(a);if(l)return l.apiNotebook}return s}}),c._registerApiCommands(p)}getEditorById(b){const p=this._editors.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(b){for(const[p,D]of this._editors)if(D.apiEditor===b)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,p){const D=this._documents.get(b);if(!D&&!p)throw new Error(`NO notebook document for '${b}'`);return D}static _convertNotebookRegistrationData(b,p){if(!p)return;const D=p.filenamePattern.map(n=>m.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(p.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:D,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,D){const n=c._notebookStatusBarItemProviderHandlePool++,s=typeof D.onDidChangeCellStatusBarItems=="function"?c._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,s,p);let a;return s!==void 0&&(a=D.onDidChangeCellStatusBarItems(l=>this._notebookProxy.$emitCellStatusBarEvent(s))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,s),a?.dispose()})}async createNotebookDocument(b){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return y.URI.revive(p)}async openNotebookDocument(b){const p=this._documents.get(b);if(p)return p.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(b),n=this._documents.get(y.URI.revive(D));return(0,A.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(b,p){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let D;typeof p=="object"?D={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,D),s=n&&this._editors.get(n)?.apiEditor;if(s)return s;throw n?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,D,n){const s=this._notebookStatusBarItemProviders.get(b),a=y.URI.revive(p),l=this._documents.get(a);if(!l||!s)return;const u=l.getCellFromIndex(D);if(!u)return;const d=await s.provideCellStatusBarItems(u.apiCell,n);if(!d)return;const r=new w.DisposableStore,h=this._statusBarCache.add([r]),P=(Array.isArray(d)?d:[d]).map(L=>m.NotebookStatusBarItem.from(L,this._commandsConverter,r));return{cacheId:h,items:P}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,p,D,n,s){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,D),this._notebookProxy.$registerNotebookSerializer(a,{id:b.identifier,location:b.extensionLocation},p,m.NotebookDocumentContentOptions.from(n),c._convertNotebookRegistrationData(b,s)),(0,w.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(b,p,D){const n=this._notebookSerializer.get(b);if(!n)throw new Error("NO serializer found");const s=await n.deserializeNotebook(p.buffer,D);return new f.SerializableObjectWithBuffers(m.NotebookData.from(s))}async $notebookToData(b,p,D){const n=this._notebookSerializer.get(b);if(!n)throw new Error("NO serializer found");const s=await n.serializeNotebook(m.NotebookData.to(p.value),D);return i.VSBuffer.wrap(s)}_createExtHostEditor(b,p,D){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const n=new o.ExtHostNotebookEditor(p,this._notebookEditorsProxy,b,D.visibleRanges.map(m.NotebookRange.to),D.selections.map(m.NotebookRange.to),typeof D.viewColumn=="number"?m.ViewColumn.to(D.viewColumn):void 0);this._editors.set(p,n)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const D of b.value.removedDocuments){const n=y.URI.revive(D),s=this._documents.get(n);s&&(s.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===n.toString()&&this._editors.delete(a.id)}if(b.value.addedDocuments){const D=[];for(const n of b.value.addedDocuments){const s=y.URI.revive(n.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,s,n);D.push(...n.cells.map(l=>t.ExtHostCell.asModelAddData(a.apiNotebook,l))),this._documents.get(s)?.dispose(),this._documents.set(s,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(b.value.addedEditors)for(const D of b.value.addedEditors){if(this._editors.has(D.id))return;const n=y.URI.revive(D.documentUri),s=this._documents.get(n);s&&this._createExtHostEditor(s,D.id,D)}const p=[];if(b.value.removedEditors)for(const D of b.value.removedEditors){const n=this._editors.get(D);n&&(this._editors.delete(D),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),p.push(n))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const D=new Set;this._visibleNotebookEditors.forEach(n=>D.add(n.id));for(const n of this._editors.values()){const s=D.has(n.id);n._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(b){const p=S.ApiCommandArgument.String.with("notebookType","A notebook type"),D=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new S.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>i.VSBuffer.wrap(s))],new S.ApiCommandResult("Notebook Data",s=>m.NotebookData.to(s.value))),n=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new f.SerializableObjectWithBuffers(m.NotebookData.from(s)))],new S.ApiCommandResult("Bytes",s=>s.buffer));b.registerApiCommand(D),b.registerApiCommand(n)}}e.ExtHostNotebookController=c,c._notebookStatusBarItemProviderHandlePool=0}),define(De[215],Ie([1,0,16,15,20,4,7,28,2,25,11,5,38,8,6,66,174,27,43]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(l,u,d,r,h){this._initData=u,this._extHostNotebook=d,this._commands=r,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=l.getProxy(S.MainContext.MainThreadNotebookKernels);const v=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const L=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:L}}else if(P&&"notebookEditor"in P){const L=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return P})],m.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(l,u,d,r,h,v){for(const ne of this._kernelData.values())if(ne.controller.id===u&&k.ExtensionIdentifier.equals(l.identifier,ne.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const P=this._handlePool++,L=this;this._logService.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${u}`);const j=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${l.identifier}'`);let V=!1;const W=new I.DisposableStore,T=new M.Emitter,F=new M.Emitter,R={id:s(l.identifier,u),notebookType:d,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:r||l.identifier.value,preloads:v?v.map(E.NotebookRendererScript.from):[]};let x=h??j,B;this._proxy.$addKernel(P,R).catch(ne=>{console.log(ne),V=!0});let H=0;const G=()=>{if(V)return;const ne=++H;Promise.resolve().then(()=>{ne===H&&this._proxy.$updateKernel(P,R)})},ee=new A.ResourceMap,de={get id(){return u},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return R.label},set label(ne){R.label=ne??l.displayName??l.name,G()},get detail(){return R.detail??""},set detail(ne){R.detail=ne,G()},get description(){return R.description??""},set description(ne){R.description=ne,G()},get kind(){return(0,c.checkProposedApiEnabled)(l,"notebookControllerKind"),R.kind??""},set kind(ne){(0,c.checkProposedApiEnabled)(l,"notebookControllerKind"),R.kind=ne,G()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(ne){R.supportedLanguages=ne,G()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){R.supportsExecutionOrder=ne,G()},get rendererScripts(){return R.preloads?R.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(ne){x=ne??j},get interruptHandler(){return B},set interruptHandler(ne){B=ne,R.supportsInterrupt=Boolean(ne),G()},createNotebookCellExecution(ne){if(V)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw L._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return L._createNotebookCellExecution(ne,s(l.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${P}], DISPOSED`),V=!0,this._kernelData.delete(P),W.dispose(),T.dispose(),F.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(ne,me){me===f.NotebookControllerAffinity2.Hidden&&(0,c.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(P,ne.uri,me)},onDidReceiveMessage:F.event,postMessage(ne,me){return(0,c.checkProposedApiEnabled)(l,"notebookMessaging"),L._proxy.$postMessage(P,me&&L._extHostNotebook.getIdByEditor(me),ne)},asWebviewUri(ne){return(0,c.checkProposedApiEnabled)(l,"notebookMessaging"),(0,t.asWebviewUri)(ne,L._initData.remote)}};return this._kernelData.set(P,{extensionId:l.identifier,controller:de,onDidReceiveMessage:F,onDidChangeSelection:T,associatedNotebooks:ee}),de}getIdByController(l){for(const[u,d]of this._kernelData)if(d.controller===l)return s(d.extensionId,l.id);return null}$acceptNotebookAssociation(l,u,d){const r=this._kernelData.get(l);if(r){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));d?r.associatedNotebooks.set(h.uri,!0):r.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,h.uri.toString(),d),r.onDidChangeSelection.fire({selected:d,notebook:h.apiNotebook})}}async $executeCells(l,u,d){const r=this._kernelData.get(l);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)),v=[];for(const P of d){const L=h.getCell(P);L&&v.push(L.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,h.uri.toString(),v.length),await r.controller.executeHandler.call(r.controller,v,h.apiNotebook,r.controller)}catch(P){this._logService.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,u,d){const r=this._kernelData.get(l);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,h.apiNotebook);else for(const v of d){const P=h.getCell(v);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,u,d){const r=this._kernelData.get(l);if(!r)return;const h=this._extHostNotebook.getEditorById(u);r.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:d}))}$cellExecutionChanged(l,u,d){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)).getCell(u);if(h){const v=d?E.NotebookCellExecutionState.to(d):f.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:v})}}_createNotebookCellExecution(l,u){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const h=new D(u,r,this._proxy);this._activeExecutions.set(r.uri,h);const v=h.onDidChangeState(()=>{h.state===p.Resolved&&(h.dispose(),v.dispose(),this._activeExecutions.delete(r.uri))});return h.asApiObject()}};b=We([$e(4,O.ILogService)],b),e.ExtHostNotebookKernels=b;var p;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(p||(p={}));class D extends I.Disposable{get state(){return this._state}constructor(l,u,d){super(),this._cell=u,this._proxy=d,this._handle=D.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new n(10,r=>this.update(r)),this._executionOrder=u.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,l,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const u=Array.isArray(l)?l:[l];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(u))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let u=this._cell;if(l&&(u=this._cell.notebook.getCellFromApiCell(l)),!u)throw new Error("INVALID cell");return u.handle}validateAndConvertOutputs(l){return l.map(u=>{const d=f.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return d===u.items?E.NotebookCellOutput.from(u):E.NotebookCellOutput.from({items:d,id:u.id,metadata:u.metadata})})}async updateOutputs(l,u,d){const r=this.cellIndexToHandle(u),h=this.validateAndConvertOutputs((0,i.asArray)(l));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:r,append:d,outputs:h})}async updateOutputItems(l,u,d){return l=f.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(l),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(E.NotebookCellOutputItem.from),outputId:u.id,append:d})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(d){l._executionOrder=d,l.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l._executionOrder}])},start(d){if(l._state===p.Resolved||l._state===p.Started)throw new Error("Cannot call start again");l._state=p.Started,l._onDidChangeState.fire(),l.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,r){if(l._state===p.Resolved)throw new Error("Cannot call resolve twice");l._state=p.Resolved,l._onDidChangeState.fire(),l._collector.flush(),l._proxy.$completeExecution(l._handle,new g.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:d}))},clearOutput(d){return l.verifyStateForOutput(),l.updateOutputs([],d,!1)},appendOutput(d,r){return l.verifyStateForOutput(),l.updateOutputs(d,r,!0)},replaceOutput(d,r){return l.verifyStateForOutput(),l.updateOutputs(d,r,!1)},appendOutputItems(d,r){return l.verifyStateForOutput(),l.updateOutputItems(d,r,!0)},replaceOutputItems(d,r){return l.verifyStateForOutput(),l.updateOutputItems(d,r,!1)}})}}D.HANDLE=0;class n{constructor(l,u){this.delay=l,this.callback=u,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const u=this.batch;return this.batch=[],this.callback(u).finally(()=>l.complete())}}function s(a,l){return`${a.value}/${l}`}e.createKernelId=s}),define(De[216],Ie([1,0,4,5,95]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,k){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,S,m)=>this.getOrCreateEmitterFor(y).event(O,S,m),postMessage:(O,S)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,S]=[S,O]);const m=S&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(m?.id,y,O)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=M}),define(De[217],Ie([1,0,20,4,7,5,2,6,12,16,29,63]),function(te,e,i,C,w,M,I,A,y,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(E,f,t){const o=E.getProxy(M.MainContext.MainThreadQuickOpen);class c{constructor(u,d){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=d}showQuickPick(u,d,r=i.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(u),v=++this._instances,P=o.$show(v,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},r),L={},j=P.then(()=>L);return Promise.race([j,h]).then(V=>{if(V!==L)return h.then(W=>{const T=[];for(let F=0;F<W.length;F++){const R=W[F];typeof R=="string"?T.push({label:R,handle:F}):R.kind===A.QuickPickItemKind.Separator?T.push({type:"separator",label:R.label}):T.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:F})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=F=>{d.onDidSelectItem(W[F])}),o.$setItems(v,T),P.then(F=>{if(typeof F=="number")return W[F];if(Array.isArray(F))return F.map(R=>W[R])})})}).then(void 0,V=>{if(!(0,y.isCancellationError)(V))return o.$setError(v,V),Promise.reject(V)})}$onItemSelected(u){this._onDidSelectItem?.(u)}showInput(u,d=i.CancellationToken.None){return this._validateInput=u?.validateInput,o.$input(u,typeof this._validateInput=="function",d).then(void 0,r=>{if(!(0,y.isCancellationError)(r))return Promise.reject(r)})}async $validateInput(u){if(!this._validateInput)return;const d=await this._validateInput(u);if(!d||typeof d=="string")return d;let r;switch(d.severity){case A.InputBoxValidationSeverity.Info:r=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:r=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:r=O.default.Error;break;default:r=d.message?O.default.Error:O.default.Ignore;break}return{content:d.message,severity:r}}async showWorkspaceFolderPick(u,d=i.CancellationToken.None){const r=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!r)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(v=>v.uri.toString()===r.uri.toString())}createQuickPick(u){const d=new s(u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(u){const d=new a(u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(u,d){this._sessions.get(u)?._fireDidChangeValue(d)}$onDidAccept(u){this._sessions.get(u)?._fireDidAccept()}$onDidChangeActive(u,d){const r=this._sessions.get(u);r instanceof s&&r._fireDidChangeActive(d)}$onDidChangeSelection(u,d){const r=this._sessions.get(u);r instanceof s&&r._fireDidChangeSelection(d)}$onDidTriggerButton(u,d){this._sessions.get(u)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(u,d,r){const h=this._sessions.get(u);h instanceof s&&h._fireDidTriggerItemButton(d,r)}$onDidHide(u){this._sessions.get(u)?._fireDidHide()}}class g{constructor(u,d){this._extensionId=u,this._onDidDispose=d,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((d,r)=>{const h=d===A.QuickInputButtons.Back?-1:r;this._handlesToButtons.set(h,d)}),this.update({buttons:u.map((d,r)=>({...n(d),tooltip:d.tooltip,handle:d===A.QuickInputButtons.Back?-1:r}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const d=this._handlesToButtons.get(u);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,w.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),o.$dispose(this._id))}update(u){if(!this._disposed){for(const d of Object.keys(u)){const r=u[d];this._pendingUpdate[d]=r===void 0?null:r}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){o.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function b(l){if(l instanceof A.ThemeIcon)return{id:l.id};const u=D(l),d=p(l);return{dark:typeof u=="string"?I.URI.file(u):u,light:typeof d=="string"?I.URI.file(d):d}}function p(l){return typeof l=="object"&&"light"in l?l.light:l}function D(l){return typeof l=="object"&&"dark"in l?l.dark:l}function n(l){const u=b(l.iconPath);let d,r;return"id"in u?r=S.ThemeIcon.asClassName(u):d=u,{iconPath:d,iconClass:r}}class s extends g{constructor(u,d){super(u.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((r,h)=>{this._handlesToItems.set(h,r),this._itemsToHandles.set(r,h)});const d=[];for(let r=0;r<u.length;r++){const h=u[r];h.kind===A.QuickPickItemKind.Separator?d.push({type:"separator",label:h.label}):d.push({handle:r,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((v,P)=>({...n(v),tooltip:v.tooltip,handle:P}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(u){const d=(0,k.coalesce)(u.map(r=>this._handlesToItems.get(r)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(u){const d=(0,k.coalesce)(u.map(r=>this._handlesToItems.get(r)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(u,d){const r=this._handlesToItems.get(u);if(!r||!r.buttons||!r.buttons.length)return;const h=r.buttons[d];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:r})}}class a extends g{constructor(u,d){super(u.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get valueSelection(){return this._valueSelection}set valueSelection(u){this._valueSelection=u,this.update({valueSelection:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,u?typeof u=="string"?this.update({validationMessage:u,severity:O.default.Error}):this.update({validationMessage:u.message,severity:u.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new c(f,t)}e.createExtHostQuickOpen=m});var Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i};define(De[218],Ie([1,0,2,4,58,7,15,5,16,120,11,25,63,8,27]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function g(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,L=typeof v.iconPath=="string"?v.iconPath:i.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,k.comparePaths)(P,L)}function b(h,v){let P=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(P=g(h,v),P!==0)return P;if(h.light&&v.light)P=g(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(P!==0)return P;if(h.dark&&v.dark)P=g(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return P}function p(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const L=h.arguments[P],j=v.arguments[P];if(L!==j)return L<j?-1:1}return 0}function D(h,v){let P=(0,k.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&v.command)P=p(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(P!==0)return P;if(h.decorations&&v.decorations)P=b(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return P}function n(h,v){for(let P=0;P<h.length;P++)if(h[P]!==v[P])return!1;return!0}function s(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?n(h.arguments,v.arguments):h.arguments===v.arguments)}function a(h,v){return(0,y.equals)(h,v,s)}class l{get value(){return this._value}set value(v){v=v??"",Ae(this,t,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ae(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ae(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Ae(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ae(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,P,L){this._extension=v,this._sourceControlHandle=L,t.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,t,P,"f")}showValidationMessage(v,P){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Ae(this,t,"f").$showValidationMessage(this._sourceControlHandle,v,P)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=l,t=new WeakMap;class u{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,P,L,j,V){this._proxy=v,this._commands=P,this._sourceControlHandle=L,this._id=j,this._label=V,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,P){const L=this._resourceStatesCommandsMap.get(v);return L?(0,I.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(D),L=(0,y.sortedDiff)(this._resourceSnapshot,v,D).map(W=>{const T=W.toInsert.map(F=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,F);const x=F.resourceUri;let B;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const ge=new M.DisposableStore;B=this._commands.converter.toInternal(F.command,ge),this._resourceStatesDisposablesMap.set(R,ge)}else this._resourceStatesCommandsMap.set(R,F.command);const H=c(F.decorations),G=F.decorations&&c(F.decorations.light)||H,ee=F.decorations&&c(F.decorations.dark)||H,de=[G,ee],ne=F.decorations&&F.decorations.tooltip||"",me=F.decorations&&!!F.decorations.strikeThrough,le=F.decorations&&!!F.decorations.faded,ue=F.contextValue||"";return{rawResource:[R,x,de,ne,me,le,ue,B],handle:R}});return{start:W.start,deleteCount:W.deleteCount,toInsert:T}}),j=L.map(({start:W,deleteCount:T,toInsert:F})=>[W,T,F.map(R=>R.rawResource)]),V=L.reverse();for(const{start:W,deleteCount:T,toInsert:F}of V){const R=F.map(B=>B.handle),x=this._handlesSnapshot.splice(W,T,...R);for(const B of x)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=v,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ae(this,o,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ae(this,o,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ae(this,o,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const P=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ae(this,o,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const P=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(L=>L.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Ae(this,o,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&a(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const P=(v||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Ae(this,o,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}constructor(v,P,L,j,V,W){this._extension=v,this._commands=L,this._id=j,this._label=V,this._rootUri=W,o.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,o,P,"f"),this._inputBox=new l(v,Ae(this,o,"f"),this.handle),Ae(this,o,"f").$registerSourceControl(this.handle,j,V,W)}createResourceGroup(v,P){const L=new u(Ae(this,o,"f"),this._commands,this.handle,v,P),j=C.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,j),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const v=[],P=[];for(const[L,j]of this.createdResourceGroups){j.dispose();const V=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});C.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),V.dispose(),this._groups.delete(L.handle),Ae(this,o,"f").$unregisterGroup(this.handle,L.handle)}),v.push([L.handle,L.id,L.label,L.features]);const W=L._takeResourceStateSnapshot();W.length>0&&P.push([L.handle,W]),this._groups.set(L.handle,L)}Ae(this,o,"f").$registerGroups(this.handle,v,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(P=>{const L=P._takeResourceStateSnapshot();L.length!==0&&v.push([P.handle,L])}),v.length>0&&Ae(this,o,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ae(this,o,"f").$unregisterSourceControl(this.handle)}}o=new WeakMap,d._handlePool=0,We([(0,w.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),We([(0,w.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let r=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,P,L){this._commands=P,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const V=this._sourceControls.get(j.sourceControlHandle);if(!V)return j;const W=V.getResourceGroup(j.groupHandle);return W?W.getResourceState(j.handle):j}else if(j&&j.$mid===4){const V=this._sourceControls.get(j.sourceControlHandle);return V?V.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const V=this._sourceControls.get(j.handle);return V||j}return j}})}createSourceControl(v,P,L,j){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,P,L,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const V=Ji._handlePool++,W=new d(v,this._proxy,this._commands,P,L,j);this._sourceControls.set(V,W);const T=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(v.identifier))||[];return T.push(W),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(v.identifier),T),W}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const P=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(v.identifier)),L=P&&P[P.length-1];return L&&L.inputBox}$provideOriginalResource(v,P,L){const j=i.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,j.toString());const V=this._sourceControls.get(v);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>V.quickDiffProvider.provideOriginalResource(j,L)).then(W=>W||null)}$onInputBoxValueChange(v,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const L=this._sourceControls.get(v);return L&&L.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(v,P,L,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,P,L);const V=this._sourceControls.get(v);if(!V)return Promise.resolve(void 0);const W=V.getResourceGroup(P);return W?W.$executeResourceCommand(L,j):Promise.resolve(void 0)}$validateInput(v,P,L){this.logService.trace("ExtHostSCM#$validateInput",v);const j=this._sourceControls.get(v);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>j.inputBox.validateInput(P,L)).then(V=>{if(!V)return Promise.resolve(void 0);const W=E.MarkdownString.fromStrict(V.message);return W?Promise.resolve([W,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};r._handlePool=0,r=We([$e(2,O.ILogService)],r),e.ExtHostSCM=r}),define(De[74],Ie([1,0,5,4,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,k){return this._proxy.$setPassword(A,y,k)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[219],Ie([1,0,6,5,135,7,8,9]),function(te,e,i,C,w,M,I,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,t,o,c,g=i.StatusBarAlignment.Left,b){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,y,f,"f"),Je(this,k,t,"f"),this._entryId=O.ID_GEN++,this._extension=o,this._id=c,this._alignment=g,this._priority=this.validatePriority(b)}validatePriority(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ae(this,k,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ae(this,k,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let t;this._name?t=this._name:t=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const c=I.MarkdownString.fromStrict(this._tooltip);Ae(this,y,"f").$setEntry(this._entryId,f,t,this._text,c,this._command?.internal,o,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,k=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const t={message:f};return this._messages.unshift(t),this._update(),new i.Disposable(()=>{const o=this._messages.indexOf(t);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,t){this._proxy=f.getProxy(C.MainContext.MainThreadStatusBar),this._commands=t,this._statusMessage=new S(this)}createStatusBarEntry(f,t,o,c){return new O(this._proxy,this._commands,f,t,o,c)}setStatusBarMessage(f,t){const o=this._statusMessage.setMessage(f);let c;return typeof t=="number"?c=setTimeout(()=>o.dispose(),t):typeof t<"u"&&t.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(c)})}}e.ExtHostStatusBar=m}),define(De[75],Ie([1,0,5,4,3]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,k){return this._proxy.$initializeExtensionStorage(A,y).then(O=>O||k)}setValue(A,y,k){return this._proxy.$setValue(A,y,k)}$acceptValue(A,y,k){this._onDidChangeStorage.fire({shared:A,key:y,value:k})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(De[76],Ie([1,0,3,26,11,55,2]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,O,S){this._logService=O,this._extHostFileSystem=S,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(k){return I.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,O=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(k){if(this._value)return I.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return I.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=We([$e(0,C.IExtHostInitDataService),$e(1,w.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(De[56],Ie([1,0,4,5,3,2,14,7,6,136,12,175,20,34,160,63,9,15,8]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class b{constructor(r,h,v,P){this._proxy=r,this._id=h,this._creationOptions=v,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(j,V=!0){L._checkDisposed(),L._proxy.$sendText(L._id,j,V)},show(j){L._checkDisposed(),L._proxy.$show(L._id,j)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(r,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,o.withNullAsUndefined)(r.shellPath),shellArgs:(0,o.withNullAsUndefined)(r.shellArgs),cwd:(0,o.withNullAsUndefined)(r.cwd),env:(0,o.withNullAsUndefined)(r.env),icon:(0,o.withNullAsUndefined)(l(r.iconPath)),color:t.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,o.withNullAsUndefined)(r.message),strictEnv:(0,o.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(r.location,h?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,h,v,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(r,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,h){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in r?{viewColumn:g.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitStatus(r,h){this._exitStatus=Object.freeze({code:r,reason:h})}setDimensions(r,h){return r===this._cols&&h===this._rows||r===0||h===0?!1:(this._cols=r,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=b;class p{get onProcessReady(){return this._onProcessReady.event}constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput?.(r)}resize(r,h){this._pty.setDimensions?.({columns:r,rows:h})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(r||void 0),r&&this._pty.setDimensions?.(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let D=1,n=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(r,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[v,P]of this._terminalProcesses)P.shutdown(!0)}})}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,h){const v=new b(this._proxy,(0,E.generateUuid)(),r,r.name),P=new p(r.pty);return v.createExtensionTerminal(r.location,this._serializeParentTerminal(r,h).resolvedExtHostIdentifier,l(r.iconPath),u(r.color)).then(L=>{const j=this._setupExtHostProcessListeners(L,P);this._terminalProcessDisposables[L]=j}),this._terminals.push(v),v.value}_serializeParentTerminal(r,h){if(h=h||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const P=this._terminals.find(L=>L.value===v);P&&(h.resolvedExtHostIdentifier=P._id)}}else r.location&&typeof r.location!="object"?h.location=r.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(r,h){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const P=new p(h),L=this._setupExtHostProcessListeners(r,P);this._terminalProcessDisposables[r]=L}async $acceptActiveTerminalChanged(r){const h=this._activeTerminal;if(r===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(r);v&&(this._activeTerminal=v,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,h){const v=this._getTerminalById(r);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(r,h,v){const P=this._getTerminalById(r);P&&P.setDimensions(h,v)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(r,h,v){this._terminalProcesses.get(r)?.resize(h,v)}async $acceptTerminalTitleChange(r,h){const v=this._getTerminalById(r);v&&(v.name=h)}async $acceptTerminalClosed(r,h,v){const P=this._getTerminalObjectIndexById(this._terminals,r);if(P!==null){const L=this._terminals.splice(P,1)[0];L.setExitStatus(h,v),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(r,h,v,P){if(h){const V=this._getTerminalObjectIndexById(this._terminals,h);if(V!==null){this._terminals[V]._id=r,this._onDidOpenTerminal.fire(this.terminals[V]),this._terminals[V].isOpen=!0;return}}const L={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new b(this._proxy,r,L,v);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(r,h){this._getTerminalById(r)?._setProcessId(h)}async $startExtensionTerminal(r,h){const v=this._getTerminalById(r);if(!v)return{message:(0,k.localize)(0,null,r)};v.isOpen||await new Promise(L=>{const j=this.onDidOpenTerminal(async V=>{V===v.value&&(j.dispose(),L())})});const P=this._terminalProcesses.get(r);P?P.startSendingEvents(h):this._extensionTerminalAwaitingStart[r]={initialDimensions:h}}_setupExtHostProcessListeners(r,h){const v=new A.DisposableStore;v.add(h.onProcessReady(L=>this._proxy.$sendProcessReady(r,L.pid,L.cwd))),v.add(h.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(r,L))),this._bufferer.startBuffering(r,h.onProcessData),v.add(h.onProcessExit(L=>this._onProcessExit(r,L))),this._terminalProcesses.set(r,h);const P=this._extensionTerminalAwaitingStart[r];return P&&h instanceof p&&(h.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),v}$acceptProcessAckDataEvent(r,h){this._terminalProcesses.get(r)?.acknowledgeDataEvent(h)}$acceptProcessInput(r,h){this._terminalProcesses.get(r)?.input(h)}$acceptTerminalInteraction(r){const h=this._getTerminalById(r);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(r,h,v){try{this._terminalProcesses.get(r)?.resize(h,v)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(r,h){this._terminalProcesses.get(r)?.shutdown(h)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(r,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(h=>this._proxy.$sendProcessProperty(r,{type:"cwd",value:h}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,h,v){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,v),this._proxy.$registerProfileProvider(h,r.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(r,h){const v=new m.CancellationTokenSource().token;let P=await this._profileProviders.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(r,h){const v=this._getTerminalById(r);if(!v)return[];this._terminalLinkCache.delete(r),this._terminalLinkCancellationSource.get(r)?.dispose(!0);const L=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,L);const j=[],V={terminal:v.value,line:h},W=[];for(const R of this._linkProviders)W.push(c.Promises.withAsyncBody(async x=>{L.token.onCancellationRequested(()=>x({provider:R,links:[]}));const B=await R.provideTerminalLinks(V,L.token)||[];L.token.isCancellationRequested||x({provider:R,links:B})}));const T=await Promise.all(W);if(L.token.isCancellationRequested)return[];const F=new Map;for(const R of T)R&&R.links.length>0&&j.push(...R.links.map(x=>{const B={id:D++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return F.set(B.id,{provider:R.provider,link:x}),B}));return this._terminalLinkCache.set(r,F),j}$activateLink(r,h){const v=this._terminalLinkCache.get(r)?.get(h);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(r,h){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const v=this._terminalProcessDisposables[r];v&&(v.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,h)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,h){const v=this._getTerminalObjectIndexById(r,h);return v!==null?r[v]:null}_getTerminalObjectIndexById(r,h){let v=null;return r.some((P,L)=>P._id===h?(v=L,!0):!1),v}getEnvironmentVariableCollection(r){let h=this._environmentVariableCollections.get(r.identifier.value);return h||(h=new s,this._setEnvironmentVariableCollection(r.identifier.value,h)),h}_syncEnvironmentVariableCollection(r,h){const v=(0,S.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(r,h.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(r){r.forEach(h=>{const v=h[0],P=new s(h[1]);this._setEnvironmentVariableCollection(v,P)})}$acceptDefaultProfile(r,h){const v=this._defaultProfile;this._defaultProfile=r,this._defaultAutomationProfile=h,v?.path!==r.path&&this._onDidChangeShell.fire(r.path)}_setEnvironmentVariableCollection(r,h){this._environmentVariableCollections.set(r,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,h)})}};n=We([$e(1,I.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class s{get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(r,h){this._setIfDiffers(r,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,h){const v=this.map.get(r);(!v||v.value!==h.value||v.type!==h.type)&&(this.map.set(r,h),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,h){this.map.forEach((v,P)=>r.call(h,P,v,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let a=class extends n{constructor(r){super(!1,r)}createTerminal(r,h,v){throw new O.NotSupportedError}createTerminalFromOptions(r,h){throw new O.NotSupportedError}};a=We([$e(0,I.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function l(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function u(d){return t.ThemeColor.isThemeColor(d)?d:void 0}});var Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i};define(De[220],Ie([1,0,16,24,20,4,184,221,7,23,9,34,5,14,96,8,6,42,68,51]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b){"use strict";var p,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(V,W,T){this.editors=T,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=V.getProxy(m.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new a(this.proxy),W.registerArgumentProcessor({processArgument:F=>{if(F?.$mid!==14)return F;const R=F,x=R.tests[R.tests.length-1].item.extId;return this.controllers.get(c.TestId.root(x))?.collection.tree.get(x)?.actual??(0,f.toItemFromContext)(F)}})}createTestController(V,W,T){if(this.controllers.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const F=new y.DisposableStore,R=F.add(new f.ExtHostTestItemCollection(V,W,this.editors));R.root.label=W;const x=new Map,B=this.proxy,H={items:R.root.children,get label(){return W},set label(ee){W=ee,R.root.label=ee,B.$updateController(V,{label:W})},get refreshHandler(){return T},set refreshHandler(ee){T=ee,B.$updateController(V,{canRefresh:!!ee})},get id(){return V},createRunProfile:(ee,de,ne,me,le)=>{let ue=(0,A.hash)(ee);for(;x.has(ue);)ue++;return new P(this.proxy,x,V,ue,ee,de,ne,me,le)},createTestItem(ee,de,ne){return new f.TestItemImpl(V,ee,de,ne)},createTestRun:(ee,de,ne=!0)=>this.runTracker.createTestRun(V,R,ee,de,ne),set resolveHandler(ee){R.resolveHandler=ee},get resolveHandler(){return R.resolveHandler},dispose:()=>{F.dispose()}};B.$registerTestController(V,W,!!T),F.add((0,y.toDisposable)(()=>B.$unregisterTestController(V)));const G={controller:H,collection:R,profiles:x};return this.controllers.set(V,G),F.add((0,y.toDisposable)(()=>this.controllers.delete(V))),F.add(R.onDidGenerateDiff(ee=>B.$publishDiff(V,ee.map(b.TestsDiffOp.serialize)))),H}createTestObserver(){return this.observer.checkout()}async runTests(V,W=w.CancellationToken.None){const T=l(V);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(T.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:V.include?.map(R=>c.TestId.fromExtHostTestItem(R,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:L[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:V.exclude?.map(R=>R.id)},W)}$syncTests(){for(const{collection:V}of this.controllers.values())V.flushDiff();return Promise.resolve()}$provideFileCoverage(V,W,T){return(0,i.mapFind)(this.runTracker.trackers,R=>R.id===V?R.getCoverage(W):void 0)?.provideFileCoverage(T)??Promise.resolve([])}$resolveFileCoverage(V,W,T,F){return(0,i.mapFind)(this.runTracker.trackers,x=>x.id===V?x.getCoverage(W):void 0)?.resolveFileCoverage(T,F)??Promise.resolve([])}$configureRunProfile(V,W){this.controllers.get(V)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(V,W){await this.controllers.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(W=>(0,k.deepFreeze)(t.TestResults.to(W))).concat(this.results).sort((W,T)=>T.completedAt-W.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(V,W){const T=this.controllers.get(c.TestId.fromString(V).controllerId)?.collection;T&&(await T.expand(V,W<0?1/0:W),T.flushDiff())}$acceptDiff(V){this.observer.applyDiff(V.map(b.TestsDiffOp.deserialize))}async $runControllerTests(V,W){return Promise.all(V.map(T=>this.runControllerTestRequest(T,W)))}async runControllerTestRequest(V,W){const T=this.controllers.get(V.controllerId);if(!T)return{};const{collection:F,profiles:R}=T,x=R.get(V.profileId);if(!x)return{};const B=V.testIds.map(de=>F.tree.get(de)).filter(O.isDefined),H=V.excludeExtIds.map(de=>T.collection.tree.get(de)).filter(O.isDefined).filter(de=>B.some(ne=>ne.fullId.compare(de.fullId)===2));if(!B.length)return{};const G=new o.TestRunRequest(B.some(de=>de.actual instanceof f.TestItemRootImpl)?void 0:B.map(de=>de.actual),H.map(de=>de.actual),x),ee=this.runTracker.prepareForMainThreadTestRun(G,u.fromInternal(V,T.collection),W);try{return await x.runHandler(G,W),{}}catch(de){return{error:String(de)}}finally{ee.isRunning&&!W.isCancellationRequested&&await M.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(V){V===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(V)}};n=We([$e(0,E.IExtHostRpcService)],n),e.ExtHostTesting=n;class s extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(V,W,T){super(),this.dto=V,this.proxy=W,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(T)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}getCoverage(V){return this.tasks.get(V)?.coverage}createRun(V){const W=this.dto.id,T=this.dto.controllerId,F=(0,S.generateUuid)(),R=new d(this.proxy,W,F),x=ee=>(de,...ne)=>{if(H){console.warn(`Setting the state of test "${de.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(de)||(this.ensureTestIsKnown(de),ee(de,...ne))},B=(ee,de)=>{const ne=de instanceof Array?de.map(t.TestMessage.from):[t.TestMessage.from(de)];if(ee.uri&&ee.range){const me={range:t.Range.from(ee.range),uri:ee.uri};for(const le of ne)le.location=le.location||me}this.proxy.$appendTestMessagesInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),ne)};let H=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:V,get coverageProvider(){return R.coverageProvider},set coverageProvider(ee){R.coverageProvider=ee},enqueued:x(ee=>{this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),1)}),skipped:x(ee=>{this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),5)}),started:x(ee=>{this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),2)}),errored:x((ee,de,ne)=>{B(ee,de),this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),6,ne)}),failed:x((ee,de,ne)=>{B(ee,de),this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,T).toString(),4,ne)}),passed:x((ee,de)=>{this.proxy.$updateTestStateInRun(W,F,c.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,de)}),appendOutput:(ee,de,ne)=>{H||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(W,F,C.VSBuffer.fromString(ee),de&&t.location.from(de),ne&&c.TestId.fromExtHostTestItem(ne,T).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(W,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:G,coverage:R}),this.proxy.$startedTestRunTask(W,{id:F,name:V,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(V){if(!(V instanceof f.TestItemImpl))throw new g.InvalidTestItemError(V.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString()))return;const W=[],T=this.dto.colllection.root;for(;;){const F=t.TestItem.from(V);if(W.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),V===T))break;V=V.parent||T}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,W)}}class a{get trackers(){return this.tracked.values()}constructor(V){this.proxy=V,this.tracked=new Map}prepareForMainThreadTestRun(V,W,T){return this.getTracker(V,W,T)}cancelRunById(V){for(const W of this.tracked.values())if(W.id===V){W.dispose();return}}cancelAllRuns(){for(const V of this.tracked.values())V.dispose()}createTestRun(V,W,T,F,R){const x=this.tracked.get(T);if(x)return x.createRun(F);const B=u.fromPublic(V,W,T,R),H=l(T);this.proxy.$startedExtensionTestRun({controllerId:V,profile:H&&{group:L[H.kind],id:H.profileId},exclude:T.exclude?.map(ee=>c.TestId.fromExtHostTestItem(ee,W.root.id).toString())??[],id:B.id,include:T.include?.map(ee=>c.TestId.fromExtHostTestItem(ee,W.root.id).toString())??[W.root.id],persist:R});const G=this.getTracker(T,B);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),G.createRun(F)}getTracker(V,W,T){const F=new s(W,this.proxy,T);return this.tracked.set(V,F),F.onEnd(()=>this.tracked.delete(V)),F}}e.TestRunCoordinator=a;const l=j=>{if(!!j.profile){if(!(j.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class u{static fromPublic(V,W,T,F){return new u(V,(0,S.generateUuid)(),T.include?.map(R=>c.TestId.fromExtHostTestItem(R,V).toString())??[V],T.exclude?.map(R=>c.TestId.fromExtHostTestItem(R,V).toString())??[],F,W)}static fromInternal(V,W){return new u(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,T,F,R,x){this.controllerId=V,this.id=W,this.isPersisted=R,this.colllection=x,this.includePrefix=T.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}isIncluded(V){const W=c.TestId.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const T of this.excludePrefix)if(W===T||W.startsWith(T))return!1;for(const T of this.includePrefix)if(W===T||W.startsWith(T))return!0;return!1}}e.TestRunDto=u;class d{set coverageProvider(V){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!V||(this._coverageProvider=V,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(V,W,T){this.proxy=V,this.runId=W,this.taskId=T}async provideFileCoverage(V){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(V))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.fileCoverage=void 0,W}}async resolveFileCoverage(V,W){const T=await this.fileCoverage;let F=T?.[V];return!this._coverageProvider||!T||!F?[]:(F.detailedCoverage||(F=T[V]=await this._coverageProvider.resolveFileCoverage?.(F,W)??F),F.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class r extends b.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(V){super(),this.emitter=V,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(V){this.added.add(V)}update(V){Object.assign(V.revived,t.TestItem.toPlain(V.item)),this.added.has(V)||this.updated.add(V)}remove(V){if(this.added.has(V)){this.added.delete(V);return}this.updated.delete(V);const W=c.TestId.parentId(V.item.extId);if(W&&this.alreadyRemoved.has(W.toString())){this.alreadyRemoved.add(V.item.extId);return}this.removed.add(V)}getChangeEvent(){const{added:V,updated:W,removed:T}=this;return{get added(){return[...V].map(F=>F.revived)},get updated(){return[...W].map(F=>F.revived)},get removed(){return[...T].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(V){return this.items.get(V)}getMirroredTestDataByReference(V){return this.items.get(V.id)}createItem(V,W){return{...V,revived:t.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=h;class v{constructor(V){this.proxy=V}checkout(){this.current||(this.current=this.createObserverData());const V=this.current;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,I.once)(()=>{--V.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(V){return this.current?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.current?.tests.apply(V)}createObserverData(){const V=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:V}}}class P{get label(){return this._label}set label(V){V!==this._label&&(this._label=V,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:V}))}get isDefault(){return this._isDefault}set isDefault(V){V!==this._isDefault&&(this._isDefault=V,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:V?t.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(V){V!==this._configureHandler&&(this._configureHandler=V,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!V}))}constructor(V,W,T,F,R,x,B,H=!1,G=void 0){this.controllerId=T,this.profileId=F,this._label=R,this.kind=x,this.runHandler=B,this._isDefault=H,this._tag=G,p.set(this,void 0),D.set(this,void 0),Je(this,p,V,"f"),Je(this,D,W,"f"),W.set(F,this);const ee=L[x];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,p,"f").$publishTestRunProfile({profileId:F,controllerId:T,tag:G?t.TestTag.namespace(this.controllerId,G.id):null,label:R,group:ee,isDefault:H,hasConfigurationHandler:!1})}dispose(){Ae(this,D,"f")?.delete(this.profileId)&&(Je(this,D,void 0,"f"),Ae(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P,p=new WeakMap,D=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[222],Ie([1,0,16,4,5,97,8,6]),function(te,e,i,C,w,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const S=this._extHostDocumentsAndEditors.allEditors();return O?S:S.map(m=>m.value)}async showTextDocument(O,S,m){let E;typeof S=="number"?E={position:I.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?E={position:I.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?I.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:E={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,E),t=f&&this._extHostDocumentsAndEditors.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,S){return new M.TextEditorDecorationType(this._proxy,O,S).value}$acceptEditorPropertiesChanged(O,S){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const E=S.selections.selections.map(I.Selection.to);m._acceptSelections(E)}if(S.visibleRanges){const E=i.coalesce(S.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(E)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...S.options,lineNumbers:I.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const E=A.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:E})}if(S.visibleRanges){const E=i.coalesce(S.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:E})}}$acceptEditorPositionData(O){for(const S in O){const m=this._extHostDocumentsAndEditors.getEditor(S);if(!m)throw new Error("Unknown text editor");const E=I.ViewColumn.to(O[S]);m.value.viewColumn!==E&&(m._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:E}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(De[223],Ie([1,0,2,3,5,7,6,8,9]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class k{constructor(m,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const t=f.uri===void 0?void 0:i.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(t))?.get(f.handle)}return f}})}async $getTimeline(m,E,f,t){return this._providers.get(m)?.provideTimeline(i.URI.revive(E),f,t)}registerTimelineProvider(m,E,f,t){const o=new M.DisposableStore,c=this.convertTimelineItem(E.id,t,o).bind(this);let g;E.onDidChange&&(g=E.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:E.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:m,onDidChange:void 0,async provideTimeline(p,D,n){D?.resetCache&&(o.clear(),b.get(E.id)?.clear());const s=await E.provideTimeline(p,D,n);if(s==null)return;const a=c(p,D);return{...s,source:E.id,items:s.items.map(a)}},dispose(){for(const p of b.values())p.get(E.id)?.clear();g?.dispose(),o.dispose()}})}convertTimelineItem(m,E,f){return(t,o)=>{let c;if(o?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const b=O(t);c=g.get(b),c===void 0&&(c=new Map,g.set(b,c))}return g=>{const{iconPath:b,...p}=g,D=`${m}|${g.id??g.timestamp}`;c?.set(D,g);let n,s,a;g.iconPath&&(b instanceof I.ThemeIcon?a={id:b.id,color:b.color}:i.URI.isUri(b)?(n=b,s=b):{light:n,dark:s}=b);let l;return I.MarkdownString.isMarkdownString(p.tooltip)?l=A.MarkdownString.from(p.tooltip):(0,y.isString)(p.tooltip)?l=p.tooltip:I.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=A.MarkdownString.from(p.detail)):(0,y.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.detail),{...p,id:p.id??void 0,handle:D,source:m,command:g.command?E.toInternal(g.command,f):void 0,icon:n,iconDark:s,themeIcon:a,tooltip:l,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function O(S){return S?.toString()}}),define(De[224],Ie([1,0,7,13,2,5]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this._openers=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,O,S){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=S.schemes.find(E=>!I.supportedSchemes.has(E));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,O),this._proxy.$registerUriOpener(k,S.schemes,y,S.label),(0,i.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,O){const S=this._openers.get(y);if(!S)throw new Error(`Unknown opener with id: ${y}`);const m=w.URI.revive(k);return S.canOpenExternalUri(m,O)}async $openUri(y,k,O){const S=this._openers.get(y);if(!S)throw new Error(`Unknown opener id: '${y}'`);return S.openExternalUri(w.URI.revive(k.resolvedUri),{sourceUri:w.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(De[225],Ie([1,0,5,2,7,12,25]),function(te,e,i,C,w,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.handles.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const S=A.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(k)),this.handlers.set(S,O),this._proxy.$registerUriHandler(S,k),(0,w.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(k)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(k,O){const S=this.handlers.get(k);if(!S)return Promise.resolve(void 0);try{S.handleUri(C.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[57],Ie([1,0,4,13,23,2,147,168,66,5]),function(te,e,i,C,w,M,I,A,y,k){"use strict";var O,S,m,E,f,t,o,c,g,b,p,D,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(L,j,V,W,T,F,R){O.set(this,void 0),S.set(this,void 0),m.set(this,void 0),E.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,""),c.set(this,void 0),g.set(this,!1),b.set(this,!1),p.set(this,void 0),D.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new i.Emitter),this._onDidDispose=Ae(this,n,"f").event,Je(this,O,L,"f"),Je(this,S,j,"f"),Je(this,c,V,"f"),Je(this,E,W,"f"),Je(this,f,T,"f"),Je(this,t,F,"f"),Je(this,p,a(F),"f"),Je(this,D,l(F),"f"),Je(this,m,R,"f")}dispose(){Je(this,g,!0,"f"),Ae(this,n,"f").fire(),Ae(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,b,!0,"f"),(0,y.asWebviewUri)(L,Ae(this,E,"f"))}get cspSource(){const L=Ae(this,t,"f").extensionLocation;if(L.scheme===C.Schemas.https||L.scheme===C.Schemas.http){let j=L.toString();return j.endsWith("/")||(j+="/"),j+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,o,"f")}set html(L){this.assertNotDisposed(),Ae(this,o,"f")!==L&&(Je(this,o,L,"f"),Ae(this,D,"f")&&!Ae(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,b,!0,"f"),Ae(this,m,"f").report("Webview vscode-resource: uris",Ae(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,S,"f").$setHtml(Ae(this,O,"f"),this.rewriteOldResourceUrlsIfNeeded(L)))}get options(){return this.assertNotDisposed(),Ae(this,c,"f")}set options(L){this.assertNotDisposed(),w.equals(Ae(this,c,"f"),L)||Ae(this,S,"f").$setOptions(Ae(this,O,"f"),r(Ae(this,t,"f"),Ae(this,f,"f"),L)),Je(this,c,L,"f")}async postMessage(L){if(Ae(this,g,"f"))return!1;const j=(0,A.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Ae(this,p,"f")});return Ae(this,S,"f").$postMessage(Ae(this,O,"f"),j.message,...j.buffers)}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(L){if(!Ae(this,D,"f"))return L;const j=Ae(this,t,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,V=Ae(this,t,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Ae(this,t,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,T,F,R,x,B)=>{const H=M.URI.from({scheme:R||"file",path:decodeURIComponent(x)}),G=(0,y.asWebviewUri)(H,{isRemote:j,authority:V}).toString();return`${T}${G}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(W,T,F,R,x,B)=>{const H=M.URI.from({scheme:R||"file",path:decodeURIComponent(x)}),G=(0,y.asWebviewUri)(H,{isRemote:j,authority:V}).toString();return`${T}${G}${B}`})}}e.ExtHostWebview=s,O=new WeakMap,S=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,c=new WeakMap,g=new WeakMap,b=new WeakMap,p=new WeakMap,D=new WeakMap,n=new WeakMap;function a(P){try{const L=(0,I.normalizeVersion)((0,I.parseVersion)(P.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function l(P){try{const L=(0,I.normalizeVersion)((0,I.parseVersion)(P.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class u{constructor(L,j,V,W,T){this.remoteInfo=j,this.workspace=V,this._logService=W,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=L.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(L,j,V){const W=this.getWebview(L);if(W){const{message:T}=(0,A.deserializeWebviewMessage)(j,V.value);W._onMessageEmitter.fire(T)}}$onMissingCsp(L,j){this._logService.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,j,V){const W=new s(L,this._webviewProxy,h(j),this.remoteInfo,this.workspace,V,this._deprecationService);return this._webviews.set(L,W),W._onDidDispose(()=>{this._webviews.delete(L)}),W}deleteWebview(L){this._webviews.delete(L)}getWebview(L){return this._webviews.get(L)}}e.ExtHostWebviews=u;function d(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=d;function r(P,L,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||v(P,L)}}e.serializeWebviewOptions=r;function h(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(L=>M.URI.from(L))}}function v(P,L){return[...(L?.getWorkspaceFolders()||[]).map(j=>j.uri),P.extensionLocation]}}),define(De[226],Ie([1,0,20,221,7,13,22,2,8,57,64,5,6]),function(te,e,i,C,w,M,I,A,y,k,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(s,a){this.document=s,this._storagePath=a,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,a){await this.getEdit(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.getEdit(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=D(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const a=this._edits.get(s,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this._documents=new Map}get(s,a){return this._documents.get(this.key(s,a))}add(s,a,l){const u=this.key(s,a.uri);if(this._documents.has(u))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const d=new E(a,l);return this._documents.set(u,d),d}delete(s,a){const l=this.key(s,a.uri);this._documents.delete(l)}key(s,a){return`${s}@@@${a}`}}var t;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(t||(t={}));class o{constructor(){this._providers=new Map}addTextProvider(s,a,l){return this.add(0,s,a,l)}addCustomProvider(s,a,l){return this.add(1,s,a,l)}get(s){return this._providers.get(s)}add(s,a,l,u){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:s,extension:l,provider:u}),new m.Disposable(()=>this._providers.delete(a))}}class c{constructor(s,a,l,u,d){this._extHostDocuments=a,this._extensionStoragePaths=l,this._extHostWebview=u,this._extHostWebviewPanels=d,this._editorProviders=new o,this._documents=new f,this._proxy=s.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,l,u){const d=new w.DisposableStore;return b(l)?(d.add(this._editorProviders.addTextProvider(a,s,l)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(s),a,u.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(s))):(d.add(this._editorProviders.addCustomProvider(a,s,l)),g(l)&&d.add(l.onDidChangeCustomDocument(r=>{const h=this.getCustomDocumentEntry(a,r.document.uri);if(p(r)){const v=h.addEdit(r);this._proxy.$onDidEdit(r.document.uri,a,v,r.label)}else this._proxy.$onContentChange(r.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(s),a,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(d,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,l,u,d){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${a}'`);const h=A.URI.revive(s),v=await r.provider.openCustomDocument(h,{backupId:l,untitledDocumentData:u?.buffer},d);let P;return g(r.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension)),this._documents.add(a,v,P),{editable:g(r.provider)}}async $disposeCustomDocument(s,a){const l=this._editorProviders.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${a}'`);const u=A.URI.revive(s),{document:d}=this.getCustomDocumentEntry(a,u);this._documents.delete(a,d),d.dispose()}async $resolveWebviewEditor(s,a,l,u,d,r){const h=this._editorProviders.get(l);if(!h)throw new Error(`No provider found for '${l}'`);const v=y.ViewColumn.to(d),P=this._extHostWebview.createNewWebview(a,u.contentOptions,h.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(a,l,u.title,v,u.options,P,!0),j=A.URI.revive(s);switch(h.type){case 1:{const{document:V}=this.getCustomDocumentEntry(l,j);return h.provider.resolveCustomEditor(V,L,r)}case 0:{const V=this._extHostDocuments.getDocument(j);return h.provider.resolveCustomTextEditor(V,L,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,l){this.getCustomDocumentEntry(a,s).disposeEdits(l)}async $onMoveCustomEditor(s,a,l){const u=this._editorProviders.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this._extHostWebviewPanels.getWebviewPanel(s);if(!d)throw new Error("No webview found");const r=A.URI.revive(a),h=this._extHostDocuments.getDocument(r);await u.provider.moveCustomTextEditor(h,d,i.CancellationToken.None)}async $undo(s,a,l,u){return this.getCustomDocumentEntry(a,s).undo(l,u)}async $redo(s,a,l,u){return this.getCustomDocumentEntry(a,s).redo(l,u)}async $revert(s,a,l){const u=this.getCustomDocumentEntry(a,s);await this.getCustomEditorProvider(a).revertCustomDocument(u.document,l),u.disposeBackup()}async $onSave(s,a,l){const u=this.getCustomDocumentEntry(a,s);await this.getCustomEditorProvider(a).saveCustomDocument(u.document,l),u.disposeBackup()}async $onSaveAs(s,a,l,u){const d=this.getCustomDocumentEntry(a,s);return this.getCustomEditorProvider(a).saveCustomDocumentAs(d.document,A.URI.revive(l),u)}async $backup(s,a,l){const u=this.getCustomDocumentEntry(a,s),r=await this.getCustomEditorProvider(a).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},l);return u.updateBackup(r),r.id}getCustomDocumentEntry(s,a){const l=this._documents.get(s,A.URI.revive(a));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(s){const l=this._editorProviders.get(s)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=c;function g(n){return!!n.onDidChangeCustomDocument}function b(n){return typeof n.resolveCustomTextEditor=="function"}function p(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function D(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,C.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[227],Ie([1,0,4,7,2,34,8,57,5,6]),function(te,e,i,C,w,M,I,A,y,k){"use strict";var O,S,m,E,f,t,o,c,g,b,p,D,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends C.Disposable{constructor(d,r,h,v){super(),O.set(this,void 0),S.set(this,void 0),m.set(this,void 0),E.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,void 0),c.set(this,void 0),g.set(this,!0),b.set(this,void 0),p.set(this,!1),D.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,D,"f").event,n.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Ae(this,n,"f").event,Je(this,O,d,"f"),Je(this,S,r,"f"),Je(this,E,h,"f"),Je(this,m,v.viewType,"f"),Je(this,f,v.panelOptions,"f"),Je(this,c,v.viewColumn,"f"),Je(this,t,v.title,"f"),Je(this,b,v.active,"f")}dispose(){Ae(this,p,"f")||(Je(this,p,!0,"f"),Ae(this,D,"f").fire(),Ae(this,S,"f").$disposeWebview(Ae(this,O,"f")),Ae(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,E,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,m,"f")}get title(){return this.assertNotDisposed(),Ae(this,t,"f")}set title(d){this.assertNotDisposed(),Ae(this,t,"f")!==d&&(Je(this,t,d,"f"),Ae(this,S,"f").$setTitle(Ae(this,O,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ae(this,o,"f")}set iconPath(d){this.assertNotDisposed(),Ae(this,o,"f")!==d&&(Je(this,o,d,"f"),Ae(this,S,"f").$setIconPath(Ae(this,O,"f"),w.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ae(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,c,"f")=="number"&&Ae(this,c,"f")<0))return Ae(this,c,"f")}get active(){return this.assertNotDisposed(),Ae(this,b,"f")}get visible(){return this.assertNotDisposed(),Ae(this,g,"f")}_updateViewState(d){Ae(this,p,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Je(this,b,d.active,"f"),Je(this,g,d.visible,"f"),Je(this,c,d.viewColumn,"f"),Ae(this,n,"f").fire({webviewPanel:this}))}reveal(d,r){this.assertNotDisposed(),Ae(this,S,"f").$reveal(Ae(this,O,"f"),{viewColumn:typeof d>"u"?void 0:I.ViewColumn.from(d),preserveFocus:!!r})}assertNotDisposed(){if(Ae(this,p,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,S=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,c=new WeakMap,g=new WeakMap,b=new WeakMap,p=new WeakMap,D=new WeakMap,n=new WeakMap;class a{static newHandle(){return(0,M.generateUuid)()}constructor(d,r,h){this.webviews=r,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,r,h,v,P={}){const L=typeof v=="object"?v.viewColumn:v,j={viewColumn:I.ViewColumn.from(L),preserveFocus:typeof v=="object"&&!!v.preserveFocus},V=(0,A.shouldSerializeBuffersForPostMessage)(d),W=a.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(d),W,r,{title:h,panelOptions:l(P),webviewOptions:(0,A.serializeWebviewOptions)(d,this.workspace,P),serializeBuffersForPostMessage:V},j);const T=this.webviews.createNewWebview(W,P,d);return this.createNewWebviewPanel(W,r,h,L,P,T,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((h,v)=>{const P=d[h],L=d[v];return P.active?1:L.active?-1:+P.visible-+L.visible});for(const h of r){const v=this.getWebviewPanel(h);if(!v)continue;const P=d[h];v._updateViewState({active:P.active,visible:P.visible,viewColumn:I.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,r,h){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:h,extension:d}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(d)}),new k.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,h,v){const P=this._serializers.get(r);if(!P)throw new Error(`No serializer found for '${r}'`);const{serializer:L,extension:j}=P,V=this.webviews.createNewWebview(d,h.webviewOptions,j),W=this.createNewWebviewPanel(d,r,h.title,v,h.panelOptions,V,h.active);await L.deserializeWebviewPanel(W,h.state)}createNewWebviewPanel(d,r,h,v,P,L,j){const V=new s(d,this._proxy,L,{viewType:r,title:h,viewColumn:v,panelOptions:P,active:j});return this._webviewPanels.set(d,V),V}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=a;function l(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[228],Ie([1,0,4,7,57,8,5,6]),function(te,e,i,C,w,M,I,A){"use strict";var y,k,O,S,m,E,f,t,o,c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends C.Disposable{constructor(n,s,a,l,u,d){super(),y.set(this,void 0),k.set(this,void 0),O.set(this,void 0),S.set(this,void 0),m.set(this,!1),E.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,void 0),c.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Ae(this,c,"f").event,g.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,g,"f").event,Je(this,O,a,"f"),Je(this,f,l,"f"),Je(this,y,n,"f"),Je(this,k,s,"f"),Je(this,S,u,"f"),Je(this,E,d,"f")}dispose(){Ae(this,m,"f")||(Je(this,m,!0,"f"),Ae(this,g,"f").fire(),Ae(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,f,"f")}set title(n){this.assertNotDisposed(),Ae(this,f,"f")!==n&&(Je(this,f,n,"f"),Ae(this,k,"f").$setWebviewViewTitle(Ae(this,y,"f"),n))}get description(){return this.assertNotDisposed(),Ae(this,t,"f")}set description(n){this.assertNotDisposed(),Ae(this,t,"f")!==n&&(Je(this,t,n,"f"),Ae(this,k,"f").$setWebviewViewDescription(Ae(this,y,"f"),n))}get visible(){return Ae(this,E,"f")}get webview(){return Ae(this,S,"f")}get viewType(){return Ae(this,O,"f")}_setVisible(n){n===Ae(this,E,"f")||Ae(this,m,"f")||(Je(this,E,n,"f"),Ae(this,c,"f").fire())}get badge(){return this.assertNotDisposed(),Ae(this,o,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Ae(this,o,"f")?.value&&n?.tooltip===Ae(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(n),"f"),Ae(this,k,"f").$setWebviewViewBadge(Ae(this,y,"f"),n))}show(n){this.assertNotDisposed(),Ae(this,k,"f").$show(Ae(this,y,"f"),!!n)}assertNotDisposed(){if(Ae(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,O=new WeakMap,S=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,c=new WeakMap,g=new WeakMap;class p{constructor(n,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,s,a,l){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:a,extension:n}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(n),s,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(n)}),new A.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(n,s,a,l,u){const d=this._viewProviders.get(s);if(!d)throw new Error(`No view provider found for '${s}'`);const{provider:r,extension:h}=d,v=this._extHostWebview.createNewWebview(n,{},h),P=new b(n,this._proxy,s,a,v,!0);this._webviewViews.set(n,P),await r.resolveWebviewView(P,{state:l},u)}async $onDidChangeWebviewViewVisibility(n,s){this.getWebviewView(n)._setVisible(s)}async $disposeWebviewView(n){const s=this.getWebviewView(n);this._webviewViews.delete(n),s.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const s=this._webviewViews.get(n);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=p}),define(De[99],Ie([1,0,4,5,2,13,10,3,14]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Zi{get state(){return this._state}constructor(S){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=S.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,m){let E;if(typeof S=="string"){E=S;try{S=w.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,I.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,E,m)}async asExternalUri(S,m){if((0,I.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(S,m);return w.URI.from(E)}};k.InitialState={focused:!0},k=We([$e(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(De[229],Ie([1,0,199,26,14]),function(te,e,i,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends i.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,k){y.apply(console,k)}};M=We([$e(0,w.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(De[230],Ie([1,0,15,24,20,12,4,7,121,193,43]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,L){try{return JSON.stringify(P,L)}catch{return"null"}}const E="$$ref$$",f={[E]:-1};class t{constructor(L,j){this.jsonString=L,this.referencedBuffers=j}}function o(P,L=null,j=!1){const V=[];return{jsonString:(j?m:JSON.stringify)(P,(T,F)=>{if(typeof F>"u")return f;if(typeof F=="object"){if(F instanceof C.VSBuffer){const R=V.push(F)-1;return{[E]:R}}if(L)return L(T,F)}return F}),referencedBuffers:V}}e.stringifyJsonWithBufferRefs=o;function c(P,L,j){return JSON.parse(P,(V,W)=>{if(W){const T=W[E];if(typeof T=="number")return L[T];if(j&&W.$mid===1)return j.transformIncoming(W)}return W})}e.parseJsonAndRestoreBufferRefs=c;function g(P,L){return JSON.stringify(P,L)}function b(P){return P?(L,j)=>j&&j.$mid===1?P.transformOutgoing(j):j:null}var p;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class l extends A.Disposable{constructor(L,j=null,V=null){super(),this[S]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=j,this._uriTransformer=V,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let W=0,T=O.ProxyIdentifier.count;W<T;W++)this._locals[W]=null,this._proxies[W]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(W=>this._receiveOneMessage(W))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,y.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:j,sid:V}=L;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,V)),this._proxies[j]}_createProxy(L,j){const V={get:(W,T)=>(typeof T=="string"&&!W[T]&&T.charCodeAt(0)===36&&(W[T]=(...F)=>this._remoteCall(L,T,F)),T===a?j:W[T])};return new Proxy(Object.create(null),V)}set(L,j){return this._locals[L.nid]=j,j}assertRegistered(L){for(let j=0,V=L.length;j<V;j++){const W=L[j];if(!this._locals[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const j=L.byteLength,V=u.read(L,0),W=V.readUInt8(),T=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:F,method:R,args:x}=r.deserializeRequestJSONArgs(V);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,T,F,R,x,W===2);break}case 3:case 4:{let{rpcId:F,method:R,args:x}=r.deserializeRequestMixedArgs(V);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,T,F,R,x,W===4);break}case 5:{this._logger?.logIncoming(j,T,0,"ack"),this._onDidReceiveAcknowledge(T);break}case 6:{this._receiveCancel(j,T);break}case 7:{this._receiveReply(j,T,void 0);break}case 9:{let F=r.deserializeReplyOKJSON(V);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReply(j,T,F);break}case 10:{const F=r.deserializeReplyOKJSONWithBuffers(V,this._uriTransformer);this._receiveReply(j,T,F);break}case 8:{const F=r.deserializeReplyOKVSBuffer(V);this._receiveReply(j,T,F);break}case 11:{let F=r.deserializeReplyErrError(V);this._uriTransformer&&(F=(0,y.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReplyErr(j,T,F);break}case 12:{this._receiveReplyErr(j,T,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,j,V,W,T,F){this._logger?.logIncoming(L,j,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(V)}.${W}(`,T);const R=String(j);let x,B;if(F){const G=new w.CancellationTokenSource;T.push(G.token),x=this._invokeHandler(V,W,T),B=()=>G.cancel()}else x=this._invokeHandler(V,W,T),B=n;this._cancelInvokedHandlers[R]=B;const H=r.serializeAcknowledged(j);this._logger?.logOutgoing(H.byteLength,j,1,"ack"),this._protocol.send(H),x.then(G=>{delete this._cancelInvokedHandlers[R];const ee=r.serializeReplyOK(j,G,this._uriReplacer);this._logger?.logOutgoing(ee.byteLength,j,1,"reply:",G),this._protocol.send(ee)},G=>{delete this._cancelInvokedHandlers[R];const ee=r.serializeReplyErr(j,G);this._logger?.logOutgoing(ee.byteLength,j,1,"replyErr:",G),this._protocol.send(ee)})}_receiveCancel(L,j){this._logger?.logIncoming(L,j,1,"receiveCancel");const V=String(j);this._cancelInvokedHandlers[V]?.()}_receiveReply(L,j,V){this._logger?.logIncoming(L,j,0,"receiveReply:",V);const W=String(j);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const T=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W],T.resolveOk(V)}_receiveReplyErr(L,j,V){this._logger?.logIncoming(L,j,0,"receiveReplyErr:",V);const W=String(j);if(!this._pendingRPCReplies.hasOwnProperty(W))return;const T=this._pendingRPCReplies[W];delete this._pendingRPCReplies[W];let F;V&&(V.$isError?(F=new Error,F.name=V.name,F.message=V.message,F.stack=V.stack):F=V),T.resolveErr(F)}_invokeHandler(L,j,V){try{return Promise.resolve(this._doInvokeHandler(L,j,V))}catch(W){return Promise.reject(W)}}_doInvokeHandler(L,j,V){const W=this._locals[L];if(!W)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(L));const T=W[j];if(typeof T!="function")throw new Error("Unknown method "+j+" on actor "+(0,O.getStringIdentifierForProxy)(L));return T.apply(W,V)}_remoteCall(L,j,V){if(this._isDisposed)return new k.CanceledLazyPromise;let W=null;if(V.length>0&&w.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(M.canceled());const T=r.serializeRequestArguments(V,this._uriReplacer),F=++this._lastMessageId,R=String(F),x=new k.LazyPromise;W&&W.onCancellationRequested(()=>{const H=r.serializeCancel(F);this._logger?.logOutgoing(H.byteLength,F,0,"cancel"),this._protocol.send(r.serializeCancel(F))}),this._pendingRPCReplies[R]=x,this._onWillSendRequest(F);const B=r.serializeRequest(F,L,j,T,!!W);return this._logger?.logOutgoing(B.byteLength,F,0,`request: ${(0,O.getStringIdentifierForProxy)(L)}.${j}(`,V),this._protocol.send(B),x}}e.RPCProtocol=l,S=s,l.UNRESPONSIVE_TIME=3*1e3;class u{static alloc(L,j,V){const W=new u(C.VSBuffer.alloc(V+1+4),0);return W.writeUInt8(L),W.writeUInt32(j),W}static read(L,j){return new u(L,j)}get buffer(){return this._buff}constructor(L,j){this._buff=L,this._offset=j}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,V}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,j}static sizeMixedArray(L){let j=0;j+=1;for(let V=0,W=L.length;V<W;V++){const T=L[V];switch(j+=1,T.type){case 1:j+=this.sizeLongString(T.value);break;case 2:j+=this.sizeVSBuffer(T.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(T.value);for(let F=0;F<T.buffers.length;++F)j+=this.sizeVSBuffer(T.buffers[F]);break;case 4:break}}return j}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let j=0,V=L.length;j<V;j++){const W=L[j];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let T=0;T<W.buffers.length;++T)this.writeBuffer(W.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(L);for(let V=0;V<L;V++)switch(this.readUInt8()){case 1:j[V]=this.readLongString();break;case 2:j[V]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),F=this.readLongString(),R=[];for(let x=0;x<T;++x)R.push(this.readVSBuffer());j[V]=new O.SerializableObjectWithBuffers(c(F,R,null));break}case 4:j[V]=void 0;break}return j}}u.sizeUInt32=4;var d;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(d||(d={}));class r{static _useMixedArgSerialization(L){for(let j=0,V=L.length;j<V;j++)if(L[j]instanceof C.VSBuffer||L[j]instanceof O.SerializableObjectWithBuffers||typeof L[j]>"u")return!0;return!1}static serializeRequestArguments(L,j){if(this._useMixedArgSerialization(L)){const V=[];for(let W=0,T=L.length;W<T;W++){const F=L[W];if(F instanceof C.VSBuffer)V[W]={type:2,value:F};else if(typeof F>"u")V[W]={type:4};else if(F instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:x}=o(F.value,j);V[W]={type:3,value:C.VSBuffer.fromString(R),buffers:x}}else V[W]={type:1,value:C.VSBuffer.fromString(g(F,j))}}return{type:1,args:V}}return{type:0,args:g(L,j)}}static serializeRequest(L,j,V,W,T){switch(W.type){case 0:return this._requestJSONArgs(L,j,V,W.args,T);case 1:return this._requestMixedArgs(L,j,V,W.args,T)}}static _requestJSONArgs(L,j,V,W,T){const F=C.VSBuffer.fromString(V),R=C.VSBuffer.fromString(W);let x=0;x+=u.sizeUInt8(),x+=u.sizeShortString(F),x+=u.sizeLongString(R);const B=u.alloc(T?2:1,L,x);return B.writeUInt8(j),B.writeShortString(F),B.writeLongString(R),B.buffer}static deserializeRequestJSONArgs(L){const j=L.readUInt8(),V=L.readShortString(),W=L.readLongString();return{rpcId:j,method:V,args:JSON.parse(W)}}static _requestMixedArgs(L,j,V,W,T){const F=C.VSBuffer.fromString(V);let R=0;R+=u.sizeUInt8(),R+=u.sizeShortString(F),R+=u.sizeMixedArray(W);const x=u.alloc(T?4:3,L,R);return x.writeUInt8(j),x.writeShortString(F),x.writeMixedArray(W),x.buffer}static deserializeRequestMixedArgs(L){const j=L.readUInt8(),V=L.readShortString(),W=L.readMixedArray(),T=new Array(W.length);for(let F=0,R=W.length;F<R;F++){const x=W[F];typeof x=="string"?T[F]=JSON.parse(x):T[F]=x}return{rpcId:j,method:V,args:T}}static serializeAcknowledged(L){return u.alloc(5,L,0).buffer}static serializeCancel(L){return u.alloc(6,L,0).buffer}static serializeReplyOK(L,j,V){if(typeof j>"u")return this._serializeReplyOKEmpty(L);if(j instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(L,j);if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:T}=o(j.value,V,!0);return this._serializeReplyOKJSONWithBuffers(L,W,T)}else return this._serializeReplyOKJSON(L,m(j,V))}static _serializeReplyOKEmpty(L){return u.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,j){let V=0;V+=u.sizeVSBuffer(j);const W=u.alloc(8,L,V);return W.writeVSBuffer(j),W.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,j){const V=C.VSBuffer.fromString(j);let W=0;W+=u.sizeLongString(V);const T=u.alloc(9,L,W);return T.writeLongString(V),T.buffer}static _serializeReplyOKJSONWithBuffers(L,j,V){const W=C.VSBuffer.fromString(j);let T=0;T+=u.sizeUInt32,T+=u.sizeLongString(W);for(const R of V)T+=u.sizeVSBuffer(R);const F=u.alloc(10,L,T);F.writeUInt32(V.length),F.writeLongString(W);for(const R of V)F.writeBuffer(R);return F.buffer}static deserializeReplyOKJSON(L){const j=L.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(L,j){const V=L.readUInt32(),W=L.readLongString(),T=[];for(let F=0;F<V;++F)T.push(L.readVSBuffer());return new O.SerializableObjectWithBuffers(c(W,T,j))}static serializeReplyErr(L,j){const V=j?m(M.transformErrorForSerialization(j),null):void 0;if(typeof V!="string")return this._serializeReplyErrEmpty(L);const W=C.VSBuffer.fromString(V);let T=0;T+=u.sizeLongString(W);const F=u.alloc(11,L,T);return F.writeLongString(W),F.buffer}static deserializeReplyErrError(L){const j=L.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(L){return u.alloc(12,L,0).buffer}}var h;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(v||(v={}))}),define(De[231],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const I=A=>{self.removeEventListener("message",I);const y=A.data;Object.defineProperties(self,{postMessage:{value(k,O){y.postMessage(k,O)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(M,I,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${I}'))`,k=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(k),S=new MessageChannel,m=O,E={type:"_newWorker",id:m,port:S.port2,url:O,options:A};M(E,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),S.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),S.port1.start()}}e.NestedWorker=C}),define(De[232],Ie([1,0,4,30,41,3,36,12,15]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new w.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new w.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new w.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(t=>f.push(t)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function S(E,f,t,o,c){return(0,y.createCancelablePromise)(async g=>{await(0,I.whenProviderRegistered)(t,o);const b=C.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,o,c,g),b.registerChannel({id:E,label:f,file:t,log:!0})}catch(p){(0,A.isCancellationError)(p)||c.error("Error while registering log channel",t.toString(),(0,A.getErrorMessage)(p))}})}e.registerLogChannel=S;async function m(E,f,t,o,c){if(!await t.exists(E)){if(c.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",E.toString()),await(0,y.timeout)(1e3,c),await m(E,f+1,t,o,c)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new w.RawContextKey("activeOutputChannel","")}),define(De[100],Ie([1,0,5,3,14,25,11,232,55,26,37,114,24,9,36,4,7]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class c extends I.AbstractMessageLogger{get disposed(){return this._disposed}constructor(D,n,s,a,l){super(),this.id=D,this.name=n,this.logger=s,this.proxy=a,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this._register(s.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.logger.getLevel()}appendLine(D){this.append(D+`
`)}append(D){this.info(D)}clear(){const D=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,D)}replace(D){const n=this.offset;this.info(D),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,n),this.visible&&this.logger.flush()}show(D,n){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof D=="boolean"?D:n))}hide(){this.proxy.$close(this.id)}log(D,n){this.offset+=m.VSBuffer.fromString(n).byteLength,(0,I.log)(this.logger,D,n),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class g extends c{appendLine(D){this.append(D)}}let b=class{constructor(D,n,s,a,l,u){this.initData=n,this.extHostFileSystem=s,this.extHostFileSystemInfo=a,this.loggerService=l,this.logService=u,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=D.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(n.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(D){this.visibleChannelId=D;for(const[n,s]of this.channels)s.visible=n===this.visibleChannelId}createOutputChannel(D,n,s){if(D=D.trim(),!D)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,l=(0,E.isString)(n)?n:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const d=this.initData.environment.extensionLogLevel?.find(([h])=>M.ExtensionIdentifier.equals(s.identifier,h))?.[1];d&&(u=(0,I.parseLogLevel)(d));const r=a?this.doCreateLogOutputChannel(D,u,s):this.doCreateOutputChannel(D,l,s);return r.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),a?this.createExtHostLogOutputChannel(D,u??this.logService.getLevel(),r):this.createExtHostOutputChannel(D,r)}async doCreateOutputChannel(D,n,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const a=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${D.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(D,l,!1,n,s.identifier.value);return new c(d,D,u,this.proxy,s)}async doCreateLogOutputChannel(D,n,s){const a=await this.createExtensionLogDirectory(s),l=this.extHostFileSystemInfo.extUri.joinPath(a,`${D.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(l,{name:D},n),d=await this.proxy.$register(D,l,!0,void 0,s.identifier.value);return new g(d,D,u,this.proxy,s)}createExtensionLogDirectory(D){let n=this.extensionLogDirectoryPromise.get(D.identifier.value);if(!n){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,D.identifier.value);this.extensionLogDirectoryPromise.set(D.identifier.value,n=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}createExtHostOutputChannel(D,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return D},append(l){a(),n.then(u=>u.append(l))},appendLine(l){a(),n.then(u=>u.appendLine(l))},clear(){a(),n.then(l=>l.clear())},replace(l){a(),n.then(u=>u.replace(l))},show(l,u){a(),n.then(d=>d.show(l,u))},hide(){a(),n.then(l=>l.hide())},dispose(){s=!0,n.then(l=>l.dispose())}}}createExtHostLogOutputChannel(D,n,s){const a=new o.DisposableStore,l=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},u=a.add(new t.Emitter);return s.then(d=>{a.add(d),a.add(d.onDidChangeLogLevel(r=>{n=r,u.fire(r)}))}),{...this.createExtHostOutputChannel(D,s),get logLevel(){return n},onDidChangeLogLevel:u.event,trace(d,...r){l(),s.then(h=>h.trace(d,...r))},debug(d,...r){l(),s.then(h=>h.debug(d,...r))},info(d,...r){l(),s.then(h=>h.info(d,...r))},warn(d,...r){l(),s.then(h=>h.warn(d,...r))},error(d,...r){l(),s.then(h=>h.error(d,...r))},dispose(){a.dispose()}}}};b=We([$e(0,w.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,O.IExtHostFileSystemInfo),$e(4,I.ILoggerService),$e(5,I.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(De[233],Ie([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(De[234],Ie([1,0,39,13,19,21,22,2,3,164,49,179,233]),function(te,e,i,C,w,M,I,A,y,k,O,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let E=class en{constructor(t,o,c,g){this.localUserHome=t,this.remoteAgentService=o,this.environmentService=c,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome??t})()}hasValidBasename(t,o,c){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(g=>this.doHasValidBasename(t,g,o)):this.doHasValidBasename(t,o,c)}doHasValidBasename(t,o,c){return t.scheme===C.Schemas.file||t.scheme===C.Schemas.vscodeRemote?(0,i.isValidBasename)(c??(0,I.basename)(t),o===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,o){if(t.remoteAuthority)return C.Schemas.vscodeRemote;const c=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(c)return c;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const b=o.getWorkspace().configuration;return b?b.scheme:C.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?w.win32:w.posix)}async fileURI(t){let o="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(o=t.substring(2),t="/"):(o=t.substring(2,g),t=t.substring(g)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:o,path:t,query:"",fragment:""})}};E=We([$e(1,m.IRemoteAgentService),$e(2,S.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(De[101],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new i(0,0)}with(I){return new i(0,0)}}e.Position=i;class C{constructor(I,A,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(I,A),this.end=new i(y,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var w;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[44],Ie([1,0,16,35,23,39,10,3,19,12,101,15]),function(te,e,i,C,w,M,I,A,y,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",E=" characters skipped \u27EB",f=(m.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var t;(function(ne){ne[ne.file=0]="file",ne[ne.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ne){ne[ne.File=1]="File",ne[ne.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function c(ne){return!!ne.preview}e.resultIsMatch=c;function g(ne){return!!ne.resource}e.isFileMatch=g;function b(ne){return!!ne.message}e.isProgressMessage=b;var p;(function(ne){ne[ne.Normal=0]="Normal",ne[ne.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(me){this.resource=me,this.results=[]}}e.FileMatch=D;class n{constructor(me,le,ue){this.ranges=le;const Q=Array.isArray(le)?le:[le];if(ue&&ue.matchLines===1&&s(Q)){me=(0,I.getNLines)(me,ue.matchLines);let ge="",Se=0,Oe=0;const xe=Math.floor(ue.charsPerLine/5),Qe=[];for(const Ce of Q){const ye=Math.max(Ce.startColumn-xe,0),Te=Ce.startColumn+ue.charsPerLine;if(ye>Oe+xe+f){const se=m+(ye-Oe)+E;ge+=se+me.slice(ye,Te),Se+=ye-(Oe+se.length)}else ge+=me.slice(Oe,Te);Qe.push(new l(0,Ce.startColumn-Se,Ce.endColumn-Se)),Oe=Te}this.preview={text:ge,matches:Array.isArray(this.ranges)?Qe:Qe[0]}}else{const ge=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:me,matches:(0,i.mapArrayOrNot)(le,Se=>new a(Se.startLineNumber-ge,Se.startColumn,Se.endLineNumber-ge,Se.endColumn))}}}}e.TextSearchMatch=n;function s(ne){const me=ne[0].startLineNumber;for(const le of ne)if(le.startLineNumber!==me||le.endLineNumber!==me)return!1;return!0}class a{constructor(me,le,ue,Q){this.startLineNumber=me,this.startColumn=le,this.endLineNumber=ue,this.endColumn=Q}}e.SearchRange=a;class l extends a{constructor(me,le,ue){super(me,le,me,ue)}}e.OneLineRange=l;var u;(function(ne){ne.List="list",ne.Tree="tree"})(u=e.ViewMode||(e.ViewMode={}));var d;(function(ne){ne.Default="default",ne.FileNames="fileNames",ne.Type="type",ne.Modified="modified",ne.CountDescending="countDescending",ne.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function r(ne,me=!0){const le=ne&&ne.files&&ne.files.exclude,ue=me&&ne&&ne.search&&ne.search.exclude;if(!le&&!ue)return;if(!le||!ue)return le||ue;let Q=Object.create(null);return Q=w.mixin(Q,w.deepClone(le)),Q=w.mixin(Q,w.deepClone(ue),!0),Q}e.getExcludes=r;function h(ne,me){return ne.excludePattern&&C.match(ne.excludePattern,me)?!1:ne.includePattern||ne.usingSearchPaths?ne.includePattern&&C.match(ne.includePattern,me)?!0:ne.usingSearchPaths?!!ne.folderQueries&&ne.folderQueries.some(le=>{const ue=le.folder.fsPath;if(M.isEqualOrParent(me,ue)){const Q=y.relative(ue,me);return!le.includePattern||!!C.match(le.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var v;(function(ne){ne[ne.unknownEncoding=1]="unknownEncoding",ne[ne.regexParseError=2]="regexParseError",ne[ne.globParseError=3]="globParseError",ne[ne.invalidLiteral=4]="invalidLiteral",ne[ne.rgProcessError=5]="rgProcessError",ne[ne.other=6]="other",ne[ne.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(me,le){super(me),this.code=le}}e.SearchError=P;function L(ne){const me=ne.message;if((0,k.isCancellationError)(ne))return new P(me,v.canceled);try{const le=JSON.parse(me);return new P(le.message,le.code)}catch{return new P(me,v.other)}}e.deserializeSearchError=L;function j(ne){const me={message:ne.message,code:ne.code};return new Error(JSON.stringify(me))}e.serializeSearchError=j;function V(ne){return ne.type==="error"?!0:ne.type==="success"}e.isSerializedSearchComplete=V;function W(ne){return ne.type==="success"}e.isSerializedSearchSuccess=W;function T(ne){return!!ne.path}e.isSerializedFileMatch=T;function F(ne,me){const le=ne.searchPath?ne.searchPath:ne.relativePath;return(0,I.fuzzyContains)(le,me)}e.isFilePatternMatch=F;class R{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function x(ne,me){const le={...ne||{},...me||{}};return Object.keys(le).filter(ue=>{const Q=le[ue];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=x;class B{constructor(me,le){this._parsedIncludeExpression=null,this._excludeExpression={...me.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let ue=me.includePattern;le.includePattern&&(ue?ue={...ue,...le.includePattern}:ue=le.includePattern),ue&&(this._parsedIncludeExpression=C.parse(ue))}matchesExcludesSync(me,le,ue){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(me,le,ue))}includedInQuerySync(me,le,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(me,le,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(me,le,ue))}includedInQuery(me,le,ue){const Q=this._parsedExcludeExpression(me,le,ue),ge=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(me,le,ue):!0;return(0,S.isThenable)(Q)?Q.then(Se=>Se?!1:ge()):ge()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=B;function H(ne){for(const me in ne)if(typeof ne[me]!="boolean")return!0;return!1}function G(ne){if(!ne)return;let me;return le=>(me||(me=(ne()||Promise.resolve([])).then(ue=>ue?de(ue):{})),me.then(ue=>!!ue[le]))}e.hasSiblingPromiseFn=G;function ee(ne){if(!ne)return;let me;return le=>{if(!me){const ue=ne();me=ue?de(ue):{}}return!!me[le]}}e.hasSiblingFn=ee;function de(ne){const me={};for(const le of ne)me[le]=!0;return me}}),define(De[31],Ie([1,0,16,15,20,4,7,46,13,108,22,10,9,2,138,3,11,152,49,37,26,14,8,6,50,44,5]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D,n,s,a,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(W,T,F){return new O.ExtUri(R=>P(R,F)).isEqual(W,T)}function r(W,T,F){return d(W.uri,T.uri,F)?0:(0,S.compare)(W.uri.toString(),T.uri.toString())}function h(W,T,F){return W.index!==T.index?W.index<T.index?-1:1:d(W.uri,T.uri,F)?(0,S.compare)(W.name,T.name):(0,S.compare)(W.uri.toString(),T.uri.toString())}function v(W,T,F,R){const x=W.slice(0).sort((H,G)=>F(H,G,R)),B=T.slice(0).sort((H,G)=>F(H,G,R));return(0,i.delta)(x,B,(H,G)=>F(H,G,R))}function P(W,T){const F=T.getCapabilities(W.scheme);return!(F&&F&1024)}class L extends g.Workspace{static toExtHostWorkspace(T,F,R,x){if(!T)return{workspace:null,added:[],removed:[]};const{id:B,name:H,folders:G,configuration:ee,transient:de,isUntitled:ne}=T,me=[],le=F;F?G.forEach((Se,Oe)=>{const xe=E.URI.revive(Se.uri),Qe=L._findFolder(R||F,xe,x);Qe?(Qe.name=Se.name,Qe.index=Se.index,me.push(Qe)):me.push({uri:xe,name:Se.name,index:Oe})}):me.push(...G.map(({uri:Se,name:Oe,index:xe})=>({uri:E.URI.revive(Se),name:Oe,index:xe}))),me.sort((Se,Oe)=>Se.index<Oe.index?-1:1);const ue=new L(B,H,me,!!de,ee?E.URI.revive(ee):null,!!ne,Se=>P(Se,x)),{added:Q,removed:ge}=v(le?le.workspaceFolders:[],ue.workspaceFolders,r,x);return{workspace:ue,added:Q,removed:ge}}static _findFolder(T,F,R){for(let x=0;x<T.folders.length;x++){const B=T.workspaceFolders[x];if(d(B.uri,F,R))return B}}constructor(T,F,R,x,B,H,G){super(T,R.map(ee=>new g.WorkspaceFolder(ee)),x,B,G),this._name=F,this._isUntitled=H,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),R.forEach(ee=>{this._workspaceFolders.push(ee),this._structure.set(ee.uri,ee)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(T,F){return F&&this._structure.get(T)&&(T=(0,O.dirname)(T)),this._structure.findSubstr(T)}resolveWorkspaceFolder(T){return this._structure.get(T)}}let j=class{constructor(T,F,R,x,B){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=x,this._extHostFileSystemInfo=R,this._uriTransformerService=B,this._requestIdProvider=new k.Counter,this._barrier=new C.Barrier,this._proxy=T.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=T.getProxy(u.MainContext.MainThreadMessageService);const H=F.workspace;this._confirmedWorkspace=H?new L(H.id,H.name,[],!!H.transient,H.configuration?E.URI.revive(H.configuration):null,!!H.isUntitled,G=>P(G,R)):void 0}$initializeWorkspace(T,F){this._trusted=F,this.$acceptWorkspaceData(T),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(T,F,R,...x){const B=[];if(Array.isArray(x)&&x.forEach(ne=>{E.URI.isUri(ne.uri)&&!B.some(me=>d(me.uri,ne.uri,this._extHostFileSystemInfo))&&B.push({uri:ne.uri,name:ne.name||(0,O.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[F,R].some(ne=>typeof ne!="number"||ne<0)||R===0&&B.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+R>H.length)return!1;const G=H.slice(0);G.splice(F,R,...B.map(ne=>({uri:ne.uri,name:ne.name||(0,O.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<G.length;ne++){const me=G[ne];if(G.some((le,ue)=>ue!==ne&&d(me.uri,le.uri,this._extHostFileSystemInfo)))return!1}G.forEach((ne,me)=>ne.index=me);const{added:ee,removed:de}=v(H,G,h,this._extHostFileSystemInfo);if(ee.length===0&&de.length===0)return!1;if(this._proxy){const ne=T.displayName||T.name;this._proxy.$updateWorkspaceFolders(ne,F,R,B).then(void 0,me=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:T.identifier,label:T.displayName||T.name}};this._messageService.$showMessage(c.Severity.Error,(0,f.localize)(0,null,ne,me.toString()),le,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(T,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,F)}async getWorkspaceFolder2(T,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,F)}async resolveWorkspaceFolder(T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(T)}getPath(){if(!this._actualWorkspace)return;const{folders:T}=this._actualWorkspace;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,F){let R,x="";if(typeof T=="string"?(R=E.URI.file(T),x=T):typeof T<"u"&&(R=T,x=T.fsPath),!R)return x;const B=this.getWorkspaceFolder(R,!0);if(!B)return x;typeof F>"u"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let H=(0,O.relativePath)(B.uri,R);return F&&B.name&&(H=`${B.name}/${H}`),H}trySetWorkspaceFolders(T){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:T,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:F,added:R,removed:x}=L.toExtHostWorkspace(T,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:x}))}findFiles(T,F,R,x,B=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let H;if(F===null?H=!1:F&&(typeof F=="string"?H=F:H=F.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:ee}=V(n.GlobPattern.from(T));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(G),(0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(H),(0,m.withUndefinedAsNull)(R),B).then(de=>Array.isArray(de)?de.map(ne=>E.URI.revive(ne)):[])}async findTextInFiles(T,F,R,x,B=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),G=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:ee,folder:de}=V(n.GlobPattern.from(F.include)),ne=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,me={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:G,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:ee,excludePattern:ne},le=!1;if(this._activeSearchCallbacks[H]=ue=>{if(le)return;const Q=E.URI.revive(ue.resource);ue.results.forEach(ge=>{(0,l.resultIsMatch)(ge)?R({uri:Q,preview:{text:ge.preview.text,matches:(0,i.mapArrayOrNot)(ge.preview.matches,Se=>new s.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,i.mapArrayOrNot)(ge.ranges,Se=>new s.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):R({uri:Q,text:ge.text,lineNumber:ge.lineNumber})})},B.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(T,(0,m.withUndefinedAsNull)(de),me,H,B);return delete this._activeSearchCallbacks[H],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[H],ue}}$handleTextSearchResult(T,F){this._activeSearchCallbacks[F]?.(T)}saveAll(T){return this._proxy.$saveAll(T)}resolveProxy(T){return this._proxy.$resolveProxy(T)}get trusted(){return this._trusted}requestWorkspaceTrust(T){return this._proxy.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(T,F){if(this._editSessionIdentityProviders.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this._editSessionIdentityProviders.set(T,F);const R=this._uriTransformerService.transformOutgoingScheme(T),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,R),(0,I.toDisposable)(()=>{this._editSessionIdentityProviders.delete(T),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(T,F){this._logService.info("Getting edit session identifier for workspaceFolder",T);const R=await this.resolveWorkspaceFolder(E.URI.revive(T));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const x=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!x),!x)return;const B=await x.provideEditSessionIdentity(R,F);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(T,F,R,x){this._logService.info("Getting edit session identifier for workspaceFolder",T);const B=await this.resolveWorkspaceFolder(E.URI.revive(T));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const H=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!H),!H)return;const G=await H.provideEditSessionIdentityMatch?.(F,R,x);if(this._logService.info("Provider returned edit session identifier match result: ",G),!!G)return G}};j=We([$e(0,D.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,o.ILogService),$e(4,a.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function V(W){let T,F;return W&&(typeof W=="string"?T=W:(T=W.pattern,F=E.URI.revive(W.baseUri))),{includePattern:T,folder:F}}}),define(De[32],Ie([1,0,23,4,31,5,6,155,89,9,15,3,14,11,2]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(s,a){if(a){const l=a.split(".");let u=s;for(let d=0;u&&d<l.length;d++)u=u[l[d]];return u}}function o(s){return s instanceof f.URI}function c(s){return s&&s.uri instanceof f.URI&&s.languageId&&typeof s.languageId=="string"}function g(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof f.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(o(s))return{resource:s};if(c(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(g(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let D=class{constructor(a,l,u){this._proxy=a.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=u,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new n(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,l){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,l))}};D=We([$e(0,m.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,E.ILogService)],D),e.ExtHostConfiguration=D;class n{constructor(a,l,u,d){this._onDidChangeConfiguration=new C.Emitter,this._proxy=a,this._logService=d,this._extHostWorkspace=l,this._configuration=A.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,l){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,u))}getConfiguration(a,l,u){const d=p(l)||{},r=this._toReadonlyValue(a?t(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,d,u?.identifier);function h(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(P){return typeof t(r,P)<"u"},get:(P,L)=>{this._validateConfigurationAccess(a?`${a}.${P}`:P,d,u?.identifier);let j=t(r,P);if(typeof j>"u")j=L;else{let V;const W=(T,F)=>{let R;const x=()=>{V=V||(0,i.deepClone)(r),R=R||t(V,F)};return(0,k.isObject)(T)?new Proxy(T,{get:(B,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return x(),()=>R;if(V)return R=R||t(V,F),R[H];const G=B[H];return typeof H=="string"?W(G,`${F}.${H}`):G},set:(B,H,G)=>(x(),R&&(R[H]=G),!0),deleteProperty:(B,H)=>(x(),R&&delete R[H],!0),defineProperty:(B,H,G)=>(x(),R&&Object.defineProperty(R,H,G),!0)}):T};j=W(j,P)}return j},update:(P,L,j,V)=>{P=a?`${a}.${P}`:P;const W=h(j);return L!==void 0?this._proxy.$updateConfigurationOption(W,P,L,d,V):this._proxy.$removeConfigurationOption(W,P,d,V)},inspect:P=>{P=a?`${a}.${P}`:P;const L=this._configuration.inspect(P,d,this._extHostWorkspace.workspace);if(L)return{key:P,defaultValue:(0,i.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,i.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,i.deepClone)(L.workspace?.value),workspaceFolderValue:(0,i.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(L.default?.override),globalLanguageValue:(0,i.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,i.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(L.workspaceFolder?.override),languageIds:(0,i.deepClone)(L.overrideIdentifiers)}}};return typeof r=="object"&&(0,i.mixin)(v,r,!1),Object.freeze(v)}_toReadonlyValue(a){const l=u=>(0,k.isObject)(u)?new Proxy(u,{get:(d,r)=>l(d[r]),set:(d,r,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(d,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(d,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return l(a)}_validateConfigurationAccess(a,l,u){const d=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),r=u?`[${u.value}] `:"";if(d===4){typeof l?.resource>"u"&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,l){const u=new A.ConfigurationChangeEvent(a,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,r)=>u.affectsConfiguration(d,p(r))})}_toMap(a){return a.reduce((l,u)=>(l.set(u[0],u[1]),l),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[102],Ie([1,0,2,15,4,5,6,31,53,32,20,56,14,26,3,13,21,11,72,192,12]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(T){function F(x){if(x!=null)return x}T.from=F;function R(x){if(x!=null)return x}T.to=R})(n||(n={}));var s;(function(T){function F(x){if(x!=null)return x}T.from=F;function R(x){if(x!=null)return x}T.to=R})(s||(s={}));var a;(function(T){function F(x){if(x!=null)return x}T.from=F;function R(x){if(x!=null)return x}T.to=R})(a||(a={}));var l;(function(T){function F(B){if(B){const H=B;return H&&!!H.process}else return!1}T.is=F;function R(B){if(B==null)return;const H={process:B.process,args:B.args};return B.options&&(H.options=a.from(B.options)),H}T.from=R;function x(B){if(B!=null)return new I.ProcessExecution(B.process,B.args,B.options)}T.to=x})(l||(l={}));var u;(function(T){function F(x){if(x!=null)return x}T.from=F;function R(x){if(x!=null)return x}T.to=R})(u||(u={}));var d;(function(T){function F(B){if(B){const H=B;return H&&(!!H.commandLine||!!H.command)}else return!1}T.is=F;function R(B){if(B==null)return;const H={};return B.commandLine!==void 0?H.commandLine=B.commandLine:(H.command=B.command,H.args=B.args),B.options&&(H.options=u.from(B.options)),H}T.from=R;function x(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new I.ShellExecution(B.commandLine,B.options):new I.ShellExecution(B.command,B.args?B.args:[],B.options)}T.to=x})(d||(d={}));var r;(function(T){function F(B){if(B){const H=B;return H&&H.customExecution==="customExecution"}else return!1}T.is=F;function R(B){return{customExecution:"customExecution"}}T.from=R;function x(B,H){return H.get(B)}T.to=x})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(T){function F(R,x){let B;return R.scope!==void 0&&typeof R.scope!="number"?B=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===I.TaskScope.Workspace&&x&&x.workspaceFile?B=x.workspaceFile:B=b.USER_TASKS_GROUP_KEY),{id:R._id,workspaceFolder:B}}T.from=F})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(T){function F(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}T.from=F})(v||(v={}));var P;(function(T){function F(B,H){if(B==null)return[];const G=[];for(const ee of B){const de=R(ee,H);de&&G.push(de)}return G}T.fromMany=F;function R(B,H){if(B==null)return;let G;B.execution instanceof I.ProcessExecution?G=l.from(B.execution):B.execution instanceof I.ShellExecution?G=d.from(B.execution):B.execution&&B.execution instanceof I.CustomExecution&&(G=r.from(B.execution));const ee=n.from(B.definition);let de;return B.scope?typeof B.scope=="number"?de=B.scope:de=B.scope.uri:de=I.TaskScope.Workspace,!ee||!de?void 0:{_id:B._id,definition:ee,name:B.name,source:{extensionId:H.identifier.value,label:B.source,scope:de},execution:G,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:s.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}T.from=R;async function x(B,H,G){if(B==null)return;let ee;l.is(B.execution)?ee=l.to(B.execution):d.is(B.execution)?ee=d.to(B.execution):r.is(B.execution)&&(ee=r.to(B._id,G));const de=n.to(B.definition);let ne;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ne=B.source.scope:ne=await H.resolveWorkspaceFolder(i.URI.revive(B.source.scope)):ne=I.TaskScope.Workspace),!de||!ne)return;const me=new I.Task(de,ne,B.name,B.source.label,ee,B.problemMatchers);return B.isBackground!==void 0&&(me.isBackground=B.isBackground),B.group!==void 0&&(me.group=I.TaskGroup.from(B.group._id),me.group&&B.group.isDefault&&(me.group=new I.TaskGroup(me.group.id,me.group.label),B.group.isDefault===!0&&(me.group.isDefault=B.group.isDefault))),B.presentationOptions&&(me.presentationOptions=s.to(B.presentationOptions)),B._id&&(me._id=B._id),B.detail&&(me.detail=B.detail),me}T.to=x})(P=e.TaskDTO||(e.TaskDTO={}));var L;(function(T){function F(x){return x}T.from=F;function R(x){if(!!x)return Object.assign(Object.create(null),x)}T.to=R})(L||(L={}));class j{constructor(F,R,x){this._id=R,this._task=x,D.set(this,void 0),Je(this,D,F,"f")}get task(){return this._task}terminate(){Ae(this,D,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}D=new WeakMap;let V=class{constructor(F,R,x,B,H,G,ee,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=F.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=B,this._configurationService=H,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ee,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,R,x){if(!x)return new I.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:R,provider:x,extension:F}),this._proxy.$registerTaskProvider(B,R),new I.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(F,R){this._proxy.$registerTaskSystem(F,R)}fetchTasks(F){return this._proxy.$fetchTasks(L.from(F)).then(async R=>{const x=[];for(const B of R){const H=await P.to(B,this._workspaceProvider,this._providedCustomExecutions2);H&&x.push(H)}return x})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(R=>F.push(R)),F}terminateTask(F){if(!(F instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,R,x){const B=this._providedCustomExecutions2.get(F.id);B&&(this._activeCustomExecutions2.set(F.id,B),this._terminalService.attachPtyToTerminal(R,await B.callback(x))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const R=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:R})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const R=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:R,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const R=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:R,exitCode:F.exitCode})}$provideTasks(F,R){const x=this._handlers.get(F);if(!x)return Promise.reject(new Error("no handler found"));const B=[],H=(0,C.asPromise)(()=>x.provider.provideTasks(O.CancellationToken.None)).then(G=>this.provideTasksInternal(R,B,x,G));return new Promise(G=>{H.then(ee=>{Promise.all(B).then(()=>{G(ee)})})})}async $resolveTask(F,R){const x=this._handlers.get(F);if(!x)return Promise.reject(new Error("no handler found"));if(R.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${x.type}].`);const B=await P.to(R,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const H=await x.provider.resolveTask(B,O.CancellationToken.None);if(!H)return;this.checkDeprecation(H,x);const G=P.from(H,x.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(G.execution)&&await this.addCustomExecution(G,H,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,R,x){const B=await this._proxy.$createTaskId(F);!x&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,R.execution)),this._providedCustomExecutions2.set(B,R.execution)}async getTaskExecution(F,R){if(typeof F=="string"){const H=this._taskExecutionPromises.get(F);if(!H)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const x=this._taskExecutionPromises.get(F.id);if(x)return x;const B=new Promise((H,G)=>{function ee(de,ne,me){me?H(new j(de,ne.id,me)):G("Unexpected: Task does not exist.")}R?ee(this,F,R):P.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>ee(this,F,de))});return this._taskExecutionPromises.set(F.id,B),B.then(H=>(this._taskExecutions.set(F.id,H),H),H=>Promise.reject(H))}checkDeprecation(F,R){F._deprecated&&this._deprecationService.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const x=this._notProvidedCustomExecutions.values();let B=x.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=x.next()}};V=We([$e(0,m.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,c.ILogService),$e(7,g.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let W=class extends V{constructor(F,R,x,B,H,G,ee,de){super(F,R,x,B,H,G,ee,de),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(F,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const x=P.from(R,F);if(x===void 0)throw new Error("Task is not valid");if(r.is(x.execution))await this.addCustomExecution(x,R,!1);else throw new p.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),R);return this._proxy.$executeTask(x).catch(H=>{throw new Error(H)}),B}provideTasksInternal(F,R,x,B){const H=[];if(B)for(const G of B){this.checkDeprecation(G,x),(!G.definition||!F[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ee=P.from(G,x.extension);ee&&r.is(ee.execution)?(H.push(ee),R.push(this.addCustomExecution(ee,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:x.extension}}async resolveTaskInternal(F){if(r.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,R,x){}};W=We([$e(0,m.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,c.ILogService),$e(7,g.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(De[235],Ie([1,0,19,20,45,35,22,210,44]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,E,f){this.config=m,this.provider=E,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const E=this.config.folderQueries||[];return new Promise((f,t)=>{const o=c=>{this.resultCount++,m(c)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(c=>{const g=c.toString(),b=i.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,b)||this.matchFile(o,{base:c,basename:b})}),Promise.all(E.map(c=>this.searchInFolder(c,o))).then(c=>{f({limitHit:this.isLimitHit,stats:c[0]||void 0})},c=>{t(new Error((0,w.toErrorMessage)(c)))})})}async searchInFolder(m,E){const f=new C.CancellationTokenSource,t=this.getSearchOptionsForFolder(m),o=this.initDirectoryTree(),c=new y.QueryGlobTester(this.config,m),g=!c.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(f),b=A.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},t,f.token),D=b.elapsed(),n=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(s=>{const a=i.posix.relative(m.folder.path,s.path);if(g){const l=i.basename(s.path);this.matchFile(E,{base:m.folder,relativePath:a,basename:l});return}this.addDirectoryEntries(o,m.folder,a,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,c,E),{providerTime:D,postProcessTime:n.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,y.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:E,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},E,f,t){if(f===this.filePattern){const c=i.basename(this.filePattern);this.matchFile(t,{base:E,relativePath:this.filePattern,basename:c})}function o(c){const g=i.basename(c),b=i.dirname(c);let p=m[b];p||(p=m[b]=[],o(b)),p.push({base:E,relativePath:c,basename:g})}o(f)}matchDirectoryTree({rootEntries:m,pathToEntries:E},f,t){const o=this,c=this.filePattern;function g(b){const p=(0,y.hasSiblingFn)(()=>b.map(D=>D.basename));for(let D=0,n=b.length;D<n;D++){const s=b[D],{relativePath:a,basename:l}=s;if(f.matchesExcludesSync(a,l,c!==l?p:void 0))continue;const u=E[a];if(u)g(u);else{if(a===c)continue;o.matchFile(t,s)}if(o.isLimitHit)break}}g(m)}matchFile(m,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(E))}}class O{constructor(){this.sessions=new Map}fileSearch(m,E,f,t){const o=this.getSessionTokenSource(m.cacheKey),c=new k(m,E,o&&o.token);let g=0;const b=p=>{g+=p.length,f(p.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(c,O.BATCH_SIZE,b,t).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:p.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new C.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,E,f,t){t.onCancellationRequested(()=>{m.cancel()});const o=g=>{g&&(c.push(g),E>0&&c.length>=E&&(f(c),c=[]))};let c=[];return m.search(o).then(g=>(c.length&&f(c),g),g=>(c.length&&f(c),Promise.reject(g)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(De[236],Ie([1,0,16,78,35,82,28,13,19,22,10,9,2,252,146,40,11,49,93,234,44]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let D=class{constructor(v,P,L,j,V){this.configurationService=v,this.workspaceContextService=P,this.editorGroupsService=L,this.logService=j,this.pathService=V}text(v,P,L={}){v=this.getContentPattern(v,L);const j=this.configurationService.getValue(),V=P&&P.some(T=>!this.configurationService.getValue({resource:T}).search.useRipgrep);return{...this.commonQuery(P?.map(c.toWorkspaceFolder),L),type:2,contentPattern:v,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:j.search.usePCRE2||V||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(v,P){const L=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const j={...v,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(v,P)&&(j.isCaseSensitive=!0),this.isMultiline(v)&&(j.isMultiline=!0),j}file(v,P={}){return{...this.commonQuery(v,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(v,P){return v?(v=Array.isArray(v)?v.map(u):u(v),P?this.parseSearchPaths(v):{pattern:s(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],P={}){const L=this.handleIncludeExclude(P.includePattern,P.expandPatterns),j=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),V=v.length>1,W=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,P,j)):v.map(R=>this.getFolderQueryForRoot(R,P,j,V))).filter(R=>!!R),T={_reason:P._reason,folderQueries:W,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:j.pattern,includePattern:L.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const R=i.coalesce(i.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const x=R.filter(H=>(0,p.pathIncludedInQuery)(T,H.fsPath)),B=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...T,...B}}const F=P.extraFileResources&&P.extraFileResources.filter(R=>(0,p.pathIncludedInQuery)(T,R.fsPath));return T.extraFileResources=F&&F.length?F:void 0,T}commonQueryFromFileList(v){const P=[],L=new I.ResourceMap,j={};let V=!1;return v.forEach(W=>{if(W.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(W)){const F=this.workspaceContextService.getWorkspaceFolder(W)?.uri??W.with({path:y.dirname(W.fsPath)});let R=L.get(F);R||(V=!0,R={folder:F,includePattern:{}},P.push(R),L.set(F,R));const x=y.relative(F.fsPath,W.fsPath);(0,S.assertIsDefined)(R.includePattern)[x.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,j[W.fsPath]=!0)}),{folderQueries:P,includePattern:j,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}isCaseSensitive(v,P){if(P.isSmartCase){if(v.isRegExp){if(O.containsUppercaseCharacter(v.pattern,!0))return!0}else if(O.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,E.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const P=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),j=(Array.isArray(v)?v:a(v)).map(B=>{const H=this.pathService.resolvedUserHome;return H?(0,M.untildify)(B,H.scheme===A.Schemas.file?H.fsPath:H.path):B}),V=C.groupBy(j,B=>P(B)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(B=>O.rtrim(B,"/")).map(B=>O.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),T={},F=this.expandSearchPathPatterns(V.searchPaths||[]);F&&F.length&&(T.searchPaths=F);const R=i.flatten(W),x=s(...R);return x&&(T.pattern=x),T}getExcludesForFolder(v,P){return P.disregardExcludeSettings?void 0:(0,p.getExcludes)(v,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const P=i.flatten(v.map(j=>{let{pathPortion:V,globPortion:W}=n(j);W&&(W=d(W));const T=this.expandOneSearchPath(V);return i.flatten(T.map(F=>this.resolveOneSearchPathPattern(F,W)))})),L=new Map;return P.forEach(j=>{const V=j.searchPath.toString(),W=L.get(V);W?j.pattern&&(W.pattern=W.pattern||{},W.pattern[j.pattern]=!0):L.set(V,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(v){if(y.isAbsolute(v)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==A.Schemas.file?[{searchPath:P[0].uri.with({path:v})}]:[{searchPath:m.URI.file(y.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=u(v),v.startsWith("../")||v===".."){const j=y.posix.resolve(P.path,v);return[{searchPath:P.with({path:j})}]}const L=d(v);return[{searchPath:P,pattern:L}]}else{if(v==="./"||v===".\\")return[];{const P=v.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(V=>{const W=P.match(new RegExp(`^${O.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.isDefined);if(j.length)return j.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&d(W)}});{const V=v.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:v,T=f.localize(0,null,W);throw new Error(T)}}}}resolveOneSearchPathPattern(v,P){const L=v.pattern&&P?`${v.pattern}/${P}`:v.pattern||P,j=[{searchPath:v.searchPath,pattern:L}];return L&&!L.endsWith("**")&&j.push({searchPath:v.searchPath,pattern:L+"/**"}),j}getFolderQueryForSearchPath(v,P,L){const j=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(v.searchPath),P,L,!1);return j?{...j,includePattern:v.pattern}:null}getFolderQueryForRoot(v,P,L,j){let V;const W=m.URI.isUri(v)?v:v.uri;if(L.searchPaths){const B=L.searchPaths.filter(H=>(0,k.isEqual)(H.searchPath,W))[0];if(B&&!B.pattern)return null;B&&(V=B.pattern)}const T=this.configurationService.getValue({resource:W}),R={...this.getExcludesForFolder(T,P)||{},...V||{}},x=m.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:W,folderName:j?x:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!T.search.followSymlinks}}};D=We([$e(0,t.IConfigurationService),$e(1,c.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,o.ILogService),$e(4,b.IPathService)],D),e.QueryBuilder=D;function n(h){const v=h.match(/[\*\{\}\(\)\[\]\?]/);if(v){const P=v.index,L=h.substr(0,P).match(/[/|\\][^/\\]*$/);if(L){let j=h.substr(0,L.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((v,P)=>(v[P]=!0,v),Object.create(null)):void 0}function a(h){return w.splitGlobAware(h,",").map(v=>v.trim()).filter(v=>!!v.length)}function l(h){return[`**/${h}/**`,`**/${h}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function u(h){return h.replace(/\\/g,"/")}function d(h){return u(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(h,v){h=i.distinct(h,j=>j.toString());const P=[],L=v.getWorkspace();return h&&h.forEach(j=>{let V;if(v.getWorkbenchState()===2)V=(0,k.relativePath)(L.folders[0].uri,j),V&&V!=="."&&(V="./"+V);else{const W=v.getWorkspaceFolder(j);if(W){const T=W.name;if(L.folders.filter(R=>R.name===T).length===1){const R=(0,k.relativePath)(W.uri,j);R===""?V=`./${W.name}`:V=`./${W.name}/${R}`}else V=j.fsPath}}V&&P.push(V)}),P}e.resolveResourcesForSearchIncludes=r}),define(De[237],Ie([1,0,22,2,20,12,3,236,44,49]),function(te,e,i,C,w,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function S(t,o){const c=o.activationEvents;if(!c)return Promise.resolve(void 0);const g=[],b=[];for(const l of c)if(/^workspaceContains:/.test(l)){const u=l.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||t.forceUsingSearch?b.push(u):g.push(u)}if(g.length===0&&b.length===0)return Promise.resolve(void 0);let p;const D=new Promise((l,u)=>{p=l}),n=l=>p({activationEvent:l}),s=Promise.all(g.map(l=>m(t,l,n))).then(()=>{}),a=E(t,o.identifier,b,n);return Promise.all([s,a]).then(()=>{p(void 0)}),D}e.checkActivateWorkspaceContainsExtension=S;async function m(t,o,c){for(const g of t.folders)if(await t.exists(i.joinPath(C.URI.revive(g),o))){c(`workspaceContains:${o}`);return}}async function E(t,o,c,g){if(c.length===0)return Promise.resolve(void 0);const b=new w.CancellationTokenSource,p=t.checkExists(t.folders,c,b.token),D=setTimeout(async()=>{b.cancel(),t.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},O);let n=!1;try{n=await p}catch(s){M.isCancellationError(s)||M.onUnexpectedError(s)}b.dispose(),clearTimeout(D),n&&g(`workspaceContains:${c.join(",")}`)}function f(t,o,c,g){const b=t.get(I.IInstantiationService),p=t.get(y.ISearchService),n=b.createInstance(A.QueryBuilder).file(o.map(s=>(0,k.toWorkspaceFolder)(C.URI.revive(s))),{_reason:"checkExists",includePattern:c,exists:!0});return p.fileSearch(n,g).then(s=>!!s.limitHit,s=>M.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,C,w){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?w.call(te,i):w?w.value=i:e.set(te,i),i},Ae=this&&this.__classPrivateFieldGet||function(te,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(te):C?C.value:e.get(te)};define(De[33],Ie([1,0,133,19,77,22,15,7,46,2,11,5,32,181,75,31,27,180,12,25,24,165,6,90,3,26,76,14,61,65,56,4,237,74,167,13,73]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D,n,s,a,l,u,d,r,h,v,P,L,j,V,W,T){"use strict";var F,R,x;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let B=class Pi extends A.Disposable{constructor(le,ue,Q,ge,Se,Oe,xe,Qe,Ce,ye,Te){super(),this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ue,this._extHostContext=Q,this._initData=xe,this._extHostWorkspace=ge,this._extHostConfiguration=Se,this._logService=Oe,this._extHostTunnelService=Ce,this._extHostTerminalService=ye,this._extHostLocalizationService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._globalRegistry=new c.ExtensionDescriptionRegistry(this._initData.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new c.ExtensionDescriptionRegistry(ee(this._globalRegistry,se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Qe,this._instaService=le.createChild(new r.ServiceCollection([f.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ae=[],J=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(N=>!N.main&&!N.browser).map(N=>N.identifier),J=this._initData.allExtensions.filter(N=>!se.has(b.ExtensionIdentifier.toKey(N.identifier.value))).filter(N=>(N.main||N.browser)&&N.api==="none").map(N=>N.identifier));const _=(0,o.extensionIdentifiersArrayToSet)(J);this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,ae,J,{onExtensionActivationError:(N,$,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(N,g.transformErrorForSerialization($),q)},actualActivateExtension:async(N,$)=>{if(_.has(b.ExtensionIdentifier.toKey(N)))return await this._mainThreadExtensionsProxy.$activateExtension(N,$),new E.HostExtension;const q=this._myRegistry.getExtensionDescription(N);return this._activateExtension(q,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){g.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,ue=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ge=>{this._logService.error(ge)}),this._extHostContext.dispose();const Q=this._deactivateAll();Promise.race([(0,I.timeout)(5e3),Q]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ue}`):this._logService.info(`Extension host exiting with code ${ue}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ue)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const ue=await this._mainThreadExtensionsProxy.$getExtension(le);let Q;if(ue?.browserNlsBundleUris){Q={};for(const ge of Object.keys(ue.browserNlsBundleUris))Q[ge]=k.URI.revive(ue.browserNlsBundleUris[ge])}return ue&&{...ue,identifier:new b.ExtensionIdentifier(ue.identifier.value),extensionLocation:k.URI.revive(ue.extensionLocation),browserNlsBundleUris:Q}}_activateByEvent(le,ue){return this._activator.activateByEvent(le,ue)}_activateById(le,ue){return this._activator.activateById(le,ue)}activateByIdWithErrors(le,ue){return this._activateById(le,ue).then(()=>{const Q=this._activator.getActivatedExtension(le);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==W.Schemas.file)return le;const ue=await this._hostUtils.realpath(le.fsPath);return k.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new ne(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const ue=y.TernarySearchTree.forUris(Q=>M.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(le.map(async Q=>{if(this._getEntryPoint(Q)){const ge=await this._realPathExtensionUri(Q.extensionLocation);ue.set(ge,Q)}})),ue}_deactivate(le){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return ue;const Q=this._activator.getActivatedExtension(le);if(!Q)return ue;try{typeof Q.module.deactivate=="function"&&(ue=Promise.resolve(Q.module.deactivate()).then(void 0,ge=>(this._logService.error(ge),Promise.resolve(void 0))))}catch(ge){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(ge)}try{(0,A.dispose)(Q.subscriptions)}catch(ge){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(ge)}return ue}async _activateExtension(le,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,ue).then(Q=>{const ge=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,ue),this._logExtensionActivationTimes(le,ue,"success",ge),Q},Q=>{throw this._logExtensionActivationTimes(le,ue,"failure"),Q})}_logExtensionActivationTimes(le,ue,Q,ge){const Se=H(le,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...ge||{},outcome:Q})}_doActivateExtension(le,ue){const Q=H(le,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const ge=this._getEntryPoint(le);if(!ge)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${le.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const Se=new E.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(le,(0,M.joinPath)(le.extensionLocation,ge),Se),this._loadExtensionContext(le)]).then(Oe=>(w.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Pi._callActivate(this._logService,le.identifier,Oe[0],Oe[1],Se))).then(Oe=>(w.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Oe))}_loadExtensionContext(le){const ue=new D.ExtensionGlobalMemento(le,this._storage),Q=new D.ExtensionMemento(le.identifier.value,!1,this._storage),ge=new V.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Oe=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([ue.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const xe=this;let Qe,Ce;const ye=(0,o.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:Q,secrets:ge,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(Te){return C.join(le.extensionLocation.fsPath,Te)},get storagePath(){return xe._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return xe._storagePath.globalValue(le).fsPath},get logPath(){return C.join(xe._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return k.URI.joinPath(xe._initData.logsLocation,le.identifier.value)},get storageUri(){return xe._storagePath.workspaceValue(le)},get globalStorageUri(){return xe._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Qe===void 0&&(Qe=new G(xe,le.identifier,le,Oe,!1)),Qe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(le,"extensionRuntime"),xe.extensionRuntime},get environmentVariableCollection(){return xe._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!Ce){if(!ye)return;const Te=P.Event.buffer(P.Event.fromDOMEventEmitter(ye,"message",se=>se.data));ye.start(),Ce={onDidReceiveMessage:Te,postMessage:ye.postMessage.bind(ye)}}return Ce}})})}static _callActivate(le,ue,Q,ge,Se){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,ue,Q,ge,Se).then(Oe=>new E.ActivatedExtension(!1,null,Se.build(),Q,Oe,ge.subscriptions))}static _callActivateOptional(le,ue,Q,ge,Se){if(typeof Q.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const Oe=typeof global=="object"?global:self,xe=Q.activate.apply(Oe,[ge]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(xe).then(Qe=>(Se.activateResolveStop(),Qe))}catch(Oe){return Promise.reject(Oe)}else return Promise.resolve(Q)}_activateOneStartupFinished(le,ue){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:ue}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const ue of le.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(le,ue)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(ue),ge=Promise.all([le,Q]).then(()=>{});return Promise.race([ge,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ge}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(le,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,ue){if(this.isActivated(ue.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ge={logService:this._logService,folders:le.map(Oe=>Oe.uri),forceUsingSearch:Q,exists:Oe=>this._hostUtils.exists(Oe.fsPath),checkExists:(Oe,xe,Qe)=>this._mainThreadWorkspaceProxy.$checkExists(Oe,xe,Qe)},Se=await(0,L.checkActivateWorkspaceContainsExtension)(ge,ue);if(!!Se)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:Se.activationEvent}).then(void 0,Oe=>this._logService.error(Oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:ue}=this._initData.environment;if(!le||!ue)throw new Error(i.localize(0,null));const Q=await this._loadCommonJSModule(null,ue,new E.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(i.localize(1,null,ue.toString()));return new Promise((ge,Se)=>{const Oe=(Ce,ye)=>{Ce?Se(Ce):ge(typeof ye=="number"&&ye>0?1:0)},xe=(0,M.originalFSPath)(ue),Qe=Q.run(xe,Oe);Qe&&Qe.then&&Qe.then(()=>{ge(0)}).catch(Ce=>{Se(Ce instanceof Error&&Ce.stack?Ce.stack:String(Ce))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,ue){return this._resolvers[le]=ue,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const ue=le.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const Q=le.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(le,ue){this._logService.info(`$resolveAuthority invoked for authority (${de(le)})`);const{authorityPrefix:Q,resolver:ge}=await this._activateAndGetResolver(le);if(!ge)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ge)),w.mark(`code/extHost/willResolveAuthority/${Q}`);const Se=await ge.resolve(le,{resolveAttempt:ue});w.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const Oe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},xe={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Oe,options:xe,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(w.mark(`code/extHost/didResolveAuthorityError/${Q}`),Se instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,ue){this._logService.info(`$getCanonicalURI invoked for authority (${de(le)})`);const{resolver:Q}=await this._activateAndGetResolver(le);if(!Q)return null;const ge=k.URI.revive(ue);if(typeof Q.getCanonicalURI>"u")return ge;const Se=await(0,I.asPromise)(()=>Q.getCanonicalURI(ge));return Se||ge}static _applyExtensionsDelta(le,ue,Q){const ge=new c.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());ge.deltaExtensions(Q.toAdd,Q.toRemove);const Se=(0,o.extensionIdentifiersArrayToSet)(ue.getAllExtensionDescriptions().map(xe=>xe.identifier));for(const xe of Q.myToRemove)Se.delete(b.ExtensionIdentifier.toKey(xe));for(const xe of Q.myToAdd)Se.add(b.ExtensionIdentifier.toKey(xe));const Oe=ee(ge,Se);return{globalRegistry:ge,myExtensions:Oe}}$startExtensionHost(le){le.toAdd.forEach(ge=>ge.extensionLocation=k.URI.revive(ge.extensionLocation));const{globalRegistry:ue,myExtensions:Q}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(Q),this._startExtensionHost()}$activateByEvent(le,ue){return ue===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(le,!1))}async $activate(le,ue){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,ue),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Oe=>Oe.extensionLocation=k.URI.revive(Oe.extensionLocation));const{globalRegistry:ue,myExtensions:Q}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),ge=await this._createExtensionPathIndex(Q);return(await this.getExtensionPathIndex()).setSearchTree(ge),this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(Q),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const ue=p.VSBuffer.alloc(le),Q=Math.random()%256;for(let ge=0;ge<le;ge++)ue.writeUInt8(Q,ge);return ue}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};B=We([$e(0,a.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,t.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,O.ILogService),$e(6,l.IExtHostInitDataService),$e(7,u.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,v.IExtHostTerminalService),$e(10,T.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function H(me,le){return{id:me.identifier.value,name:me.name,extensionVersion:me.version,publisherDisplayName:me.publisher,activationEvents:me.activationEvents?me.activationEvents.join(","):null,isBuiltin:me.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class G{constructor(le,ue,Q,ge,Se){F.set(this,void 0),R.set(this,void 0),x.set(this,void 0),Je(this,F,le,"f"),Je(this,R,ue,"f"),Je(this,x,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=ge,this.isFromDifferentExtensionHost=Se}get isActive(){return Ae(this,F,"f").isActivated(Ae(this,x,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ae(this,F,"f").getExtensionExports(Ae(this,x,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ae(this,F,"f").activateByIdWithErrors(Ae(this,x,"f"),{startup:!1,extensionId:Ae(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,F=new WeakMap,R=new WeakMap,x=new WeakMap;function ee(me,le){return me.getAllExtensionDescriptions().filter(ue=>le.has(b.ExtensionIdentifier.toKey(ue.identifier)))}function de(me){const le=me.indexOf("+");return le===-1?me:me.substring(0,le)}class ne{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=ne}),define(De[238],Ie([1,0,77,2,5,32,27,25,14,26,3,33,48,11,10]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(D,n,s,a,l,u,d){this._apiFactory=D,this._extensionRegistry=n,this._instaService=s,this._extHostConfiguration=a,this._extHostExtensionService=l,this._initData=u,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const D=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,n,this._extensionRegistry,D,this._logService)),this.register(this._instaService.createInstance(g,n)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,n,this._initData.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const n of D.nodeModuleName)this._factories.set(n,D);else this._factories.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this._alternatives.push(n=>D.alternativeModuleName(n))}};t=We([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,S.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,E.ILogService)],t),e.RequireInterceptor=t;let o=class Qi{constructor(D){if(D.environment.appRoot&&Qi.aliased.size){const n=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(D.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${l}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(D){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(D));if(!n)return;const[,s,a,l]=n,u=Qi.aliased.get(a);if(u!==void 0)return console.warn(`${a} as been renamed to ${u}, please update your imports`),s+u+l}forceForwardSlashes(D){return D.replace(/\\/g,"/")}};o.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=We([$e(0,k.IExtHostInitDataService)],o);class c{constructor(D,n,s,a,l){this._apiFactory=D,this._extensionPaths=n,this._extensionRegistry=s,this._configProvider=a,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(D,n){const s=this._extensionPaths.findSubstr(n);if(s){let a=this._extApiImpl.get(A.ExtensionIdentifier.toKey(s.identifier));return a||(a=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(s.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((l,u)=>a+=`	${u} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(D,n,s){this._extensionPaths=D,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(w.MainContext.MainThreadTelemetry);const{environment:a}=s,l=n.getProxy(w.MainContext.MainThreadKeytar);if(a.appRoot){let u=a.appRoot.fsPath;m.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,d)=>l.$getPassword(u,d),setPassword:(u,d,r)=>l.$setPassword(u,d,r),deletePassword:(u,d)=>l.$deletePassword(u,d),findPassword:u=>l.$findPassword(u),findCredentials(u){return l.$findCredentials(u)}}}load(D,n){const s=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(D){const n=D.length;if(n<=7||!this.alternativeNames)return;const s=n-7;if((D.charAt(s)==="/"||D.charAt(s)==="\\")&&D.endsWith("keytar")&&(D=D.replace(/\\/g,"/"),this.alternativeNames.has(D)))return"keytar"}};g=We([$e(1,y.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],g);let b=class{constructor(D,n,s){this._extensionPaths=D,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(w.MainContext.MainThreadTelemetry);const a=s.getProxy(w.MainContext.MainThreadWindow);this._impl=(l,u)=>{const d=C.URI.parse(l);return u?this.callOriginal(l,u):d.scheme==="http"||d.scheme==="https"?a.$openUri(d,l,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?a.$openUri(d,l,{}):this.callOriginal(l,u)}}load(D,n,s){const a=this._extensionPaths.findSubstr(n);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=s(D),this._impl}callOriginal(D,n){return this.sendNoForwardTelemetry(),this._original(D,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=We([$e(2,y.IExtHostRpcService)],b)}),define(De[103],Ie([1,0,204,7,19,48,3,53,54,33,6,31,177,32]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(c,g,b,p,D,n,s){function a(){if(b){const l=b.activeEditor();if(l)return l.document.uri;const u=p.tabGroups.all.find(d=>d.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof O.TextDiffTabInput||u.input instanceof O.NotebookDiffEditorTabInput)return u.input.modified;if(u.input instanceof O.TextTabInput||u.input instanceof O.NotebookEditorTabInput||u.input instanceof O.CustomEditorTabInput)return u.input.uri}}}super({getFolderUri:l=>{const u=n.folders.filter(d=>d.name===l);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(l,u)=>D.getConfiguration(void 0,l).get(u),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=a();if(l)return w.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=a();if(l){const u=g.getWorkspaceFolder(l);if(u)return w.normalize(u.uri.fsPath)}}},getSelectedText:()=>{if(b){const l=b.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(b){const l=b.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>c.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let t=class extends C.Disposable{constructor(c,g,b,p,D){super(),this.extensionService=c,this.workspaceService=g,this.editorService=b,this.configurationService=p,this.editorTabs=D,this._resolver=new i.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),a={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{a.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,a,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};t=We([$e(0,k.IExtHostExtensionService),$e(1,S.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,E.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(De[104],Ie([1,0,15,4,9,2,3,5,54,33,14,6,31,170,172,32,103]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(a,l,u,d,r,h){this._workspaceService=l,this._extensionService=u,this._configurationService=d,this._editorTabs=r,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=a.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(P=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(a,l){const u=a;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let d=`debug:${encodeURIComponent(u.path||"")}`,r="?";return l&&(d+=`${r}session=${encodeURIComponent(l.id)}`,r="&"),d+=`${r}ref=${u.sourceReference}`,M.URI.parse(d)}else{if(u.path)return M.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const l=[];for(const u of a.getAllExtensionDescriptions())if(u.contributes){const d=u.contributes.debuggers;if(d&&d.length>0)for(const r of d)(0,f.isDebuggerMainContribution)(r)&&l.push(r.type)}this._debugServiceProxy.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(l=>a.push(l)),a}addBreakpoints(a){this.startBreakpoints();const l=a.filter(r=>{const h=r.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,r),!0)});this.fireBreakpointChanges(l,[],[]);const u=[],d=new Map;for(const r of l)if(r instanceof S.SourceBreakpoint){let h=d.get(r.location.uri.toString());h||(h={type:"sourceMulti",uri:r.location.uri,lines:[]},d.set(r.location.uri.toString(),h),u.push(h)),h.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof S.FunctionBreakpoint&&u.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(a){this.startBreakpoints();const l=a.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],l,[]);const u=l.filter(h=>h instanceof S.SourceBreakpoint).map(h=>h.id),d=l.filter(h=>h instanceof S.FunctionBreakpoint).map(h=>h.id),r=l.filter(h=>h instanceof S.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(u,d,r)}startDebugging(a,l,u){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,l,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,l,u){if(!l)return new S.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:d,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,u,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,d),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(r=>r.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(a,l,u){if(!u)return new S.Disposable(()=>{});if(!this.definesDebugType(a,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:d,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,d),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(r=>r.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(a,l){if(!l)return new S.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:u,factory:l}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==l)})}async $runInTerminal(a,l){return Promise.resolve(void 0)}async $substituteVariables(a,l){let u;const d=await this.getFolder(a);return d&&(u={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(u,l)}createDebugAdapter(a,l){if(a.type==="implementation")return new D(a.implementation)}createSignService(){}async $startDASession(a,l){const u=this,d=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const h=this.convertToDto(r),v=this.createDebugAdapter(h,d);if(!v)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const P=v;return this._debugAdapters.set(a,P),this.getDebugAdapterTrackers(d).then(L=>(L&&this._debugAdaptersTrackers.set(a,L),P.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const V=j,W={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(V.arguments.value);W.body={signature:T},P.sendResponse(W)}else throw new Error("no signer")}catch(T){W.success=!1,W.message=T.message,P.sendResponse(W)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(j),j=(0,f.convertToVSCPaths)(j,!0),u._debugServiceProxy.$acceptDAMessage(a,j)}),P.onError(j=>{L&&L.onError&&L.onError(j),this._debugServiceProxy.$acceptDAError(a,j.name,j.message,j.stack)}),P.onExit(j=>{L&&L.onExit&&L.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,w.withNullAsUndefined)(j),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),P.startSession()))})}$sendDAMessage(a,l){l=(0,f.convertToDAPaths)(l,!1);const u=this._debugAdaptersTrackers.get(a);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(l),this._debugAdapters.get(a)?.sendMessage(l)}$stopDASession(a){const l=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),l&&l.onWillStopSession&&l.onWillStopSession();const u=this._debugAdapters.get(a);return this._debugAdapters.delete(a),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const l=[],u=[],d=[];if(a.added)for(const r of a.added){const h=r.id;if(h&&!this._breakpoints.has(h)){let v;if(r.type==="function")v=new S.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")v=new S.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const P=M.URI.revive(r.uri);v=new S.SourceBreakpoint(new S.Location(P,new S.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}v._id=h,this._breakpoints.set(h,v),l.push(v)}}if(a.removed)for(const r of a.removed){const h=this._breakpoints.get(r);h&&(this._breakpoints.delete(r),u.push(h))}if(a.changed){for(const r of a.changed)if(r.id){const h=this._breakpoints.get(r.id);if(h){if(h instanceof S.FunctionBreakpoint&&r.type==="function"){const v=h;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.functionName=r.functionName}else if(h instanceof S.SourceBreakpoint&&r.type==="source"){const v=h;v.enabled=r.enabled,v.condition=r.condition,v.hitCondition=r.hitCondition,v.logMessage=r.logMessage,v.location=new S.Location(M.URI.revive(r.uri),new S.Position(r.line,r.character))}d.push(h)}}}this.fireBreakpointChanges(l,u,d)}$provideDebugConfigurations(a,l,u){return(0,i.asPromise)(async()=>{const d=this.getConfigProviderByHandle(a);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.getFolder(l);return d.provideDebugConfigurations(r,u)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(a,l,u,d){return(0,i.asPromise)(async()=>{const r=this.getConfigProviderByHandle(a);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(l);return r.resolveDebugConfiguration(h,u,d)})}$resolveDebugConfigurationWithSubstitutedVariables(a,l,u,d){return(0,i.asPromise)(async()=>{const r=this.getConfigProviderByHandle(a);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(l);return r.resolveDebugConfigurationWithSubstitutedVariables(h,u,d)})}async $provideDebugAdapter(a,l){const u=this.getAdapterDescriptorFactoryByHandle(a);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(l);return this.getAdapterDescriptor(u,d).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(r)})}async $acceptDebugSessionStarted(a){const l=await this.getSession(a);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(a){const l=await this.getSession(a);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,l){(await this.getSession(a))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(a,l){const d={session:await this.getSession(a),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(a){if(a instanceof S.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof S.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const l=this._adapterFactories.filter(u=>u.type===a);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(a){const l=this._adapterFactories.filter(u=>u.handle===a);if(l.length>0)return l[0].factory}getConfigProviderByHandle(a){const l=this._configProviders.filter(u=>u.handle===a);if(l.length>0)return l[0].provider}definesDebugType(a,l){if(a.contributes){const u=a.contributes.debuggers;if(u&&u.length>0){for(const d of u)if(d.label&&d.type&&d.type===l)return!0}}return!1}getDebugAdapterTrackers(a){const u=a.configuration.type,d=this._trackerFactories.filter(r=>r.type===u||r.type==="*").map(r=>(0,i.asPromise)(()=>r.factory.createDebugAdapterTracker(a)).then(h=>h,h=>null));return Promise.race([Promise.all(d).then(r=>{const h=r.filter(v=>!!v);if(h.length>0)return new p(h)}),new Promise((r,h)=>{const v=setTimeout(()=>{clearTimeout(v),h(new Error("timeout"))},1e3)})]).catch(r=>{})}async getAdapterDescriptor(a,l){const u=l.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new S.DebugAdapterServer(u));if(a){const r=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>a.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,r))).then(h=>{if(h)return h})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,d))}daExecutableFromPackage(a,l){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,l,u){(a.length>0||l.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:l,changed:u}))}async getSession(a){if(a)if(typeof a=="string"){const l=this._debugSessions.get(a);if(l)return l}else{let l=this._debugSessions.get(a.id);if(!l){const u=await this.getFolder(a.folderUri),d=a.parent?this._debugSessions.get(a.parent):void 0;l=new g(this._debugServiceProxy,a.id,a.type,a.name,u,a.configuration,d),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(a){if(a){const l=M.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};c=We([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,o.IExtHostVariableResolverProvider)],c),e.ExtHostDebugServiceBase=c;class g{constructor(a,l,u,d,r,h,v){this._debugServiceProxy=a,this._id=l,this._type=u,this._name=d,this._workspaceFolder=r,this._configuration=h,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,l)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=g;class b{constructor(a){this.value=Object.freeze({append(l){a.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=b;class p{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(l=>l.onError?l.onError(a):void 0)}onExit(a,l){this.trackers.forEach(u=>u.onExit?u.onExit(a,l):void 0)}}class D extends E.AbstractDebugAdapter{constructor(a){super(),this.implementation=a,a.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends c{constructor(a,l,u,d,r,h){super(a,l,u,d,r,h)}};n=We([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,o.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(De[239],Ie([1,0,12,77,2,5,230,11,60,61,26,150,14,50,33,70]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(b){const p=b.get(A.ILogService),n=b.get(m.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(s=>{p.error(s);const a=i.transformErrorForSerialization(s);n.$onUnexpectedError(a)})}static async installFullHandler(b){const p=b.get(A.ILogService),D=b.get(m.IExtHostRpcService),n=b.get(f.IExtHostExtensionService),s=b.get(t.IExtHostTelemetry),a=D.getProxy(M.MainContext.MainThreadExtensionService),l=D.getProxy(M.MainContext.MainThreadErrors),u=await n.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(r,h)=>{let v="",P,L;for(const j of h)v+=`
	at ${j.toString()}`,L=j.getFileName(),!P&&L&&(P=u.findSubstr(w.URI.file(L)));return d.set(r,P?.identifier),`${r.name||"Error"}: ${r.message||""}${v}`},i.setUnexpectedErrorHandler(r=>{p.error(r);const h=i.transformErrorForSerialization(r),v=d.get(r);if(!v){l.$onUnexpectedError(h);return}a.$onExtensionRuntimeError(v,h);const P=s.onExtensionError(v,r);p.trace("forwarded error to extension?",P,v)})}}Error.stackTraceLimit=100;class c{constructor(b,p,D,n,s){this._hostUtils=D,this._rpcProtocol=new I.RPCProtocol(b,null,n),p=c._transform(p,this._rpcProtocol);const a=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());a.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:s}),a.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),a.set(E.IURITransformerService,new E.URITransformerService(n)),a.set(f.IHostUtils,D);const l=new S.InstantiationService(a,!0);l.invokeFunction(o.installEarlyHandler),this._logService=l.invokeFunction(u=>u.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",p),this._extensionService=l.invokeFunction(u=>u.get(f.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(b){const p=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return w.URI.revive(await p.$asBrowserUri(b))}terminate(b){this._extensionService.terminate(b)}static _transform(b,p){b.allExtensions.forEach(n=>{n.extensionLocation=w.URI.revive(p.transformIncomingURIs(n.extensionLocation));const s={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(a=>s[a]=w.URI.revive(p.transformIncomingURIs(n.browserNlsBundleUris[a]))),n.browserNlsBundleUris=s)}),b.environment.appRoot=w.URI.revive(p.transformIncomingURIs(b.environment.appRoot));const D=b.environment.extensionDevelopmentLocationURI;return D&&(b.environment.extensionDevelopmentLocationURI=D.map(n=>w.URI.revive(p.transformIncomingURIs(n)))),b.environment.extensionTestsLocationURI=w.URI.revive(p.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=w.URI.revive(p.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=w.URI.revive(p.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=w.URI.revive(p.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=w.URI.revive(p.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=w.URI.revive(p.transformIncomingURIs(b.logsLocation)),b.logFile=w.URI.revive(p.transformIncomingURIs(b.logFile)),b.workspace=p.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=c}),define(De[240],Ie([1,0,16,15,20,45,13,19,22,2,44]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(g,b,p,D){this.query=g,this.provider=b,this.fileUtils=p,this.processType=D,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,b){const p=this.query.folderQueries||[],D=new w.CancellationTokenSource;return b.onCancellationRequested(()=>D.cancel()),new Promise((n,s)=>{this.collector=new E(g);let a=!1;const l=(u,d)=>{if(!a&&!this.isLimitHit){const r=this.resultSize(u);t(u)&&typeof this.query.maxResults=="number"&&this.resultCount+r>this.query.maxResults&&(this.isLimitHit=!0,a=!0,D.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const h=this.resultSize(u);this.resultCount+=h,(h>0||!t(u))&&this.collector.add(u,d)}};Promise.all(p.map((u,d)=>this.searchInFolder(u,r=>l(r,d),D.token))).then(u=>{D.dispose(),this.collector.flush();const d=u.some(r=>!!r&&!!r.limitHit);n({limitHit:this.isLimitHit||d,messages:(0,i.flatten)(u.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.processType}})},u=>{D.dispose();const d=(0,M.toErrorMessage)(u);s(new Error(d))})})}resultSize(g){return t(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,b){const p=Array.isArray(g.ranges)?g.ranges:[g.ranges],D=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:p.slice(0,b),preview:{matches:D.slice(0,b),text:g.preview.text},uri:g.uri}}async searchInFolder(g,b,p){const D=new O.QueryGlobTester(this.query,g),n=[],s={report:u=>{if(!this.validateProviderResult(u))return;const d=g.folder.scheme===I.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(u.uri))):void 0,r=y.relativePath(g.folder,u.uri);if(r){const h=D.includedInQuery(r,A.basename(r),d);(0,C.isThenable)(h)?n.push(h.then(v=>{v&&b(u)})):h&&b(u)}}},a=this.getSearchOptionsForFolder(g),l=await this.provider.provideTextSearchResults(m(this.query.contentPattern),a,s,p);return n.length&&await Promise.all(n),l}validateProviderResult(g){if(t(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const b=(0,O.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),p=(0,O.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),D={folder:k.URI.from(g.folder),excludes:p,includes:b,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return D.usePCRE2=this.query.usePCRE2,D}}e.TextSearchManager=S;function m(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class E{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,b=>this.sendItems(b))}add(g,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!y.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=E;function f(c){return t(c)?{preview:{matches:(0,i.mapArrayOrNot)(c.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:c.preview.text},ranges:(0,i.mapArrayOrNot)(c.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function t(c){return!!c.preview}e.extensionResultIsMatch=t;class o{constructor(g,b){this.maxBatchSize=g,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,b){!g||this.addItemToBatch(g,b)}addItems(g,b){!g||this.addItemsToBatch(g,b)}addItemToBatch(g,b){this.batch.push(g),this.batchSize+=b,this.onUpdate()}addItemsToBatch(g,b){this.batch=this.batch.concat(g),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o,o.TIMEOUT=4e3,o.START_BATCH_AFTER_COUNT=50}),define(De[105],Ie([1,0,7,5,3,235,14,50,11,2,240]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let S=class{constructor(t,o,c){this.extHostRpc=t,this._uriTransformer=o,this._logService=c,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(t){return this._uriTransformer.transformOutgoingScheme(t)}registerTextSearchProvider(t,o){if(this._textSearchUsedSchemes.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this._textSearchUsedSchemes.add(t);const c=this._handlePool++;return this._textSearchProvider.set(c,o),this._proxy.$registerTextSearchProvider(c,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(t),this._textSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}registerFileSearchProvider(t,o){if(this._fileSearchUsedSchemes.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this._fileSearchUsedSchemes.add(t);const c=this._handlePool++;return this._fileSearchProvider.set(c,o),this._proxy.$registerFileSearchProvider(c,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(t),this._fileSearchProvider.delete(c),this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(t,o,c,g){const b=m(c),p=this._fileSearchProvider.get(t);if(p)return this._fileSearchManager.fileSearch(b,p,D=>{this._proxy.$handleFileMatch(t,o,D.map(n=>n.resource))},g);throw new Error("unknown provider: "+t)}$clearCache(t){return this._fileSearchManager.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,o,c,g){const b=this._textSearchProvider.get(t);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const p=m(c);return this.createTextSearchManager(p,b).search(n=>this._proxy.$handleTextMatch(t,o,n),g)}$enableExtensionHostSearch(){}createTextSearchManager(t,o){return new O.TextSearchManager(t,o,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};S=We([$e(0,I.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,y.ILogService)],S),e.ExtHostSearch=S;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(E),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=m;function E(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(De[241],Ie([1,0,60,100,31,98,32,38,53,56,102,104,105,75,65,72,99,55,37,74,70,54,212,11,182,103,73]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D,n,s,a,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(u.IExtHostLocalizationService,u.ExtHostLocalizationService,1),(0,i.registerSingleton)(s.ILoggerService,n.ExtHostLoggerService,1),(0,i.registerSingleton)(s.ILogService,a.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,i.registerSingleton)(c.IExtHostConsumerFileSystem,c.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace,0),(0,i.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,i.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,i.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs,0),(0,i.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(De[242],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const M=this._dragOperations.get(w);return this._dragOperations.delete(w),M}}addDragOperationTransfer(w,M){this._dragOperations.set(w,M)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,M){this._renderedElements.set(w,M)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=i}),define(De[243],Ie([1,0,137,6,22,2,4,7,15,6,9,16,8,20,242,27]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(b,p){if((0,O.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let D;return Array.isArray(b.highlights)&&(D=b.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),D=D.length?D:void 0),{label:b.label,highlights:D}}}class c{constructor(p,D,n){this._proxy=p,this.commands=D,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}D.registerArgumentProcessor({processArgument:a=>s(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(l=>s(l)?this.convertArgument(l):l):a})}registerTreeDataProvider(p,D,n){const s=this.createTreeView(p,{treeDataProvider:D},n);return{dispose:()=>s.dispose()}}createTreeView(p,D,n){if(!D||!D.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=D.dragAndDropController?.dropMimeTypes??[],a=D.dragAndDropController?.dragMimeTypes??[],l=!!D.dragAndDropController?.handleDrag,u=!!D.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(p,D,n),r=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!D.showCollapseAll,canSelectMany:!!D.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:l,hasHandleDrop:u});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(n,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(h){d.message=h},get title(){return d.title},set title(h){d.title=h},get description(){return d.description},set description(h){d.description=h},get badge(){return d.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?d.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(d.badge=void 0)},reveal:(h,v)=>d.reveal(h,v),dispose:async()=>{await r,this.treeViews.delete(p),d.dispose()}}}$getChildren(p,D){const n=this.treeViews.get(p);return n?n.getChildren(D):Promise.reject(new Error((0,i.localize)(0,null,p)))}async $handleDrop(p,D,n,s,a,l,u,d){const r=this.treeViews.get(p);if(!r)return Promise.reject(new Error((0,i.localize)(1,null,p)));const h=m.DataTransfer.toDataTransfer(n,async v=>(await this._proxy.$resolveDropFileData(p,D,v)).buffer);return u===p&&d&&await this.addAdditionalTransferItems(h,r,d,a,l),r.onDrop(h,s,a)}async addAdditionalTransferItems(p,D,n,s,a){const l=this.treeDragAndDropService.removeDragOperationTransfer(a);if(l)(await l)?.forEach((u,d)=>{u&&p.set(d,u)});else if(a&&D.handleDrag){const u=D.handleDrag(n,p,s);this.treeDragAndDropService.addDragOperationTransfer(a,u),await u}return p}async $handleDrag(p,D,n,s){const a=this.treeViews.get(p);if(!a)return Promise.reject(new Error((0,i.localize)(2,null,p)));const l=await this.addAdditionalTransferItems(new C.DataTransfer,a,D,s,n);if(!!l)return m.DataTransfer.toDataTransferDTO(l)}async $hasResolve(p){const D=this.treeViews.get(p);if(!D)throw new Error((0,i.localize)(3,null,p));return D.hasResolve}$resolve(p,D,n){const s=this.treeViews.get(p);if(!s)throw new Error((0,i.localize)(4,null,p));return s.resolveTreeItem(D,n)}$setExpanded(p,D,n){const s=this.treeViews.get(p);if(!s)throw new Error((0,i.localize)(5,null,p));s.setExpanded(D,n)}$setSelection(p,D){const n=this.treeViews.get(p);if(!n)throw new Error((0,i.localize)(6,null,p));n.setSelection(D)}$setFocus(p,D){const n=this.treeViews.get(p);if(!n)throw new Error((0,i.localize)(7,null,p));n.setFocus(D)}$setVisible(p,D){const n=this.treeViews.get(p);if(!n)throw new Error((0,i.localize)(8,null,p));n.setVisible(D)}$changeCheckboxState(p,D){const n=this.treeViews.get(p);if(!n)throw new Error((0,i.localize)(9,null,p));n.setCheckboxState(D)}createExtHostTreeView(p,D,n){const s=new g(p,D,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(p,s),s}convertArgument(p){const D=this.treeViews.get(p.$treeViewId);return D&&"$treeItemHandle"in p?D.getExtensionElement(p.$treeItemHandle):D&&"$focusedTreeItem"in p&&p.$focusedTreeItem?D.focusedElement:null}}e.ExtHostTreeViews=c;class g extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,O.isUndefinedOrNull)(p))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(p,D,n,s,a,l){if(super(),this.viewId=p,this.proxy=n,this.commands=s,this.logService=a,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new I.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,l.contributes&&l.contributes.views)for(const r in l.contributes.views)for(const h of l.contributes.views[r])h.id===p&&(this._title=h.name);this.dataProvider=D.treeDataProvider,this.dndController=D.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let u,d;this._register(I.Event.debounce(this._onDidChangeData.event,(r,h)=>(r||(r={message:!1,elements:[]}),h.element!==!1&&(u||(u=new Promise(v=>d=v),this.refreshPromise=this.refreshPromise.then(()=>u)),Array.isArray(h.element)?r.elements.push(...h.element):r.elements.push(h.element)),h.message&&(r.message=!0),r),200,!0)(({message:r,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=d;return u=null,this.refresh(h).then(()=>v())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(p){const D=p?this.getExtensionElement(p):void 0;if(p&&!D)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(p);return n||(n=await this.fetchChildrenNodes(D)),n?n.map(s=>s.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,D){D=D||{select:!0,focus:!1};const n=(0,O.isUndefinedOrNull)(D.select)?!0:D.select,s=(0,O.isUndefinedOrNull)(D.focus)?!1:D.focus,a=(0,O.isUndefinedOrNull)(D.expand)?!1:D.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(l=>this.resolveTreeNode(p,l[l.length-1]).then(u=>this.proxy.$reveal(this.viewId,{item:u.item,parentChain:l.map(d=>d.item)},{select:n,focus:s,expand:a})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:s,expand:a})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}get badge(){return this._badge}set badge(p){this._badge?.value===p?.value&&this._badge?.tooltip===p?.tooltip||(this._badge=m.ViewBadge.from(p),this.proxy.$setBadge(this.viewId,p))}setExpanded(p,D){const n=this.getExtensionElement(p);n&&(D?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(p){(0,S.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this._focusedHandle=p}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(p){const D=(await Promise.all(p.map(async n=>{const s=this.getExtensionElement(n.treeItemHandle);return s?{extensionItem:s,treeItem:await this.dataProvider.getTreeItem(s),newState:n.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);D.forEach(n=>{n.treeItem.checkboxState=n.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:D.map(n=>[n.extensionItem,n.newState])})}async handleDrag(p,D,n){const s=[];for(const a of p){const l=this.getExtensionElement(a);l&&s.push(l)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,D,n),D}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(p,D,n){const s=D?this.getExtensionElement(D):void 0;if(!(!s&&D||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,p,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,D){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(p);if(n){const s=this.nodes.get(n);if(s){const a=await this.dataProvider.resolveTreeItem(s.extensionItem,n,D)??s.extensionItem;return this.validateTreeItem(a),s.item.tooltip=this.getTooltip(a.tooltip),s.item.command=this.getCommand(s.disposableStore,a.command),s.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(D=>D?this.resolveUnknownParentChain(D).then(n=>this.resolveTreeNode(D,n[n.length-1]).then(s=>(n.push(s),n))):Promise.resolve([]))}resolveParent(p){const D=this.nodes.get(p);return D?Promise.resolve(D.parent?this.elements.get(D.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,D){const n=this.nodes.get(p);return n?Promise.resolve(n):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(s=>this.createHandle(p,s,D,!0)).then(s=>this.getChildren(D?D.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const l=this.nodes.get(a);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(p){if(p){let D;if(typeof p=="string"){const n=this.getExtensionElement(p);D=n?this.nodes.get(n):void 0}else D=p;return D&&D.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const D=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=p?this.nodes.get(p):void 0,s=await this.dataProvider.getChildren(p);if(D.token.isCancellationRequested)return;const a=await Promise.all((0,S.coalesce)(s||[]).map(async l=>{const u=await this.dataProvider.getTreeItem(l);return u&&!D.token.isCancellationRequested?this.createAndRegisterTreeNode(l,u,n):null}));return D.token.isCancellationRequested?void 0:(0,S.coalesce)(a)}finally{D.dispose()}}refresh(p){if(p.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(p);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const D=new Set,n=p.map(a=>this.nodes.get(a));for(const a of n)if(a&&!D.has(a.item.handle)){let l=a;for(;l&&l.parent&&n.findIndex(u=>l&&l.parent&&u&&u.item.handle===l.parent.item.handle)===-1;){const u=this.elements.get(l.parent.item.handle);l=u?this.nodes.get(u):void 0}l&&!l.parent&&D.add(a.item.handle)}const s=[];return D.forEach(a=>{const l=this.elements.get(a);if(l){const u=this.nodes.get(l);u&&(!u.parent||!D.has(u.parent.item.handle))&&s.push(a)}}),s}refreshHandles(p){const D={};return Promise.all(p.map(n=>this.refreshNode(n).then(s=>{s&&(D[n]=s.item)}))).then(()=>Object.keys(D).length?this.proxy.$refresh(this.viewId,D):void 0)}refreshNode(p){const D=this.getExtensionElement(p);if(D){const n=this.nodes.get(D);if(n)return this.clearChildren(D),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(D)).then(s=>{if(s){const a=this.createTreeNode(D,s,n.parent);return this.updateNodeCache(D,a,n,n.parent),n.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,D,n){const s=this.createTreeNode(p,D,n);if(D.id&&this.elements.has(s.item.handle))throw new Error((0,i.localize)(10,null,D.id));return this.addNodeToCache(p,s),this.addNodeToParentCache(s,n),s}getTooltip(p){return k.MarkdownString.isMarkdownString(p)?m.MarkdownString.from(p):p}getCommand(p,D){return D?{...this.commands.toInternal(D,p),originalId:D.command}:void 0}getCheckbox(p){if(!p.checkboxState)return;let D,n;return typeof p.checkboxState=="number"?D=p.checkboxState:(D=p.checkboxState.state,n=p.checkboxState.tooltip),{isChecked:D===k.TreeItemCheckboxState.Checked,tooltip:n}}validateTreeItem(p){if(!k.TreeItem.isTreeItem(p,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(p,D,n){this.validateTreeItem(D);const s=new A.DisposableStore,a=this.createHandle(p,D,n),l=this.getLightIconPath(D);return{item:{handle:a,parentHandle:n?n.item.handle:void 0,label:o(D.label,this.extension),description:D.description,resourceUri:D.resourceUri,tooltip:this.getTooltip(D.tooltip),command:this.getCommand(s,D.command),contextValue:D.contextValue,icon:l,iconDark:this.getDarkIconPath(D)||l,themeIcon:this.getThemeIcon(D),collapsibleState:(0,O.isUndefinedOrNull)(D.collapsibleState)?k.TreeItemCollapsibleState.None:D.collapsibleState,accessibilityInformation:D.accessibilityInformation,checkbox:this.getCheckbox(D)},extensionItem:D,parent:n,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(p){return p.iconPath instanceof k.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:D,label:n,resourceUri:s},a,l){if(D)return`${g.ID_HANDLE_PREFIX}/${D}`;const u=o(n,this.extension),d=a?a.item.handle:g.LABEL_HANDLE_PREFIX;let r=u?u.label:s?(0,w.basename)(s):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const h=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,v=this.getChildrenNodes(a)||[];let P,L=0;do{if(P=`${d}/${L}:${r}`,l||!this.elements.has(P)||h===P)break;L++}while(L<=v.length);return P}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof k.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return M.URI.isUri(p)?p:M.URI.file(p)}addNodeToCache(p,D){this.elements.set(D.item.handle,p),this.nodes.set(p,D)}updateNodeCache(p,D,n,s){this.elements.delete(D.item.handle),this.nodes.delete(p),D.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(p,D);const a=this.getChildrenNodes(s)||[],l=a.filter(u=>u.item.handle===n.item.handle)[0];l&&a.splice(a.indexOf(l),1,D)}addNodeToParentCache(p,D){D?(D.children||(D.children=[]),D.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const D=this.nodes.get(p);if(D){if(D.children)for(const n of D.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}D.children=void 0}}else this.clearAll()}clear(p){const D=this.nodes.get(p);if(D){if(D.children)for(const n of D.children){const s=this.elements.get(n.item.handle);s&&this.clear(s)}this.nodes.delete(p),this.elements.delete(D.item.handle),D.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(De[244],Ie([1,0,20,12,4,29,2,124,253,112,122,36,5,69,197,196,38,198,32,200,201,202,185,203,53,33,205,206,209,211,213,100,188,217,218,219,75,56,222,243,8,6,225,57,99,31,169,208,62,98,102,104,105,11,50,14,26,214,183,65,72,194,223,76,55,228,226,227,195,37,220,224,74,54,70,215,101,216,13,87,187,166,207,7,27,171,73,163]),function(te,e,i,C,w,M,I,A,y,k,O,S,m,E,f,t,o,c,g,b,p,D,n,s,a,l,u,d,r,h,v,P,L,j,V,W,T,F,R,x,B,H,G,ee,de,ne,me,le,ue,Q,ge,Se,Oe,xe,Qe,Ce,ye,Te,se,ae,J,_,N,$,q,Z,ce,we,oe,be,ve,Ue,ze,et,Ge,tt,Fe,ht,X,Y,pe,Ne,je,qe,He,Ze,nt,lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Dt(rt){const it=rt.get(ye.IExtHostInitDataService),Mt=rt.get(be.IExtHostFileSystemInfo),Ot=rt.get(q.IExtHostConsumerFileSystem),Ft=rt.get(l.IExtHostExtensionService),ft=rt.get(ne.IExtHostWorkspace),It=rt.get(Ge.IExtHostTelemetry),kt=rt.get(g.IExtHostConfiguration),Pt=rt.get(Qe.IURITransformerService),Ke=rt.get(Ce.IExtHostRpcService),Tt=rt.get(T.IExtHostStorage),Lt=rt.get($.IExtensionStoragePaths),xt=rt.get(xe.ILoggerService),pt=rt.get(xe.ILogService),yt=rt.get(ae.IExtHostTunnelService),St=rt.get(J.IExtHostApiDeprecationService),_e=rt.get(de.IExtHostWindow),Pe=rt.get(ze.IExtHostSecretState),fe=rt.get(et.IExtHostEditorTabs);Ke.set(m.ExtHostContext.ExtHostFileSystemInfo,Mt),Ke.set(m.ExtHostContext.ExtHostLogLevelServiceShape,xt),Ke.set(m.ExtHostContext.ExtHostWorkspace,ft),Ke.set(m.ExtHostContext.ExtHostConfiguration,kt),Ke.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ke.set(m.ExtHostContext.ExtHostStorage,Tt),Ke.set(m.ExtHostContext.ExtHostTunnelService,yt),Ke.set(m.ExtHostContext.ExtHostWindow,_e),Ke.set(m.ExtHostContext.ExtHostSecretState,Pe),Ke.set(m.ExtHostContext.ExtHostTelemetry,It),Ke.set(m.ExtHostContext.ExtHostEditorTabs,fe);const K=Ke.set(m.ExtHostContext.ExtHostDecorations,rt.get(Q.IExtHostDecorations)),ke=Ke.set(m.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(a.IExtHostDocumentsAndEditors)),Le=Ke.set(m.ExtHostContext.ExtHostCommands,rt.get(o.IExtHostCommands)),Xe=Ke.set(m.ExtHostContext.ExtHostTerminalService,rt.get(F.IExtHostTerminalService)),Be=Ke.set(m.ExtHostContext.ExtHostDebugService,rt.get(Se.IExtHostDebugService)),ot=Ke.set(m.ExtHostContext.ExtHostSearch,rt.get(Oe.IExtHostSearch)),mt=Ke.set(m.ExtHostContext.ExtHostTask,rt.get(ge.IExtHostTask)),At=Ke.set(m.ExtHostContext.ExtHostOutputService,rt.get(P.IExtHostOutputService)),vt=Ke.set(m.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),Et=Ke.set(m.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(Ke)),dt=Ke.set(m.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ke,ke)),Nt=Ke.set(m.ExtHostContext.ExtHostDocumentContentProviders,new D.ExtHostDocumentContentProvider(Ke,ke,pt)),Kt=Ke.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(pt,dt,Ke.getProxy(m.MainContext.MainThreadBulkEdits))),bt=Ke.set(m.ExtHostContext.ExtHostNotebook,new Te.ExtHostNotebookController(Ke,Le,ke,dt)),Ht=Ke.set(m.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(bt)),ni=Ke.set(m.ExtHostContext.ExtHostNotebookEditors,new pe.ExtHostNotebookEditors(pt,bt)),ri=Ke.set(m.ExtHostContext.ExtHostNotebookKernels,new tt.ExtHostNotebookKernels(Ke,it,bt,Le,pt)),mi=Ke.set(m.ExtHostContext.ExtHostNotebookRenderers,new ht.ExtHostNotebookRenderers(Ke,bt)),_t=Ke.set(m.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(Ke,ke)),si=Ke.set(m.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Ke.getProxy(m.MainContext.MainThreadTreeViews),Le,pt)),Ai=Ke.set(m.ExtHostContext.ExtHostEditorInsets,new me.ExtHostEditorInsets(Ke.getProxy(m.MainContext.MainThreadEditorInsets),_t,it.remote)),Jt=Ke.set(m.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ke,pt,Mt,ke)),zt=Ke.set(m.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ke,dt,Le.converter,Pt)),ct=Ke.set(m.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Ke,Pt,dt,Le,Jt,pt,St,It)),gi=Ke.set(m.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(Ke,ct)),$t=Ke.set(m.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Ke,pt,ke)),Gt=Ke.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ke,ft,Le)),oi=Ke.set(m.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(Ke,Le,pt)),pi=Ke.set(m.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(Ke,Le,dt)),ai=Ke.set(m.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ke.getProxy(m.MainContext.MainThreadProgress))),vi=Ke.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ke)),Di=Ke.set(m.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ke)),Zt=Ke.set(m.ExtHostContext.ExtHostAuthentication,new _.ExtHostAuthentication(Ke)),Ei=Ke.set(m.ExtHostContext.ExtHostTimeline,new N.ExtHostTimeline(Ke,Le)),ei=Ke.set(m.ExtHostContext.ExtHostWebviews,new ee.ExtHostWebviews(Ke,it.remote,ft,pt,St)),ti=Ke.set(m.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ke,ei,ft)),Ri=Ke.set(m.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Ke,dt,Lt,ei,ti)),bi=Ke.set(m.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Ke,ei)),Xt=Ke.set(m.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(Ke,Le,ke)),Oi=Ke.set(m.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(Ke));Ke.set(m.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ke,bt,ke,Le,pt));const Fi=Object.values(m.ExtHostContext);Ke.assertRegistered(Fi);const Li=new oe.ExtHostBulkEdits(Ke,ke),Mi=new t.ExtHostClipboard(Ke),wi=new v.ExtHostMessageService(Ke,pt),Ii=new p.ExtHostDialogs(Ke),li=new W.ExtHostStatusBar(Ke,Le.converter);return f.ExtHostApiCommands.register(Le),function(Me,Vt,Ci){const gt=function(){let re=!Me.isUnderDevelopment;function he(){re||(pt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),ci={getSession(re,he,Re){return Zt.getSession(Me,re,he,Re)},async hasSession(re,he){return(0,He.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,st){return Zt.registerAuthenticationProvider(re,he,Re,st)}},Ni={registerCommand(re,he,Re){return Le.registerCommand(!0,re,he,Re,void 0,Me)},registerTextEditorCommand(re,he,Re){return Le.registerCommand(!0,re,(...st)=>{const wt=_t.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Ct=>{he.apply(Re,[wt,Ct,...st])}).then(Ct=>{Ct||pt.warn("Edits from command "+re+" were not applied.")},Ct=>{pt.warn("An error occurred while running command "+re,Ct)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Re)=>((0,He.checkProposedApiEnabled)(Me,"diffCommand"),Le.registerCommand(!0,re,async(...st)=>{const wt=ke.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Ct=await _t.getDiffInformation(wt.id);he.apply(Re,[Ct,...st])},void 0,void 0,Me)),executeCommand(re,...he){return Le.executeCommand(re,...he)},getCommands(re=!1){return Le.getCommands(re)}},Ti={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return Mi.value},get shell(){return Xe.getDefaultShell(!1)},get onDidChangeShell(){return(0,He.checkProposedApiEnabled)(Me,"envShellEvent"),Xe.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.isNewAppInstall)(it.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return(0,He.checkProposedApiEnabled)(Me,"telemetryLogger"),It.instantiateLogger(Me,re)},openExternal(re,he){return _e.openUri(re,{allowTunneling:!!it.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===it.environment.appUriScheme)return Et.createAppUri(re);try{return await _e.asExternalUri(re,{allowTunneling:!!it.remote.authority})}catch(he){if((0,Y.matchesScheme)(re,X.Schemas.http)||(0,Y.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,ue.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Me,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel}};it.environment.extensionTestsLocationURI||Object.freeze(Ti);const Ui={createTestController(re,he,Re){return Xt.createTestController(re,he,Re)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Xt.createTestObserver()},runTests(re){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Xt.runTests(re)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Xt.results}},ui=it.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Si={getExtension(re,he){(0,He.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(re);if(Re)return new l.Extension(Ft,Me.identifier,Re,ui,!1);if(he){const st=Vt.all.getExtensionDescription(re);if(st)return new l.Extension(Ft,Me.identifier,st,ui,!0)}},get all(){const re=[];for(const he of Vt.mine.getAllExtensionDescriptions())re.push(new l.Extension(Ft,Me.identifier,he,ui,!1));return re},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Me,"extensionsAny");const re=new He.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const st=!re.has(Re.identifier);he.push(new l.Extension(Ft,Me.identifier,Re,ui,st))}return he},get onDidChange(){return(0,He.isProposedApiEnabled)(Me,"extensionsAny")?w.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Bi={createDiagnosticCollection(re){return Jt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:re=>Jt.getDiagnostics(re),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(re,he){return zt.changeLanguage(re.uri,he)},match(re,he){const Re=dt.getDocumentData(he.uri)?.notebook;return(0,O.score)(B.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return ct.registerCodeActionProvider(Me,gt(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,He.checkProposedApiEnabled)(Me,"documentPaste"),ct.registerDocumentPasteEditProvider(Me,gt(re),he,Re)},registerCodeLensProvider(re,he){return ct.registerCodeLensProvider(Me,gt(re),he)},registerDefinitionProvider(re,he){return ct.registerDefinitionProvider(Me,gt(re),he)},registerDeclarationProvider(re,he){return ct.registerDeclarationProvider(Me,gt(re),he)},registerImplementationProvider(re,he){return ct.registerImplementationProvider(Me,gt(re),he)},registerTypeDefinitionProvider(re,he){return ct.registerTypeDefinitionProvider(Me,gt(re),he)},registerHoverProvider(re,he){return ct.registerHoverProvider(Me,gt(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return ct.registerEvaluatableExpressionProvider(Me,gt(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return ct.registerInlineValuesProvider(Me,gt(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return ct.registerDocumentHighlightProvider(Me,gt(re),he)},registerLinkedEditingRangeProvider(re,he){return ct.registerLinkedEditingRangeProvider(Me,gt(re),he)},registerReferenceProvider(re,he){return ct.registerReferenceProvider(Me,gt(re),he)},registerRenameProvider(re,he){return ct.registerRenameProvider(Me,gt(re),he)},registerDocumentSymbolProvider(re,he,Re){return ct.registerDocumentSymbolProvider(Me,gt(re),he,Re)},registerWorkspaceSymbolProvider(re){return ct.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return ct.registerDocumentFormattingEditProvider(Me,gt(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ct.registerDocumentRangeFormattingEditProvider(Me,gt(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...st){return ct.registerOnTypeFormattingEditProvider(Me,gt(re),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,he,Re){return ct.registerDocumentSemanticTokensProvider(Me,gt(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return ct.registerDocumentRangeSemanticTokensProvider(Me,gt(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...st){return typeof Re=="object"?ct.registerSignatureHelpProvider(Me,gt(re),he,Re):ct.registerSignatureHelpProvider(Me,gt(re),he,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(re,he,...Re){return ct.registerCompletionItemProvider(Me,gt(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Me,gt(re),he)},registerDocumentLinkProvider(re,he){return ct.registerDocumentLinkProvider(Me,gt(re),he)},registerColorProvider(re,he){return ct.registerColorProvider(Me,gt(re),he)},registerFoldingRangeProvider(re,he){return ct.registerFoldingRangeProvider(Me,gt(re),he)},registerSelectionRangeProvider(re,he){return ct.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return ct.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return ct.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>ct.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,He.checkProposedApiEnabled)(Me,"tokenInformation"),zt.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ct.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return zt.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return ct.registerDocumentOnDropEditProvider(Me,re,he)}},jt={get activeTextEditor(){return _t.getActiveTextEditor()},get visibleTextEditors(){return _t.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(re,he,Re){const st=await(I.URI.isUri(re)?Promise.resolve(ii.openTextDocument(re)):Promise.resolve(re));return _t.showTextDocument(st,he,Re)},createTextEditorDecorationType(re){return _t.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Re){return _t.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return _t.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return _t.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return _t.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return _t.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return _t.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return Xe.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return Xe.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return Xe.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,He.checkProposedApiEnabled)(Me,"terminalDimensions"),Xe.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return Xe.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,He.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Xe.onDidWriteTerminalData(re,he,Re)},get state(){return _e.state},onDidChangeWindowState(re,he,Re){return _e.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return wi.showMessage(Me,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return wi.showMessage(Me,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return wi.showMessage(Me,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Gt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Gt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Gt.showInput(re,he)},showOpenDialog(re){return Ii.showOpenDialog(re)},showSaveDialog(re){return Ii.showSaveDialog(re)},createStatusBarItem(re,he,Re){let st,wt,Ct;return typeof re=="string"?(st=re,wt=he,Ct=Re):(wt=re,Ct=he),li.createStatusBarEntry(Me,st,wt,Ct)},setStatusBarMessage(re,he){return li.setStatusBarMessage(re,he)},withScmProgress(re){return St.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ai.withProgress(Me,{location:H.ProgressLocation.SourceControl},(he,Re)=>re({report(st){}}))},withProgress(re,he){return ai.withProgress(Me,re,he)},createOutputChannel(re,he){return At.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Re,st){return ti.createWebviewPanel(Me,re,he,Re,st)},createWebviewTextEditorInset(re,he,Re,st){return(0,He.checkProposedApiEnabled)(Me,"editorInsets"),Ai.createWebviewEditorInset(re,he,Re,st,Me)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?Xe.createExtensionTerminal(re):Xe.createTerminalFromOptions(re):Xe.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return Xe.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return Xe.registerProfileProvider(Me,re,he)},registerTreeDataProvider(re,he){return si.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return si.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ti.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Re={})=>Ri.registerCustomEditorProvider(Me,re,he,Re),registerFileDecorationProvider(re){return K.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Et.registerUriHandler(Me.identifier,re)},createQuickPick(){return Gt.createQuickPick(Me)},createInputBox(){return Gt.createInputBox(Me)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return Di.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return bi.registerWebviewViewProvider(Me,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return bt.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return ni.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return ni.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,He.checkProposedApiEnabled)(Me,"externalUriOpener"),Oi.registerExternalUriOpener(Me.identifier,re,he,Re)},get tabGroups(){return fe.tabGroups}},ii={get rootPath(){return St.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw C.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw C.readonly()},updateWorkspaceFolders:(re,he,...Re)=>ft.updateWorkspaceFolders(Me,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return ft.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Re,st)=>ft.findFiles(re,he,Re,Me.identifier,st),findTextInFiles:(re,he,Re,st)=>{(0,He.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Ct;return typeof he=="object"?(wt=he,Ct=Re):(wt={},Ct=he,st=Re),ft.findTextInFiles(re,wt||{},Ct,Me.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re,he){return Li.applyWorkspaceEdit(re,Me,he)},createFileSystemWatcher:(re,he,Re,st)=>$t.createFileSystemWatcher(ft,Me,re,he,Re,st),get textDocuments(){return dt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw C.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(I.URI.file(re));else if(I.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=dt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>dt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Re)=>dt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>dt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>dt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>dt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>Kt.getOnWillSaveTextDocumentEvent(Me)(re,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(I.URI.isUri(re))Re=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Re=I.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return Ht.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return Ht.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,st){return bt.registerNotebookSerializer(Me,re,he,Re,(0,He.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,he,Re)=>Ci.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Ci.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return Nt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(St.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Me,re,he,Re),Ot.addFileSystemProvider(re,he))},get fs(){return Ot.value},registerFileSearchProvider:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"fileSearchProvider"),ot.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"textSearchProvider"),ot.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),Ft.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),vi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>$t.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>$t.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>$t.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>$t.getOnWillCreateFileEvent(Me)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>$t.getOnWillDeleteFileEvent(Me)(re,he,Re),onWillRenameFiles:(re,he,Re)=>$t.getOnWillRenameFileEvent(Me)(re,he,Re),openTunnel:re=>((0,He.checkProposedApiEnabled)(Me,"tunnels"),yt.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,He.checkProposedApiEnabled)(Me,"tunnels"),yt.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,He.checkProposedApiEnabled)(Me,"tunnels"),yt.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"portsAttributes"),yt.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"timeline"),Ei.registerTimelineProvider(re,he,Me.identifier,Le.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,He.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>ft.onDidGrantWorkspaceTrust(re,he,Re),registerEditSessionIdentityProvider:(re,he)=>((0,He.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(re,he))},xi={get inputBox(){return St.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Me)},createSourceControl(re,he,Re){return oi.createSourceControl(Me,re,he,Re)}},Ut={createCommentController(re,he){return pi.createCommentController(Me,re,he)}},di={get activeDebugSession(){return Be.activeDebugSession},get activeDebugConsole(){return Be.activeDebugConsole},get breakpoints(){return Be.breakpoints},onDidStartDebugSession(re,he,Re){return Be.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return Be.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return Be.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return Be.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return Be.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return Be.registerDebugConfigurationProvider(re,he,Re||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return Be.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return Be.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Be.startDebugging(re,he,{parentSession:Re}):Be.startDebugging(re,he,Re||{})},stopDebugging(re){return Be.stopDebugging(re)},addBreakpoints(re){return Be.addBreakpoints(re)},removeBreakpoints(re){return Be.removeBreakpoints(re)},asDebugSourceUri(re,he){return Be.asDebugSourceUri(re,he)}},zi={registerTaskProvider:(re,he)=>mt.registerTaskProvider(Me,re,he),fetchTasks:re=>mt.fetchTasks(re),executeTask:re=>mt.executeTask(Me,re),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(re,he,Re)=>mt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>mt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>mt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>mt.onDidEndTaskProcess(re,he,Re)},$i={createNotebookController(re,he,Re,st,wt){return ri.createNotebookController(Me,re,he,Re,st,(0,He.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return mi.createRendererMessaging(Me,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,He.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(re,he,Re)}},Wi={t(...re){if(typeof re[0]=="string"){const he=re.shift(),Re=!re||typeof re[0]!="object"?re:re[0];return vt.getMessage(Me.identifier.value,{message:he,args:Re})}return vt.getMessage(Me.identifier.value,re[0])},get bundle(){return vt.getBundle(Me.identifier.value)},get uri(){return vt.getBundleUri(Me.identifier.value)}};return{version:it.version,authentication:ci,commands:Ni,comments:Ut,debug:di,env:Ti,extensions:Si,l10n:Wi,languages:Bi,notebooks:$i,scm:xi,tasks:zi,tests:Ui,window:jt,workspace:ii,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:k.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:E.UIKind,Uri:I.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TerminalExitReason:H.TerminalExitReason,LogLevel:xe.LogLevel,EditSessionIdentityMatch:lt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Dt}),define(De[245],Ie([1,0,244,33,2,238,6,15,229]),function(te,e,i,C,w,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends M.RequireInterceptor{_installInterceptor(){}getModule(E,f){for(const t of this._alternatives){const o=t(E);if(o){E=o;break}}if(this._factories.has(E))return this._factories.get(E).load(E,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(k,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,f,t){f=f.with({path:S(f.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(f)),g=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const b=await g.text(),p=`${f.toString(!0)}#vscode-extension`,D=`${b}
//# sourceURL=${p}`;let n;try{n=new Function("module","exports","require",D)}catch(u){throw console.error(o?`Loading code for extension ${o} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${f.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const s={},a={exports:s},l=u=>{const d=this._fakeModules.getModule(u,f);if(d===void 0)throw new Error(`Cannot load module '${u}'`);return d};try{return t.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),n(a,s,l),a.exports!==s?a.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),t.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+E;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function S(m,E){return m.endsWith(E)?m:m+E}}),define(De[246],Ie([1,0,60,33,76,245]),function(te,e,i,C,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,i.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths,0)}),define(De[254],Ie([1,0,24,4,69,239,231,19,77,13,2,241,246]),function(te,e,i,C,w,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(n){return/^(file|vscode-remote):/i.test(n)}const f=fetch.bind(self);function t(n){self.fetch=async function(s,a){return s instanceof Request||E(String(s))&&(s=(await n(O.URI.parse(String(s)))).toString(!0)),f(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,l,u,d){(async()=>(E(a.toString())&&(a=(await n(O.URI.parse(a.toString()))).toString(!0)),super.open(s,a,l??!0,u,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=k.FileAccess.uriToBrowserUri(O.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(v){function P(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const L=fetch.bind(self);self.fetch=function(V,W){return V instanceof Request?L(V,W):L(P(V),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,W,T,F,R){return super.open(V,P(W),T??!0,F,R)}};const j=importScripts.bind(self);self.importScripts=(...V)=>{j(...V.map(P))},j(v)}.toString()}('${s}'))`;a=a||{},a.name=a.name||A.basename(s.toString());const d=new Blob([u],{type:"application/javascript"}),r=URL.createObjectURL(d);return new n(r,a)}}else self.Worker=class extends I.NestedWorker{constructor(n,s){super(m,n,{name:A.basename(n.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(n){S()}async exists(n){return!0}async realpath(n){return n}};class c{constructor(){const s=new MessageChannel,a=new C.Emitter;let l=!1;m(s.port2,[s.port2]),s.port1.onmessage=u=>{const{data:d}=u;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const r=i.VSBuffer.wrap(new Uint8Array(d,0,d.byteLength));if((0,w.isMessageOfType)(r,2)){l=!0,b("received terminate message from renderer");return}a.fire(r)},this.protocol={onMessage:a.event,send:u=>{if(!l){const d=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);s.port1.postMessage(d,[d])}}}}}function g(n){return new Promise(s=>{const a=n.onMessage(l=>{a.dispose();const u=JSON.parse(l.toString());n.send((0,w.createMessageOfType)(0)),s({protocol:n,initData:u})});n.send((0,w.createMessageOfType)(1))})}let b=n=>S();function p(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function D(){y.mark("code/extHost/willConnectToRenderer");const n=new c;return{onmessage(s){!p(s)||g(n.protocol).then(a=>{y.mark("code/extHost/didWaitForInitData");const l=new M.ExtensionHostMain(a.protocol,a.initData,o,null,s.data);t(u=>l.asBrowserUri(u)),b=u=>l.terminate(u)})}}}e.create=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef415578d1b1019db585718968a303eeca4b8979/core/vs/workbench/api/worker/extensionHostWorker.js.map
